/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/iterator","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Re=function(me){for(var e=[],S=0,M=me.length;S<M;S++)e[S]=Pe[me[S]];return e};define(Pe[68],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.$Lh=e.$Kh=void 0;function S(R){return(m,f,E)=>{let N=null,D=null;if(typeof E.value=="function"?(N="value",D=E.value):typeof E.get=="function"&&(N="get",D=E.get),!D)throw new Error("not supported");E[N]=R(D,f)}}function M(R,m,f){let E=null,N=null;if(typeof f.value=="function"?(E="value",N=f.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(E="get",N=f.get),!N)throw new Error("not supported");const D=`$memoize$${m}`;f[E]=function(...l){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,l)}),this[D]}}e.$Kh=M;function P(R,m,f){return S((E,N)=>{const D=`$debounce$${N}`,l=`$debounce$result$${N}`;return function(...k){this[l]||(this[l]=f?f():void 0),clearTimeout(this[D]),m&&(this[l]=m(this[l],...k),k=[this[l]]),this[D]=setTimeout(()=>{E.apply(this,k),this[l]=f?f():void 0},R)}})}e.$Lh=P;function F(R,m,f){return S((E,N)=>{const D=`$throttle$timer$${N}`,l=`$throttle$result$${N}`,k=`$throttle$lastRun$${N}`,g=`$throttle$pending$${N}`;return function(...s){if(this[l]||(this[l]=f?f():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),m&&(this[l]=m(this[l],...s)),this[g])return;const a=this[k]+R;a<=Date.now()?(this[k]=Date.now(),E.apply(this,[this[l]]),this[l]=f?f():void 0):(this[g]=!0,this[D]=setTimeout(()=>{this[g]=!1,this[k]=Date.now(),E.apply(this,[this[l]]),this[l]=f?f():void 0},a-Date.now()))}})}e.$Mh=F}),define(Pe[90],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vO=e.$uO=void 0;class S{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$uO=S,e.$vO=new S("id#")}),define(Pe[122],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var F;(function(t){t.DEFAULT={allowTrailingComma:!0}})(F||(e.ParseOptions=F={}));function R(t,p=!1){let u=0;const o=t.length;let v="",b=0,$=16,I=0;function h(U){let C=0,O=0;for(;C<U;){const q=t.charCodeAt(u);if(q>=48&&q<=57)O=O*16+q-48;else if(q>=65&&q<=70)O=O*16+q-65+10;else if(q>=97&&q<=102)O=O*16+q-97+10;else break;u++,C++}return C<U&&(O=-1),O}function y(U){u=U,v="",b=0,$=16,I=0}function w(){const U=u;if(t.charCodeAt(u)===48)u++;else for(u++;u<t.length&&E(t.charCodeAt(u));)u++;if(u<t.length&&t.charCodeAt(u)===46)if(u++,u<t.length&&E(t.charCodeAt(u)))for(u++;u<t.length&&E(t.charCodeAt(u));)u++;else return I=3,t.substring(U,u);let C=u;if(u<t.length&&(t.charCodeAt(u)===69||t.charCodeAt(u)===101))if(u++,(u<t.length&&t.charCodeAt(u)===43||t.charCodeAt(u)===45)&&u++,u<t.length&&E(t.charCodeAt(u))){for(u++;u<t.length&&E(t.charCodeAt(u));)u++;C=u}else I=3;return t.substring(U,C)}function A(){let U="",C=u;for(;;){if(u>=o){U+=t.substring(C,u),I=2;break}const O=t.charCodeAt(u);if(O===34){U+=t.substring(C,u),u++;break}if(O===92){if(U+=t.substring(C,u),u++,u>=o){I=2;break}switch(t.charCodeAt(u++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const ne=h(4);ne>=0?U+=String.fromCharCode(ne):I=4;break}default:I=5}C=u;continue}if(O>=0&&O<=31)if(f(O)){U+=t.substring(C,u),I=2;break}else I=6;u++}return U}function L(){if(v="",I=0,b=u,u>=o)return b=o,$=17;let U=t.charCodeAt(u);if(m(U)){do u++,v+=String.fromCharCode(U),U=t.charCodeAt(u);while(m(U));return $=15}if(f(U))return u++,v+=String.fromCharCode(U),U===13&&t.charCodeAt(u)===10&&(u++,v+=`
`),$=14;switch(U){case 123:return u++,$=1;case 125:return u++,$=2;case 91:return u++,$=3;case 93:return u++,$=4;case 58:return u++,$=6;case 44:return u++,$=5;case 34:return u++,v=A(),$=10;case 47:{const C=u-1;if(t.charCodeAt(u+1)===47){for(u+=2;u<o&&!f(t.charCodeAt(u));)u++;return v=t.substring(C,u),$=12}if(t.charCodeAt(u+1)===42){u+=2;const O=o-1;let q=!1;for(;u<O;){if(t.charCodeAt(u)===42&&t.charCodeAt(u+1)===47){u+=2,q=!0;break}u++}return q||(u++,I=1),v=t.substring(C,u),$=13}return v+=String.fromCharCode(U),u++,$=16}case 45:if(v+=String.fromCharCode(U),u++,u===o||!E(t.charCodeAt(u)))return $=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=w(),$=11;default:for(;u<o&&J(U);)u++,U=t.charCodeAt(u);if(b!==u){switch(v=t.substring(b,u),v){case"true":return $=8;case"false":return $=9;case"null":return $=7}return $=16}return v+=String.fromCharCode(U),u++,$=16}}function J(U){if(m(U)||f(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let U;do U=L();while(U>=12&&U<=15);return U}return{setPosition:y,getPosition:()=>u,scan:p?W:L,getToken:()=>$,getTokenValue:()=>v,getTokenOffset:()=>b,getTokenLength:()=>u-b,getTokenError:()=>I}}e.$qn=R;function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var N;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(N||(N={}));function D(t,p){const u=[],o=new Object;let v;const b={value:{},offset:0,length:0,type:"object",parent:void 0};let $=!1;function I(h,y,w,A){b.value=h,b.offset=y,b.length=w,b.type=A,b.colonOffset=void 0,v=b}try{n(t,{onObjectBegin:(h,y)=>{if(p<=h)throw o;v=void 0,$=p>h,u.push("")},onObjectProperty:(h,y,w)=>{if(p<y||(I(h,y,w,"property"),u[u.length-1]=h,p<=y+w))throw o},onObjectEnd:(h,y)=>{if(p<=h)throw o;v=void 0,u.pop()},onArrayBegin:(h,y)=>{if(p<=h)throw o;v=void 0,u.push(0)},onArrayEnd:(h,y)=>{if(p<=h)throw o;v=void 0,u.pop()},onLiteralValue:(h,y,w)=>{if(p<y||(I(h,y,w,d(h)),p<=y+w))throw o},onSeparator:(h,y,w)=>{if(p<=y)throw o;if(h===":"&&v&&v.type==="property")v.colonOffset=y,$=!1,v=void 0;else if(h===","){const A=u[u.length-1];typeof A=="number"?u[u.length-1]=A+1:($=!0,u[u.length-1]=""),v=void 0}}})}catch(h){if(h!==o)throw h}return{path:u,previousNode:v,isAtPropertyKey:$,matches:h=>{let y=0;for(let w=0;y<h.length&&w<u.length;w++)if(h[y]===u[w]||h[y]==="*")y++;else if(h[y]!=="**")return!1;return y===h.length}}}e.$rn=D;function l(t,p=[],u=F.DEFAULT){let o=null,v=[];const b=[];function $(h){Array.isArray(v)?v.push(h):o!==null&&(v[o]=h)}return n(t,{onObjectBegin:()=>{const h={};$(h),b.push(v),v=h,o=null},onObjectProperty:h=>{o=h},onObjectEnd:()=>{v=b.pop()},onArrayBegin:()=>{const h=[];$(h),b.push(v),v=h,o=null},onArrayEnd:()=>{v=b.pop()},onLiteralValue:$,onError:(h,y,w)=>{p.push({error:h,offset:y,length:w})}},u),v[0]}e.$sn=l;function k(t,p=[],u=F.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v(h){o.type==="property"&&(o.length=h-o.offset,o=o.parent)}function b(h){return o.children.push(h),h}n(t,{onObjectBegin:h=>{o=b({type:"object",offset:h,length:-1,parent:o,children:[]})},onObjectProperty:(h,y,w)=>{o=b({type:"property",offset:y,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:h,offset:y,length:w,parent:o})},onObjectEnd:(h,y)=>{o.length=h+y-o.offset,o=o.parent,v(h+y)},onArrayBegin:(h,y)=>{o=b({type:"array",offset:h,length:-1,parent:o,children:[]})},onArrayEnd:(h,y)=>{o.length=h+y-o.offset,o=o.parent,v(h+y)},onLiteralValue:(h,y,w)=>{b({type:d(h),offset:y,length:w,parent:o,value:h}),v(y+w)},onSeparator:(h,y,w)=>{o.type==="property"&&(h===":"?o.colonOffset=y:h===","&&v(y))},onError:(h,y,w)=>{p.push({error:h,offset:y,length:w})}},u);const I=o.children[0];return I&&delete I.parent,I}e.$tn=k;function g(t,p){if(!t)return;let u=t;for(const o of p)if(typeof o=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let v=!1;for(const b of u.children)if(Array.isArray(b.children)&&b.children[0].value===o){u=b.children[1],v=!0;break}if(!v)return}else{const v=o;if(u.type!=="array"||v<0||!Array.isArray(u.children)||v>=u.children.length)return;u=u.children[v]}return u}e.$un=g;function s(t){if(!t.parent||!t.parent.children)return[];const p=s(t.parent);if(t.parent.type==="property"){const u=t.parent.children[0].value;p.push(u)}else if(t.parent.type==="array"){const u=t.parent.children.indexOf(t);u!==-1&&p.push(u)}return p}e.$vn=s;function a(t){switch(t.type){case"array":return t.children.map(a);case"object":{const p=Object.create(null);for(const u of t.children){const o=u.children[1];o&&(p[u.children[0].value]=a(o))}return p}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$wn=a;function r(t,p,u=!1){return p>=t.offset&&p<t.offset+t.length||u&&p===t.offset+t.length}e.$xn=r;function i(t,p,u=!1){if(r(t,p,u)){const o=t.children;if(Array.isArray(o))for(let v=0;v<o.length&&o[v].offset<=p;v++){const b=i(o[v],p,u);if(b)return b}return t}}e.$yn=i;function n(t,p,u=F.DEFAULT){const o=R(t,!1);function v(re){return re?()=>re(o.getTokenOffset(),o.getTokenLength()):()=>!0}function b(re){return re?$e=>re($e,o.getTokenOffset(),o.getTokenLength()):()=>!0}const $=v(p.onObjectBegin),I=b(p.onObjectProperty),h=v(p.onObjectEnd),y=v(p.onArrayBegin),w=v(p.onArrayEnd),A=b(p.onLiteralValue),L=b(p.onSeparator),J=v(p.onComment),W=b(p.onError),U=u&&u.disallowComments,C=u&&u.allowTrailingComma;function O(){for(;;){const re=o.scan();switch(o.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:U||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(re){case 12:case 13:U?q(10):J();break;case 16:q(1);break;case 15:case 14:break;default:return re}}}function q(re,$e=[],ie=[]){if(W(re),$e.length+ie.length>0){let le=o.getToken();for(;le!==17;){if($e.indexOf(le)!==-1){O();break}else if(ie.indexOf(le)!==-1)break;le=O()}}}function ne(re){const $e=o.getTokenValue();return re?A($e):I($e),O(),!0}function ce(){switch(o.getToken()){case 11:{let re=0;try{re=JSON.parse(o.getTokenValue()),typeof re!="number"&&(q(2),re=0)}catch{q(2)}A(re);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return O(),!0}function ye(){return o.getToken()!==10?(q(3,[],[2,5]),!1):(ne(!1),o.getToken()===6?(L(":"),O(),ve()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function Ie(){$(),O();let re=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(re||q(4,[],[]),L(","),O(),o.getToken()===2&&C)break}else re&&q(6,[],[]);ye()||q(4,[],[2,5]),re=!0}return h(),o.getToken()!==2?q(7,[2],[]):O(),!0}function ue(){y(),O();let re=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(re||q(4,[],[]),L(","),O(),o.getToken()===4&&C)break}else re&&q(6,[],[]);ve()||q(4,[],[4,5]),re=!0}return w(),o.getToken()!==4?q(8,[4],[]):O(),!0}function ve(){switch(o.getToken()){case 3:return ue();case 1:return Ie();case 10:return ne(!0);default:return ce()}}return O(),o.getToken()===17?u.allowEmptyContent?!0:(q(4,[],[]),!1):ve()?(o.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.$zn=n;function c(t,p){const u=R(t),o=[];let v,b=0,$;do switch($=u.getPosition(),v=u.scan(),v){case 12:case 13:case 17:b!==$&&o.push(t.substring(b,$)),p!==void 0&&o.push(u.getTokenValue().replace(/[^\r\n]/g,p)),b=u.getPosition();break}while(v!==17);return o.join("")}e.$An=c;function d(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Bn=d}),function(me,e){typeof define=="function"&&define.amd?define(Pe[123],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(Ee,be){for(var ge=0;ge<be.length;ge++){var G=be[ge];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(Ee,G.key,G)}}function S(Ee,be,ge){return be&&e(Ee.prototype,be),ge&&e(Ee,ge),Object.defineProperty(Ee,"prototype",{writable:!1}),Ee}function M(Ee,be){if(Ee){if(typeof Ee=="string")return P(Ee,be);var ge=Object.prototype.toString.call(Ee).slice(8,-1);if(ge==="Object"&&Ee.constructor&&(ge=Ee.constructor.name),ge==="Map"||ge==="Set")return Array.from(Ee);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return P(Ee,be)}}function P(Ee,be){(be==null||be>Ee.length)&&(be=Ee.length);for(var ge=0,G=new Array(be);ge<be;ge++)G[ge]=Ee[ge];return G}function F(Ee,be){var ge=typeof Symbol<"u"&&Ee[Symbol.iterator]||Ee["@@iterator"];if(ge)return(ge=ge.call(Ee)).next.bind(ge);if(Array.isArray(Ee)||(ge=M(Ee))||be&&Ee&&typeof Ee.length=="number"){ge&&(Ee=ge);var G=0;return function(){return G>=Ee.length?{done:!0}:{done:!1,value:Ee[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=R();function m(Ee){me.defaults=Ee}var f=/[&<>"']/,E=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(be){return l[be]};function g(Ee,be){if(be){if(f.test(Ee))return Ee.replace(E,k)}else if(N.test(Ee))return Ee.replace(D,k);return Ee}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(Ee){return Ee.replace(s,function(be,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var r=/(^|[^\[])\^/g;function i(Ee,be){Ee=typeof Ee=="string"?Ee:Ee.source,be=be||"";var ge={replace:function(Y,he){return he=he.source||he,he=he.replace(r,"$1"),Ee=Ee.replace(Y,he),ge},getRegex:function(){return new RegExp(Ee,be)}};return ge}var n=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(Ee,be,ge){if(Ee){var G;try{G=decodeURIComponent(a(ge)).replace(n,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}be&&!c.test(ge)&&(ge=v(be,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var t={},p=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(Ee,be){t[" "+Ee]||(p.test(Ee)?t[" "+Ee]=Ee+"/":t[" "+Ee]=h(Ee,"/",!0)),Ee=t[" "+Ee];var ge=Ee.indexOf(":")===-1;return be.substring(0,2)==="//"?ge?be:Ee.replace(u,"$1")+be:be.charAt(0)==="/"?ge?be:Ee.replace(o,"$1")+be:Ee+be}var b={exec:function(){}};function $(Ee){for(var be=1,ge,G;be<arguments.length;be++){ge=arguments[be];for(G in ge)Object.prototype.hasOwnProperty.call(ge,G)&&(Ee[G]=ge[G])}return Ee}function I(Ee,be){var ge=Ee.replace(/\|/g,function(he,fe,Oe){for(var de=!1,Ce=fe;--Ce>=0&&Oe[Ce]==="\\";)de=!de;return de?"|":" |"}),G=ge.split(/ \|/),Y=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>be)G.splice(be);else for(;G.length<be;)G.push("");for(;Y<G.length;Y++)G[Y]=G[Y].trim().replace(/\\\|/g,"|");return G}function h(Ee,be,ge){var G=Ee.length;if(G===0)return"";for(var Y=0;Y<G;){var he=Ee.charAt(G-Y-1);if(he===be&&!ge)Y++;else if(he!==be&&ge)Y++;else break}return Ee.slice(0,G-Y)}function y(Ee,be){if(Ee.indexOf(be[1])===-1)return-1;for(var ge=Ee.length,G=0,Y=0;Y<ge;Y++)if(Ee[Y]==="\\")Y++;else if(Ee[Y]===be[0])G++;else if(Ee[Y]===be[1]&&(G--,G<0))return Y;return-1}function w(Ee){Ee&&Ee.sanitize&&!Ee.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(Ee,be){if(be<1)return"";for(var ge="";be>1;)be&1&&(ge+=Ee),be>>=1,Ee+=Ee;return ge+Ee}function L(Ee,be,ge,G){var Y=be.href,he=be.title?g(be.title):null,fe=Ee[1].replace(/\\([\[\]])/g,"$1");if(Ee[0].charAt(0)!=="!"){G.state.inLink=!0;var Oe={type:"link",raw:ge,href:Y,title:he,text:fe,tokens:G.inlineTokens(fe)};return G.state.inLink=!1,Oe}return{type:"image",raw:ge,href:Y,title:he,text:g(fe)}}function J(Ee,be){var ge=Ee.match(/^(\s+)(?:```)/);if(ge===null)return be;var G=ge[1];return be.split(`
`).map(function(Y){var he=Y.match(/^\s+/);if(he===null)return Y;var fe=he[0];return fe.length>=G.length?Y.slice(G.length):Y}).join(`
`)}var W=function(){function Ee(ge){this.options=ge||me.defaults}var be=Ee.prototype;return be.space=function(G){var Y=this.rules.block.newline.exec(G);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},be.code=function(G){var Y=this.rules.block.code.exec(G);if(Y){var he=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?he:h(he,`
`)}}},be.fences=function(G){var Y=this.rules.block.fences.exec(G);if(Y){var he=Y[0],fe=J(he,Y[3]||"");return{type:"code",raw:he,lang:Y[2]?Y[2].trim():Y[2],text:fe}}},be.heading=function(G){var Y=this.rules.block.heading.exec(G);if(Y){var he=Y[2].trim();if(/#$/.test(he)){var fe=h(he,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(he=fe.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:he,tokens:this.lexer.inline(he)}}},be.hr=function(G){var Y=this.rules.block.hr.exec(G);if(Y)return{type:"hr",raw:Y[0]}},be.blockquote=function(G){var Y=this.rules.block.blockquote.exec(G);if(Y){var he=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},be.list=function(G){var Y=this.rules.block.list.exec(G);if(Y){var he,fe,Oe,de,Ce,Ae,ze,z,j,K,H,ee,se=Y[1].trim(),Ne=se.length>1,Ve={type:"list",raw:"",ordered:Ne,start:Ne?+se.slice(0,-1):"",loose:!1,items:[]};se=Ne?"\\d{1,9}\\"+se.slice(-1):"\\"+se,this.options.pedantic&&(se=Ne?se:"[*+-]");for(var He=new RegExp("^( {0,3}"+se+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(ee=!1,!(!(Y=He.exec(G))||this.rules.block.hr.test(G)));){if(he=Y[0],G=G.substring(he.length),z=Y[2].split(`
`,1)[0],j=G.split(`
`,1)[0],this.options.pedantic?(de=2,H=z.trimLeft()):(de=Y[2].search(/[^ ]/),de=de>4?1:de,H=z.slice(de),de+=Y[1].length),Ae=!1,!z&&/^ *$/.test(j)&&(he+=j+`
`,G=G.substring(j.length+1),ee=!0),!ee)for(var xe=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,de-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),lt=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,de-1)+"}#");G&&(K=G.split(`
`,1)[0],z=K,this.options.pedantic&&(z=z.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(lt.test(z)||rt.test(z)||xe.test(z)||tt.test(G)));){if(z.search(/[^ ]/)>=de||!z.trim())H+=`
`+z.slice(de);else if(!Ae)H+=`
`+z;else break;!Ae&&!z.trim()&&(Ae=!0),he+=K+`
`,G=G.substring(K.length+1)}Ve.loose||(ze?Ve.loose=!0:/\n *\n *$/.test(he)&&(ze=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(H),fe&&(Oe=fe[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:he,task:!!fe,checked:Oe,loose:!1,text:H}),Ve.raw+=he}Ve.items[Ve.items.length-1].raw=he.trimRight(),Ve.items[Ve.items.length-1].text=H.trimRight(),Ve.raw=Ve.raw.trimRight();var it=Ve.items.length;for(Ce=0;Ce<it;Ce++){this.lexer.state.top=!1,Ve.items[Ce].tokens=this.lexer.blockTokens(Ve.items[Ce].text,[]);var ot=Ve.items[Ce].tokens.filter(function(et){return et.type==="space"}),Be=ot.every(function(et){for(var X=et.raw.split(""),Z=0,pe=F(X),We;!(We=pe()).done;){var Ze=We.value;if(Ze===`
`&&(Z+=1),Z>1)return!0}return!1});!Ve.loose&&ot.length&&Be&&(Ve.loose=!0,Ve.items[Ce].loose=!0)}return Ve}},be.html=function(G){var Y=this.rules.block.html.exec(G);if(Y){var he={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var fe=this.options.sanitizer?this.options.sanitizer(Y[0]):g(Y[0]);he.type="paragraph",he.text=fe,he.tokens=this.lexer.inline(fe)}return he}},be.def=function(G){var Y=this.rules.block.def.exec(G);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var he=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:Y[0],href:Y[2],title:Y[3]}}},be.table=function(G){var Y=this.rules.block.table.exec(G);if(Y){var he={type:"table",header:I(Y[1]).map(function(ze){return{text:ze}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=Y[0];var fe=he.align.length,Oe,de,Ce,Ae;for(Oe=0;Oe<fe;Oe++)/^ *-+: *$/.test(he.align[Oe])?he.align[Oe]="right":/^ *:-+: *$/.test(he.align[Oe])?he.align[Oe]="center":/^ *:-+ *$/.test(he.align[Oe])?he.align[Oe]="left":he.align[Oe]=null;for(fe=he.rows.length,Oe=0;Oe<fe;Oe++)he.rows[Oe]=I(he.rows[Oe],he.header.length).map(function(ze){return{text:ze}});for(fe=he.header.length,de=0;de<fe;de++)he.header[de].tokens=this.lexer.inline(he.header[de].text);for(fe=he.rows.length,de=0;de<fe;de++)for(Ae=he.rows[de],Ce=0;Ce<Ae.length;Ce++)Ae[Ce].tokens=this.lexer.inline(Ae[Ce].text);return he}}},be.lheading=function(G){var Y=this.rules.block.lheading.exec(G);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},be.paragraph=function(G){var Y=this.rules.block.paragraph.exec(G);if(Y){var he=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:he,tokens:this.lexer.inline(he)}}},be.text=function(G){var Y=this.rules.block.text.exec(G);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},be.escape=function(G){var Y=this.rules.inline.escape.exec(G);if(Y)return{type:"escape",raw:Y[0],text:g(Y[1])}},be.tag=function(G){var Y=this.rules.inline.tag.exec(G);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):g(Y[0]):Y[0]}},be.link=function(G){var Y=this.rules.inline.link.exec(G);if(Y){var he=Y[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var fe=h(he.slice(0,-1),"\\");if((he.length-fe.length)%2===0)return}else{var Oe=y(Y[2],"()");if(Oe>-1){var de=Y[0].indexOf("!")===0?5:4,Ce=de+Y[1].length+Oe;Y[2]=Y[2].substring(0,Oe),Y[0]=Y[0].substring(0,Ce).trim(),Y[3]=""}}var Ae=Y[2],ze="";if(this.options.pedantic){var z=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);z&&(Ae=z[1],ze=z[3])}else ze=Y[3]?Y[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(he)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),L(Y,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},be.reflink=function(G,Y){var he;if((he=this.rules.inline.reflink.exec(G))||(he=this.rules.inline.nolink.exec(G))){var fe=(he[2]||he[1]).replace(/\s+/g," ");if(fe=Y[fe.toLowerCase()],!fe||!fe.href){var Oe=he[0].charAt(0);return{type:"text",raw:Oe,text:Oe}}return L(he,fe,he[0],this.lexer)}},be.emStrong=function(G,Y,he){he===void 0&&(he="");var fe=this.rules.inline.emStrong.lDelim.exec(G);if(fe&&!(fe[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Oe=fe[1]||fe[2]||"";if(!Oe||Oe&&(he===""||this.rules.inline.punctuation.exec(he))){var de=fe[0].length-1,Ce,Ae,ze=de,z=0,j=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(j.lastIndex=0,Y=Y.slice(-1*G.length+de);(fe=j.exec(Y))!=null;)if(Ce=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!Ce){if(Ae=Ce.length,fe[3]||fe[4]){ze+=Ae;continue}else if((fe[5]||fe[6])&&de%3&&!((de+Ae)%3)){z+=Ae;continue}if(ze-=Ae,!(ze>0)){if(Ae=Math.min(Ae,Ae+ze+z),Math.min(de,Ae)%2){var K=G.slice(1,de+fe.index+Ae);return{type:"em",raw:G.slice(0,de+fe.index+Ae+1),text:K,tokens:this.lexer.inlineTokens(K)}}var H=G.slice(2,de+fe.index+Ae-1);return{type:"strong",raw:G.slice(0,de+fe.index+Ae+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},be.codespan=function(G){var Y=this.rules.inline.code.exec(G);if(Y){var he=Y[2].replace(/\n/g," "),fe=/[^ ]/.test(he),Oe=/^ /.test(he)&&/ $/.test(he);return fe&&Oe&&(he=he.substring(1,he.length-1)),he=g(he,!0),{type:"codespan",raw:Y[0],text:he}}},be.br=function(G){var Y=this.rules.inline.br.exec(G);if(Y)return{type:"br",raw:Y[0]}},be.del=function(G){var Y=this.rules.inline.del.exec(G);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},be.autolink=function(G,Y){var he=this.rules.inline.autolink.exec(G);if(he){var fe,Oe;return he[2]==="@"?(fe=g(this.options.mangle?Y(he[1]):he[1]),Oe="mailto:"+fe):(fe=g(he[1]),Oe=fe),{type:"link",raw:he[0],text:fe,href:Oe,tokens:[{type:"text",raw:fe,text:fe}]}}},be.url=function(G,Y){var he;if(he=this.rules.inline.url.exec(G)){var fe,Oe;if(he[2]==="@")fe=g(this.options.mangle?Y(he[0]):he[0]),Oe="mailto:"+fe;else{var de;do de=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(de!==he[0]);fe=g(he[0]),he[1]==="www."?Oe="http://"+fe:Oe=fe}return{type:"link",raw:he[0],text:fe,href:Oe,tokens:[{type:"text",raw:fe,text:fe}]}}},be.inlineText=function(G,Y){var he=this.rules.inline.text.exec(G);if(he){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):g(he[0]):he[0]:fe=g(this.options.smartypants?Y(he[0]):he[0]),{type:"text",raw:he[0],text:fe}}},Ee}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:b,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=i(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=i(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=i(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=i(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=i(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=i(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=$({},U),U.gfm=$({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=i(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=i(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=$({},U.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:b,paragraph:i(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var C={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:b,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:b,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};C._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",C.punctuation=i(C.punctuation).replace(/punctuation/g,C._punctuation).getRegex(),C.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,C.escapedEmSt=/\\\*|\\_/g,C._comment=i(U._comment).replace("(?:-->|$)","-->").getRegex(),C.emStrong.lDelim=i(C.emStrong.lDelim).replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimAst=i(C.emStrong.rDelimAst,"g").replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimUnd=i(C.emStrong.rDelimUnd,"g").replace(/punct/g,C._punctuation).getRegex(),C._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,C._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,C._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,C.autolink=i(C.autolink).replace("scheme",C._scheme).replace("email",C._email).getRegex(),C._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,C.tag=i(C.tag).replace("comment",C._comment).replace("attribute",C._attribute).getRegex(),C._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,C._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,C._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,C.link=i(C.link).replace("label",C._label).replace("href",C._href).replace("title",C._title).getRegex(),C.reflink=i(C.reflink).replace("label",C._label).replace("ref",U._label).getRegex(),C.nolink=i(C.nolink).replace("ref",U._label).getRegex(),C.reflinkSearch=i(C.reflinkSearch,"g").replace("reflink",C.reflink).replace("nolink",C.nolink).getRegex(),C.normal=$({},C),C.pedantic=$({},C.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",C._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",C._label).getRegex()}),C.gfm=$({},C.normal,{escape:i(C.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),C.gfm.url=i(C.gfm.url,"i").replace("email",C.gfm._extended_email).getRegex(),C.breaks=$({},C.gfm,{br:i(C.br).replace("{2,}","*").getRegex(),text:i(C.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(Ee){return Ee.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(Ee){var be="",ge,G,Y=Ee.length;for(ge=0;ge<Y;ge++)G=Ee.charCodeAt(ge),Math.random()>.5&&(G="x"+G.toString(16)),be+="&#"+G+";";return be}var ne=function(){function Ee(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||me.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:U.normal,inline:C.normal};this.options.pedantic?(G.block=U.pedantic,G.inline=C.pedantic):this.options.gfm&&(G.block=U.gfm,this.options.breaks?G.inline=C.breaks:G.inline=C.gfm),this.tokenizer.rules=G}Ee.lex=function(G,Y){var he=new Ee(Y);return he.lex(G)},Ee.lexInline=function(G,Y){var he=new Ee(Y);return he.inlineTokens(G)};var be=Ee.prototype;return be.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},be.blockTokens=function(G,Y){var he=this;Y===void 0&&(Y=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(ze,z,j){return z+"    ".repeat(j.length)});for(var fe,Oe,de,Ce;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(fe=ze.call({lexer:he},G,Y))?(G=G.substring(fe.raw.length),Y.push(fe),!0):!1}))){if(fe=this.tokenizer.space(G)){G=G.substring(fe.raw.length),fe.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(fe);continue}if(fe=this.tokenizer.code(G)){G=G.substring(fe.raw.length),Oe=Y[Y.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+fe.raw,Oe.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):Y.push(fe);continue}if(fe=this.tokenizer.fences(G)){G=G.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.heading(G)){G=G.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.hr(G)){G=G.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.blockquote(G)){G=G.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.list(G)){G=G.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.html(G)){G=G.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.def(G)){G=G.substring(fe.raw.length),Oe=Y[Y.length-1],Oe&&(Oe.type==="paragraph"||Oe.type==="text")?(Oe.raw+=`
`+fe.raw,Oe.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(G)){G=G.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.lheading(G)){G=G.substring(fe.raw.length),Y.push(fe);continue}if(de=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,z=G.slice(1),j=void 0;he.options.extensions.startBlock.forEach(function(K){j=K.call({lexer:this},z),typeof j=="number"&&j>=0&&(ze=Math.min(ze,j))}),ze<1/0&&ze>=0&&(de=G.substring(0,ze+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(de))){Oe=Y[Y.length-1],Ce&&Oe.type==="paragraph"?(Oe.raw+=`
`+fe.raw,Oe.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):Y.push(fe),Ce=de.length!==G.length,G=G.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(G)){G=G.substring(fe.raw.length),Oe=Y[Y.length-1],Oe&&Oe.type==="text"?(Oe.raw+=`
`+fe.raw,Oe.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Oe.text):Y.push(fe);continue}if(G){var Ae="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,Y},be.inline=function(G,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:G,tokens:Y}),Y},be.inlineTokens=function(G,Y){var he=this;Y===void 0&&(Y=[]);var fe,Oe,de,Ce=G,Ae,ze,z;if(this.tokens.links){var j=Object.keys(this.tokens.links);if(j.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ce))!=null;)j.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ce=Ce.slice(0,Ae.index)+"["+A("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"["+A("a",Ae[0].length-2)+"]"+Ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ce))!=null;)Ce=Ce.slice(0,Ae.index)+"++"+Ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(ze||(z=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return(fe=H.call({lexer:he},G,Y))?(G=G.substring(fe.raw.length),Y.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(G)){G=G.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.tag(G)){G=G.substring(fe.raw.length),Oe=Y[Y.length-1],Oe&&fe.type==="text"&&Oe.type==="text"?(Oe.raw+=fe.raw,Oe.text+=fe.text):Y.push(fe);continue}if(fe=this.tokenizer.link(G)){G=G.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(fe.raw.length),Oe=Y[Y.length-1],Oe&&fe.type==="text"&&Oe.type==="text"?(Oe.raw+=fe.raw,Oe.text+=fe.text):Y.push(fe);continue}if(fe=this.tokenizer.emStrong(G,Ce,z)){G=G.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.codespan(G)){G=G.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.br(G)){G=G.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.del(G)){G=G.substring(fe.raw.length),Y.push(fe);continue}if(fe=this.tokenizer.autolink(G,q)){G=G.substring(fe.raw.length),Y.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(G,q))){G=G.substring(fe.raw.length),Y.push(fe);continue}if(de=G,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,ee=G.slice(1),se=void 0;he.options.extensions.startInline.forEach(function(Ne){se=Ne.call({lexer:this},ee),typeof se=="number"&&se>=0&&(H=Math.min(H,se))}),H<1/0&&H>=0&&(de=G.substring(0,H+1))}(),fe=this.tokenizer.inlineText(de,O)){G=G.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(z=fe.raw.slice(-1)),ze=!0,Oe=Y[Y.length-1],Oe&&Oe.type==="text"?(Oe.raw+=fe.raw,Oe.text+=fe.text):Y.push(fe);continue}if(G){var K="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return Y},S(Ee,null,[{key:"rules",get:function(){return{block:U,inline:C}}}]),Ee}(),ce=function(){function Ee(ge){this.options=ge||me.defaults}var be=Ee.prototype;return be.code=function(G,Y,he){var fe=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Oe=this.options.highlight(G,fe);Oe!=null&&Oe!==G&&(he=!0,G=Oe)}return G=G.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+g(fe,!0)+'">'+(he?G:g(G,!0))+`</code></pre>
`:"<pre><code>"+(he?G:g(G,!0))+`</code></pre>
`},be.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},be.html=function(G){return G},be.heading=function(G,Y,he,fe){if(this.options.headerIds){var Oe=this.options.headerPrefix+fe.slug(he);return"<h"+Y+' id="'+Oe+'">'+G+"</h"+Y+`>
`}return"<h"+Y+">"+G+"</h"+Y+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(G,Y,he){var fe=Y?"ol":"ul",Oe=Y&&he!==1?' start="'+he+'"':"";return"<"+fe+Oe+`>
`+G+"</"+fe+`>
`},be.listitem=function(G){return"<li>"+G+`</li>
`},be.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(G){return"<p>"+G+`</p>
`},be.table=function(G,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+Y+`</table>
`},be.tablerow=function(G){return`<tr>
`+G+`</tr>
`},be.tablecell=function(G,Y){var he=Y.header?"th":"td",fe=Y.align?"<"+he+' align="'+Y.align+'">':"<"+he+">";return fe+G+("</"+he+`>
`)},be.strong=function(G){return"<strong>"+G+"</strong>"},be.em=function(G){return"<em>"+G+"</em>"},be.codespan=function(G){return"<code>"+G+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(G){return"<del>"+G+"</del>"},be.link=function(G,Y,he){if(G=d(this.options.sanitize,this.options.baseUrl,G),G===null)return he;var fe='<a href="'+g(G)+'"';return Y&&(fe+=' title="'+Y+'"'),fe+=">"+he+"</a>",fe},be.image=function(G,Y,he){if(G=d(this.options.sanitize,this.options.baseUrl,G),G===null)return he;var fe='<img src="'+G+'" alt="'+he+'"';return Y&&(fe+=' title="'+Y+'"'),fe+=this.options.xhtml?"/>":">",fe},be.text=function(G){return G},Ee}(),ye=function(){function Ee(){}var be=Ee.prototype;return be.strong=function(G){return G},be.em=function(G){return G},be.codespan=function(G){return G},be.del=function(G){return G},be.html=function(G){return G},be.text=function(G){return G},be.link=function(G,Y,he){return""+he},be.image=function(G,Y,he){return""+he},be.br=function(){return""},Ee}(),Ie=function(){function Ee(){this.seen={}}var be=Ee.prototype;return be.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(G,Y){var he=G,fe=0;if(this.seen.hasOwnProperty(he)){fe=this.seen[G];do fe++,he=G+"-"+fe;while(this.seen.hasOwnProperty(he))}return Y||(this.seen[G]=fe,this.seen[he]=0),he},be.slug=function(G,Y){Y===void 0&&(Y={});var he=this.serialize(G);return this.getNextSafeSlug(he,Y.dryrun)},Ee}(),ue=function(){function Ee(ge){this.options=ge||me.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new Ie}Ee.parse=function(G,Y){var he=new Ee(Y);return he.parse(G)},Ee.parseInline=function(G,Y){var he=new Ee(Y);return he.parseInline(G)};var be=Ee.prototype;return be.parse=function(G,Y){Y===void 0&&(Y=!0);var he="",fe,Oe,de,Ce,Ae,ze,z,j,K,H,ee,se,Ne,Ve,He,xe,tt,lt,rt,it=G.length;for(fe=0;fe<it;fe++){if(H=G[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(rt=this.options.extensions.renderers[H.type].call({parser:this},H),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){he+=rt||"";continue}switch(H.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(H.tokens),H.depth,a(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(j="",z="",Ce=H.header.length,Oe=0;Oe<Ce;Oe++)z+=this.renderer.tablecell(this.parseInline(H.header[Oe].tokens),{header:!0,align:H.align[Oe]});for(j+=this.renderer.tablerow(z),K="",Ce=H.rows.length,Oe=0;Oe<Ce;Oe++){for(ze=H.rows[Oe],z="",Ae=ze.length,de=0;de<Ae;de++)z+=this.renderer.tablecell(this.parseInline(ze[de].tokens),{header:!1,align:H.align[de]});K+=this.renderer.tablerow(z)}he+=this.renderer.table(j,K);continue}case"blockquote":{K=this.parse(H.tokens),he+=this.renderer.blockquote(K);continue}case"list":{for(ee=H.ordered,se=H.start,Ne=H.loose,Ce=H.items.length,K="",Oe=0;Oe<Ce;Oe++)He=H.items[Oe],xe=He.checked,tt=He.task,Ve="",He.task&&(lt=this.renderer.checkbox(xe),Ne?He.tokens.length>0&&He.tokens[0].type==="paragraph"?(He.tokens[0].text=lt+" "+He.tokens[0].text,He.tokens[0].tokens&&He.tokens[0].tokens.length>0&&He.tokens[0].tokens[0].type==="text"&&(He.tokens[0].tokens[0].text=lt+" "+He.tokens[0].tokens[0].text)):He.tokens.unshift({type:"text",text:lt}):Ve+=lt),Ve+=this.parse(He.tokens,Ne),K+=this.renderer.listitem(Ve,tt,xe);he+=this.renderer.list(K,ee,se);continue}case"html":{he+=this.renderer.html(H.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(K=H.tokens?this.parseInline(H.tokens):H.text;fe+1<it&&G[fe+1].type==="text";)H=G[++fe],K+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);he+=Y?this.renderer.paragraph(K):K;continue}default:{var ot='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error(ot);return}else throw new Error(ot)}}}return he},be.parseInline=function(G,Y){Y=Y||this.renderer;var he="",fe,Oe,de,Ce=G.length;for(fe=0;fe<Ce;fe++){if(Oe=G[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Oe.type]&&(de=this.options.extensions.renderers[Oe.type].call({parser:this},Oe),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Oe.type))){he+=de||"";continue}switch(Oe.type){case"escape":{he+=Y.text(Oe.text);break}case"html":{he+=Y.html(Oe.text);break}case"link":{he+=Y.link(Oe.href,Oe.title,this.parseInline(Oe.tokens,Y));break}case"image":{he+=Y.image(Oe.href,Oe.title,Oe.text);break}case"strong":{he+=Y.strong(this.parseInline(Oe.tokens,Y));break}case"em":{he+=Y.em(this.parseInline(Oe.tokens,Y));break}case"codespan":{he+=Y.codespan(Oe.text);break}case"br":{he+=Y.br();break}case"del":{he+=Y.del(this.parseInline(Oe.tokens,Y));break}case"text":{he+=Y.text(Oe.text);break}default:{var Ae='Token with "'+Oe.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return he},Ee}();function ve(Ee,be,ge){if(typeof Ee>"u"||Ee===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");if(typeof be=="function"&&(ge=be,be=null),be=$({},ve.defaults,be||{}),w(be),ge){var G=be.highlight,Y;try{Y=ne.lex(Ee,be)}catch(Ce){return ge(Ce)}var he=function(Ae){var ze;if(!Ae)try{be.walkTokens&&ve.walkTokens(Y,be.walkTokens),ze=ue.parse(Y,be)}catch(z){Ae=z}return be.highlight=G,Ae?ge(Ae):ge(null,ze)};if(!G||G.length<3||(delete be.highlight,!Y.length))return he();var fe=0;ve.walkTokens(Y,function(Ce){Ce.type==="code"&&(fe++,setTimeout(function(){G(Ce.text,Ce.lang,function(Ae,ze){if(Ae)return he(Ae);ze!=null&&ze!==Ce.text&&(Ce.text=ze,Ce.escaped=!0),fe--,fe===0&&he()})},0))}),fe===0&&he();return}function Oe(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+g(Ce.message+"",!0)+"</pre>";throw Ce}try{var de=ne.lex(Ee,be);if(be.walkTokens){if(be.async)return Promise.all(ve.walkTokens(de,be.walkTokens)).then(function(){return ue.parse(de,be)}).catch(Oe);ve.walkTokens(de,be.walkTokens)}return ue.parse(de,be)}catch(Ce){Oe(Ce)}}ve.options=ve.setOptions=function(Ee){return $(ve.defaults,Ee),m(ve.defaults),ve},ve.getDefaults=R,ve.defaults=me.defaults,ve.use=function(){for(var Ee=arguments.length,be=new Array(Ee),ge=0;ge<Ee;ge++)be[ge]=arguments[ge];var G=$.apply(void 0,[{}].concat(be)),Y=ve.defaults.extensions||{renderers:{},childTokens:{}},he;be.forEach(function(fe){if(fe.extensions&&(he=!0,fe.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var Ce=Y.renderers?Y.renderers[de.name]:null;Ce?Y.renderers[de.name]=function(){for(var Ae=arguments.length,ze=new Array(Ae),z=0;z<Ae;z++)ze[z]=arguments[z];var j=de.renderer.apply(this,ze);return j===!1&&(j=Ce.apply(this,ze)),j}:Y.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[de.level]?Y[de.level].unshift(de.tokenizer):Y[de.level]=[de.tokenizer],de.start&&(de.level==="block"?Y.startBlock?Y.startBlock.push(de.start):Y.startBlock=[de.start]:de.level==="inline"&&(Y.startInline?Y.startInline.push(de.start):Y.startInline=[de.start]))}de.childTokens&&(Y.childTokens[de.name]=de.childTokens)})),fe.renderer&&function(){var de=ve.defaults.renderer||new ce,Ce=function(z){var j=de[z];de[z]=function(){for(var K=arguments.length,H=new Array(K),ee=0;ee<K;ee++)H[ee]=arguments[ee];var se=fe.renderer[z].apply(de,H);return se===!1&&(se=j.apply(de,H)),se}};for(var Ae in fe.renderer)Ce(Ae);G.renderer=de}(),fe.tokenizer&&function(){var de=ve.defaults.tokenizer||new W,Ce=function(z){var j=de[z];de[z]=function(){for(var K=arguments.length,H=new Array(K),ee=0;ee<K;ee++)H[ee]=arguments[ee];var se=fe.tokenizer[z].apply(de,H);return se===!1&&(se=j.apply(de,H)),se}};for(var Ae in fe.tokenizer)Ce(Ae);G.tokenizer=de}(),fe.walkTokens){var Oe=ve.defaults.walkTokens;G.walkTokens=function(de){var Ce=[];return Ce.push(fe.walkTokens.call(this,de)),Oe&&(Ce=Ce.concat(Oe.call(this,de))),Ce}}he&&(G.extensions=Y),ve.setOptions(G)})},ve.walkTokens=function(Ee,be){for(var ge=[],G=function(){var Oe=he.value;switch(ge=ge.concat(be.call(ve,Oe)),Oe.type){case"table":{for(var de=F(Oe.header),Ce;!(Ce=de()).done;){var Ae=Ce.value;ge=ge.concat(ve.walkTokens(Ae.tokens,be))}for(var ze=F(Oe.rows),z;!(z=ze()).done;)for(var j=z.value,K=F(j),H;!(H=K()).done;){var ee=H.value;ge=ge.concat(ve.walkTokens(ee.tokens,be))}break}case"list":{ge=ge.concat(ve.walkTokens(Oe.items,be));break}default:ve.defaults.extensions&&ve.defaults.extensions.childTokens&&ve.defaults.extensions.childTokens[Oe.type]?ve.defaults.extensions.childTokens[Oe.type].forEach(function(se){ge=ge.concat(ve.walkTokens(Oe[se],be))}):Oe.tokens&&(ge=ge.concat(ve.walkTokens(Oe.tokens,be)))}},Y=F(Ee),he;!(he=Y()).done;)G();return ge},ve.parseInline=function(Ee,be){if(typeof Ee>"u"||Ee===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");be=$({},ve.defaults,be||{}),w(be);try{var ge=ne.lexInline(Ee,be);return be.walkTokens&&ve.walkTokens(ge,be.walkTokens),ue.parseInline(ge,be)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+g(G.message+"",!0)+"</pre>";throw G}},ve.Parser=ue,ve.parser=ue.parse,ve.Renderer=ce,ve.TextRenderer=ye,ve.Lexer=ne,ve.lexer=ne.lex,ve.Tokenizer=W,ve.Slugger=Ie,ve.parse=ve;var re=ve.options,$e=ve.setOptions,ie=ve.use,le=ve.walkTokens,V=ve.parseInline,_=ve,ke=ue.parse,Le=ne.lex;me.Lexer=ne,me.Parser=ue,me.Renderer=ce,me.Slugger=Ie,me.TextRenderer=ye,me.Tokenizer=W,me.getDefaults=R,me.lexer=Le,me.marked=ve,me.options=re,me.parse=_,me.parseInline=V,me.parser=ke,me.setOptions=$e,me.use=ie,me.walkTokens=le,Object.defineProperty(me,"__esModule",{value:!0})}),define(Pe[124],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=void 0;function S(s){const a=F(s);if(a&&a.length>0)return new Uint32Array(a)}e.$5j=S;let M=0;const P=new Uint32Array(10);function F(s){if(M=0,R(s,D,4352),M>0||(R(s,l,4449),M>0)||(R(s,k,4520),M>0)||(R(s,g,12593),M))return P.subarray(0,M);if(s>=44032&&s<=55203){const a=s-44032,r=a%588,i=Math.floor(a/588),n=Math.floor(r/28),c=r%28-1;if(i<D.length?R(i,D,0):4352+i-12593<g.length&&R(4352+i,g,12593),n<l.length?R(n,l,0):4449+n-12593<g.length&&R(4449+n-12593,g,12593),c>=0&&(c<k.length?R(c,k,0):4520+c-12593<g.length&&R(4520+c-12593,g,12593)),M>0)return P.subarray(0,M)}}function R(s,a,r){s>=r&&s<r+a.length&&m(a[s-r])}function m(s){s!==0&&(P[M++]=s&255,s>>8&&(P[M++]=s>>8&255),s>>16&&(P[M++]=s>>16&255))}var f;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(f||(f={}));var E;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(E||(E={}));var N;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(N||(N={}));const D=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),k=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),g=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Pe[125],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=e.$hm=e.rot=e.$fm=void 0;function S(m,f,E){return Math.min(Math.max(m,f),E)}e.$fm=S;function M(m,f){return(f+m%f)%f}e.rot=M;class P{constructor(){this.a=0}getNext(){return this.a++}}e.$hm=P;class F{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$im=F;class R{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const E=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$jm=R}),function(){function me(P){const F=[];typeof P=="number"&&F.push("code/timeOrigin",P);function R(f){F.push(f,Date.now())}function m(){const f=[];for(let E=0;E<F.length;E+=2)f.push({name:F[E],startTime:F[E+1]});return f}return{mark:R,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const F=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const R of performance.getEntriesByType("mark"))F.push({name:R.name,startTime:Math.round(P+R.startTime)});return F}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function S(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=S(M))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var M in S)(typeof exports=="object"?exports:me)[M]=S[M]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function S(M){if(e[M])return e[M].exports;var P=e[M]={i:M,l:!1,exports:{}};return me[M].call(P.exports,P,P.exports,S),P.l=!0,P.exports}return S.m=me,S.c=e,S.d=function(M,P,F){S.o(M,P)||Object.defineProperty(M,P,{enumerable:!0,get:F})},S.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},S.t=function(M,P){if(1&P&&(M=S(M)),8&P||4&P&&typeof M=="object"&&M&&M.__esModule)return M;var F=Object.create(null);if(S.r(F),Object.defineProperty(F,"default",{enumerable:!0,value:M}),2&P&&typeof M!="string")for(var R in M)S.d(F,R,function(m){return M[m]}.bind(null,R));return F},S.n=function(M){var P=M&&M.__esModule?function(){return M.default}:function(){return M};return S.d(P,"a",P),P},S.o=function(M,P){return Object.prototype.hasOwnProperty.call(M,P)},S.p="",S(S.s=0)}([function(me,e,S){(function(M){var P;e=me.exports=ie,P=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var F=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],f=e.src=[],E=0,N=E++;f[N]="0|[1-9]\\d*";var D=E++;f[D]="[0-9]+";var l=E++;f[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=E++;f[k]="("+f[N]+")\\.("+f[N]+")\\.("+f[N]+")";var g=E++;f[g]="("+f[D]+")\\.("+f[D]+")\\.("+f[D]+")";var s=E++;f[s]="(?:"+f[N]+"|"+f[l]+")";var a=E++;f[a]="(?:"+f[D]+"|"+f[l]+")";var r=E++;f[r]="(?:-("+f[s]+"(?:\\."+f[s]+")*))";var i=E++;f[i]="(?:-?("+f[a]+"(?:\\."+f[a]+")*))";var n=E++;f[n]="[0-9A-Za-z-]+";var c=E++;f[c]="(?:\\+("+f[n]+"(?:\\."+f[n]+")*))";var d=E++,t="v?"+f[k]+f[r]+"?"+f[c]+"?";f[d]="^"+t+"$";var p="[v=\\s]*"+f[g]+f[i]+"?"+f[c]+"?",u=E++;f[u]="^"+p+"$";var o=E++;f[o]="((?:<|>)?=?)";var v=E++;f[v]=f[D]+"|x|X|\\*";var b=E++;f[b]=f[N]+"|x|X|\\*";var $=E++;f[$]="[v=\\s]*("+f[b]+")(?:\\.("+f[b]+")(?:\\.("+f[b]+")(?:"+f[r]+")?"+f[c]+"?)?)?";var I=E++;f[I]="[v=\\s]*("+f[v]+")(?:\\.("+f[v]+")(?:\\.("+f[v]+")(?:"+f[i]+")?"+f[c]+"?)?)?";var h=E++;f[h]="^"+f[o]+"\\s*"+f[$]+"$";var y=E++;f[y]="^"+f[o]+"\\s*"+f[I]+"$";var w=E++;f[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=E++;f[A]="(?:~>?)";var L=E++;f[L]="(\\s*)"+f[A]+"\\s+",m[L]=new RegExp(f[L],"g");var J=E++;f[J]="^"+f[A]+f[$]+"$";var W=E++;f[W]="^"+f[A]+f[I]+"$";var U=E++;f[U]="(?:\\^)";var C=E++;f[C]="(\\s*)"+f[U]+"\\s+",m[C]=new RegExp(f[C],"g");var O=E++;f[O]="^"+f[U]+f[$]+"$";var q=E++;f[q]="^"+f[U]+f[I]+"$";var ne=E++;f[ne]="^"+f[o]+"\\s*("+p+")$|^$";var ce=E++;f[ce]="^"+f[o]+"\\s*("+t+")$|^$";var ye=E++;f[ye]="(\\s*)"+f[o]+"\\s*("+p+"|"+f[$]+")",m[ye]=new RegExp(f[ye],"g");var Ie=E++;f[Ie]="^\\s*("+f[$]+")\\s+-\\s+("+f[$]+")\\s*$";var ue=E++;f[ue]="^\\s*("+f[I]+")\\s+-\\s+("+f[I]+")\\s*$";var ve=E++;f[ve]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)P(re,f[re]),m[re]||(m[re]=new RegExp(f[re]));function $e(j,K){if(j instanceof ie)return j;if(typeof j!="string"||j.length>F||!(K?m[u]:m[d]).test(j))return null;try{return new ie(j,K)}catch{return null}}function ie(j,K){if(j instanceof ie){if(j.loose===K)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>F)throw new TypeError("version is longer than "+F+" characters");if(!(this instanceof ie))return new ie(j,K);P("SemVer",j,K),this.loose=K;var H=j.trim().match(K?m[u]:m[d]);if(!H)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var se=+ee;if(se>=0&&se<R)return se}return ee}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=$e,e.valid=function(j,K){var H=$e(j,K);return H?H.version:null},e.clean=function(j,K){var H=$e(j.trim().replace(/^[=v]+/,""),K);return H?H.version:null},e.SemVer=ie,ie.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ie.prototype.toString=function(){return this.version},ie.prototype.compare=function(j){return P("SemVer.compare",this.version,this.loose,j),j instanceof ie||(j=new ie(j,this.loose)),this.compareMain(j)||this.comparePre(j)},ie.prototype.compareMain=function(j){return j instanceof ie||(j=new ie(j,this.loose)),V(this.major,j.major)||V(this.minor,j.minor)||V(this.patch,j.patch)},ie.prototype.comparePre=function(j){if(j instanceof ie||(j=new ie(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var K=0;do{var H=this.prerelease[K],ee=j.prerelease[K];if(P("prerelease compare",K,H,ee),H===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(H===void 0)return-1;if(H!==ee)return V(H,ee)}while(++K)},ie.prototype.inc=function(j,K){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,K,H,ee){typeof H=="string"&&(ee=H,H=void 0);try{return new ie(j,H).inc(K,ee).version}catch{return null}},e.diff=function(j,K){if(Ee(j,K))return null;var H=$e(j),ee=$e(K);if(H.prerelease.length||ee.prerelease.length){for(var se in H)if((se==="major"||se==="minor"||se==="patch")&&H[se]!==ee[se])return"pre"+se;return"prerelease"}for(var se in H)if((se==="major"||se==="minor"||se==="patch")&&H[se]!==ee[se])return se},e.compareIdentifiers=V;var le=/^[0-9]+$/;function V(j,K){var H=le.test(j),ee=le.test(K);return H&&ee&&(j=+j,K=+K),H&&!ee?-1:ee&&!H?1:j<K?-1:j>K?1:0}function _(j,K,H){return new ie(j,H).compare(new ie(K,H))}function ke(j,K,H){return _(j,K,H)>0}function Le(j,K,H){return _(j,K,H)<0}function Ee(j,K,H){return _(j,K,H)===0}function be(j,K,H){return _(j,K,H)!==0}function ge(j,K,H){return _(j,K,H)>=0}function G(j,K,H){return _(j,K,H)<=0}function Y(j,K,H,ee){var se;switch(K){case"===":typeof j=="object"&&(j=j.version),typeof H=="object"&&(H=H.version),se=j===H;break;case"!==":typeof j=="object"&&(j=j.version),typeof H=="object"&&(H=H.version),se=j!==H;break;case"":case"=":case"==":se=Ee(j,H,ee);break;case"!=":se=be(j,H,ee);break;case">":se=ke(j,H,ee);break;case">=":se=ge(j,H,ee);break;case"<":se=Le(j,H,ee);break;case"<=":se=G(j,H,ee);break;default:throw new TypeError("Invalid operator: "+K)}return se}function he(j,K){if(j instanceof he){if(j.loose===K)return j;j=j.value}if(!(this instanceof he))return new he(j,K);P("comparator",j,K),this.loose=K,this.parse(j),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(j,K){return V(K,j)},e.major=function(j,K){return new ie(j,K).major},e.minor=function(j,K){return new ie(j,K).minor},e.patch=function(j,K){return new ie(j,K).patch},e.compare=_,e.compareLoose=function(j,K){return _(j,K,!0)},e.rcompare=function(j,K,H){return _(K,j,H)},e.sort=function(j,K){return j.sort(function(H,ee){return e.compare(H,ee,K)})},e.rsort=function(j,K){return j.sort(function(H,ee){return e.rcompare(H,ee,K)})},e.gt=ke,e.lt=Le,e.eq=Ee,e.neq=be,e.gte=ge,e.lte=G,e.cmp=Y,e.Comparator=he;var fe={};function Oe(j,K){if(j instanceof Oe)return j.loose===K?j:new Oe(j.raw,K);if(j instanceof he)return new Oe(j.value,K);if(!(this instanceof Oe))return new Oe(j,K);if(this.loose=K,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function de(j){return!j||j.toLowerCase()==="x"||j==="*"}function Ce(j,K,H,ee,se,Ne,Ve,He,xe,tt,lt,rt,it){return((K=de(H)?"":de(ee)?">="+H+".0.0":de(se)?">="+H+"."+ee+".0":">="+K)+" "+(He=de(xe)?"":de(tt)?"<"+(+xe+1)+".0.0":de(lt)?"<"+xe+"."+(+tt+1)+".0":rt?"<="+xe+"."+tt+"."+lt+"-"+rt:"<="+He)).trim()}function Ae(j,K){for(var H=0;H<j.length;H++)if(!j[H].test(K))return!1;if(K.prerelease.length){for(H=0;H<j.length;H++)if(P(j[H].semver),j[H].semver!==fe&&j[H].semver.prerelease.length>0){var ee=j[H].semver;if(ee.major===K.major&&ee.minor===K.minor&&ee.patch===K.patch)return!0}return!1}return!0}function ze(j,K,H){try{K=new Oe(K,H)}catch{return!1}return K.test(j)}function z(j,K,H,ee){var se,Ne,Ve,He,xe;switch(j=new ie(j,ee),K=new Oe(K,ee),H){case">":se=ke,Ne=G,Ve=Le,He=">",xe=">=";break;case"<":se=Le,Ne=ge,Ve=ke,He="<",xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(j,K,ee))return!1;for(var tt=0;tt<K.set.length;++tt){var lt=K.set[tt],rt=null,it=null;if(lt.forEach(function(ot){ot.semver===fe&&(ot=new he(">=0.0.0")),rt=rt||ot,it=it||ot,se(ot.semver,rt.semver,ee)?rt=ot:Ve(ot.semver,it.semver,ee)&&(it=ot)}),rt.operator===He||rt.operator===xe||(!it.operator||it.operator===He)&&Ne(j,it.semver)||it.operator===xe&&Ve(j,it.semver))return!1}return!0}he.prototype.parse=function(j){var K=this.loose?m[ne]:m[ce],H=j.match(K);if(!H)throw new TypeError("Invalid comparator: "+j);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new ie(H[2],this.loose):this.semver=fe},he.prototype.toString=function(){return this.value},he.prototype.test=function(j){return P("Comparator.test",j,this.loose),this.semver===fe||(typeof j=="string"&&(j=new ie(j,this.loose)),Y(j,this.operator,this.semver,this.loose))},he.prototype.intersects=function(j,K){if(!(j instanceof he))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Oe(j.value,K),ze(this.value,H,K);if(j.operator==="")return H=new Oe(this.value,K),ze(j.semver,H,K);var ee=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),se=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Ne=this.semver.version===j.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),He=Y(this.semver,"<",j.semver,K)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),xe=Y(this.semver,">",j.semver,K)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return ee||se||Ne&&Ve||He||xe},e.Range=Oe,Oe.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},Oe.prototype.toString=function(){return this.range},Oe.prototype.parseRange=function(j){var K=this.loose;j=j.trim(),P("range",j,K);var H=K?m[ue]:m[Ie];j=j.replace(H,Ce),P("hyphen replace",j),j=j.replace(m[ye],"$1$2$3"),P("comparator trim",j,m[ye]),j=(j=(j=j.replace(m[L],"$1~")).replace(m[C],"$1^")).split(/\s+/).join(" ");var ee=K?m[ne]:m[ce],se=j.split(" ").map(function(Ne){return function(Ve,He){return P("comp",Ve),Ve=function(xe,tt){return xe.trim().split(/\s+/).map(function(lt){return function(rt,it){P("caret",rt,it);var ot=it?m[q]:m[O];return rt.replace(ot,function(Be,et,X,Z,pe){var We;return P("caret",rt,Be,et,X,Z,pe),de(et)?We="":de(X)?We=">="+et+".0.0 <"+(+et+1)+".0.0":de(Z)?We=et==="0"?">="+et+"."+X+".0 <"+et+"."+(+X+1)+".0":">="+et+"."+X+".0 <"+(+et+1)+".0.0":pe?(P("replaceCaret pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),We=et==="0"?X==="0"?">="+et+"."+X+"."+Z+pe+" <"+et+"."+X+"."+(+Z+1):">="+et+"."+X+"."+Z+pe+" <"+et+"."+(+X+1)+".0":">="+et+"."+X+"."+Z+pe+" <"+(+et+1)+".0.0"):(P("no pr"),We=et==="0"?X==="0"?">="+et+"."+X+"."+Z+" <"+et+"."+X+"."+(+Z+1):">="+et+"."+X+"."+Z+" <"+et+"."+(+X+1)+".0":">="+et+"."+X+"."+Z+" <"+(+et+1)+".0.0"),P("caret return",We),We})}(lt,tt)}).join(" ")}(Ve,He),P("caret",Ve),Ve=function(xe,tt){return xe.trim().split(/\s+/).map(function(lt){return function(rt,it){var ot=it?m[W]:m[J];return rt.replace(ot,function(Be,et,X,Z,pe){var We;return P("tilde",rt,Be,et,X,Z,pe),de(et)?We="":de(X)?We=">="+et+".0.0 <"+(+et+1)+".0.0":de(Z)?We=">="+et+"."+X+".0 <"+et+"."+(+X+1)+".0":pe?(P("replaceTilde pr",pe),pe.charAt(0)!=="-"&&(pe="-"+pe),We=">="+et+"."+X+"."+Z+pe+" <"+et+"."+(+X+1)+".0"):We=">="+et+"."+X+"."+Z+" <"+et+"."+(+X+1)+".0",P("tilde return",We),We})}(lt,tt)}).join(" ")}(Ve,He),P("tildes",Ve),Ve=function(xe,tt){return P("replaceXRanges",xe,tt),xe.split(/\s+/).map(function(lt){return function(rt,it){rt=rt.trim();var ot=it?m[y]:m[h];return rt.replace(ot,function(Be,et,X,Z,pe,We){P("xRange",rt,Be,et,X,Z,pe,We);var Ze=de(X),st=Ze||de(Z),Me=st||de(pe);return et==="="&&Me&&(et=""),Ze?Be=et===">"||et==="<"?"<0.0.0":"*":et&&Me?(st&&(Z=0),Me&&(pe=0),et===">"?(et=">=",st?(X=+X+1,Z=0,pe=0):Me&&(Z=+Z+1,pe=0)):et==="<="&&(et="<",st?X=+X+1:Z=+Z+1),Be=et+X+"."+Z+"."+pe):st?Be=">="+X+".0.0 <"+(+X+1)+".0.0":Me&&(Be=">="+X+"."+Z+".0 <"+X+"."+(+Z+1)+".0"),P("xRange return",Be),Be})}(lt,tt)}).join(" ")}(Ve,He),P("xrange",Ve),Ve=function(xe,tt){return P("replaceStars",xe,tt),xe.trim().replace(m[ve],"")}(Ve,He),P("stars",Ve),Ve}(Ne,K)}).join(" ").split(/\s+/);return this.loose&&(se=se.filter(function(Ne){return!!Ne.match(ee)})),se=se.map(function(Ne){return new he(Ne,K)})},Oe.prototype.intersects=function(j,K){if(!(j instanceof Oe))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ee){return j.set.some(function(se){return se.every(function(Ne){return ee.intersects(Ne,K)})})})})},e.toComparators=function(j,K){return new Oe(j,K).set.map(function(H){return H.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Oe.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new ie(j,this.loose));for(var K=0;K<this.set.length;K++)if(Ae(this.set[K],j))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(j,K,H){var ee=null,se=null;try{var Ne=new Oe(K,H)}catch{return null}return j.forEach(function(Ve){Ne.test(Ve)&&(ee&&se.compare(Ve)!==-1||(se=new ie(ee=Ve,H)))}),ee},e.minSatisfying=function(j,K,H){var ee=null,se=null;try{var Ne=new Oe(K,H)}catch{return null}return j.forEach(function(Ve){Ne.test(Ve)&&(ee&&se.compare(Ve)!==1||(se=new ie(ee=Ve,H)))}),ee},e.validRange=function(j,K){try{return new Oe(j,K).range||"*"}catch{return null}},e.ltr=function(j,K,H){return z(j,K,"<",H)},e.gtr=function(j,K,H){return z(j,K,">",H)},e.outside=z,e.prerelease=function(j,K){var H=$e(j,K);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(j,K,H){return j=new Oe(j,H),K=new Oe(K,H),j.intersects(K)},e.coerce=function(j){if(j instanceof ie)return j;if(typeof j!="string")return null;var K=j.match(m[w]);return K==null?null:$e((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,S(1))},function(me,e){var S,M,P=me.exports={};function F(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function m(a){if(S===setTimeout)return setTimeout(a,0);if((S===F||!S)&&setTimeout)return S=setTimeout,setTimeout(a,0);try{return S(a,0)}catch{try{return S.call(null,a,0)}catch{return S.call(this,a,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:F}catch{S=F}try{M=typeof clearTimeout=="function"?clearTimeout:R}catch{M=R}})();var f,E=[],N=!1,D=-1;function l(){N&&f&&(N=!1,f.length?E=f.concat(E):D=-1,E.length&&k())}function k(){if(!N){var a=m(l);N=!0;for(var r=E.length;r;){for(f=E,E=[];++D<r;)f&&f[D].run();D=-1,r=E.length}f=null,N=!1,function(i){if(M===clearTimeout)return clearTimeout(i);if((M===R||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(i);try{M(i)}catch{try{return M.call(null,i)}catch{return M.call(this,i)}}}(a)}}function g(a,r){this.fun=a,this.array=r}function s(){}P.nextTick=function(a){var r=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)r[i-1]=arguments[i];E.push(new g(a,r)),E.length!==1||N||m(k)},g.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=s,P.addListener=s,P.once=s,P.off=s,P.removeListener=s,P.removeAllListeners=s,P.emit=s,P.prependListener=s,P.prependOnceListener=s,P.listeners=function(a){return[]},P.binding=function(a){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(a){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Pe[126],Re([1,0,14,6]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=void 0;function P(c){const d=c;return d?typeof d.read=="function":!1}e.$ee=P;function F(c){const d=c;return d?[d.on,d.pause,d.resume,d.destroy].every(t=>typeof t=="function"):!1}e.$fe=F;function R(c){const d=c;return d?F(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.$ge=R;function m(c,d){return new f(c,d)}e.$he=m;class f{constructor(d,t){this.e=d,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(d){if(!this.a.destroyed){if(this.a.flowing)this.g(d);else if(this.b.data.push(d),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(d){this.a.destroyed||(this.a.flowing?this.h(d):this.b.error.push(d))}end(d){this.a.destroyed||(typeof d<"u"&&this.write(d),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(d){this.c.data.slice(0).forEach(t=>t(d))}h(d){this.c.error.length===0?(0,S.$1)(d):this.c.error.slice(0).forEach(t=>t(d))}i(){this.c.end.slice(0).forEach(d=>d())}on(d,t){if(!this.a.destroyed)switch(d){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(d,t){if(this.a.destroyed)return;let p;switch(d){case"data":p=this.c.data;break;case"end":p=this.c.end;break;case"error":p=this.c.error;break}if(p){const u=p.indexOf(t);u>=0&&p.splice(u,1)}}j(){if(this.b.data.length>0){const d=this.e(this.b.data);this.g(d),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(p=>p())}}k(){if(this.c.error.length>0){for(const d of this.b.error)this.h(d);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(c,d){const t=[];let p;for(;(p=c.read())!==null;)t.push(p);return d(t)}e.$ie=E;function N(c,d,t){const p=[];let u;for(;(u=c.read())!==null&&p.length<t;)p.push(u);return u===null&&p.length>0?d(p):{read:()=>{if(p.length>0)return p.shift();if(typeof u<"u"){const o=u;return u=void 0,o}return c.read()}}}e.$je=N;function D(c,d){return new Promise((t,p)=>{const u=[];l(c,{onData:o=>{d&&u.push(o)},onError:o=>{d?p(o):t(void 0)},onEnd:()=>{t(d?d(u):void 0)}})})}e.$ke=D;function l(c,d,t){c.on("error",p=>{t?.isCancellationRequested||d.onError(p)}),c.on("end",()=>{t?.isCancellationRequested||d.onEnd()}),c.on("data",p=>{t?.isCancellationRequested||d.onData(p)})}e.$le=l;function k(c,d){return new Promise((t,p)=>{const u=new M.$Sc,o=[],v=I=>{if(o.push(I),o.length>d)return u.dispose(),c.pause(),t({stream:c,buffer:o,ended:!1})},b=I=>(u.dispose(),p(I)),$=()=>(u.dispose(),t({stream:c,buffer:o,ended:!0}));u.add((0,M.$Rc)(()=>c.removeListener("error",b))),c.on("error",b),u.add((0,M.$Rc)(()=>c.removeListener("end",$))),c.on("end",$),u.add((0,M.$Rc)(()=>c.removeListener("data",v))),c.on("data",v)})}e.$me=k;function g(c,d){const t=m(d);return t.end(c),t}e.$ne=g;function s(){const c=m(()=>{throw new Error("not supported")});return c.end(),c}e.$oe=s;function a(c){let d=!1;return{read:()=>d?null:(d=!0,c)}}e.$pe=a;function r(c,d,t){const p=m(t);return l(c,{onData:u=>p.write(d.data(u)),onError:u=>p.error(d.error?d.error(u):u),onEnd:()=>p.end()}),p}e.$qe=r;function i(c,d,t){let p=!1;return{read:()=>{const u=d.read();return p?u:(p=!0,u!==null?t([c,u]):c)}}}e.$re=i;function n(c,d,t){let p=!1;const u=m(t);return l(d,{onData:o=>p?u.write(o):(p=!0,u.write(t([c,o]))),onError:o=>u.error(o),onEnd:()=>{p||(p=!0,u.write(c)),u.end()}}),u}e.$se=n}),define(Pe[23],Re([1,0,39,126]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=void 0;const P=typeof Buffer<"u",F=new S.$V(()=>new Uint8Array(256));let R,m;class f{static alloc(w){return P?new f(Buffer.allocUnsafe(w)):new f(new Uint8Array(w))}static wrap(w){return P&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new f(w)}static fromString(w,A){return!(A?.dontUseNodeBuffer||!1)&&P?new f(Buffer.from(w)):(R||(R=new TextEncoder),new f(R.encode(w)))}static fromByteArray(w){const A=f.alloc(w.length);for(let L=0,J=w.length;L<J;L++)A.buffer[L]=w[L];return A}static concat(w,A){if(typeof A>"u"){A=0;for(let W=0,U=w.length;W<U;W++)A+=w[W].byteLength}const L=f.alloc(A);let J=0;for(let W=0,U=w.length;W<U;W++){const C=w[W];L.set(C,J),J+=C.byteLength}return L}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=f.alloc(this.byteLength);return w.set(this),w}toString(){return P?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(w,A){return new f(this.buffer.subarray(w,A))}set(w,A){if(w instanceof f)this.buffer.set(w.buffer,A);else if(w instanceof Uint8Array)this.buffer.set(w,A);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),A);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return l(this.buffer,w)}writeUInt32BE(w,A){k(this.buffer,w,A)}readUInt32LE(w){return g(this.buffer,w)}writeUInt32LE(w,A){s(this.buffer,w,A)}readUInt8(w){return a(this.buffer,w)}writeUInt8(w,A){r(this.buffer,w,A)}indexOf(w,A=0){return E(this.buffer,w instanceof f?w.buffer:w,A)}}e.$te=f;function E(y,w,A=0){const L=w.byteLength,J=y.byteLength;if(L===0)return 0;if(L===1)return y.indexOf(w[0]);if(L>J-A)return-1;const W=F.value;W.fill(w.length);for(let q=0;q<w.length;q++)W[w[q]]=w.length-q-1;let U=A+w.length-1,C=U,O=-1;for(;U<J;)if(y[U]===w[C]){if(C===0){O=U;break}U--,C--}else U+=Math.max(w.length-C,W[y[U]]),C=w.length-1;return O}e.$ue=E;function N(y,w){return y[w+0]<<0>>>0|y[w+1]<<8>>>0}e.$ve=N;function D(y,w,A){y[A+0]=w&255,w=w>>>8,y[A+1]=w&255}e.$we=D;function l(y,w){return y[w]*2**24+y[w+1]*2**16+y[w+2]*2**8+y[w+3]}e.$xe=l;function k(y,w,A){y[A+3]=w,w=w>>>8,y[A+2]=w,w=w>>>8,y[A+1]=w,w=w>>>8,y[A]=w}e.$ye=k;function g(y,w){return y[w+0]<<0>>>0|y[w+1]<<8>>>0|y[w+2]<<16>>>0|y[w+3]<<24>>>0}e.$ze=g;function s(y,w,A){y[A+0]=w&255,w=w>>>8,y[A+1]=w&255,w=w>>>8,y[A+2]=w&255,w=w>>>8,y[A+3]=w&255}e.$Ae=s;function a(y,w){return y[w]}e.$Be=a;function r(y,w,A){y[A]=w}e.$Ce=r;function i(y){return M.$ie(y,w=>f.concat(w))}e.$De=i;function n(y){return M.$pe(y)}e.$Ee=n;function c(y){return M.$ke(y,w=>f.concat(w))}e.$Fe=c;async function d(y){return y.ended?f.concat(y.buffer):f.concat([...y.buffer,await c(y.stream)])}e.$Ge=d;function t(y){return M.$ne(y,w=>f.concat(w))}e.$He=t;function p(y){return M.$qe(y,{data:w=>typeof w=="string"?f.fromString(w):f.wrap(w)},w=>f.concat(w))}e.$Ie=p;function u(y){return M.$he(w=>f.concat(w),y)}e.$Je=u;function o(y,w){return M.$re(y,w,A=>f.concat(A))}e.$Ke=o;function v(y,w){return M.$se(y,w,A=>f.concat(A))}e.$Le=v;function b(y){let w=0,A=0,L=0;const J=new Uint8Array(Math.floor(y.length/4*3)),W=C=>{switch(A){case 3:J[L++]=w|C,A=0;break;case 2:J[L++]=w|C>>>2,w=C<<6,A=3;break;case 1:J[L++]=w|C>>>4,w=C<<4,A=2;break;default:w=C<<2,A=1}};for(let C=0;C<y.length;C++){const O=y.charCodeAt(C);if(O>=65&&O<=90)W(O-65);else if(O>=97&&O<=122)W(O-97+26);else if(O>=48&&O<=57)W(O-48+52);else if(O===43||O===45)W(62);else if(O===47||O===95)W(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${y[C]}`)}}const U=L;for(;A>0;)W(0);return f.wrap(J).slice(0,U)}e.$Me=b;const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:y},w=!0,A=!1){const L=A?I:$;let J="";const W=y.byteLength%3;let U=0;for(;U<y.byteLength-W;U+=3){const C=y[U+0],O=y[U+1],q=y[U+2];J+=L[C>>>2],J+=L[(C<<4|O>>>4)&63],J+=L[(O<<2|q>>>6)&63],J+=L[q&63]}if(W===1){const C=y[U+0];J+=L[C>>>2],J+=L[C<<4&63],w&&(J+="==")}else if(W===2){const C=y[U+0],O=y[U+1];J+=L[C>>>2],J+=L[(C<<4|O>>>4)&63],J+=L[O<<2&63],w&&(J+="=")}return J}e.$Ne=h}),define(Pe[127],Re([1,0,28,124,15]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jk=e.$ik=e.$hk=e.$gk=e.FuzzyScore=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.or=void 0;function F(...de){return function(Ce,Ae){for(let ze=0,z=de.length;ze<z;ze++){const j=de[ze](Ce,Ae);if(j)return j}return null}}e.or=F,e.$7j=R.bind(void 0,!1),e.$8j=R.bind(void 0,!0);function R(de,Ce,Ae){if(!Ae||Ae.length<Ce.length)return null;let ze;return de?ze=P.$lf(Ae,Ce):ze=Ae.indexOf(Ce)===0,ze?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function m(de,Ce){const Ae=Ce.toLowerCase().indexOf(de.toLowerCase());return Ae===-1?null:[{start:Ae,end:Ae+de.length}]}e.$9j=m;function f(de,Ce){return E(de.toLowerCase(),Ce.toLowerCase(),0,0)}e.$0j=f;function E(de,Ce,Ae,ze){if(Ae===de.length)return[];if(ze===Ce.length)return null;if(de[Ae]===Ce[ze]){let z=null;return(z=E(de,Ce,Ae+1,ze+1))?c({start:ze,end:ze+1},z):null}return E(de,Ce,Ae,ze+1)}function N(de){return 97<=de&&de<=122}function D(de){return 65<=de&&de<=90}e.$$j=D;function l(de){return 48<=de&&de<=57}function k(de){return de===32||de===9||de===10||de===13}const g=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(de=>g.add(de.charCodeAt(0)));function s(de){return k(de)||g.has(de)}function a(de,Ce){return de===Ce||s(de)&&s(Ce)}const r=new Map;function i(de){if(r.has(de))return r.get(de);let Ce;const Ae=(0,M.$5j)(de);return Ae&&(Ce=Ae),r.set(de,Ce),Ce}function n(de){return N(de)||D(de)||l(de)}function c(de,Ce){return Ce.length===0?Ce=[de]:de.end===Ce[0].start?Ce[0].start=de.start:Ce.unshift(de),Ce}function d(de,Ce){for(let Ae=Ce;Ae<de.length;Ae++){const ze=de.charCodeAt(Ae);if(D(ze)||l(ze)||Ae>0&&!n(de.charCodeAt(Ae-1)))return Ae}return de.length}function t(de,Ce,Ae,ze){if(Ae===de.length)return[];if(ze===Ce.length)return null;if(de[Ae]!==Ce[ze].toLowerCase())return null;{let z=null,j=ze+1;for(z=t(de,Ce,Ae+1,ze+1);!z&&(j=d(Ce,j))<Ce.length;)z=t(de,Ce,Ae+1,j),j++;return z===null?null:c({start:ze,end:ze+1},z)}}function p(de){let Ce=0,Ae=0,ze=0,z=0,j=0;for(let Ne=0;Ne<de.length;Ne++)j=de.charCodeAt(Ne),D(j)&&Ce++,N(j)&&Ae++,n(j)&&ze++,l(j)&&z++;const K=Ce/de.length,H=Ae/de.length,ee=ze/de.length,se=z/de.length;return{upperPercent:K,lowerPercent:H,alphaPercent:ee,numericPercent:se}}function u(de){const{upperPercent:Ce,lowerPercent:Ae}=de;return Ae===0&&Ce>.6}function o(de){const{upperPercent:Ce,lowerPercent:Ae,alphaPercent:ze,numericPercent:z}=de;return Ae>.2&&Ce<.8&&ze>.6&&z<.2}function v(de){let Ce=0,Ae=0,ze=0,z=0;for(let j=0;j<de.length;j++)ze=de.charCodeAt(j),D(ze)&&Ce++,N(ze)&&Ae++,k(ze)&&z++;return(Ce===0||Ae===0)&&z===0?de.length<=30:Ce<=5}function b(de,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!v(de))return null;Ce.length>60&&(Ce=Ce.substring(0,60));const Ae=p(Ce);if(!o(Ae)){if(!u(Ae))return null;Ce=Ce.toLowerCase()}let ze=null,z=0;for(de=de.toLowerCase();z<Ce.length&&(ze=t(de,Ce,0,z))===null;)z=d(Ce,z+1);return ze}e.$_j=b;function $(de,Ce,Ae=!1){if(!Ce||Ce.length===0)return null;let ze=null,z=0;for(de=de.toLowerCase(),Ce=Ce.toLowerCase();z<Ce.length&&(ze=I(de,Ce,0,z,Ae),ze===null);)z=h(Ce,z+1);return ze}e.$ak=$;function I(de,Ce,Ae,ze,z){let j=0;if(Ae===de.length)return[];if(ze===Ce.length)return null;if(!a(de.charCodeAt(Ae),Ce.charCodeAt(ze))){const ee=i(de.charCodeAt(Ae));if(!ee)return null;for(let se=0;se<ee.length;se++)if(!a(ee[se],Ce.charCodeAt(ze+se)))return null;j+=ee.length-1}let K=null,H=ze+j+1;if(K=I(de,Ce,Ae+1,H,z),!z)for(;!K&&(H=h(Ce,H))<Ce.length;)K=I(de,Ce,Ae+1,H,z),H++;if(!K)return null;if(de.charCodeAt(Ae)!==Ce.charCodeAt(ze)){const ee=i(de.charCodeAt(Ae));if(!ee)return K;for(let se=0;se<ee.length;se++)if(ee[se]!==Ce.charCodeAt(ze+se))return K}return c({start:ze,end:ze+j+1},K)}function h(de,Ce){for(let Ae=Ce;Ae<de.length;Ae++)if(s(de.charCodeAt(Ae))||Ae>0&&s(de.charCodeAt(Ae-1)))return Ae;return de.length}const y=F(e.$8j,b,m),w=F(e.$8j,b,f),A=new S.$Dc(1e4);function L(de,Ce,Ae=!1){if(typeof de!="string"||typeof Ce!="string")return null;let ze=A.get(de);ze||(ze=new RegExp(P.$6e(de),"i"),A.set(de,ze));const z=ze.exec(Ce);return z?[{start:z.index,end:z.index+z[0].length}]:Ae?w(de,Ce):y(de,Ce)}e.$bk=L;function J(de,Ce){const Ae=be(de,de.toLowerCase(),0,Ce,Ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ae?U(Ae):null}e.$ck=J;function W(de,Ce,Ae,ze,z,j){const K=Math.min(13,de.length);for(;Ae<K;Ae++){const H=be(de,Ce,Ae,ze,z,j,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(H)return H}return[0,j]}e.$dk=W;function U(de){if(typeof de>"u")return[];const Ce=[],Ae=de[1];for(let ze=de.length-1;ze>1;ze--){const z=de[ze]+Ae,j=Ce[Ce.length-1];j&&j.end===z?j.end=z+1:Ce.push({start:z,end:z+1})}return Ce}e.$ek=U;const C=128;function O(){const de=[],Ce=[];for(let Ae=0;Ae<=C;Ae++)Ce[Ae]=0;for(let Ae=0;Ae<=C;Ae++)de.push(Ce.slice(0));return de}function q(de){const Ce=[];for(let Ae=0;Ae<=de;Ae++)Ce[Ae]=0;return Ce}const ne=q(2*C),ce=q(2*C),ye=O(),Ie=O(),ue=O(),ve=!1;function re(de,Ce,Ae,ze,z){function j(H,ee,se=" "){for(;H.length<ee;)H=se+H;return H}let K=` |   |${ze.split("").map(H=>j(H,3)).join("|")}
`;for(let H=0;H<=Ae;H++)H===0?K+=" |":K+=`${Ce[H-1]}|`,K+=de[H].slice(0,z+1).map(ee=>j(ee.toString(),3)).join("|")+`
`;return K}function $e(de,Ce,Ae,ze){de=de.substr(Ce),Ae=Ae.substr(ze),console.log(re(Ie,de,de.length,Ae,Ae.length)),console.log(re(ue,de,de.length,Ae,Ae.length)),console.log(re(ye,de,de.length,Ae,Ae.length))}function ie(de,Ce){if(Ce<0||Ce>=de.length)return!1;const Ae=de.codePointAt(Ce);switch(Ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!P.$Df(Ae)}}function le(de,Ce){if(Ce<0||Ce>=de.length)return!1;switch(de.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function V(de,Ce,Ae){return Ce[de]!==Ae[de]}function _(de,Ce,Ae,ze,z,j,K=!1){for(;Ce<Ae&&z<j;)de[Ce]===ze[z]&&(K&&(ne[Ce]=z),Ce+=1),z+=1;return Ce===Ae}e.$fk=_;var ke;(function(de){de[de.Diag=1]="Diag",de[de.Left=2]="Left",de[de.LeftLeft=3]="LeftLeft"})(ke||(ke={}));var Le;(function(de){de.Default=[-100,0];function Ce(Ae){return!Ae||Ae.length===2&&Ae[0]===-100&&Ae[1]===0}de.isDefault=Ce})(Le||(e.FuzzyScore=Le={}));class Ee{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ce,Ae){this.firstMatchCanBeWeak=Ce,this.boostFullMatch=Ae}}e.$gk=Ee;function be(de,Ce,Ae,ze,z,j,K=Ee.default){const H=de.length>C?C:de.length,ee=ze.length>C?C:ze.length;if(Ae>=H||j>=ee||H-Ae>ee-j||!_(Ce,Ae,H,z,j,ee,!0))return;ge(H,ee,Ae,j,Ce,z);let se=1,Ne=1,Ve=Ae,He=j;const xe=[!1];for(se=1,Ve=Ae;Ve<H;se++,Ve++){const ot=ne[Ve],Be=ce[Ve],et=Ve+1<H?ce[Ve+1]:ee;for(Ne=ot-j+1,He=ot;He<et;Ne++,He++){let X=Number.MIN_SAFE_INTEGER,Z=!1;He<=Be&&(X=G(de,Ce,Ve,Ae,ze,z,He,ee,j,ye[se-1][Ne-1]===0,xe));let pe=0;X!==Number.MAX_SAFE_INTEGER&&(Z=!0,pe=X+Ie[se-1][Ne-1]);const We=He>ot,Ze=We?Ie[se][Ne-1]+(ye[se][Ne-1]>0?-5:0):0,st=He>ot+1&&ye[se][Ne-1]>0,Me=st?Ie[se][Ne-2]+(ye[se][Ne-2]>0?-5:0):0;if(st&&(!We||Me>=Ze)&&(!Z||Me>=pe))Ie[se][Ne]=Me,ue[se][Ne]=3,ye[se][Ne]=0;else if(We&&(!Z||Ze>=pe))Ie[se][Ne]=Ze,ue[se][Ne]=2,ye[se][Ne]=0;else if(Z)Ie[se][Ne]=pe,ue[se][Ne]=1,ye[se][Ne]=ye[se-1][Ne-1]+1;else throw new Error("not possible")}}if(ve&&$e(de,Ae,ze,j),!xe[0]&&!K.firstMatchCanBeWeak)return;se--,Ne--;const tt=[Ie[se][Ne],j];let lt=0,rt=0;for(;se>=1;){let ot=Ne;do{const Be=ue[se][ot];if(Be===3)ot=ot-2;else if(Be===2)ot=ot-1;else break}while(ot>=1);lt>1&&Ce[Ae+se-1]===z[j+Ne-1]&&!V(ot+j-1,ze,z)&&lt+1>ye[se][ot]&&(ot=Ne),ot===Ne?lt++:lt=1,rt||(rt=ot),se--,Ne=ot-1,tt.push(Ne)}ee===H&&K.boostFullMatch&&(tt[0]+=2);const it=rt-H;return tt[0]-=it,tt}e.$hk=be;function ge(de,Ce,Ae,ze,z,j){let K=de-1,H=Ce-1;for(;K>=Ae&&H>=ze;)z[K]===j[H]&&(ce[K]=H,K--),H--}function G(de,Ce,Ae,ze,z,j,K,H,ee,se,Ne){if(Ce[Ae]!==j[K])return Number.MIN_SAFE_INTEGER;let Ve=1,He=!1;return K===Ae-ze?Ve=de[Ae]===z[K]?7:5:V(K,z,j)&&(K===0||!V(K-1,z,j))?(Ve=de[Ae]===z[K]?7:5,He=!0):ie(j,K)&&(K===0||!ie(j,K-1))?Ve=5:(ie(j,K-1)||le(j,K-1))&&(Ve=5,He=!0),Ve>1&&Ae===ze&&(Ne[0]=!0),He||(He=V(K,z,j)||ie(j,K-1)||le(j,K-1)),Ae===ze?K>ee&&(Ve-=He?3:5):se?Ve+=He?2:0:Ve+=He?0:1,K+1===H&&(Ve-=He?3:5),Ve}function Y(de,Ce,Ae,ze,z,j,K){return fe(de,Ce,Ae,ze,z,j,!0,K)}e.$ik=Y;function he(de,Ce,Ae,ze,z,j,K){return fe(de,Ce,Ae,ze,z,j,!1,K)}e.$jk=he;function fe(de,Ce,Ae,ze,z,j,K,H){let ee=be(de,Ce,Ae,ze,z,j,H);if(ee&&!K)return ee;if(de.length>=3){const se=Math.min(7,de.length-1);for(let Ne=Ae+1;Ne<se;Ne++){const Ve=Oe(de,Ne);if(Ve){const He=be(Ve,Ve.toLowerCase(),Ae,ze,z,j,H);He&&(He[0]-=3,(!ee||He[0]>ee[0])&&(ee=He))}}}return ee}function Oe(de,Ce){if(Ce+1>=de.length)return;const Ae=de[Ce],ze=de[Ce+1];if(Ae!==ze)return de.slice(0,Ce)+ze+Ae+de.slice(Ce+2)}}),define(Pe[32],Re([1,0,15]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(M||(M={})),function(P){const F="error",R="warning",m="warn",f="info",E="ignore";function N(l){return l?S.$kf(F,l)?P.Error:S.$kf(R,l)||S.$kf(m,l)?P.Warning:S.$kf(f,l)?P.Info:P.Ignore:P.Ignore}P.fromValue=N;function D(l){switch(l){case P.Error:return F;case P.Warning:return R;case P.Info:return f;default:return E}}P.toString=D}(M||(M={})),e.default=M}),define(Pe[128],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0,e.$3d=Symbol("MicrotaskDelay")}),define(Pe[50],Re([1,0,18,15]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=e.$ji=e.$ii=void 0;class P{constructor(){this.b="",this.c=0}reset(k){return this.b=k,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(k){const g=k.charCodeAt(0),s=this.b.charCodeAt(this.c);return g-s}value(){return this.b[this.c]}}e.$ii=P;class F{constructor(k=!0){this.e=k}reset(k){return this.b=k,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let k=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(k)this.c++;else break;else k=!1;return this}cmp(k){return this.e?(0,M.$ef)(k,this.b,0,k.length,this.c,this.d):(0,M.$gf)(k,this.b,0,k.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ji=F;class R{constructor(k=!0,g=!0){this.f=k,this.g=g}reset(k){this.d=0,this.e=0,this.b=k,this.c=k.length;for(let g=k.length-1;g>=0;g--,this.c--){const s=this.b.charCodeAt(g);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let k=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(k)this.d++;else break;else k=!1}return this}cmp(k){return this.g?(0,M.$ef)(k,this.b,0,k.length,this.d,this.e):(0,M.$gf)(k,this.b,0,k.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ki=R;var m;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(m||(m={}));class f{constructor(k,g){this.f=k,this.g=g,this.d=[],this.e=0}reset(k){return this.c=k,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(k)),this.b.reset(k.path),this.b.value()&&this.d.push(3)),this.g(k)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(k){if(this.d[this.e]===1)return(0,M.$ff)(k,this.c.scheme);if(this.d[this.e]===2)return(0,M.$ff)(k,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(k);if(this.d[this.e]===4)return(0,M.$df)(k,this.c.query);if(this.d[this.e]===5)return(0,M.$df)(k,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$li=f;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const k=this.right;return this.right=k.left,k.left=this,this.updateHeight(),k.updateHeight(),k}rotateRight(){const k=this.left;return this.left=k.right,k.right=this,this.updateHeight(),k.updateHeight(),k}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var N;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(N||(N={}));class D{static forUris(k=()=>!1,g=()=>!1){return new D(new f(k,g))}static forPaths(k=!1){return new D(new R(void 0,!k))}static forStrings(){return new D(new P)}static forConfigKeys(){return new D(new F)}constructor(k){this.b=k}clear(){this.c=void 0}fill(k,g){if(g){const s=g.slice(0);(0,S.$Xb)(s);for(const a of s)this.set(a,k)}else{const s=k.slice(0);(0,S.$Xb)(s);for(const a of s)this.set(a[0],a[1])}}set(k,g){const s=this.b.reset(k);let a;this.c||(this.c=new E,this.c.segment=s.value());const r=[];for(a=this.c;;){const n=s.cmp(a.segment);if(n>0)a.left||(a.left=new E,a.left.segment=s.value()),r.push([-1,a]),a=a.left;else if(n<0)a.right||(a.right=new E,a.right.segment=s.value()),r.push([1,a]),a=a.right;else if(s.hasNext())s.next(),a.mid||(a.mid=new E,a.mid.segment=s.value()),r.push([0,a]),a=a.mid;else break}const i=a.value;a.value=g,a.key=k;for(let n=r.length-1;n>=0;n--){const c=r[n][1];c.updateHeight();const d=c.balanceFactor();if(d<-1||d>1){const t=r[n][0],p=r[n+1][0];if(t===1&&p===1)r[n][1]=c.rotateLeft();else if(t===-1&&p===-1)r[n][1]=c.rotateRight();else if(t===1&&p===-1)c.right=r[n+1][1]=r[n+1][1].rotateRight(),r[n][1]=c.rotateLeft();else if(t===-1&&p===1)c.left=r[n+1][1]=r[n+1][1].rotateLeft(),r[n][1]=c.rotateRight();else throw new Error;if(n>0)switch(r[n-1][0]){case-1:r[n-1][1].left=r[n][1];break;case 1:r[n-1][1].right=r[n][1];break;case 0:r[n-1][1].mid=r[n][1];break}else this.c=r[0][1]}}return i}get(k){return this.d(k)?.value}d(k){const g=this.b.reset(k);let s=this.c;for(;s;){const a=g.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(g.hasNext())g.next(),s=s.mid;else break}return s}has(k){const g=this.d(k);return!(g?.value===void 0&&g?.mid===void 0)}delete(k){return this.e(k,!1)}deleteSuperstr(k){return this.e(k,!0)}e(k,g){const s=this.b.reset(k),a=[];let r=this.c;for(;r;){const i=s.cmp(r.segment);if(i>0)a.push([-1,r]),r=r.left;else if(i<0)a.push([1,r]),r=r.right;else if(s.hasNext())s.next(),a.push([0,r]),r=r.mid;else break}if(r){if(g?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const i=this.f(r.right);if(i.key){const{key:n,value:c,segment:d}=i;this.e(i.key,!1),r.key=n,r.value=c,r.segment=d}}else{const i=r.left??r.right;if(a.length>0){const[n,c]=a[a.length-1];switch(n){case-1:c.left=i;break;case 0:c.mid=i;break;case 1:c.right=i;break}}else this.c=i}for(let i=a.length-1;i>=0;i--){const n=a[i][1];n.updateHeight();const c=n.balanceFactor();if(c>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),a[i][1]=n.rotateLeft()):c<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),a[i][1]=n.rotateRight()),i>0)switch(a[i-1][0]){case-1:a[i-1][1].left=a[i][1];break;case 1:a[i-1][1].right=a[i][1];break;case 0:a[i-1][1].mid=a[i][1];break}else this.c=a[0][1]}}}f(k){for(;k.left;)k=k.left;return k}findSubstr(k){const g=this.b.reset(k);let s=this.c,a;for(;s;){const r=g.cmp(s.segment);if(r>0)s=s.left;else if(r<0)s=s.right;else if(g.hasNext())g.next(),a=s.value||a,s=s.mid;else break}return s&&s.value||a}findSuperstr(k){return this.g(k,!1)}g(k,g){const s=this.b.reset(k);let a=this.c;for(;a;){const r=s.cmp(a.segment);if(r>0)a=a.left;else if(r<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this.h(a.mid):g?a.value:void 0}}hasElementOrSubtree(k){return this.g(k,!0)!==void 0}forEach(k){for(const[g,s]of this)k(s,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(k){const g=[];return this.j(k,g),g[Symbol.iterator]()}j(k,g){k&&(k.left&&this.j(k.left,g),k.value&&g.push([k.key,k.value]),k.mid&&this.j(k.mid,g),k.right&&this.j(k.right,g))}_isBalanced(){const k=g=>{if(!g)return!0;const s=g.balanceFactor();return s<-1||s>1?!1:k(g.left)&&k(g.right)};return k(this.c)}}e.$mi=D}),define(Pe[40],Re([1,0,91]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$qk=e.ThemeColor=void 0;var M;(function(R){function m(f){return f&&typeof f=="object"&&typeof f.id=="string"}R.isThemeColor=m})(M||(e.ThemeColor=M={}));function P(R){return{id:R}}e.$qk=P;var F;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function f(i){const n=m.exec(i.id);if(!n)return f(S.$pk.error);const[,c,d]=n,t=["codicon","codicon-"+c];return d&&t.push("codicon-modifier-"+d.substring(1)),t}R.asClassNameArray=f;function E(i){return f(i).join(" ")}R.asClassName=E;function N(i){return"."+f(i).join(".")}R.asCSSSelector=N;function D(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||M.isThemeColor(i.color))}R.isThemeIcon=D;const l=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function k(i){const n=l.exec(i);if(!n)return;const[,c]=n;return{id:c}}R.fromString=k;function g(i){return{id:i}}R.fromId=g;function s(i,n){let c=i.id;const d=c.lastIndexOf("~");return d!==-1&&(c=c.substring(0,d)),n&&(c=`${c}~${n}`),{id:c}}R.modify=s;function a(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}R.getModifier=a;function r(i,n){return i.id===n.id&&i.color?.id===n.color?.id}R.isEqual=r})(F||(e.ThemeIcon=F={}))}),define(Pe[129],Re([1,0,127,15,40]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=void 0;const F="$(",R=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${R.source}`,"g");function f(r){return r.replace(m,(i,n)=>n?i:`\\${i}`)}e.$rk=f;const E=new RegExp(`\\\\${R.source}`,"g");function N(r){return r.replace(E,i=>`\\${i}`)}e.$sk=N;const D=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function l(r){return r.indexOf(F)===-1?r:r.replace(D,(i,n,c,d)=>c?i:n||d||"")}e.$tk=l;function k(r){return r?r.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$uk=k;const g=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(r){g.lastIndex=0;let i="";const n=[];let c=0;for(;;){const d=g.lastIndex,t=g.exec(r),p=r.substring(d,t?.index);if(p.length>0){i+=p;for(let u=0;u<p.length;u++)n.push(c)}if(!t)break;c+=t[0].length}return{text:i,iconOffsets:n}}e.$vk=s;function a(r,i,n=!1){const{text:c,iconOffsets:d}=i;if(!d||d.length===0)return(0,S.$bk)(r,c,n);const t=(0,M.$4e)(c," "),p=c.length-t.length,u=(0,S.$bk)(r,t,n);if(u)for(const o of u){const v=d[o.start+p]+p;o.start+=v,o.end+=v}return u}e.$wk=a}),define(Pe[33],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=e.$Bg=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(P){return S.test(P)}e.$Bg=M,e.$Cg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(m){for(let f=0;f<m.length;f++)m[f]=Math.floor(Math.random()*256);return m};const F=new Uint8Array(16),R=[];for(let m=0;m<256;m++)R.push(m.toString(16).padStart(2,"0"));return function(){P(F),F[6]=F[6]&15|64,F[8]=F[8]&63|128;let f=0,E="";return E+=R[F[f++]],E+=R[F[f++]],E+=R[F[f++]],E+=R[F[f++]],E+="-",E+=R[F[f++]],E+=R[F[f++]],E+="-",E+=R[F[f++]],E+=R[F[f++]],E+="-",E+=R[F[f++]],E+=R[F[f++]],E+="-",E+=R[F[f++]],E+=R[F[f++]],E+=R[F[f++]],E+=R[F[f++]],E+=R[F[f++]],E+=R[F[f++]],E}}()}),define(Pe[130],Re([1,0,18,51,33]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=e.$Ft=e.$Et=e.$Dt=e.$Ct=void 0;function F(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$Ct=F;function R(D,l,k){const g={id:(0,P.$Cg)(),name:D,uri:l,data:k};return{asString:async()=>"",asFile:()=>g,value:void 0}}e.$Dt=R;class m{constructor(){this.a=new Map}get size(){let l=0;for(const k of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const k=[...this.a.keys()];return M.Iterable.some(this,([g,s])=>s.asFile())&&k.push("files"),N(f(l),k)}get(l){return this.a.get(this.b(l))?.[0]}append(l,k){const g=this.a.get(l);g?g.push(k):this.a.set(this.b(l),[k])}replace(l,k){this.a.set(this.b(l),[k])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,k]of this.a)for(const g of k)yield[l,g]}b(l){return f(l)}}e.$Et=m;function f(D){return D.toLowerCase()}function E(D,l){return N(f(D),l.map(f))}e.$Ft=E;function N(D,l){if(D==="*/*")return l.length>0;if(l.includes(D))return!0;const k=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!k)return!1;const[g,s,a]=k;return a==="*"?l.some(r=>r.startsWith(s+"/")):!1}e.$Gt=Object.freeze({create:D=>(0,S.$Mb)(D.map(l=>l.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$Gt.split(D).filter(l=>!l.startsWith("#"))})}),define(Pe[131],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=e.StringEOL=void 0;var S;(function(P){P[P.Unknown=0]="Unknown",P[P.Invalid=3]="Invalid",P[P.LF=1]="LF",P[P.CRLF=2]="CRLF"})(S||(e.StringEOL=S={}));function M(P){let F=0,R=0,m=0,f=0;for(let E=0,N=P.length;E<N;E++){const D=P.charCodeAt(E);D===13?(F===0&&(R=E),F++,E+1<N&&P.charCodeAt(E+1)===10?(f|=2,E++):f|=3,m=E+1):D===10&&(f|=1,F===0&&(R=E),F++,m=E+1)}return F===0&&(R=P.length),[F,R,P.length-m,f]}e.$Jt=M}),define(Pe[132],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0,e.$Hs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[133],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9t=e.$8t=e.IndentAction=void 0;var S;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(S||(e.IndentAction=S={}));class M{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let f=0,E=m.notIn.length;f<E;f++)switch(m.notIn[f]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,f){if(m.getTokenCount()===0)return!0;const E=m.findTokenIndexAtOffset(f-2),N=m.getStandardTokenType(E);return this.isOK(N)}g(m,f){for(let E=m;E<=f;E++){const N=String.fromCharCode(E);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$8t=M;class P{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const f of m)F(this.autoClosingPairsOpenByStart,f.open.charAt(0),f),F(this.autoClosingPairsOpenByEnd,f.open.charAt(f.open.length-1),f),F(this.autoClosingPairsCloseByStart,f.close.charAt(0),f),F(this.autoClosingPairsCloseByEnd,f.close.charAt(f.close.length-1),f),f.close.length===1&&f.open.length===1&&F(this.autoClosingPairsCloseSingleChar,f.close,f)}}e.$9t=P;function F(R,m,f){R.has(m)?R.get(m).push(f):R.set(m,[f])}}),define(Pe[134],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fC=e.$eC=e.$dC=e.$cC=e.$bC=e.$aC=e.$_B=e.$$B=e.$0B=e.NodeColor=e.$9B=void 0;class S{constructor(a,r){this.piece=a,this.color=r,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$0B)return P(this.right);let a=this;for(;a.parent!==e.$0B&&a.parent.left!==a;)a=a.parent;return a.parent===e.$0B?e.$0B:a.parent}prev(){if(this.left!==e.$0B)return F(this.left);let a=this;for(;a.parent!==e.$0B&&a.parent.right!==a;)a=a.parent;return a.parent===e.$0B?e.$0B:a.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$9B=S;var M;(function(s){s[s.Black=0]="Black",s[s.Red=1]="Red"})(M||(e.NodeColor=M={})),e.$0B=new S(null,0),e.$0B.parent=e.$0B,e.$0B.left=e.$0B,e.$0B.right=e.$0B,e.$0B.color=0;function P(s){for(;s.left!==e.$0B;)s=s.left;return s}e.$$B=P;function F(s){for(;s.right!==e.$0B;)s=s.right;return s}e.$_B=F;function R(s){return s===e.$0B?0:s.size_left+s.piece.length+R(s.right)}function m(s){return s===e.$0B?0:s.lf_left+s.piece.lineFeedCnt+m(s.right)}function f(){e.$0B.parent=e.$0B}function E(s,a){const r=a.right;r.size_left+=a.size_left+(a.piece?a.piece.length:0),r.lf_left+=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),a.right=r.left,r.left!==e.$0B&&(r.left.parent=a),r.parent=a.parent,a.parent===e.$0B?s.root=r:a.parent.left===a?a.parent.left=r:a.parent.right=r,r.left=a,a.parent=r}e.$aC=E;function N(s,a){const r=a.left;a.left=r.right,r.right!==e.$0B&&(r.right.parent=a),r.parent=a.parent,a.size_left-=r.size_left+(r.piece?r.piece.length:0),a.lf_left-=r.lf_left+(r.piece?r.piece.lineFeedCnt:0),a.parent===e.$0B?s.root=r:a===a.parent.right?a.parent.right=r:a.parent.left=r,r.right=a,a.parent=r}e.$bC=N;function D(s,a){let r,i;if(a.left===e.$0B?(i=a,r=i.right):a.right===e.$0B?(i=a,r=i.left):(i=P(a.right),r=i.right),i===s.root){s.root=r,r.color=0,a.detach(),f(),s.root.parent=e.$0B;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=r:i.parent.right=r,i===a?(r.parent=i.parent,g(s,r)):(i.parent===a?r.parent=i:r.parent=i.parent,g(s,r),i.left=a.left,i.right=a.right,i.parent=a.parent,i.color=a.color,a===s.root?s.root=i:a===a.parent.left?a.parent.left=i:a.parent.right=i,i.left!==e.$0B&&(i.left.parent=i),i.right!==e.$0B&&(i.right.parent=i),i.size_left=a.size_left,i.lf_left=a.lf_left,g(s,i)),a.detach(),r.parent.left===r){const d=R(r),t=m(r);if(d!==r.parent.size_left||t!==r.parent.lf_left){const p=d-r.parent.size_left,u=t-r.parent.lf_left;r.parent.size_left=d,r.parent.lf_left=t,k(s,r.parent,p,u)}}if(g(s,r.parent),n){f();return}let c;for(;r!==s.root&&r.color===0;)r===r.parent.left?(c=r.parent.right,c.color===1&&(c.color=0,r.parent.color=1,E(s,r.parent),c=r.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,r=r.parent):(c.right.color===0&&(c.left.color=0,c.color=1,N(s,c),c=r.parent.right),c.color=r.parent.color,r.parent.color=0,c.right.color=0,E(s,r.parent),r=s.root)):(c=r.parent.left,c.color===1&&(c.color=0,r.parent.color=1,N(s,r.parent),c=r.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,r=r.parent):(c.left.color===0&&(c.right.color=0,c.color=1,E(s,c),c=r.parent.left),c.color=r.parent.color,r.parent.color=0,c.left.color=0,N(s,r.parent),r=s.root));r.color=0,f()}e.$cC=D;function l(s,a){for(g(s,a);a!==s.root&&a.parent.color===1;)if(a.parent===a.parent.parent.left){const r=a.parent.parent.right;r.color===1?(a.parent.color=0,r.color=0,a.parent.parent.color=1,a=a.parent.parent):(a===a.parent.right&&(a=a.parent,E(s,a)),a.parent.color=0,a.parent.parent.color=1,N(s,a.parent.parent))}else{const r=a.parent.parent.left;r.color===1?(a.parent.color=0,r.color=0,a.parent.parent.color=1,a=a.parent.parent):(a===a.parent.left&&(a=a.parent,N(s,a)),a.parent.color=0,a.parent.parent.color=1,E(s,a.parent.parent))}s.root.color=0}e.$dC=l;function k(s,a,r,i){for(;a!==s.root&&a!==e.$0B;)a.parent.left===a&&(a.parent.size_left+=r,a.parent.lf_left+=i),a=a.parent}e.$eC=k;function g(s,a){let r=0,i=0;if(a!==s.root){for(;a!==s.root&&a===a.parent.right;)a=a.parent;if(a!==s.root)for(a=a.parent,r=R(a.left)-a.size_left,i=m(a.left)-a.lf_left,a.size_left+=r,a.lf_left+=i;a!==s.root&&(r!==0||i!==0);)a.parent.left===a&&(a.parent.size_left+=r,a.parent.lf_left+=i),a=a.parent}}e.$fC=g}),define(Pe[92],Re([1,0,93,29,94,134,95]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qC=e.$pC=e.$oC=e.$nC=e.$mC=void 0;const m=65535;function f(r){let i;return r[r.length-1]<65536?i=new Uint16Array(r.length):i=new Uint32Array(r.length),i.set(r,0),i}class E{constructor(i,n,c,d,t){this.lineStarts=i,this.cr=n,this.lf=c,this.crlf=d,this.isBasicASCII=t}}function N(r,i=!0){const n=[0];let c=1;for(let d=0,t=r.length;d<t;d++){const p=r.charCodeAt(d);p===13?d+1<t&&r.charCodeAt(d+1)===10?(n[c++]=d+2,d++):n[c++]=d+1:p===10&&(n[c++]=d+1)}return i?f(n):n}e.$mC=N;function D(r,i){r.length=0,r[0]=0;let n=1,c=0,d=0,t=0,p=!0;for(let o=0,v=i.length;o<v;o++){const b=i.charCodeAt(o);b===13?o+1<v&&i.charCodeAt(o+1)===10?(t++,r[n++]=o+2,o++):(c++,r[n++]=o+1):b===10?(d++,r[n++]=o+1):p&&b!==9&&(b<32||b>126)&&(p=!1)}const u=new E(f(r),c,d,t,p);return r.length=0,u}e.$nC=D;class l{constructor(i,n,c,d,t){this.bufferIndex=i,this.start=n,this.end=c,this.lineFeedCnt=d,this.length=t}}e.$oC=l;class k{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$pC=k;class g{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==F.$0B&&i.iterate(i.root,c=>(c!==F.$0B&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const c=this.b[n];if(c.nodeStartOffset<=i&&c.nodeStartOffset+c.node.piece.length>=i)return c}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const c=this.b[n];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<i&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=i)return c}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const c=this.b;for(let d=0;d<c.length;d++){const t=c[d];if(t.node.parent===null||t.nodeStartOffset>=i){c[d]=null,n=!0;continue}}if(n){const d=[];for(const t of c)t!==null&&d.push(t);this.b=d}}}class a{constructor(i,n,c){this.create(i,n,c)}create(i,n,c){this.a=[new k("",[0])],this.g={line:0,column:0},this.root=F.$0B,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=c;let d=null;for(let t=0,p=i.length;t<p;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=N(i[t].buffer));const u=new l(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),d=this.S(d,u)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=m,c=n-Math.floor(n/3),d=c*2;let t="",p=0;const u=[];if(this.iterate(this.root,o=>{const v=this.R(o),b=v.length;if(p<=c||p+b<d)return t+=v,p+=b,!0;const $=t.replace(/\r\n|\r|\n/g,i);return u.push(new k($,N($))),t=v,p=b,!0}),p>0){const o=t.replace(/\r\n|\r|\n/g,i);u.push(new k(o,N(o)))}this.create(u,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new g(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,d=>{if(d===F.$0B)return!0;const t=this.R(d),p=t.length,u=i.G(n),o=i.G(n+p),v=i.getValueInRange2(u,o);return n+=p,t===v})}getOffsetAt(i,n){let c=0,d=this.root;for(;d!==F.$0B;)if(d.left!==F.$0B&&d.lf_left+1>=i)d=d.left;else if(d.lf_left+d.piece.lineFeedCnt+1>=i){c+=d.size_left;const t=this.B(d,i-d.lf_left-2);return c+=t+n-1}else i-=d.lf_left+d.piece.lineFeedCnt,c+=d.size_left+d.piece.length,d=d.right;return c}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,c=0;const d=i;for(;n!==F.$0B;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(c+=n.lf_left+t.index,t.index===0){const p=this.getOffsetAt(c+1,1),u=d-p;return new S.$9s(c+1,u+1)}return new S.$9s(c+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,c+=n.lf_left+n.piece.lineFeedCnt,n.right===F.$0B){const t=this.getOffsetAt(c+1,1),p=d-i-t;return new S.$9s(c+1,p+1)}else n=n.right;return new S.$9s(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const c=this.H(i.startLineNumber,i.startColumn),d=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(c,d);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const u=i.node,o=this.a[u.piece.bufferIndex].buffer,v=this.u(u.piece.bufferIndex,u.piece.start);return o.substring(v+i.remainder,v+n.remainder)}let c=i.node;const d=this.a[c.piece.bufferIndex].buffer,t=this.u(c.piece.bufferIndex,c.piece.start);let p=d.substring(t+i.remainder,t+c.piece.length);for(c=c.next();c!==F.$0B;){const u=this.a[c.piece.bufferIndex].buffer,o=this.u(c.piece.bufferIndex,c.piece.start);if(c===n.node){p+=u.substring(o,o+n.remainder);break}else p+=u.substr(o,c.piece.length);c=c.next()}return p}getLinesContent(){const i=[];let n=0,c="",d=!1;return this.iterate(this.root,t=>{if(t===F.$0B)return!0;const p=t.piece;let u=p.length;if(u===0)return!0;const o=this.a[p.bufferIndex].buffer,v=this.a[p.bufferIndex].lineStarts,b=p.start.line,$=p.end.line;let I=v[b]+p.start.column;if(d&&(o.charCodeAt(I)===10&&(I++,u--),i[n++]=c,c="",d=!1,u===0))return!0;if(b===$)return!this.f&&o.charCodeAt(I+u-1)===13?(d=!0,c+=o.substr(I,u-1)):c+=o.substr(I,u),!0;c+=this.f?o.substring(I,Math.max(I,v[b+1]-this.e)):o.substring(I,v[b+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=c;for(let h=b+1;h<$;h++)c=this.f?o.substring(v[h],v[h+1]-this.e):o.substring(v[h],v[h+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=c;return!this.f&&o.charCodeAt(v[$]+p.end.column-1)===13?(d=!0,p.end.column===0?n--:c=o.substr(v[$],p.end.column-1)):c=o.substr(v[$],p.end.column),!0}),d&&(i[n++]=c,c=""),i[n++]=c,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const c=this.a[n.piece.bufferIndex],d=this.u(n.piece.bufferIndex,n.piece.start);return c.buffer.charCodeAt(d)}else{const n=this.a[i.node.piece.bufferIndex],d=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(d)}}getLineCharCode(i,n){const c=this.H(i,n+1);return this.l(c)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,c,d,t,p,u,o,v,b,$){const I=this.a[i.piece.bufferIndex],h=this.u(i.piece.bufferIndex,i.piece.start),y=this.u(i.piece.bufferIndex,t),w=this.u(i.piece.bufferIndex,p);let A;const L={line:0,column:0};let J,W;n._wordSeparators?(J=I.buffer.substring(y,w),W=U=>U+y,n.reset(0)):(J=I.buffer,W=U=>U,n.reset(y));do if(A=n.next(J),A){if(W(A.index)>=w)return b;this.s(i,W(A.index)-h,L);const U=this.t(i.piece.bufferIndex,t,L),C=L.line===t.line?L.column-t.column+d:L.column+1,O=C+A[0].length;if($[b++]=(0,R.$iC)(new M.$0s(c+U,C,c+U,O),A,o),W(A.index)+A[0].length>=w||b>=v)return b}while(A);return b}findMatchesLineByLine(i,n,c,d){const t=[];let p=0;const u=new R.$lC(n.wordSeparators,n.regex);let o=this.H(i.startLineNumber,i.startColumn);if(o===null)return[];const v=this.H(i.endLineNumber,i.endColumn);if(v===null)return[];let b=this.s(o.node,o.remainder);const $=this.s(v.node,v.remainder);if(o.node===v.node)return this.findMatchesInNode(o.node,u,i.startLineNumber,i.startColumn,b,$,n,c,d,p,t),t;let I=i.startLineNumber,h=o.node;for(;h!==v.node;){const w=this.t(h.piece.bufferIndex,b,h.piece.end);if(w>=1){const L=this.a[h.piece.bufferIndex].lineStarts,J=this.u(h.piece.bufferIndex,h.piece.start),W=L[b.line+w],U=I===i.startLineNumber?i.startColumn:1;if(p=this.findMatchesInNode(h,u,I,U,b,this.s(h,W-J),n,c,d,p,t),p>=d)return t;I+=w}const A=I===i.startLineNumber?i.startColumn-1:0;if(I===i.endLineNumber){const L=this.getLineContent(I).substring(A,i.endColumn-1);return p=this.n(n,u,L,i.endLineNumber,A,p,t,c,d),t}if(p=this.n(n,u,this.getLineContent(I).substr(A),I,A,p,t,c,d),p>=d)return t;I++,o=this.H(I,1),h=o.node,b=this.s(o.node,o.remainder)}if(I===i.endLineNumber){const w=I===i.startLineNumber?i.startColumn-1:0,A=this.getLineContent(I).substring(w,i.endColumn-1);return p=this.n(n,u,A,i.endLineNumber,w,p,t,c,d),t}const y=I===i.startLineNumber?i.startColumn:1;return p=this.findMatchesInNode(v.node,u,I,y,b,$,n,c,d,p,t),t}n(i,n,c,d,t,p,u,o,v){const b=i.wordSeparators;if(!o&&i.simpleSearch){const I=i.simpleSearch,h=I.length,y=c.length;let w=-h;for(;(w=c.indexOf(I,w+h))!==-1;)if((!b||(0,R.$kC)(b,c,y,w,h))&&(u[p++]=new P.$qv(new M.$0s(d,w+1+t,d,w+1+h+t),null),p>=v))return p;return p}let $;n.reset(0);do if($=n.next(c),$&&(u[p++]=(0,R.$iC)(new M.$0s(d,$.index+1+t,d,$.index+1+$[0].length+t),$,o),p>=v))return p;while($);return p}insert(i,n,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==F.$0B){const{node:d,remainder:t,nodeStartOffset:p}=this.G(i),u=d.piece,o=u.bufferIndex,v=this.s(d,t);if(d.piece.bufferIndex===0&&u.end.line===this.g.line&&u.end.column===this.g.column&&p+u.length===i&&n.length<m){this.F(d,n),this.y();return}if(p===i)this.o(n,d),this.h.validate(i);else if(p+d.piece.length>i){const b=[];let $=new l(u.bufferIndex,v,u.end,this.t(u.bufferIndex,v,u.end),this.u(o,u.end)-this.u(o,v));if(this.K()&&this.M(n)&&this.I(d,t)===10){const w={line:$.start.line+1,column:0};$=new l($.bufferIndex,w,$.end,this.t($.bufferIndex,w,$.end),$.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(d,t-1)===13){const w=this.s(d,t-1);this.C(d,w),n="\r"+n,d.piece.length===0&&b.push(d)}else this.C(d,v);else this.C(d,v);const I=this.w(n);$.length>0&&this.S(d,$);let h=d;for(let y=0;y<I.length;y++)h=this.S(h,I[y]);this.v(b)}else this.q(n,d)}else{const d=this.w(n);let t=this.T(null,d[0]);for(let p=1;p<d.length;p++)t=this.S(t,d[p])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===F.$0B)return;const c=this.G(i),d=this.G(i+n),t=c.node,p=d.node;if(t===p){const I=this.s(t,c.remainder),h=this.s(t,d.remainder);if(c.nodeStartOffset===i){if(n===t.piece.length){const y=t.next();(0,F.$cC)(this,t),this.N(y),this.y();return}this.D(t,h),this.h.validate(i),this.N(t),this.y();return}if(c.nodeStartOffset+t.piece.length===i+n){this.C(t,I),this.O(t),this.y();return}this.E(t,I,h),this.y();return}const u=[],o=this.s(t,c.remainder);this.C(t,o),this.h.validate(i),t.piece.length===0&&u.push(t);const v=this.s(p,d.remainder);this.D(p,v),p.piece.length===0&&u.push(p);const b=t.next();for(let I=b;I!==F.$0B&&I!==p;I=I.next())u.push(I);const $=t.piece.length===0?t.prev():t;this.v(u),this.O($),this.y()}o(i,n){const c=[];if(this.K()&&this.M(i)&&this.L(n)){const p=n.piece,u={line:p.start.line+1,column:0},o=new l(p.bufferIndex,u,p.end,this.t(p.bufferIndex,u,p.end),p.length-1);n.piece=o,i+=`
`,(0,F.$eC)(this,n,-1,-1),n.piece.length===0&&c.push(n)}const d=this.w(i);let t=this.T(n,d[d.length-1]);for(let p=d.length-2;p>=0;p--)t=this.T(t,d[p]);this.N(t),this.v(c)}q(i,n){this.Q(i,n)&&(i+=`
`);const c=this.w(i),d=this.S(n,c[0]);let t=d;for(let p=1;p<c.length;p++)t=this.S(t,c[p]);this.N(d)}s(i,n,c){const d=i.piece,t=i.piece.bufferIndex,p=this.a[t].lineStarts,o=p[d.start.line]+d.start.column+n;let v=d.start.line,b=d.end.line,$=0,I=0,h=0;for(;v<=b&&($=v+(b-v)/2|0,h=p[$],$!==b);)if(I=p[$+1],o<h)b=$-1;else if(o>=I)v=$+1;else break;return c?(c.line=$,c.column=o-h,null):{line:$,column:o-h}}t(i,n,c){if(c.column===0)return c.line-n.line;const d=this.a[i].lineStarts;if(c.line===d.length-1)return c.line-n.line;const t=d[c.line+1],p=d[c.line]+c.column;if(t>p+1)return c.line-n.line;const u=p-1;return this.a[i].buffer.charCodeAt(u)===13?c.line-n.line+1:c.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,F.$cC)(this,i[n])}w(i){if(i.length>m){const b=[];for(;i.length>m;){const I=i.charCodeAt(m-1);let h;I===13||I>=55296&&I<=56319?(h=i.substring(0,m-1),i=i.substring(m-1)):(h=i.substring(0,m),i=i.substring(m));const y=N(h);b.push(new l(this.a.length,{line:0,column:0},{line:y.length-1,column:h.length-y[y.length-1]},y.length-1,h.length)),this.a.push(new k(h,y))}const $=N(i);return b.push(new l(this.a.length,{line:0,column:0},{line:$.length-1,column:i.length-$[$.length-1]},$.length-1,i.length)),this.a.push(new k(i,$)),b}let n=this.a[0].buffer.length;const c=N(i,!1);let d=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},d=this.g;for(let b=0;b<c.length;b++)c[b]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let b=0;b<c.length;b++)c[b]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,p=this.a[0].lineStarts.length-1,u=t-this.a[0].lineStarts[p],o={line:p,column:u},v=new l(0,d,o,this.t(0,d,o),t-n);return this.g=o,[v]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let c=this.root,d="";const t=this.h.get2(i);if(t){c=t.node;const p=this.B(c,i-t.nodeStartLineNumber-1),u=this.a[c.piece.bufferIndex].buffer,o=this.u(c.piece.bufferIndex,c.piece.start);if(t.nodeStartLineNumber+c.piece.lineFeedCnt===i)d=u.substring(o+p,o+c.piece.length);else{const v=this.B(c,i-t.nodeStartLineNumber);return u.substring(o+p,o+v-n)}}else{let p=0;const u=i;for(;c!==F.$0B;)if(c.left!==F.$0B&&c.lf_left>=i-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>i-1){const o=this.B(c,i-c.lf_left-2),v=this.B(c,i-c.lf_left-1),b=this.a[c.piece.bufferIndex].buffer,$=this.u(c.piece.bufferIndex,c.piece.start);return p+=c.size_left,this.h.set({node:c,nodeStartOffset:p,nodeStartLineNumber:u-(i-1-c.lf_left)}),b.substring($+o,$+v-n)}else if(c.lf_left+c.piece.lineFeedCnt===i-1){const o=this.B(c,i-c.lf_left-2),v=this.a[c.piece.bufferIndex].buffer,b=this.u(c.piece.bufferIndex,c.piece.start);d=v.substring(b+o,b+c.piece.length);break}else i-=c.lf_left+c.piece.lineFeedCnt,p+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==F.$0B;){const p=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const u=this.B(c,0),o=this.u(c.piece.bufferIndex,c.piece.start);return d+=p.substring(o,o+u-n),d}else{const u=this.u(c.piece.bufferIndex,c.piece.start);d+=p.substr(u,c.piece.length)}c=c.next()}return d}y(){let i=this.root,n=1,c=0;for(;i!==F.$0B;)n+=i.lf_left+i.piece.lineFeedCnt,c+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=c,this.h.validate(this.c)}A(i,n){const c=i.piece,d=this.s(i,n),t=d.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===n){const p=this.t(i.piece.bufferIndex,c.start,d);if(p!==t)return{index:p,remainder:0}}return{index:t,remainder:d.column}}B(i,n){if(n<0)return 0;const c=i.piece,d=this.a[c.bufferIndex].lineStarts,t=c.start.line+n+1;return t>c.end.line?d[c.end.line]+c.end.column-d[c.start.line]-c.start.column:d[t]-d[c.start.line]-c.start.column}C(i,n){const c=i.piece,d=c.lineFeedCnt,t=this.u(c.bufferIndex,c.end),p=n,u=this.u(c.bufferIndex,p),o=this.t(c.bufferIndex,c.start,p),v=o-d,b=u-t,$=c.length+b;i.piece=new l(c.bufferIndex,c.start,p,o,$),(0,F.$eC)(this,i,b,v)}D(i,n){const c=i.piece,d=c.lineFeedCnt,t=this.u(c.bufferIndex,c.start),p=n,u=this.t(c.bufferIndex,p,c.end),o=this.u(c.bufferIndex,p),v=u-d,b=t-o,$=c.length+b;i.piece=new l(c.bufferIndex,p,c.end,u,$),(0,F.$eC)(this,i,b,v)}E(i,n,c){const d=i.piece,t=d.start,p=d.end,u=d.length,o=d.lineFeedCnt,v=n,b=this.t(d.bufferIndex,d.start,v),$=this.u(d.bufferIndex,n)-this.u(d.bufferIndex,t);i.piece=new l(d.bufferIndex,d.start,v,b,$),(0,F.$eC)(this,i,$-u,b-o);const I=new l(d.bufferIndex,c,p,this.t(d.bufferIndex,c,p),this.u(d.bufferIndex,p)-this.u(d.bufferIndex,c)),h=this.S(i,I);this.N(h)}F(i,n){this.Q(n,i)&&(n+=`
`);const c=this.K()&&this.L(n)&&this.M(i),d=this.a[0].buffer.length;this.a[0].buffer+=n;const t=N(n,!1);for(let h=0;h<t.length;h++)t[h]+=d;if(c){const h=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:d-h}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const p=this.a[0].lineStarts.length-1,u=this.a[0].buffer.length-this.a[0].lineStarts[p],o={line:p,column:u},v=i.piece.length+n.length,b=i.piece.lineFeedCnt,$=this.t(0,i.piece.start,o),I=$-b;i.piece=new l(i.piece.bufferIndex,i.piece.start,o,$,v),this.g=o,(0,F.$eC)(this,i,n.length,I)}G(i){let n=this.root;const c=this.h.get(i);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:i-c.nodeStartOffset};let d=0;for(;n!==F.$0B;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){d+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:d};return this.h.set(t),t}else i-=n.size_left+n.piece.length,d+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let c=this.root,d=0;for(;c!==F.$0B;)if(c.left!==F.$0B&&c.lf_left>=i-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>i-1){const t=this.B(c,i-c.lf_left-2),p=this.B(c,i-c.lf_left-1);return d+=c.size_left,{node:c,remainder:Math.min(t+n-1,p),nodeStartOffset:d}}else if(c.lf_left+c.piece.lineFeedCnt===i-1){const t=this.B(c,i-c.lf_left-2);if(t+n-1<=c.piece.length)return{node:c,remainder:t+n-1,nodeStartOffset:d};n-=c.piece.length-t;break}else i-=c.lf_left+c.piece.lineFeedCnt,d+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==F.$0B;){if(c.piece.lineFeedCnt>0){const t=this.B(c,0),p=this.J(c);return{node:c,remainder:Math.min(n-1,t),nodeStartOffset:p}}else if(c.piece.length>=n-1){const t=this.J(c);return{node:c,remainder:n-1,nodeStartOffset:t}}else n-=c.piece.length;c=c.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const c=this.a[i.piece.bufferIndex],d=this.u(i.piece.bufferIndex,i.piece.start)+n;return c.buffer.charCodeAt(d)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===F.$0B||i.piece.lineFeedCnt===0)return!1;const n=i.piece,c=this.a[n.bufferIndex].lineStarts,d=n.start.line,t=c[d]+n.start.column;return d===c.length-1||c[d+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===F.$0B||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const c=[],d=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:d[i.piece.end.line]-d[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const p=i.piece.length-1,u=i.piece.lineFeedCnt-1;i.piece=new l(i.piece.bufferIndex,i.piece.start,t,u,p),(0,F.$eC)(this,i,-1,-1),i.piece.length===0&&c.push(i);const o={line:n.piece.start.line+1,column:0},v=n.piece.length-1,b=this.t(n.piece.bufferIndex,o,n.piece.end);n.piece=new l(n.piece.bufferIndex,o,n.piece.end,b,v),(0,F.$eC)(this,n,-1,-1),n.piece.length===0&&c.push(n);const $=this.w(`\r
`);this.S(i,$[0]);for(let I=0;I<c.length;I++)(0,F.$cC)(this,c[I])}Q(i,n){if(this.K()&&this.M(i)){const c=n.next();if(this.L(c)){if(i+=`
`,c.piece.length===1)(0,F.$cC)(this,c);else{const d=c.piece,t={line:d.start.line+1,column:0},p=d.length-1,u=this.t(d.bufferIndex,t,d.end);c.piece=new l(d.bufferIndex,t,d.end,u,p),(0,F.$eC)(this,c,-1,-1)}return!0}}return!1}iterate(i,n){if(i===F.$0B)return n(F.$0B);const c=this.iterate(i.left,n);return c&&n(i)&&this.iterate(i.right,n)}R(i){if(i===F.$0B)return"";const n=this.a[i.piece.bufferIndex],c=i.piece,d=this.u(c.bufferIndex,c.start),t=this.u(c.bufferIndex,c.end);return n.buffer.substring(d,t)}getPieceContent(i){const n=this.a[i.bufferIndex],c=this.u(i.bufferIndex,i.start),d=this.u(i.bufferIndex,i.end);return n.buffer.substring(c,d)}S(i,n){const c=new F.$9B(n,1);if(c.left=F.$0B,c.right=F.$0B,c.parent=F.$0B,c.size_left=0,c.lf_left=0,this.root===F.$0B)this.root=c,c.color=0;else if(i.right===F.$0B)i.right=c,c.parent=i;else{const t=(0,F.$$B)(i.right);t.left=c,c.parent=t}return(0,F.$dC)(this,c),c}T(i,n){const c=new F.$9B(n,1);if(c.left=F.$0B,c.right=F.$0B,c.parent=F.$0B,c.size_left=0,c.lf_left=0,this.root===F.$0B)this.root=c,c.color=0;else if(i.left===F.$0B)i.left=c,c.parent=i;else{const d=(0,F.$_B)(i.left);d.right=c,c.parent=d}return(0,F.$dC)(this,c),c}U(i){let n="";return this.iterate(i,c=>(n+=this.R(c),!0)),n}}e.$qC=a}),define(Pe[135],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K9=e.$J9=void 0;class S{constructor(){this.a=new Map}removeDragOperationTransfer(F){if(F&&this.a.has(F)){const R=this.a.get(F);return this.a.delete(F),R}}addDragOperationTransfer(F,R){this.a.set(F,R)}}e.$J9=S;class M{constructor(F){this.identifier=F}}e.$K9=M}),define(Pe[136],Re([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(Pe[137],Re([1,0,5,6,136]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=void 0;class F extends M.$Tc{constructor(l,k="",g="",s=!0,a){super(),this.h=this.B(new S.$6d),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=k,this.u=g,this.w=s,this.C=a}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,k){this.C&&await this.C(l)}}e.$Xi=F;class R extends M.$Tc{constructor(){super(...arguments),this.f=this.B(new S.$6d),this.onWillRun=this.f.event,this.m=this.B(new S.$6d),this.onDidRun=this.m.event}async run(l,k){if(!l.enabled)return;this.f.fire({action:l});let g;try{await this.u(l,k)}catch(s){g=s}this.m.fire({action:l,error:g})}async u(l,k){await l.run(k)}}e.$Yi=R;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let k=[];for(const g of l)g.length&&(k.length?k=[...k,new m,...g]:k=g);return k}static{this.ID="vs.actions.separator"}async run(){}}e.$Zi=m;class f{get actions(){return this.a}constructor(l,k,g,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=k,this.class=s,this.a=g}async run(){}}e.$1i=f;class E extends F{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,P.localize(0,null),void 0,!1)}}e.$2i=E;function N(D){return{id:D.id,label:D.label,class:D.class,enabled:D.enabled??!0,checked:D.checked,run:async(...l)=>D.run(...l),tooltip:D.label}}e.$3i=N}),define(Pe[138],Re([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(Pe[139],Re([1,0,138]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=e.$Km=void 0;const M=60,P=M*60,F=P*24,R=F*7,m=F*30,f=F*365;function E(l,k,g,s){typeof l!="number"&&(l=l.getTime());const a=Math.round((new Date().getTime()-l)/1e3);if(a<-30)return(0,S.localize)(0,null,E(new Date().getTime()+a*1e3,!1));if(!s&&a<30)return(0,S.localize)(1,null);let r;return a<M?(r=a,k?r===1?g?(0,S.localize)(2,null,r):(0,S.localize)(3,null,r):g?(0,S.localize)(4,null,r):(0,S.localize)(5,null,r):r===1?g?(0,S.localize)(6,null,r):(0,S.localize)(7,null,r):g?(0,S.localize)(8,null,r):(0,S.localize)(9,null,r)):a<P?(r=Math.floor(a/M),k?r===1?g?(0,S.localize)(10,null,r):(0,S.localize)(11,null,r):g?(0,S.localize)(12,null,r):(0,S.localize)(13,null,r):r===1?g?(0,S.localize)(14,null,r):(0,S.localize)(15,null,r):g?(0,S.localize)(16,null,r):(0,S.localize)(17,null,r)):a<F?(r=Math.floor(a/P),k?r===1?g?(0,S.localize)(18,null,r):(0,S.localize)(19,null,r):g?(0,S.localize)(20,null,r):(0,S.localize)(21,null,r):r===1?g?(0,S.localize)(22,null,r):(0,S.localize)(23,null,r):g?(0,S.localize)(24,null,r):(0,S.localize)(25,null,r)):a<R?(r=Math.floor(a/F),k?r===1?(0,S.localize)(26,null,r):(0,S.localize)(27,null,r):r===1?(0,S.localize)(28,null,r):(0,S.localize)(29,null,r)):a<m?(r=Math.floor(a/R),k?r===1?g?(0,S.localize)(30,null,r):(0,S.localize)(31,null,r):g?(0,S.localize)(32,null,r):(0,S.localize)(33,null,r):r===1?g?(0,S.localize)(34,null,r):(0,S.localize)(35,null,r):g?(0,S.localize)(36,null,r):(0,S.localize)(37,null,r)):a<f?(r=Math.floor(a/m),k?r===1?g?(0,S.localize)(38,null,r):(0,S.localize)(39,null,r):g?(0,S.localize)(40,null,r):(0,S.localize)(41,null,r):r===1?g?(0,S.localize)(42,null,r):(0,S.localize)(43,null,r):g?(0,S.localize)(44,null,r):(0,S.localize)(45,null,r)):(r=Math.floor(a/f),k?r===1?g?(0,S.localize)(46,null,r):(0,S.localize)(47,null,r):g?(0,S.localize)(48,null,r):(0,S.localize)(49,null,r):r===1?g?(0,S.localize)(50,null,r):(0,S.localize)(51,null,r):g?(0,S.localize)(52,null,r):(0,S.localize)(53,null,r))}e.$Km=E;function N(l,k){const g=Math.abs(l/1e3);return g<1?k?(0,S.localize)(54,null,l):(0,S.localize)(55,null,l):g<M?k?(0,S.localize)(56,null,Math.round(l)/1e3):(0,S.localize)(57,null,Math.round(l)/1e3):g<P?k?(0,S.localize)(58,null,Math.round(l/(1e3*M))):(0,S.localize)(59,null,Math.round(l/(1e3*M))):g<F?k?(0,S.localize)(60,null,Math.round(l/(1e3*P))):(0,S.localize)(61,null,Math.round(l/(1e3*P))):(0,S.localize)(62,null,Math.round(l/(1e3*F)))}e.$Lm=N;function D(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Mm=D}),define(Pe[140],Re([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(Pe[41],Re([1,0,18,16,140]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=e.$5i=e.$4i=void 0;function F(D,l){return l&&(D.stack||D.stacktrace)?P.localize(0,null,m(D),R(D.stack)||R(D.stacktrace)):m(D)}function R(D){return Array.isArray(D)?D.join(`
`):D}function m(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?P.localize(1,null,D.message):D.message||P.localize(2,null)}function f(D=null,l=!1){if(!D)return P.localize(3,null);if(Array.isArray(D)){const k=S.$Hb(D),g=f(k[0],l);return k.length>1?P.localize(4,null,g,k.length):g}if(M.$Tf(D))return D;if(D.detail){const k=D.detail;if(k.error)return F(k.error,l);if(k.exception)return F(k.exception,l)}return D.stack?F(D,l):D.message?D.message:P.localize(5,null)}e.$4i=f;function E(D){const l=D;return l instanceof Error&&Array.isArray(l.actions)}e.$5i=E;function N(D,l){let k;return typeof D=="string"?k=new Error(D):k=D,k.actions=l,k}e.$6i=N}),define(Pe[141],Re([1,0,39,19]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=e.$9q=e.$8q=e.$7q=e.$6q=e.$5q=e.$4q=e.$3q=e.$2q=e.$1q=e.$Zq=e.$Yq=e.$Xq=void 0;const P=new S.$V(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),F=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(I,h,y=!1){const w=I||"",A=h||"",L=P.value.collator.compare(w,A);return P.value.collatorIsNumeric&&L===0&&w!==A?w<A?-1:1:L}e.$Xq=m;function f(I,h){const y=F.value.collator;return I=I||"",h=h||"",c(y,I,h)}e.$Yq=f;function E(I,h){const y=F.value.collator;return I=I||"",h=h||"",u(I,h)||c(y,I,h)}e.$Zq=E;function N(I,h){const y=F.value.collator;return I=I||"",h=h||"",p(I,h)||c(y,I,h)}e.$1q=N;function D(I,h){return I=I||"",h=h||"",I===h?0:I<h?-1:1}e.$2q=D;function l(I,h){const[y,w]=i(I),[A,L]=i(h);let J=P.value.collator.compare(w,L);if(J===0){if(P.value.collatorIsNumeric&&w!==L)return w<L?-1:1;if(J=P.value.collator.compare(y,A),P.value.collatorIsNumeric&&J===0&&y!==A)return y<A?-1:1}return J}e.$3q=l;function k(I,h){I=I||"",h=h||"";const y=n(I),w=n(h),A=F.value.collator,L=R.value.collator;return c(L,y,w)||c(A,I,h)}e.$4q=k;function g(I,h){I=I||"",h=h||"";const y=n(I),w=n(h),A=F.value.collator,L=R.value.collator;return c(L,y,w)||u(I,h)||c(A,I,h)}e.$5q=g;function s(I,h){I=I||"",h=h||"";const y=n(I),w=n(h),A=F.value.collator,L=R.value.collator;return c(L,y,w)||p(I,h)||c(A,I,h)}e.$6q=s;function a(I,h){I=I||"",h=h||"";const y=n(I).toLowerCase(),w=n(h).toLowerCase();return y!==w?y<w?-1:1:I!==h?I<h?-1:1:0}e.$7q=a;const r=/^(.*?)(\.([^.]*))?$/;function i(I,h=!1){const y=I?r.exec(I):[];let w=[y&&y[1]||"",y&&y[3]||""];return h&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function n(I){const h=I?r.exec(I):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function c(I,h,y){const w=I.compare(h,y);return w!==0?w:h.length!==y.length?h.length<y.length?-1:1:0}function d(I){const h=I.charAt(0);return h.toLocaleUpperCase()!==h}function t(I){const h=I.charAt(0);return h.toLocaleLowerCase()!==h}function p(I,h){return d(I)&&t(h)?-1:t(I)&&d(h)?1:0}function u(I,h){return t(I)&&d(h)?-1:d(I)&&t(h)?1:0}function o(I,h,y=!1){return y||(I=I&&I.toLowerCase(),h=h&&h.toLowerCase()),I===h?0:I<h?-1:1}function v(I,h,y=!1){const w=I.split(M.sep),A=h.split(M.sep),L=w.length-1,J=A.length-1;let W,U;for(let C=0;;C++){if(W=L===C,U=J===C,W&&U)return m(w[C],A[C],y);if(W)return-1;if(U)return 1;const O=o(w[C],A[C],y);if(O!==0)return O}}e.$8q=v;function b(I,h,y){const w=I.toLowerCase(),A=h.toLowerCase(),L=$(I,h,y);if(L)return L;const J=w.endsWith(y),W=A.endsWith(y);if(J!==W)return J?-1:1;const U=m(w,A);return U!==0?U:w.localeCompare(A)}e.$9q=b;function $(I,h,y){const w=I.toLowerCase(),A=h.toLowerCase(),L=w.startsWith(y),J=A.startsWith(y);if(L!==J)return L?-1:1;if(L&&J){if(w.length<A.length)return-1;if(w.length>A.length)return 1}return 0}e.$0q=$}),define(Pe[45],Re([1,0,19,21,15,16]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=void 0;function R(b){return b===47||b===92}e.$_f=R;function m(b){return b.replace(/[\\/]/g,S.$gc.sep)}e.$ag=m;function f(b){return b.indexOf("/")===-1&&(b=m(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}e.$bg=f;function E(b,$=S.$gc.sep){if(!b)return"";const I=b.length,h=b.charCodeAt(0);if(R(h)){if(R(b.charCodeAt(1))&&!R(b.charCodeAt(2))){let w=3;const A=w;for(;w<I&&!R(b.charCodeAt(w));w++);if(A!==w&&!R(b.charCodeAt(w+1))){for(w+=1;w<I;w++)if(R(b.charCodeAt(w)))return b.slice(0,w+1).replace(/[\\/]/g,$)}}return $}else if(r(h)&&b.charCodeAt(1)===58)return R(b.charCodeAt(2))?b.slice(0,2)+$:b.slice(0,2);let y=b.indexOf("://");if(y!==-1){for(y+=3;y<I;y++)if(R(b.charCodeAt(y)))return b.slice(0,y+1)}return""}e.$cg=E;function N(b){if(!M.$i||!b||b.length<5)return!1;let $=b.charCodeAt(0);if($!==92||($=b.charCodeAt(1),$!==92))return!1;let I=2;const h=I;for(;I<b.length&&($=b.charCodeAt(I),$!==92);I++);return!(h===I||($=b.charCodeAt(I+1),isNaN($)||$===92))}e.$dg=N;const D=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(b,$=M.$i){const I=$?D:l;return!(!b||b.length===0||/^\s+$/.test(b)||(I.lastIndex=0,I.test(b))||$&&k.test(b)||b==="."||b===".."||$&&b[b.length-1]==="."||$&&b.length!==b.trim().length||b.length>255)}e.$eg=g;function s(b,$,I){const h=b===$;return!I||h?h:!b||!$?!1:(0,P.$kf)(b,$)}e.$fg=s;function a(b,$,I,h=S.sep){if(b===$)return!0;if(!b||!$||$.length>b.length)return!1;if(I){if(!(0,P.$lf)(b,$))return!1;if($.length===b.length)return!0;let w=$.length;return $.charAt($.length-1)===h&&w--,b.charAt(w)===h}return $.charAt($.length-1)!==h&&($+=h),b.indexOf($)===0}e.$gg=a;function r(b){return b>=65&&b<=90||b>=97&&b<=122}e.$hg=r;function i(b,$){return M.$i&&b.endsWith(":")&&(b+=S.sep),(0,S.$ic)(b)||(b=(0,S.$jc)($,b)),b=(0,S.$hc)(b),M.$i?(b=(0,P.$5e)(b,S.sep),b.endsWith(":")&&(b+=S.sep)):(b=(0,P.$5e)(b,S.sep),b||(b=S.sep)),b}e.$ig=i;function n(b){const $=(0,S.$hc)(b);return M.$i?b.length>3?!1:c($)&&(b.length===2||$.charCodeAt(2)===92):$===S.$gc.sep}e.$jg=n;function c(b,$=M.$i){return $?r(b.charCodeAt(0))&&b.charCodeAt(1)===58:!1}e.$kg=c;function d(b,$=M.$i){return c(b,$)?b[0]:void 0}e.$lg=d;function t(b,$,I){return $.length>b.length?-1:b===$?0:(I&&(b=b.toLowerCase(),$=$.toLowerCase()),b.indexOf($))}e.$mg=t;function p(b){const $=b.split(":");let I,h,y;for(const w of $){const A=Number(w);(0,F.$Xf)(A)?h===void 0?h=A:y===void 0&&(y=A):I=I?[I,w].join(":"):w}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:h!==void 0?h:void 0,column:y!==void 0?y:h!==void 0?1:void 0}}e.$ng=p;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function v(b,$,I=8){let h="";for(let w=0;w<I;w++){let A;w===0&&M.$i&&!$&&(I===3||I===4)?A=o:A=u,h+=A.charAt(Math.floor(Math.random()*A.length))}let y;return $?y=`${$}-${h}`:y=h,b?(0,S.$jc)(b,y):y}e.$og=v}),define(Pe[69],Re([1,0,19]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=e.$xs=e.$ws=e.$vs=e.$us=void 0,e.$us=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function F(N){const D=(0,S.$oc)(N),l=M[D.toLowerCase()];return l!==void 0?l:R(N)}e.$vs=F;function R(N){const D=(0,S.$oc)(N);return P[D.toLowerCase()]}e.$ws=R;function m(N){for(const D in P)if(P[D]===N)return D}e.$xs=m;const f=/^(.+)\/(.+?)(;.+)?$/;function E(N,D){const l=f.exec(N);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:D?void 0:N}e.$ys=E}),define(Pe[52],Re([1,0,23,2]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=e.$Oh=e.$Nh=void 0;function P(f){return JSON.stringify(f,R)}e.$Nh=P;function F(f){let E=JSON.parse(f);return E=m(E),E}e.$Oh=F;function R(f,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function m(f,E=0){if(!f||E>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return M.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof S.$te||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let N=0;N<f.length;++N)f[N]=m(f[N],E+1);else for(const N in f)Object.hasOwnProperty.call(f,N)&&(f[N]=m(f[N],E+1))}return f}e.$Ph=m}),define(Pe[12],Re([1,0,14,21,15,2,19]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.Schemas=void 0;var m;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatCodeBlock="vscode-chat-code-block",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm",g.codeSetting="code-setting"})(m||(e.Schemas=m={}));function f(g,s){return F.URI.isUri(g)?(0,P.$kf)(g.scheme,s):(0,P.$lf)(g,s+":")}e.$pg=f;function E(g,...s){return s.some(a=>f(g,a))}e.$qg=E,e.$rg="vscode-tkn",e.$sg="tkn";class N{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,a){this.f=D(s,a)}getServerRootPath(){return this.f}get g(){return R.$gc.join(this.f,m.vscodeRemoteResource)}set(s,a,r){this.a[s]=a,this.b[s]=r}setConnectionToken(s,a){this.c[s]=a}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(d){return S.$1(d),s}const a=s.authority;let r=this.a[a];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const i=this.b[a],n=this.c[a];let c=`path=${encodeURIComponent(s.path)}`;return typeof n=="string"&&(c+=`&${e.$sg}=${encodeURIComponent(n)}`),F.URI.from({scheme:M.$o?this.d:m.vscodeRemoteResource,authority:`${r}:${i}`,path:this.g,query:c})}}e.$tg=new N;function D(g,s){return R.$gc.join(s??"/",`${g.quality??"oss"}-${g.commit??"dev"}`)}e.$ug=D,e.$vg="vs/../../extensions",e.$wg="vs/../../node_modules",e.$xg="vs/../../node_modules.asar",e.$yg="vs/../../node_modules.asar.unpacked",e.$zg="vscode-app";class l{static{this.a=e.$zg}asBrowserUri(s){const a=this.b(s,me);return this.uriToBrowserUri(a)}uriToBrowserUri(s){return s.scheme===m.vscodeRemote?e.$tg.rewrite(s):s.scheme===m.file&&(M.$m||M.$q===`${m.vscodeFileResource}://${l.a}`)?s.with({scheme:m.vscodeFileResource,authority:s.authority||l.a,query:null,fragment:null}):s}asFileUri(s){const a=this.b(s,me);return this.uriToFileUri(a)}uriToFileUri(s){return s.scheme===m.vscodeFileResource?s.with({scheme:m.file,authority:s.authority!==l.a?s.authority:null,query:null,fragment:null}):s}b(s,a){return F.URI.isUri(s)?s:F.URI.parse(a.toUrl(s))}}e.$Ag=new l;var k;(function(g){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(s.get("3"));const a="vscode-coi";function r(n){let c;typeof n=="string"?c=new URL(n).searchParams:n instanceof URL?c=n.searchParams:F.URI.isUri(n)&&(c=new URL(n.toString(!0)).searchParams);const d=c?.get(a);if(d)return s.get(d)}g.getHeadersFromQuery=r;function i(n,c,d){if(!globalThis.crossOriginIsolated)return;const t=c&&d?"3":d?"2":"1";n instanceof URLSearchParams?n.set(a,t):n[a]=t}g.addSearchParam=i})(k||(e.COI=k={}))}),define(Pe[24],Re([1,0,45,12,19,21,15,2]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=e.DataUri=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=void 0;function f(k){return(0,m.$wc)(k,!0)}e.$Hg=f;class E{constructor(g){this.a=g}compare(g,s,a=!1){return g===s?0:(0,R.$df)(this.getComparisonKey(g,a),this.getComparisonKey(s,a))}isEqual(g,s,a=!1){return g===s?!0:!g||!s?!1:this.getComparisonKey(g,a)===this.getComparisonKey(s,a)}getComparisonKey(g,s=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,s,a=!1){if(g.scheme===s.scheme){if(g.scheme===M.Schemas.file)return S.$gg(f(g),f(s),this.a(g))&&g.query===s.query&&(a||g.fragment===s.fragment);if((0,e.$Yg)(g.authority,s.authority))return S.$gg(g.path,s.path,this.a(g),"/")&&g.query===s.query&&(a||g.fragment===s.fragment)}return!1}joinPath(g,...s){return m.URI.joinPath(g,...s)}basenameOrAuthority(g){return(0,e.$Qg)(g)||g.authority}basename(g){return P.$gc.basename(g.path)}extname(g){return P.$gc.extname(g.path)}dirname(g){if(g.path.length===0)return g;let s;return g.scheme===M.Schemas.file?s=m.URI.file(P.$mc(f(g))).path:(s=P.$gc.dirname(g.path),g.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),s="/")),g.with({path:s})}normalizePath(g){if(!g.path.length)return g;let s;return g.scheme===M.Schemas.file?s=m.URI.file(P.$hc(f(g))).path:s=P.$gc.normalize(g.path),g.with({path:s})}relativePath(g,s){if(g.scheme!==s.scheme||!(0,e.$Yg)(g.authority,s.authority))return;if(g.scheme===M.Schemas.file){const i=P.$lc(f(g),f(s));return F.$i?S.$ag(i):i}let a=g.path||"/";const r=s.path||"/";if(this.a(g)){let i=0;for(const n=Math.min(a.length,r.length);i<n&&!(a.charCodeAt(i)!==r.charCodeAt(i)&&a.charAt(i).toLowerCase()!==r.charAt(i).toLowerCase());i++);a=r.substr(0,i)+a.substr(i)}return P.$gc.relative(a,r)}resolvePath(g,s){if(g.scheme===M.Schemas.file){const a=m.URI.file(P.$kc(f(g),s));return g.with({authority:a.authority,path:a.path})}return s=S.$bg(s),g.with({path:P.$gc.resolve(g.path,s)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,s){return g===s||g!==void 0&&s!==void 0&&(0,R.$kf)(g,s)}hasTrailingPathSeparator(g,s=P.sep){if(g.scheme===M.Schemas.file){const a=f(g);return a.length>S.$cg(a).length&&a[a.length-1]===s}else{const a=g.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,s=P.sep){return(0,e.$Zg)(g,s)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,s=P.sep){let a=!1;if(g.scheme===M.Schemas.file){const r=f(g);a=r!==void 0&&r.length===S.$cg(r).length&&r[r.length-1]===s}else{s="/";const r=g.path;a=r.length===1&&r.charCodeAt(r.length-1)===47}return!a&&!(0,e.$Zg)(g,s)?g.with({path:g.path+"/"}):g}}e.$Ig=E,e.$Jg=new E(()=>!1),e.$Kg=new E(k=>k.scheme===M.Schemas.file?!F.$k:!0),e.$Lg=new E(k=>!0),e.$Mg=e.$Jg.isEqual.bind(e.$Jg),e.$Ng=e.$Jg.isEqualOrParent.bind(e.$Jg),e.$Og=e.$Jg.getComparisonKey.bind(e.$Jg),e.$Pg=e.$Jg.basenameOrAuthority.bind(e.$Jg),e.$Qg=e.$Jg.basename.bind(e.$Jg),e.$Rg=e.$Jg.extname.bind(e.$Jg),e.$Sg=e.$Jg.dirname.bind(e.$Jg),e.$Tg=e.$Jg.joinPath.bind(e.$Jg),e.$Ug=e.$Jg.normalizePath.bind(e.$Jg),e.$Vg=e.$Jg.relativePath.bind(e.$Jg),e.$Wg=e.$Jg.resolvePath.bind(e.$Jg),e.$Xg=e.$Jg.isAbsolutePath.bind(e.$Jg),e.$Yg=e.$Jg.isEqualAuthority.bind(e.$Jg),e.$Zg=e.$Jg.hasTrailingPathSeparator.bind(e.$Jg),e.$1g=e.$Jg.removeTrailingPathSeparator.bind(e.$Jg),e.$2g=e.$Jg.addTrailingPathSeparator.bind(e.$Jg);function N(k,g){const s=[];for(let a=0;a<k.length;a++){const r=g(k[a]);k.some((i,n)=>n===a?!1:(0,e.$Ng)(r,g(i)))||s.push(k[a])}return s}e.$3g=N;var D;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function g(s){const a=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(n=>{const[c,d]=n.split(":");c&&d&&a.set(c,d)});const i=s.path.substring(0,s.path.indexOf(";"));return i&&a.set(k.META_DATA_MIME,i),a}k.parseMetaData=g})(D||(e.DataUri=D={}));function l(k,g,s){if(g){let a=k.path;return a&&a[0]!==P.$gc.sep&&(a=P.$gc.sep+a),k.with({scheme:s,authority:g,path:a})}return k.with({scheme:s})}e.$4g=l}),define(Pe[11],Re([1,0,25,14,5,6,24,21,128,39]),function(me,e,S,M,P,F,R,m,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.Promises=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0;function N(ge){return!!ge&&typeof ge.then=="function"}e.$5g=N;function D(ge){const G=new S.$de,Y=ge(G.token),he=new Promise((fe,Oe)=>{const de=G.token.onCancellationRequested(()=>{de.dispose(),Oe(new M.$5)});Promise.resolve(Y).then(Ce=>{de.dispose(),G.dispose(),fe(Ce)},Ce=>{de.dispose(),G.dispose(),Oe(Ce)})});return new class{cancel(){G.cancel(),G.dispose()}then(fe,Oe){return he.then(fe,Oe)}catch(fe){return this.then(void 0,fe)}finally(fe){return he.finally(fe)}}}e.$6g=D;function l(ge,G,Y){return new Promise((he,fe)=>{const Oe=G.onCancellationRequested(()=>{Oe.dispose(),he(Y)});ge.then(he,fe).finally(()=>Oe.dispose())})}e.$7g=l;function k(ge,G){return new Promise((Y,he)=>{const fe=G.onCancellationRequested(()=>{fe.dispose(),he(new M.$5)});ge.then(Y,he).finally(()=>fe.dispose())})}e.$8g=k;async function g(ge){let G=-1;const Y=ge.map((he,fe)=>he.then(Oe=>(G=fe,Oe)));try{return await Promise.race(Y)}finally{ge.forEach((he,fe)=>{fe!==G&&he.cancel()})}}e.$9g=g;function s(ge,G,Y){let he;const fe=setTimeout(()=>{he?.(void 0),Y?.()},G);return Promise.race([ge.finally(()=>clearTimeout(fe)),new Promise(Oe=>he=Oe)])}e.$0g=s;function a(ge){return new Promise((G,Y)=>{const he=ge();N(he)?he.then(G,Y):G(he)})}e.$$g=a;function r(){let ge,G;return{promise:new Promise((he,fe)=>{ge=he,G=fe}),resolve:ge,reject:G}}e.$_g=r;class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(G){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=G,!this.b){const Y=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(Y,Y).then(he)})}return new Promise((Y,he)=>{this.b.then(Y,he)})}return this.a=G(),new Promise((Y,he)=>{this.a.then(fe=>{this.a=null,Y(fe)},fe=>{this.a=null,he(fe)})})}dispose(){this.f=!0}}e.$ah=i;class n{constructor(){this.a=Promise.resolve(null)}queue(G){return this.a=this.a.then(()=>G(),()=>G())}}e.$bh=n;class c{constructor(){this.a=new Map}queue(G,Y){const fe=(this.a.get(G)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(G)===fe&&this.a.delete(G)});return this.a.set(G,fe),fe}}e.$ch=c;const d=(ge,G)=>{let Y=!0;const he=setTimeout(()=>{Y=!1,G()},ge);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(he),Y=!1}}},t=ge=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,ge())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};class p{constructor(G){this.defaultDelay=G,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(G,Y=this.defaultDelay){this.g=G,this.h(),this.b||(this.b=new Promise((fe,Oe)=>{this.d=fe,this.f=Oe}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=Y===f.$3d?t(he):d(Y,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$dh=p;class u{constructor(G){this.a=new p(G),this.b=new i}trigger(G,Y){return this.a.trigger(()=>this.b.queue(G),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$eh=u;class o{constructor(){this.a=!1,this.b=new Promise((G,Y)=>{this.d=G})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$fh=o;class v extends o{constructor(G){super(),this.f=setTimeout(()=>this.open(),G)}open(){clearTimeout(this.f),super.open()}}e.$gh=v;function b(ge,G){return G?new Promise((Y,he)=>{const fe=setTimeout(()=>{Oe.dispose(),Y()},ge),Oe=G.onCancellationRequested(()=>{clearTimeout(fe),Oe.dispose(),he(new M.$5)})}):D(Y=>b(ge,Y))}e.$hh=b;function $(ge,G=0,Y){const he=setTimeout(()=>{ge(),Y&&fe.dispose()},G),fe=(0,F.$Rc)(()=>{clearTimeout(he),Y?.deleteAndLeak(fe)});return Y?.add(fe),fe}e.$ih=$;function I(ge){const G=[];let Y=0;const he=ge.length;function fe(){return Y<he?ge[Y++]():null}function Oe(de){de!=null&&G.push(de);const Ce=fe();return Ce?Ce.then(Oe):Promise.resolve(G)}return Promise.resolve(null).then(Oe)}e.$jh=I;function h(ge,G=he=>!!he,Y=null){let he=0;const fe=ge.length,Oe=()=>{if(he>=fe)return Promise.resolve(Y);const de=ge[he++];return Promise.resolve(de()).then(Ae=>G(Ae)?Promise.resolve(Ae):Oe())};return Oe()}e.$kh=h;function y(ge,G=he=>!!he,Y=null){if(ge.length===0)return Promise.resolve(Y);let he=ge.length;const fe=()=>{he=-1;for(const Oe of ge)Oe.cancel?.()};return new Promise((Oe,de)=>{for(const Ce of ge)Ce.then(Ae=>{--he>=0&&G(Ae)?(fe(),Oe(Ae)):he===0&&Oe(Y)}).catch(Ae=>{--he>=0&&(fe(),de(Ae))})})}e.$lh=y;class w{constructor(G){this.a=0,this.b=!1,this.f=G,this.g=[],this.d=0,this.h=new P.$6d}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(G){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,he)=>{this.g.push({factory:G,c:Y,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const G=this.g.shift();this.d++;const Y=G.factory();Y.then(G.c,G.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$mh=w;class A extends w{constructor(){super(1)}}e.$nh=A;class L{constructor(){this.a=new ue,this.b=0}queue(G){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,G())):this.a.run(this.b++,G())}}e.$oh=L;class J{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const G=new $e;return this.b.add(G),G.p}g(){for(const[,G]of this.a)if(G.size>0)return!1;return!0}queueSize(G,Y=R.$Jg){const he=Y.getComparisonKey(G);return this.a.get(he)?.size??0}queueFor(G,Y,he=R.$Jg){const fe=he.getComparisonKey(G);let Oe=this.a.get(fe);if(!Oe){Oe=new A;const de=this.f++,Ce=P.Event.once(Oe.onDrained)(()=>{Oe?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(de),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new F.$3c),this.d.set(de,Ce),this.a.set(fe,Oe)}return Oe.queue(Y)}h(){this.g()&&this.j()}j(){for(const G of this.b)G.complete();this.b.clear()}dispose(){for(const[,G]of this.a)G.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ph=J;class W{constructor(G,Y){this.a=-1,typeof G=="function"&&typeof Y=="number"&&this.setIfNotSet(G,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(G,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,G()},Y)}setIfNotSet(G,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,G()},Y))}}e.$qh=W;class U{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(G,Y,he=globalThis){this.cancel();const fe=he.setInterval(()=>{G()},Y);this.d=(0,F.$Rc)(()=>{he.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$rh=U;class C{constructor(G,Y){this.b=-1,this.a=G,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(G=this.d){this.cancel(),this.b=setTimeout(this.f,G)}get delay(){return this.d}set delay(G){this.d=G}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$sh=C;class O{constructor(G,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=G,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(G=this.b){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(G/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$th=O;class q extends C{constructor(G,Y){super(G,Y),this.j=[]}work(G){this.j.push(G),this.isScheduled()||this.schedule()}h(){const G=this.j;this.j=[],this.a?.(G)}dispose(){this.j=[],super.dispose()}}e.$uh=q;class ne extends F.$Tc{constructor(G,Y){super(),this.g=G,this.h=Y,this.a=[],this.b=this.B(new F.$Uc),this.f=!1}get pending(){return this.a.length}work(G){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+G.length>this.g.maxBufferedWork)return!1}else if(this.pending+G.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of G)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new C(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$vh=ne,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$xh=(ge,G)=>{(0,m.$B)(()=>{if(Y)return;const he=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$xh=(ge,G,Y)=>{const he=ge.requestIdleCallback(G,typeof Y=="number"?{timeout:Y}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,ge.cancelIdleCallback(he))}}},e.$wh=ge=>(0,e.$xh)(globalThis,ge)}();class ce{constructor(G,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$xh)(G,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$yh=ce;class ye extends ce{constructor(G){super(globalThis,G)}}e.$zh=ye;async function Ie(ge,G,Y){let he;for(let fe=0;fe<Y;fe++)try{return await ge()}catch(Oe){he=Oe,await b(G)}throw he}e.$Ah=Ie;class ue{isRunning(G){return typeof G=="number"?this.a?.taskId===G:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(G,Y,he){return this.a={taskId:G,cancel:()=>he?.(),promise:Y},Y.then(()=>this.d(G),()=>this.d(G)),Y}d(G){this.a&&G===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const G=this.b;this.b=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}queue(G){if(this.b)this.b.run=G;else{const{promise:Y,resolve:he,reject:fe}=r();this.b={run:G,promise:Y,promiseResolve:he,promiseReject:fe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Bh=ue;class ve{constructor(G,Y=()=>Date.now()){this.d=G,this.f=Y,this.a=0,this.b=0}increment(){const G=this.f();return G-this.a>this.d&&(this.a=G,this.b=0),this.b++,this.b}}e.$Ch=ve;var re;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(re||(re={}));class $e{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((G,Y)=>{this.a=G,this.b=Y})}complete(G){return new Promise(Y=>{this.a(G),this.d={outcome:0,value:G},Y()})}error(G){return new Promise(Y=>{this.b(G),this.d={outcome:1,value:G},Y()})}cancel(){return this.error(new M.$5)}}e.$Dh=$e;var ie;(function(ge){async function G(he){let fe;const Oe=await Promise.all(he.map(de=>de.then(Ce=>Ce,Ce=>{fe||(fe=Ce)})));if(typeof fe<"u")throw fe;return Oe}ge.settled=G;function Y(he){return new Promise(async(fe,Oe)=>{try{await he(fe,Oe)}catch(de){Oe(de)}})}ge.withAsyncBody=Y})(ie||(e.Promises=ie={}));class le{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(G){this.a=void 0,this.b=void 0,this.d=!1,this.promise=G.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new M.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Eh=le;class V{constructor(G){this.b=G,this.a=new E.$V(()=>new le(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Fh=V;var _;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(_||(_={}));class ke{static fromArray(G){return new ke(Y=>{Y.emitMany(G)})}static fromPromise(G){return new ke(async Y=>{Y.emitMany(await G)})}static fromPromises(G){return new ke(async Y=>{await Promise.all(G.map(async he=>Y.emitOne(await he)))})}static merge(G){return new ke(async Y=>{await Promise.all(G.map(async he=>{for await(const fe of he)Y.emitOne(fe)}))})}static{this.EMPTY=ke.fromArray([])}constructor(G){this.a=0,this.b=[],this.d=null,this.f=new P.$6d,queueMicrotask(async()=>{const Y={emitOne:he=>this.g(he),emitMany:he=>this.h(he),reject:he=>this.k(he)};try{await Promise.resolve(G(Y)),this.j()}catch(he){this.k(he)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(G<this.b.length)return{done:!1,value:this.b[G++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(G,Y){return new ke(async he=>{for await(const fe of G)he.emitOne(Y(fe))})}map(G){return ke.map(this,G)}static filter(G,Y){return new ke(async he=>{for await(const fe of G)Y(fe)&&he.emitOne(fe)})}filter(G){return ke.filter(this,G)}static coalesce(G){return ke.filter(G,Y=>!!Y)}coalesce(){return ke.coalesce(this)}static async toPromise(G){const Y=[];for await(const he of G)Y.push(he);return Y}toPromise(){return ke.toPromise(this)}g(G){this.a===0&&(this.b.push(G),this.f.fire())}h(G){this.a===0&&(this.b=this.b.concat(G),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(G){this.a===0&&(this.a=2,this.d=G,this.f.fire())}}e.$Gh=ke;class Le extends ke{constructor(G,Y){super(Y),this.l=G}cancel(){this.l.cancel()}}e.$Hh=Le;function Ee(ge){const G=new S.$de,Y=ge(G.token);return new Le(G,async he=>{const fe=G.token.onCancellationRequested(()=>{fe.dispose(),G.dispose(),he.reject(new M.$5)});try{for await(const Oe of Y){if(G.token.isCancellationRequested)return;he.emitOne(Oe)}fe.dispose(),G.dispose()}catch(Oe){fe.dispose(),G.dispose(),he.reject(Oe)}})}e.$Ih=Ee;class be{constructor(){this.a=new $e,this.b=new ke(he=>{if(G){he.reject(G);return}return Y&&he.emitMany(Y),this.d=fe=>he.reject(fe),this.f=fe=>he.emitOne(fe),this.a.p});let G,Y;this.f=he=>{Y||(Y=[]),Y.push(he)},this.d=he=>{G||(G=he)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(G){this.d(G),this.a.complete()}emitOne(G){this.f(G)}}e.$Jh=be}),define(Pe[34],Re([1,0,18,11,45,28,19,21,15]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=void 0;function E(){return Object.create(null)}e.$Uj=E,e.$Vj="**",e.$Wj="/";const N="[/\\\\]",D="[^/\\\\]",l=/\//g;function k(ce,ye){switch(ce){case 0:return"";case 1:return`${D}*?`;default:return`(?:${N}|${D}+${N}${ye?`|${N}${D}+`:""})*?`}}function g(ce,ye){if(!ce)return[];const Ie=[];let ue=!1,ve=!1,re="";for(const $e of ce){switch($e){case ye:if(!ue&&!ve){Ie.push(re),re="";continue}break;case"{":ue=!0;break;case"}":ue=!1;break;case"[":ve=!0;break;case"]":ve=!1;break}re+=$e}return re&&Ie.push(re),Ie}e.$Xj=g;function s(ce){if(!ce)return"";let ye="";const Ie=g(ce,e.$Wj);if(Ie.every(ue=>ue===e.$Vj))ye=".*";else{let ue=!1;Ie.forEach((ve,re)=>{if(ve===e.$Vj){if(ue)return;ye+=k(2,re===Ie.length-1)}else{let $e=!1,ie="",le=!1,V="";for(const _ of ve){if(_!=="}"&&$e){ie+=_;continue}if(le&&(_!=="]"||!V)){let ke;_==="-"?ke=_:(_==="^"||_==="!")&&!V?ke="^":_===e.$Wj?ke="":ke=(0,f.$Ye)(_),V+=ke;continue}switch(_){case"{":$e=!0;continue;case"[":le=!0;continue;case"}":{const Le=`(?:${g(ie,",").map(Ee=>s(Ee)).join("|")})`;ye+=Le,$e=!1,ie="";break}case"]":{ye+="["+V+"]",le=!1,V="";break}case"?":ye+=D;continue;case"*":ye+=k(1);continue;default:ye+=(0,f.$Ye)(_)}}re<Ie.length-1&&(Ie[re+1]!==e.$Vj||re+2<Ie.length)&&(ye+=N)}ue=ve===e.$Vj})}return ye}const a=/^\*\*\/\*\.[\w\.-]+$/,r=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,d=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new F.$Dc(1e4),p=function(){return!1},u=function(){return null};function o(ce,ye){if(!ce)return u;let Ie;typeof ce!="string"?Ie=ce.pattern:Ie=ce,Ie=Ie.trim();const ue=`${Ie}_${!!ye.trimForExclusions}`;let ve=t.get(ue);if(ve)return v(ve,ce);let re;return a.test(Ie)?ve=$(Ie.substr(4),Ie):(re=r.exec(b(Ie,ye)))?ve=I(re[1],Ie):(ye.trimForExclusions?n:i).test(Ie)?ve=h(Ie,ye):(re=c.exec(b(Ie,ye)))?ve=y(re[1].substr(1),Ie,!0):(re=d.exec(b(Ie,ye)))?ve=y(re[1],Ie,!1):ve=w(Ie),t.set(ue,ve),v(ve,ce)}function v(ce,ye){if(typeof ye=="string")return ce;const Ie=function(ue,ve){return(0,P.$gg)(ue,ye.base,!m.$k)?ce((0,f.$4e)(ue.substr(ye.base.length),R.sep),ve):null};return Ie.allBasenames=ce.allBasenames,Ie.allPaths=ce.allPaths,Ie.basenames=ce.basenames,Ie.patterns=ce.patterns,Ie}function b(ce,ye){return ye.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function $(ce,ye){return function(Ie,ue){return typeof Ie=="string"&&Ie.endsWith(ce)?ye:null}}function I(ce,ye){const Ie=`/${ce}`,ue=`\\${ce}`,ve=function($e,ie){return typeof $e!="string"?null:ie?ie===ce?ye:null:$e===ce||$e.endsWith(Ie)||$e.endsWith(ue)?ye:null},re=[ce];return ve.basenames=re,ve.patterns=[ye],ve.allBasenames=re,ve}function h(ce,ye){const Ie=q(ce.slice(1,-1).split(",").map(ie=>o(ie,ye)).filter(ie=>ie!==u),ce),ue=Ie.length;if(!ue)return u;if(ue===1)return Ie[0];const ve=function(ie,le){for(let V=0,_=Ie.length;V<_;V++)if(Ie[V](ie,le))return ce;return null},re=Ie.find(ie=>!!ie.allBasenames);re&&(ve.allBasenames=re.allBasenames);const $e=Ie.reduce((ie,le)=>le.allPaths?ie.concat(le.allPaths):ie,[]);return $e.length&&(ve.allPaths=$e),ve}function y(ce,ye,Ie){const ue=R.sep===R.$gc.sep,ve=ue?ce:ce.replace(l,R.sep),re=R.sep+ve,$e=R.$gc.sep+ce;let ie;return Ie?ie=function(le,V){return typeof le=="string"&&(le===ve||le.endsWith(re)||!ue&&(le===ce||le.endsWith($e)))?ye:null}:ie=function(le,V){return typeof le=="string"&&(le===ve||!ue&&le===ce)?ye:null},ie.allPaths=[(Ie?"*/":"./")+ce],ie}function w(ce){try{const ye=new RegExp(`^${s(ce)}$`);return function(Ie){return ye.lastIndex=0,typeof Ie=="string"&&ye.test(Ie)?ce:null}}catch{return u}}function A(ce,ye,Ie){return!ce||typeof ye!="string"?!1:L(ce)(ye,void 0,Ie)}e.$Yj=A;function L(ce,ye={}){if(!ce)return p;if(typeof ce=="string"||J(ce)){const Ie=o(ce,ye);if(Ie===u)return p;const ue=function(ve,re){return!!Ie(ve,re)};return Ie.allBasenames&&(ue.allBasenames=Ie.allBasenames),Ie.allPaths&&(ue.allPaths=Ie.allPaths),ue}return C(ce,ye)}e.$Zj=L;function J(ce){const ye=ce;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}e.$1j=J;function W(ce){return ce.allBasenames||[]}e.$2j=W;function U(ce){return ce.allPaths||[]}e.$3j=U;function C(ce,ye){const Ie=q(Object.getOwnPropertyNames(ce).map(ie=>O(ie,ce[ie],ye)).filter(ie=>ie!==u)),ue=Ie.length;if(!ue)return u;if(!Ie.some(ie=>!!ie.requiresSiblings)){if(ue===1)return Ie[0];const ie=function(_,ke){let Le;for(let Ee=0,be=Ie.length;Ee<be;Ee++){const ge=Ie[Ee](_,ke);if(typeof ge=="string")return ge;(0,M.$5g)(ge)&&(Le||(Le=[]),Le.push(ge))}return Le?(async()=>{for(const Ee of Le){const be=await Ee;if(typeof be=="string")return be}return null})():null},le=Ie.find(_=>!!_.allBasenames);le&&(ie.allBasenames=le.allBasenames);const V=Ie.reduce((_,ke)=>ke.allPaths?_.concat(ke.allPaths):_,[]);return V.length&&(ie.allPaths=V),ie}const ve=function(ie,le,V){let _,ke;for(let Le=0,Ee=Ie.length;Le<Ee;Le++){const be=Ie[Le];be.requiresSiblings&&V&&(le||(le=(0,R.$nc)(ie)),_||(_=le.substr(0,le.length-(0,R.$oc)(ie).length)));const ge=be(ie,le,_,V);if(typeof ge=="string")return ge;(0,M.$5g)(ge)&&(ke||(ke=[]),ke.push(ge))}return ke?(async()=>{for(const Le of ke){const Ee=await Le;if(typeof Ee=="string")return Ee}return null})():null},re=Ie.find(ie=>!!ie.allBasenames);re&&(ve.allBasenames=re.allBasenames);const $e=Ie.reduce((ie,le)=>le.allPaths?ie.concat(le.allPaths):ie,[]);return $e.length&&(ve.allPaths=$e),ve}function O(ce,ye,Ie){if(ye===!1)return u;const ue=o(ce,Ie);if(ue===u)return u;if(typeof ye=="boolean")return ue;if(ye){const ve=ye.when;if(typeof ve=="string"){const re=($e,ie,le,V)=>{if(!V||!ue($e,ie))return null;const _=ve.replace("$(basename)",()=>le),ke=V(_);return(0,M.$5g)(ke)?ke.then(Le=>Le?ce:null):ke?ce:null};return re.requiresSiblings=!0,re}}return ue}function q(ce,ye){const Ie=ce.filter(ie=>!!ie.basenames);if(Ie.length<2)return ce;const ue=Ie.reduce((ie,le)=>{const V=le.basenames;return V?ie.concat(V):ie},[]);let ve;if(ye){ve=[];for(let ie=0,le=ue.length;ie<le;ie++)ve.push(ye)}else ve=Ie.reduce((ie,le)=>{const V=le.patterns;return V?ie.concat(V):ie},[]);const re=function(ie,le){if(typeof ie!="string")return null;if(!le){let _;for(_=ie.length;_>0;_--){const ke=ie.charCodeAt(_-1);if(ke===47||ke===92)break}le=ie.substr(_)}const V=ue.indexOf(le);return V!==-1?ve[V]:null};re.basenames=ue,re.patterns=ve,re.allBasenames=ue;const $e=ce.filter(ie=>!ie.basenames);return $e.push(re),$e}function ne(ce,ye){return(0,S.$ub)(ce,ye,(Ie,ue)=>typeof Ie=="string"&&typeof ue=="string"?Ie===ue:typeof Ie!="string"&&typeof ue!="string"?Ie.base===ue.base&&Ie.pattern===ue.pattern:!1)}e.$4j=ne}),define(Pe[53],Re([1,0,14,129,24,15,2]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class f{constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,S.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=l(this.supportThemeIcons?(0,M.$rk)(i):i).replace(/([ \t]+)/g,(c,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${k(n,i)}
`,this}appendLink(i,n,c){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(i,n){const c=new RegExp((0,F.$Ye)(n),"g");return i.replace(c,(d,t)=>i.charAt(t-1)!=="\\"?`\\${d}`:d)}}e.$xk=f;function E(r){return N(r)?!r.value:Array.isArray(r)?r.every(E):!0}e.$yk=E;function N(r){return r instanceof f?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||typeof r.isTrusted=="object"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.$zk=N;function D(r,i){return r===i?!0:!r||!i?!1:r.value===i.value&&r.isTrusted===i.isTrusted&&r.supportThemeIcons===i.supportThemeIcons&&r.supportHtml===i.supportHtml&&(r.baseUri===i.baseUri||!!r.baseUri&&!!i.baseUri&&(0,P.$Mg)(R.URI.from(r.baseUri),R.URI.from(i.baseUri)))}e.$Ak=D;function l(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$Bk=l;function k(r,i){const n=r.match(/^`+/gm)?.reduce((d,t)=>d.length>t.length?d:t).length??0,c=n>=3?n+1:3;return[`${"`".repeat(c)}${i}`,r,`${"`".repeat(c)}`].join(`
`)}e.$Ck=k;function g(r){return r.replace(/"/g,"&quot;")}e.$Dk=g;function s(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$Ek=s;function a(r){const i=[],n=r.split("|").map(d=>d.trim());r=n[0];const c=n[1];if(c){const d=/height=(\d+)/.exec(c),t=/width=(\d+)/.exec(c),p=d?d[1]:"",u=t?t[1]:"",o=isFinite(parseInt(u)),v=isFinite(parseInt(p));o&&i.push(`width="${u}"`),v&&i.push(`height="${p}"`)}return{href:r,dimensions:i}}e.$Fk=a}),define(Pe[96],Re([1,0,18,45,19,21,24,15]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iw=e.$hw=e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=void 0;function f(o,v){const{os:b,tildify:$,relative:I}=v;if(I){const w=E(o,I,b);if(typeof w=="string")return w}let h=o.fsPath;if(b===1&&!F.$i?h=h.replace(/\//g,"\\"):b!==1&&F.$i&&(h=h.replace(/\\/g,"/")),b!==1&&$?.userHome){const w=$.userHome.fsPath;let A;o.scheme!==$.userHome.scheme&&o.path[0]===P.$gc.sep&&o.path[1]!==P.$gc.sep?A=$.userHome.with({path:o.path}).fsPath:A=h,h=l(A,w,b)}return(b===1?P.$fc:P.$gc).normalize(N(h,b===1))}e.$_v=f;function E(o,v,b){const $=b===1?P.$fc:P.$gc,I=b===3?R.$Jg:R.$Lg,h=v.getWorkspace(),y=(0,S.$Ob)(h.folders);if(!y)return;o.scheme!==y.uri.scheme&&o.path[0]===P.$gc.sep&&o.path[1]!==P.$gc.sep&&(o=y.uri.with({path:o.path}));const w=v.getWorkspaceFolder(o);if(!w)return;let A;if(I.isEqual(w.uri,o)?A="":A=I.relativePath(w.uri,o)??"",A&&(A=$.normalize(A)),h.folders.length>1&&!v.noPrefix){const L=w.name?w.name:I.basenameOrAuthority(w.uri);A=A?`${L} \u2022 ${A}`:L}return A}function N(o,v=F.$i){return(0,M.$kg)(o,v)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$aw=N;let D=Object.create(null);function l(o,v,b=F.OS){if(b===1||!o||!v)return o;let $=D.original===v?D.normalized:void 0;$||($=v,F.$i&&($=(0,M.$ag)($)),$=`${(0,m.$5e)($,P.$gc.sep)}${P.$gc.sep}`,D={original:v,normalized:$});let I=o;return F.$i&&(I=(0,M.$ag)(I)),(b===3?I.startsWith($):(0,m.$lf)(I,$))?`~/${I.substr($.length)}`:o}e.$bw=l;function k(o,v){return o.replace(/^~($|\/|\\)/,`${v}$1`)}e.$cw=k;const g="\u2026",s="\\\\",a="~";function r(o,v=P.sep){const b=new Array(o.length);let $=!1;for(let I=0;I<o.length;I++){const h=o[I];if(h===""){b[I]=`.${v}`;continue}if(!h){b[I]=h;continue}$=!0;let y="",w=h;w.indexOf(s)===0?(y=w.substr(0,w.indexOf(s)+s.length),w=w.substr(w.indexOf(s)+s.length)):w.indexOf(v)===0?(y=w.substr(0,w.indexOf(v)+v.length),w=w.substr(w.indexOf(v)+v.length)):w.indexOf(a)===0&&(y=w.substr(0,w.indexOf(a)+a.length),w=w.substr(w.indexOf(a)+a.length));const A=w.split(v);for(let L=1;$&&L<=A.length;L++)for(let J=A.length-L;$&&J>=0;J--){$=!1;let W=A.slice(J,J+L).join(v);for(let U=0;!$&&U<o.length;U++)if(U!==I&&o[U]&&o[U].indexOf(W)>-1){const C=J+L===A.length,O=J>0&&o[U].indexOf(v)>-1?v+W:W,q=o[U].endsWith(O);$=!C||q}if(!$){let U="";(A[0].endsWith(":")||y!=="")&&(J===1&&(J=0,L++,W=A[0]+v+W),J>0&&(U=A[0]+v),U=y+U),J>0&&(U=U+g+v),U=U+W,J+L<A.length&&(U=U+v+g),b[I]=U}}$&&(b[I]=h)}return b}e.$dw=r;var i;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(o,v=Object.create(null)){const b=[];let $=!1,I="";for(const h of o)if(h==="$"||$&&h==="{")I&&b.push({value:I,type:i.TEXT}),I="",$=!0;else if(h==="}"&&$){const y=v[I];if(typeof y=="string")y.length&&b.push({value:y,type:i.VARIABLE});else if(y){const w=b[b.length-1];(!w||w.type!==i.SEPARATOR)&&b.push({value:y.label,type:i.SEPARATOR})}I="",$=!1}else I+=h;return I&&!$&&b.push({value:I,type:i.TEXT}),b.filter((h,y)=>{if(h.type===i.SEPARATOR){const w=b[y-1],A=b[y+1];return[w,A].every(L=>L&&(L.type===i.VARIABLE||L.type===i.TEXT)&&L.value.length>0)}return!0}).map(h=>h.value).join("")}e.$ew=n;function c(o,v){return F.$j||v?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.$j?"&":"&&"):o.replace(/&&|&/g,b=>b==="&"?"&&":"&")}e.$fw=c;function d(o,v){return F.$j||v?o.replace(/\(&&\w\)|&&/g,""):F.$i?o.replace(/&&|&/g,b=>b==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$gw=d;function t(o){return o.replace(/&/g,"&&")}e.$hw=t;function p(o){if(o.endsWith("]")){const v=o.lastIndexOf(" [",o.length-2);if(v!==-1){const b=u(o.substring(0,v)),$=o.substring(v);return{name:b.name+$,parentPath:b.parentPath}}}return u(o)}e.$iw=p;function u(o){const v=o.indexOf("/")!==-1?P.$gc:P.$fc,b=v.basename(o),$=v.dirname(o);return b.length?{name:b,parentPath:$}:{name:$,parentPath:""}}}),define(Pe[142],Re([1,0,23,2]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=void 0;function P(D){return D.toJSON()}class F{constructor(l){this.a=l}transformIncoming(l){const k=this.a.transformIncoming(l);return k===l?l:P(M.URI.from(k))}transformOutgoing(l){const k=this.a.transformOutgoing(l);return k===l?l:P(M.URI.from(k))}transformOutgoingURI(l){const k=this.a.transformOutgoing(l);return k===l?l:M.URI.from(k)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$hn=F,e.$in=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function R(D,l,k){if(!D||k>200)return null;if(typeof D=="object"){if(D instanceof M.URI)return l.transformOutgoing(D);for(const g in D)if(Object.hasOwnProperty.call(D,g)){const s=R(D[g],l,k+1);s!==null&&(D[g]=s)}}return null}function m(D,l){const k=R(D,l,0);return k===null?D:k}e.$jn=m;function f(D,l,k,g){if(!D||g>200)return null;if(typeof D=="object"){if(D.$mid===1)return k?M.URI.revive(l.transformIncoming(D)):l.transformIncoming(D);if(D instanceof S.$te)return null;for(const s in D)if(Object.hasOwnProperty.call(D,s)){const a=f(D[s],l,k,g+1);a!==null&&(D[s]=a)}}return null}function E(D,l){const k=f(D,l,!1,0);return k===null?D:k}e.$kn=E;function N(D,l){const k=f(D,l,!0,0);return k===null?D:k}e.$ln=N}),define(Pe[143],Re([1,0,15,21,23]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=e.$qt=e.$pt=void 0;let F;function R(){return F||(F=new TextDecoder("UTF-16LE")),F}let m;function f(){return m||(m=new TextDecoder("UTF-16BE")),m}let E;function N(){return E||(E=M.$D()?R():f()),E}e.$pt=N;function D(g,s,a){const r=new Uint16Array(g.buffer,s,a);return a>0&&(r[0]===65279||r[0]===65534)?l(g,s,a):R().decode(r)}e.$qt=D;function l(g,s,a){const r=[];let i=0;for(let n=0;n<a;n++){const c=P.$ve(g,s);s+=2,r[i++]=String.fromCharCode(c)}return r.join("")}class k{constructor(s){this.a=s|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const s=new Uint16Array(this.b.buffer,0,this.d);return N().decode(s)}f(){const s=this.e();this.d=0,this.c===null?this.c=[s]:this.c[this.c.length]=s}appendCharCode(s){const a=this.a-this.d;a<=1&&(a===0||S.$of(s))&&this.f(),this.b[this.d++]=s}appendASCIICharCode(s){this.d===this.a&&this.f(),this.b[this.d++]=s}appendString(s){const a=s.length;if(this.d+a>=this.a){this.f(),this.c[this.c.length]=s;return}for(let r=0;r<a;r++)this.b[this.d++]=s.charCodeAt(r)}}e.$rt=k}),define(Pe[144],Re([1,0,23,143]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$st=void 0;function P(f){return f.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class F{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,N,D,l){this.oldPosition=E,this.oldText=N,this.newPosition=D,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,N,D){const l=N.length;S.$ye(E,l,D),D+=4;for(let k=0;k<l;k++)S.$we(E,N.charCodeAt(k),D),D+=2;return D}static d(E,N){const D=S.$xe(E,N);return N+=4,(0,M.$qt)(E,N,D)}writeSize(){return 8+F.a(this.oldText)+F.a(this.newText)}write(E,N){return S.$ye(E,this.oldPosition,N),N+=4,S.$ye(E,this.newPosition,N),N+=4,N=F.c(E,this.oldText,N),N=F.c(E,this.newText,N),N}static read(E,N,D){const l=S.$xe(E,N);N+=4;const k=S.$xe(E,N);N+=4;const g=F.d(E,N);N+=F.a(g);const s=F.d(E,N);return N+=F.a(s),D.push(new F(l,g,k,s)),N}}e.$st=F;function R(f,E){return f===null||f.length===0?E:new m(f,E).compress()}e.$tt=R;class m{constructor(E,N){this.a=E,this.c=N,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,N=0,D=this.n(E),l=this.l(N);for(;E<this.f||N<this.h;){if(D===null){this.k(l),l=this.l(++N);continue}if(l===null){this.m(D),D=this.n(++E);continue}if(l.oldEnd<=D.newPosition){this.k(l),l=this.l(++N);continue}if(D.newEnd<=l.oldPosition){this.m(D),D=this.n(++E);continue}if(l.oldPosition<D.newPosition){const[r,i]=m.r(l,D.newPosition-l.oldPosition);this.k(r),l=i;continue}if(D.newPosition<l.oldPosition){const[r,i]=m.q(D,l.oldPosition-D.newPosition);this.m(r),D=i;continue}let s,a;if(l.oldEnd===D.newEnd)s=D,a=l,D=this.n(++E),l=this.l(++N);else if(l.oldEnd<D.newEnd){const[r,i]=m.q(D,l.oldLength);s=r,a=l,D=i,l=this.l(++N)}else{const[r,i]=m.r(l,D.newLength);s=D,a=r,D=this.n(++E),l=i}this.d[this.e++]=new F(s.oldPosition,s.oldText,a.newPosition,a.newText),this.g+=s.newLength-s.oldLength,this.j+=a.newLength-a.oldLength}const k=m.s(this.d);return m.t(k)}k(E){this.d[this.e++]=m.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=m.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,N){return new F(N.oldPosition-E,N.oldText,N.newPosition,N.newText)}static p(E,N){return new F(N.oldPosition,N.oldText,N.newPosition+E,N.newText)}static q(E,N){const D=E.newText.substr(0,N),l=E.newText.substr(N);return[new F(E.oldPosition,E.oldText,E.newPosition,D),new F(E.oldEnd,"",E.newPosition+N,l)]}static r(E,N){const D=E.oldText.substr(0,N),l=E.oldText.substr(N);return[new F(E.oldPosition,D,E.newPosition,E.newText),new F(E.oldPosition+N,l,E.newEnd,"")]}static s(E){if(E.length===0)return E;const N=[];let D=0,l=E[0];for(let k=1;k<E.length;k++){const g=E[k];l.oldEnd===g.oldPosition?l=new F(l.oldPosition,l.oldText+g.oldText,l.newPosition,l.newText+g.newText):(N[D++]=l,l=g)}return N[D++]=l,N}static t(E){if(E.length===0)return E;const N=[];let D=0;for(let l=0;l<E.length;l++){const k=E[l];k.oldText!==k.newText&&(N[D++]=k)}return N}}}),define(Pe[145],Re([1,0,34,19]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rt=e.$Qt=void 0;function P(R,m,f,E,N,D){if(Array.isArray(R)){let l=0;for(const k of R){const g=P(k,m,f,E,N,D);if(g===10)return g;g>l&&(l=g)}return l}else{if(typeof R=="string")return E?R==="*"?5:R===f?10:0:0;if(R){const{language:l,pattern:k,scheme:g,hasAccessToAllModels:s,notebookType:a}=R;if(!E&&!s)return 0;a&&N&&(m=N);let r=0;if(g)if(g===m.scheme)r=10;else if(g==="*")r=5;else return 0;if(l)if(l===f)r=10;else if(l==="*")r=Math.max(r,5);else return 0;if(a)if(a===D)r=10;else if(a==="*"&&D!==void 0)r=Math.max(r,5);else return 0;if(k){let i;if(typeof k=="string"?i=k:i={...k,base:(0,M.$hc)(k.base)},i===m.fsPath||(0,S.$Yj)(i,m.fsPath))r=10;else return 0}return r}else return 0}}e.$Qt=P;function F(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(F):!!R.notebookType}e.$Rt=F}),define(Pe[146],Re([1,0,5,15,29,94,92,131,144,6]),function(me,e,S,M,P,F,R,m,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rC=void 0;class N extends E.$Tc{constructor(l,k,g,s,a,r,i){super(),this.m=this.B(new S.$6d),this.onDidChangeContent=this.m.event,this.f=k,this.j=!r,this.g=s,this.h=a,this.c=new R.$qC(l,g,i)}equals(l){return!(l instanceof N)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,k){return this.c.getOffsetAt(l,k)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,k){const g=l+k,s=this.getPositionAt(l),a=this.getPositionAt(g);return new P.$0s(s.lineNumber,s.column,a.lineNumber,a.column)}getValueInRange(l,k=0){if(l.isEmpty())return"";const g=this.n(k);return this.c.getValueInRange(l,g)}getValueLengthInRange(l,k=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const g=this.getOffsetAt(l.startLineNumber,l.startColumn),s=this.getOffsetAt(l.endLineNumber,l.endColumn);let a=0;const r=this.n(k),i=this.getEOL();if(r.length!==i.length){const n=r.length-i.length,c=l.endLineNumber-l.startLineNumber;a=n*c}return s-g+a}getCharacterCountInRange(l,k=0){if(this.j){let g=0;const s=l.startLineNumber,a=l.endLineNumber;for(let r=s;r<=a;r++){const i=this.getLineContent(r),n=r===s?l.startColumn-1:0,c=r===a?l.endColumn-1:i.length;for(let d=n;d<c;d++)M.$of(i.charCodeAt(d))?(g=g+1,d=d+1):g=g+1}return g+=this.n(k).length*(a-s),g}return this.getValueLengthInRange(l,k)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,k){return this.c.getLineCharCode(l,k)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const k=M.$_e(this.getLineContent(l));return k===-1?0:k+1}getLineLastNonWhitespaceColumn(l){const k=M.$bf(this.getLineContent(l));return k===-1?0:k+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,k,g){let s=this.g,a=this.h,r=this.j,i=!0,n=[];for(let v=0;v<l.length;v++){const b=l[v];i&&b._isTracked&&(i=!1);const $=b.range;if(b.text){let A=!0;r||(A=!M.$zf(b.text),r=A),!s&&A&&(s=M.$yf(b.text)),!a&&A&&(a=M.$Bf(b.text))}let I="",h=0,y=0,w=0;if(b.text){let A;[h,y,w,A]=(0,m.$Jt)(b.text);const L=this.getEOL();A===0||A===(L===`\r
`?2:1)?I=b.text:I=b.text.replace(/\r\n|\r|\n/g,L)}n[v]={sortIndex:v,identifier:b.identifier||null,range:$,rangeOffset:this.getOffsetAt($.startLineNumber,$.startColumn),rangeLength:this.getValueLengthInRange($),text:I,eolCount:h,firstLineLength:y,lastLineLength:w,forceMoveMarkers:!!b.forceMoveMarkers,isAutoWhitespaceEdit:b.isAutoWhitespaceEdit||!1}}n.sort(N.u);let c=!1;for(let v=0,b=n.length-1;v<b;v++){const $=n[v].range.getEndPosition(),I=n[v+1].range.getStartPosition();if(I.isBeforeOrEqual($)){if(I.isBefore($))throw new Error("Overlapping ranges are not allowed!");c=!0}}i&&(n=this.s(n));const d=g||k?N._getInverseEditRanges(n):[],t=[];if(k)for(let v=0;v<n.length;v++){const b=n[v],$=d[v];if(b.isAutoWhitespaceEdit&&b.range.isEmpty())for(let I=$.startLineNumber;I<=$.endLineNumber;I++){let h="";I===$.startLineNumber&&(h=this.getLineContent(b.range.startLineNumber),M.$_e(h)!==-1)||t.push({lineNumber:I,oldContent:h})}}let p=null;if(g){let v=0;p=[];for(let b=0;b<n.length;b++){const $=n[b],I=d[b],h=this.getValueInRange($.range),y=$.rangeOffset+v;v+=$.text.length-h.length,p[b]={sortIndex:$.sortIndex,identifier:$.identifier,range:I,text:h,textChange:new f.$st($.rangeOffset,h,y,$.text)}}c||p.sort((b,$)=>b.sortIndex-$.sortIndex)}this.g=s,this.h=a,this.j=r;const u=this.t(n);let o=null;if(k&&t.length>0){t.sort((v,b)=>b.lineNumber-v.lineNumber),o=[];for(let v=0,b=t.length;v<b;v++){const $=t[v].lineNumber;if(v>0&&t[v-1].lineNumber===$)continue;const I=t[v].oldContent,h=this.getLineContent($);h.length===0||h===I||M.$_e(h)!==-1||o.push($)}}return this.m.fire(),new F.$uv(p,u,o)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let k=!1;const g=l[0].range,s=l[l.length-1].range,a=new P.$0s(g.startLineNumber,g.startColumn,s.endLineNumber,s.endColumn);let r=g.startLineNumber,i=g.startColumn;const n=[];for(let u=0,o=l.length;u<o;u++){const v=l[u],b=v.range;k=k||v.forceMoveMarkers,n.push(this.getValueInRange(new P.$0s(r,i,b.startLineNumber,b.startColumn))),v.text.length>0&&n.push(v.text),r=b.endLineNumber,i=b.endColumn}const c=n.join(""),[d,t,p]=(0,m.$Jt)(c);return{sortIndex:0,identifier:l[0].identifier,range:a,rangeOffset:this.getOffsetAt(a.startLineNumber,a.startColumn),rangeLength:this.getValueLengthInRange(a,0),text:c,eolCount:d,firstLineLength:t,lastLineLength:p,forceMoveMarkers:k,isAutoWhitespaceEdit:!1}}t(l){l.sort(N.w);const k=[];for(let g=0;g<l.length;g++){const s=l[g],a=s.range.startLineNumber,r=s.range.startColumn,i=s.range.endLineNumber,n=s.range.endColumn;if(a===i&&r===n&&s.text.length===0)continue;s.text?(this.c.delete(s.rangeOffset,s.rangeLength),this.c.insert(s.rangeOffset,s.text,!0)):this.c.delete(s.rangeOffset,s.rangeLength);const c=new P.$0s(a,r,i,n);k.push({range:c,rangeLength:s.rangeLength,text:s.text,rangeOffset:s.rangeOffset,forceMoveMarkers:s.forceMoveMarkers})}return k}findMatchesLineByLine(l,k,g,s){return this.c.findMatchesLineByLine(l,k,g,s)}getPieceTree(){return this.c}static _getInverseEditRange(l,k){const g=l.startLineNumber,s=l.startColumn,[a,r,i]=(0,m.$Jt)(k);let n;if(k.length>0){const c=a+1;c===1?n=new P.$0s(g,s,g,s+r):n=new P.$0s(g,s,g+c-1,i+1)}else n=new P.$0s(g,s,g,s);return n}static _getInverseEditRanges(l){const k=[];let g=0,s=0,a=null;for(let r=0,i=l.length;r<i;r++){const n=l[r];let c,d;a?a.range.endLineNumber===n.range.startLineNumber?(c=g,d=s+(n.range.startColumn-a.range.endColumn)):(c=g+(n.range.startLineNumber-a.range.endLineNumber),d=n.range.startColumn):(c=n.range.startLineNumber,d=n.range.startColumn);let t;if(n.text.length>0){const p=n.eolCount+1;p===1?t=new P.$0s(c,d,c,d+n.firstLineLength):t=new P.$0s(c,d,c+p-1,n.lastLineLength+1)}else t=new P.$0s(c,d,c,d);g=t.endLineNumber,s=t.endColumn,k.push(t),a=n}return k}static u(l,k){const g=P.$0s.compareRangesUsingEnds(l.range,k.range);return g===0?l.sortIndex-k.sortIndex:g}static w(l,k){const g=P.$0s.compareRangesUsingEnds(l.range,k.range);return g===0?k.sortIndex-l.sortIndex:-g}}e.$rC=N}),define(Pe[147],Re([1,0,15,92,146]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sC=void 0;class F{constructor(f,E,N,D,l,k,g,s,a){this.a=f,this.b=E,this.c=N,this.d=D,this.e=l,this.f=k,this.g=g,this.h=s,this.j=a}k(f){const E=this.c+this.d+this.e,N=this.c+this.e;return E===0?f===1?`
`:`\r
`:N>E/2?`\r
`:`
`}create(f){const E=this.k(f),N=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let l=0,k=N.length;l<k;l++){const g=N[l].buffer.replace(/\r\n|\r|\n/g,E),s=(0,M.$mC)(g);N[l]=new M.$pC(g,s)}const D=new P.$rC(N,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:D,disposable:D}}getFirstLineText(f){return this.a[0].buffer.substr(0,f).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(f){if(f.length===0)return;this.a.length===0&&S.$Hf(f)&&(this.b=S.$Gf,f=f.substr(1));const E=f.charCodeAt(f.length-1);E===13||E>=55296&&E<=56319?(this.m(f.substr(0,f.length-1),!1),this.c=!0,this.d=E):(this.m(f,!1),this.c=!1,this.d=E)}m(f,E){!E&&f.length===0||(this.c?this.n(String.fromCharCode(this.d)+f):this.n(f))}n(f){const E=(0,M.$nC)(this.e,f);this.a.push(new M.$pC(f,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=S.$yf(f)),this.k||(this.k=S.$Bf(f)))}finish(f=!0){return this.o(),new F(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,f)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const f=this.a[this.a.length-1];f.buffer+=String.fromCharCode(this.d);const E=(0,M.$mC)(f.buffer);f.lineStarts=E,this.d===13&&this.f++}}}e.$sC=R}),define(Pe[97],Re([1,0,23,21]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eab=e.$dab=void 0;var P;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(P||(P={}));function F(D){for(let l=0,k=D.length;l<k;l+=4){const g=D[l+0],s=D[l+1],a=D[l+2],r=D[l+3];D[l+0]=r,D[l+1]=a,D[l+2]=s,D[l+3]=g}}function R(D){const l=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return M.$D()||F(l),S.$te.wrap(l)}function m(D){const l=D.buffer;if(M.$D()||F(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const k=new Uint8Array(l.byteLength);return k.set(l),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function f(D){const l=new Uint32Array(E(D));let k=0;if(l[k++]=D.id,D.type==="full")l[k++]=1,l[k++]=D.data.length,l.set(D.data,k),k+=D.data.length;else{l[k++]=2,l[k++]=D.deltas.length;for(const g of D.deltas)l[k++]=g.start,l[k++]=g.deleteCount,g.data?(l[k++]=g.data.length,l.set(g.data,k),k+=g.data.length):l[k++]=0}return R(l)}e.$dab=f;function E(D){let l=0;if(l+=2,D.type==="full")l+=1+D.data.length;else{l+=1,l+=3*D.deltas.length;for(const k of D.deltas)k.data&&(l+=k.data.length)}return l}function N(D){const l=m(D);let k=0;const g=l[k++];if(l[k++]===1){const i=l[k++],n=l.subarray(k,k+i);return k+=i,{id:g,type:"full",data:n}}const a=l[k++],r=[];for(let i=0;i<a;i++){const n=l[k++],c=l[k++],d=l[k++];let t;d>0&&(t=l.subarray(k,k+d),k+=d),r[i]={start:n,deleteCount:c,data:t}}return{id:g,type:"delta",deltas:r}}e.$eab=N}),define(Pe[148],Re([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(Pe[149],Re([1,0,18,26,21,132,150,148]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var f;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(f||(e.EditorAutoIndentStrategy=f={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=E;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class D{constructor(Z,pe,We,Ze){this.id=Z,this.name=pe,this.defaultValue=We,this.schema=Ze}applyUpdate(Z,pe){return k(Z,pe)}compute(Z,pe,We){return We}}class l{constructor(Z,pe){this.newValue=Z,this.didChange=pe}}e.ApplyUpdateResult=l;function k(X,Z){if(typeof X!="object"||typeof Z!="object"||!X||!Z)return new l(Z,X!==Z);if(Array.isArray(X)||Array.isArray(Z)){const We=Array.isArray(X)&&Array.isArray(Z)&&S.$ub(X,Z);return new l(Z,!We)}let pe=!1;for(const We in Z)if(Z.hasOwnProperty(We)){const Ze=k(X[We],Z[We]);Ze.didChange&&(X[We]=Ze.newValue,pe=!0)}return new l(X,pe)}class g{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,pe){return k(Z,pe)}validate(Z){return this.defaultValue}}class s{constructor(Z,pe,We,Ze){this.id=Z,this.name=pe,this.defaultValue=We,this.schema=Ze}applyUpdate(Z,pe){return k(Z,pe)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,pe,We){return We}}function a(X,Z){return typeof X>"u"?Z:X==="false"?!1:!!X}e.boolean=a;class r extends s{constructor(Z,pe,We,Ze=void 0){typeof Ze<"u"&&(Ze.type="boolean",Ze.default=We),super(Z,pe,We,Ze)}validate(Z){return a(Z,this.defaultValue)}}function i(X,Z,pe,We){if(typeof X>"u")return Z;let Ze=parseInt(X,10);return isNaN(Ze)?Z:(Ze=Math.max(pe,Ze),Ze=Math.min(We,Ze),Ze|0)}e.clampedInt=i;class n extends s{static clampedInt(Z,pe,We,Ze){return i(Z,pe,We,Ze)}constructor(Z,pe,We,Ze,st,Me=void 0){typeof Me<"u"&&(Me.type="integer",Me.default=We,Me.minimum=Ze,Me.maximum=st),super(Z,pe,We,Me),this.minimum=Ze,this.maximum=st}validate(Z){return n.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function c(X,Z,pe,We){if(typeof X>"u")return Z;const Ze=d.float(X,Z);return d.clamp(Ze,pe,We)}e.clampedFloat=c;class d extends s{static clamp(Z,pe,We){return Z<pe?pe:Z>We?We:Z}static float(Z,pe){if(typeof Z=="number")return Z;if(typeof Z>"u")return pe;const We=parseFloat(Z);return isNaN(We)?pe:We}constructor(Z,pe,We,Ze,st){typeof st<"u"&&(st.type="number",st.default=We),super(Z,pe,We,st),this.validationFn=Ze}validate(Z){return this.validationFn(d.float(Z,this.defaultValue))}}class t extends s{static string(Z,pe){return typeof Z!="string"?pe:Z}constructor(Z,pe,We,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.default=We),super(Z,pe,We,Ze)}validate(Z){return t.string(Z,this.defaultValue)}}function p(X,Z,pe,We){return typeof X!="string"?Z:We&&X in We?We[X]:pe.indexOf(X)===-1?Z:X}e.stringSet=p;class u extends s{constructor(Z,pe,We,Ze,st=void 0){typeof st<"u"&&(st.type="string",st.enum=Ze,st.default=We),super(Z,pe,We,st),this.c=Ze}validate(Z){return p(Z,this.defaultValue,this.c)}}class o extends D{constructor(Z,pe,We,Ze,st,Me,Dt=void 0){typeof Dt<"u"&&(Dt.type="string",Dt.enum=st,Dt.default=Ze),super(Z,pe,We,Dt),this.c=st,this.d=Me}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function v(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class b extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,pe,We){return We===0?Z.accessibilitySupport:We}}class $ extends D{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:m.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertSpace:a(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:a(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function h(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var y;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(y||(e.TextEditorCursorStyle=y={}));function w(X){switch(X){case y.Line:return"line";case y.Block:return"block";case y.Underline:return"underline";case y.LineThin:return"line-thin";case y.BlockOutline:return"block-outline";case y.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function A(X){switch(X){case"line":return y.Line;case"block":return y.Block;case"underline":return y.Underline;case"line-thin":return y.LineThin;case"block-outline":return y.BlockOutline;case"underline-thin":return y.UnderlineThin}}class L extends g{constructor(){super(141)}compute(Z,pe,We){const Ze=["monaco-editor"];return pe.get(39)&&Ze.push(pe.get(39)),Z.extraEditorClassName&&Ze.push(Z.extraEditorClassName),pe.get(74)==="default"?Ze.push("mouse-default"):pe.get(74)==="copy"&&Ze.push("mouse-copy"),pe.get(111)&&Ze.push("showUnused"),pe.get(139)&&Ze.push("showDeprecated"),Ze.join(" ")}}class J extends r{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(Z,pe,We){return We&&Z.emptySelectionClipboard}}class W extends D{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:m.localize(16,null),included:P.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:m.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{cursorMoveOnType:a(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":p(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":p(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:a(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:a(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:a(pe.loop,this.defaultValue.loop)}}}class U extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"||Z.length===0?U.OFF:Z==="true"?U.ON:Z:Z?U.ON:U.OFF}}e.EditorFontLigatures=U;class C extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",C.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?C.OFF:Z==="true"?C.TRANSLATE:Z:Z?C.TRANSLATE:C.OFF}compute(Z,pe,We){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=C;class O extends g{constructor(){super(50)}compute(Z,pe,We){return Z.fontInfo}}class q extends s{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(Z){const pe=d.float(Z,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(pe,6,100)}compute(Z,pe,We){return Z.fontInfo.fontSize}}class ne extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ne.d,maximum:ne.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ne.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(n.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,ne.d,ne.e))}}class ce extends D{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},We=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:We,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:We,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:We,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:We,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:We,description:m.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{multiple:p(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??p(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??p(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??p(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??p(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??p(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends D{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:m.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:a(pe.enabled,this.defaultValue.enabled),delay:n.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:a(pe.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:a(pe.above,this.defaultValue.above)}}}var Ie;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(Ie||(e.RenderMinimap=Ie={}));class ue extends g{constructor(){super(144)}compute(Z,pe,We){return ue.computeLayout(pe,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const pe=Z.height/Z.lineHeight,We=Math.floor(Z.paddingTop/Z.lineHeight);let Ze=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(Ze=Math.max(Ze,pe-1));const st=(We+Z.viewLineCount+Ze)/(Z.pixelRatio*Z.height),Me=Math.floor(Z.viewLineCount/st);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:We,extraLinesBeyondLastLine:Ze,desiredRatio:st,minimapLineCount:Me}}static c(Z,pe){const We=Z.outerWidth,Ze=Z.outerHeight,st=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*Ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ze};const Me=pe.stableMinimapLayoutInput,Dt=Me&&Z.outerHeight===Me.outerHeight&&Z.lineHeight===Me.lineHeight&&Z.typicalHalfwidthCharacterWidth===Me.typicalHalfwidthCharacterWidth&&Z.pixelRatio===Me.pixelRatio&&Z.scrollBeyondLastLine===Me.scrollBeyondLastLine&&Z.paddingTop===Me.paddingTop&&Z.paddingBottom===Me.paddingBottom&&Z.minimap.enabled===Me.minimap.enabled&&Z.minimap.side===Me.minimap.side&&Z.minimap.size===Me.minimap.size&&Z.minimap.showSlider===Me.minimap.showSlider&&Z.minimap.renderCharacters===Me.minimap.renderCharacters&&Z.minimap.maxColumn===Me.minimap.maxColumn&&Z.minimap.scale===Me.minimap.scale&&Z.verticalScrollbarWidth===Me.verticalScrollbarWidth&&Z.isViewportWrapping===Me.isViewportWrapping,Qt=Z.lineHeight,jt=Z.typicalHalfwidthCharacterWidth,si=Z.scrollBeyondLastLine,Vt=Z.minimap.renderCharacters;let St=st>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Yt=Z.minimap.maxColumn,Wt=Z.minimap.size,oi=Z.minimap.side,xt=Z.verticalScrollbarWidth,Ye=Z.viewLineCount,Ot=Z.remainingWidth,_t=Z.isViewportWrapping,dt=Vt?2:3;let $t=Math.floor(st*Ze);const ei=$t/st;let qt=!1,Ht=!1,ht=dt*St,Mt=St/st,ti=1;if(Wt==="fill"||Wt==="fit"){const{typicalViewportLineCount:It,extraLinesBeforeFirstLine:Ct,extraLinesBeyondLastLine:Lt,desiredRatio:ai,minimapLineCount:Ut}=ue.computeContainedMinimapLineCount({viewLineCount:Ye,scrollBeyondLastLine:si,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:Ze,lineHeight:Qt,pixelRatio:st});if(Ye/Ut>1)qt=!0,Ht=!0,St=1,ht=1,Mt=St/st;else{let bt=!1,Ft=St+1;if(Wt==="fit"){const Bt=Math.ceil((Ct+Ye+Lt)*ht);_t&&Dt&&Ot<=pe.stableFitRemainingWidth?(bt=!0,Ft=pe.stableFitMaxMinimapScale):bt=Bt>$t}if(Wt==="fill"||bt){qt=!0;const Bt=St;ht=Math.min(Qt*st,Math.max(1,Math.floor(1/ai))),_t&&Dt&&Ot<=pe.stableFitRemainingWidth&&(Ft=pe.stableFitMaxMinimapScale),St=Math.min(Ft,Math.max(1,Math.floor(ht/dt))),St>Bt&&(ti=Math.min(2,St/Bt)),Mt=St/st/ti,$t=Math.ceil(Math.max(It,Ct+Ye+Lt)*ht),_t?(pe.stableMinimapLayoutInput=Z,pe.stableFitRemainingWidth=Ot,pe.stableFitMaxMinimapScale=St):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const ii=Math.floor(Yt*Mt),Ke=Math.min(ii,Math.max(0,Math.floor((Ot-xt-2)*Mt/(jt+Mt)))+e.MINIMAP_GUTTER_WIDTH);let Nt=Math.floor(st*Ke);const zt=Nt/st;Nt=Math.floor(Nt*ti);const Zt=Vt?1:2,mt=oi==="left"?0:We-Ke-xt;return{renderMinimap:Zt,minimapLeft:mt,minimapWidth:Ke,minimapHeightIsEditorHeight:qt,minimapIsSampling:Ht,minimapScale:St,minimapLineHeight:ht,minimapCanvasInnerWidth:Nt,minimapCanvasInnerHeight:$t,minimapCanvasOuterWidth:zt,minimapCanvasOuterHeight:ei}}static computeLayout(Z,pe){const We=pe.outerWidth|0,Ze=pe.outerHeight|0,st=pe.lineHeight|0,Me=pe.lineNumbersDigitCount|0,Dt=pe.typicalHalfwidthCharacterWidth,Qt=pe.maxDigitWidth,jt=pe.pixelRatio,si=pe.viewLineCount,Vt=Z.get(136),St=Vt==="inherit"?Z.get(135):Vt,Yt=St==="inherit"?Z.get(131):St,Wt=Z.get(134),oi=pe.isDominatedByLongLines,xt=Z.get(57),Ye=Z.get(68).renderType!==0,Ot=Z.get(69),_t=Z.get(105),dt=Z.get(84),$t=Z.get(73),ei=Z.get(103),qt=ei.verticalScrollbarSize,Ht=ei.verticalHasArrows,ht=ei.arrowSize,Mt=ei.horizontalScrollbarSize,ti=Z.get(43),ii=Z.get(110)!=="never";let Ke=Z.get(66);ti&&ii&&(Ke+=16);let Nt=0;if(Ye){const wt=Math.max(Me,Ot);Nt=Math.round(wt*Qt)}let zt=0;xt&&(zt=st*pe.glyphMarginDecorationLaneCount);let Zt=0,mt=Zt+zt,It=mt+Nt,Ct=It+Ke;const Lt=We-zt-Nt-Ke;let ai=!1,Ut=!1,Xt=-1;St==="inherit"&&oi?(ai=!0,Ut=!0):Yt==="on"||Yt==="bounded"?Ut=!0:Yt==="wordWrapColumn"&&(Xt=Wt);const bt=ue.c({outerWidth:We,outerHeight:Ze,lineHeight:st,typicalHalfwidthCharacterWidth:Dt,pixelRatio:jt,scrollBeyondLastLine:_t,paddingTop:dt.top,paddingBottom:dt.bottom,minimap:$t,verticalScrollbarWidth:qt,viewLineCount:si,remainingWidth:Lt,isViewportWrapping:Ut},pe.memory||new N);bt.renderMinimap!==0&&bt.minimapLeft===0&&(Zt+=bt.minimapWidth,mt+=bt.minimapWidth,It+=bt.minimapWidth,Ct+=bt.minimapWidth);const Ft=Lt-bt.minimapWidth,Bt=Math.max(1,Math.floor((Ft-qt-2)/Dt)),Tt=Ht?ht:0;return Ut&&(Xt=Math.max(1,Bt),Yt==="bounded"&&(Xt=Math.min(Xt,Wt))),{width:We,height:Ze,glyphMarginLeft:Zt,glyphMarginWidth:zt,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:mt,lineNumbersWidth:Nt,decorationsLeft:It,decorationsWidth:Ke,contentLeft:Ct,contentWidth:Ft,minimap:bt,viewportColumn:Bt,isWordWrapMinified:ai,isViewportWrapping:Ut,wrappingColumn:Xt,verticalScrollbarWidth:qt,horizontalScrollbarHeight:Mt,overviewRuler:{top:Tt,width:qt,height:Ze-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=ue;class ve extends D{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(Z){return p(Z,"simple",["simple","advanced"])}compute(Z,pe,We){return pe.get(2)===2?"advanced":We}}var re;(function(X){X.Off="off",X.OnCode="onCode",X.On="on"})(re||(e.ShowLightbulbIconMode=re={}));class $e extends D{constructor(){const Z={enabled:re.OnCode};super(65,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[re.Off,re.OnCode,re.On],default:Z.enabled,enumDescriptions:[m.localize(50,null),m.localize(51,null),m.localize(52,null)],description:m.localize(53,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:p(Z.enabled,this.defaultValue.enabled,[re.Off,re.OnCode,re.On])}}}class ie extends D{constructor(){const Z={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:m.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:20,description:m.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:m.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:m.localize(57,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:a(pe.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:p(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:a(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class le extends D{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:m.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(59,null),m.localize(60,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(61,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:m.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:m.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:m.localize(65,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:p(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily),padding:a(pe.padding,this.defaultValue.padding)}}}class V extends D{constructor(){super(66,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):n.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,pe,We){return We<0?n.clampedInt(-We*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):We}}class _ extends d{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>d.clamp(Z,0,150),{markdownDescription:m.localize(66,null)})}compute(Z,pe,We){return Z.fontInfo.lineHeight}}class ke extends D{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(73,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:m.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:m.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(69,null),m.localize(70,null),m.localize(71,null)],default:Z.size,description:m.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:m.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:m.localize(74,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:m.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:m.localize(77,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:a(pe.enabled,this.defaultValue.enabled),autohide:a(pe.autohide,this.defaultValue.autohide),size:p(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:p(pe.side,this.defaultValue.side,["right","left"]),showSlider:p(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:a(pe.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(pe.scale,1,1,3),maxColumn:n.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Le(X){return X==="ctrlCmd"?P.$j?"metaKey":"ctrlKey":"altKey"}class Ee extends D{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(79,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{top:n.clampedInt(pe.top,0,0,1e3),bottom:n.clampedInt(pe.bottom,0,0,1e3)}}}class be extends D{constructor(){const Z={enabled:!0,cycle:!0};super(86,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:m.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:m.localize(81,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:a(pe.enabled,this.defaultValue.enabled),cycle:a(pe.cycle,this.defaultValue.cycle)}}}class ge extends g{constructor(){super(142)}compute(Z,pe,We){return Z.pixelRatio}}class G extends D{constructor(){const Z={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(82,null),m.localize(83,null),m.localize(84,null)]}];super(89,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:Z.strings,description:m.localize(85,null)},comments:{anyOf:pe,default:Z.comments,description:m.localize(86,null)},other:{anyOf:pe,default:Z.other,description:m.localize(87,null)}},default:Z,markdownDescription:m.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const jt=Z?"on":"off";return{comments:jt,strings:jt,other:jt}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:pe,comments:We,strings:Ze}=Z,st=["on","inline","off"];let Me,Dt,Qt;return typeof pe=="boolean"?Me=pe?"on":"off":Me=p(pe,this.defaultValue.other,st),typeof We=="boolean"?Dt=We?"on":"off":Dt=p(We,this.defaultValue.comments,st),typeof Ze=="boolean"?Qt=Ze?"on":"off":Qt=p(Ze,this.defaultValue.strings,st),{other:Me,comments:Dt,strings:Qt}}}var Y;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class he extends D{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(89,null),m.localize(90,null),m.localize(91,null),m.localize(92,null)],default:"on",description:m.localize(93,null)})}validate(Z){let pe=this.defaultValue.renderType,We=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(pe=4,We=Z):Z==="interval"?pe=3:Z==="relative"?pe=2:Z==="on"?pe=1:pe=0),{renderType:pe,renderFn:We}}}function fe(X){const Z=X.get(98);return Z==="editable"?X.get(91):Z!=="on"}e.filterValidationDecorations=fe;class Oe extends D{constructor(){const Z=[],pe={type:"number",description:m.localize(94,null)};super(102,"rulers",Z,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:m.localize(95,null),format:"color-hex"}}}]},default:Z,description:m.localize(96,null)})}validate(Z){if(Array.isArray(Z)){const pe=[];for(const We of Z)if(typeof We=="number")pe.push({column:n.clampedInt(We,0,0,1e4),color:null});else if(We&&typeof We=="object"){const Ze=We;pe.push({column:n.clampedInt(Ze.column,0,0,1e4),color:Ze.color})}return pe.sort((We,Ze)=>We.column-Ze.column),pe}return this.defaultValue}}class de extends D{constructor(){super(92,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Ce(X,Z){if(typeof X!="string")return Z;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ae extends D{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(97,null),m.localize(98,null),m.localize(99,null)],default:"auto",description:m.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(101,null),m.localize(102,null),m.localize(103,null)],default:"auto",description:m.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:m.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:m.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:m.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Z.ignoreHorizontalScrollbarInContentHeight,description:m.localize(108,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z,We=n.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ze=n.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ce(pe.vertical,this.defaultValue.vertical),horizontal:Ce(pe.horizontal,this.defaultValue.horizontal),useShadows:a(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:a(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:a(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:a(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:a(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:We,horizontalSliderSize:n.clampedInt(pe.horizontalSliderSize,We,0,1e3),verticalScrollbarSize:Ze,verticalSliderSize:n.clampedInt(pe.verticalSliderSize,Ze,0,1e3),scrollByPage:a(pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:a(pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends D{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:m.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:m.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:m.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:m.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:m.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:m.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:m.localize(115,null)}})}applyUpdate(Z,pe){let We=!1;pe.allowedCharacters&&Z&&(M.$Pn(Z.allowedCharacters,pe.allowedCharacters)||(Z={...Z,allowedCharacters:pe.allowedCharacters},We=!0)),pe.allowedLocales&&Z&&(M.$Pn(Z.allowedLocales,pe.allowedLocales)||(Z={...Z,allowedLocales:pe.allowedLocales},We=!0));const Ze=super.applyUpdate(Z,pe);return We?new l(Ze.newValue,!0):Ze}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{nonBasicASCII:ee(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:a(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:a(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,pe){if(typeof Z!="object"||!Z)return pe;const We={};for(const[Ze,st]of Object.entries(Z))st===!0&&(We[Ze]=!0);return We}}class z extends D{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:m.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(117,null),m.localize(118,null),m.localize(119,null)],description:m.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:m.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Z.fontFamily,description:m.localize(122,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:a(pe.enabled,this.defaultValue.enabled),mode:p(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:p(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:a(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:a(pe.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class j extends D{constructor(){const Z={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Z,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Z.enabled,description:m.localize(123,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(124,null),m.localize(125,null),m.localize(126,null)],description:m.localize(127,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Z.fontFamily,description:m.localize(128,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Z.backgroundColoring,description:m.localize(129,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:a(pe.enabled,this.defaultValue.enabled),showToolbar:p(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily),keepOnBlur:a(pe.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:a(pe.backgroundColoring,this.defaultValue.backgroundColoring)}}}class K extends D{constructor(){const Z={enabled:F.$Hs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:F.$Hs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:m.localize(130,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:m.localize(131,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:a(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:a(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends D{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(132,null),m.localize(133,null),m.localize(134,null)],default:Z.bracketPairs,description:m.localize(135,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(136,null),m.localize(137,null),m.localize(138,null)],default:Z.bracketPairsHorizontal,description:m.localize(139,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:m.localize(140,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:m.localize(141,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(142,null),m.localize(143,null),m.localize(144,null)],default:Z.highlightActiveIndentation,description:m.localize(145,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{bracketPairs:ee(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:a(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:a(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(X,Z,pe){const We=pe.indexOf(X);return We===-1?Z:pe[We]}class se extends D{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(146,null),m.localize(147,null)],default:Z.insertMode,description:m.localize(148,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:m.localize(149,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:m.localize(150,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:m.localize(151,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(152,null),m.localize(153,null),m.localize(154,null),m.localize(155,null)],default:Z.selectionMode,markdownDescription:m.localize(156,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:m.localize(157,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:m.localize(158,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:m.localize(159,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:m.localize(160,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:m.localize(161,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(162,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(163,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(183,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(184,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(185,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(186,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(187,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(188,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(189,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(190,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(191,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(192,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(193,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{insertMode:p(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:a(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:a(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:a(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:a(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:p(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:a(pe.showIcons,this.defaultValue.showIcons),showStatusBar:a(pe.showStatusBar,this.defaultValue.showStatusBar),preview:a(pe.preview,this.defaultValue.preview),previewMode:p(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:a(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:a(pe.showMethods,this.defaultValue.showMethods),showFunctions:a(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:a(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:a(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:a(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:a(pe.showFields,this.defaultValue.showFields),showVariables:a(pe.showVariables,this.defaultValue.showVariables),showClasses:a(pe.showClasses,this.defaultValue.showClasses),showStructs:a(pe.showStructs,this.defaultValue.showStructs),showInterfaces:a(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:a(pe.showModules,this.defaultValue.showModules),showProperties:a(pe.showProperties,this.defaultValue.showProperties),showEvents:a(pe.showEvents,this.defaultValue.showEvents),showOperators:a(pe.showOperators,this.defaultValue.showOperators),showUnits:a(pe.showUnits,this.defaultValue.showUnits),showValues:a(pe.showValues,this.defaultValue.showValues),showConstants:a(pe.showConstants,this.defaultValue.showConstants),showEnums:a(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:a(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:a(pe.showKeywords,this.defaultValue.showKeywords),showWords:a(pe.showWords,this.defaultValue.showWords),showColors:a(pe.showColors,this.defaultValue.showColors),showFiles:a(pe.showFiles,this.defaultValue.showFiles),showReferences:a(pe.showReferences,this.defaultValue.showReferences),showFolders:a(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:a(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:a(pe.showSnippets,this.defaultValue.showSnippets),showUsers:a(pe.showUsers,this.defaultValue.showUsers),showIssues:a(pe.showIssues,this.defaultValue.showIssues)}}}class Ne extends D{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(194,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(195,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:a(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:a(Z.selectSubwords,this.defaultValue.selectSubwords)}}}var Ve;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Ve||(e.WrappingIndent=Ve={}));class He extends D{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(196,null),m.localize(197,null),m.localize(198,null),m.localize(199,null)],description:m.localize(200,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,pe,We){return pe.get(2)===2?0:We}}class xe extends g{constructor(){super(145)}compute(Z,pe,We){const Ze=pe.get(144);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Ze.isWordWrapMinified,isViewportWrapping:Ze.isViewportWrapping,wrappingColumn:Ze.wrappingColumn}}}class tt extends D{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:m.localize(201,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(202,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(203,null),m.localize(204,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:a(pe.enabled,this.defaultValue.enabled),showDropSelector:p(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class lt extends D{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:m.localize(205,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(206,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(207,null),m.localize(208,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const pe=Z;return{enabled:a(pe.enabled,this.defaultValue.enabled),showPasteSelector:p(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",ot="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$j?it:P.$k?ot:rt,fontWeight:"normal",fontSize:P.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(X){return e.editorOptionsRegistry[X.id]=X,X}var et;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.inlineEdit=63]="inlineEdit",X[X.letterSpacing=64]="letterSpacing",X[X.lightbulb=65]="lightbulb",X[X.lineDecorationsWidth=66]="lineDecorationsWidth",X[X.lineHeight=67]="lineHeight",X[X.lineNumbers=68]="lineNumbers",X[X.lineNumbersMinChars=69]="lineNumbersMinChars",X[X.linkedEditing=70]="linkedEditing",X[X.links=71]="links",X[X.matchBrackets=72]="matchBrackets",X[X.minimap=73]="minimap",X[X.mouseStyle=74]="mouseStyle",X[X.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=76]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",X[X.multiCursorModifier=78]="multiCursorModifier",X[X.multiCursorPaste=79]="multiCursorPaste",X[X.multiCursorLimit=80]="multiCursorLimit",X[X.occurrencesHighlight=81]="occurrencesHighlight",X[X.overviewRulerBorder=82]="overviewRulerBorder",X[X.overviewRulerLanes=83]="overviewRulerLanes",X[X.padding=84]="padding",X[X.pasteAs=85]="pasteAs",X[X.parameterHints=86]="parameterHints",X[X.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",X[X.quickSuggestions=89]="quickSuggestions",X[X.quickSuggestionsDelay=90]="quickSuggestionsDelay",X[X.readOnly=91]="readOnly",X[X.readOnlyMessage=92]="readOnlyMessage",X[X.renameOnType=93]="renameOnType",X[X.renderControlCharacters=94]="renderControlCharacters",X[X.renderFinalNewline=95]="renderFinalNewline",X[X.renderLineHighlight=96]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=98]="renderValidationDecorations",X[X.renderWhitespace=99]="renderWhitespace",X[X.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",X[X.roundedSelection=101]="roundedSelection",X[X.rulers=102]="rulers",X[X.scrollbar=103]="scrollbar",X[X.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=105]="scrollBeyondLastLine",X[X.scrollPredominantAxis=106]="scrollPredominantAxis",X[X.selectionClipboard=107]="selectionClipboard",X[X.selectionHighlight=108]="selectionHighlight",X[X.selectOnLineNumbers=109]="selectOnLineNumbers",X[X.showFoldingControls=110]="showFoldingControls",X[X.showUnused=111]="showUnused",X[X.snippetSuggestions=112]="snippetSuggestions",X[X.smartSelect=113]="smartSelect",X[X.smoothScrolling=114]="smoothScrolling",X[X.stickyScroll=115]="stickyScroll",X[X.stickyTabStops=116]="stickyTabStops",X[X.stopRenderingLineAfter=117]="stopRenderingLineAfter",X[X.suggest=118]="suggest",X[X.suggestFontSize=119]="suggestFontSize",X[X.suggestLineHeight=120]="suggestLineHeight",X[X.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",X[X.suggestSelection=122]="suggestSelection",X[X.tabCompletion=123]="tabCompletion",X[X.tabIndex=124]="tabIndex",X[X.unicodeHighlighting=125]="unicodeHighlighting",X[X.unusualLineTerminators=126]="unusualLineTerminators",X[X.useShadowDOM=127]="useShadowDOM",X[X.useTabStops=128]="useTabStops",X[X.wordBreak=129]="wordBreak",X[X.wordSeparators=130]="wordSeparators",X[X.wordWrap=131]="wordWrap",X[X.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=134]="wordWrapColumn",X[X.wordWrapOverride1=135]="wordWrapOverride1",X[X.wordWrapOverride2=136]="wordWrapOverride2",X[X.wrappingIndent=137]="wrappingIndent",X[X.wrappingStrategy=138]="wrappingStrategy",X[X.showDeprecated=139]="showDeprecated",X[X.inlayHints=140]="inlayHints",X[X.editorClassName=141]="editorClassName",X[X.pixelRatio=142]="pixelRatio",X[X.tabFocusMode=143]="tabFocusMode",X[X.layoutInfo=144]="layoutInfo",X[X.wrappingInfo=145]="wrappingInfo",X[X.defaultColorDecorators=146]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(et||(e.EditorOption=et={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new r(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(209,null)})),acceptSuggestionOnEnter:Be(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(210,null),""],markdownDescription:m.localize(211,null)})),accessibilitySupport:Be(new b),accessibilityPageSize:Be(new n(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(212,null),tags:["accessibility"]})),ariaLabel:Be(new t(4,"ariaLabel",m.localize(213,null))),ariaRequired:Be(new r(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Be(new r(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(214,null),tags:["accessibility"]})),autoClosingBrackets:Be(new u(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(215,null),m.localize(216,null),""],description:m.localize(217,null)})),autoClosingComments:Be(new u(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(218,null),m.localize(219,null),""],description:m.localize(220,null)})),autoClosingDelete:Be(new u(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(221,null),""],description:m.localize(222,null)})),autoClosingOvertype:Be(new u(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(223,null),""],description:m.localize(224,null)})),autoClosingQuotes:Be(new u(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(225,null),m.localize(226,null),""],description:m.localize(227,null)})),autoIndent:Be(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[m.localize(228,null),m.localize(229,null),m.localize(230,null),m.localize(231,null),m.localize(232,null)],description:m.localize(233,null)})),automaticLayout:Be(new r(13,"automaticLayout",!1)),autoSurround:Be(new u(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(234,null),m.localize(235,null),m.localize(236,null),""],description:m.localize(237,null)})),bracketPairColorization:Be(new K),bracketPairGuides:Be(new H),stickyTabStops:Be(new r(116,"stickyTabStops",!1,{description:m.localize(238,null)})),codeLens:Be(new r(17,"codeLens",!0,{description:m.localize(239,null)})),codeLensFontFamily:Be(new t(18,"codeLensFontFamily","",{description:m.localize(240,null)})),codeLensFontSize:Be(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(241,null)})),colorDecorators:Be(new r(20,"colorDecorators",!0,{description:m.localize(242,null)})),colorDecoratorActivatedOn:Be(new u(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(243,null),m.localize(244,null),m.localize(245,null)],description:m.localize(246,null)})),colorDecoratorsLimit:Be(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(247,null)})),columnSelection:Be(new r(22,"columnSelection",!1,{description:m.localize(248,null)})),comments:Be(new $),contextmenu:Be(new r(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new r(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(249,null)})),cursorBlinking:Be(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:m.localize(250,null)})),cursorSmoothCaretAnimation:Be(new u(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(251,null),m.localize(252,null),m.localize(253,null)],description:m.localize(254,null)})),cursorStyle:Be(new o(28,"cursorStyle",y.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],A,{description:m.localize(255,null)})),cursorSurroundingLines:Be(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(256,null)})),cursorSurroundingLinesStyle:Be(new u(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(257,null),m.localize(258,null)],markdownDescription:m.localize(259,null)})),cursorWidth:Be(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(260,null)})),disableLayerHinting:Be(new r(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new r(33,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new r(34,"domReadOnly",!1)),dragAndDrop:Be(new r(35,"dragAndDrop",!0,{description:m.localize(261,null)})),emptySelectionClipboard:Be(new J),dropIntoEditor:Be(new tt),stickyScroll:Be(new ie),experimentalWhitespaceRendering:Be(new u(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(262,null),m.localize(263,null),m.localize(264,null)],description:m.localize(265,null)})),extraEditorClassName:Be(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Be(new d(40,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:m.localize(266,null)})),find:Be(new W),fixedOverflowWidgets:Be(new r(42,"fixedOverflowWidgets",!1)),folding:Be(new r(43,"folding",!0,{description:m.localize(267,null)})),foldingStrategy:Be(new u(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(268,null),m.localize(269,null)],description:m.localize(270,null)})),foldingHighlight:Be(new r(45,"foldingHighlight",!0,{description:m.localize(271,null)})),foldingImportsByDefault:Be(new r(46,"foldingImportsByDefault",!1,{description:m.localize(272,null)})),foldingMaximumRegions:Be(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(273,null)})),unfoldOnClickAfterEndOfLine:Be(new r(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(274,null)})),fontFamily:Be(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(275,null)})),fontInfo:Be(new O),fontLigatures2:Be(new U),fontSize:Be(new q),fontWeight:Be(new ne),fontVariations:Be(new C),formatOnPaste:Be(new r(55,"formatOnPaste",!1,{description:m.localize(276,null)})),formatOnType:Be(new r(56,"formatOnType",!1,{description:m.localize(277,null)})),glyphMargin:Be(new r(57,"glyphMargin",!0,{description:m.localize(278,null)})),gotoLocation:Be(new ce),hideCursorInOverviewRuler:Be(new r(59,"hideCursorInOverviewRuler",!1,{description:m.localize(279,null)})),hover:Be(new ye),inDiffEditor:Be(new r(61,"inDiffEditor",!1)),letterSpacing:Be(new d(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>d.clamp(X,-5,20),{description:m.localize(280,null)})),lightbulb:Be(new $e),lineDecorationsWidth:Be(new V),lineHeight:Be(new _),lineNumbers:Be(new he),lineNumbersMinChars:Be(new n(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new r(70,"linkedEditing",!1,{description:m.localize(281,null)})),links:Be(new r(71,"links",!0,{description:m.localize(282,null)})),matchBrackets:Be(new u(72,"matchBrackets","always",["always","near","never"],{description:m.localize(283,null)})),minimap:Be(new ke),mouseStyle:Be(new u(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new d(75,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:m.localize(284,null)})),mouseWheelZoom:Be(new r(76,"mouseWheelZoom",!1,{markdownDescription:P.$j?m.localize(285,null):m.localize(286,null)})),multiCursorMergeOverlapping:Be(new r(77,"multiCursorMergeOverlapping",!0,{description:m.localize(287,null)})),multiCursorModifier:Be(new o(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Le,{markdownEnumDescriptions:[m.localize(288,null),m.localize(289,null)],markdownDescription:m.localize(290,null)})),multiCursorPaste:Be(new u(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(291,null),m.localize(292,null)],markdownDescription:m.localize(293,null)})),multiCursorLimit:Be(new n(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(294,null)})),occurrencesHighlight:Be(new u(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(295,null),m.localize(296,null),m.localize(297,null)],markdownDescription:m.localize(298,null)})),overviewRulerBorder:Be(new r(82,"overviewRulerBorder",!0,{description:m.localize(299,null)})),overviewRulerLanes:Be(new n(83,"overviewRulerLanes",3,0,3)),padding:Be(new Ee),pasteAs:Be(new lt),parameterHints:Be(new be),peekWidgetDefaultFocus:Be(new u(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(300,null),m.localize(301,null)],description:m.localize(302,null)})),definitionLinkOpensInPeek:Be(new r(88,"definitionLinkOpensInPeek",!1,{description:m.localize(303,null)})),quickSuggestions:Be(new G),quickSuggestionsDelay:Be(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(304,null)})),readOnly:Be(new r(91,"readOnly",!1)),readOnlyMessage:Be(new de),renameOnType:Be(new r(93,"renameOnType",!1,{description:m.localize(305,null),markdownDeprecationMessage:m.localize(306,null)})),renderControlCharacters:Be(new r(94,"renderControlCharacters",!0,{description:m.localize(307,null),restricted:!0})),renderFinalNewline:Be(new u(95,"renderFinalNewline",P.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(308,null)})),renderLineHighlight:Be(new u(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(309,null)],description:m.localize(310,null)})),renderLineHighlightOnlyWhenFocus:Be(new r(97,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(311,null)})),renderValidationDecorations:Be(new u(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new u(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(312,null),m.localize(313,null),m.localize(314,null),""],description:m.localize(315,null)})),revealHorizontalRightPadding:Be(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new r(101,"roundedSelection",!0,{description:m.localize(316,null)})),rulers:Be(new Oe),scrollbar:Be(new Ae),scrollBeyondLastColumn:Be(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(317,null)})),scrollBeyondLastLine:Be(new r(105,"scrollBeyondLastLine",!0,{description:m.localize(318,null)})),scrollPredominantAxis:Be(new r(106,"scrollPredominantAxis",!0,{description:m.localize(319,null)})),selectionClipboard:Be(new r(107,"selectionClipboard",!0,{description:m.localize(320,null),included:P.$k})),selectionHighlight:Be(new r(108,"selectionHighlight",!0,{description:m.localize(321,null)})),selectOnLineNumbers:Be(new r(109,"selectOnLineNumbers",!0)),showFoldingControls:Be(new u(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(322,null),m.localize(323,null),m.localize(324,null)],description:m.localize(325,null)})),showUnused:Be(new r(111,"showUnused",!0,{description:m.localize(326,null)})),showDeprecated:Be(new r(139,"showDeprecated",!0,{description:m.localize(327,null)})),inlayHints:Be(new le),snippetSuggestions:Be(new u(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(328,null),m.localize(329,null),m.localize(330,null),m.localize(331,null)],description:m.localize(332,null)})),smartSelect:Be(new Ne),smoothScrolling:Be(new r(114,"smoothScrolling",!1,{description:m.localize(333,null)})),stopRenderingLineAfter:Be(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new se),inlineSuggest:Be(new z),inlineEdit:Be(new j),inlineCompletionsAccessibilityVerbose:Be(new r(148,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(334,null)})),suggestFontSize:Be(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(335,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(336,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new r(121,"suggestOnTriggerCharacters",!0,{description:m.localize(337,null)})),suggestSelection:Be(new u(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(338,null),m.localize(339,null),m.localize(340,null)],description:m.localize(341,null)})),tabCompletion:Be(new u(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(342,null),m.localize(343,null),m.localize(344,null)],description:m.localize(345,null)})),tabIndex:Be(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new ze),unusualLineTerminators:Be(new u(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(346,null),m.localize(347,null),m.localize(348,null)],description:m.localize(349,null)})),useShadowDOM:Be(new r(127,"useShadowDOM",!0)),useTabStops:Be(new r(128,"useTabStops",!0,{description:m.localize(350,null)})),wordBreak:Be(new u(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(351,null),m.localize(352,null)],description:m.localize(353,null)})),wordSeparators:Be(new t(130,"wordSeparators",R.$Is,{description:m.localize(354,null)})),wordWrap:Be(new u(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(355,null),m.localize(356,null),m.localize(357,null),m.localize(358,null)],description:m.localize(359,null)})),wordWrapBreakAfterCharacters:Be(new t(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new t(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new n(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(360,null)})),wordWrapOverride1:Be(new u(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new u(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new L),defaultColorDecorators:Be(new r(146,"defaultColorDecorators",!1,{markdownDescription:m.localize(361,null)})),pixelRatio:Be(new ge),tabFocusMode:Be(new r(143,"tabFocusMode",!1,{markdownDescription:m.localize(362,null)})),layoutInfo:Be(new ue),wrappingInfo:Be(new xe),wrappingIndent:Be(new He),wrappingStrategy:Be(new ve)}}),define(Pe[151],Re([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[152],Re([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[153],Re([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[154],Re([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[155],Re([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[156],Re([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(Pe[157],Re([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(Pe[158],Re([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[159],Re([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(Pe[160],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[161],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[162],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[163],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[164],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Pe[165],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[166],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[167],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[168],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[169],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[170],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[171],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[172],Re([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[173],Re([9,10]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(Pe[174],Re([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(Pe[175],Re([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(Pe[176],Re([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[177],Re([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[178],Re([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[179],Re([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[180],Re([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[181],Re([9,10]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[182],Re([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[183],Re([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[184],Re([1,0,14,153]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=e.TokenType=void 0;var P;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(P||(e.TokenType=P={}));function F(...E){switch(E.length){case 1:return(0,M.localize)(0,null,E[0]);case 2:return(0,M.localize)(1,null,E[0],E[1]);case 3:return(0,M.localize)(2,null,E[0],E[1],E[2]);default:return}}const R=(0,M.localize)(3,null),m=(0,M.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(N){switch(N.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return N.isTripleEq?"===":"==";case 4:return N.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return N.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return N.lexeme;case 18:return N.lexeme;case 19:return N.lexeme;case 20:return"EOF";default:throw(0,S.$8)(`unhandled token type: ${JSON.stringify(N)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(N=>N.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(N){return this.c=N,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(F("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(F("&&"));break;case 124:this.h(124)?this.k(16):this.l(F("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(N){return this.r()||this.c.charCodeAt(this.e)!==N?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(N){this.f.push({type:N,offset:this.d})}l(N){const D=this.d,l=this.c.substring(this.d,this.e),k={type:19,offset:this.d,lexeme:l};this.g.push({offset:D,lexeme:l,additionalInfo:N}),this.f.push(k)}n(){this.m.lastIndex=this.d;const N=this.m.exec(this.c);if(N){this.e=this.d+N[0].length;const D=this.c.substring(this.d,this.e),l=f.b.get(D);l?this.k(l):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let N=this.e,D=!1,l=!1;for(;;){if(N>=this.c.length){this.e=N,this.l(m);return}const g=this.c.charCodeAt(N);if(D)D=!1;else if(g===47&&!l){N++;break}else g===91?l=!0:g===92?D=!0:g===93&&(l=!1);N++}for(;N<this.c.length&&f.a.has(this.c.charCodeAt(N));)N++;this.e=N;const k=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:k,offset:this.d})}r(){return this.e>=this.c.length}}e.$bj=f}),define(Pe[185],Re([1,0,24,32,155,297]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function f(r){return r=r.trim(),r==="*"||R.test(r)}e.$pp=f;function E(r){if(!f(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=r.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$qp=E;function N(r){if(!r)return null;const i=r.majorBase,n=r.majorMustEqual,c=r.minorBase;let d=r.minorMustEqual;const t=r.patchBase;let p=r.patchMustEqual;r.hasCaret&&(i===0||(d=!1),p=!1);let u=0;if(r.preRelease){const o=m.exec(r.preRelease);if(o){const[,v,b,$]=o;u=Date.UTC(Number(v),Number(b)-1,Number($))}}return{majorBase:i,majorMustEqual:n,minorBase:c,minorMustEqual:d,patchBase:t,patchMustEqual:p,isMinimum:r.hasGreaterEquals,notBefore:u}}e.$rp=N;function D(r,i,n){let c;typeof r=="string"?c=N(E(r)):c=r;let d;i instanceof Date?d=i.getTime():typeof i=="string"&&(d=new Date(i).getTime());let t;if(typeof n=="string"?t=N(E(n)):t=n,!c||!t)return!1;const p=c.majorBase,u=c.minorBase,o=c.patchBase;let v=t.majorBase,b=t.minorBase,$=t.patchBase;const I=t.notBefore;let h=t.majorMustEqual,y=t.minorMustEqual,w=t.patchMustEqual;return t.isMinimum?p>v?!0:p<v?!1:u>b?!0:u<b||d&&d<I?!1:o>=$:(p===1&&v===0&&(!h||!y||!w)&&(v=1,b=0,$=0,h=!0,y=!1,w=!1),p<v?!1:p>v?!h:u<b?!1:u>b?!y:o<$?!1:o>$?!w:!(d&&d<I))}e.$sp=D;function l(r,i,n,c,d){const t=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return t.push([M.default.Error,P.localize(0,null)]),t;if(typeof c.name!="string")return t.push([M.default.Error,P.localize(1,null,"name")]),t;if(typeof c.version!="string")return t.push([M.default.Error,P.localize(2,null,"version")]),t;if(!c.engines)return t.push([M.default.Error,P.localize(3,null,"engines")]),t;if(typeof c.engines.vscode!="string")return t.push([M.default.Error,P.localize(4,null,"engines.vscode")]),t;if(typeof c.extensionDependencies<"u"&&!a(c.extensionDependencies))return t.push([M.default.Error,P.localize(5,null,"extensionDependencies")]),t;if(typeof c.activationEvents<"u"){if(!a(c.activationEvents))return t.push([M.default.Error,P.localize(6,null,"activationEvents")]),t;if(typeof c.main>"u"&&typeof c.browser>"u")return t.push([M.default.Error,P.localize(7,null,"activationEvents","main","browser")]),t}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&t.push([M.default.Warning,P.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return t.push([M.default.Error,P.localize(9,null,"main")]),t;{const o=(0,S.$Tg)(n,c.main);(0,S.$Ng)(o,n)||t.push([M.default.Warning,P.localize(10,null,o.path,n.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return t.push([M.default.Error,P.localize(11,null,"browser")]),t;{const o=(0,S.$Tg)(n,c.browser);(0,S.$Ng)(o,n)||t.push([M.default.Warning,P.localize(12,null,o.path,n.path)])}}if(!F.valid(c.version))return t.push([M.default.Error,P.localize(13,null)]),t;const p=[];if(!k(r,i,c,d,p))for(const o of p)t.push([M.default.Error,o]);return t}e.$tp=l;function k(r,i,n,c,d){return c||typeof n.main>"u"&&typeof n.browser>"u"?!0:s(r,i,n.engines.vscode,d)}e.$up=k;function g(r,i,n){return r==="*"||s(i,n,r)}e.$vp=g;function s(r,i,n,c=[]){const d=N(E(n));if(!d)return c.push(P.localize(14,null,n)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return c.push(P.localize(15,null,n)),!1}else if(!d.majorMustEqual)return c.push(P.localize(16,null,n)),!1;return D(r,i,d)?!0:(c.push(P.localize(17,null,r,n)),!1)}function a(r){if(!Array.isArray(r))return!1;for(let i=0,n=r.length;i<n;i++)if(typeof r[i]!="string")return!1;return!0}}),define(Pe[70],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=void 0;class S{constructor(P,F=[],R=!1){this.ctor=P,this.staticArguments=F,this.supportsDelayedInstantiation=R}}e.$di=S}),define(Pe[54],Re([1,0,70]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=e.$bs=e.InstantiationType=void 0;const M=[];var P;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function F(m,f,E){f instanceof S.$di||(f=new S.$di(f,[],!!E)),M.push([m,f])}e.$bs=F;function R(){return M}e.$cs=R}),define(Pe[186],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=e.$Rq=void 0;class S{constructor(F,R){this.key=F,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Rq=S;class M{constructor(F){this.b=F,this.a=new Map}roots(){const F=[];for(const R of this.a.values())R.outgoing.size===0&&F.push(R);return F}insertEdge(F,R){const m=this.lookupOrInsertNode(F),f=this.lookupOrInsertNode(R);m.outgoing.set(f.key,f),f.incoming.set(m.key,m)}removeNode(F){const R=this.b(F);this.a.delete(R);for(const m of this.a.values())m.outgoing.delete(R),m.incoming.delete(R)}lookupOrInsertNode(F){const R=this.b(F);let m=this.a.get(R);return m||(m=new S(R,F),this.a.set(R,m)),m}lookup(F){return this.a.get(this.b(F))}isEmpty(){return this.a.size===0}toString(){const F=[];for(const[R,m]of this.a)F.push(`${R}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return F.join(`
`)}findCycleSlow(){for(const[F,R]of this.a){const m=new Set([F]),f=this.c(R,m);if(f)return f}}c(F,R){for(const[m,f]of F.outgoing){if(R.has(m))return[...R,m].join(" -> ");R.add(m);const E=this.c(f,R);if(E)return E;R.delete(m)}}}e.$Sq=M}),define(Pe[3],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.$gi=e.$fi=e._util=void 0;var S;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function m(f){return f[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=m})(S||(e._util=S={})),e.$fi=P("instantiationService");function M(R,m,f){m[S.DI_TARGET]===m?m[S.DI_DEPENDENCIES].push({id:R,index:f}):(m[S.DI_DEPENDENCIES]=[{id:R,index:f}],m[S.DI_TARGET]=m)}function P(R){if(S.serviceIds.has(R))return S.serviceIds.get(R);const m=function(f,E,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(m,f,N)};return m.toString=()=>R,S.serviceIds.set(R,m),m}e.$gi=P;function F(R){return R}e.$hi=F}),define(Pe[46],Re([1,0,16,2,3]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.ConfigurationTarget=e.$Oi=e.$Ni=e.$Mi=void 0,e.$Mi=(0,P.$gi)("configurationService");function F(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof M.URI)}e.$Ni=F;function R(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof M.URI)}e.$Oi=R;var m;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function f(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Pi=f;function E(r){return r.applicationValue!==void 0||r.userValue!==void 0||r.userLocalValue!==void 0||r.userRemoteValue!==void 0||r.workspaceValue!==void 0||r.workspaceFolderValue!==void 0}e.$Qi=E;function N(r,i){const n=Object.create(null);for(const c in r)D(n,c,r[c],i);return n}e.$Ri=N;function D(r,i,n,c){const d=i.split("."),t=d.pop();let p=r;for(let u=0;u<d.length;u++){const o=d[u];let v=p[o];switch(typeof v){case"undefined":v=p[o]=Object.create(null);break;case"object":break;default:c(`Ignoring ${i} as ${d.slice(0,u+1).join(".")} is ${JSON.stringify(v)}`);return}p=v}if(typeof p=="object"&&p!==null)try{p[t]=n}catch{c(`Ignoring ${i} as ${d.join(".")} is ${JSON.stringify(p)}`)}else c(`Ignoring ${i} as ${d.join(".")} is ${JSON.stringify(p)}`)}e.$Si=D;function l(r,i){const n=i.split(".");k(r,n)}e.$Ti=l;function k(r,i){const n=i.shift();if(i.length===0){delete r[n];return}if(Object.keys(r).indexOf(n)!==-1){const c=r[n];typeof c=="object"&&!Array.isArray(c)&&(k(c,i),Object.keys(c).length===0&&delete r[n])}}function g(r,i,n){function c(p,u){let o=p;for(const v of u){if(typeof o!="object"||o===null)return;o=o[v]}return o}const d=i.split("."),t=c(r,d);return typeof t>"u"?n:t}e.$Ui=g;function s(r,i,n){Object.keys(i).forEach(c=>{c!=="__proto__"&&(c in r?S.$Vf(r[c])&&S.$Vf(i[c])?s(r[c],i[c],n):n&&(r[c]=i[c]):r[c]=i[c])})}e.$Vi=s;function a(r){return r.replace(/[\[\]]/g,"")}e.$Wi=a}),define(Pe[35],Re([1,0,21,15,184,3,152,14]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.ContextKeyExprType=e.$cj=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",S.$j),f.set("isLinux",S.$k),f.set("isWindows",S.$i),f.set("isWeb",S.$o),f.set("isMacNative",S.$j&&!S.$o),f.set("isEdge",S.$H),f.set("isFirefox",S.$F),f.set("isChrome",S.$E),f.set("isSafari",S.$G);function E(le,V){if(f.get(le)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(le,V)}e.$cj=E;const N=Object.prototype.hasOwnProperty;var D;(function(le){le[le.False=0]="False",le[le.True=1]="True",le[le.Defined=2]="Defined",le[le.Not=3]="Not",le[le.Equals=4]="Equals",le[le.NotEquals=5]="NotEquals",le[le.And=6]="And",le[le.Regex=7]="Regex",le[le.NotRegex=8]="NotRegex",le[le.Or=9]="Or",le[le.In=10]="In",le[le.NotIn=11]="NotIn",le[le.Greater=12]="Greater",le[le.GreaterEquals=13]="GreaterEquals",le[le.Smaller=14]="Smaller",le[le.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const l={regexParsingWithErrorRecovery:!0},k=(0,R.localize)(0,null),g=(0,R.localize)(1,null),s=(0,R.localize)(2,null),a=(0,R.localize)(3,null),r=(0,R.localize)(4,null),i=(0,R.localize)(5,null),n=(0,R.localize)(6,null),c=(0,R.localize)(7,null);class d{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=l){this.k=V,this.d=new P.$bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:k,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const _=this.l();if(!this.E()){const ke=this.D(),Le=ke.type===17?i:void 0;throw this.h.push({message:r,offset:ke.offset,lexeme:P.$bj.getLexeme(ke),additionalInfo:Le}),d.c}return _}catch(_){if(_!==d.c)throw _;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const _=this.o();V.push(_)}return V.length===1?V[0]:t.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const _=this.s();V.push(_)}return V.length===1?V[0]:t.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),v.INSTANCE;case 12:return this.z(),b.INSTANCE;case 0:{this.z();const _=this.l();return this.A(1,a),_?.negate()}case 17:return this.z(),A.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const _=this.l();return this.A(1,a),_}case 17:{const _=V.lexeme;if(this.z(),this.y(9)){const Le=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Le.type!==10)throw this.B("REGEX",Le);const Ee=Le.lexeme,be=Ee.lastIndexOf("/"),ge=be===Ee.length-1?void 0:this.w(Ee.substring(be+1));let G;try{G=new RegExp(Ee.substring(1,be),ge)}catch{throw this.B("REGEX",Le)}return O.create(_,G)}switch(Le.type){case 10:case 19:{const Ee=[Le.lexeme];this.z();let be=this.D(),ge=0;for(let Oe=0;Oe<Le.lexeme.length;Oe++)Le.lexeme.charCodeAt(Oe)===40?ge++:Le.lexeme.charCodeAt(Oe)===41&&ge--;for(;!this.E()&&be.type!==15&&be.type!==16;){switch(be.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let Oe=0;Oe<be.lexeme.length;Oe++)be.lexeme.charCodeAt(Oe)===40?ge++:Le.lexeme.charCodeAt(Oe)===41&&ge--}if(ge<0)break;Ee.push(P.$bj.getLexeme(be)),this.z(),be=this.D()}const G=Ee.join(""),Y=G.lastIndexOf("/"),he=Y===G.length-1?void 0:this.w(G.substring(Y+1));let fe;try{fe=new RegExp(G.substring(1,Y),he)}catch{throw this.B("REGEX",Le)}return t.regex(_,fe)}case 18:{const Ee=Le.lexeme;this.z();let be=null;if(!(0,M.$Te)(Ee)){const ge=Ee.indexOf("/"),G=Ee.lastIndexOf("/");if(ge!==G&&ge>=0){const Y=Ee.slice(ge+1,G),he=Ee[G+1]==="i"?"i":"";try{be=new RegExp(Y,he)}catch{throw this.B("REGEX",Le)}}}if(be===null)throw this.B("REGEX",Le);return O.create(_,be)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,s);const Le=this.u();return t.notIn(_,Le)}switch(this.D().type){case 3:{this.z();const Le=this.u();if(this.x().type===18)return t.equals(_,Le);switch(Le){case"true":return t.has(_);case"false":return t.not(_);default:return t.equals(_,Le)}}case 4:{this.z();const Le=this.u();if(this.x().type===18)return t.notEquals(_,Le);switch(Le){case"true":return t.not(_);case"false":return t.has(_);default:return t.notEquals(_,Le)}}case 5:return this.z(),U.create(_,this.u());case 6:return this.z(),C.create(_,this.u());case 7:return this.z(),J.create(_,this.u());case 8:return this.z(),W.create(_,this.u());case 13:return this.z(),t.in(_,this.u());default:return t.has(_)}}case 20:throw this.h.push({message:n,offset:V.offset,lexeme:"",additionalInfo:c}),d.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,_){if(this.C(V))return this.z();throw this.B(_,this.D())}B(V,_,ke){const Le=(0,R.localize)(8,null,V,P.$bj.getLexeme(_)),Ee=_.offset,be=P.$bj.getLexeme(_);return this.h.push({message:Le,offset:Ee,lexeme:be,additionalInfo:ke}),d.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$dj=d;class t{static false(){return v.INSTANCE}static true(){return b.INSTANCE}static has(V){return $.create(V)}static equals(V,_){return I.create(V,_)}static notEquals(V,_){return w.create(V,_)}static regex(V,_){return O.create(V,_)}static in(V,_){return h.create(V,_)}static notIn(V,_){return y.create(V,_)}static not(V){return A.create(V)}static and(...V){return ce.create(V,null,!0)}static or(...V){return ye.create(V,null,!0)}static greater(V,_){return J.create(V,_)}static greaterEquals(V,_){return W.create(V,_)}static smaller(V,_){return U.create(V,_)}static smallerEquals(V,_){return C.create(V,_)}static{this.c=new d({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$ej=t;function p(le){const V=new d({regexParsingWithErrorRecovery:!1});return le.map(_=>(V.parse(_),V.lexingErrors.length>0?V.lexingErrors.map(ke=>({errorMessage:ke.additionalInfo?(0,R.localize)(9,null,ke.additionalInfo):(0,R.localize)(10,null),offset:ke.offset,length:ke.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(ke=>({errorMessage:ke.additionalInfo?`${ke.message}. ${ke.additionalInfo}`:ke.message,offset:ke.offset,length:ke.lexeme.length})):[]))}e.$fj=p;function u(le,V){const _=le?le.substituteConstants():void 0,ke=V?V.substituteConstants():void 0;return!_&&!ke?!0:!_||!ke?!1:_.equals(ke)}e.$gj=u;function o(le,V){return le.cmp(V)}class v{static{this.INSTANCE=new v}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return b.INSTANCE}}e.$hj=v;class b{static{this.INSTANCE=new b}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return v.INSTANCE}}e.$ij=b;class ${static create(V,_=null){const ke=f.get(V);return typeof ke=="boolean"?ke?b.INSTANCE:v.INSTANCE:new $(V,_)}constructor(V,_){this.key=V,this.c=_,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=f.get(this.key);return typeof V=="boolean"?V?b.INSTANCE:v.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=A.create(this.key,this)),this.c}}e.$jj=$;class I{static create(V,_,ke=null){if(typeof _=="boolean")return _?$.create(V,ke):A.create(V,ke);const Le=f.get(V);return typeof Le=="boolean"?_===(Le?"true":"false")?b.INSTANCE:v.INSTANCE:new I(V,_,ke)}constructor(V,_,ke){this.c=V,this.d=_,this.f=ke,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=f.get(this.c);if(typeof V=="boolean"){const _=V?"true":"false";return this.d===_?b.INSTANCE:v.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$kj=I;class h{static create(V,_){return new h(V,_)}constructor(V,_){this.d=V,this.f=_,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const _=V.getValue(this.f),ke=V.getValue(this.d);return Array.isArray(_)?_.includes(ke):typeof ke=="string"&&typeof _=="object"&&_!==null?N.call(_,ke):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$lj=h;class y{static create(V,_){return new y(V,_)}constructor(V,_){this.d=V,this.f=_,this.type=11,this.c=h.create(V,_)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$mj=y;class w{static create(V,_,ke=null){if(typeof _=="boolean")return _?A.create(V,ke):$.create(V,ke);const Le=f.get(V);return typeof Le=="boolean"?_===(Le?"true":"false")?v.INSTANCE:b.INSTANCE:new w(V,_,ke)}constructor(V,_,ke){this.c=V,this.d=_,this.f=ke,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=f.get(this.c);if(typeof V=="boolean"){const _=V?"true":"false";return this.d===_?v.INSTANCE:b.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$nj=w;class A{static create(V,_=null){const ke=f.get(V);return typeof ke=="boolean"?ke?v.INSTANCE:b.INSTANCE:new A(V,_)}constructor(V,_){this.c=V,this.d=_,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:ue(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=f.get(this.c);return typeof V=="boolean"?V?v.INSTANCE:b.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=$.create(this.c,this)),this.d}}e.$oj=A;function L(le,V){if(typeof le=="string"){const _=parseFloat(le);isNaN(_)||(le=_)}return typeof le=="string"||typeof le=="number"?V(le):v.INSTANCE}class J{static create(V,_,ke=null){return L(_,Le=>new J(V,Le,ke))}constructor(V,_,ke){this.c=V,this.d=_,this.f=ke,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$pj=J;class W{static create(V,_,ke=null){return L(_,Le=>new W(V,Le,ke))}constructor(V,_,ke){this.c=V,this.d=_,this.f=ke,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$qj=W;class U{static create(V,_,ke=null){return L(_,Le=>new U(V,Le,ke))}constructor(V,_,ke){this.c=V,this.d=_,this.f=ke,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$rj=U;class C{static create(V,_,ke=null){return L(_,Le=>new C(V,Le,ke))}constructor(V,_,ke){this.c=V,this.d=_,this.f=ke,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$sj=C;class O{static create(V,_){return new O(V,_)}constructor(V,_){this.d=V,this.f=_,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const _=this.f?this.f.source:"",ke=V.f?V.f.source:"";return _<ke?-1:_>ke?1:0}equals(V){if(V.type===this.type){const _=this.f?this.f.source:"",ke=V.f?V.f.source:"";return this.d===V.d&&_===ke}return!1}substituteConstants(){return this}evaluate(V){const _=V.getValue(this.d);return this.f?this.f.test(_):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=q.create(this)),this.c}}e.$tj=O;class q{static create(V){return new q(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new q(this.c.map(V))}negate(){return this.c}}e.$uj=q;function ne(le){let V=null;for(let _=0,ke=le.length;_<ke;_++){const Le=le[_].substituteConstants();if(le[_]!==Le&&V===null){V=[];for(let Ee=0;Ee<_;Ee++)V[Ee]=le[Ee]}V!==null&&(V[_]=Le)}return V===null?le:V}class ce{static create(V,_,ke){return ce.d(V,_,ke)}constructor(V,_){this.expr=V,this.c=_,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let _=0,ke=this.expr.length;_<ke;_++){const Le=o(this.expr[_],V.expr[_]);if(Le!==0)return Le}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let _=0,ke=this.expr.length;_<ke;_++)if(!this.expr[_].equals(V.expr[_]))return!1;return!0}return!1}substituteConstants(){const V=ne(this.expr);return V===this.expr?this:ce.create(V,this.c,!1)}evaluate(V){for(let _=0,ke=this.expr.length;_<ke;_++)if(!this.expr[_].evaluate(V))return!1;return!0}static d(V,_,ke){const Le=[];let Ee=!1;for(const be of V)if(be){if(be.type===1){Ee=!0;continue}if(be.type===0)return v.INSTANCE;if(be.type===6){Le.push(...be.expr);continue}Le.push(be)}if(Le.length===0&&Ee)return b.INSTANCE;if(Le.length!==0){if(Le.length===1)return Le[0];Le.sort(o);for(let be=1;be<Le.length;be++)Le[be-1].equals(Le[be])&&(Le.splice(be,1),be--);if(Le.length===1)return Le[0];for(;Le.length>1;){const be=Le[Le.length-1];if(be.type!==9)break;Le.pop();const ge=Le.pop(),G=Le.length===0,Y=ye.create(be.expr.map(he=>ce.create([he,ge],null,ke)),null,G);Y&&(Le.push(Y),Le.sort(o))}if(Le.length===1)return Le[0];if(ke){for(let be=0;be<Le.length;be++)for(let ge=be+1;ge<Le.length;ge++)if(Le[be].negate().equals(Le[ge]))return v.INSTANCE;if(Le.length===1)return Le[0]}return new ce(Le,_)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const _ of this.expr)V.push(..._.keys());return V}map(V){return new ce(this.expr.map(_=>_.map(V)),null)}negate(){if(!this.c){const V=[];for(const _ of this.expr)V.push(_.negate());this.c=ye.create(V,this,!0)}return this.c}}e.$vj=ce;class ye{static create(V,_,ke){return ye.d(V,_,ke)}constructor(V,_){this.expr=V,this.c=_,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let _=0,ke=this.expr.length;_<ke;_++){const Le=o(this.expr[_],V.expr[_]);if(Le!==0)return Le}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let _=0,ke=this.expr.length;_<ke;_++)if(!this.expr[_].equals(V.expr[_]))return!1;return!0}return!1}substituteConstants(){const V=ne(this.expr);return V===this.expr?this:ye.create(V,this.c,!1)}evaluate(V){for(let _=0,ke=this.expr.length;_<ke;_++)if(this.expr[_].evaluate(V))return!0;return!1}static d(V,_,ke){let Le=[],Ee=!1;if(V){for(let be=0,ge=V.length;be<ge;be++){const G=V[be];if(G){if(G.type===0){Ee=!0;continue}if(G.type===1)return b.INSTANCE;if(G.type===9){Le=Le.concat(G.expr);continue}Le.push(G)}}if(Le.length===0&&Ee)return v.INSTANCE;Le.sort(o)}if(Le.length!==0){if(Le.length===1)return Le[0];for(let be=1;be<Le.length;be++)Le[be-1].equals(Le[be])&&(Le.splice(be,1),be--);if(Le.length===1)return Le[0];if(ke){for(let be=0;be<Le.length;be++)for(let ge=be+1;ge<Le.length;ge++)if(Le[be].negate().equals(Le[ge]))return b.INSTANCE;if(Le.length===1)return Le[0]}return new ye(Le,_)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const _ of this.expr)V.push(..._.keys());return V}map(V){return new ye(this.expr.map(_=>_.map(V)),null)}negate(){if(!this.c){const V=[];for(const _ of this.expr)V.push(_.negate());for(;V.length>1;){const _=V.shift(),ke=V.shift(),Le=[];for(const Ee of ie(_))for(const be of ie(ke))Le.push(ce.create([Ee,be],null,!1));V.unshift(ye.create(Le,null,!1))}this.c=ye.create(V,this,!0)}return this.c}}e.$wj=ye;class Ie extends ${static{this.d=[]}static all(){return Ie.d.values()}constructor(V,_,ke){super(V,null),this.f=_,typeof ke=="object"?Ie.d.push({...ke,key:V}):ke!==!0&&Ie.d.push({key:V,description:ke,type:_!=null?typeof _:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return I.create(this.key,V)}notEqualsTo(V){return w.create(this.key,V)}}e.$xj=Ie,e.$yj=(0,F.$gi)("contextKeyService");function ue(le,V){return le<V?-1:le>V?1:0}function ve(le,V,_,ke){return le<_?-1:le>_?1:V<ke?-1:V>ke?1:0}function re(le,V){if(le.type===0||V.type===1)return!0;if(le.type===9)return V.type===9?$e(le.expr,V.expr):!1;if(V.type===9){for(const _ of V.expr)if(re(le,_))return!0;return!1}if(le.type===6){if(V.type===6)return $e(V.expr,le.expr);for(const _ of le.expr)if(re(_,V))return!0;return!1}return le.equals(V)}e.$zj=re;function $e(le,V){let _=0,ke=0;for(;_<le.length&&ke<V.length;){const Le=le[_].cmp(V[ke]);if(Le<0)return!1;Le===0&&_++,ke++}return _===le.length}function ie(le){return le.type===9?le.expr:[le]}}),define(Pe[187],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=void 0,e.$ni=(0,S.$gi)("environmentService"),e.$oi=(0,S.$hi)(e.$ni)}),define(Pe[98],Re([1,0,154,3]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.ExtensionGalleryErrorCode=e.$Po=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Oo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0,e.$Co="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Do=new RegExp(e.$Co),e.$Eo="__web_extension",e.$Fo="skipWalkthrough",e.$Go="extensionsSync",e.$Ho="dependecyOrPackExtensionInstall";function P(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Io=P;function F(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Jo=F;function R(n,c){switch(n){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Ko=R;function m(n,c){return c==="web"&&!n.includes("web")}e.$Lo=m;function f(n,c,d){return m(c,d)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===d}e.$Mo=f;function E(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.$No=E;var N;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(N||(e.SortBy=N={}));var D;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(D||(e.SortOrder=D={}));var l;(function(n){n.Install="install",n.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var k;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(k||(e.InstallOperation=k={})),e.$Oo=(0,M.$gi)("extensionGalleryService");var g;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Unknown="Unknown",n.Internal="Internal"})(g||(e.ExtensionManagementErrorCode=g={}));var s;(function(n){n.UnknownError="UnknownError",n.PackageIsInvalidZip="PackageIsInvalidZip",n.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(s||(e.ExtensionSignaturetErrorCode=s={}));class a extends Error{constructor(c,d){super(c),this.code=d,this.name=d}}e.$Po=a;var r;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(r||(e.ExtensionGalleryErrorCode=r={}));class i extends Error{constructor(c,d){super(c),this.code=d,this.name=d}}e.$Qo=i,e.$Ro=(0,M.$gi)("extensionManagementService"),e.$So="extensionsIdentifiers/disabled",e.$To="extensionsIdentifiers/enabled",e.$Uo=(0,M.$gi)("IGlobalExtensionEnablementService"),e.$Vo=(0,M.$gi)("IExtensionTipsService"),e.$Wo=(0,S.localize2)(0,"Extensions"),e.$Xo=(0,S.localize2)(1,"Preferences")}),define(Pe[42],Re([1,0,50,19,15,16,2,156,3,21,12,39]),function(me,e,S,M,P,F,R,m,f,E,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.FileKind=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.FileOperationResult=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.FileChangeType=e.$Yk=e.FileOperation=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.FileSystemProviderErrorCode=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileSystemProviderCapabilities=e.$Ik=e.FilePermission=e.FileType=e.$Hk=e.$Gk=void 0,e.$Gk=(0,f.$gi)("fileService");function l(re){return re.create===!0}e.$Hk=l;var k;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(k||(e.FileType=k={}));var g;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(g||(e.FilePermission=g={}));function s(re){const $e=re;return!!$e&&typeof $e.onDidChange=="function"}e.$Ik=s;var a;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function r(re){return!!(re.capabilities&2)}e.$Jk=r;function i(re){return!!(re.capabilities&8)}e.$Kk=i;function n(re){return!!(re.capabilities&131072)}e.$Lk=n;function c(re){return!!(re.capabilities&4)}e.$Mk=c;function d(re){return!!(re.capabilities&16)}e.$Nk=d;function t(re){return r(re)?!!(re.capabilities&16384):!1}e.$Ok=t;function p(re){return r(re)?!!(re.capabilities&32768):!1}e.$Pk=p;function u(re){return!!(re.capabilities&65536)}e.$Qk=u;function o(re){return!!(re.capabilities&2048)}e.$Rk=o;var v;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(v||(e.FileSystemProviderErrorCode=v={}));class b extends Error{static create($e,ie){const le=new b($e.toString(),ie);return h(le,ie),le}constructor($e,ie){super($e),this.code=ie}}e.$Sk=b;function $(re,$e){return b.create(re,$e)}e.$Tk=$;function I(re){return re||$((0,m.localize)(0,null),v.Unknown)}e.$Uk=I;function h(re,$e){return re.name=$e?`${$e} (FileSystemError)`:"FileSystemError",re}e.$Vk=h;function y(re){if(!re)return v.Unknown;if(re instanceof b)return re.code;const $e=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!$e)return v.Unknown;switch($e[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.$Wk=y;function w(re){if(re instanceof C)return re.fileOperationResult;switch(y(re)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 9;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileTooLarge:return 7;default:return 10}}e.$Xk=w;var A;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(A||(e.FileOperation=A={}));class L{constructor($e,ie,le){this.resource=$e,this.operation=ie,this.target=le}isOperation($e){return this.operation===$e}}e.$Yk=L;var J;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(J||(e.FileChangeType=J={}));class W{static{this.a=null}constructor($e,ie){this.c=ie,this.b=void 0,this.d=new D.$V(()=>{const le=S.$mi.forUris(()=>this.c);return le.fill(this.rawAdded.map(V=>[V,!0])),le}),this.f=new D.$V(()=>{const le=S.$mi.forUris(()=>this.c);return le.fill(this.rawUpdated.map(V=>[V,!0])),le}),this.g=new D.$V(()=>{const le=S.$mi.forUris(()=>this.c);return le.fill(this.rawDeleted.map(V=>[V,!0])),le}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const le of $e){switch(le.type){case 1:this.rawAdded.push(le.resource);break;case 0:this.rawUpdated.push(le.resource);break;case 2:this.rawDeleted.push(le.resource);break}this.b!==W.a&&(typeof le.cId=="number"?this.b===void 0?this.b=le.cId:this.b!==le.cId&&(this.b=W.a):this.b!==void 0&&(this.b=W.a))}}contains($e,...ie){return this.h($e,{includeChildren:!1},...ie)}affects($e,...ie){return this.h($e,{includeChildren:!0},...ie)}h($e,ie,...le){if(!$e)return!1;const V=le.length>0;return!!((!V||le.includes(1))&&(this.d.value.get($e)||ie.includeChildren&&this.d.value.findSuperstr($e))||(!V||le.includes(0))&&(this.f.value.get($e)||ie.includeChildren&&this.f.value.findSuperstr($e))||(!V||le.includes(2))&&(this.g.value.findSubstr($e)||ie.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$Zk=W;function U(re,$e,ie){return!re||!$e||re===$e||$e.length>re.length?!1:($e.charAt($e.length-1)!==M.sep&&($e+=M.sep),ie?(0,P.$lf)(re,$e):re.indexOf($e)===0)}e.$1k=U;class C extends Error{constructor($e,ie,le){super($e),this.fileOperationResult=ie,this.options=le}}e.$2k=C;class O extends C{constructor($e,ie,le,V){super($e,ie,V),this.fileOperationResult=ie,this.size=le}}e.$3k=O;class q extends C{constructor($e,ie,le){super($e,2,le),this.stat=ie}}e.$4k=q;var ne;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ne||(e.FileOperationResult=ne={})),e.$5k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$6k={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$7k="files.associations",e.$8k="files.exclude",e.$9k="files.readonlyInclude",e.$0k="files.readonlyExclude",e.$$k="files.readonlyFromPermissions";var ce;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce||(e.FileKind=ce={})),e.$_k="";function ye(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}e.$al=ye;async function Ie(re,$e){if(!$e.hasProvider(R.URI.from({scheme:re.scheme})))return new Promise(ie=>{const le=$e.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===re.scheme&&V.added&&(le.dispose(),ie())})})}e.$bl=Ie;class ue{static{this.KB=1024}static{this.MB=ue.KB*ue.KB}static{this.GB=ue.MB*ue.KB}static{this.TB=ue.GB*ue.KB}static formatSize($e){return(0,F.$Xf)($e)||($e=0),$e<ue.KB?(0,m.localize)(1,null,$e.toFixed(0)):$e<ue.MB?(0,m.localize)(2,null,($e/ue.KB).toFixed(2)):$e<ue.GB?(0,m.localize)(3,null,($e/ue.MB).toFixed(2)):$e<ue.TB?(0,m.localize)(4,null,($e/ue.GB).toFixed(2)):(0,m.localize)(5,null,($e/ue.TB).toFixed(2))}}e.$cl=ue;function ve(re){const $e=typeof re=="string"||re?.scheme===N.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===N.Schemas.file?1024*ue.MB:$e?10*ue.MB:E.$o?50*ue.MB:1024*ue.MB}e.$dl=ve}),define(Pe[71],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=void 0;class S{constructor(...P){this.a=new Map;for(const[F,R]of P)this.set(F,R)}set(P,F){const R=this.a.get(P);return this.a.set(P,F),R}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$ei=S}),define(Pe[188],Re([1,0,11,14,6,70,186,3,71,189]),function(me,e,S,M,P,F,R,m,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=void 0;const N=!1;class D extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class l{constructor(a=new f.$ei,r=!1,i,n=N){this.f=a,this.g=r,this.h=i,this.i=n,this.o=new Set,this.f.set(m.$fi,this),this._globalGraph=n?i?._globalGraph??new R.$Sq(c=>c):void 0}createChild(a){return new l(a,this.g,this,this.i)}invokeFunction(a,...r){const i=g.traceInvocation(this.i,a);let n=!1;try{return a({get:d=>{if(n)throw(0,M.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(d,i);if(!t)throw new Error(`[invokeFunction] unknown service '${d}'`);return t}},...r)}finally{n=!0,i.stop()}}createInstance(a,...r){let i,n;return a instanceof F.$di?(i=g.traceCreation(this.i,a.ctor),n=this.j(a.ctor,a.staticArguments.concat(r),i)):(i=g.traceCreation(this.i,a),n=this.j(a,r,i)),i.stop(),n}j(a,r=[],i){const n=m._util.getServiceDependencies(a).sort((t,p)=>t.index-p.index),c=[];for(const t of n){const p=this.m(t.id,i);p||this.u(`[createInstance] ${a.name} depends on UNKNOWN service ${t.id}.`,!1),c.push(p)}const d=n.length>0?n[0].index:r.length;if(r.length!==d){console.trace(`[createInstance] First service dependency of ${a.name} at position ${d+1} conflicts with ${r.length} static arguments`);const t=d-r.length;t>0?r=r.concat(new Array(t)):r=r.slice(0,d)}return Reflect.construct(a,r.concat(c))}k(a,r){if(this.f.get(a)instanceof F.$di)this.f.set(a,r);else if(this.h)this.h.k(a,r);else throw new Error("illegalState - setting UNKNOWN service instance")}l(a){const r=this.f.get(a);return!r&&this.h?this.h.l(a):r}m(a,r){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const i=this.l(a);return i instanceof F.$di?this.q(a,i,r.branch(a,!0)):(r.branch(a,!1),i)}q(a,r,i){if(this.o.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.o.add(a);try{return this.r(a,r,i)}finally{this.o.delete(a)}}r(a,r,i){const n=new R.$Sq(t=>t.id.toString());let c=0;const d=[{id:a,desc:r,_trace:i}];for(;d.length;){const t=d.pop();if(n.lookupOrInsertNode(t),c++>1e3)throw new D(n);for(const p of m._util.getServiceDependencies(t.desc.ctor)){const u=this.l(p.id);if(u||this.u(`[createInstance] ${a} depends on ${p.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(p.id)),u instanceof F.$di){const o={id:p.id,desc:u,_trace:t._trace.branch(p.id,!0)};n.insertEdge(t,o),d.push(o)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new D(n);break}for(const{data:p}of t){if(this.l(p.id)instanceof F.$di){const o=this.s(p.id,p.desc.ctor,p.desc.staticArguments,p.desc.supportsDelayedInstantiation,p._trace);this.k(p.id,o)}n.removeNode(p)}}return this.l(a)}s(a,r,i=[],n,c){if(this.f.get(a)instanceof F.$di)return this.t(a,r,i,n,c);if(this.h)return this.h.s(a,r,i,n,c);throw new Error(`illegalState - creating UNKNOWN service instance ${r.name}`)}t(a,r,i=[],n,c){if(n){const d=new l(void 0,this.g,this,this.i);d.c=String(a);const t=new Map,p=new S.$zh(()=>{const u=d.j(r,i,c);for(const[o,v]of t){const b=u[o];if(typeof b=="function")for(const $ of v)$.disposable=b.apply(u,$.listener)}return t.clear(),u});return new Proxy(Object.create(null),{get(u,o){if(!p.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let $=t.get(o);return $||($=new E.$4c,t.set(o,$)),(h,y,w)=>{if(p.isInitialized)return p.value[o](h,y,w);{const A={listener:[h,y,w],disposable:void 0},L=$.push(A);return(0,P.$Rc)(()=>{L(),A.disposable?.dispose()})}}}if(o in u)return u[o];const v=p.value;let b=v[o];return typeof b!="function"||(b=b.bind(v),u[o]=b),b},set(u,o,v){return p.value[o]=v,!0},getPrototypeOf(u){return r.prototype}})}else return this.j(r,i,c)}u(a,r){if(r&&console.warn(a),this.g)throw new Error(a)}}e.$Tq=l;var k;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(k||(k={}));class g{static{this.all=new Set}static{this.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(a,r){return a?new g(2,r.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(a,r){return a?new g(1,r.name):g.c}static{this.f=0}constructor(a,r){this.type=a,this.name=r,this.g=Date.now(),this.h=[]}branch(a,r){const i=new g(3,a.toString());return this.h.push([a,r,i]),i}stop(){const a=Date.now()-this.g;g.f+=a;let r=!1;function i(c,d){const t=[],p=new Array(c+1).join("	");for(const[u,o,v]of d.h)if(o&&v){r=!0,t.push(`${p}CREATES -> ${u}`);const b=i(c+1,v);b&&t.push(b)}else t.push(`${p}uses -> ${u}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(a>2||r)&&g.all.add(n.join(`
`))}}e.$Uq=g}),define(Pe[13],Re([1,0,41,5,99,6,28,21,24,16,2,35,3]),function(me,e,S,M,P,F,R,m,f,E,N,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.log=e.$Dj=e.LogLevel=e.$Cj=e.$Bj=e.$Aj=void 0,e.$Aj=(0,l.$gi)("logService"),e.$Bj=(0,l.$gi)("loggerService");function k(){return new Date().toISOString()}function g(h){return(0,E.$Xf)(h)}e.$Cj=g;var s;(function(h){h[h.Off=0]="Off",h[h.Trace=1]="Trace",h[h.Debug=2]="Debug",h[h.Info=3]="Info",h[h.Warning=4]="Warning",h[h.Error=5]="Error"})(s||(e.LogLevel=s={})),e.$Dj=s.Info;function a(h,y,w){switch(y){case s.Trace:h.trace(w);break;case s.Debug:h.debug(w);break;case s.Info:h.info(w);break;case s.Warning:h.warn(w);break;case s.Error:h.error(w);break;case s.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=a;function r(h,y=!1){let w="";for(let A=0;A<h.length;A++){let L=h[A];if(L instanceof Error&&(L=(0,S.$4i)(L,y)),typeof L=="object")try{L=JSON.stringify(L)}catch{}w+=(A>0?" ":"")+L}return w}class i extends F.$Tc{constructor(){super(...arguments),this.b=e.$Dj,this.c=this.B(new M.$6d),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==s.Off&&this.b<=y}}e.$Fj=i;class n extends i{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...w){this.f(s.Trace)&&this.g(s.Trace,r([y,...w],!0))}debug(y,...w){this.f(s.Debug)&&this.g(s.Debug,r([y,...w]))}info(y,...w){this.f(s.Info)&&this.g(s.Info,r([y,...w]))}warn(y,...w){this.f(s.Warning)&&this.g(s.Warning,r([y,...w]))}error(y,...w){if(this.f(s.Error))if(y instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=y.stack,this.g(s.Error,r(A))}else this.g(s.Error,r([y,...w]))}flush(){}}e.$Gj=n;class c extends i{constructor(y=e.$Dj){super(),this.setLevel(y),this.g=!m.$i}trace(y,...w){this.f(s.Trace)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,y,...w):console.log(`[main ${k()}]`,y,...w))}debug(y,...w){this.f(s.Debug)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,y,...w):console.log(`[main ${k()}]`,y,...w))}info(y,...w){this.f(s.Info)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,y,...w):console.log(`[main ${k()}]`,y,...w))}warn(y,...w){this.f(s.Warning)&&(this.g?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,y,...w):console.warn(`[main ${k()}]`,y,...w))}error(y,...w){this.f(s.Error)&&(this.g?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,y,...w):console.error(`[main ${k()}]`,y,...w))}flush(){}}e.$Hj=c;class d extends i{constructor(y=e.$Dj,w=!0){super(),this.g=w,this.setLevel(y)}trace(y,...w){this.f(s.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...w):console.log(y,...w))}debug(y,...w){this.f(s.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...w):console.log(y,...w))}info(y,...w){this.f(s.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...w):console.log(y,...w))}warn(y,...w){this.f(s.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...w):console.log(y,...w))}error(y,...w){this.f(s.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...w):console.error(y,...w))}flush(){}}e.$Ij=d;class t extends i{constructor(y,w=e.$Dj){super(),this.g=y,this.setLevel(w)}trace(y,...w){this.f(s.Trace)&&this.g.log(s.Trace,[this.h(y),...w])}debug(y,...w){this.f(s.Debug)&&this.g.log(s.Debug,[this.h(y),...w])}info(y,...w){this.f(s.Info)&&this.g.log(s.Info,[this.h(y),...w])}warn(y,...w){this.f(s.Warning)&&this.g.log(s.Warning,[this.h(y),...w])}error(y,...w){this.f(s.Error)&&this.g.log(s.Error,[this.h(y),...w])}h(y){return typeof y=="string"?y:(0,S.$4i)(y,this.f(s.Trace))}flush(){}}e.$Jj=t;class p extends i{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const w of this.g)w.setLevel(y);super.setLevel(y)}trace(y,...w){for(const A of this.g)A.trace(y,...w)}debug(y,...w){for(const A of this.g)A.debug(y,...w)}info(y,...w){for(const A of this.g)A.info(y,...w)}warn(y,...w){for(const A of this.g)A.warn(y,...w)}error(y,...w){for(const A of this.g)A.error(y,...w)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose();super.dispose()}}e.$Kj=p;class u extends F.$Tc{constructor(y,w,A){if(super(),this.h=y,this.j=w,this.b=new R.$Ac,this.c=this.B(new M.$6d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$6d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$6d),this.onDidChangeVisibility=this.g.event,A)for(const L of A)this.b.set(L.resource,{logger:void 0,info:L})}m(y){return(0,E.$Tf)(y)?[...this.b.values()].find(w=>w.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,w){const A=this.n(y),L=(0,E.$Tf)(y)?y:w?.id??(0,P.$7i)(A.toString()).toString(16);let J=this.b.get(A)?.logger;const W=w?.logLevel==="always"?s.Trace:w?.logLevel;J||(J=this.s(A,W??this.getLogLevel(A)??this.h,{...w,id:L}));const U={logger:J,info:{resource:A,id:L,logLevel:W,name:w?.name,hidden:w?.hidden,extensionId:w?.extensionId,when:w?.when}};return this.registerLogger(U.info),this.b.set(A,U),J}n(y){return(0,E.$Tf)(y)?(0,f.$Tg)(this.j,`${y}.log`):y}setLogLevel(y,w){if(N.URI.isUri(y)){const A=y,L=w,J=this.b.get(A);J&&L!==J.info.logLevel&&(J.info.logLevel=L===this.h?void 0:L,J.logger?.setLevel(L),this.b.set(J.info.resource,J),this.f.fire([A,L]))}else{this.h=y;for(const[A,L]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&L.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,w){const A=this.m(y);A&&w!==!A.info.hidden&&(A.info.hidden=!w,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,w]))}getLogLevel(y){let w;return y&&(w=this.b.get(y)?.info.logLevel),w??this.h}registerLogger(y){const w=this.b.get(y.resource);w?w.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const w=this.b.get(y);w&&(w.logger&&w.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[w.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Lj=u;class o{constructor(){this.onDidChangeLogLevel=new M.$6d().event}setLevel(y){}getLevel(){return s.Info}trace(y,...w){}debug(y,...w){}info(y,...w){}warn(y,...w){}error(y,...w){}critical(y,...w){}dispose(){}flush(){}}e.$Mj=o;class v extends o{}e.$Nj=v;function b(h){if(h.verbose)return s.Trace;if(typeof h.logLevel=="string"){const y=I(h.logLevel.toLowerCase());if(y!==void 0)return y}return e.$Dj}e.$Oj=b;function $(h){switch(h){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}e.$Pj=$;function I(h){switch(h){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.$Qj=I,e.$Rj=new D.$xj("logLevel",$(s.Info))}),define(Pe[190],Re([1,0,6,13]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NP=void 0;class P extends S.$Tc{constructor(R,m=[]){super(),this.a=new M.$Kj([R,...m]),this.B(R.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...m){this.a.trace(R,...m)}debug(R,...m){this.a.debug(R,...m)}info(R,...m){this.a.info(R,...m)}warn(R,...m){this.a.warn(R,...m)}error(R,...m){this.a.error(R,...m)}flush(){this.a.flush()}}e.$NP=P}),define(Pe[100],Re([1,0,32,157,3]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var F;(function(f){f[f.Unnecessary=1]="Unnecessary",f[f.Deprecated=2]="Deprecated"})(F||(e.MarkerTag=F={}));var R;(function(f){f[f.Hint=1]="Hint",f[f.Info=2]="Info",f[f.Warning=4]="Warning",f[f.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(f){function E(g,s){return s-g}f.compare=E;const N=Object.create(null);N[f.Error]=(0,M.localize)(0,null),N[f.Warning]=(0,M.localize)(1,null),N[f.Info]=(0,M.localize)(2,null);function D(g){return N[g]||""}f.toString=D;function l(g){switch(g){case S.default.Error:return f.Error;case S.default.Warning:return f.Warning;case S.default.Info:return f.Info;case S.default.Ignore:return f.Hint}}f.fromSeverity=l;function k(g){switch(g){case f.Error:return S.default.Error;case f.Warning:return S.default.Warning;case f.Info:return S.default.Info;case f.Hint:return S.default.Ignore}}f.toSeverity=k}(R||(e.MarkerSeverity=R={}));var m;(function(f){const E="";function N(l){return D(l,!0)}f.makeKey=N;function D(l,k){const g=[E];return l.source?g.push(l.source.replace("\xA6","\\\xA6")):g.push(E),l.code?typeof l.code=="string"?g.push(l.code.replace("\xA6","\\\xA6")):g.push(l.code.value.replace("\xA6","\\\xA6")):g.push(E),l.severity!==void 0&&l.severity!==null?g.push(R.toString(l.severity)):g.push(E),l.message&&k?g.push(l.message.replace("\xA6","\\\xA6")):g.push(E),l.startLineNumber!==void 0&&l.startLineNumber!==null?g.push(l.startLineNumber.toString()):g.push(E),l.startColumn!==void 0&&l.startColumn!==null?g.push(l.startColumn.toString()):g.push(E),l.endLineNumber!==void 0&&l.endLineNumber!==null?g.push(l.endLineNumber.toString()):g.push(E),l.endColumn!==void 0&&l.endColumn!==null?g.push(l.endColumn.toString()):g.push(E),g.push(E),g.join("\xA6")}f.makeKeyOptionalMessage=D})(m||(e.IMarkerData=m={})),e.$Pt=(0,P.$gi)("markerService")}),define(Pe[191],Re([1,0,5,32,3]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iv=e.$Hv=e.NotificationsFilter=e.$Gv=e.NeverShowAgainScope=e.NotificationPriority=e.$Fv=e.Severity=void 0,e.Severity=M.default,e.$Fv=(0,P.$gi)("notificationService");var F;(function(D){D[D.DEFAULT=0]="DEFAULT",D[D.SILENT=1]="SILENT",D[D.URGENT=2]="URGENT"})(F||(e.NotificationPriority=F={}));var R;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function m(D){if(D){const l=D;return typeof l.id=="string"&&typeof l.label=="string"}return!1}e.$Gv=m;var f;(function(D){D[D.OFF=0]="OFF",D[D.ERROR=1]="ERROR"})(f||(e.NotificationsFilter=f={}));class E{constructor(){this.progress=new N,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$Hv=E;class N{infinite(){}done(){}total(l){}worked(l){}}e.$Iv=N}),define(Pe[192],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tj=e.$Sj=void 0,e.$Sj=(0,S.$gi)("productService"),e.$Tj="vscode://schemas/vscode-product"});var Qe=this&&this.__decorate||function(me,e,S,M){var P=arguments.length,F=P<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,S):M,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")F=Reflect.decorate(me,e,S,M);else for(var m=me.length-1;m>=0;m--)(R=me[m])&&(F=(P<3?R(F):P>3?R(e,S,F):R(e,S))||F);return P>3&&F&&Object.defineProperty(e,S,F),F},qe=this&&this.__param||function(me,e){return function(S,M){e(S,M,me)}};define(Pe[101],Re([1,0,11,25,6,3]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pv=e.$Ov=e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.ProgressLocation=e.$Jv=void 0,e.$Jv=(0,F.$gi)("progressService");var R;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$Kv=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$Lv=m;class f{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const k=this.d;this.d=()=>{k?.(),l()}}):Promise.resolve()}}e.$Mv=f;let E=class extends P.$Tc{constructor(l,k){super(),this.a=new S.$Dh,k.withProgress(l,g=>(this.b=g,this.c&&g.report(this.c),this.a.p)),this.B((0,P.$Rc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$Nv=E,e.$Nv=E=Qe([qe(1,e.$Jv)],E);class N extends P.$Tc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new P.$Sc)}start(l){this.stop();const k=++this.a,g=new M.$de;return this.f=setTimeout(()=>{k===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,P.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Rc)(()=>g.cancel())),this.b.add((0,P.$Rc)(()=>this.c?this.c.done():void 0)),{id:k,token:g.token,stop:()=>this.h(k),isCurrent:()=>this.a===k}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$Ov=N,e.$Pv=(0,F.$gi)("editorProgressService")}),define(Pe[30],Re([1,0,55,16]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=void 0;class P{constructor(){this.a=new Map}add(R,m){S.ok(M.$Tf(R)),S.ok(M.$Vf(m)),S.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,m)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Xn=new P}),define(Pe[72],Re([1,0,5,30]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=void 0,e.$Yn={JSONContribution:"base.contributions.json"};function P(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class F{constructor(){this.b=new S.$6d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,E){this.a[P(f)]=E,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const R=new F;M.$Xn.add(e.$Yn.JSONContribution,R)}),define(Pe[56],Re([1,0,18,5,16,151,46,72,30]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.ConfigurationScope=e.$3n=e.EditPresentationTypes=void 0;var E;(function(d){d.Multiline="multilineText",d.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$3n={Configuration:"base.contributions.configuration"};var N;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.MACHINE=2]="MACHINE",d[d.WINDOW=3]="WINDOW",d[d.RESOURCE=4]="RESOURCE",d[d.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",d[d.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(N||(e.ConfigurationScope=N={})),e.$4n={properties:{},patternProperties:{}},e.$5n={properties:{},patternProperties:{}},e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n="vscode://schemas/settings/resourceLanguage",e.$$n="vscode://schemas/settings/configurationDefaults";const D=f.$Xn.as(m.$Yn.JSONContribution);class l{constructor(){this.h=new Set,this.i=new M.$6d,this.onDidSchemaChange=this.i.event,this.j=new M.$6d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:F.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$0n,this.g),this.v()}registerConfiguration(t,p=!0){this.registerConfigurations([t],p)}registerConfigurations(t,p=!0){const u=new Set;this.n(t,p,u),D.registerSchema(e.$0n,this.g),this.i.fire(),this.j.fire({properties:u})}deregisterConfigurations(t){const p=new Set;this.o(t,p),D.registerSchema(e.$0n,this.g),this.i.fire(),this.j.fire({properties:p})}updateConfigurations({add:t,remove:p}){const u=new Set;this.o(p,u),this.n(t,!1,u),D.registerSchema(e.$0n,this.g),this.i.fire(),this.j.fire({properties:u})}registerDefaultConfigurations(t){const p=new Set;this.k(t,p),this.i.fire(),this.j.fire({properties:p,defaultsOverrides:!0})}k(t,p){const u=[];for(const{overrides:o,source:v}of t)for(const b in o)if(p.add(b),e.$ao.test(b)){const $=this.a.get(b),I=$?.valuesSources??new Map;if(v)for(const A of Object.keys(o[b]))I.set(A,v);const h={...$?.value||{},...o[b]};this.a.set(b,{source:v,value:h,valuesSources:I});const y=(0,R.$Wi)(b),w={type:"object",default:h,description:F.localize(1,null,y),$ref:e.$0n,defaultDefaultValue:h,source:P.$Tf(v)?void 0:v,defaultValueSource:v};u.push(...s(b)),this.d[b]=w,this.b.properties[b]=w}else{this.a.set(b,{value:o[b],source:v});const $=this.d[b];$&&(this.w(b,$),this.r(b,$))}this.m(u)}deregisterDefaultConfigurations(t){const p=new Set;this.l(t,p),this.i.fire(),this.j.fire({properties:p,defaultsOverrides:!0})}l(t,p){for(const{overrides:u,source:o}of t)for(const v in u){const b=this.a.get(v),$=P.$Tf(o)?o:o?.id,I=P.$Tf(b?.source)?b?.source:b?.source?.id;if($===I)if(p.add(v),this.a.delete(v),e.$ao.test(v))delete this.d[v],delete this.b.properties[v];else{const h=this.d[v];h&&(this.w(v,h),this.r(v,h))}}this.u()}deltaConfiguration(t){let p=!1;const u=new Set;t.removedDefaults&&(this.l(t.removedDefaults,u),p=!0),t.addedDefaults&&(this.k(t.addedDefaults,u),p=!0),t.removedConfigurations&&this.o(t.removedConfigurations,u),t.addedConfigurations&&this.n(t.addedConfigurations,!1,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:p})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const p of t)this.h.add(p);this.u()}n(t,p,u){t.forEach(o=>{this.p(o,p,o.extensionInfo,o.restrictedProperties,void 0,u),this.c.push(o),this.q(o)})}o(t,p){const u=o=>{if(o.properties)for(const v in o.properties){p.add(v);const b=this.d[v];b?.policy?.name&&this.e.delete(b.policy.name),delete this.d[v],this.s(v,o.properties[v])}o.allOf?.forEach(v=>u(v))};for(const o of t){u(o);const v=this.c.indexOf(o);v!==-1&&this.c.splice(v,1)}}p(t,p=!0,u,o,v=3,b){v=P.$3f(t.scope)?v:t.scope;const $=t.properties;if($)for(const h in $){const y=$[h];if(p&&n(h,y)){delete $[h];continue}if(y.source=u,y.defaultDefaultValue=$[h].default,this.w(h,y),e.$ao.test(h)?y.scope=void 0:(y.scope=P.$3f(y.scope)?v:y.scope,y.restricted=P.$3f(y.restricted)?!!o?.includes(h):y.restricted),$[h].hasOwnProperty("included")&&!$[h].included){this.f[h]=$[h],delete $[h];continue}else this.d[h]=$[h],$[h].policy?.name&&this.e.set($[h].policy.name,h);!$[h].deprecationMessage&&$[h].markdownDeprecationMessage&&($[h].deprecationMessage=$[h].markdownDeprecationMessage),b.add(h)}const I=t.allOf;if(I)for(const h of I)this.p(h,p,u,o,v,b)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const p=u=>{const o=u.properties;if(o)for(const b in o)this.r(b,o[b]);u.allOf?.forEach(p)};p(t)}r(t,p){switch(e.$4n.properties[t]=p,p.scope){case 1:e.$5n.properties[t]=p;break;case 2:e.$6n.properties[t]=p;break;case 6:e.$7n.properties[t]=p;break;case 3:e.$8n.properties[t]=p;break;case 4:e.$9n.properties[t]=p;break;case 5:e.$9n.properties[t]=p,this.g.properties[t]=p;break}}s(t,p){switch(delete e.$4n.properties[t],p.scope){case 1:delete e.$5n.properties[t];break;case 2:delete e.$6n.properties[t];break;case 6:delete e.$7n.properties[t];break;case 3:delete e.$8n.properties[t];break;case 4:case 5:delete e.$9n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const p=`[${t}]`,u={type:"object",description:F.localize(2,null),errorMessage:F.localize(3,null),$ref:e.$0n};this.w(p,u),e.$4n.properties[p]=u,e.$5n.properties[p]=u,e.$6n.properties[p]=u,e.$7n.properties[p]=u,e.$8n.properties[p]=u,e.$9n.properties[p]=u}}v(){const t={type:"object",description:F.localize(4,null),errorMessage:F.localize(5,null),$ref:e.$0n};e.$4n.patternProperties[e.$_n]=t,e.$5n.patternProperties[e.$_n]=t,e.$6n.patternProperties[e.$_n]=t,e.$7n.patternProperties[e.$_n]=t,e.$8n.patternProperties[e.$_n]=t,e.$9n.patternProperties[e.$_n]=t,this.i.fire()}w(t,p){const u=this.a.get(t);let o=u?.value,v=u?.source;P.$1f(o)&&(o=p.defaultDefaultValue,v=void 0),P.$1f(o)&&(o=r(p.type)),p.default=o,p.defaultValueSource=v}}const k="\\[([^\\]]+)\\]",g=new RegExp(k,"g");e.$_n=`^(${k})+$`,e.$ao=new RegExp(e.$_n);function s(d){const t=[];if(e.$ao.test(d)){let p=g.exec(d);for(;p?.length;){const u=p[1].trim();u&&t.push(u),p=g.exec(d)}}return(0,S.$Mb)(t)}e.$bo=s;function a(d){return d.reduce((t,p)=>`${t}[${p}]`,"")}e.$co=a;function r(d){switch(Array.isArray(d)?d[0]:d){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$do=r;const i=new l;f.$Xn.add(e.$3n.Configuration,i);function n(d,t){return d.trim()?e.$ao.test(d)?F.localize(7,null,d):i.getConfigurationProperties()[d]!==void 0?F.localize(8,null,d):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?F.localize(9,null,d,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:F.localize(6,null)}e.$eo=n;function c(){const d=[],t=i.getConfigurationProperties();for(const p of Object.keys(t))d.push([p,t[p].scope]);return d.push(["launch",4]),d.push(["task",4]),d}e.$fo=c}),define(Pe[193],Re([1,0,18,5,122,6,28,26,16,2,46,56,30]),function(me,e,S,M,P,F,R,m,f,E,N,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=void 0;function k(p){return Object.isFrozen(p)?p:m.$Mn(p)}class g{constructor(u={},o=[],v=[],b){this.b=u,this.c=o,this.d=v,this.raw=b,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const u=this.raw.map(o=>{if(o instanceof g)return o;const v=new s("");return v.parseRaw(o),v.configurationModel});this.f=u.reduce((o,v)=>v===o?v:o.merge(v),u[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(u){return u?(0,N.$Ui)(this.contents,u):this.contents}inspect(u,o){const v=this;return{get value(){return k(v.rawConfiguration.getValue(u))},get override(){return o?k(v.rawConfiguration.getOverrideValue(u,o)):void 0},get merged(){return k(o?v.rawConfiguration.override(o).getValue(u):v.rawConfiguration.getValue(u))},get overrides(){const b=[];for(const{contents:$,identifiers:I,keys:h}of v.rawConfiguration.overrides){const y=new g($,h).getValue(u);y!==void 0&&b.push({identifiers:I,value:y})}return b.length?k(b):void 0}}}getOverrideValue(u,o){const v=this.i(o);return v?u?(0,N.$Ui)(v,u):v:void 0}getKeysForOverrideIdentifier(u){const o=[];for(const v of this.overrides)v.identifiers.includes(u)&&o.push(...v.keys);return S.$Mb(o)}getAllOverrideIdentifiers(){const u=[];for(const o of this.overrides)u.push(...o.identifiers);return S.$Mb(u)}override(u){let o=this.a.get(u);return o||(o=this.g(u),this.a.set(u,o)),o}merge(...u){const o=m.$Ln(this.contents),v=m.$Ln(this.overrides),b=[...this.keys],$=this.raw?.length?[...this.raw]:[this];for(const I of u)if($.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(o,I.contents);for(const h of I.overrides){const[y]=v.filter(w=>S.$ub(w.identifiers,h.identifiers));y?(this.h(y.contents,h.contents),y.keys.push(...h.keys),y.keys=S.$Mb(y.keys)):v.push(m.$Ln(h))}for(const h of I.keys)b.indexOf(h)===-1&&b.push(h)}return new g(o,b,v,$.every(I=>I instanceof g)?void 0:$)}g(u){const o=this.i(u);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const v={};for(const b of S.$Mb([...Object.keys(this.contents),...Object.keys(o)])){let $=this.contents[b];const I=o[b];I&&(typeof $=="object"&&typeof I=="object"?($=m.$Ln($),this.h($,I)):$=I),v[b]=$}return new g(v,this.keys,this.overrides)}h(u,o){for(const v of Object.keys(o)){if(v in u&&f.$Vf(u[v])&&f.$Vf(o[v])){this.h(u[v],o[v]);continue}u[v]=m.$Ln(o[v])}}i(u){let o=null,v=null;const b=$=>{$&&(v?this.h(v,$):v=m.$Ln($))};for(const $ of this.overrides)$.identifiers.length===1&&$.identifiers[0]===u?o=$.contents:$.identifiers.includes(u)&&b($.contents);return b(o),v}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,o){this.j(u,o,!0)}setValue(u,o){this.j(u,o,!1)}removeValue(u){const o=this.keys.indexOf(u);o!==-1&&(this.keys.splice(o,1),(0,N.$Ti)(this.contents,u),D.$ao.test(u)&&this.overrides.splice(this.overrides.findIndex(v=>S.$ub(v.identifiers,(0,D.$bo)(u))),1))}j(u,o,v){(0,N.$Si)(this.contents,u,o,b=>console.error(b)),v=v||this.keys.indexOf(u)===-1,v&&this.keys.push(u),D.$ao.test(u)&&this.overrides.push({identifiers:(0,D.$bo)(u),keys:Object.keys(this.contents[u]),contents:(0,N.$Ri)(this.contents[u],b=>console.error(b))})}}e.$go=g;class s{constructor(u){this.f=u,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(u,o){if(!f.$3f(u)){const v=this.g(u);this.parseRaw(v,o)}}reparse(u){this.a&&this.parseRaw(this.a,u)}parseRaw(u,o){this.a=u;const{contents:v,keys:b,overrides:$,restricted:I,hasExcludedProperties:h}=this.h(u,o);this.b=new g(v,b,$,h?[u]:void 0),this.c=I||[]}g(u){let o={},v=null,b=[];const $=[],I=[];function h(w){Array.isArray(b)?b.push(w):v!==null&&(b[v]=w)}const y={onObjectBegin:()=>{const w={};h(w),$.push(b),b=w,v=null},onObjectProperty:w=>{v=w},onObjectEnd:()=>{b=$.pop()},onArrayBegin:()=>{const w=[];h(w),$.push(b),b=w,v=null},onArrayEnd:()=>{b=$.pop()},onLiteralValue:h,onError:(w,A,L)=>{I.push({error:w,offset:A,length:L})}};if(u)try{P.$zn(u,y),o=b[0]||{}}catch(w){console.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return o}h(u,o){const v=l.$Xn.as(D.$3n.Configuration).getConfigurationProperties(),b=this.i(u,v,!0,o);u=b.raw;const $=(0,N.$Ri)(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),I=Object.keys(u),h=this.j(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:$,keys:I,overrides:h,restricted:b.restricted,hasExcludedProperties:b.hasExcludedProperties}}i(u,o,v,b){let $=!1;if(!b?.scopes&&!b?.skipRestricted&&!b?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:$};const I={},h=[];for(const y in u)if(D.$ao.test(y)&&v){const w=this.i(u[y],o,!1,b);I[y]=w.raw,$=$||w.hasExcludedProperties,h.push(...w.restricted)}else{const w=o[y],A=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&h.push(y),!b.exclude?.includes(y)&&(b.include?.includes(y)||(A===void 0||b.scopes===void 0||b.scopes.includes(A))&&!(b.skipRestricted&&w?.restricted))?I[y]=u[y]:$=!0}return{raw:I,restricted:h,hasExcludedProperties:$}}j(u,o){const v=[];for(const b of Object.keys(u))if(D.$ao.test(b)){const $={};for(const I in u[b])$[I]=u[b][I];v.push({identifiers:(0,D.$bo)(b),keys:Object.keys($),contents:(0,N.$Ri)($,o)})}return v}}e.$ho=s;class a extends F.$Tc{constructor(u,o,v,b){super(),this.c=u,this.f=o,this.g=b,this.b=this.B(new M.$6d),this.onDidChange=this.b.event,this.a=new s(this.c.toString()),this.B(this.g.watch(v.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,$=>$.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,$=>($.isOperation(0)||$.isOperation(3)||$.isOperation(1)||$.isOperation(4))&&v.isEqual($.resource,u)))(()=>this.b.fire()))}async loadConfiguration(){try{const u=await this.g.readFile(this.c);return this.a.parse(u.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new g}}reparse(u){return u&&(this.f=u),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$io=a;class r{constructor(u,o,v,b,$,I,h,y,w,A,L,J,W){this.a=u,this.b=o,this.c=v,this.overrideIdentifiers=b,this.d=$,this.f=I,this.g=h,this.h=y,this.i=w,this.j=A,this.k=L,this.l=J,this.m=W}get value(){return k(this.c)}n(u){return u?.value!==void 0||u?.override!==void 0||u?.overrides!==void 0?u:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(u,o,v,b,$=new g,I=new g,h=new R.$Ac,y=new g,w=new R.$Ac){this.c=u,this.d=o,this.f=v,this.g=b,this.h=$,this.i=I,this.j=h,this.l=y,this.m=w,this.a=null,this.b=new R.$Ac,this.n=null}getValue(u,o,v){return this.p(u,o,v).getValue(u)}updateValue(u,o,v={}){let b;v.resource?(b=this.m.get(v.resource),b||(b=new g,this.m.set(v.resource,b))):b=this.l,o===void 0?b.removeValue(u):b.setValue(u,o),v.resource||(this.a=null)}inspect(u,o,v){const b=this.p(u,o,v),$=this.t(o.resource,v),I=o.resource?this.m.get(o.resource)||this.l:this.l,h=new Set;for(const y of b.overrides)for(const w of y.identifiers)b.getOverrideValue(u,w)!==void 0&&h.add(w);return new r(u,o,b.getValue(u),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,v?this.i:void 0,$||void 0,I)}keys(u){const o=this.t(void 0,u);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(u){this.c=u,this.a=null,this.b.clear()}updatePolicyConfiguration(u){this.d=u}updateApplicationConfiguration(u){this.f=u,this.a=null,this.b.clear()}updateLocalUserConfiguration(u){this.g=u,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(u){this.h=u,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(u){this.i=u,this.a=null,this.b.clear()}updateFolderConfiguration(u,o){this.j.set(u,o),this.b.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this.b.delete(u)}compareAndUpdateDefaultConfiguration(u,o){const v=[];if(!o){const{added:b,updated:$,removed:I}=d(this.c,u);o=[...b,...$,...I]}for(const b of o)for(const $ of(0,D.$bo)(b)){const I=this.c.getKeysForOverrideIdentifier($),h=u.getKeysForOverrideIdentifier($),y=[...h.filter(w=>I.indexOf(w)===-1),...I.filter(w=>h.indexOf(w)===-1),...I.filter(w=>!m.$Pn(this.c.override($).getValue(w),u.override($).getValue(w)))];v.push([$,y])}return this.updateDefaultConfiguration(u),{keys:o,overrides:v}}compareAndUpdatePolicyConfiguration(u){const{added:o,updated:v,removed:b}=d(this.d,u),$=[...o,...v,...b];return $.length&&this.updatePolicyConfiguration(u),{keys:$,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:o,updated:v,removed:b,overrides:$}=d(this.applicationConfiguration,u),I=[...o,...v,...b];return I.length&&this.updateApplicationConfiguration(u),{keys:I,overrides:$}}compareAndUpdateLocalUserConfiguration(u){const{added:o,updated:v,removed:b,overrides:$}=d(this.localUserConfiguration,u),I=[...o,...v,...b];return I.length&&this.updateLocalUserConfiguration(u),{keys:I,overrides:$}}compareAndUpdateRemoteUserConfiguration(u){const{added:o,updated:v,removed:b,overrides:$}=d(this.remoteUserConfiguration,u),I=[...o,...v,...b];return I.length&&this.updateRemoteUserConfiguration(u),{keys:I,overrides:$}}compareAndUpdateWorkspaceConfiguration(u){const{added:o,updated:v,removed:b,overrides:$}=d(this.workspaceConfiguration,u),I=[...o,...v,...b];return I.length&&this.updateWorkspaceConfiguration(u),{keys:I,overrides:$}}compareAndUpdateFolderConfiguration(u,o){const v=this.folderConfigurations.get(u),{added:b,updated:$,removed:I,overrides:h}=d(v,o),y=[...b,...$,...I];return(y.length||!v)&&this.updateFolderConfiguration(u,o),{keys:y,overrides:h}}compareAndDeleteFolderConfiguration(u){const o=this.folderConfigurations.get(u);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:v,updated:b,removed:$,overrides:I}=d(o,void 0);return{keys:[...v,...b,...$],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(u,o,v){let b=this.q(o,v);return o.overrideIdentifier&&(b=b.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(u)!==void 0&&(b=b.merge(this.d)),b}q({resource:u},o){let v=this.r();if(o&&u){const b=o.getFolder(u);b&&(v=this.s(b.uri)||v);const $=this.m.get(u);$&&(v=v.merge($))}return v}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(u){let o=this.b.get(u);if(!o){const v=this.r(),b=this.j.get(u);b?(o=v.merge(b),this.b.set(u,o)):o=v}return o}t(u,o){if(o&&u){const v=o.getFolder(u);if(v)return this.j.get(v.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((u,o)=>{const{contents:v,overrides:b,keys:$}=this.j.get(o);return u.push([o,{contents:v,overrides:b,keys:$}]),u},[])}}allKeys(){const u=new Set;return this.c.keys.forEach(o=>u.add(o)),this.userConfiguration.keys.forEach(o=>u.add(o)),this.i.keys.forEach(o=>u.add(o)),this.j.forEach(o=>o.keys.forEach(v=>u.add(v))),[...u.values()]}u(){const u=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>u.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>u.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>u.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(v=>u.add(v))),[...u.values()]}v(u){const o=new Set;return this.c.getKeysForOverrideIdentifier(u).forEach(v=>o.add(v)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(v=>o.add(v)),this.i.getKeysForOverrideIdentifier(u).forEach(v=>o.add(v)),this.j.forEach(v=>v.getKeysForOverrideIdentifier(u).forEach(b=>o.add(b))),[...o.values()]}static parse(u){const o=this.w(u.defaults),v=this.w(u.policy),b=this.w(u.application),$=this.w(u.user),I=this.w(u.workspace),h=u.folders.reduce((y,w)=>(y.set(E.URI.revive(w[0]),this.w(w[1])),y),new R.$Ac);return new i(o,v,b,$,new g,I,h,new g,new R.$Ac)}static w(u){return new g(u.contents,u.keys,u.overrides)}}e.$jo=i;function n(...p){if(p.length===0)return{keys:[],overrides:[]};if(p.length===1)return p[0];const u=new Set,o=new Map;for(const b of p)b.keys.forEach($=>u.add($)),b.overrides.forEach(([$,I])=>{const h=(0,R.$xc)(o,$,new Set);I.forEach(y=>h.add(y))});const v=[];return o.forEach((b,$)=>v.push([$,[...b.values()]])),{keys:[...u.values()],overrides:v}}e.$ko=n;class c{constructor(u,o,v,b){this.change=u,this.f=o,this.g=v,this.h=b,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const $ of u.keys)this.affectedKeys.add($);for(const[,$]of u.overrides)for(const I of $)this.affectedKeys.add(I);this.d=this.a;for(const $ of this.affectedKeys)this.d+=$+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(u,o){const v=this.a+u,b=this.d.indexOf(v);if(b<0)return!1;const $=b+v.length;if($>=this.d.length)return!1;const I=this.d.charCodeAt($);if(I!==this.b&&I!==this.c)return!1;if(o){const h=this.previousConfiguration?this.previousConfiguration.getValue(u,o,this.f?.workspace):void 0,y=this.g.getValue(u,o,this.h);return!m.$Pn(h,y)}return!0}}e.$lo=c;function d(p,u){const{added:o,removed:v,updated:b}=t(u?.rawConfiguration,p?.rawConfiguration),$=[],I=p?.getAllOverrideIdentifiers()||[],h=u?.getAllOverrideIdentifiers()||[];if(u){const y=h.filter(w=>!I.includes(w));for(const w of y)$.push([w,u.getKeysForOverrideIdentifier(w)])}if(p){const y=I.filter(w=>!h.includes(w));for(const w of y)$.push([w,p.getKeysForOverrideIdentifier(w)])}if(u&&p){for(const y of I)if(h.includes(y)){const w=t({contents:p.getOverrideValue(void 0,y)||{},keys:p.getKeysForOverrideIdentifier(y)},{contents:u.getOverrideValue(void 0,y)||{},keys:u.getKeysForOverrideIdentifier(y)});$.push([y,[...w.added,...w.removed,...w.updated]])}}return{added:o,removed:v,updated:b,overrides:$}}function t(p,u){const o=p?u?p.keys.filter($=>u.keys.indexOf($)===-1):[...p.keys]:[],v=u?p?u.keys.filter($=>p.keys.indexOf($)===-1):[...u.keys]:[],b=[];if(p&&u){for(const $ of u.keys)if(p.keys.indexOf($)!==-1){const I=(0,N.$Ui)(u.contents,$),h=(0,N.$Ui)(p.contents,$);m.$Pn(I,h)||b.push($)}}return{added:o,removed:v,updated:b}}}),define(Pe[102],Re([1,0,14,3]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ol=e.RemoteAuthorityResolverErrorCode=e.$nl=e.$ml=e.RemoteConnectionType=e.$ll=void 0,e.$ll=(0,M.$gi)("remoteAuthorityResolverService");var P;(function(N){N[N.WebSocket=0]="WebSocket",N[N.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class F{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$ml=F;class R{constructor(D,l){this.host=D,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$nl=R;var m;(function(N){N.Unknown="Unknown",N.NotAvailable="NotAvailable",N.TemporarilyNotAvailable="TemporarilyNotAvailable",N.NoResolverFound="NoResolverFound",N.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class f extends S.$bb{static isNotAvailable(D){return D instanceof f&&D._code===m.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof f&&D._code===m.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof f&&D._code===m.NoResolverFound}static isInvalidAuthority(D){return D instanceof f&&D._code===m.InvalidAuthority}static isHandled(D){return D instanceof f&&D.isHandled}constructor(D,l=m.Unknown,k){super(D),this._message=D,this._code=l,this._detail=k,this.isHandled=l===m.NotAvailable&&k===!0,Object.setPrototypeOf(this,f.prototype)}}e.$ol=f;function E(N){const D=N.indexOf("+");return D===-1?N:N.substring(0,D)}e.$pl=E}),define(Pe[57],Re([1,0,12]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=e.$rm=e.$qm=void 0;function M(f){return f.scheme===S.Schemas.vscodeRemote?f.authority:void 0}e.$qm=M;function P(f){if(!f)return;const E=f.indexOf("+");return E<0?f:f.substr(0,E)}e.$rm=P;function F(f){const{host:E,port:N}=m(f);if(typeof N>"u")throw new Error(`Invalid remote authority: ${f}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:N}}e.$sm=F;function R(f,E){let{host:N,port:D}=m(f);return typeof D>"u"&&(D=E),{host:N,port:D}}e.$tm=R;function m(f){const E=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const N=f.match(/^(\[[0-9a-z:]+\])$/);if(N)return{host:N[1],port:void 0};const D=f.match(/(.*):(\d+)$/);return D?{host:D[1],port:parseInt(D[2],10)}:{host:f,port:void 0}}}),define(Pe[20],Re([1,0,15,3,57]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.TargetPlatform=e.ExtensionType=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=void 0,e.$um="extensions.user.cache",e.$vm="extensions.builtin.cache",e.$wm="undefined_publisher",e.$xm=["ui","workspace","web"];function F(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$ym=F,e.$zm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(R||(e.ExtensionType=R={}));var m;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class f{constructor(a){this.value=a,this._lower=a.toLowerCase()}static equals(a,r){if(typeof a>"u"||a===null)return typeof r>"u"||r===null;if(typeof r>"u"||r===null)return!1;if(typeof a=="string"||typeof r=="string"){const i=typeof a=="string"?a:a.value,n=typeof r=="string"?r:r.value;return S.$kf(i,n)}return a._lower===r._lower}static toKey(a){return typeof a=="string"?a.toLowerCase():a._lower}}e.$Am=f;class E{get size(){return this.c.size}constructor(a){if(this.c=new Set,a)for(const r of a)this.add(r)}add(a){this.c.add(f.toKey(a))}delete(a){return this.c.delete(f.toKey(a))}has(a){return this.c.has(f.toKey(a))}}e.$Bm=E;class N{constructor(){this.c=new Map}clear(){this.c.clear()}delete(a){this.c.delete(f.toKey(a))}get(a){return this.c.get(f.toKey(a))}has(a){return this.c.has(f.toKey(a))}set(a,r){this.c.set(f.toKey(a),r)}values(){return this.c.values()}forEach(a){this.c.forEach(a)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Cm=N;function D(s){return l(s)}e.$Dm=D;function l(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}e.$Em=l;function k(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}e.$Fm=k;function g(s,a){if(a){const r=`onResolveRemoteAuthority:${(0,P.$rm)(a)}`;return!!s.activationEvents?.includes(r)}return!1}e.$Gm=g,e.$Hm=(0,M.$gi)("IBuiltinExtensionsScannerService")}),define(Pe[103],Re([1,0,14,20]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FF=e.$EF=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(R,m){this.a.set(R,m)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const m=Object.create(null);for(const f of R){const E=this.readActivationEvents(f);E.length>0&&(m[M.$Am.toKey(f.identifier)]=E)}return m}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const m=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let f=0;f<m.length;f++)m[f]==="onUri"&&(m[f]=`onUri:${M.$Am.toKey(R.identifier)}`);if(!R.contributes)return m;for(const f in R.contributes){const E=this.a.get(f);if(!E)continue;const N=R.contributes[f],D=Array.isArray(N)?N:[N];try{E(D,m)}catch(l){(0,S.$1)(l)}}return m}}e.$EF=P,e.$FF=new P}),define(Pe[194],Re([1,0,21,73,33]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=void 0;function F(f){if(S.$u===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function R(f,E,N,D,l,k,g,s,a){const r=Object.create(null);r["common.machineId"]=k,r["common.sqmId"]=g,r.sessionID=(0,P.$Cg)()+Date.now(),r.commitHash=D,r.version=l,r["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,S.$h)(S.$u),r["common.nodePlatform"]=M.$dc,r["common.nodeArch"]=N,r["common.product"]=a||"desktop",s&&(r["common.msftInternal"]=s);let i=0;const n=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),S.$l&&(r["common.snap"]="true");const c=F(E);return c&&(r["common.platformDetail"]=c),r}e.$Yo=R;function m(f){const E=M.env.USERDNSDOMAIN;if(!E)return!1;const N=E.toLowerCase();return f.some(D=>N===D)}e.$Zo=m}),define(Pe[195],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=void 0,e.$Fl=(0,S.$gi)("telemetryService"),e.$Gl=(0,S.$gi)("customEndpointTelemetryService"),e.$Hl="telemetry.currentSessionDate",e.$Il="telemetry.firstSessionDate",e.$Jl="telemetry.lastSessionDate",e.$Kl="telemetry.machineId",e.$Ll="telemetry.sqmId",e.$Ml="telemetry",e.$Nl="telemetry.telemetryLevel",e.$Ol="telemetry.enableCrashReporter",e.$Pl="telemetry.enableTelemetry";var M;(function(F){F[F.NONE=0]="NONE",F[F.CRASH=1]="CRASH",F[F.ERROR=2]="ERROR",F[F.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var P;(function(F){F.OFF="off",F.CRASH="crash",F.ERROR="error",F.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Pe[58],Re([1,0,26,16,57,194,195]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0;class m{constructor(p){this.value=p,this.isTrustedTelemetryValue=!0}}e.$1o=m;class f{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$2o=f,e.$3o=new f;class E{async publicLog(p,u,o){}async publicLogError(p,u,o){}}e.$4o=E,e.$5o="telemetry",e.$6o="extensionTelemetryLog",e.$7o={log:()=>null,flush:()=>Promise.resolve(null)};function N(t,p){return!p.isBuilt&&!p.disableTelemetry?!0:!(p.disableTelemetry||!t.enableTelemetry)}e.$8o=N;function D(t,p){return p.extensionTestsLocationURI?!0:!(p.isBuilt||p.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$9o=D;function l(t){const p=t.getValue(R.$Nl),u=t.getValue(R.$Ol);if(t.getValue(R.$Pl)===!1||u===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$0o=l;function k(t){const p={},u={},o={};a(t,o);for(let v in o){v=v.length>150?v.substr(v.length-149):v;const b=o[v];typeof b=="number"?u[v]=b:typeof b=="boolean"?u[v]=b?1:0:typeof b=="string"?(b.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${b.length}`),p[v]=b.substring(0,8191)):typeof b<"u"&&b!==null&&(p[v]=b)}return{properties:p,measurements:u}}e.$$o=k;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(t){if(!t)return"none";const p=(0,P.$rm)(t);return g.has(p)?p:"other"}e.$_o=s;function a(t,p,u=0,o){if(t)for(const v of Object.getOwnPropertyNames(t)){const b=t[v],$=o?o+v:v;Array.isArray(b)?p[$]=(0,S.$Qn)(b):b instanceof Date?p[$]=b.toISOString():(0,M.$Vf)(b)?u<2?a(b,p,u+1,$+"."):p[$]=(0,S.$Qn)(b):p[$]=b}}function r(t,p){const u=t.msftInternalDomains||[],o=p.getValue("telemetry.internalTesting");return(0,F.$Zo)(u)||o}e.$ap=r;function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$bp=i;function n(t,p){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let u=t;const o=[];for(const I of p)for(;;){const h=I.exec(t);if(!h)break;o.push([h.index,I.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,b=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let $=0;for(u="";;){const I=b.exec(t);if(!I)break;const h=o.some(([y,w])=>I.index<w&&y<b.lastIndex);!v.test(I[0])&&!h&&(u+=t.substring($,I.index)+"<REDACTED: user-file-path>",$=b.lastIndex)}return $<t.length&&(u+=t.substr($)),u}function c(t){if(!t)return t;const p=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of p)if(u.regex.test(t))return`<REDACTED: ${u.label}>`;return t}function d(t,p){return(0,S.$Nn)(t,u=>{if(u instanceof m||Object.hasOwnProperty.call(u,"isTrustedTelemetryValue"))return u.value;if(typeof u=="string"){let o=u.replaceAll("%20"," ");o=n(o,p);for(const v of p)o=o.replace(v,"");return o=c(o),o}})}e.$cp=d}),define(Pe[196],Re([1,0,15,98,20,21,2,14,73,58]),function(me,e,S,M,P,F,R,m,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=void 0;function N(u,o){return u.uuid&&o.uuid?u.uuid===o.uuid:u.id===o.id?!0:(0,S.$ff)(u.id,o.id)===0}e.$dp=N;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(o){const v=o.manifest?o.manifest.version:o.version,b=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new l(o.identifier,v,b)}static parse(o){const v=D.exec(o);return v&&v[1]&&v[2]?new l({id:v[1]},v[2],v[4]||void 0):null}constructor(o,v,b="undefined"){this.version=v,this.targetPlatform=b,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof l?N(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$ep=l;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(u){const o=k.exec(u);return o&&o[1]?[a(o[1]),o[2]]:[a(u),void 0]}e.$fp=g;function s(u,o){return`${u}.${o}`}e.$gp=s;function a(u){return u.toLowerCase()}e.$hp=a;function r(u,o){return a(s(u??P.$wm,o))}e.$ip=r;function i(u,o){const v=[],b=$=>{for(const I of v)if(I.some(h=>N(o(h),o($))))return I;return null};for(const $ of u){const I=b($);I?I.push($):v.push([$])}return v}e.$jp=i;function n(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.$kp=n;function c(u){return{id:new E.$1o(u.identifier.id),name:new E.$1o(u.name),galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.$lp=c,e.$mp=new P.$Am("pprice.better-merge");function d(u,o){const v=[],b=o.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const $=b.shift();if($&&v.every(I=>!N(I.identifier,{id:$}))){const I=u.filter(h=>N(h.identifier,{id:$}));I.length===1&&(v.push(I[0]),b.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.$np=d;async function t(u,o){if(!F.$k)return!1;let v;try{v=(await u.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{v=(await u.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch($){o.debug("Error while getting the os-release file.",(0,m.$0)($))}}return!!v&&(v.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function p(u,o){const v=await t(u,o),b=(0,M.$Ko)(v?"alpine":F.$u,f.$ec);return o.debug("ComputeTargetPlatform:",b),b}e.$op=p}),define(Pe[197],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=e.$6r=e.$5r=e.$4r=e.$3r=e.$2r=void 0;function S(f){return[...f.entries()]}e.$2r=S;function M(f){return f?[...f.entries()]:[]}e.$3r=M;function P(f){return new Map(f)}e.$4r=P;function F(f){return new Map(f??[])}e.$5r=F;function R(f){return Array.from(f.entries()).map(E=>[E[0],S(E[1].map),M(E[1].descriptionMap)])}e.$6r=R;function m(f){return new Map(f.map(E=>[E[0],{map:P(E[1]),descriptionMap:F(E[2])}]))}e.$7r=m}),define(Pe[198],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qtb=void 0;class S{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,F,R=5){const m=F(f=>{const E=typeof f=="string"?f:f.data;let N=this.a.get(P);if(N){N.data.push(E);return}const D=setTimeout(()=>this.flushBuffer(P),R);N={data:[E],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(P),m.dispose()}},this.a.set(P,N)});return m}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const F=this.a.get(P);F&&(this.a.delete(P),this.b(P,F.data.join("")))}}e.$Qtb=S}),define(Pe[199],Re([1,0,11,91,298,40,5,16,2,158,72,30]),function(me,e,S,M,P,F,R,m,f,E,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uw=e.$Tw=e.$Sw=e.$Rw=e.$Qw=e.$Pw=e.$Ow=e.$Nw=e.IconFontDefinition=e.IconContribution=e.$Mw=void 0,e.$Mw={IconContribution:"base.contributions.icons"};var l;(function(d){function t(p,u){let o=p.defaults;for(;F.ThemeIcon.isThemeIcon(o);){const v=s.getIcon(o.id);if(!v)return;o=v.defaults}return o}d.getDefinition=t})(l||(e.IconContribution=l={}));var k;(function(d){function t(u){return{weight:u.weight,style:u.style,src:u.src.map(o=>({format:o.format,location:o.location.toString()}))}}d.toJSONObject=t;function p(u){const o=v=>(0,m.$Tf)(v)?v:void 0;if(u&&Array.isArray(u.src)&&u.src.every(v=>(0,m.$Tf)(v.format)&&(0,m.$Tf)(v.location)))return{weight:o(u.weight),style:o(u.style),src:u.src.map(v=>({format:v.format,location:f.URI.parse(v.location)}))}}d.fromJSONObject=p})(k||(e.IconFontDefinition=k={}));class g{constructor(){this.a=new R.$6d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${F.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,p,u,o){const v=this.b[t];if(v){if(u&&!v.description){v.description=u,this.d.properties[t].markdownDescription=`${u} $(${t})`;const I=this.e.enum.indexOf(t);I!==-1&&(this.e.enumDescriptions[I]=u),this.a.fire()}return v}const b={id:t,description:u,defaults:p,deprecationMessage:o};this.b[t]=b;const $={$ref:"#/definitions/icons"};return o&&($.deprecationMessage=o),u&&($.markdownDescription=`${u}: $(${t})`),this.d.properties[t]=$,this.e.enum.push(t),this.e.enumDescriptions.push(u||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const p=this.e.enum.indexOf(t);p!==-1&&(this.e.enum.splice(p,1),this.e.enumDescriptions.splice(p,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,p){const u=this.f[t];return u||(this.f[t]=p,this.a.fire(),p)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(v,b)=>v.id.localeCompare(b.id),p=v=>{for(;F.ThemeIcon.isThemeIcon(v.defaults);)v=this.b[v.defaults.id];return`codicon codicon-${v?v.id:""}`},u=[];u.push("| preview     | identifier                        | default codicon ID                | description"),u.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.b).map(v=>this.b[v]);for(const v of o.filter(b=>!!b.description).sort(t))u.push(`|<i class="${p(v)}"></i>|${v.id}|${F.ThemeIcon.isThemeIcon(v.defaults)?v.defaults.id:v.id}|${v.description||""}|`);u.push("| preview     | identifier                        "),u.push("| ----------- | --------------------------------- |");for(const v of o.filter(b=>!F.ThemeIcon.isThemeIcon(b.defaults)).sort(t))u.push(`|<i class="${p(v)}"></i>|${v.id}|`);return u.join(`
`)}}const s=new g;D.$Xn.add(e.$Mw.IconContribution,s);function a(d,t,p,u){return s.registerIcon(d,t,p,u)}e.$Nw=a;function r(){return s}e.$Ow=r;function i(){const d=(0,P.$lk)();for(const t in d){const p="\\"+d[t].toString(16);s.registerIcon(t,{fontCharacter:p})}}i(),e.$Pw="vscode://schemas/icons";const n=D.$Xn.as(N.$Yn.JSONContribution);n.registerSchema(e.$Pw,s.getIconSchema());const c=new S.$sh(()=>n.notifySchemaChanged(e.$Pw),200);s.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$Qw=a("widget-close",M.$pk.close,(0,E.localize)(2,null)),e.$Rw=a("goto-previous-location",M.$pk.arrowUp,(0,E.localize)(3,null)),e.$Sw=a("goto-next-location",M.$pk.arrowDown,(0,E.localize)(4,null)),e.$Tw=F.ThemeIcon.modify(M.$pk.sync,"spin"),e.$Uw=F.ThemeIcon.modify(M.$pk.loading,"spin")}),define(Pe[200],Re([1,0,5,46,3,13]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=e.$Uv=e.$Tv=e.ProvidedOnAutoForward=e.$Sv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Rv=e.$Qv=void 0,e.$Qv=(0,P.$gi)("tunnelService"),e.$Rv=(0,P.$gi)("sharedTunnelsService");var R;(function(a){a.Http="http",a.Https="https"})(R||(e.TunnelProtocol=R={}));var m;(function(a){a.ConstantPrivate="constantPrivate",a.Private="private",a.Public="public"})(m||(e.TunnelPrivacyId=m={}));function f(a){return!!a.forwardPort}e.$Sv=f;var E;(function(a){a[a.Notify=1]="Notify",a[a.OpenBrowser=2]="OpenBrowser",a[a.OpenPreview=3]="OpenPreview",a[a.Silent=4]="Silent",a[a.Ignore=5]="Ignore",a[a.OpenBrowserOnce=6]="OpenBrowserOnce"})(E||(e.ProvidedOnAutoForward=E={}));function N(a){if(a.scheme!=="http"&&a.scheme!=="https")return;const r=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(a.authority);if(r)return{address:r[1],port:+r[2]}}e.$Tv=N,e.$Uv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(a){return e.$Uv.indexOf(a)>=0}e.$Vv=D,e.$Wv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(a){return e.$Wv.indexOf(a)>=0}e.$Xv=l;function k(a,r,i,n){if(i===1)return!1;if(i===2&&l(r)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(c?.length===4&&parseInt(c[1])>=18)return!1}return a<1024}e.$Yv=k;class g{constructor(r,i,n){this.remoteAddress=r,this.localAddress=i,this.b=n,this.a=new S.$6d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Zv=g;let s=class{constructor(r,i){this.k=r,this.l=i,this.a=new S.$6d,this.onTunnelOpened=this.a.event,this.b=new S.$6d,this.onTunnelClosed=this.b.event,this.c=new S.$6d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const r=this.l.getValue("remote.localPortHost");return!r||r==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(r){return this.f=r,r?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(r){this.g=r.elevation,this.i=r.privacyOptions,this.h=r.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const r=[],i=Array.from(this.e.values());for(const n of i){const c=Array.from(n.values());for(const d of c){const t=await d.value;t&&typeof t!="string"&&r.push(t)}}return r}async dispose(){for(const r of this.e.values()){for(const{value:i}of r.values())await i.then(n=>typeof n!="string"?n?.dispose():void 0);r.clear()}this.e.clear()}setEnvironmentTunnel(r,i,n,c,d){this.q(r,i,Promise.resolve({tunnelRemoteHost:r,tunnelRemotePort:i,localAddress:n,privacy:c,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(r,i){(l(r)||D(r))&&(r=e.$Uv[0]);const n=this.s(r,i);if(n)return++n.refcount,n.value}openTunnel(r,i,n,c,d,t=!1,p,u){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${n} on local port ${d}.`);const o=this.f??r;if(!o)return;if(i||(i="localhost"),c||(c=this.m),this.f&&this.j.has(n)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const v=this.t(o,i,n,c,d,t,p,u);return v?v.then(b=>{if(b){if(typeof b=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(i,n),b}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(i,n);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const $=this.o(b);return(b.tunnelRemoteHost!==i||b.tunnelRemotePort!==n)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),p&&b.privacy!==p&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire($),$}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}o(r){return{tunnelRemotePort:r.tunnelRemotePort,tunnelRemoteHost:r.tunnelRemoteHost,tunnelLocalPort:r.tunnelLocalPort,localAddress:r.localAddress,privacy:r.privacy,protocol:r.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${r.tunnelRemoteHost}:${r.tunnelRemotePort} `);const i=this.e.get(r.tunnelRemoteHost);if(i){const n=i.get(r.tunnelRemotePort);n&&(n.refcount--,await this.p(r.tunnelRemoteHost,r.tunnelRemotePort,n))}}}}async p(r,i,n){if(n.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${r}:${i}.`);const c=n.value.then(async d=>{d&&typeof d!="string"&&(await d.dispose(!0),this.b.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this.e.has(r)&&this.e.get(r).delete(i),c}}async closeTunnel(r,i){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${r}:${i} `);const n=this.e.get(r);if(n&&n.has(i)){const c=n.get(i);c.refcount=0,await this.p(r,i,c)}}q(r,i,n){this.e.has(r)||this.e.set(r,new Map),this.e.get(r).set(i,{refcount:1,value:n})}async r(r,i){const n=this.e.get(r);if(n){const c=n.get(i),d=c?await c.value:void 0;(!d||typeof d=="string")&&n.delete(i),n.size===0&&this.e.delete(r)}}s(r,i){const n=[r];D(r)?(n.push(...e.$Uv),n.push(...e.$Wv)):l(r)&&n.push(...e.$Wv);const c=n.map(d=>this.e.get(d));for(const d of c){const t=d?.get(i);if(t)return t}}canTunnel(r){return!!N(r)}u(r,i,n,c,d,t,p){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${n} on local port ${c}.`);const u=n;this.j.add(u);const o=c===void 0?n:c,v={elevationRequired:d?this.isPortPrivileged(o):!1},b={remoteAddress:{host:i,port:n},localAddressPort:c,privacy:t,public:t?t!==m.Private:void 0,protocol:p},$=r.forwardPort(b,v);return $?(this.q(i,n,$),$.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(u)})):this.j.delete(u),$}};e.$1v=s,e.$1v=s=Qe([qe(0,F.$Aj),qe(1,M.$Mi)],s)}),define(Pe[201],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$2v=void 0,e.$2v=(0,S.$gi)("editSessionIdentityService");var M;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Pe[202],Re([1,0,12]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=void 0;function M(f){return f.scheme!==S.Schemas.file&&f.scheme!==S.Schemas.vscodeRemote}e.$GL=M;function P(f){if(f.folders.length)return f.folders.every(E=>M(E.uri))?f.folders[0].uri:void 0;if(f.configuration&&M(f.configuration))return f.configuration}e.$HL=P;function F(f){return P(f)?.scheme}e.$IL=F;function R(f){return P(f)?.authority}e.$JL=R;function m(f){return P(f)!==void 0}e.$KL=m}),define(Pe[47],Re([1,0,159,19,50,24,2,3,12]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.WorkbenchState=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=void 0,e.$pi=(0,m.$gi)("contextService");function E(o){const v=o;return typeof v?.id=="string"&&R.URI.isUri(v.uri)}e.$qi=E;function N(o){return typeof o?.id=="string"&&!E(o)&&!l(o)}e.$ri=N,e.$si={id:"ext-dev"},e.$ti={id:"empty-window"};function D(o,v){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,M.$nc)(o)}:v?e.$si:e.$ti;const b=o;return b.configuration?{id:b.id,configPath:b.configuration}:b.folders.length===1?{id:b.id,uri:b.folders[0].uri}:{id:b.id}}e.$ui=D;function l(o){const v=o;return typeof v?.id=="string"&&R.URI.isUri(v.configPath)}e.$vi=l;function k(o){const v=o;if(v?.uri)return{id:v.id,uri:R.URI.revive(v.uri)};const b=o;if(b?.configPath)return{id:b.id,configPath:R.URI.revive(b.configPath)};if(o?.id)return{id:o.id}}e.$wi=k;var g;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function s(o){const v=o;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.$xi=s;function a(o){const v=o;return!!(v&&typeof v=="object"&&R.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.$yi=a;class r{constructor(v,b,$,I,h){this.h=v,this.j=$,this.k=I,this.l=h,this.c=P.$mi.forUris(this.l,()=>!0),this.folders=b}update(v){this.h=v.id,this.k=v.configuration,this.j=v.transient,this.l=v.l,this.folders=v.folders}get folders(){return this.g}set folders(v){this.g=v,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(v){this.k=v}getFolder(v){return v&&this.c.findSubstr(v)||null}n(){this.c=P.$mi.forUris(this.l,()=>!0);for(const v of this.folders)this.c.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$zi=r;class i{constructor(v,b){this.raw=b,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,F.$Tg)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ai=i;function n(o){return new i({uri:o,index:0,name:(0,F.$Pg)(o)},{uri:o.toString()})}e.$Bi=n,e.$Ci="code-workspace",e.$Di=`.${e.$Ci}`,e.$Ei=[{name:(0,S.localize)(0,null),extensions:[e.$Ci]}],e.$Fi="workspace.json";function c(o,v){return F.$Kg.isEqualOrParent(o,v.untitledWorkspacesHome)}e.$Gi=c;function d(o){let v;return R.URI.isUri(o)?v=o:v=o.configuration,v?.scheme===f.Schemas.tmp}e.$Hi=d,e.$Ii="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(o){return o.id===e.$Ii}e.$Ji=t;function p(o,v){return!c(o,v)&&!d(o)}e.$Ki=p;function u(o){return(typeof o=="string"?(0,M.$oc)(o):(0,F.$Rg)(o))===e.$Di}e.$Li=u}),define(Pe[74],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=void 0;class S{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const F=this.c++;return this.b.set(F,P),this.e(),F}get(P,F){return this.b.has(P)?this.b.get(P)[F]:void 0}delete(P){this.b.delete(P),this.e()}e(){S.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$aic=S}),define(Pe[43],Re([1,0,12,24,3]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gic=e.$fic=void 0;class F{constructor(){this.a=new Set(Object.keys(S.Schemas)),this.b=new Map,this.extUri=new M.$Ig(m=>{const f=this.b.get(m.scheme);return!(f===void 0||f&1024)})}$acceptProviderInfos(m,f){f===null?this.b.delete(m.scheme):this.b.set(m.scheme,f)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$fic=F,e.$gic=(0,P.$gi)("IExtHostFileSystemInfo")}),define(Pe[27],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FO=void 0,e.$FO=(0,S.$gi)("IExtHostInitDataService")}),define(Pe[203],Re([1,0,165,13,190,27]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mkc=void 0;let R=class extends P.$NP{constructor(f,E,N){const D=N.remote.isRemote?"remoteexthost":f?"workerexthost":"exthost",l=N.remote.isRemote?(0,S.localize)(0,null):f?(0,S.localize)(1,null):(0,S.localize)(2,null);super(E.createLogger(D,{name:l}))}};e.$mkc=R,e.$mkc=R=Qe([qe(1,M.$Bj),qe(2,F.$FO)],R)}),define(Pe[204],Re([1,0,11]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=e.$1ic=void 0;class M{constructor(R,m,f){this.h=new Map,this.a=R,this.b=m,this.c=f,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new S.$sh(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const N of E.values())N.complete()}catch(N){for(const D of E.values())D.error(N)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,m){let f=this.f[R];return typeof f>"u"&&(f=m),f}update(R,m){this.f[R]=m;const f=this.h.get(R);if(f!==void 0)return f.p;const E=new S.$Dh;return this.h.set(R,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$1ic=M;class P extends M{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,m){super(R.identifier.value,!0,m),this.j=R}}e.$2ic=P}),define(Pe[205],Re([1,0,5,2]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ojc=void 0;class P{constructor(R){this.c=R,this.a=new S.$6d,this.onDidSaveNotebookDocument=this.a.event,this.b=new S.$6d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,m,f,E){const D=this.c.getNotebookDocument(M.URI.revive(R)).acceptModelChanged(m.value,f,E);this.b.fire(D)}$acceptDirtyStateChanged(R,m){this.c.getNotebookDocument(M.URI.revive(R)).acceptDirty(m)}$acceptModelSaved(R){const m=this.c.getNotebookDocument(M.URI.revive(R));this.a.fire(m.apiNotebook)}}e.$Ojc=P}),define(Pe[17],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qO=e.$pO=void 0,e.$pO=(0,S.$gi)("IExtHostRpcService");class M{constructor(F){this.getProxy=F.getProxy.bind(F),this.set=F.set.bind(F),this.dispose=F.dispose.bind(F),this.assertRegistered=F.assertRegistered.bind(F),this.drain=F.drain.bind(F)}}e.$qO=M}),define(Pe[206],Re([1,0,20,5]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ic=void 0;class P{#e;constructor(R,m){this.b=new M.$6d,this.onDidChange=this.b.event,this.a=S.$Am.toKey(R.identifier),this.#e=m,this.#e.onDidChangePassword(f=>{f.extensionId===this.a&&this.b.fire({key:f.key})})}get(R){return this.#e.get(this.a,R)}store(R,m){return this.#e.store(this.a,R,m)}delete(R){return this.#e.delete(this.a,R)}}e.$9ic=P}),define(Pe[59],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zic=e.$yic=void 0,e.$yic=(0,S.$gi)("IURITransformerService");class M{constructor(F){F?(this.transformIncoming=F.transformIncoming.bind(F),this.transformOutgoing=F.transformOutgoing.bind(F),this.transformOutgoingURI=F.transformOutgoingURI.bind(F),this.transformOutgoingScheme=F.transformOutgoingScheme.bind(F)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$zic=M}),define(Pe[207],Re([1,0,23]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knb=e.$jnb=void 0;class M{constructor(){this.buffers=[]}add(f){let E=this.buffers.indexOf(f);return E<0&&(E=this.buffers.length,this.buffers.push(f)),E}}function P(m,f){if(f.serializeBuffersForPostMessage){const E=new M,D=JSON.stringify(m,(k,g)=>{if(g instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(g)};if(ArrayBuffer.isView(g)){const s=F(g);if(s)return{$$vscode_array_buffer_reference$$:!0,index:E.add(g.buffer),view:{type:s,byteLength:g.byteLength,byteOffset:g.byteOffset}}}return g}),l=E.buffers.map(k=>{const g=new Uint8Array(k);return S.$te.wrap(g)});return{message:D,buffers:l}}else return{message:JSON.stringify(m),buffers:[]}}e.$jnb=P;function F(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(m,f){const E=f.map(l=>{const k=new ArrayBuffer(l.byteLength);return new Uint8Array(k).set(l.buffer),k}),N=f.length?(l,k)=>{if(k&&typeof k=="object"&&k.$$vscode_array_buffer_reference$$){const g=k,{index:s}=g,a=E[s];if(g.view)switch(g.view.type){case 1:return new Int8Array(a,g.view.byteOffset,g.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(a,g.view.byteOffset,g.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(a,g.view.byteOffset,g.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(a,g.view.byteOffset,g.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(a,g.view.byteOffset,g.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(a,g.view.byteOffset,g.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(a,g.view.byteOffset,g.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(a,g.view.byteOffset,g.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(a,g.view.byteOffset,g.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(a,g.view.byteOffset,g.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(a,g.view.byteOffset,g.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return a}return k}:void 0;return{message:JSON.parse(m,N),arrayBuffers:E}}e.$knb=R}),define(Pe[104],Re([1,0,174,16,2,6,3,30,42,12,41,137,32]),function(me,e,S,M,P,F,R,m,f,E,N,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kF=e.$jF=e.$iF=e.EditorsOrder=e.$hF=e.CloseDirection=e.$gF=e.$fF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$eF=e.$dF=e.$cF=e.$bF=e.$aF=e.$_E=e.$$E=e.$0E=e.EditorInputCapabilities=e.$9E=e.SaveReason=e.Verbosity=e.$8E=e.$7E=e.$6E=e.$5E=e.$4E=e.$3E=e.$2E=e.$1E=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=void 0,e.$VE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$WE={id:"default",displayName:(0,S.localize)(0,null),providerDisplayName:(0,S.localize)(1,null)},e.$XE="workbench.editor.sidebysideEditor",e.$YE="workbench.editors.textDiffEditor",e.$ZE="workbench.editors.binaryResourceDiffEditor";var k;(function(ie){ie[ie.PROGRAMMATIC=1]="PROGRAMMATIC",ie[ie.USER=2]="USER",ie[ie.EDIT=3]="EDIT",ie[ie.NAVIGATION=4]="NAVIGATION",ie[ie.JUMP=5]="JUMP"})(k||(e.EditorPaneSelectionChangeReason=k={}));var g;(function(ie){ie[ie.IDENTICAL=1]="IDENTICAL",ie[ie.SIMILAR=2]="SIMILAR",ie[ie.DIFFERENT=3]="DIFFERENT"})(g||(e.EditorPaneSelectionCompareResult=g={}));function s(ie){const le=ie;return!!le&&typeof le.getSelection=="function"&&!!le.onDidChangeSelection}e.$1E=s;function a(ie,le,V){for(const _ of V.visibleEditorPanes)if(_.group.id===le&&ie.matches(_.input))return _.getViewState()}e.$2E=a;function r(ie){if($(ie))return!1;const le=ie;return P.URI.isUri(le?.resource)}e.$3E=r;function i(ie){if($(ie))return!1;const le=ie;return le?.original!==void 0&&le.modified!==void 0}e.$4E=i;function n(ie){if($(ie))return!1;const le=ie;return!le||le.resources&&!Array.isArray(le.resources)?!1:!!le.resources||!!le.multiDiffSource}e.$5E=n;function c(ie){if($(ie)||i(ie))return!1;const le=ie;return le?.primary!==void 0&&le.secondary!==void 0}e.$6E=c;function d(ie){if($(ie))return!1;const le=ie;return le?le.resource===void 0||le.resource.scheme===E.Schemas.untitled||le.forceUntitled===!0:!1}e.$7E=d;function t(ie){if($(ie))return!1;const le=ie;return P.URI.isUri(le?.base?.resource)&&P.URI.isUri(le?.input1?.resource)&&P.URI.isUri(le?.input2?.resource)&&P.URI.isUri(le?.result?.resource)}e.$8E=t;var p;(function(ie){ie[ie.SHORT=0]="SHORT",ie[ie.MEDIUM=1]="MEDIUM",ie[ie.LONG=2]="LONG"})(p||(e.Verbosity=p={}));var u;(function(ie){ie[ie.EXPLICIT=1]="EXPLICIT",ie[ie.AUTO=2]="AUTO",ie[ie.FOCUS_CHANGE=3]="FOCUS_CHANGE",ie[ie.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class o{constructor(){this.a=new Map}registerSource(le,V){let _=this.a.get(le);return _||(_={source:le,label:V},this.a.set(le,_)),_.source}getSourceLabel(le){return this.a.get(le)?.label??le}}e.$9E=new o;var v;(function(ie){ie[ie.None=0]="None",ie[ie.Readonly=2]="Readonly",ie[ie.Untitled=4]="Untitled",ie[ie.Singleton=8]="Singleton",ie[ie.RequiresTrust=16]="RequiresTrust",ie[ie.CanSplitInGroup=32]="CanSplitInGroup",ie[ie.ForceDescription=64]="ForceDescription",ie[ie.CanDropIntoEditor=128]="CanDropIntoEditor",ie[ie.MultipleEditors=256]="MultipleEditors",ie[ie.Scratchpad=512]="Scratchpad",ie[ie.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(v||(e.EditorInputCapabilities=v={}));class b extends F.$Tc{}e.$0E=b;function $(ie){return ie instanceof b}e.$$E=$;function I(ie){const le=ie;return P.URI.isUri(le?.preferredResource)}function h(ie){const le=ie;return $(le?.primary)&&$(le?.secondary)}e.$_E=h;function y(ie){const le=ie;return $(le?.modified)&&$(le?.original)}e.$aF=y;function w(ie,le,V,_,ke){return $e(_,[(0,D.$3i)({id:"workbench.action.openLargeFile",label:(0,S.localize)(2,null),run:()=>{const Le={...V,limits:{size:Number.MAX_VALUE}};ie.openEditor(le,Le)}}),(0,D.$3i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,S.localize)(3,null),run:()=>ke.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$bF=w;function A(ie){return $(ie?.editor)}e.$cF=A;function L(ie){const le=ie;return A(ie)&&le?.group!==void 0}e.$dF=L;function J(ie){const le=ie;return typeof le?.groupId=="number"&&$(le.editor)}e.$eF=J;var W;(function(ie){ie[ie.UNKNOWN=0]="UNKNOWN",ie[ie.REPLACE=1]="REPLACE",ie[ie.MOVE=2]="MOVE",ie[ie.UNPIN=3]="UNPIN"})(W||(e.EditorCloseContext=W={}));var U;(function(ie){ie[ie.GROUP_ACTIVE=0]="GROUP_ACTIVE",ie[ie.GROUP_INDEX=1]="GROUP_INDEX",ie[ie.GROUP_LABEL=2]="GROUP_LABEL",ie[ie.GROUP_LOCKED=3]="GROUP_LOCKED",ie[ie.EDITOR_OPEN=4]="EDITOR_OPEN",ie[ie.EDITOR_CLOSE=5]="EDITOR_CLOSE",ie[ie.EDITOR_MOVE=6]="EDITOR_MOVE",ie[ie.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ie[ie.EDITOR_LABEL=8]="EDITOR_LABEL",ie[ie.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ie[ie.EDITOR_PIN=10]="EDITOR_PIN",ie[ie.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ie[ie.EDITOR_STICKY=12]="EDITOR_STICKY",ie[ie.EDITOR_DIRTY=13]="EDITOR_DIRTY",ie[ie.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var C;(function(ie){ie[ie.PRIMARY=1]="PRIMARY",ie[ie.SECONDARY=2]="SECONDARY",ie[ie.BOTH=3]="BOTH",ie[ie.ANY=4]="ANY"})(C||(e.SideBySideEditor=C={}));class O{getOriginalUri(le,V){if(!le)return;if(t(le))return e.$gF.getOriginalUri(le.result,V);if(V?.supportSideBySide){const{primary:ke,secondary:Le}=this.a(le);if(ke&&Le){if(V?.supportSideBySide===C.BOTH)return{primary:this.getOriginalUri(ke,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Le,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===C.ANY)return this.getOriginalUri(ke,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Le,{filterByScheme:V.filterByScheme});le=V.supportSideBySide===C.PRIMARY?ke:Le}}if(i(le)||n(le)||c(le)||t(le))return;const _=I(le)?le.preferredResource:le.resource;return!_||!V||!V.filterByScheme?_:this.b(_,V.filterByScheme)}a(le){return h(le)||c(le)?{primary:le.primary,secondary:le.secondary}:y(le)||i(le)?{primary:le.modified,secondary:le.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(le,V){if(!le)return;if(t(le))return e.$gF.getCanonicalUri(le.result,V);if(V?.supportSideBySide){const{primary:ke,secondary:Le}=this.a(le);if(ke&&Le){if(V?.supportSideBySide===C.BOTH)return{primary:this.getCanonicalUri(ke,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Le,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===C.ANY)return this.getCanonicalUri(ke,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Le,{filterByScheme:V.filterByScheme});le=V.supportSideBySide===C.PRIMARY?ke:Le}}if(i(le)||n(le)||c(le)||t(le))return;const _=le.resource;return!_||!V||!V.filterByScheme?_:this.b(_,V.filterByScheme)}b(le,V){if(Array.isArray(V)){if(V.some(_=>le.scheme===_))return le}else if(V===le.scheme)return le}}var q;(function(ie){ie[ie.UNKNOWN=0]="UNKNOWN",ie[ie.KEYBOARD=1]="KEYBOARD",ie[ie.MOUSE=2]="MOUSE"})(q||(e.EditorCloseMethod=q={}));function ne(ie,le,V,_){if(!ie.isSticky(le))return!1;switch(_.preventPinnedEditorClose){case"keyboardAndMouse":return V===q.MOUSE||V===q.KEYBOARD;case"mouse":return V===q.MOUSE;case"keyboard":return V===q.KEYBOARD}return!1}e.$fF=ne,e.$gF=new O;var ce;(function(ie){ie[ie.LEFT=0]="LEFT",ie[ie.RIGHT=1]="RIGHT"})(ce||(e.CloseDirection=ce={}));class ye{constructor(){this.c=new Map,this.d=new Map}start(le){const V=this.a=le.get(R.$fi);for(const[_,ke]of this.c)this.e(_,ke,V);this.c.clear()}e(le,V,_){const ke=_.createInstance(V);this.d.set(le,ke)}registerFileEditorFactory(le){if(this.b)throw new Error("Can only register one file editor factory.");this.b=le}getFileEditorFactory(){return(0,M.$5f)(this.b)}registerEditorSerializer(le,V){if(this.c.has(le)||this.d.has(le))throw new Error(`A editor serializer with type ID '${le}' was already registered.`);return this.a?this.e(le,V,this.a):this.c.set(le,V),(0,F.$Rc)(()=>{this.c.delete(le),this.d.delete(le)})}getEditorSerializer(le){return this.d.get(typeof le=="string"?le:le.typeId)}}m.$Xn.add(e.$VE.EditorFactory,new ye);async function Ie(ie,le,V){return!ie||!ie.length?[]:await Promise.all(ie.map(async _=>{const ke=P.URI.revive(_.fileUri);if(!ke){V.info("Cannot resolve the path because it is not valid.",_);return}if(!await le.canHandleResource(ke)){V.info("Cannot resolve the path because it cannot be handled",_);return}let Ee=_.exists,be=_.type;if(typeof Ee!="boolean"||typeof be!="number")try{be=(await le.stat(ke)).isDirectory?f.FileType.Directory:f.FileType.Unknown,Ee=!0}catch(G){V.error(G),Ee=!1}if(!Ee&&_.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",_);return}if(be===f.FileType.Directory){V.info("Cannot resolve the path because it is a directory",_);return}const ge={..._.options,pinned:!0};return Ee?{resource:ke,options:ge}:{resource:ke,options:ge,forceUntitled:!0}}))}e.$hF=Ie;var ue;(function(ie){ie[ie.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ie[ie.SEQUENTIAL=1]="SEQUENTIAL"})(ue||(e.EditorsOrder=ue={}));function ve(ie){const le=ie;if(!le)return!1;const V=le;if(V.modified)return ve(V.modified);const _=le;return!!(_.contributionsState&&_.viewState&&Array.isArray(_.cursorState))}e.$iF=ve;function re(ie){return(0,N.$5i)(ie)}e.$jF=re;function $e(ie,le,V){const _=(0,N.$6i)(ie,le);return _.forceMessage=V?.forceMessage,_.forceSeverity=V?.forceSeverity,_.allowDialog=V?.allowDialog,_}e.$kF=$e}),define(Pe[208],Re([1,0,5,175,3,6,28,30,18,26,91,199]),function(me,e,S,M,P,F,R,m,f,E,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sF=e.$rF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$qF=e.ViewContentGroups=e.$pF=e.$oF=e.ViewContainerLocation=e.Extensions=e.$nF=e.$mF=e.$lF=void 0,e.$lF="views",e.$mF=(0,M.localize)(0,null),e.$nF=(0,D.$Nw)("default-view-icon",N.$pk.window,(0,M.localize)(1,null));var l;(function(p){p.ViewContainersRegistry="workbench.registry.view.containers",p.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var k;(function(p){p[p.Sidebar=0]="Sidebar",p[p.Panel=1]="Panel",p[p.AuxiliaryBar=2]="AuxiliaryBar"})(k||(e.ViewContainerLocation=k={})),e.$oF=[0,1,2];function g(p){switch(p){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$pF=g;class s extends F.$Tc{constructor(){super(...arguments),this.c=this.B(new S.$6d),this.onDidRegister=this.c.event,this.f=this.B(new S.$6d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,f.$Rb)([...this.g.values()])}registerViewContainer(u,o,v){const b=this.get(u.id);if(b)return b;const $=u;return $.openCommandActionDescriptor=v?.doNotRegisterOpenCommand?void 0:$.openCommandActionDescriptor??{id:$.id},(0,R.$xc)(this.g,o,[]).push($),v?.isDefault&&this.h.push($),this.c.fire({viewContainer:$,viewContainerLocation:o}),$}deregisterViewContainer(u){for(const o of this.g.keys()){const v=this.g.get(o),b=v?.indexOf(u);if(b!==-1){v?.splice(b,1),v.length===0&&this.g.delete(o),this.f.fire({viewContainer:u,viewContainerLocation:o});return}}}get(u){return this.all.filter(o=>o.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(v=>v?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(o=>this.getViewContainerLocation(o)===u)}}m.$Xn.add(l.ViewContainersRegistry,new s);var a;(function(p){p.Open="2_open",p.Debug="4_debug",p.SCM="5_scm",p.More="9_more"})(a||(e.ViewContentGroups=a={}));function r(p,u){const o=p.group??a.More,v=u.group??a.More;return o!==v?o.localeCompare(v):(p.order??5)-(u.order??5)}class i extends F.$Tc{constructor(){super(...arguments),this.c=this.B(new S.$6d),this.onViewsRegistered=this.c.event,this.f=this.B(new S.$6d),this.onViewsDeregistered=this.f.event,this.g=this.B(new S.$6d),this.onDidChangeContainer=this.g.event,this.h=this.B(new S.$6d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(u,o){this.registerViews2([{views:u,viewContainer:o}])}registerViews2(u){u.forEach(({views:o,viewContainer:v})=>this.r(o,v)),this.c.fire(u)}deregisterViews(u,o){const v=this.s(u,o);v.length&&this.f.fire({views:v,viewContainer:o})}moveViews(u,o){for(const v of this.m.keys())if(v!==o){const b=this.s(u,v);b.length&&(this.r(b,o),this.g.fire({views:b,from:v,to:o}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const o of this.j){const v=(this.m.get(o)||[]).filter(b=>b.id===u)[0];if(v)return v}return null}getViewContainer(u){for(const o of this.j)if((this.m.get(o)||[]).filter(b=>b.id===u)[0])return o;return null}registerViewWelcomeContent(u,o){return this.n.add(u,o),this.h.fire(u),(0,F.$Rc)(()=>{this.n.delete(u,o),this.h.fire(u)})}registerViewWelcomeContent2(u,o){const v=new Map;for(const[b,$]of o)this.n.add(u,$),v.set(b,(0,F.$Rc)(()=>{this.n.delete(u,$),this.h.fire(u)}));return this.h.fire(u),v}getViewWelcomeContent(u){const o=[];return this.n.forEach(u,v=>o.push(v)),o.sort(r)}r(u,o){let v=this.m.get(o);v||(v=[],this.m.set(o,v),this.j.push(o));for(const b of u){if(this.getView(b.id)!==null)throw new Error((0,M.localize)(2,null,b.id));v.push(b)}}s(u,o){const v=this.m.get(o);if(!v)return[];const b=[],$=[];for(const I of v)u.includes(I)?b.push(I):$.push(I);return b.length&&($.length?this.m.set(o,$):(this.m.delete(o),this.j.splice(this.j.indexOf(o),1))),b}}m.$Xn.add(l.ViewsRegistry,new i),e.$qF=(0,P.$gi)("viewDescriptorService");var n;(function(p){p[p.Default=0]="Default",p[p.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var c;(function(p){p[p.None=0]="None",p[p.Collapsed=1]="Collapsed",p[p.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class d{constructor(u,o){this.c=!1,this.d=!1,(0,E.$On)(this,u),this.d=!!o,this.resolve=async v=>{if(o&&!this.c){const b=await o(v);b&&(this.tooltip=this.tooltip??b.tooltip,this.command=this.command??b.command)}v.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$rF=d;class t extends Error{constructor(u){super((0,M.localize)(3,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$sF=t}),define(Pe[209],Re([1,0,2,29,3]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DF=e.$CF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$BF=e.$AF=void 0;function F(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof S.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(M.$0s.isIRange)}e.$AF=F;function R(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(F)}e.$BF=R;var m;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var f;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(f||(e.ChatCopyKind=f={})),e.$CF=(0,P.$gi)("IChatService"),e.$DF="accessibility.voice.keywordActivation"}),define(Pe[210],Re([1,0,5,11,176]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pnb=void 0;class F{constructor(){this.f=new Map,this.m=[],this.n=new S.$6d,this.o=new S.$6d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(m){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=m}onEvent(m){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=m}onRequest(m){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.u("response",m)}sendRequest(m,f,E,N){const D={command:m};if(f&&Object.keys(f).length>0&&(D.arguments=f),this.u("request",D),typeof N=="number"){const l=setTimeout(()=>{clearTimeout(l);const k=this.f.get(D.seq);if(k){this.f.delete(D.seq);const g={type:"response",seq:0,request_seq:D.seq,success:!1,command:m,message:(0,P.localize)(0,null,N,m)};k(g)}},N)}return E&&this.f.set(D.seq,E),D.seq}acceptMessage(m){this.k?this.k(m):(this.m.push(m),this.m.length===1&&this.s())}q(m,f){return m.type!=="event"||f.type!=="event"}async s(){let m;for(;this.m.length;){if((!m||this.q(this.m[0],m))&&await(0,M.$hh)(0),m=this.m.shift(),!m)return;switch(m.type){case"event":this.j?.(m);break;case"request":this.g?.(m);break;case"response":{const f=m,E=this.f.get(f.request_seq);E&&(this.f.delete(f.request_seq),E(f));break}}}}u(m,f){f.type=m,f.seq=this.d++,this.sendMessage(f)}async w(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((f,E)=>m.set(E,f)),await(0,M.$hh)(500),m.forEach((f,E)=>{f({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Pnb=F}),define(Pe[211],Re([1,0,2,177,35,3]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$GI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$FI=e.MemoryRangeType=e.$EI=e.State=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=void 0,e.$tH="workbench.view.debug",e.$uH="workbench.debug.variablesView",e.$vH="workbench.debug.watchExpressionsView",e.$wH="workbench.debug.callStackView",e.$xH="workbench.debug.loadedScriptsView",e.$yH="workbench.debug.breakPointsView",e.$zH="workbench.debug.disassemblyView",e.$AH="workbench.panel.repl",e.$BH="workbench.panel.repl.view",e.$CH=new P.$xj("debugType",void 0,{type:"string",description:M.localize(0,null)}),e.$DH=new P.$xj("debugConfigurationType",void 0,{type:"string",description:M.localize(1,null)}),e.$EH=new P.$xj("debugState","inactive",{type:"string",description:M.localize(2,null)}),e.$FH="debugUx",e.$GH=new P.$xj(e.$FH,"default",{type:"string",description:M.localize(3,null)}),e.$HH=new P.$xj("hasDebugged",!1,{type:"boolean",description:M.localize(4,null)}),e.$IH=new P.$xj("inDebugMode",!1,{type:"boolean",description:M.localize(5,null)}),e.$JH=new P.$xj("inDebugRepl",!1,{type:"boolean",description:M.localize(6,null)}),e.$KH=new P.$xj("breakpointWidgetVisible",!1,{type:"boolean",description:M.localize(7,null)}),e.$LH=new P.$xj("inBreakpointWidget",!1,{type:"boolean",description:M.localize(8,null)}),e.$MH=new P.$xj("breakpointsFocused",!0,{type:"boolean",description:M.localize(9,null)}),e.$NH=new P.$xj("watchExpressionsFocused",!0,{type:"boolean",description:M.localize(10,null)}),e.$OH=new P.$xj("watchExpressionsExist",!1,{type:"boolean",description:M.localize(11,null)}),e.$PH=new P.$xj("variablesFocused",!0,{type:"boolean",description:M.localize(12,null)}),e.$QH=new P.$xj("expressionSelected",!1,{type:"boolean",description:M.localize(13,null)}),e.$RH=new P.$xj("breakpointInputFocused",!1,{type:"boolean",description:M.localize(14,null)}),e.$SH=new P.$xj("callStackItemType",void 0,{type:"string",description:M.localize(15,null)}),e.$TH=new P.$xj("callStackSessionIsAttach",!1,{type:"boolean",description:M.localize(16,null)}),e.$UH=new P.$xj("callStackItemStopped",!1,{type:"boolean",description:M.localize(17,null)}),e.$VH=new P.$xj("callStackSessionHasOneThread",!1,{type:"boolean",description:M.localize(18,null)}),e.$WH=new P.$xj("watchItemType",void 0,{type:"string",description:M.localize(19,null)}),e.$XH=new P.$xj("canViewMemory",void 0,{type:"boolean",description:M.localize(20,null)}),e.$YH=new P.$xj("breakpointItemType",void 0,{type:"string",description:M.localize(21,null)}),e.$ZH=new P.$xj("breakpointItemBytes",void 0,{type:"boolean",description:M.localize(22,null)}),e.$1H=new P.$xj("breakpointHasModes",!1,{type:"boolean",description:M.localize(23,null)}),e.$2H=new P.$xj("breakpointSupportsCondition",!1,{type:"boolean",description:M.localize(24,null)}),e.$3H=new P.$xj("loadedScriptsSupported",!1,{type:"boolean",description:M.localize(25,null)}),e.$4H=new P.$xj("loadedScriptsItemType",void 0,{type:"string",description:M.localize(26,null)}),e.$5H=new P.$xj("focusedSessionIsAttach",!1,{type:"boolean",description:M.localize(27,null)}),e.$6H=new P.$xj("focusedSessionIsNoDebug",!1,{type:"boolean",description:M.localize(28,null)}),e.$7H=new P.$xj("stepBackSupported",!1,{type:"boolean",description:M.localize(29,null)}),e.$8H=new P.$xj("restartFrameSupported",!1,{type:"boolean",description:M.localize(30,null)}),e.$9H=new P.$xj("stackFrameSupportsRestart",!1,{type:"boolean",description:M.localize(31,null)}),e.$0H=new P.$xj("jumpToCursorSupported",!1,{type:"boolean",description:M.localize(32,null)}),e.$$H=new P.$xj("stepIntoTargetsSupported",!1,{type:"boolean",description:M.localize(33,null)}),e.$_H=new P.$xj("breakpointsExist",!1,{type:"boolean",description:M.localize(34,null)}),e.$aI=new P.$xj("debuggersAvailable",!1,{type:"boolean",description:M.localize(35,null)}),e.$bI=new P.$xj("debugExtensionAvailable",!0,{type:"boolean",description:M.localize(36,null)}),e.$cI=new P.$xj("debugProtocolVariableMenuContext",void 0,{type:"string",description:M.localize(37,null)}),e.$dI=new P.$xj("debugSetVariableSupported",!1,{type:"boolean",description:M.localize(38,null)}),e.$eI=new P.$xj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:M.localize(39,null)}),e.$fI=new P.$xj("debugSetExpressionSupported",!1,{type:"boolean",description:M.localize(40,null)}),e.$gI=new P.$xj("breakWhenValueChangesSupported",!1,{type:"boolean",description:M.localize(41,null)}),e.$hI=new P.$xj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:M.localize(42,null)}),e.$iI=new P.$xj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:M.localize(43,null)}),e.$jI=new P.$xj("terminateDebuggeeSupported",!1,{type:"boolean",description:M.localize(44,null)}),e.$kI=new P.$xj("suspendDebuggeeSupported",!1,{type:"boolean",description:M.localize(45,null)}),e.$lI=new P.$xj("variableEvaluateNamePresent",!1,{type:"boolean",description:M.localize(46,null)}),e.$mI=new P.$xj("variableIsReadonly",!1,{type:"boolean",description:M.localize(47,null)}),e.$nI=new P.$xj("variableValue",!1,{type:"string",description:M.localize(48,null)}),e.$oI=new P.$xj("variableType",!1,{type:"string",description:M.localize(49,null)}),e.$pI=new P.$xj("variableName",!1,{type:"string",description:M.localize(50,null)}),e.$qI=new P.$xj("variableLanguage",!1,{type:"string",description:M.localize(51,null)}),e.$rI=new P.$xj("variableExtensionId",!1,{type:"string",description:M.localize(52,null)}),e.$sI=new P.$xj("exceptionWidgetVisible",!1,{type:"boolean",description:M.localize(53,null)}),e.$tI=new P.$xj("multiSessionRepl",!1,{type:"boolean",description:M.localize(54,null)}),e.$uI=new P.$xj("multiSessionDebug",!1,{type:"boolean",description:M.localize(55,null)}),e.$vI=new P.$xj("disassembleRequestSupported",!1,{type:"boolean",description:M.localize(56,null)}),e.$wI=new P.$xj("disassemblyViewFocus",!1,{type:"boolean",description:M.localize(57,null)}),e.$xI=new P.$xj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:M.localize(58,null)}),e.$yI=new P.$xj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:M.localize(59,null)});const R=i=>M.localize(60,null,i);e.$zI=R,e.$AI="editor.contrib.debug",e.$BI="editor.contrib.breakpoint",e.$CI="debug",e.$DI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:M.localize(61,null)};var m;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(m||(e.State=m={}));function f(i){switch(i){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$EI=f;var E;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$FI="vscode-debug-memory";var N;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(N||(e.DataBreakpointSetType=N={}));var D;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(D||(e.DebugConfigurationProviderTriggerKind=D={}));var l;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(l||(e.DebuggerString=l={})),e.$GI=(0,F.$gi)("debugService");var k;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(k||(e.BreakpointWidgetContext=k={}));var g;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(g||(e.DebugVisualizationType=g={}));var s;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(s||(e.DebugTreeItemCollapsibleState=s={}));var a;(function(i){i.deserialize=n=>n,i.serialize=n=>n})(a||(e.IDebugVisualizationTreeItem=a={}));var r;(function(i){i.deserialize=n=>({id:n.id,name:n.name,iconPath:n.iconPath&&{light:S.URI.revive(n.iconPath.light),dark:S.URI.revive(n.iconPath.dark)},iconClass:n.iconClass,visualization:n.visualization}),i.serialize=n=>n})(r||(e.IDebugVisualization=r={}))}),define(Pe[212],Re([1,0,15,2,19,26,12,29,25,18]),function(me,e,S,M,P,F,R,m,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=void 0;const N=/{([^}]+)}/g;function D(I,h,y){return I.replace(N,function(w,A){return h&&A.length>0&&A[0]!=="_"?w:y&&y.hasOwnProperty(A)?y[A]:w})}e.$vG=D;function l(I){const h={};for(const y of Object.keys(I))y.startsWith("!")||(h[y]=I[y]);return h}e.$wG=l;function k(I){return I.configuration.request==="attach"&&!g(I)&&(!I.parentSession||k(I.parentSession))}e.$xG=k;function g(I){let h=I.configuration.type;if(h)return h==="vslsShare"&&(h=I.configuration.adapterProxy.configuration.type),(0,S.$kf)(h,"extensionhost")||(0,S.$kf)(h,"pwa-extensionhost")?I:I.parentSession?g(I.parentSession):void 0}e.$yG=g;function s(I){return I.type&&(I.label||I.program||I.runtime)}e.$zG=s;function a(I,h,y){let w,A=0;const L=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let J=null;for(;J=L.exec(I);){const W=J.index+1,U=W+J[0].length;if(W<=h&&U>=y){w=J[0],A=W;break}}if(w){const W=/\w+/g;let U=null;for(;(U=W.exec(w))&&!(U.index+1+A+U[0].length>=y););U&&(w=w.substring(0,W.lastIndex))}return w?{start:A,end:A+w.length-1}:{start:0,end:0}}e.$AG=a;async function r(I,h,y,w){if(I.evaluatableExpressionProvider.has(h)){const A=I.evaluatableExpressionProvider.ordered(h),L=(0,E.$Hb)(await Promise.all(A.map(async J=>{try{return await J.provideEvaluatableExpression(h,y,w??f.CancellationToken.None)}catch{return}})));if(L.length>0){let J=L[0].expression;const W=L[0].range;return J||(J=h.getLineContent(y.lineNumber).substring(W.startColumn-1,W.endColumn-1)),{range:W,matchingExpression:J}}}else{const A=h.getLineContent(y.lineNumber),{start:L,end:J}=a(A,y.column,y.column),W=A.substring(L-1,J);return{matchingExpression:W,range:new m.$0s(y.lineNumber,L,y.lineNumber,L+W.length)}}return null}e.$BG=r;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(I){return!!(I&&I.match(i))}e.$CG=n;function c(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(n(I.path))return M.URI.parse(I.path);if((0,P.$ic)(I.path))return M.URI.file(I.path)}return I.path}function d(I){if(typeof I.path=="object"){const h=M.URI.revive(I.path);if(h)return h.scheme===R.Schemas.file?h.fsPath:h.toString()}return I.path}function t(I,h){const y=h?c:d,w=(0,F.$Ln)(I);return u(w,(A,L)=>{A&&L&&(L.path=y(L))}),w}e.$DG=t;function p(I,h){const y=h?c:d,w=(0,F.$Ln)(I);return u(w,(A,L)=>{!A&&L&&(L.path=y(L))}),w}e.$EG=p;function u(I,h){switch(I.type){case"event":{const y=I;switch(y.event){case"output":h(!1,y.body.source);break;case"loadedSource":h(!1,y.body.source);break;case"breakpoint":h(!1,y.body.breakpoint.source);break;default:break}break}case"request":{const y=I;switch(y.command){case"setBreakpoints":h(!0,y.arguments.source);break;case"breakpointLocations":h(!0,y.arguments.source);break;case"source":h(!0,y.arguments.source);break;case"gotoTargets":h(!0,y.arguments.source);break;case"launchVSCode":y.arguments.args.forEach(w=>h(!1,w));break;default:break}break}case"response":{const y=I;if(y.success&&y.body)switch(y.command){case"stackTrace":y.body.stackFrames.forEach(w=>h(!1,w.source));break;case"loadedSources":y.body.sources.forEach(w=>h(!1,w));break;case"scopes":y.body.scopes.forEach(w=>h(!1,w.source));break;case"setFunctionBreakpoints":y.body.breakpoints.forEach(w=>h(!1,w.source));break;case"setBreakpoints":y.body.breakpoints.forEach(w=>h(!1,w.source));break;case"disassemble":y.body?.instructions.forEach(A=>h(!1,A.location));break;default:break}break}}}function o(I){return I.filter(h=>!h.presentation?.hidden).sort((h,y)=>h.presentation?y.presentation?h.presentation.group?y.presentation.group?h.presentation.group!==y.presentation.group?h.presentation.group.localeCompare(y.presentation.group):v(h.presentation.order,y.presentation.order):-1:y.presentation.group?1:v(h.presentation.order,y.presentation.order):-1:y.presentation?1:0)}e.$FG=o;function v(I,h){return typeof I!="number"?typeof h!="number"?0:1:typeof h!="number"?-1:I-h}async function b(I,h){const y=I.getValue("debug.saveBeforeStart",{overrideIdentifier:h.activeTextEditorLanguageId});if(y!=="none"&&(await h.saveAll(),y==="allEditorsInActiveGroup")){const w=h.activeEditorPane;w&&w.input.resource?.scheme===R.Schemas.untitled&&await h.save({editor:w.input,groupId:w.group.id})}await I.reloadConfiguration()}e.$GG=b;const $=(I,h)=>!I||!h?I===h:I.name===h.name&&I.path===h.path&&I.sourceReference===h.sourceReference;e.$HG=$}),define(Pe[213],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aK=e.CellExecutionUpdateType=void 0;var M;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$aK=(0,S.$gi)("INotebookExecutionService")}),define(Pe[214],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gb=e.$0gb=e.ProxyKernelState=e.$9gb=void 0,e.$9gb=100;var M;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(M||(e.ProxyKernelState=M={})),e.$0gb=(0,S.$gi)("INotebookKernelService"),e.$$gb=(0,S.$gi)("INotebookKernelHistoryService")}),define(Pe[215],Re([1,0,6,29,147,95]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ETb=void 0;class R extends S.$Tc{constructor(f,E,N){super(),this._source=f,this.b=E,this.c=N,this.a=void 0}f(f){const E=f.getLineCount();return new M.$0s(1,1,E,this.g(f,E))}g(f,E){if(E<1||E>f.getLineCount())throw new Error("Illegal value for lineNumber");return f.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const f=new P.$sC;f.acceptChunk(this._source);const E=f.finish(!0),{textBuffer:N,disposable:D}=E.create(1);this.b=N,this.B(D)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(f=>{const E=new P.$sC;E.acceptChunk(f);const N=E.finish(!0),{textBuffer:D,disposable:l}=N.create(1);return this.B(l),D})),this.a}findInInputs(f){const N=new F.$gC(f,!1,!1,null).parseSearchRequest();if(!N)return[];const D=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(D,N,!0,5e3)}findInOutputs(f){const N=new F.$gC(f,!1,!1,null).parseSearchRequest();return N?this.outputTextBuffers.map(D=>{const l=D.findMatchesLineByLine(this.f(D),N,!0,5e3);if(l.length!==0)return{textBuffer:D,matches:l}}).filter(D=>!!D):[]}}e.$ETb=R}),define(Pe[48],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZK=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(F){F.Delimiter="\0"})(S||(e.TestIdPathParts=S={}));var M;(function(F){F[F.IsSame=0]="IsSame",F[F.Disconnected=1]="Disconnected",F[F.IsChild=2]="IsChild",F[F.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class P{static fromExtHostTestItem(R,m,f=R.parent){if(R._isRoot)return new P([m]);const E=[R.id];for(let N=f;N&&N.id!==m;N=N.parent)E.push(N.id);return E.push(m),new P(E.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const m=R.indexOf("\0");return m===-1?R:R.slice(0,m)}static fromString(R){return new P(R.split("\0"))}static join(R,m){return new P([...R.path,m])}static joinToString(R,m){return R.toString()+"\0"+m}static parentId(R){const m=R.lastIndexOf("\0");return m===-1?void 0:R.slice(0,m)}static localId(R){const m=R.lastIndexOf("\0");return m===-1?R:R.slice(m+1)}static isChild(R,m){return m.startsWith(R)&&m[R.length]==="\0"}static compare(R,m){return R===m?0:P.isChild(R,m)?2:P.isChild(m,R)?3:1}constructor(R,m=R.length){if(this.path=R,this.d=m,R.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new P(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new P(this.path,R)}compare(R){if(typeof R=="string")return P.compare(this.toString(),R);for(let m=0;m<R.d&&m<this.d;m++)if(R.path[m]!==this.path[m])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$ZK=P}),define(Pe[60],Re([1,0,2,93,29,48]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8K=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$7K=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$6K=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$5K=e.$4K=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$3K=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$2K=e.$1K=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var m;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var f;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(f||(e.TestRunProfileBitset=f={})),e.$1K=[2,4,8,16,32,64];const E=C=>"runId"in C;e.$2K=E;var N;(function(C){C.serialize=O=>({range:O.range.toJSON(),uri:O.uri.toJSON()}),C.deserialize=(O,q)=>({range:P.$0s.lift(q.range),uri:O.asCanonicalUri(S.URI.revive(q.uri))})})(N||(e.IRichLocation=N={}));var D;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(D||(e.TestMessageType=D={}));var l;(function(C){C.serialize=O=>({message:O.message,type:0,expected:O.expected,actual:O.actual,contextValue:O.contextValue,location:O.location&&N.serialize(O.location)}),C.deserialize=(O,q)=>({message:q.message,type:0,expected:q.expected,actual:q.actual,contextValue:q.contextValue,location:q.location&&N.deserialize(O,q.location)})})(l||(e.ITestErrorMessage=l={}));const k=(C,O)=>`${O?"s":"e"}${C}`;e.$3K=k;var g;(function(C){C.serialize=O=>({message:O.message,type:1,offset:O.offset,length:O.length,location:O.location&&N.serialize(O.location)}),C.deserialize=(O,q)=>({message:q.message,type:1,offset:q.offset,length:q.length,location:q.location&&N.deserialize(O,q.location)})})(g||(e.ITestOutputMessage=g={}));var s;(function(C){C.serialize=O=>O.type===0?l.serialize(O):g.serialize(O),C.deserialize=(O,q)=>q.type===0?l.deserialize(O,q):g.deserialize(O,q)})(s||(e.ITestMessage=s={}));var a;(function(C){C.serializeWithoutMessages=O=>({state:O.state,duration:O.duration,messages:[]}),C.serialize=O=>({state:O.state,duration:O.duration,messages:O.messages.map(s.serialize)}),C.deserialize=(O,q)=>({state:q.state,duration:q.duration,messages:q.messages.map(ne=>s.deserialize(O,ne))})})(a||(e.ITestTaskState=a={}));const r="\0",i=(C,O)=>C+r+O;e.$4K=i;const n=C=>{const O=C.indexOf(r);return{ctrlId:C.slice(0,O),tagId:C.slice(O+1)}};e.$5K=n;var c;(function(C){C.serialize=O=>({extId:O.extId,label:O.label,tags:O.tags,busy:O.busy,children:void 0,uri:O.uri?.toJSON(),range:O.range?.toJSON()||null,description:O.description,error:O.error,sortText:O.sortText}),C.deserialize=(O,q)=>({extId:q.extId,label:q.label,tags:q.tags,busy:q.busy,children:void 0,uri:q.uri?O.asCanonicalUri(S.URI.revive(q.uri)):void 0,range:q.range?P.$0s.lift(q.range):null,description:q.description,error:q.error,sortText:q.sortText})})(c||(e.ITestItem=c={}));var d;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(d||(e.TestItemExpandState=d={}));var t;(function(C){C.serialize=O=>({expand:O.expand,item:c.serialize(O.item)}),C.deserialize=(O,q)=>({controllerId:F.$ZK.root(q.item.extId),expand:q.expand,item:c.deserialize(O,q.item)})})(t||(e.InternalTestItem=t={}));var p;(function(C){C.serialize=O=>{let q;return O.item&&(q={},O.item.label!==void 0&&(q.label=O.item.label),O.item.tags!==void 0&&(q.tags=O.item.tags),O.item.busy!==void 0&&(q.busy=O.item.busy),O.item.uri!==void 0&&(q.uri=O.item.uri?.toJSON()),O.item.range!==void 0&&(q.range=O.item.range?.toJSON()),O.item.description!==void 0&&(q.description=O.item.description),O.item.error!==void 0&&(q.error=O.item.error),O.item.sortText!==void 0&&(q.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:q}},C.deserialize=O=>{let q;return O.item&&(q={},O.item.label!==void 0&&(q.label=O.item.label),O.item.tags!==void 0&&(q.tags=O.item.tags),O.item.busy!==void 0&&(q.busy=O.item.busy),O.item.range!==void 0&&(q.range=O.item.range?P.$0s.lift(O.item.range):null),O.item.description!==void 0&&(q.description=O.item.description),O.item.error!==void 0&&(q.error=O.item.error),O.item.sortText!==void 0&&(q.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:q}}})(p||(e.ITestItemUpdate=p={}));const u=(C,O)=>{O.expand!==void 0&&(C.expand=O.expand),O.item!==void 0&&(C.item=C.item?Object.assign(C.item,O.item):O.item)};e.$6K=u;var o;(function(C){C.serializeWithoutMessages=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(a.serializeWithoutMessages)}),C.serialize=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(a.serialize)}),C.deserialize=(O,q)=>({...t.deserialize(O,q),ownComputedState:q.ownComputedState,computedState:q.computedState,tasks:q.tasks.map(ne=>a.deserialize(O,ne)),retired:!0})})(o||(e.TestResultItem=o={}));var v;(function(C){C.empty=()=>({covered:0,total:0}),C.sum=(O,q)=>{O.covered+=q.covered,O.total+=q.total}})(v||(e.ICoveredCount=v={}));var b;(function(C){C.serialize=O=>({statement:O.statement,branch:O.branch,declaration:O.declaration,details:O.details?.map(y.serialize),uri:O.uri.toJSON()}),C.deserialize=(O,q)=>({statement:q.statement,branch:q.branch,declaration:q.declaration,details:q.details?.map(y.deserialize),uri:O.asCanonicalUri(S.URI.revive(q.uri))})})(b||(e.IFileCoverage=b={}));function $(C){return{...C,location:C.location?.toJSON()}}function I(C){return C.location=C.location?M.$9s.isIPosition(C.location)?M.$9s.lift(C.location):P.$0s.lift(C.location):void 0,C}e.$7K=3;var h;(function(C){C[C.Declaration=0]="Declaration",C[C.Statement=1]="Statement",C[C.Branch=2]="Branch"})(h||(e.DetailType=h={}));var y;(function(C){C.serialize=O=>O.type===0?A.serialize(O):L.serialize(O),C.deserialize=O=>O.type===0?A.deserialize(O):L.deserialize(O)})(y||(e.CoverageDetails=y={}));var w;(function(C){C.serialize=$,C.deserialize=I})(w||(e.IBranchCoverage=w={}));var A;(function(C){C.serialize=$,C.deserialize=I})(A||(e.IDeclarationCoverage=A={}));var L;(function(C){C.serialize=O=>({...$(O),branches:O.branches?.map(w.serialize)}),C.deserialize=O=>({...I(O),branches:O.branches?.map(w.deserialize)})})(L||(e.IStatementCoverage=L={}));var J;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(J||(e.TestDiffOpType=J={}));var W;(function(C){C.deserialize=(O,q)=>q.op===0?{op:q.op,item:t.deserialize(O,q.item)}:q.op===1?{op:q.op,item:p.deserialize(q.item)}:q.op===2?{op:q.op,uri:O.asCanonicalUri(S.URI.revive(q.uri)),docv:q.docv}:q,C.serialize=O=>O.op===0?{op:O.op,item:t.serialize(O.item)}:O.op===1?{op:O.op,item:p.serialize(O.item)}:O})(W||(e.TestsDiffOp=W={}));class U{constructor(O){this.k=O,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(O){const q=this.v();for(const ne of O)switch(ne.op){case 0:this.l(t.deserialize(this.k,ne.item),q);break;case 1:this.o(p.deserialize(ne.item),q);break;case 3:this.p(ne.itemId,q);break;case 5:this.q(ne.itemId);break;case 4:this.updatePendingRoots(ne.amount);break;case 6:this.c.set(ne.tag.id,ne.tag);break;case 7:this.c.delete(ne.id);break}q.complete?.()}l(O,q){const ne=F.$ZK.parentId(O.item.extId)?.toString();let ce;if(!ne)ce=this.w(O),this.g.add(ce),this.f.set(O.item.extId,ce);else if(this.f.has(ne)){const ye=this.f.get(ne);ye.children.add(O.item.extId),ce=this.w(O,ye),this.f.set(O.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(O)}`);return}return q.add?.(ce),O.expand===2&&this.h++,ce}o(O,q){const ne=this.f.get(O.extId);if(ne)return O.expand!==void 0&&(ne.expand===2&&this.h--,O.expand===2&&this.h++),(0,e.$6K)(ne,O),q.update?.(ne),ne}p(O,q){const ne=this.f.get(O);if(!ne)return;const ce=F.$ZK.parentId(ne.item.extId)?.toString();ce?this.f.get(ce).children.delete(ne.item.extId):this.g.delete(ne);const ye=[[O]];for(;ye.length;)for(const Ie of ye.pop()){const ue=this.f.get(Ie);ue&&(ye.push(ue.children),this.f.delete(Ie),q.remove?.(ue,ue!==ne),ue.expand===2&&this.h--)}}q(O){}updatePendingRoots(O){this.j+=O}v(){return{}}}e.$8K=U}),define(Pe[75],Re([1,0,11,5,6,55,60,48]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.TestItemEventOp=void 0;var f;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(f||(e.TestItemEventOp=f={}));const E=(i,n)=>i===n,D=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:E,label:E,description:E,error:E,sortText:E,tags:(i,n)=>!(i.length!==n.length||i.some(c=>!n.includes(c)))}),l=(i,n)=>{let c;for(const[d,t]of D)t(i[d],n[d])||(c?c[d]=n[d]:c={[d]:n[d]});return c};class k extends P.$Tc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new S.$sh(()=>this.flushDiff(),200)),this.g=this.B(new M.$6d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===n.uri){c.docv=n.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===n.item.extId){(0,R.$6K)(c.item,n.item);return}if(c.op===0&&c.item.item.extId===n.item.extId){(0,R.$6K)(c.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,c){const d=this.tree.get(n);if(d){if((d.expandLevels===void 0||c>d.expandLevels)&&(d.expandLevels=c),d.expand===1){const t=this.M(d);return t.isOpen()?this.L(d,c-1):t.wait().then(()=>this.L(d,c-1))}else if(d.expand===3)return d.resolveBarrier?.isOpen()===!1?d.resolveBarrier.wait().then(()=>this.L(d,c-1)):this.L(d,c-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,c){switch(c.op){case 3:this.O(m.$ZK.joinToString(n.fullId,c.id));break;case 0:this.z(c.item,n);break;case 5:for(const d of c.ops)this.w(n,d);break;case 1:this.C(c.new,c.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:c.update}});break;case 6:this.y(n.actual.uri);break;default:(0,F.$9c)(c)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,c){const d=m.$ZK.fromExtHostTestItem(n,this.root.id,c?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==c?.actual&&this.s.getChildren(t.parent).delete(n.id);let p=this.tree.get(d.toString());if(!p){p={fullId:d,actual:n,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set(p.fullId.toString(),p),this.G(n,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:p.expand,item:this.s.toITestItem(n)}}),this.I(n,p,c);return}if(p.actual===n){this.H(n,p,c);return}if(p.actual.uri?.toString()!==n.uri?.toString())return this.O(d.toString()),this.z(n,c);const u=this.s.getChildren(p.actual),o=p.actual,v=l(this.s.toITestItem(o),this.s.toITestItem(n));this.s.getApiFor(o).listener=void 0,p.actual=n,p.expand=0,v&&(v.hasOwnProperty("tags")&&(this.C(n.tags,o.tags,d.toString()),delete v.tags),this.w(p,{op:4,update:v})),this.I(n,p,c);for(const[b,$]of u)this.s.getChildren(n).get($.id)||this.O(m.$ZK.joinToString(d,$.id));this.y(p.actual.uri)}C(n,c,d){const t=new Set(c.map(p=>p.id));for(const p of n)t.delete(p.id)||this.D(p);this.pushDiff({op:1,item:{extId:d,item:{tags:n.map(p=>(0,R.$4K)(this.s.controllerId,p.id))}}}),t.forEach(this.F,this)}D(n){const c=this.j.get(n.id);c?c.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$4K)(this.s.controllerId,n.id)}}))}F(n){const c=this.j.get(n);c&&!--c.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,R.$4K)(this.s.controllerId,n)}))}G(n,c){this.s.getApiFor(n).parent=c&&c.actual!==this.root?c.actual:void 0}H(n,c,d){this.G(n,d);const t=this.s.getApiFor(n);t.parent=d?.actual,t.listener=p=>this.w(c,p),this.J(c)}I(n,c,d){this.H(n,c,d);for(const[t,p]of this.s.getChildren(n))this.z(p,c)}J(n){let c;this.h?n.resolveBarrier?c=n.resolveBarrier.isOpen()?3:2:c=n.actual.canResolveChildren?1:0:c=0,c!==n.expand&&(n.expand=c,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:c}}),c===1&&n.expandLevels!==void 0&&this.M(n))}L(n,c){if(c<0)return;const d=[];for(const[t,p]of this.s.getChildren(n.actual)){const u=this.expand(m.$ZK.joinToString(n.fullId,p.id),c);(0,S.$5g)(u)&&d.push(u)}if(d.length)return Promise.all(d).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const p=new S.$fh;return p.open(),p}n.expand=2,this.N(n);const c=n.resolveBarrier=new S.$fh,d=p=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,p)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(p){d(p)}return(0,S.$5g)(t)?t.catch(d).then(()=>{c.open(),this.J(n)}):(c.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const c=this.tree.get(n);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const d=[c];for(;d.length;){const t=d.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const p of t.actual.tags)this.F(p.id);this.tree.delete(t.fullId.toString());for(const[p,u]of this.s.getChildren(t.actual))d.push(this.tree.get(m.$ZK.joinToString(t.fullId,u.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$fO=k;class g extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$gO=g;class s extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$hO=s;class a extends Error{constructor(n,c,d){super(`TestItem with ID "${n}" is from controller "${c}" and cannot be added as a child of an item from controller "${d}".`)}}e.$iO=a;const r=(i,n,c)=>{let d=new Map;return{get size(){return d.size},forEach(t,p){for(const u of d.values())t.call(p,u,this)},[Symbol.iterator](){return d.entries()},replace(t){const p=new Map,u=new Set(d.keys()),o={op:5,ops:[]};for(const v of t){if(!(v instanceof c))throw new s(v.id);const b=n(v).controllerId;if(b!==i.controllerId)throw new a(v.id,b,i.controllerId);if(p.has(v.id))throw new g(v.id);p.set(v.id,v),u.delete(v.id),o.ops.push({op:0,item:v})}for(const v of u.keys())o.ops.push({op:3,id:v});i.listener?.(o),d=p},add(t){if(!(t instanceof c))throw new s(t.id);d.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){d.delete(t)&&i.listener?.({op:3,id:t})},get(t){return d.get(t)},toJSON(){return Array.from(d.values())}}};e.$jO=r}),define(Pe[105],Re([1,0,75]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lO=e.$kO=void 0;const M=new WeakMap,P=(R,m)=>{const f={controllerId:m};return M.set(R,f),f};e.$kO=P;const F=R=>{const m=M.get(R);if(!m)throw new S.$hO(R?.id||"<unknown>");return m};e.$lO=F}),define(Pe[76],Re([1,0,12,2]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mxb=e.$Lxb=e.$Kxb=e.$Jxb=e.$Ixb=void 0,e.$Ixb="vscode-cdn.net",e.$Jxb=`vscode-resource.${e.$Ixb}`,e.$Kxb=`'self' https://*.${e.$Ixb}`;function P(m,f){return m.scheme===S.Schemas.http||m.scheme===S.Schemas.https?m:(f&&f.authority&&f.isRemote&&m.scheme===S.Schemas.file&&(m=M.URI.from({scheme:S.Schemas.vscodeRemote,authority:f.authority,path:m.path})),M.URI.from({scheme:S.Schemas.https,authority:`${m.scheme}+${F(m.authority)}.${e.$Jxb}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$Lxb=P;function F(m){return m.replace(/./g,f=>{const E=f.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?f:"-"+E.toString(16).padStart(4,"0")})}function R(m){return m.replace(/-([0-9a-f]{4})/g,(f,E)=>String.fromCharCode(parseInt(E,16)))}e.$Mxb=R}),define(Pe[216],Re([1,0,5,6,76]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=void 0;class F{constructor(m,f,E){this.d=m,this.e=f,this.f=E,this.a=0,this.b=new M.$Sc,this.c=new Map,this.b.add(f.onDidChangeVisibleTextEditors(()=>{const N=f.getVisibleTextEditors();for(const D of this.c.values())N.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,f,E,N,D){let l;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===m){l=n;break}if(!l)throw new Error("not a visible editor");const k=this,g=this.a++,s=new S.$6d,a=new S.$6d,r=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,P.$Lxb)(n,k.f)}get cspSource(){return P.$Kxb}set options(n){this.b=n,k.d.$setOptions(g,n)}get options(){return this.b}set html(n){this.a=n,k.d.$setHtml(g,n)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(n){return k.d.$postMessage(g,n)}},i=new class{constructor(){this.editor=m,this.line=f,this.height=E,this.webview=r,this.onDidDispose=a.event}dispose(){k.c.has(g)&&(k.c.delete(g),k.d.$disposeEditorInset(g),a.fire(),a.dispose(),s.dispose())}};return this.d.$createEditorInset(g,l.id,l.value.document.uri,f+1,E,N||{},D.identifier,D.extensionLocation),this.c.set(g,{editor:m,inset:i,onDidReceiveMessage:s}),i}$onDidDispose(m){const f=this.c.get(m);f&&f.inset.dispose()}$onDidReceiveMessage(m,f){this.c.get(m)?.onDidReceiveMessage.fire(f)}}e.$wic=F}),define(Pe[106],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eL=e.$dL=e.$cL=void 0,e.$cL="__",e.$dL=(0,S.$gi)("IAuthenticationService"),e.$eL=(0,S.$gi)("IAuthenticationExtensionsService")}),define(Pe[217],Re([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cP=e.VariableKind=e.$bP=void 0,e.$bP=(0,S.$gi)("configurationResolverService");var M;(function(F){F.Unknown="unknown",F.Env="env",F.Config="config",F.Command="command",F.Input="input",F.ExtensionInstallFolder="extensionInstallFolder",F.WorkspaceFolder="workspaceFolder",F.Cwd="cwd",F.WorkspaceFolderBasename="workspaceFolderBasename",F.UserHome="userHome",F.LineNumber="lineNumber",F.SelectedText="selectedText",F.File="file",F.FileWorkspaceFolder="fileWorkspaceFolder",F.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",F.RelativeFile="relativeFile",F.RelativeFileDirname="relativeFileDirname",F.FileDirname="fileDirname",F.FileExtname="fileExtname",F.FileBasename="fileBasename",F.FileBasenameNoExtension="fileBasenameNoExtension",F.FileDirnameBasename="fileDirnameBasename",F.ExecPath="execPath",F.ExecInstallFolder="execInstallFolder",F.PathSeparator="pathSeparator",F.PathSeparatorAlias="/"})(M||(e.VariableKind=M={}));class P extends Error{constructor(R,m){super(m),this.variable=R}}e.$cP=P}),define(Pe[218],Re([1,0,19,73,16,26,21,96,180,217,15]),function(me,e,S,M,P,F,R,m,f,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rP=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(k,g,s,a){this.h=new Map,this.a=k,this.b=g,this.g=s,a&&(this.c=a.then(r=>this.i(r)))}i(k){if(R.$i){const g=Object.create(null);return Object.keys(k).forEach(s=>{g[s.toLowerCase()]=k[s]}),g}return k}resolveWithEnvironment(k,g,s){return this.l({env:this.i(k),userHome:void 0},g?g.uri:void 0,s)}async resolveAsync(k,g){const s={env:await this.c,userHome:await this.g};return this.l(s,k?k.uri:void 0,g)}async j(k,g,s,a){const r=F.$Ln(g);R.$i&&r.windows?Object.keys(r.windows).forEach(n=>r[n]=r.windows[n]):R.$j&&r.osx?Object.keys(r.osx).forEach(n=>r[n]=r.osx[n]):R.$k&&r.linux&&Object.keys(r.linux).forEach(n=>r[n]=r.linux[n]),delete r.windows,delete r.osx,delete r.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,k?k.uri:void 0,r,s,a)}async resolveAnyAsync(k,g,s){return this.j(k,g,s)}async resolveAnyMap(k,g,s){const a=new Map;return{newConfig:await this.j(k,g,s,a),resolvedVariables:a}}resolveWithInteractionReplace(k,g,s,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,g,s,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,g){if(this.h.has(k))throw new Error("Variable "+k+" is contributed twice.");this.h.set(k,g)}async l(k,g,s,a,r){if(P.$Tf(s))return this.m(k,g,s,a,r);if(Array.isArray(s))return Promise.all(s.map(i=>this.l(k,g,i,a,r)));if(P.$Vf(s)){const i=Object.create(null),n=await Promise.all(Object.keys(s).map(async c=>[await this.m(k,g,c,a,r),await this.l(k,g,s[c],a,r)]));for(const[c,d]of n)i[c]=d;return i}return s}m(k,g,s,a,r){return(0,N.$cf)(s,D.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(D.VARIABLE_LHS))return i;let c=await this.o(k,i,n,g,a);return r?.set(n,c),c!==i&&P.$Tf(c)&&c.match(D.VARIABLE_REGEXP)&&(c=await this.m(k,g,c,a,r)),c})}n(k){return this.b?this.b.getUriLabel(k,{noPrefix:!0}):k.fsPath}async o(k,g,s,a,r){let i;const n=s.split(":");n.length>1&&(s=n[0],i=n[1]);const c=p=>{const u=this.a.getFilePath();if(u)return(0,m.$aw)(u);throw new E.$cP(p,(0,f.localize)(0,null,g))},d=p=>{const u=c(p);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,m.$aw)(o)}throw new E.$cP(p,(0,f.localize)(1,null,g,S.$nc(u)))},t=p=>{if(i){const u=this.a.getFolderUri(i);if(u)return u;throw new E.$cP(p,(0,f.localize)(2,null,g,i))}if(a)return a;throw this.a.getWorkspaceFolderCount()>1?new E.$cP(p,(0,f.localize)(3,null,g)):new E.$cP(p,(0,f.localize)(4,null,g))};switch(s){case"env":if(i){if(k.env){const p=k.env[R.$i?i.toLowerCase():i];if(P.$Tf(p))return p}return""}throw new E.$cP(E.VariableKind.Env,(0,f.localize)(5,null,g));case"config":if(i){const p=this.a.getConfigurationValue(a,i);if(P.$3f(p))throw new E.$cP(E.VariableKind.Config,(0,f.localize)(6,null,g,i));if(P.$Vf(p))throw new E.$cP(E.VariableKind.Config,(0,f.localize)(7,null,g,i));return p}throw new E.$cP(E.VariableKind.Config,(0,f.localize)(8,null,g));case"command":return this.p(E.VariableKind.Command,g,i,r,"command");case"input":return this.p(E.VariableKind.Input,g,i,r,"input");case"extensionInstallFolder":if(i){const p=await this.a.getExtension(i);if(!p)throw new E.$cP(E.VariableKind.ExtensionInstallFolder,(0,f.localize)(9,null,g,i));return this.n(p.extensionLocation)}throw new E.$cP(E.VariableKind.ExtensionInstallFolder,(0,f.localize)(10,null,g));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,m.$aw)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return a||i?(0,m.$aw)(this.n(t(E.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$aw)(S.$nc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new E.$cP(E.VariableKind.UserHome,(0,f.localize)(11,null,g))}case"lineNumber":{const p=this.a.getLineNumber();if(p)return p;throw new E.$cP(E.VariableKind.LineNumber,(0,f.localize)(12,null,g))}case"selectedText":{const p=this.a.getSelectedText();if(p)return p;throw new E.$cP(E.VariableKind.SelectedText,(0,f.localize)(13,null,g))}case"file":return c(E.VariableKind.File);case"fileWorkspaceFolder":return d(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return S.$nc(d(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return a||i?S.$lc(this.n(t(E.VariableKind.RelativeFile)),c(E.VariableKind.RelativeFile)):c(E.VariableKind.RelativeFile);case"relativeFileDirname":{const p=S.$mc(c(E.VariableKind.RelativeFileDirname));if(a||i){const u=S.$lc(this.n(t(E.VariableKind.RelativeFileDirname)),p);return u.length===0?".":u}return p}case"fileDirname":return S.$mc(c(E.VariableKind.FileDirname));case"fileExtname":return S.$oc(c(E.VariableKind.FileExtname));case"fileBasename":return S.$nc(c(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const p=S.$nc(c(E.VariableKind.FileBasenameNoExtension));return p.slice(0,p.length-S.$oc(p).length)}case"fileDirnameBasename":return S.$nc(S.$mc(c(E.VariableKind.FileDirnameBasename)));case"execPath":{const p=this.a.getExecPath();return p||g}case"execInstallFolder":{const p=this.a.getAppRoot();return p||g}case"pathSeparator":case"/":return S.sep;default:try{const p=i?`${s}:${i}`:s;return this.p(E.VariableKind.Unknown,g,p,r,void 0)}catch{return g}}}}p(k,g,s,a,r){if(s&&a){const i=r===void 0?a[s]:a[r+":"+s];if(typeof i=="string")return i;throw new E.$cP(k,(0,f.localize)(14,null,g))}return g}}e.$rP=D}),define(Pe[107],Re([1,0,3,104]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rD=e.$qD=e.OpenEditorContext=e.GroupsOrder=e.$pD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$oD=void 0,e.$oD=(0,S.$gi)("editorGroupsService");var P;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var F;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(F||(e.GroupOrientation=F={}));var R;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var m;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EXPAND=1]="EXPAND",g[g.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var f;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(f||(e.MergeGroupMode=f={}));function E(g){const s=g;return(0,M.$$E)(s?.editor)&&(0,M.$$E)(s?.replacement)}e.$pD=E;var N;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N||(e.GroupsOrder=N={}));var D;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function l(g){const s=g;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}e.$qD=l;function k(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$rD=k}),define(Pe[219],Re([1,0,3,107]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wD=e.$vD=e.$uD=e.$tD=e.$sD=void 0,e.$sD=(0,S.$gi)("editorService"),e.$tD=-1,e.$uD=-2,e.$vD=-3;function P(F){const R=F;return typeof F=="number"||(0,M.$qD)(R)}e.$wD=P}),define(Pe[220],Re([1,0,3,187]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uL=void 0,e.$uL=(0,S.$hi)(M.$ni)}),define(Pe[108],Re([1,0,20,5,19,6,11]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d0b=e.$c0b=e.$b0b=e.$a0b=e.$_9b=void 0;class m{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$_9b=m;class f{static isHostExtension(i,n,c){if(n.getExtensionDescription(i))return!1;const d=c.getExtensionDescription(i);return d?!!((d.main||d.browser)&&d.api==="none"):!1}constructor(i,n){this.j=i,this.c=new M.$6d,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(s),this.f=new S.$Cm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const c of n)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=a(this.e,n),this.e=this.e.concat(i);const c=f.l(this.e);return this.e=a(this.e,c.map(d=>d.identifier)),this.k(),this.d++,this.c.fire(void 0),new m(this.d,c)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(u){this.d.has(u)||(this.d.add(u),this.e.push(u))}addArc(u,o){this.addNode(u),this.addNode(o),this.c.has(u)?this.c.get(u).push(o):this.c.set(u,[o])}getArcs(u){return this.c.has(u)?this.c.get(u):[]}hasOnlyGoodArcs(u,o){const v=n.getArcs(u);for(let b=0;b<v.length;b++)if(!o.has(v[b]))return!1;return!0}getNodes(){return this.e}},c=new S.$Cm;for(const u of i)if(c.set(u.identifier,u),u.extensionDependencies)for(const o of u.extensionDependencies)n.addArc(S.$Am.toKey(u.identifier),S.$Am.toKey(o));const d=new Set;n.getNodes().filter(u=>n.getArcs(u).length===0).forEach(u=>d.add(u));const t=n.getNodes().filter(u=>!d.has(u));let p;do{p=!1;for(let u=0;u<t.length;u++){const o=t[u];n.hasOnlyGoodArcs(o,d)&&(t.splice(u,1),u--,d.add(o),p=!0)}}while(p);return t.map(u=>c.get(u))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$a0b=f;class E{constructor(i,n){this.versionId=i,this.extensions=n}}e.$b0b=E;class N{constructor(i){this.d=new k,this.c=new f(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new D(this,n)}deltaExtensions(i,n,c){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,c)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$c0b=N;class D extends F.$Tc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$d0b=D;class l{constructor(i){this.name=i;const n=(0,R.$_g)();this.promise=n.promise,this.c=n.resolve}resolve(i){this.c(i)}}class k{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new l(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const c=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),d=()=>{n&&(clearTimeout(c),n=!1,this.d=!1,this.e())};i.resolve((0,F.$Rc)(d))}}var g;(function(r){r[r.Builtin=0]="Builtin",r[r.User=1]="User",r[r.Dev=2]="Dev"})(g||(g={}));function s(r,i){const n=r.isBuiltin?0:r.isUnderDevelopment?2:1,c=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==c)return n-c;const d=P.$gc.basename(r.extensionLocation.path),t=P.$gc.basename(i.extensionLocation.path);return d<t?-1:d>t?1:0}function a(r,i){const n=new S.$Bm(i);return r.filter(c=>!n.has(c.identifier))}}),define(Pe[77],Re([1,0,23]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Jm=e.$Im=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(M||(e.UIKind=M={}));var P;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var F;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(F||(e.MessageType=F={}));function R(E){const N=S.$te.alloc(1);switch(E){case 0:N.writeUInt8(1,0);break;case 1:N.writeUInt8(2,0);break;case 2:N.writeUInt8(3,0);break}return N}e.$Im=R;function m(E,N){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return N===0;case 2:return N===1;case 3:return N===2;default:return!1}}e.$Jm=m;var f;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(f||(e.NativeLogMarkers=f={}))}),define(Pe[61],Re([1,0,3,5,13,27,77,57,58,26,2,6,168]),function(me,e,S,M,P,F,R,m,f,E,N,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JO=e.$IO=e.$HO=e.$GO=void 0;let k=class extends D.$Tc{constructor(r,i){super(),this.s=r,this.t=i,this.a=this.B(new M.$6d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$6d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=N.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:f.$6o,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,P.$Cj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===P.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(r,i,n){const c=this.getTelemetryDetails(),d=new g(i,n,r,this.n,this.j,this.getBuiltInCommonProperties(r),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),t=this.r.get(r.identifier.value)??[];return this.r.set(r.identifier.value,[...t,d]),d.apiTelemetryLogger}$initializeTelemetryLevel(r,i,n){this.f=r,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(r){const i=Object.create(null);switch(i["common.extname"]=`${r.publisher}.${r.name}`,i["common.extversion"]=r.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,m.$rm)((0,f.$_o)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(r){this.h=this.getTelemetryConfiguration(),this.f=r;const i=this.getTelemetryDetails();this.r.forEach((n,c)=>{const d=n.filter(t=>!t.isDisposed);d.length===0?this.r.delete(c):this.r.set(c,d)}),this.r.forEach(n=>{for(const c of n)c.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(r,i){const c=this.r.get(r.value)?.filter(t=>!t.isDisposed);if(!c)return this.r.delete(r.value),!1;let d=!1;for(const t of c)t.ignoreUnhandledExtHostErrors||(t.logError(i),d=!0);return d}};e.$GO=k,e.$GO=k=Qe([qe(0,F.$FO),qe(1,P.$Bj)],k);class g{static validateSender(r){if(typeof r!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof r.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof r.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof r.flush<"u"&&typeof r.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(r,i,n,c,d,t,p){this.g=n,this.h=c,this.i=d,this.j=t,this.a=new M.$6d,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=r,this.d={isUsageEnabled:p.isUsageEnabled,isErrorsEnabled:p.isErrorsEnabled}}updateTelemetryEnablements(r,i){this.e&&(this.d={isUsageEnabled:r,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(r){let i="properties"in r?r.properties??{}:r;return i=(0,f.$cp)(i,[]),this.c&&(i=(0,E.$On)(i,this.c)),this.b||(i=(0,E.$On)(i,this.j)),"properties"in r?r.properties=i:r=i,r}k(r,i){this.f&&(this.g.publisher==="vscode"?r=this.g.name+"/"+r:r=this.g.identifier.value+"/"+r,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(r,i),this.h.trace(r,i))}logUsage(r,i){this.d.isUsageEnabled&&this.k(r,i)}logError(r,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof r=="string")this.k(r,i);else{const n={name:r.name,message:r.message,stack:r.stack,cause:r.cause},c=(0,f.$cp)(n,[]),d=new Error(c.message,{cause:c.cause});d.stack=c.stack,d.name=c.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(d,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const r=this,i={logUsage:r.logUsage.bind(r),get isUsageEnabled(){return r.d.isUsageEnabled},get isErrorsEnabled(){return r.d.isErrorsEnabled},logError:r.logError.bind(r),dispose:r.dispose.bind(r),onDidChangeEnableStates:r.a.event.bind(r)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let r=this.f;this.f=void 0,Promise.resolve(r.flush()).then(r=void 0),this.e=void 0}else this.f=void 0}}e.$HO=g;function s(a){const r=Date.now()-new Date(a).getTime();return isNaN(r)?!1:r<1e3*60*60*24}e.$IO=s,e.$JO=(0,S.$gi)("IExtHostTelemetry")}),define(Pe[22],Re([1,0,5,2,196,103,20,3]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6F=e.$5F=e.$4F=e.ActivationKind=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.ExtensionHostStartup=e.$XF=e.$WF=e.$VF=e.$UF=void 0,e.$UF=Object.freeze({identifier:new R.$Am("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$VF="extensions.webWorker",e.$WF=(0,m.$gi)("extensionService");class f{constructor(d){this.dependency=d}}e.$XF=f;var E;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class N{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(d,t,p){this.c=d,this.d=t.slice(0),this.e=p.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:F.$FF.createActivationEventsMap(this.d)}}set(d,t,p){if(this.c>d)throw new Error(`ExtensionHostExtensions: invalid versionId ${d} (current: ${this.c})`);const u=[],o=[],v=[],b=[],$=D(this.d),I=D(t),h=(J,W)=>J.extensionLocation.toString()===W.extensionLocation.toString()||J.isBuiltin===W.isBuiltin||J.isUserBuiltin===W.isUserBuiltin||J.isUnderDevelopment===W.isUnderDevelopment;for(const J of this.d){const W=I.get(J.identifier);if(!W){u.push(J.identifier),$.delete(J.identifier);continue}if(!h(J,W)){u.push(J.identifier),$.delete(J.identifier);continue}}for(const J of t){const W=$.get(J.identifier);if(!W){o.push(J);continue}if(!h(W,J)){u.push(W.identifier),$.delete(W.identifier);continue}}const y=new R.$Bm(this.e),w=new R.$Bm(p);for(const J of this.e)w.has(J)||v.push(J);for(const J of p)y.has(J)||b.push(J);const A=F.$FF.createActivationEventsMap(o),L={versionId:d,toRemove:u,toAdd:o,addActivationEvents:A,myToRemove:v,myToAdd:b};return this.delta(L),L}delta(d){if(this.c>=d.versionId)return null;const{toRemove:t,toAdd:p,myToRemove:u,myToAdd:o}=d,v=new R.$Bm(t),b=new R.$Bm(u);for(let $=0;$<this.d.length;$++)v.has(this.d[$].identifier)&&(this.d.splice($,1),$--);for(let $=0;$<this.e.length;$++)b.has(this.e[$])&&(this.e.splice($,1),$--);for(const $ of p)this.d.push($);for(const $ of o)this.e.push($);return this.f=null,d}containsExtension(d){for(const t of this.e)if(R.$Am.equals(t,d))return!0;return!1}containsActivationEvent(d){return this.f||(this.f=this.g()),this.f.has(d)}g(){const d=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const p=F.$FF.readActivationEvents(t);for(const u of p)d.add(u)}return d}}e.$YF=N;function D(c){const d=new R.$Cm;for(const t of c)d.set(t.identifier,t);return d}function l(c,d){return c.enabledApiProposals?c.enabledApiProposals.includes(d):!1}e.$ZF=l;function k(c,d){if(!l(c,d))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${d}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${d}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.$1F=k;class g{constructor(d,t,p,u){this.codeLoadingTime=d,this.activateCallTime=t,this.activateResolvedTime=p,this.activationReason=u}}e.$2F=g;class s{constructor(d,t){this.description=d,this.value=t}}e.$3F=s;var a;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(a||(e.ActivationKind=a={}));function r(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,P.$ip)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.$4F=r;function i(c,d){return{identifier:new R.$Am((0,P.$gp)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!d,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}e.$5F=i;class n{constructor(){this.onDidRegisterExtensions=S.Event.None,this.onDidChangeExtensionsStatus=S.Event.None,this.onDidChangeExtensions=S.Event.None,this.onWillActivateByEvent=S.Event.None,this.onDidChangeResponsiveChange=S.Event.None,this.onWillStop=S.Event.None,this.extensions=[]}activateByEvent(d){return Promise.resolve(void 0)}activateById(d,t){return Promise.resolve(void 0)}activationEventIsDone(d){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(d){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(d,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(d){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$6F=n}),define(Pe[221],Re([1,0,14,108,20,22,13,11]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xic=e.$Wic=e.$Vic=e.$Uic=e.$Tic=e.$Sic=void 0;class f{static{this.NONE=new f(!1,-1,-1,-1)}constructor(r,i,n,c){this.startup=r,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=c}}e.$Sic=f;class E{constructor(r){this.a=r,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(r,i){return r===-1||i===-1?-1:i-r}build(){return new f(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Tic=E;class N{constructor(r,i,n,c,d,t){this.activationFailed=r,this.activationFailedError=i,this.activationTimes=n,this.module=c,this.exports=d,this.subscriptions=t}}e.$Uic=N;class D extends N{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Vic=D;class l extends N{constructor(){super(!1,null,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Wic=l;class k extends N{constructor(r){super(!0,r,f.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let g=class{constructor(r,i,n,c){this.g=c,this.a=r,this.b=i,this.c=n,this.d=new P.$Cm,this.f=Object.create(null)}dispose(){for(const[r,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const r=[];for(const[i,n]of this.d)r.push(n.wait());await Promise.all(r)}isActivated(r){const i=this.d.get(r);return!!(i&&i.value)}getActivatedExtension(r){const i=this.d.get(r);if(!i||!i.value)throw new Error(`Extension '${r.value}' is not known or not activated`);return i.value}async activateByEvent(r,i){if(this.f[r])return;const n=this.a.getExtensionDescriptionsForActivationEvent(r);await this.h(n.map(c=>({id:c.identifier,reason:{startup:i,extensionId:c.identifier,activationEvent:r}}))),this.f[r]=!0}activateById(r,i){const n=this.a.getExtensionDescription(r);if(!n)throw new Error(`Extension '${r}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(r){const i=r.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(r){if(this.d.has(r.id))return this.d.get(r.id);if(this.l(r.id))return this.k(r,null,[],null);const i=this.a.getExtensionDescription(r.id);if(!i){const d=new Error(`Cannot activate unknown extension '${r.id.value}'`),t=this.k(r,null,[],new k(d));return this.c.onExtensionActivationError(r.id,d,new F.$XF(r.id.value)),t}const n=[],c=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const d of c){if(this.m(d))continue;const t=this.d.get(d);if(t){n.push(t);continue}if(this.l(d)){n.push(this.j({id:this.b.getExtensionDescription(d).identifier,reason:r.reason}));continue}const p=this.a.getExtensionDescription(d);if(p){if(!p.main&&!p.browser)continue;n.push(this.j({id:p.identifier,reason:r.reason}));continue}const u=i.displayName||i.identifier.value,o=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${d}'`),v=this.k(r,i.displayName,[],new k(o));return this.c.onExtensionActivationError(i.identifier,o,new F.$XF(d)),v}return this.k(r,i.displayName,n,null)}k(r,i,n,c){const d=new s(r.id,i,r.reason,n,c,this.c,this.g);return this.d.set(r.id,d),d}l(r){return M.$a0b.isHostExtension(r,this.a,this.b)}m(r){const i=this.b.getExtensionDescription(r);return i?!i.main&&!i.browser:!1}};e.$Xic=g,e.$Xic=g=Qe([qe(3,R.$Aj)],g);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(r,i,n,c,d,t,p){this.c=r,this.d=i,this.f=n,this.g=c,this.h=d,this.j=t,this.k=p,this.a=new m.$fh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let r=0;r<this.g.length;r++){const i=this.g[r];if(i.value&&!i.value.activationFailed){this.g.splice(r,1),r--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new k(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(r=>r.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(r){const i=new Error;if(r&&r.name&&(i.name=r.name),r&&r.message?i.message=`Activating extension '${this.c.value}' failed: ${r.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${r}.`,r&&r.stack&&(i.stack=r.stack),this.h=new k(i),this.b&&S.$4(r))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(r)}}};s=Qe([qe(6,R.$Aj)],s)}),define(Pe[222],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[223],Re([1,0,182,14,32,98,72,30,20,222,192,103]),function(me,e,S,M,P,F,R,m,f,E,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TF=e.$SF=e.$RF=e.$QF=e.$PF=e.$OF=void 0;const l=m.$Xn.as(R.$Yn.JSONContribution);class k{constructor(d,t,p){this.a=d,this.b=t,this.c=p}d(d,t){this.a({type:d,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(d){this.d(P.default.Error,d)}warn(d){this.d(P.default.Warning,d)}info(d){this.d(P.default.Info,d)}}e.$OF=k;class g{static a(d){const t=new f.$Bm;for(let p=0,u=d.length;p<u;p++)t.add(d[p].description.identifier);return t}static compute(d,t){if(!d||!d.length)return new g(t,[]);if(!t||!t.length)return new g([],d);const p=this.a(d),u=this.a(t),o=t.filter(b=>!p.has(b.description.identifier)),v=d.filter(b=>!u.has(b.description.identifier));return new g(o,v)}constructor(d,t){this.added=d,this.removed=t}}e.$PF=g;class s{constructor(d,t){this.name=d,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(d){if(this.a!==null)throw new Error("Handler already set!");this.a=d,this.d()}acceptUsers(d){this.c=g.compute(this.b,d),this.b=d,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(d){(0,M.$1)(d)}}}e.$QF=s;const a={type:"string",enum:["ui","workspace"],enumDescriptions:[S.localize(0,null),S.localize(1,null)]},r="vscode://schemas/vscode-extensions";e.$RF={properties:{engines:{type:"object",description:S.localize(2,null),properties:{vscode:{type:"string",description:S.localize(3,null),default:"^1.22.0"}}},publisher:{description:S.localize(4,null),type:"string"},displayName:{description:S.localize(5,null),type:"string"},categories:{description:S.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:f.$zm},{type:"string",const:"Languages",deprecationMessage:S.localize(7,null)}]}},galleryBanner:{type:"object",description:S.localize(8,null),properties:{color:{description:S.localize(9,null),type:"string"},theme:{description:S.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:S.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:S.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:S.localize(13,null)},enabledApiProposals:{markdownDescription:S.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:S.localize(15,null),type:"string",enum:["none"],enumDescriptions:[S.localize(16,null)]},activationEvents:{description:S.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:S.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:S.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:S.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:S.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:S.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:S.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:S.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:S.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:S.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:S.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:S.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:S.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:S.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:S.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:S.localize(32,null)},{label:"onUri",body:"onUri",description:S.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:S.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:S.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:S.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:S.localize(37,null)},{label:"onRenderer",description:S.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:S.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:S.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:S.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:S.localize(42,null)},{label:"*",description:S.localize(43,null),body:"*"}]}},badges:{type:"array",description:S.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:S.localize(45,null)},href:{type:"string",description:S.localize(46,null)},description:{type:"string",description:S.localize(47,null)}}}},markdown:{type:"string",description:S.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:S.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:S.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$Co}},extensionPack:{description:S.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:F.$Co}},extensionKind:{description:S.localize(52,null),type:"array",items:a,default:["workspace"],defaultSnippets:[{body:["ui"],description:S.localize(53,null)},{body:["workspace"],description:S.localize(54,null)},{body:["ui","workspace"],description:S.localize(55,null)},{body:["workspace","ui"],description:S.localize(56,null)},{body:[],description:S.localize(57,null)}]},capabilities:{description:S.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:S.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:S.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(61,null),S.localize(62,null),S.localize(63,null)]},description:{type:"string",markdownDescription:S.localize(64,null)}}},untrustedWorkspaces:{description:S.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:S.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(67,null),S.localize(68,null),S.localize(69,null)]},restrictedConfigurations:{description:S.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:S.localize(71,null)}}}}},sponsor:{description:S.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:S.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:S.localize(74,null),type:"string"},"vscode:uninstall":{description:S.localize(75,null),type:"string"}}},icon:{type:"string",description:S.localize(76,null)},l10n:{type:"string",description:S.localize(77,null)},pricing:{type:"string",markdownDescription:S.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(d){if(this.a.has(d.extensionPoint))throw new Error("Duplicate extension point: "+d.extensionPoint);const t=new s(d.extensionPoint,d.defaultExtensionKind);return this.a.set(d.extensionPoint,t),d.activationEventsGenerator&&D.$FF.register(d.extensionPoint,d.activationEventsGenerator),e.$RF.properties.contributes.properties[d.extensionPoint]=d.jsonSchema,l.registerSchema(r,e.$RF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$SF=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};m.$Xn.add(n.ExtensionsRegistry,new i),e.$TF=m.$Xn.as(n.ExtensionsRegistry),l.registerSchema(r,e.$RF),l.registerSchema(N.$Tj,{properties:{extensionEnabledApiProposals:{description:S.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(Pe[224],Re([1,0,178,16,26,223,35,5]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iH=void 0;const f={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:S.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:S.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:S.localize(2,null),default:""}}};var E;(function(l){function k(g,s,a){if(!g)return;const r=M.$Tf(g.type)?g.type:void 0;if(!r||r.length===0){a.error(S.localize(3,null));return}const i=[];if(Array.isArray(g.required))for(const n of g.required)M.$Tf(n)&&i.push(n);return{extensionId:s.value,taskType:r,required:i,properties:g.properties?P.$Ln(g.properties):{},when:g.when?R.$ej.deserialize(g.when):void 0}}l.from=k})(E||(E={}));const N=F.$TF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,k)=>{for(const g of l)g.type&&k.push(`onTaskType:${g.type}`)},jsonSchema:{description:S.localize(4,null),type:"array",items:f}});class D{constructor(){this.d=new m.$6d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((k,g)=>{N.setHandler((s,a)=>{this.c=void 0;try{for(const r of a.removed){const i=r.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const r of a.added){const i=r.value;for(const n of i){const c=E.from(n,r.description.identifier,r.collector);c&&(this.a[c.taskType]=c)}}(a.removed.length>0||a.added.length>0)&&this.d.fire()}catch{}k(void 0)})})}onReady(){return this.b}get(k){return this.a[k]}all(){return Object.keys(this.a).map(k=>this.a[k])}getJsonSchema(){if(this.c===void 0){const k=[];for(const g of this.all()){const s={type:"object",additionalProperties:!1};g.required.length>0&&(s.required=g.required.slice(0)),g.properties!==void 0?s.properties=P.$Ln(g.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[g.taskType]},k.push(s)}this.c={oneOf:k}}return this.c}}e.$iH=new D}),define(Pe[225],Re([1,0,179,16,24,26,35,224]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$sH=e.JsonSchemaVersion=e.ExecutionEngine=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$mH=e.ShellQuoting=e.$lH=e.$kH=e.$jH=void 0,e.$jH="settings",e.$kH=new R.$xj("taskRunning",!1,S.localize(0,null)),e.$lH=S.localize2(2,"Tasks");var f;(function(C){C[C.Escape=1]="Escape",C[C.Strong=2]="Strong",C[C.Weak=3]="Weak"})(f||(e.ShellQuoting=f={})),e.$mH="$customized",function(C){function O(q){if(!q)return C.Strong;switch(q.toLowerCase()){case"escape":return C.Escape;case"strong":return C.Strong;case"weak":return C.Weak;default:return C.Strong}}C.from=O}(f||(e.ShellQuoting=f={}));var E;(function(C){C.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var N;(function(C){C[C.Always=1]="Always",C[C.Silent=2]="Silent",C[C.Never=3]="Never"})(N||(e.RevealKind=N={})),function(C){function O(q){switch(q.toLowerCase()){case"always":return C.Always;case"silent":return C.Silent;case"never":return C.Never;default:return C.Always}}C.fromString=O}(N||(e.RevealKind=N={}));var D;(function(C){C[C.Never=1]="Never",C[C.OnProblem=2]="OnProblem",C[C.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(C){function O(q){switch(q.toLowerCase()){case"always":return C.Always;case"never":return C.Never;case"onproblem":return C.OnProblem;default:return C.OnProblem}}C.fromString=O}(D||(e.RevealProblemKind=D={}));var l;(function(C){C[C.Shared=1]="Shared",C[C.Dedicated=2]="Dedicated",C[C.New=3]="New"})(l||(e.PanelKind=l={})),function(C){function O(q){switch(q.toLowerCase()){case"shared":return C.Shared;case"dedicated":return C.Dedicated;case"new":return C.New;default:return C.Shared}}C.fromString=O}(l||(e.PanelKind=l={}));var k;(function(C){C.defaults={echo:!0,reveal:N.Always,revealProblems:D.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(k||(e.PresentationOptions=k={}));var g;(function(C){C[C.Shell=1]="Shell",C[C.Process=2]="Process",C[C.CustomExecution=3]="CustomExecution"})(g||(e.RuntimeType=g={})),function(C){function O(ne){switch(ne.toLowerCase()){case"shell":return C.Shell;case"process":return C.Process;case"customExecution":return C.CustomExecution;default:return C.Process}}C.fromString=O;function q(ne){switch(ne){case C.Shell:return"shell";case C.Process:return"process";case C.CustomExecution:return"customExecution";default:return"process"}}C.toString=q}(g||(e.RuntimeType=g={}));var s;(function(C){function O(q){return M.$Tf(q)?q:q.value}C.value=O})(s||(e.CommandString=s={}));var a;(function(C){C.Clean={_id:"clean",isDefault:!1},C.Build={_id:"build",isDefault:!1},C.Rebuild={_id:"rebuild",isDefault:!1},C.Test={_id:"test",isDefault:!1};function O(ne){return ne===C.Clean._id||ne===C.Build._id||ne===C.Rebuild._id||ne===C.Test._id}C.is=O;function q(ne){if(ne!==void 0)return M.$Tf(ne)?O(ne)?{_id:ne,isDefault:!1}:void 0:ne}C.from=q})(a||(e.TaskGroup=a={}));var r;(function(C){C[C.Global=1]="Global",C[C.Workspace=2]="Workspace",C[C.Folder=3]="Folder"})(r||(e.TaskScope=r={}));var i;(function(C){C.Workspace="workspace",C.Extension="extension",C.InMemory="inMemory",C.WorkspaceFile="workspaceFile",C.User="user";function O(q){switch(q){case C.User:return 2;case C.WorkspaceFile:return 5;default:return 6}}C.toConfigurationTarget=O})(i||(e.TaskSourceKind=i={}));var n;(function(C){C.parallel="parallel",C.sequence="sequence"})(n||(e.DependsOrder=n={}));var c;(function(C){C[C.default=1]="default",C[C.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var d;(function(C){C.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(d||(e.RunOptions=d={}));class t{constructor(O,q,ne,ce,ye,Ie){this._label="",this._id=O,q&&(this._label=q),ne&&(this.type=ne),this.runOptions=ce,this.configurationProperties=ye,this._source=Ie}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,q=!1){if(O===void 0)return!1;if(M.$Tf(O))return O===this._label||O===this.configurationProperties.identifier||q&&O===this._id;const ne=this.getDefinition(!0);return ne!==void 0&&ne._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$nH=t;class p extends t{constructor(O,q,ne,ce,ye,Ie,ue,ve){super(O,ne,void 0,ue,ve,q),this.command={},this._source=q,this.hasDefinedMatchers=Ie,ye&&(this.command=ye)}clone(){return new p(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let q;switch(this.command?this.command.runtime:void 0){case g.Shell:q="shell";break;case g.Process:q="process";break;case g.CustomExecution:q="customExecution";break;case void 0:q="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:q,_key:this._id,id:this._id}}}static is(O){return O instanceof p}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$jH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.d();if(!O)return;let q=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(q+=this._source.kind);const ne={type:e.$mH,folder:O,id:q};return JSON.stringify(ne)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$Qg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new p(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$oH=p;class u extends t{constructor(O,q,ne,ce,ye,Ie,ue){super(O,ne,ce,Ie,ue,q),this._source=q,this.configures=ye}static is(O){return O instanceof u}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$Qg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$jH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.d();if(!O)return;let q=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(q+=this._source.kind);const ne={type:e.$mH,folder:O,id:q};return JSON.stringify(ne)}}e.$pH=u;class o extends t{constructor(O,q,ne,ce,ye,Ie,ue,ve,re){super(O,ne,ce,ve,re,q),this.defines=ye,this.hasDefinedMatchers=ue,this.command=Ie,this.icon=re.icon,this.hide=re.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof o}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new o(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$qH=o;class v extends t{constructor(O,q,ne,ce,ye,Ie){super(O,ne,ce,ye,Ie,q),this._source=q}clone(){return new v(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof v}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new v(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$rH=v;var b;(function(C){C[C.Process=1]="Process",C[C.Terminal=2]="Terminal"})(b||(e.ExecutionEngine=b={})),function(C){C._default=C.Terminal}(b||(e.ExecutionEngine=b={}));var $;(function(C){C[C.V0_1_0=1]="V0_1_0",C[C.V2_0_0=2]="V2_0_0"})($||(e.JsonSchemaVersion=$={}));class I{constructor(O){this.c=new Map;for(let q=0;q<O.length;q++)this.c.set(O[q].uri.toString(),q)}compare(O,q){const ne=O.getWorkspaceFolder(),ce=q.getWorkspaceFolder();if(ne&&ce){let ye=this.c.get(ne.uri.toString());ye=ye===void 0?0:ye+1;let Ie=this.c.get(ce.uri.toString());return Ie=Ie===void 0?0:Ie+1,ye===Ie?O._label.localeCompare(q._label):ye-Ie}else return!ne&&ce?-1:ne&&!ce?1:0}}e.$sH=I;var h;(function(C){C.DependsOnStarted="dependsOnStarted",C.AcquiredInput="acquiredInput",C.Start="start",C.ProcessStarted="processStarted",C.Active="active",C.Inactive="inactive",C.Changed="changed",C.Terminated="terminated",C.ProcessEnded="processEnded",C.End="end"})(h||(e.TaskEventKind=h={}));var y;(function(C){C.SingleRun="singleRun",C.Background="background"})(y||(e.TaskRunType=y={}));var w;(function(C){C[C.System=0]="System",C[C.User=1]="User",C[C.FolderOpen=2]="FolderOpen",C[C.ConfigurationChange=3]="ConfigurationChange",C[C.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var A;(function(C){function O(ve){return{taskId:ve._id,taskName:ve.configurationProperties.name,runType:ve.configurationProperties.isBackground?"background":"singleRun",group:ve.configurationProperties.group,__task:ve}}function q(ve,re,$e){return{...O(ve),kind:"start",terminalId:re,resolvedVariables:$e}}C.start=q;function ne(ve,re,$e){return{...O(ve),kind:"processStarted",terminalId:re,processId:$e}}C.processStarted=ne;function ce(ve,re,$e){return{...O(ve),kind:"processEnded",terminalId:re,exitCode:$e}}C.processEnded=ce;function ye(ve,re,$e){return{...O(ve),kind:"terminated",exitReason:$e,terminalId:re}}C.terminated=ye;function Ie(ve,re,$e){return{...O(re),kind:ve,terminalId:$e}}C.general=Ie;function ue(){return{kind:"changed"}}C.changed=ue})(A||(e.TaskEvent=A={}));var L;(function(C){function O(ne){const ce=Object.keys(ne).sort();let ye="";for(const Ie of ce){let ue=ne[Ie];ue instanceof Object?ue=O(ue):typeof ue=="string"&&(ue=ue.replace(/,/g,",,")),ye+=Ie+","+ue+","}return ye}function q(ne){const ye={_key:O(ne),type:ne.taskType};return Object.assign(ye,ne),ye}C.create=q})(L||(e.KeyedTaskIdentifier=L={}));var J;(function(C){C.AutoDetect="task.autoDetect",C.SaveBeforeRun="task.saveBeforeRun",C.ShowDecorations="task.showDecorations",C.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",C.SlowProviderWarning="task.slowProviderWarning",C.QuickOpenHistory="task.quickOpen.history",C.QuickOpenDetail="task.quickOpen.detail",C.QuickOpenSkip="task.quickOpen.skip",C.QuickOpenShowAll="task.quickOpen.showAll",C.AllowAutomaticTasks="task.allowAutomaticTasks",C.Reconnection="task.reconnection",C.VerboseLogging="task.verboseLogging"})(J||(e.TaskSettingId=J={}));var W;(function(C){C.Tasks="tasks",C.SuppressTaskName="tasks.suppressTaskName",C.Windows="tasks.windows",C.Osx="tasks.osx",C.Linux="tasks.linux",C.ShowOutput="tasks.showOutput",C.IsShellCommand="tasks.isShellCommand",C.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var U;(function(C){function O(q,ne){const ce=m.$iH.get(q.type);if(ce===void 0){const ve=F.$Ln(q);return delete ve._key,L.create(ve)}const ye=Object.create(null);ye.type=ce.taskType;const Ie=new Set;ce.required.forEach(ve=>Ie.add(ve));const ue=ce.properties;for(const ve of Object.keys(ue)){const re=q[ve];if(re!=null)ye[ve]=re;else if(Ie.has(ve)){const $e=ue[ve];if($e.default!==void 0)ye[ve]=F.$Ln($e.default);else switch($e.type){case"boolean":ye[ve]=!1;break;case"number":case"integer":ye[ve]=0;break;case"string":ye[ve]="";break;default:ne.error(S.localize(1,null,JSON.stringify(q,void 0,0),ve));return}}}return L.create(ye)}C.createTaskIdentifier=O})(U||(e.TaskDefinition=U={}))}),define(Pe[226],Re([1,0,14]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f0b=e.$e0b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,m)=>{this.b=R,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,S.$1)(R))}then(R,m){return this.j().then(R,m)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$e0b=M;class P extends M{constructor(){super(),this.h=!0,this.i=new S.$5}}e.$f0b=P}),define(Pe[49],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0v=e.$9v=e.$8v=e.$7v=void 0;class S{static{this.count=0}constructor(f){this._proxyIdentifierBrand=void 0,this.sid=f,this.nid=++S.count}}e.$7v=S;const M=[];function P(m){const f=new S(m);return M[f.nid]=f,f}e.$8v=P;function F(m){return M[m].sid}e.$9v=F;class R{constructor(f){this.value=f}}e.$0v=R}),define(Pe[4],Re([1,0,49]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=e.$0L=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$9L=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var P;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput",s[s.ChatEditorInput=10]="ChatEditorInput"})(P||(e.TabInputKind=P={}));var F;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(F||(e.TabModelOperationKind=F={}));var R;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var m;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var f;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(f||(e.CellOutputKind=f={}));var E;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var N;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(N||(e.CandidatePortSource=N={}));class D{static{this.a=0}static mixin(a){return a._id=D.a++,a}}e.$9L=D;var l;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var k;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(k||(e.ISuggestResultDtoField=k={}));var g;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(g||(e.ExtHostTestingResource=g={})),e.$0L={MainThreadAuthentication:(0,S.$8v)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.$8v)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,S.$8v)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,S.$8v)("MainThreadChatAgents2"),MainThreadChatVariables:(0,S.$8v)("MainThreadChatVariables"),MainThreadClipboard:(0,S.$8v)("MainThreadClipboard"),MainThreadCommands:(0,S.$8v)("MainThreadCommands"),MainThreadComments:(0,S.$8v)("MainThreadComments"),MainThreadConfiguration:(0,S.$8v)("MainThreadConfiguration"),MainThreadConsole:(0,S.$8v)("MainThreadConsole"),MainThreadDebugService:(0,S.$8v)("MainThreadDebugService"),MainThreadDecorations:(0,S.$8v)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.$8v)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.$8v)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.$8v)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.$8v)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.$8v)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.$8v)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.$8v)("MainThreadEditorTabs"),MainThreadErrors:(0,S.$8v)("MainThreadErrors"),MainThreadTreeViews:(0,S.$8v)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.$8v)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,S.$8v)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.$8v)("MainThreadLanguages"),MainThreadLogger:(0,S.$8v)("MainThreadLogger"),MainThreadMessageService:(0,S.$8v)("MainThreadMessageService"),MainThreadOutputService:(0,S.$8v)("MainThreadOutputService"),MainThreadProgress:(0,S.$8v)("MainThreadProgress"),MainThreadQuickDiff:(0,S.$8v)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,S.$8v)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.$8v)("MainThreadStatusBar"),MainThreadSecretState:(0,S.$8v)("MainThreadSecretState"),MainThreadStorage:(0,S.$8v)("MainThreadStorage"),MainThreadSpeech:(0,S.$8v)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,S.$8v)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.$8v)("MainThreadTerminalService"),MainThreadWebviews:(0,S.$8v)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.$8v)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.$8v)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.$8v)("MainThreadCustomEditors"),MainThreadUrls:(0,S.$8v)("MainThreadUrls"),MainThreadUriOpeners:(0,S.$8v)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,S.$8v)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,S.$8v)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.$8v)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,S.$8v)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,S.$8v)("MainThreadExtensionService"),MainThreadSCM:(0,S.$8v)("MainThreadSCM"),MainThreadSearch:(0,S.$8v)("MainThreadSearch"),MainThreadShare:(0,S.$8v)("MainThreadShare"),MainThreadTask:(0,S.$8v)("MainThreadTask"),MainThreadWindow:(0,S.$8v)("MainThreadWindow"),MainThreadLabelService:(0,S.$8v)("MainThreadLabelService"),MainThreadNotebook:(0,S.$8v)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.$8v)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.$8v)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.$8v)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.$8v)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.$8v)("MainThreadInteractive"),MainThreadChat:(0,S.$8v)("MainThreadChat"),MainThreadInlineChat:(0,S.$8v)("MainThreadInlineChatShape"),MainThreadTheming:(0,S.$8v)("MainThreadTheming"),MainThreadTunnelService:(0,S.$8v)("MainThreadTunnelService"),MainThreadManagedSockets:(0,S.$8v)("MainThreadManagedSockets"),MainThreadTimeline:(0,S.$8v)("MainThreadTimeline"),MainThreadTesting:(0,S.$8v)("MainThreadTesting"),MainThreadLocalization:(0,S.$8v)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,S.$8v)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,S.$8v)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,S.$8v)("MainThreadIssueReporter")},e.$$L={ExtHostCommands:(0,S.$8v)("ExtHostCommands"),ExtHostConfiguration:(0,S.$8v)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.$8v)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.$8v)("ExtHostDebugService"),ExtHostDecorations:(0,S.$8v)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.$8v)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.$8v)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.$8v)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.$8v)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.$8v)("ExtHostEditors"),ExtHostTreeViews:(0,S.$8v)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.$8v)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.$8v)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.$8v)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.$8v)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.$8v)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.$8v)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,S.$8v)("ExtHostQuickDiff"),ExtHostStatusBar:(0,S.$8v)("ExtHostStatusBar"),ExtHostShare:(0,S.$8v)("ExtHostShare"),ExtHostExtensionService:(0,S.$8v)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.$8v)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.$8v)("ExtHostTerminalService"),ExtHostSCM:(0,S.$8v)("ExtHostSCM"),ExtHostSearch:(0,S.$8v)("ExtHostSearch"),ExtHostTask:(0,S.$8v)("ExtHostTask"),ExtHostWorkspace:(0,S.$8v)("ExtHostWorkspace"),ExtHostWindow:(0,S.$8v)("ExtHostWindow"),ExtHostWebviews:(0,S.$8v)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.$8v)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.$8v)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.$8v)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.$8v)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.$8v)("ExtHostEditorTabs"),ExtHostProgress:(0,S.$8v)("ExtHostProgress"),ExtHostComments:(0,S.$8v)("ExtHostComments"),ExtHostSecretState:(0,S.$8v)("ExtHostSecretState"),ExtHostStorage:(0,S.$8v)("ExtHostStorage"),ExtHostUrls:(0,S.$8v)("ExtHostUrls"),ExtHostUriOpeners:(0,S.$8v)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,S.$8v)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,S.$8v)("ExtHostOutputService"),ExtHostLabelService:(0,S.$8v)("ExtHostLabelService"),ExtHostNotebook:(0,S.$8v)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.$8v)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.$8v)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.$8v)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.$8v)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,S.$8v)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,S.$8v)("ExtHostInteractive"),ExtHostInlineChat:(0,S.$8v)("ExtHostInlineChatShape"),ExtHostChat:(0,S.$8v)("ExtHostChat"),ExtHostChatAgents2:(0,S.$8v)("ExtHostChatAgents"),ExtHostChatVariables:(0,S.$8v)("ExtHostChatVariables"),ExtHostChatProvider:(0,S.$8v)("ExtHostChatProvider"),ExtHostSpeech:(0,S.$8v)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,S.$8v)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,S.$8v)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,S.$8v)("ExtHostTheming"),ExtHostTunnelService:(0,S.$8v)("ExtHostTunnelService"),ExtHostManagedSockets:(0,S.$8v)("ExtHostManagedSockets"),ExtHostAuthentication:(0,S.$8v)("ExtHostAuthentication"),ExtHostTimeline:(0,S.$8v)("ExtHostTimeline"),ExtHostTesting:(0,S.$8v)("ExtHostTesting"),ExtHostTelemetry:(0,S.$8v)("ExtHostTelemetry"),ExtHostLocalization:(0,S.$8v)("ExtHostLocalization"),ExtHostIssueReporter:(0,S.$8v)("ExtHostIssueReporter")}}),define(Pe[78],Re([1,0,3,13,4,17]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=e.$dic=e.$cic=void 0,e.$cic=(0,S.$gi)("IExtHostApiDeprecationService");let R=class{constructor(f,E){this.c=E,this.a=new Set,this.b=f.getProxy(P.$0L.MainThreadTelemetry)}report(f,E,N){const D=this.d(f,E);this.a.has(D)||(this.a.add(D),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${f}' is deprecated. ${N}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:f}))}d(f,E){return`${f}-${E.identifier.value}`}};e.$dic=R,e.$dic=R=Qe([qe(0,F.$pO),qe(1,M.$Aj)],R),e.$eic=Object.freeze(new class{report(m,f,E){}})}),define(Pe[227],Re([1,0,51,6,4]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pic=void 0;class F{static{this.a=0}constructor(f,E){this.extension=f,this.provider=E,this.handle=F.a++}}class R{static{this.a=0}constructor(f){this.b=new Map,this.c=new Map,this.d=f.getProxy(P.$0L.MainThreadChat)}registerChatProvider(f,E,N){const D=new F(f,N);return this.b.set(D.handle,D),this.d.$registerChatProvider(D.handle,E),(0,M.$Rc)(()=>{this.d.$unregisterChatProvider(D.handle),this.b.delete(D.handle)})}transferChatSession(f,E){const N=S.Iterable.find(this.c.keys(),D=>this.c.get(D)===f)??0;typeof N=="number"&&this.d.$transferChatSession(N,E)}async $prepareChat(f,E){const N=this.b.get(f);if(!N)return;const D=await N.provider.prepareSession(E);if(!D)return;const l=R.a++;return this.c.set(l,D),{id:l}}$releaseSession(f){this.c.delete(f)}}e.$pic=R}),define(Pe[228],Re([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=void 0;class M{constructor(F){const R=F.getProxy(S.$0L.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(m){return R.$writeText(m)}})}}e.$uic=M}),define(Pe[229],Re([1,0,26,4,27,17]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lkc=void 0;let R=class{constructor(N,D){this.a=N.getProxy(M.$0L.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(N,D){const l=this,k=console[N];Object.defineProperty(console,N,{set:()=>{},get:()=>function(){l.e(N,D,k,arguments)}})}e(N,D,l,k){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:f(k,this.b)}),this.c&&this.f(N,l,k)}};e.$lkc=R,e.$lkc=R=Qe([qe(0,F.$pO),qe(1,P.$FO)],R);const m=1e5;function f(E,N){const D=[];if(E.length)for(let l=0;l<E.length;l++){let k=E[l];if(typeof k>"u")k="undefined";else if(k instanceof Error){const g=k;g.stack?k=g.stack:k=g.toString()}D.push(k)}if(N){const l=new Error().stack;l&&D.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,S.$Qn)(D);return l.length>m?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Pe[230],Re([1,0,2,4,22]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pjc=void 0;class F{constructor(m){this.a=m.getProxy(M.$0L.MainThreadDialogs)}showOpenDialog(m,f){return f?.allowUIResources&&(0,P.$1F)(m,"showLocal"),this.a.$showOpenDialog(f).then(E=>E?E.map(N=>S.URI.revive(N)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(f=>f?S.URI.revive(f):void 0)}}e.$pjc=F}),define(Pe[231],Re([1,0,6,4]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kjc=void 0;class P{constructor(R){this.b=0,this.a=R.getProxy(M.$0L.MainThreadLabelService)}$registerResourceLabelFormatter(R){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,R),(0,S.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$Kjc=P}),define(Pe[79],Re([1,0,21,15,2,3,13,4,27,17]),function(me,e,S,M,P,F,R,m,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ic=e.$0ic=void 0;let N=class{constructor(l,k,g){this.f=g,this.d=new Map,this.a=k.getProxy(m.$0L.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===S.$g}getMessage(l,k){const{message:g,args:s,comment:a}=k;if(this.c)return(0,M.$Ve)(g,s??{});let r=g;a&&a.length>0&&(r+=`/${Array.isArray(a)?a.join(""):a}`);const i=this.d.get(l)?.contents[r];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${r}`),(0,M.$Ve)(i??g,s??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let k;const g=await this.g(l);if(!g){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(g),a=JSON.parse(s);k=l.isBuiltin?a.contents?.bundle:a}catch(s){this.f.error(`Failed to load translations for ${l.identifier.value} from ${g}: ${s.message}`);return}k&&this.d.set(l.identifier.value,{contents:k,uri:g})}async g(l){if(l.isBuiltin){const k=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return P.URI.revive(k)}return l.l10n?P.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$0ic=N,e.$0ic=N=Qe([qe(0,f.$FO),qe(1,E.$pO),qe(2,R.$Aj)],N),e.$$ic=(0,F.$gi)("IExtHostLocalizationService")}),define(Pe[232],Re([1,0,13,4,27,17,2,52]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kkc=void 0;let f=class extends S.$Lj{constructor(D,l){super(l.logLevel,l.logsLocation,l.loggers.map(k=>(0,m.$Ph)(k))),this.r=D.getProxy(M.$0L.MainThreadLogger)}$setLogLevel(D,l){l?this.setLogLevel(R.URI.revive(l),D):this.setLogLevel(D)}setVisibility(D,l){super.setVisibility(D,l),this.r.$setVisibility(D,l)}s(D,l,k){return new E(this.r,D,l,k)}};e.$kkc=f,e.$kkc=f=Qe([qe(0,F.$pO),qe(1,P.$FO)],f);class E extends S.$Gj{constructor(D,l,k,g){super(g?.logLevel==="always"),this.r=D,this.s=l,this.m=!1,this.n=[],this.setLevel(k),this.r.$createLogger(l,g).then(()=>{this.u(this.n),this.m=!0})}g(D,l){const k=[[D,l]];this.m?this.u(k):this.n.push(...k)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Pe[80],Re([1,0,4,3,6,17,23]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ajc=e.$_ic=void 0,e.$_ic=(0,M.$gi)("IExtHostManagedSockets");let m=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(S.$0L.MainThreadManagedSockets)}setFactory(D,l){for(const k of this.d.values())k.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new f(D,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const l=++this.b,k=await this.c.makeConnection(),g=new P.$Sc;return this.d.set(l,new E(l,k,g)),g.add((0,P.$Rc)(()=>this.d.delete(l))),g.add(k.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),g.dispose()})),g.add(k.onDidClose(s=>{this.a.$onDidManagedSocketClose(l,s?.stack??s?.message),g.dispose()})),g.add(k.onDidReceiveMessage(s=>this.a.$onDidManagedSocketHaveData(l,R.$te.wrap(s)))),l}$remoteSocketWrite(D,l){this.d.get(D)?.actual.send(l.buffer)}$remoteSocketEnd(D){const l=this.d.get(D);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$ajc=m,e.$ajc=m=Qe([qe(0,F.$pO)],m);class f{constructor(D,l){this.socketFactoryId=D,this.makeConnection=l}}class E extends P.$Tc{constructor(D,l,k){super(),this.socketId=D,this.actual=l,this.B(k)}}}),define(Pe[233],Re([1,0,4,13,22]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mjc=void 0;function F(m){return m&&m.title}let R=class{constructor(f,E){this.b=E,this.a=f.getProxy(S.$0L.MainThreadMessageService)}showMessage(f,E,N,D,l){const k={source:{identifier:f.identifier,label:f.displayName||f.name}};let g;typeof D=="string"||F(D)?g=[D,...l]:(k.modal=D?.modal,k.useCustom=D?.useCustom,k.detail=D?.detail,g=l),k.useCustom&&(0,P.$1F)(f,"resolvers");const s=[];let a=!1;for(let r=0;r<g.length;r++){const i=g[r];if(typeof i=="string")s.push({title:i,handle:r,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:c}=i;s.push({title:n,isCloseAffordance:!!c,handle:r}),c&&(a?this.b.warn(`[${f.identifier}] Only one message item can have 'isCloseAffordance':`,i):a=!0)}else this.b.warn(`[${f.identifier}] Invalid message item:`,i)}return this.a.$showMessage(E,N,k,s).then(r=>{if(typeof r=="number")return g[r]})}};e.$Mjc=R,e.$Mjc=R=Qe([qe(1,M.$Aj)],R)}),define(Pe[234],Re([1,0,6,16,2,22,4]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vjc=void 0;class m{constructor(E){this.b=new Map,this.a=E.getProxy(R.$0L.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,N,D){if((0,F.$1F)(E,"profileContentHandlers"),this.b.has(N))throw new Error(`Handler with id '${N}' already registered`);return this.b.set(N,D),this.a.$registerProfileContentHandler(N,D.name,D.description,E.identifier.value),(0,S.$Rc)(()=>{this.b.delete(N),this.a.$unregisterProfileContentHandler(N)})}async $saveProfile(E,N,D,l){const k=this.b.get(E);if(!k)throw new Error(`Unknown handler with id: ${E}`);return k.saveProfile(N,D,l)}async $readProfile(E,N,D){const l=this.b.get(E);if(!l)throw new Error(`Unknown handler with id: ${E}`);return l.readProfile((0,M.$Tf)(N)?N:P.URI.revive(N),D)}}e.$Vjc=m}),define(Pe[81],Re([1,0,4,5,3]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ic=e.$7ic=void 0;class F{constructor(m){this.b=new M.$6d,this.onDidChangePassword=this.b.event,this.a=m.getProxy(S.$0L.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,f){return this.a.$getPassword(m,f)}store(m,f,E){return this.a.$setPassword(m,f,E)}delete(m,f){return this.a.$deletePassword(m,f)}}e.$7ic=F,e.$8ic=(0,P.$gi)("IExtHostSecretState")}),define(Pe[235],Re([1,0,25,6,4]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3jc=void 0;class F{static{this.a=1}constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(P.$0L.MainThreadSpeech)}async $createSpeechToTextSession(m,f,E){const N=this.c.get(m);if(!N)return;const D=new M.$Sc,l=new S.$de;this.d.set(f,l);const k=D.add(N.provideSpeechToTextSession(l.token,E?{language:E}:void 0));D.add(k.onDidChange(g=>{l.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(f,g)})),D.add(l.token.onCancellationRequested(()=>D.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}async $createKeywordRecognitionSession(m,f){const E=this.c.get(m);if(!E)return;const N=new M.$Sc,D=new S.$de;this.d.set(f,D);const l=N.add(E.provideKeywordRecognitionSession(D.token));N.add(l.onDidChange(k=>{D.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(f,k)})),N.add(D.token.onCancellationRequested(()=>N.dispose()))}async $cancelKeywordRecognitionSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,f,E){const N=F.a++;return this.c.set(N,E),this.b.$registerProvider(N,f,{extension:m,displayName:m.value}),(0,M.$Rc)(()=>{this.b.$unregisterProvider(N),this.c.delete(N)})}}e.$3jc=F}),define(Pe[82],Re([1,0,4,5,3]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zic=e.$Yic=void 0;class F{constructor(m,f){this.c=f,this.b=new M.$6d,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(S.$0L.MainThreadStorage)}registerExtensionStorageKeysToSync(m,f){this.a.$registerExtensionStorageKeysToSync(m,f)}async initializeExtensionStorage(m,f,E){const N=await this.a.$initializeExtensionStorage(m,f);let D;return N&&(D=this.d(m,f,N)),D||E}setValue(m,f,E){return this.a.$setValue(m,f,E)}$acceptValue(m,f,E){const N=this.d(m,f,E);N&&this.b.fire({shared:m,key:f,value:N})}d(m,f,E){try{return JSON.parse(E)}catch(N){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${m}): ${N}`)}}}e.$Yic=F,e.$Zic=(0,P.$gi)("IExtHostStorage")}),define(Pe[236],Re([1,0,6,12,2,4]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ekc=void 0;class R{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(f){this.c=new Map,this.b=f.getProxy(F.$0L.MainThreadUriOpeners)}registerExternalUriOpener(f,E,N,D){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const l=D.schemes.find(k=>!R.a.has(k));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(E,N),this.b.$registerUriOpener(E,D.schemes,f,D.label),(0,S.$Rc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(f,E,N){const D=this.c.get(f);if(!D)throw new Error(`Unknown opener with id: ${f}`);const l=P.URI.revive(E);return D.canOpenExternalUri(l,N)}async $openUri(f,E,N){const D=this.c.get(f);if(!D)throw new Error(`Unknown opener id: '${f}'`);return D.openExternalUri(P.URI.revive(E.resolvedUri),{sourceUri:P.URI.revive(E.sourceUri)},N)}}e.$ekc=R}),define(Pe[237],Re([1,0,4,2,6,14,20]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fkc=void 0;class m{static{this.a=0}constructor(E){this.c=new R.$Bm,this.d=new Map,this.b=E.getProxy(S.$0L.MainThreadUrls)}registerUriHandler(E,N){const D=E.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const l=m.a++;return this.c.add(D),this.d.set(l,N),this.b.$registerUriHandler(l,D,E.displayName||E.name),(0,P.$Rc)(()=>{this.c.delete(D),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(E,N){const D=this.d.get(E);if(!D)return Promise.resolve(void 0);try{D.handleUri(M.URI.revive(N))}catch(l){(0,F.$1)(l)}return Promise.resolve(void 0)}async createAppUri(E){return M.URI.revive(await this.b.$createAppUri(E))}}e.$fkc=m}),define(Pe[62],Re([1,0,5,6,12,26,2,185,207,76,4]),function(me,e,S,M,P,F,R,m,f,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=e.$Mic=e.$Lic=e.$Kic=e.$Jic=void 0;class D{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(c,d,t,p,u,o,v){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new S.$6d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new S.$6d,this._onDidDispose=this.#h.event,this.#e=c,this.#t=d,this.#o=t,this.#n=p,this.#s=u,this.#r=o,this.#l=l(o),this.#d=k(o),this.#i=v}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,E.$Lxb)(c,this.#n)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===P.Schemas.https||c.scheme===P.Schemas.http){let d=c.toString();return d.endsWith("/")||(d+="/"),d+" "+E.$Kxb}return E.$Kxb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#o}set options(c){this.a(),F.$Pn(this.#o,c)||this.#t.$setOptions(this.#e,a(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const d=(0,f.$jnb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,d.message,...d.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const d=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(p,u,o,v,b,$)=>{const I=R.URI.from({scheme:v||"file",path:decodeURIComponent(b)}),h=(0,E.$Lxb)(I,{isRemote:d,authority:t}).toString();return`${u}${h}${$}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(p,u,o,v,b,$)=>{const I=R.URI.from({scheme:v||"file",path:decodeURIComponent(b)}),h=(0,E.$Lxb)(I,{isRemote:d,authority:t}).toString();return`${u}${h}${$}`})}}e.$Jic=D;function l(n){try{const c=(0,m.$rp)((0,m.$qp)(n.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}e.$Kic=l;function k(n){try{const c=(0,m.$rp)((0,m.$qp)(n.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class g extends M.$Tc{constructor(c,d,t,p,u){super(),this.c=d,this.f=t,this.g=p,this.h=u,this.b=new Map,this.a=c.getProxy(N.$0L.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,d,t){const p=this.j(c);if(p){const{message:u}=(0,f.$knb)(d,t.value);p._onMessageEmitter.fire(u)}}$onMissingCsp(c,d){this.g.warn(`${d} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,d,t){const p=new D(c,this.a,r(d),this.c,this.f,t,this.h);this.b.set(c,p);const u=p._onDidDispose(()=>{u.dispose(),this.deleteWebview(c)});return p}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$Lic=g;function s(n){return{id:n.identifier,location:n.extensionLocation}}e.$Mic=s;function a(n,c,d){return{enableCommandUris:d.enableCommandUris,enableScripts:d.enableScripts,enableForms:d.enableForms,portMapping:d.portMapping,localResourceRoots:d.localResourceRoots||i(n,c)}}e.$Nic=a;function r(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(c=>R.URI.from(c))}}function i(n,c){return[...(c?.getWorkspaceFolders()||[]).map(d=>d.uri),n.extensionLocation]}}),define(Pe[109],Re([1,0,5,4,2,12,15,3,17,22]),function(me,e,S,M,P,F,R,m,f,E){"use strict";var N;Object.defineProperty(e,"__esModule",{value:!0}),e.$ikc=e.$hkc=void 0;let D=class{static{N=this}static{this.a={focused:!0,active:!0}}getState(k){const g=this.d;return{get focused(){return g.focused},get active(){return(0,E.$1F)(k,"windowActivity"),g.active}}}constructor(k){this.c=new S.$6d,this.onDidChangeWindowState=this.c.event,this.d=N.a,this.b=k.getProxy(M.$0L.MainThreadWindow),this.b.$getInitialState().then(({isFocused:g,isActive:s})=>{this.onDidChangeWindowProperty("focused",g),this.onDidChangeWindowProperty("active",s)})}$onDidChangeWindowFocus(k){this.onDidChangeWindowProperty("focused",k)}$onDidChangeWindowActive(k){this.onDidChangeWindowProperty("active",k)}onDidChangeWindowProperty(k,g){g!==this.d[k]&&(this.d={...this.d,[k]:g},this.c.fire(this.d))}openUri(k,g){let s;if(typeof k=="string"){s=k;try{k=P.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,R.$Te)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===F.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this.b.$openUri(k,s,g)}async asExternalUri(k,g){if((0,R.$Te)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const s=await this.b.$asExternalUri(k,g);return P.URI.from(s)}};e.$hkc=D,e.$hkc=D=N=Qe([qe(0,f.$pO)],D),e.$ikc=(0,m.$gi)("IExtHostWindow")}),define(Pe[238],Re([1,0,229,27,17]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tmc=void 0;let F=class extends S.$lkc{constructor(m,f){super(m,f)}f(m,f,E){f.apply(console,E)}};e.$tmc=F,e.$tmc=F=Qe([qe(0,P.$pO),qe(1,M.$FO)],F)}),define(Pe[239],Re([1,0,11,23,25,14,5,6,142,226,49]),function(me,e,S,M,P,F,R,m,f,E,N){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$i0b=e.ResponsiveState=e.RequestInitiator=e.$h0b=e.$g0b=void 0;function l(w,A){try{return JSON.stringify(w,A)}catch{return"null"}}const k="$$ref$$",g={[k]:-1};class s{constructor(A,L){this.jsonString=A,this.referencedBuffers=L}}function a(w,A=null,L=!1){const J=[];return{jsonString:(L?l:JSON.stringify)(w,(U,C)=>{if(typeof C>"u")return g;if(typeof C=="object"){if(C instanceof M.$te){const O=J.push(C)-1;return{[k]:O}}if(A)return A(U,C)}return C}),referencedBuffers:J}}e.$g0b=a;function r(w,A,L){return JSON.parse(w,(J,W)=>{if(W){const U=W[k];if(typeof U=="number")return A[U];if(L&&W.$mid===1)return L.transformIncoming(W)}return W})}e.$h0b=r;function i(w,A){return JSON.stringify(w,A)}function n(w){return w?(A,L)=>L&&L.$mid===1?w.transformOutgoing(L):L:null}var c;(function(w){w[w.LocalSide=0]="LocalSide",w[w.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var d;(function(w){w[w.Responsive=0]="Responsive",w[w.Unresponsive=1]="Unresponsive"})(d||(e.ResponsiveState=d={}));const t=()=>{},p=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class o extends m.$Tc{static{D=p}static{this.a=3*1e3}constructor(A,L=null,J=null){super(),this[D]=!0,this.b=this.B(new R.$6d),this.onDidChangeResponsiveState=this.b.event,this.c=A,this.f=L,this.g=J,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,U=N.$7v.count;W<U;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new S.$sh(()=>this.H(),1e3)),this.c.onMessage(W=>this.L(W))}dispose(){this.j=!0,Object.keys(this.w).forEach(A=>{const L=this.w[A];delete this.w[A],L.resolveErr(F.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(A){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(A){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(A){this.y!==A&&(this.y=A,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(A){return this.g?(0,f.$kn)(A,this.g):A}getProxy(A){const{nid:L,sid:J}=A;return this.s[L]||(this.s[L]=this.J(L,J)),this.s[L]}J(A,L){const J={get:(W,U)=>(typeof U=="string"&&!W[U]&&U.charCodeAt(0)===36&&(W[U]=(...C)=>this.U(A,U,C)),U===u?L:W[U])};return new Proxy(Object.create(null),J)}set(A,L){return this.m[A.nid]=L,L}assertRegistered(A){for(let L=0,J=A.length;L<J;L++){const W=A[L];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(A){if(this.j)return;const L=A.byteLength,J=b.read(A,0),W=J.readUInt8(),U=J.readUInt32();switch(W){case 1:case 2:{let{rpcId:C,method:O,args:q}=I.deserializeRequestJSONArgs(J);this.g&&(q=(0,f.$kn)(q,this.g)),this.M(L,U,C,O,q,W===2);break}case 3:case 4:{let{rpcId:C,method:O,args:q}=I.deserializeRequestMixedArgs(J);this.g&&(q=(0,f.$kn)(q,this.g)),this.M(L,U,C,O,q,W===4);break}case 5:{this.f?.logIncoming(L,U,0,"ack"),this.G(U);break}case 6:{this.N(L,U);break}case 7:{this.O(L,U,void 0);break}case 9:{let C=I.deserializeReplyOKJSON(J);this.g&&(C=(0,f.$kn)(C,this.g)),this.O(L,U,C);break}case 10:{const C=I.deserializeReplyOKJSONWithBuffers(J,this.g);this.O(L,U,C);break}case 8:{const C=I.deserializeReplyOKVSBuffer(J);this.O(L,U,C);break}case 11:{let C=I.deserializeReplyErrError(J);this.g&&(C=(0,f.$kn)(C,this.g)),this.P(L,U,C);break}case 12:{this.P(L,U,void 0);break}default:console.error("received unexpected message"),console.error(A)}}M(A,L,J,W,U,C){this.f?.logIncoming(A,L,1,`receiveRequest ${(0,N.$9v)(J)}.${W}(`,U);const O=String(L);let q,ne;if(C){const ye=new P.$de;U.push(ye.token),q=this.Q(J,W,U),ne=()=>ye.cancel()}else q=this.Q(J,W,U),ne=t;this.u[O]=ne;const ce=I.serializeAcknowledged(L);this.f?.logOutgoing(ce.byteLength,L,1,"ack"),this.c.send(ce),q.then(ye=>{delete this.u[O];const Ie=I.serializeReplyOK(L,ye,this.h);this.f?.logOutgoing(Ie.byteLength,L,1,"reply:",ye),this.c.send(Ie)},ye=>{delete this.u[O];const Ie=I.serializeReplyErr(L,ye);this.f?.logOutgoing(Ie.byteLength,L,1,"replyErr:",ye),this.c.send(Ie)})}N(A,L){this.f?.logIncoming(A,L,1,"receiveCancel");const J=String(L);this.u[J]?.()}O(A,L,J){this.f?.logIncoming(A,L,0,"receiveReply:",J);const W=String(L);if(!this.w.hasOwnProperty(W))return;const U=this.w[W];delete this.w[W],U.resolveOk(J)}P(A,L,J){this.f?.logIncoming(A,L,0,"receiveReplyErr:",J);const W=String(L);if(!this.w.hasOwnProperty(W))return;const U=this.w[W];delete this.w[W];let C;J&&(J.$isError?(C=new Error,C.name=J.name,C.message=J.message,C.stack=J.stack):C=J),U.resolveErr(C)}Q(A,L,J){try{return Promise.resolve(this.S(A,L,J))}catch(W){return Promise.reject(W)}}S(A,L,J){const W=this.m[A];if(!W)throw new Error("Unknown actor "+(0,N.$9v)(A));const U=W[L];if(typeof U!="function")throw new Error("Unknown method "+L+" on actor "+(0,N.$9v)(A));return U.apply(W,J)}U(A,L,J){if(this.j)return new E.$f0b;let W=null;if(J.length>0&&P.CancellationToken.isCancellationToken(J[J.length-1])&&(W=J.pop()),W&&W.isCancellationRequested)return Promise.reject(F.$6());const U=I.serializeRequestArguments(J,this.h),C=++this.t,O=String(C),q=new E.$e0b,ne=new m.$Sc;W&&ne.add(W.onCancellationRequested(()=>{const ye=I.serializeCancel(C);this.f?.logOutgoing(ye.byteLength,C,0,"cancel"),this.c.send(I.serializeCancel(C))})),this.w[O]=new v(q,ne),this.F(C);const ce=I.serializeRequest(C,A,L,U,!!W);return this.f?.logOutgoing(ce.byteLength,C,0,`request: ${(0,N.$9v)(A)}.${L}(`,J),this.c.send(ce),q}}e.$i0b=o;class v{constructor(A,L){this.a=A,this.b=L}resolveOk(A){this.a.resolveOk(A),this.b.dispose()}resolveErr(A){this.a.resolveErr(A),this.b.dispose()}}class b{static alloc(A,L,J){const W=new b(M.$te.alloc(J+1+4),0);return W.writeUInt8(A),W.writeUInt32(L),W}static read(A,L){return new b(A,L)}get buffer(){return this.a}constructor(A,L){this.a=A,this.b=L}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(A){this.a.writeUInt8(A,this.b),this.b+=1}readUInt8(){const A=this.a.readUInt8(this.b);return this.b+=1,A}writeUInt32(A){this.a.writeUInt32BE(A,this.b),this.b+=4}readUInt32(){const A=this.a.readUInt32BE(this.b);return this.b+=4,A}static sizeShortString(A){return 1+A.byteLength}writeShortString(A){this.a.writeUInt8(A.byteLength,this.b),this.b+=1,this.a.set(A,this.b),this.b+=A.byteLength}readShortString(){const A=this.a.readUInt8(this.b);this.b+=1;const J=this.a.slice(this.b,this.b+A).toString();return this.b+=A,J}static sizeLongString(A){return 4+A.byteLength}writeLongString(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readLongString(){const A=this.a.readUInt32BE(this.b);this.b+=4;const J=this.a.slice(this.b,this.b+A).toString();return this.b+=A,J}writeBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}static sizeVSBuffer(A){return 4+A.byteLength}writeVSBuffer(A){this.a.writeUInt32BE(A.byteLength,this.b),this.b+=4,this.a.set(A,this.b),this.b+=A.byteLength}readVSBuffer(){const A=this.a.readUInt32BE(this.b);this.b+=4;const L=this.a.slice(this.b,this.b+A);return this.b+=A,L}static sizeMixedArray(A){let L=0;L+=1;for(let J=0,W=A.length;J<W;J++){const U=A[J];switch(L+=1,U.type){case 1:L+=this.sizeLongString(U.value);break;case 2:L+=this.sizeVSBuffer(U.value);break;case 3:L+=this.sizeUInt32,L+=this.sizeLongString(U.value);for(let C=0;C<U.buffers.length;++C)L+=this.sizeVSBuffer(U.buffers[C]);break;case 4:break}}return L}writeMixedArray(A){this.a.writeUInt8(A.length,this.b),this.b+=1;for(let L=0,J=A.length;L<J;L++){const W=A[L];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let U=0;U<W.buffers.length;++U)this.writeBuffer(W.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const A=this.a.readUInt8(this.b);this.b+=1;const L=new Array(A);for(let J=0;J<A;J++)switch(this.readUInt8()){case 1:L[J]=this.readLongString();break;case 2:L[J]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),C=this.readLongString(),O=[];for(let q=0;q<U;++q)O.push(this.readVSBuffer());L[J]=new N.$0v(r(C,O,null));break}case 4:L[J]=void 0;break}return L}}var $;(function(w){w[w.Simple=0]="Simple",w[w.Mixed=1]="Mixed"})($||($={}));class I{static a(A){for(let L=0,J=A.length;L<J;L++)if(A[L]instanceof M.$te||A[L]instanceof N.$0v||typeof A[L]>"u")return!0;return!1}static serializeRequestArguments(A,L){if(this.a(A)){const J=[];for(let W=0,U=A.length;W<U;W++){const C=A[W];if(C instanceof M.$te)J[W]={type:2,value:C};else if(typeof C>"u")J[W]={type:4};else if(C instanceof N.$0v){const{jsonString:O,referencedBuffers:q}=a(C.value,L);J[W]={type:3,value:M.$te.fromString(O),buffers:q}}else J[W]={type:1,value:M.$te.fromString(i(C,L))}}return{type:1,args:J}}return{type:0,args:i(A,L)}}static serializeRequest(A,L,J,W,U){switch(W.type){case 0:return this.b(A,L,J,W.args,U);case 1:return this.c(A,L,J,W.args,U)}}static b(A,L,J,W,U){const C=M.$te.fromString(J),O=M.$te.fromString(W);let q=0;q+=b.sizeUInt8(),q+=b.sizeShortString(C),q+=b.sizeLongString(O);const ne=b.alloc(U?2:1,A,q);return ne.writeUInt8(L),ne.writeShortString(C),ne.writeLongString(O),ne.buffer}static deserializeRequestJSONArgs(A){const L=A.readUInt8(),J=A.readShortString(),W=A.readLongString();return{rpcId:L,method:J,args:JSON.parse(W)}}static c(A,L,J,W,U){const C=M.$te.fromString(J);let O=0;O+=b.sizeUInt8(),O+=b.sizeShortString(C),O+=b.sizeMixedArray(W);const q=b.alloc(U?4:3,A,O);return q.writeUInt8(L),q.writeShortString(C),q.writeMixedArray(W),q.buffer}static deserializeRequestMixedArgs(A){const L=A.readUInt8(),J=A.readShortString(),W=A.readMixedArray(),U=new Array(W.length);for(let C=0,O=W.length;C<O;C++){const q=W[C];typeof q=="string"?U[C]=JSON.parse(q):U[C]=q}return{rpcId:L,method:J,args:U}}static serializeAcknowledged(A){return b.alloc(5,A,0).buffer}static serializeCancel(A){return b.alloc(6,A,0).buffer}static serializeReplyOK(A,L,J){if(typeof L>"u")return this.d(A);if(L instanceof M.$te)return this.e(A,L);if(L instanceof N.$0v){const{jsonString:W,referencedBuffers:U}=a(L.value,J,!0);return this.g(A,W,U)}else return this.f(A,l(L,J))}static d(A){return b.alloc(7,A,0).buffer}static e(A,L){let J=0;J+=b.sizeVSBuffer(L);const W=b.alloc(8,A,J);return W.writeVSBuffer(L),W.buffer}static deserializeReplyOKVSBuffer(A){return A.readVSBuffer()}static f(A,L){const J=M.$te.fromString(L);let W=0;W+=b.sizeLongString(J);const U=b.alloc(9,A,W);return U.writeLongString(J),U.buffer}static g(A,L,J){const W=M.$te.fromString(L);let U=0;U+=b.sizeUInt32,U+=b.sizeLongString(W);for(const O of J)U+=b.sizeVSBuffer(O);const C=b.alloc(10,A,U);C.writeUInt32(J.length),C.writeLongString(W);for(const O of J)C.writeBuffer(O);return C.buffer}static deserializeReplyOKJSON(A){const L=A.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(A,L){const J=A.readUInt32(),W=A.readLongString(),U=[];for(let C=0;C<J;++C)U.push(A.readVSBuffer());return new N.$0v(r(W,U,L))}static serializeReplyErr(A,L){const J=L?l(F.$3(L),null):void 0;if(typeof J!="string")return this.h(A);const W=M.$te.fromString(J);let U=0;U+=b.sizeLongString(W);const C=b.alloc(11,A,U);return C.writeLongString(W),C.buffer}static deserializeReplyErrError(A){const L=A.readLongString();return JSON.parse(L)}static h(A){return b.alloc(12,A,0).buffer}}var h;(function(w){w[w.RequestJSONArgs=1]="RequestJSONArgs",w[w.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",w[w.RequestMixedArgs=3]="RequestMixedArgs",w[w.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",w[w.Acknowledged=5]="Acknowledged",w[w.Cancel=6]="Cancel",w[w.ReplyOKEmpty=7]="ReplyOKEmpty",w[w.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",w[w.ReplyOKJSON=9]="ReplyOKJSON",w[w.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",w[w.ReplyErrError=11]="ReplyErrError",w[w.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var y;(function(w){w[w.String=1]="String",w[w.VSBuffer=2]="VSBuffer",w[w.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",w[w.Undefined=4]="Undefined"})(y||(y={}))}),define(Pe[240],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=void 0;const S=function(F){const R=m=>{globalThis.removeEventListener("message",R);const f=m.data;Object.defineProperties(globalThis,{postMessage:{value(E,N){f.postMessage(E,N)}},onmessage:{get(){return f.onmessage},set(E){f.onmessage=E}}}),f.addEventListener("message",E=>{globalThis.dispatchEvent(new MessageEvent("message",{data:E.data,ports:E.ports?[...E.ports]:void 0}))}),f.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(F)};globalThis.addEventListener("message",R)}.toString();class M extends EventTarget{constructor(F,R,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const f=`((${S})('${R}'))`,E=new Blob([f],{type:"application/javascript"}),N=URL.createObjectURL(E),D=new MessageChannel,l=N,k={type:"_newWorker",id:l,port:D.port2,url:N,options:m};F(k,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{F({type:"_terminateWorker",id:l}),URL.revokeObjectURL(N),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(g){D.port1.onmessage=g}},onmessageerror:{get(){return D.port1.onmessageerror},set(g){D.port1.onmessageerror=g}}}),D.port1.addEventListener("messageerror",g=>{const s=new MessageEvent("messageerror",{data:g.data});this.dispatchEvent(s)}),D.port1.addEventListener("message",g=>{const s=new MessageEvent("message",{data:g.data});this.dispatchEvent(s)}),D.port1.start()}}e.$vmc=M}),define(Pe[241],Re([1,0,23,28,12,54,3]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SJ=e.$RJ=e.$QJ=e.$PJ=void 0,e.$PJ=(0,R.$gi)("notebookDocumentService");const m=["W","X","Y","Z","a","b","c","d","e","f"],f=new RegExp(`^[${m.join("")}]+`),E=7;function N(k){if(k.scheme!==P.Schemas.vscodeNotebookCell)return;const g=k.fragment.indexOf("s");if(g<0)return;const s=parseInt(k.fragment.substring(0,g).replace(f,""),E),a=(0,S.$Me)(k.fragment.substring(g+1)).toString();if(!isNaN(s))return{handle:s,notebook:k.with({scheme:a,fragment:null})}}e.$QJ=N;function D(k,g){const s=g.toString(E),r=`${s.length<m.length?m[s.length-1]:"z"}${s}s${(0,S.$Ne)(S.$te.fromString(k.scheme),!0,!0)}`;return k.with({scheme:P.Schemas.vscodeNotebookCell,fragment:r})}e.$RJ=D;class l{constructor(){this.a=new M.$Ac}getNotebook(g){if(g.scheme===P.Schemas.vscodeNotebookCell){const s=N(g);if(s){const a=this.a.get(s.notebook);if(a)return a}}return this.a.get(g)}addNotebookDocument(g){this.a.set(g.uri,g)}removeNotebookDocument(g){this.a.delete(g.uri)}}e.$SJ=l,(0,F.$bs)(e.$PJ,l,1)}),define(Pe[83],Re([1,0,23,34,51,69,12,19,21,35,241]),function(me,e,S,M,P,F,R,m,f,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=e.$0J=e.$9J=e.$8J=e.CellStatusbarAlignment=e.$7J=e.$6J=e.$5J=e.NotebookEditorPriority=e.$4J=e.$3J=e.$2J=e.$1J=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.CellKind=e.$VJ=e.$UJ=e.$TJ=void 0,e.$TJ="workbench.editor.notebook",e.$UJ="workbench.editor.notebookTextDiffEditor",e.$VJ="workbench.editor.interactive";var D;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(D||(e.CellKind=D={})),e.$WJ=["application/json","application/javascript","text/html","image/svg+xml",F.$us.latex,F.$us.markdown,"image/png","image/jpeg",F.$us.text],e.$XJ=[F.$us.latex,F.$us.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",F.$us.text],e.$YJ=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$ZJ="_notAvailable";var l;(function(q){q[q.Running=1]="Running",q[q.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var k;(function(q){q[q.Unconfirmed=1]="Unconfirmed",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(k||(e.NotebookCellExecutionState=k={}));var g;(function(q){q[q.Unconfirmed=1]="Unconfirmed",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(g||(e.NotebookExecutionState=g={}));var s;(function(q){q[q.WithHardKernelDependency=0]="WithHardKernelDependency",q[q.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",q[q.Pure=2]="Pure",q[q.Never=3]="Never"})(s||(e.NotebookRendererMatch=s={}));var a;(function(q){q.Always="always",q.Never="never",q.Optional="optional"})(a||(e.RendererMessagingSpec=a={}));var r;(function(q){q[q.ModelChange=1]="ModelChange",q[q.Move=2]="Move",q[q.ChangeCellLanguage=5]="ChangeCellLanguage",q[q.Initialize=6]="Initialize",q[q.ChangeCellMetadata=7]="ChangeCellMetadata",q[q.Output=8]="Output",q[q.OutputItem=9]="OutputItem",q[q.ChangeCellContent=10]="ChangeCellContent",q[q.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",q[q.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",q[q.ChangeCellMime=13]="ChangeCellMime",q[q.Unknown=100]="Unknown"})(r||(e.NotebookCellsChangeType=r={}));var i;(function(q){q[q.Handle=0]="Handle",q[q.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(q){q[q.Replace=1]="Replace",q[q.Output=2]="Output",q[q.Metadata=3]="Metadata",q[q.CellLanguage=4]="CellLanguage",q[q.DocumentMetadata=5]="DocumentMetadata",q[q.Move=6]="Move",q[q.OutputItems=7]="OutputItems",q[q.PartialMetadata=8]="PartialMetadata",q[q.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var c;(function(q){q.scheme=R.Schemas.vscodeNotebookCell;function ne(re,$e){return(0,N.$RJ)(re,$e)}q.generate=ne;function ce(re){return(0,N.$QJ)(re)}q.parse=ce;function ye(re,$e){return re.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${$e??""},${re.scheme!==R.Schemas.file?re.scheme:""}`})}q.generateCellOutputUri=ye;function Ie(re){if(re.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const $e=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(re.fragment);if(!$e)return;const ie=$e[1]&&$e[1]!==""?$e[1]:void 0,le=$e[2];return{outputId:ie,notebook:re.with({scheme:le||R.Schemas.file,fragment:null})}}q.parseCellOutputUri=Ie;function ue(re,$e,ie){return q.generate(re,$e).with({scheme:ie})}q.generateCellPropertyUri=ue;function ve(re,$e){if(re.scheme===$e)return q.parse(re.with({scheme:q.scheme}))}q.parseCellPropertyUri=ve})(c||(e.CellUri=c={}));const d=q=>f.$i?q.replace(/\//g,"\\"):q;class t{constructor(ne=[],ce=e.$WJ){this.e=ce,this.d=[...new Set(ne)].map(ye=>({pattern:ye,matches:M.$Zj(d(ye))}))}sort(ne){const ce=new Map(P.Iterable.map(ne,Ie=>[Ie,d(Ie)]));let ye=[];for(const{matches:Ie}of this.d)for(const[ue,ve]of ce)if(Ie(ve)){ye.push(ue),ce.delete(ue);break}return ce.size&&(ye=ye.concat([...ce.keys()].sort((Ie,ue)=>this.e.indexOf(Ie)-this.e.indexOf(ue)))),ye}prioritize(ne,ce){const ye=this.f(ne);if(ye===-1){this.d.unshift({pattern:ne,matches:M.$Zj(d(ne))});return}const Ie=new Set(ce.map(ve=>this.f(ve,ye)));Ie.delete(-1);const ue=Array.from(Ie).sort();this.d.splice(ye+1,0,...ue.map(ve=>this.d[ve]));for(let ve=ue.length-1;ve>=0;ve--)this.d.splice(ue[ve],1)}toArray(){return this.d.map(ne=>ne.pattern)}f(ne,ce=this.d.length){const ye=d(ne);for(let Ie=0;Ie<ce;Ie++)if(this.d[Ie].matches(ye))return Ie;return-1}}e.$1J=t;function p(q,ne,ce,ye=(Ie,ue)=>Ie===ue){const Ie=[];function ue($e,ie,le){if(ie===0&&le.length===0)return;const V=Ie[Ie.length-1];V&&V.start+V.deleteCount===$e?(V.deleteCount+=ie,V.toInsert.push(...le)):Ie.push({start:$e,deleteCount:ie,toInsert:le})}let ve=0,re=0;for(;;){if(ve===q.length){ue(ve,0,ne.slice(re));break}if(re===ne.length){ue(ve,q.length-ve,[]);break}const $e=q[ve],ie=ne[re];if(ye($e,ie)){ve+=1,re+=1;continue}ce(ie)?(ue(ve,1,[]),ve+=1):(ue(ve,0,[ie]),re+=1)}return Ie}e.$2J=p,e.$3J=new E.$xj("notebookEditorCursorAtBoundary","none"),e.$4J=new E.$xj("notebookEditorCursorAtLineBoundary","none");var u;(function(q){q.default="default",q.option="option"})(u||(e.NotebookEditorPriority=u={}));function o(q){const ne=q;return!!((typeof ne.include=="string"||M.$1j(ne.include))&&(typeof ne.exclude=="string"||M.$1j(ne.exclude)))}e.$5J=o;function v(q,ne,ce){if(Array.isArray(q.viewType)&&q.viewType.indexOf(ne)>=0||q.viewType===ne)return!0;if(q.filenamePattern){const ye=o(q.filenamePattern)?q.filenamePattern.include:q.filenamePattern,Ie=o(q.filenamePattern)?q.filenamePattern.exclude:void 0;if(M.$Yj(ye,(0,m.$nc)(ce.fsPath).toLowerCase()))return!(Ie&&M.$Yj(Ie,(0,m.$nc)(ce.fsPath).toLowerCase()))}return!1}e.$6J=v,e.$7J={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var b;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(b||(e.CellStatusbarAlignment=b={}));class ${static{this.d="notebook/"}static create(ne){return`${$.d}${ne}`}static parse(ne){if(ne.startsWith($.d))return ne.substring($.d.length)}}e.$8J=$;function I(q){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(q)}e.$9J=I;const h=new TextDecoder;function y(q){const ne=[];let ce=!1;for(const ve of q)(ne.length===0||ce)&&(ne.push(ve),ce=!0);let ye=L(ne);const Ie=S.$te.concat(ne.map(ve=>S.$te.wrap(ve))),ue=O(Ie);return ye=ye||ue.byteLength!==Ie.byteLength,{data:ue,didCompression:ye}}e.$0J=y,e.$$J="\x1B[A";const w=e.$$J.split("").map(q=>q.charCodeAt(0)),A=10;function L(q){let ne=!1;return q.forEach((ce,ye)=>{if(ye===0||ce.length<e.$$J.length)return;const Ie=q[ye-1],ue=ce.subarray(0,e.$$J.length);if(ue[0]===w[0]&&ue[1]===w[1]&&ue[2]===w[2]){const ve=Ie.lastIndexOf(A);if(ve===-1)return;ne=!0,q[ye-1]=Ie.subarray(0,ve),q[ye]=ce.subarray(e.$$J.length)}}),ne}function J(q){let ne=q;do q=ne,ne=q.replace(/[^\n]\x08/gm,"");while(ne.length<q.length);return q}function W(q){for(q=q.replace(/\r+\n/gm,`
`);q.search(/\r[^$]/g)>-1;){const ne=q.match(/^(.*)\r+/m)[1];let ce=q.match(/\r+(.*)$/m)[1];ce=ce+ne.slice(ce.length,ne.length),q=q.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ce)}return q}const U=8,C=13;function O(q){return!q.buffer.includes(U)&&!q.buffer.includes(C)?q:S.$te.fromString(W(J(h.decode(q.buffer))))}}),define(Pe[7],Re([1,0,18,14,53,28,69,15,16,2,33,20,42,102,83]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g){"use strict";var s,a,r,i,n,c,d,t,p,u,o,v,b,$,I,h,y;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$eO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$dO=e.$cO=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$4N=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$3N=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$RN=e.$QN=e.$PN=e.$ON=e.$NN=e.$MN=e.$LN=e.$KN=e.TestRunProfileKind=e.TestResultState=e.$JN=e.$IN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$HN=e.NotebookVariablesRequestKind=e.$GN=e.$FN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$EN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.ColorThemeKind=e.$yN=e.$xN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$wN=e.$vN=e.DebugConsoleMode=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$pN=e.$oN=e.FileChangeType=e.$nN=e.NewSymbolNameTag=e.$mN=e.$lN=e.$kN=e.$jN=e.InlineCompletionTriggerKind=e.$iN=e.$hN=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.$$M=e.$0M=e.$9M=e.ConfigurationTarget=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$YM=e.ViewBadge=e.ProgressLocation=e.$XM=e.$WM=e.TaskScope=e.ShellQuoting=e.$VM=e.$UM=e.$TM=e.TaskPanelKind=e.TaskRevealKind=e.$SM=e.TerminalLocation=e.$RM=e.$QM=e.$PM=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$OM=e.$NM=e.$MM=e.$LM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$KM=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$JM=e.$IM=e.$HM=e.$GM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$FM=e.$EM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.LanguageStatusSeverity=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.CodeActionTriggerKind=e.$sM=e.$rM=e.SymbolTag=e.SymbolKind=e.$qM=e.$pM=e.DocumentHighlightKind=e.$oM=e.$nM=e.$mM=e.$lM=e.DiagnosticSeverity=e.DiagnosticTag=e.$kM=e.$jM=e.FileEditType=e.$iM=e.$hM=e.$gM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function w(B){return Object.assign(B,{apply:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const Se=te.length===1?[]:te[1];return Reflect.construct(B,Se,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const[Se,...Je]=te;return Reflect.construct(B,Je,Se.constructor)}}})}var A;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(A||(e.TerminalOutputAnchor=A={}));var L;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(L||(e.TerminalQuickFixType=L={}));let J=s=class{static from(...T){let te=T;return new s(function(){if(te){for(const Se of te)Se&&typeof Se.dispose=="function"&&Se.dispose();te=void 0}})}#e;constructor(T){this.#e=T}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$_L=J,e.$_L=J=s=Qe([w],J);let W=a=class{static Min(...T){if(T.length===0)throw new TypeError;let te=T[0];for(let Se=1;Se<T.length;Se++){const Je=T[Se];Je.isBefore(te)&&(te=Je)}return te}static Max(...T){if(T.length===0)throw new TypeError;let te=T[0];for(let Se=1;Se<T.length;Se++){const Je=T[Se];Je.isAfter(te)&&(te=Je)}return te}static isPosition(T){if(!T)return!1;if(T instanceof a)return!0;const{line:te,character:Se}=T;return typeof te=="number"&&typeof Se=="number"}static of(T){if(T instanceof a)return T;if(this.isPosition(T))return new a(T.line,T.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(T,te){if(T<0)throw(0,M.$7)("line must be non-negative");if(te<0)throw(0,M.$7)("character must be non-negative");this.c=T,this.e=te}isBefore(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<T.e}isBeforeOrEqual(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<=T.e}isAfter(T){return!this.isBeforeOrEqual(T)}isAfterOrEqual(T){return!this.isBefore(T)}isEqual(T){return this.c===T.c&&this.e===T.e}compareTo(T){return this.c<T.c?-1:this.c>T.line?1:this.e<T.e?-1:this.e>T.e?1:0}translate(T,te=0){if(T===null||te===null)throw(0,M.$7)();let Se;return typeof T>"u"?Se=0:typeof T=="number"?Se=T:(Se=typeof T.lineDelta=="number"?T.lineDelta:0,te=typeof T.characterDelta=="number"?T.characterDelta:0),Se===0&&te===0?this:new a(this.line+Se,this.character+te)}with(T,te=this.character){if(T===null||te===null)throw(0,M.$7)();let Se;return typeof T>"u"?Se=this.line:typeof T=="number"?Se=T:(Se=typeof T.line=="number"?T.line:this.line,te=typeof T.character=="number"?T.character:this.character),Se===this.line&&te===this.character?this:new a(Se,te)}toJSON(){return{line:this.line,character:this.character}}};e.$aM=W,e.$aM=W=a=Qe([w],W);let U=r=class{static isRange(T){return T instanceof r?!0:T?W.isPosition(T.start)&&W.isPosition(T.end):!1}static of(T){if(T instanceof r)return T;if(this.isRange(T))return new r(T.start,T.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(T,te,Se,Je){let _e,ut;if(typeof T=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof Je=="number"?(_e=new W(T,te),ut=new W(Se,Je)):W.isPosition(T)&&W.isPosition(te)&&(_e=W.of(T),ut=W.of(te)),!_e||!ut)throw new Error("Invalid arguments");_e.isBefore(ut)?(this.c=_e,this.e=ut):(this.c=ut,this.e=_e)}contains(T){return r.isRange(T)?this.contains(T.start)&&this.contains(T.end):W.isPosition(T)?!(W.of(T).isBefore(this.c)||this.e.isBefore(T)):!1}isEqual(T){return this.c.isEqual(T.c)&&this.e.isEqual(T.e)}intersection(T){const te=W.Max(T.start,this.c),Se=W.Min(T.end,this.e);if(!te.isAfter(Se))return new r(te,Se)}union(T){if(this.contains(T))return this;if(T.contains(this))return T;const te=W.Min(T.start,this.c),Se=W.Max(T.end,this.end);return new r(te,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(T,te=this.end){if(T===null||te===null)throw(0,M.$7)();let Se;return T?W.isPosition(T)?Se=T:(Se=T.start||this.start,te=T.end||this.end):Se=this.start,Se.isEqual(this.c)&&te.isEqual(this.end)?this:new r(Se,te)}toJSON(){return[this.start,this.end]}};e.$bM=U,e.$bM=U=r=Qe([w],U);let C=i=class extends U{static isSelection(T){return T instanceof i?!0:T?U.isRange(T)&&W.isPosition(T.anchor)&&W.isPosition(T.active)&&typeof T.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(T,te,Se,Je){let _e,ut;if(typeof T=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof Je=="number"?(_e=new W(T,te),ut=new W(Se,Je)):W.isPosition(T)&&W.isPosition(te)&&(_e=W.of(T),ut=W.of(te)),!_e||!ut)throw new Error("Invalid arguments");super(_e,ut),this.f=_e,this.g=ut}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$cM=C,e.$cM=C=i=Qe([w],C);const O=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,M.$7)("connectionToken")};class q{static isResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.host=="string"&&typeof T.port=="number"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,te,Se){if(typeof T!="string"||T.length===0)throw(0,M.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,M.$7)("port");typeof Se<"u"&&O(Se),this.host=T,this.port=Math.round(te),this.connectionToken=Se}}e.$dM=q;class ne{static isManagedResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.makeConnection=="function"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,te){this.makeConnection=T,this.connectionToken=te,typeof te<"u"&&O(te)}}e.$eM=ne;class ce extends Error{static NotAvailable(T,te){return new ce(T,k.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(T){return new ce(T,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(T,te=k.RemoteAuthorityResolverErrorCode.Unknown,Se){super(T),this._message=T,this._code=te,this._detail=Se,Object.setPrototypeOf(this,ce.prototype)}}e.$fM=ce;var ye;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(ye||(e.EndOfLine=ye={}));var Ie;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(Ie||(e.EnvironmentVariableMutatorType=Ie={}));let ue=n=class{static isTextEdit(T){return T instanceof n?!0:T?U.isRange(T)&&typeof T.newText=="string":!1}static replace(T,te){return new n(T,te)}static insert(T,te){return n.replace(new U(T,T),te)}static delete(T){return n.replace(T,"")}static setEndOfLine(T){const te=new n(new U(new W(0,0),new W(0,0)),"");return te.newEol=T,te}get range(){return this.c}set range(T){if(T&&!U.isRange(T))throw(0,M.$7)("range");this.c=T}get newText(){return this.e||""}set newText(T){if(T&&typeof T!="string")throw(0,M.$7)("newText");this.e=T}get newEol(){return this.f}set newEol(T){if(T&&typeof T!="number")throw(0,M.$7)("newEol");this.f=T}constructor(T,te){this.c=T,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$gM=ue,e.$gM=ue=n=Qe([w],ue);let ve=c=class{static isNotebookCellEdit(T){return T instanceof c?!0:T?fi.isNotebookRange(T)&&Array.isArray(T.newCells):!1}static replaceCells(T,te){return new c(T,te)}static insertCells(T,te){return new c(new fi(T,T),te)}static deleteCells(T){return new c(T,[])}static updateCellMetadata(T,te){const Se=new c(new fi(T,T),[]);return Se.newCellMetadata=te,Se}static updateNotebookMetadata(T){const te=new c(new fi(0,0),[]);return te.newNotebookMetadata=T,te}constructor(T,te){this.range=T,this.newCells=te}};e.$hM=ve,e.$hM=ve=c=Qe([w],ve);class re{static isSnippetTextEdit(T){return T instanceof re?!0:T?U.isRange(T.range)&&le.isSnippetString(T.snippet):!1}static replace(T,te){return new re(T,te)}static insert(T,te){return re.replace(new U(T,T),te)}constructor(T,te){this.range=T,this.snippet=te}}e.$iM=re;var $e;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let ie=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(T,te,Se,Je){this.c.push({_type:1,from:T,to:te,options:Se,metadata:Je})}createFile(T,te,Se){this.c.push({_type:1,from:void 0,to:T,options:te,metadata:Se})}deleteFile(T,te,Se){this.c.push({_type:1,from:T,to:void 0,options:te,metadata:Se})}e(T,te,Se){this.c.push({_type:3,metadata:Se,uri:T,edit:{editType:5,metadata:te},notebookMetadata:te})}f(T,te,Se,Je){const _e=te.start,ut=te.end;(_e!==ut||Se.length>0)&&this.c.push({_type:5,uri:T,index:_e,count:ut-_e,cells:Se,metadata:Je})}g(T,te,Se,Je){this.c.push({_type:3,metadata:Je,uri:T,edit:{editType:3,index:te,metadata:Se}})}replace(T,te,Se,Je){this.c.push({_type:2,uri:T,edit:new ue(te,Se),metadata:Je})}insert(T,te,Se,Je){this.replace(T,new U(te,te),Se,Je)}delete(T,te,Se){this.replace(T,te,"",Se)}has(T){return this.c.some(te=>te._type===2&&te.uri.toString()===T.toString())}set(T,te){if(te)for(const Se of te){if(!Se)continue;let Je,_e;Array.isArray(Se)?(Je=Se[0],_e=Se[1]):Je=Se,ve.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(T,Je.range.start,Je.newCellMetadata,_e):Je.newNotebookMetadata?this.e(T,Je.newNotebookMetadata,_e):this.f(T,Je.range,Je.newCells,_e):re.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:T,range:Je.range,edit:Je.snippet,metadata:_e}):this.c.push({_type:2,uri:T,edit:Je,metadata:_e})}else{for(let Se=0;Se<this.c.length;Se++){const Je=this.c[Se];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===T.toString()&&(this.c[Se]=void 0);break}}(0,S.$Ib)(this.c)}}get(T){const te=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===T.toString()&&te.push(Se.edit);return te}entries(){const T=new F.$Ac;for(const te of this.c)if(te._type===2){let Se=T.get(te.uri);Se||(Se=[te.uri,[]],T.set(te.uri,Se)),Se[1].push(te.edit)}return[...T.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$jM=ie,e.$jM=ie=Qe([w],ie);let le=d=class{static isSnippetString(T){return T instanceof d?!0:T?typeof T.value=="string":!1}static c(T){return T.replace(/\$|}|\\/g,"\\$&")}constructor(T){this.e=1,this.value=T||""}appendText(T){return this.value+=d.c(T),this}appendTabstop(T=this.e++){return this.value+="$",this.value+=T,this}appendPlaceholder(T,te=this.e++){if(typeof T=="function"){const Se=new d;Se.e=this.e,T(Se),this.e=Se.e,T=Se.value}else T=d.c(T);return this.value+="${",this.value+=te,this.value+=":",this.value+=T,this.value+="}",this}appendChoice(T,te=this.e++){const Se=T.map(Je=>Je.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(T,te){if(typeof te=="function"){const Se=new d;Se.e=this.e,te(Se),this.e=Se.e,te=Se.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=T,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$kM=le,e.$kM=le=d=Qe([w],le);var V;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var _;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(_||(e.DiagnosticSeverity=_={}));let ke=t=class{static isLocation(T){return T instanceof t?!0:T?U.isRange(T.range)&&E.URI.isUri(T.uri):!1}constructor(T,te){if(this.uri=T,te)if(U.isRange(te))this.range=U.of(te);else if(W.isPosition(te))this.range=new U(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$lM=ke,e.$lM=ke=t=Qe([w],ke);let Le=class{static is(T){return T?typeof T.message=="string"&&T.location&&U.isRange(T.location.range)&&E.URI.isUri(T.location.uri):!1}constructor(T,te){this.location=T,this.message=te}static isEqual(T,te){return T===te?!0:!T||!te?!1:T.message===te.message&&T.location.range.isEqual(te.location.range)&&T.location.uri.toString()===te.location.uri.toString()}};e.$mM=Le,e.$mM=Le=Qe([w],Le);let Ee=class{constructor(T,te,Se=_.Error){if(!U.isRange(T))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=T,this.message=te,this.severity=Se}toJSON(){return{severity:_[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(T,te){return T===te?!0:!T||!te?!1:T.message===te.message&&T.severity===te.severity&&T.code===te.code&&T.severity===te.severity&&T.source===te.source&&T.range.isEqual(te.range)&&(0,S.$ub)(T.tags,te.tags)&&(0,S.$ub)(T.relatedInformation,te.relatedInformation,Le.isEqual)}};e.$nM=Ee,e.$nM=Ee=Qe([w],Ee);let be=class{constructor(T,te){if(!T)throw new Error("Illegal argument, contents must be defined");Array.isArray(T)?this.contents=T:this.contents=[T],this.range=te}};e.$oM=be,e.$oM=be=Qe([w],be);var ge;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(ge||(e.DocumentHighlightKind=ge={}));let G=class{constructor(T,te=ge.Text){this.range=T,this.kind=te}toJSON(){return{range:this.range,kind:ge[this.kind]}}};e.$pM=G,e.$pM=G=Qe([w],G);let Y=class{constructor(T,te){this.uri=T,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(T=>T.toJSON())}}};e.$qM=Y,e.$qM=Y=Qe([w],Y);var he;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(he||(e.SymbolKind=he={}));var fe;(function(B){B[B.Deprecated=1]="Deprecated"})(fe||(e.SymbolTag=fe={}));let Oe=p=class{static validate(T){if(!T.name)throw new Error("name must not be falsy")}constructor(T,te,Se,Je,_e){this.name=T,this.kind=te,this.containerName=_e,typeof Se=="string"&&(this.containerName=Se),Je instanceof ke?this.location=Je:Se instanceof U&&(this.location=new ke(Je,Se)),p.validate(this)}toJSON(){return{name:this.name,kind:he[this.kind],location:this.location,containerName:this.containerName}}};e.$rM=Oe,e.$rM=Oe=p=Qe([w],Oe);let de=u=class{static validate(T){if(!T.name)throw new Error("name must not be falsy");if(!T.range.contains(T.selectionRange))throw new Error("selectionRange must be contained in fullRange");T.children?.forEach(u.validate)}constructor(T,te,Se,Je,_e){this.name=T,this.detail=te,this.kind=Se,this.range=Je,this.selectionRange=_e,this.children=[],u.validate(this)}};e.$sM=de,e.$sM=de=u=Qe([w],de);var Ce;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Ce||(e.CodeActionTriggerKind=Ce={}));let Ae=class{constructor(T,te){this.title=T,this.kind=te}};e.$tM=Ae,e.$tM=Ae=Qe([w],Ae);let ze=class{static{o=this}static{this.c="."}constructor(T){this.value=T}append(T){return new o(this.value?this.value+o.c+T:T)}intersects(T){return this.contains(T)||T.contains(this)}contains(T){return this.value===T.value||T.value.startsWith(this.value+o.c)}};e.$uM=ze,e.$uM=ze=o=Qe([w],ze),ze.Empty=new ze(""),ze.QuickFix=ze.Empty.append("quickfix"),ze.Refactor=ze.Empty.append("refactor"),ze.RefactorExtract=ze.Refactor.append("extract"),ze.RefactorInline=ze.Refactor.append("inline"),ze.RefactorMove=ze.Refactor.append("move"),ze.RefactorRewrite=ze.Refactor.append("rewrite"),ze.Source=ze.Empty.append("source"),ze.SourceOrganizeImports=ze.Source.append("organizeImports"),ze.SourceFixAll=ze.Source.append("fixAll"),ze.Notebook=ze.Empty.append("notebook");let z=class{constructor(T,te){if(this.range=T,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$vM=z,e.$vM=z=Qe([w],z);class j{constructor(T,te,Se,Je,_e,ut){this.kind=T,this.name=te,this.detail=Se,this.uri=Je,this.range=_e,this.selectionRange=ut}}e.$wM=j;class K{constructor(T,te){this.fromRanges=te,this.from=T}}e.$xM=K;class H{constructor(T,te){this.fromRanges=te,this.to=T}}e.$yM=H;var ee;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(ee||(e.LanguageStatusSeverity=ee={}));let se=class{constructor(T,te){this.range=T,this.command=te}get isResolved(){return!!this.command}};e.$zM=se,e.$zM=se=Qe([w],se);let Ne=v=class{#e;static isMarkdownString(T){return T instanceof v?!0:T&&T.appendCodeblock&&T.appendMarkdown&&T.appendText&&T.value!==void 0}constructor(T,te=!1){this.#e=new P.$xk(T,{supportThemeIcons:te})}get value(){return this.#e.value}set value(T){this.#e.value=T}get isTrusted(){return this.#e.isTrusted}set isTrusted(T){this.#e.isTrusted=T}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(T){this.#e.supportThemeIcons=T}get supportHtml(){return this.#e.supportHtml}set supportHtml(T){this.#e.supportHtml=T}get baseUri(){return this.#e.baseUri}set baseUri(T){this.#e.baseUri=T}appendText(T){return this.#e.appendText(T),this}appendMarkdown(T){return this.#e.appendMarkdown(T),this}appendCodeblock(T,te){return this.#e.appendCodeblock(te??"",T),this}};e.$AM=Ne,e.$AM=Ne=v=Qe([w],Ne);let Ve=class{constructor(T,te){this.label=T,this.documentation=te}};e.$BM=Ve,e.$BM=Ve=Qe([w],Ve);let He=class{constructor(T,te){this.label=T,this.documentation=te,this.parameters=[]}};e.$CM=He,e.$CM=He=Qe([w],He);let xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$DM=xe,e.$DM=xe=Qe([w],xe);var tt;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var lt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(lt||(e.InlayHintKind=lt={}));let rt=class{constructor(T){this.value=T}};e.$EM=rt,e.$EM=rt=Qe([w],rt);let it=class{constructor(T,te,Se){this.position=T,this.label=te,this.kind=Se}};e.$FM=it,e.$FM=it=Qe([w],it);var ot;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ot||(e.CompletionTriggerKind=ot={}));var Be;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(Be||(e.CompletionItemKind=Be={}));var et;(function(B){B[B.Deprecated=1]="Deprecated"})(et||(e.CompletionItemTag=et={}));let X=class{constructor(T,te){this.label=T,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&Be[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$GM=X,e.$GM=X=Qe([w],X);let Z=class{constructor(T=[],te=!1){this.items=T,this.isIncomplete=te}};e.$HM=Z,e.$HM=Z=Qe([w],Z);let pe=class{constructor(T,te,Se){this.insertText=T,this.range=te,this.command=Se}};e.$IM=pe,e.$IM=pe=Qe([w],pe);let We=class{constructor(T){this.commands=void 0,this.suppressSuggestions=void 0,this.items=T}};e.$JM=We,e.$JM=We=Qe([w],We);var Ze;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(Ze||(e.PartialAcceptTriggerKind=Ze={}));var st;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(st||(e.ViewColumn=st={}));var Me;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Me||(e.StatusBarAlignment=Me={}));function Dt(B,T){return`${D.$Am.toKey(B)}.${T}`}e.$KM=Dt;var Qt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(Qt||(e.TextEditorLineNumbersStyle=Qt={}));var jt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(jt||(e.TextDocumentSaveReason=jt={}));var si;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(si||(e.TextEditorRevealType=si={}));var Vt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Vt||(e.TextEditorSelectionChangeKind=Vt={}));var St;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(St||(e.TextDocumentChangeReason=St={}));var Yt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Yt||(e.DecorationRangeBehavior=Yt={})),function(B){function T(te){switch(te){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=T}(Vt||(e.TextEditorSelectionChangeKind=Vt={}));var Wt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Wt||(e.SyntaxTokenType=Wt={})),function(B){function T(te){switch(te){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=T}(Wt||(e.SyntaxTokenType=Wt={}));let oi=class{constructor(T,te){if(te&&!E.URI.isUri(te))throw(0,M.$7)("target");if(!U.isRange(T)||T.isEmpty)throw(0,M.$7)("range");this.range=T,this.target=te}};e.$LM=oi,e.$LM=oi=Qe([w],oi);let xt=class{constructor(T,te,Se,Je){this.red=T,this.green=te,this.blue=Se,this.alpha=Je}};e.$MM=xt,e.$MM=xt=Qe([w],xt);let Ye=class{constructor(T,te){if(te&&!(te instanceof xt))throw(0,M.$7)("color");if(!U.isRange(T)||T.isEmpty)throw(0,M.$7)("range");this.range=T,this.color=te}};e.$NM=Ye,e.$NM=Ye=Qe([w],Ye);let Ot=class{constructor(T){if(!T||typeof T!="string")throw(0,M.$7)("label");this.label=T}};e.$OM=Ot,e.$OM=Ot=Qe([w],Ot);var _t;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(_t||(e.ColorFormat=_t={}));var dt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(dt||(e.SourceControlInputBoxValidationType=dt={}));var $t;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})($t||(e.TerminalExitReason=$t={}));class ei{constructor(T,te,Se){if(this.startIndex=T,this.length=te,this.tooltip=Se,typeof T!="number"||T<0)throw(0,M.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,M.$7)("length");if(Se!==void 0&&typeof Se!="string")throw(0,M.$7)("tooltip")}}e.$PM=ei;class qt{constructor(T){this.uri=T}}e.$QM=qt;class Ht{constructor(T){this.terminalCommand=T}}e.$RM=Ht;var ht;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(ht||(e.TerminalLocation=ht={}));class Mt{constructor(T){if(this.options=T,typeof T!="object")throw(0,M.$7)("options")}}e.$SM=Mt;var ti;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(ti||(e.TaskRevealKind=ti={}));var ii;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ii||(e.TaskPanelKind=ii={}));let Ke=class{static{b=this}static{this.Clean=new b("clean","Clean")}static{this.Build=new b("build","Build")}static{this.Rebuild=new b("rebuild","Rebuild")}static{this.Test=new b("test","Test")}static from(T){switch(T){case"clean":return b.Clean;case"build":return b.Build;case"rebuild":return b.Rebuild;case"test":return b.Test;default:return}}constructor(T,te){if(this.label=te,typeof T!="string"||typeof te!="string")throw(0,M.$7)("name");this.c=T}get id(){return this.c}};e.$TM=Ke,e.$TM=Ke=b=Qe([w],Ke);function Nt(B){let T="";for(let te=0;te<B.length;te++)T+=B[te].replace(/,/g,",,")+",";return T}let zt=class{constructor(T,te,Se){if(typeof T!="string")throw(0,M.$7)("process");this.e=[],this.c=T,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=Se):this.f=te)}get process(){return this.c}set process(T){if(typeof T!="string")throw(0,M.$7)("process");this.c=T}get args(){return this.e}set args(T){Array.isArray(T)||(T=[]),this.e=T}get options(){return this.f}set options(T){this.f=T}computeId(){const T=[];if(T.push("process"),this.c!==void 0&&T.push(this.c),this.e&&this.e.length>0)for(const te of this.e)T.push(te);return Nt(T)}};e.$UM=zt,e.$UM=zt=Qe([w],zt);let Zt=class{constructor(T,te,Se){if(this.f=[],Array.isArray(te)){if(!T)throw(0,M.$7)("command can't be undefined or null");if(typeof T!="string"&&typeof T.value!="string")throw(0,M.$7)("command");this.e=T,this.f=te,this.g=Se}else{if(typeof T!="string")throw(0,M.$7)("commandLine");this.c=T,this.g=te}}get commandLine(){return this.c}set commandLine(T){if(typeof T!="string")throw(0,M.$7)("commandLine");this.c=T}get command(){return this.e?this.e:""}set command(T){if(typeof T!="string"&&typeof T.value!="string")throw(0,M.$7)("command");this.e=T}get args(){return this.f}set args(T){this.f=T||[]}get options(){return this.g}set options(T){this.g=T}computeId(){const T=[];if(T.push("shell"),this.c!==void 0&&T.push(this.c),this.e!==void 0&&T.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)T.push(typeof te=="string"?te:te.value);return Nt(T)}};e.$VM=Zt,e.$VM=Zt=Qe([w],Zt);var mt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(mt||(e.ShellQuoting=mt={}));var It;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(It||(e.TaskScope=It={}));class Ct{constructor(T){this.c=T}computeId(){return"customExecution"+(0,N.$Cg)()}set callback(T){this.c=T}get callback(){return this.c}}e.$WM=Ct;let Lt=class{static{$=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(T,te,Se,Je,_e,ut){this.k=!1,this.l=this.definition=T;let gt;typeof te=="string"?(this.o=this.name=te,this.w=this.source=Se,this.execution=Je,gt=_e,this.k=!0):te===It.Global||te===It.Workspace?(this.target=te,this.o=this.name=Se,this.w=this.source=Je,this.execution=_e,gt=ut):(this.target=te,this.o=this.name=Se,this.w=this.source=Je,this.execution=_e,gt=ut),typeof gt=="string"?(this.r=[gt],this.t=!0):Array.isArray(gt)?(this.r=gt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(T){this.j=T}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof zt?this.l={type:$.e,id:this.q.computeId()}:this.q instanceof Zt?this.l={type:$.f,id:this.q.computeId()}:this.q instanceof Ct?this.l={type:$.c,id:this.q.computeId()}:this.l={type:$.g,id:(0,N.$Cg)()}}get definition(){return this.l}set definition(T){if(T==null)throw(0,M.$7)("Kind can't be undefined or null");this.B(),this.l=T}get scope(){return this.m}set target(T){this.B(),this.m=T}get name(){return this.o}set name(T){if(typeof T!="string")throw(0,M.$7)("name");this.B(),this.o=T}get execution(){return this.q}set execution(T){T===null&&(T=void 0),this.B(),this.q=T;const te=this.l.type;($.g===te||$.e===te||$.f===te||$.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(T){if(Array.isArray(T))this.B(),this.r=T,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(T){T!==!0&&T!==!1&&(T=!1),this.B(),this.u=T}get source(){return this.w}set source(T){if(typeof T!="string"||T.length===0)throw(0,M.$7)("source must be a string of length > 0");this.B(),this.w=T}get group(){return this.x}set group(T){T===null&&(T=void 0),this.B(),this.x=T}get detail(){return this.A}set detail(T){T===null&&(T=void 0),this.A=T}get presentationOptions(){return this.y}set presentationOptions(T){T==null&&(T=Object.create(null)),this.B(),this.y=T}get runOptions(){return this.z}set runOptions(T){T==null&&(T=Object.create(null)),this.B(),this.z=T}};e.$XM=Lt,e.$XM=Lt=$=Qe([w],Lt);var ai;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(ai||(e.ProgressLocation=ai={}));var Ut;(function(B){function T(te){const Se=te;return(0,f.$Xf)(Se.value)?Se.tooltip&&!(0,f.$Tf)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}B.isViewBadge=T})(Ut||(e.ViewBadge=Ut={}));let Xt=I=class{static isTreeItem(T,te){const Se=T;if(Se.checkboxState!==void 0){const Je=(0,f.$Xf)(Se.checkboxState)?Se.checkboxState:(0,f.$Vf)(Se.checkboxState)&&(0,f.$Xf)(Se.checkboxState.state)?Se.checkboxState.state:void 0,_e=!(0,f.$Xf)(Se.checkboxState)&&(0,f.$Vf)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Je===void 0||Je!==Ft.Checked&&Je!==Ft.Unchecked||_e!==void 0&&!(0,f.$Tf)(_e))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(T instanceof I)return!0;if(Se.label!==void 0&&!(0,f.$Tf)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,f.$Tf)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,f.$Tf)(Se.iconPath)&&!E.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,f.$Tf)(Se.iconPath.id))){const Je=Se.iconPath;if(!Je||!(0,f.$Tf)(Je.light)&&!E.URI.isUri(Je.light)&&!(0,f.$Tf)(Je.dark)&&!E.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,f.$Tf)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!E.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,f.$Tf)(Se.tooltip)&&!(Se.tooltip instanceof Ne)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<bt.None&&Se.collapsibleState>bt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,f.$Tf)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(T,te=bt.None){this.collapsibleState=te,E.URI.isUri(T)?this.resourceUri=T:this.label=T}};e.$YM=Xt,e.$YM=Xt=I=Qe([w],Xt);var bt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(bt||(e.TreeItemCollapsibleState=bt={}));var Ft;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Ft||(e.TreeItemCheckboxState=Ft={}));let Bt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(T){this.value=T}};e.$ZM=Bt,e.$ZM=Bt=Qe([w],Bt);class Tt extends Bt{}e.$1M=Tt;class wt extends Tt{#e;constructor(T){super(""),this.#e=T}asFile(){return this.#e}}e.$2M=wt;class Pt{constructor(T,te,Se,Je){this.name=T,this.uri=te,this._itemId=Se,this.c=Je}data(){return this.c()}}e.$3M=Pt;let kt=class{#e=new Map;constructor(T){for(const[te,Se]of T??[]){const Je=this.#e.get(this.#t(te));Je?Je.push(Se):this.#e.set(this.#t(te),[Se])}}get(T){return this.#e.get(this.#t(T))?.[0]}set(T,te){this.#e.set(this.#t(T),[te])}forEach(T,te){for(const[Se,Je]of this.#e)for(const _e of Je)T.call(te,_e,Se,this)}*[Symbol.iterator](){for(const[T,te]of this.#e)for(const Se of te)yield[T,Se]}#t(T){return T.toLowerCase()}};e.$4M=kt,e.$4M=kt=Qe([w],kt);let li=class{constructor(T){this.insertText=T}};e.$5M=li,e.$5M=li=Qe([w],li);let Kt=class{constructor(T,te){this.label=te,this.insertText=T}};e.$6M=Kt,e.$6M=Kt=Qe([w],Kt);let ni=class{constructor(T,te){this.id=T,this.color=te}static isThemeIcon(T){return typeof T.id!="string"?(console.log("INVALID ThemeIcon, invalid id",T.id),!1):!0}};e.$7M=ni,e.$7M=ni=Qe([w],ni),ni.File=new ni("file"),ni.Folder=new ni("folder");let we=class{constructor(T){this.id=T}};e.$8M=we,e.$8M=we=Qe([w],we);var Fe;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Fe||(e.ConfigurationTarget=Fe={}));let oe=class{get base(){return this.c}set base(T){this.c=T,this.e=E.URI.file(T)}get baseUri(){return this.e}set baseUri(T){this.e=T,this.c=T.fsPath}constructor(T,te){if(typeof T!="string"&&(!T||!E.URI.isUri(T)&&!E.URI.isUri(T.uri)))throw(0,M.$7)("base");if(typeof te!="string")throw(0,M.$7)("pattern");typeof T=="string"?this.baseUri=E.URI.file(T):E.URI.isUri(T)?this.baseUri=T:this.baseUri=T.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$9M=oe,e.$9M=oe=Qe([w],oe);const Q=new WeakMap;function De(B,T){Q.set(B,T)}e.$0M=De;let Te=class{constructor(T,te,Se,Je,_e){this.enabled=typeof T=="boolean"?T:!0,typeof te=="string"&&(this.condition=te),typeof Se=="string"&&(this.hitCondition=Se),typeof Je=="string"&&(this.logMessage=Je),typeof _e=="string"&&(this.mode=_e)}get id(){return this.c||(this.c=Q.get(this)??(0,N.$Cg)()),this.c}};e.$$M=Te,e.$$M=Te=Qe([w],Te);let Xe=class extends Te{constructor(T,te,Se,Je,_e,ut){if(super(te,Se,Je,_e,ut),T===null)throw(0,M.$7)("location");this.location=T}};e.$_M=Xe,e.$_M=Xe=Qe([w],Xe);let Ge=class extends Te{constructor(T,te,Se,Je,_e,ut){super(te,Se,Je,_e,ut),this.functionName=T}};e.$aN=Ge,e.$aN=Ge=Qe([w],Ge);let ct=class extends Te{constructor(T,te,Se,Je,_e,ut,gt,Jt){if(super(Je,_e,ut,gt,Jt),!te)throw(0,M.$7)("dataId");this.label=T,this.dataId=te,this.canPersist=Se}};e.$bN=ct,e.$bN=ct=Qe([w],ct);let yt=class{constructor(T,te,Se){this.command=T,this.args=te||[],this.options=Se}};e.$cN=yt,e.$cN=yt=Qe([w],yt);let Gt=class{constructor(T,te){this.port=T,this.host=te}};e.$dN=Gt,e.$dN=Gt=Qe([w],Gt);let Et=class{constructor(T){this.path=T}};e.$eN=Et,e.$eN=Et=Qe([w],Et);let Rt=class{constructor(T){this.implementation=T}};e.$fN=Rt,e.$fN=Rt=Qe([w],Rt);class ri{constructor(T,te,Se){this.session=T,this.threadId=te,this.frameId=Se}}e.$gN=ri;class wi{constructor(T,te){this.session=T,this.threadId=te}}e.$hN=wi;let pi=class{constructor(T,te){this.range=T,this.expression=te}};e.$iN=pi,e.$iN=pi=Qe([w],pi);var ft;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(ft||(e.InlineCompletionTriggerKind=ft={}));let Ai=class{constructor(T,te){this.range=T,this.text=te}};e.$jN=Ai,e.$jN=Ai=Qe([w],Ai);let hi=class{constructor(T,te,Se=!0){this.range=T,this.variableName=te,this.caseSensitiveLookup=Se}};e.$kN=hi,e.$kN=hi=Qe([w],hi);let mi=class{constructor(T,te){this.range=T,this.expression=te}};e.$lN=mi,e.$lN=mi=Qe([w],mi);let yi=class{constructor(T,te){this.frameId=T,this.stoppedLocation=te}};e.$mN=yi,e.$mN=yi=Qe([w],yi);var Qi;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Qi||(e.NewSymbolNameTag=Qi={}));class hn{constructor(T,te){this.newSymbolName=T,this.tags=te}}e.$nN=hn;var Zi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Zi||(e.FileChangeType=Zi={}));let ki=h=class extends Error{static FileExists(T){return new h(T,l.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(T){return new h(T,l.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(T){return new h(T,l.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(T){return new h(T,l.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(T){return new h(T,l.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(T){return new h(T,l.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}constructor(T,te=l.FileSystemProviderErrorCode.Unknown,Se){super(E.URI.isUri(T)?T.toString(!0):T),this.code=Se?.name??"Unknown",(0,l.$Vk)(this,te),Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$oN=ki,e.$oN=ki=h=Qe([w],ki);let Mi=class{constructor(T,te,Se){this.start=T,this.end=te,this.kind=Se}};e.$pN=Mi,e.$pN=Mi=Qe([w],Mi);var Fi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Fi||(e.FoldingRangeKind=Fi={}));var Xi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Xi||(e.CommentThreadCollapsibleState=Xi={}));var Ei;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Ei||(e.CommentMode=Ei={}));var Di;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Di||(e.CommentState=Di={}));var Yi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(Yi||(e.CommentThreadState=Yi={}));class dn{constructor(T,te=[]){this.tokenTypes=T,this.tokenModifiers=te}}e.$qN=dn;function bi(B){return typeof B>"u"||(0,f.$Uf)(B)}class Oi{constructor(T){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,T){this.m=!0;for(let te=0,Se=T.tokenTypes.length;te<Se;te++)this.k.set(T.tokenTypes[te],te);for(let te=0,Se=T.tokenModifiers.length;te<Se;te++)this.l.set(T.tokenModifiers[te],te)}}push(T,te,Se,Je,_e){if(typeof T=="number"&&typeof te=="number"&&typeof Se=="number"&&typeof Je=="number"&&(typeof _e=="number"||typeof _e>"u"))return typeof _e>"u"&&(_e=0),this.q(T,te,Se,Je,_e);if(U.isRange(T)&&typeof te=="string"&&bi(Se))return this.o(T,te,Se);throw(0,M.$7)()}o(T,te,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(T.start.line!==T.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Je=T.start.line,_e=T.start.character,ut=T.end.character-T.start.character,gt=this.k.get(te);let Jt=0;if(Se)for(const ui of Se){if(!this.l.has(ui))throw new Error("`tokenModifier` is not in the provided legend");const di=this.l.get(ui);Jt|=1<<di>>>0}this.q(Je,_e,ut,gt,Jt)}q(T,te,Se,Je,_e){if(this.f&&(T<this.c||T===this.c&&te<this.e)){this.f=!1;const Jt=this.g.length/5|0;let ui=0,di=0;for(let gi=0;gi<Jt;gi++){let $i=this.g[5*gi],Gi=this.g[5*gi+1];$i===0?($i=ui,Gi+=di):$i+=ui,this.g[5*gi]=$i,this.g[5*gi+1]=Gi,ui=$i,di=Gi}}let ut=T,gt=te;this.f&&this.j>0&&(ut-=this.c,ut===0&&(gt-=this.e)),this.g[this.j++]=ut,this.g[this.j++]=gt,this.g[this.j++]=Se,this.g[this.j++]=Je,this.g[this.j++]=_e,this.c=T,this.e=te}static r(T){const te=[],Se=T.length/5|0;for(let gt=0;gt<Se;gt++)te[gt]=gt;te.sort((gt,Jt)=>{const ui=T[5*gt],di=T[5*Jt];if(ui===di){const gi=T[5*gt+1],$i=T[5*Jt+1];return gi-$i}return ui-di});const Je=new Uint32Array(T.length);let _e=0,ut=0;for(let gt=0;gt<Se;gt++){const Jt=5*te[gt],ui=T[Jt+0],di=T[Jt+1],gi=T[Jt+2],$i=T[Jt+3],Gi=T[Jt+4],Rn=ui-_e,er=Rn===0?di-ut:di,Ji=5*gt;Je[Ji+0]=Rn,Je[Ji+1]=er,Je[Ji+2]=gi,Je[Ji+3]=$i,Je[Ji+4]=Gi,_e=ui,ut=di}return Je}build(T){return this.f?new Ni(new Uint32Array(this.g),T):new Ni(Oi.r(this.g),T)}}e.$rN=Oi;class Ni{constructor(T,te){this.resultId=te,this.data=T}}e.$sN=Ni;class fn{constructor(T,te,Se){this.start=T,this.deleteCount=te,this.data=Se}}e.$tN=fn;class gn{constructor(T,te){this.resultId=te,this.edits=T}}e.$uN=gn;var xi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(xi||(e.DebugConsoleMode=xi={}));class _i{constructor(T){this.name=T}}e.$vN=_i;let Si=class{static{this.Back={iconPath:new ni("arrow-left")}}constructor(){}};e.$wN=Si,e.$wN=Si=Qe([w],Si);var en;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(en||(e.QuickPickItemKind=en={}));var Li;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Li||(e.InputBoxValidationSeverity=Li={}));var Ti;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Ti||(e.ExtensionKind=Ti={}));class mn{static validate(T){if(typeof T.badge=="string"){let te=(0,m.$uf)(T.badge,0);if(te<T.badge.length&&(te+=(0,m.$uf)(T.badge,te)),T.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(T.badge&&!ni.isThemeIcon(T.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!T.color&&!T.badge&&!T.tooltip)throw new Error("The decoration is empty");return!0}constructor(T,te,Se){this.badge=T,this.tooltip=te,this.color=Se}}e.$xN=mn;let ji=class{constructor(T){this.kind=T}};e.$yN=ji,e.$yN=ji=Qe([w],ji);var tn;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(tn||(e.ColorThemeKind=tn={}));class fi{static isNotebookRange(T){return T instanceof fi?!0:T?typeof T.start=="number"&&typeof T.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(T,te){if(T<0)throw(0,M.$7)("start must be positive");if(te<0)throw(0,M.$7)("end must be positive");T<=te?(this.c=T,this.e=te):(this.c=te,this.e=T)}with(T){let te=this.c,Se=this.e;return T.start!==void 0&&(te=T.start),T.end!==void 0&&(Se=T.end),te===this.c&&Se===this.e?this:new fi(te,Se)}}e.$zN=fi;class vi{static validate(T){if(typeof T.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof T.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof T.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(T){return Array.isArray(T)&&T.every(te=>vi.isNotebookCellData(te))}static isNotebookCellData(T){return!0}constructor(T,te,Se,Je,_e,ut,gt){this.kind=T,this.value=te,this.languageId=Se,this.mime=Je,this.outputs=_e??[],this.metadata=ut,this.executionSummary=gt,vi.validate(this)}}e.$AN=vi;class nn{constructor(T){this.cells=T}}e.$BN=nn;class je{static isNotebookCellOutputItem(T){return T instanceof je?!0:T?typeof T.mime=="string"&&T.data instanceof Uint8Array:!1}static error(T){const te={name:T.name,message:T.message,stack:T.stack};return je.json(te,"application/vnd.code.notebook.error")}static stdout(T){return je.text(T,"application/vnd.code.notebook.stdout")}static stderr(T){return je.text(T,"application/vnd.code.notebook.stderr")}static bytes(T,te="application/octet-stream"){return new je(T,te)}static#e=new TextEncoder;static text(T,te=R.$us.text){const Se=je.#e.encode(String(T));return new je(Se,te)}static json(T,te="text/x-json"){const Se=JSON.stringify(T,void 0,"	");return je.text(Se,te)}constructor(T,te){this.data=T,this.mime=te;const Se=(0,R.$ys)(te,!0);if(!Se)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$CN=je;class ci{static isNotebookCellOutput(T){return T instanceof ci?!0:!T||typeof T!="object"?!1:typeof T.id=="string"&&Array.isArray(T.items)}static ensureUniqueMimeTypes(T,te=!1){const Se=new Set,Je=new Set;for(let _e=0;_e<T.length;_e++){const ut=T[_e],gt=(0,R.$ys)(ut.mime);if(!Se.has(gt)||(0,g.$9J)(gt)){Se.add(gt);continue}Je.add(_e),te&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Je.size===0?T:T.filter((_e,ut)=>!Je.has(ut))}constructor(T,te,Se){this.items=ci.ensureUniqueMimeTypes(T,!0),typeof te=="string"?(this.id=te,this.metadata=Se):(this.id=(0,N.$Cg)(),this.metadata=te??Se)}}e.$DN=ci;var zi;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(zi||(e.NotebookCellKind=zi={}));var nt;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(nt||(e.NotebookCellExecutionState=nt={}));var pt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(pt||(e.NotebookCellStatusBarAlignment=pt={}));var rn;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(rn||(e.NotebookEditorRevealType=rn={}));class $n{constructor(T,te){this.text=T,this.alignment=te}}e.$EN=$n;var Ui;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Ui||(e.NotebookControllerAffinity=Ui={}));var sn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(sn||(e.NotebookControllerAffinity2=sn={}));class Ii{constructor(T,te=[]){this.uri=T,this.provides=(0,S.$3b)(te)}}e.$FN=Ii;class pn{constructor(T){this.label=T}}e.$GN=pn;var on;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(on||(e.NotebookVariablesRequestKind=on={}));let Bi=class{constructor(T,te){this.label=T,this.timestamp=te}};e.$HN=Bi,e.$HN=Bi=Qe([w],Bi);var Vi;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(Vi||(e.ExtensionMode=Vi={}));var an;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(an||(e.ExtensionRuntime=an={}));var cn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(cn||(e.StandardTokenType=cn={}));class vn{constructor(T,te){this.ranges=T,this.wordPattern=te}}e.$IN=vn;class bn{constructor(T){this.c=T}get autoForwardAction(){return this.c}}e.$JN=bn;var un;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(un||(e.TestResultState=un={}));var ln;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(ln||(e.TestRunProfileKind=ln={}));let Wi=class{constructor(T=void 0,te=void 0,Se=void 0,Je=!1){this.include=T,this.exclude=te,this.profile=Se,this.continuous=Je}};e.$KN=Wi,e.$KN=Wi=Qe([w],Wi);let qi=y=class{static diff(T,te,Se){const Je=new y(T);return Je.expectedOutput=te,Je.actualOutput=Se,Je}constructor(T){this.message=T}};e.$LN=qi,e.$LN=qi=y=Qe([w],qi);let Hi=class{constructor(T){this.id=T}};e.$MN=Hi,e.$MN=Hi=Qe([w],Hi);class Ci{constructor(T,te){this.covered=T,this.total=te}}e.$NN=Ci;const Ki=B=>{if(B&&B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`)};class x{static fromDetails(T,te){const Se=new Ci(0,0),Je=new Ci(0,0),_e=new Ci(0,0);for(const gt of te)if("branches"in gt){Se.total+=1,Se.covered+=gt.executed?1:0;for(const Jt of gt.branches)Je.total+=1,Je.covered+=Jt.executed?1:0}else _e.total+=1,_e.covered+=gt.executed?1:0;const ut=new x(T,Se,Je.total>0?Je:void 0,_e.total>0?_e:void 0);return ut.detailedCoverage=te,ut}constructor(T,te,Se,Je){this.uri=T,this.statementCoverage=te,this.branchCoverage=Se,this.declarationCoverage=Je,Ki(te),Ki(Se),Ki(Je)}}e.$ON=x;class ae{get executionCount(){return+this.executed}set executionCount(T){this.executed=T}constructor(T,te,Se=[]){this.executed=T,this.location=te,this.branches=Se}}e.$PN=ae;class Ue{get executionCount(){return+this.executed}set executionCount(T){this.executed=T}constructor(T,te,Se){this.executed=T,this.location=te,this.label=Se}}e.$QN=Ue;class at{get executionCount(){return+this.executed}set executionCount(T){this.executed=T}constructor(T,te,Se){this.name=T,this.executed=te,this.location=Se}}e.$RN=at;var vt;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(vt||(e.ExternalUriOpenerPriority=vt={}));var At;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(At||(e.WorkspaceTrustState=At={}));var Pi;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(Pi||(e.PortAutoForwardAction=Pi={}));class An{constructor(T,te,Se,Je,_e,ut){this.kind=T,this.name=te,this.detail=Se,this.uri=Je,this.range=_e,this.selectionRange=ut}}e.$SN=An;class Mn{constructor(T){this.uri=T}}e.$TN=Mn;class Fn{constructor(T,te){this.original=T,this.modified=te}}e.$UN=Fn;class On{constructor(T,te,Se,Je){this.base=T,this.input1=te,this.input2=Se,this.result=Je}}e.$VN=On;class Nn{constructor(T,te){this.uri=T,this.viewType=te}}e.$WN=Nn;class Ln{constructor(T){this.viewType=T}}e.$XN=Ln;class Tn{constructor(T,te){this.uri=T,this.notebookType=te}}e.$YN=Tn;class jn{constructor(T,te,Se){this.original=T,this.modified=te,this.notebookType=Se}}e.$ZN=jn;class zn{constructor(){}}e.$1N=zn;class Un{constructor(T,te){this.uri=T,this.inputBoxUri=te}}e.$2N=Un;class Bn{constructor(T){this.providerId=T}}e.$3N=Bn;var wn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(wn||(e.InteractiveSessionVoteDirection=wn={}));var yn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(yn||(e.ChatCopyKind=yn={}));var kn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(kn||(e.ChatVariableLevel=kn={}));class Vn{constructor(T,te){this.label=T,this.values=te}}e.$4N=Vn;var En;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(En||(e.InteractiveEditorResponseFeedbackKind=En={}));var Dn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Dn||(e.ChatResultFeedbackKind=Dn={}));class Wn{constructor(T){this.value=typeof T=="string"?new Ne(T):T}}e.$5N=Wn;class qn{constructor(T,te){this.value=T,this.baseUri=te}}e.$6N=qn;class Hn{constructor(T,te){this.value=T,this.title=te}}e.$7N=Hn;class Kn{constructor(T){this.value=T}}e.$8N=Kn;class Gn{constructor(T){this.value=T}}e.$9N=Gn;class Jn{constructor(T){this.value=T}}e.$0N=Jn;class Qn{constructor(T,te,Se,Je){this.prompt=T,this.command=te,this.variables=Se,this.participant=Je}}e.$$N=Qn;class Zn{constructor(T,te,Se,Je){this.response=T,this.result=te,this.participant=Se,this.command=Je}}e.$_N=Zn;class Xn{constructor(T){this.content=T}}e.$aO=Xn;class Yn{constructor(T,te){this.content=T,this.name=te}}e.$bO=Yn;class xn{constructor(T){this.content=T}}e.$cO=xn;class Ri extends Error{static NotFound(T){return new Ri(T,Ri.NotFound.name)}static NoPermissions(T){return new Ri(T,Ri.NoPermissions.name)}constructor(T,te,Se){super(T,{cause:Se}),this.name="LanguageModelError",this.code=te??""}}e.$dO=Ri;var Sn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var In;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(In||(e.SpeechToTextStatus=In={}));var Cn;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(Cn||(e.KeywordRecognitionStatus=Cn={}));class _n{constructor(T,te){this.text=T,this.range=te}}e.$eO=_n;var Pn;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Pn||(e.InlineEditTriggerKind=Pn={}))}),define(Pe[242],Re([1,0,4,7]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(S.$0L.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,m,f){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(R);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(m,f)??[]}getRelatedInformation(R,m,f){return this.c.$getAiRelatedInformation(m,f)}registerRelatedInformationProvider(R,m,f){const E=this.b;return this.b++,this.a.set(E,f),this.c.$registerAiRelatedInformationProvider(E,m),new M.$_L(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$bic=P}),define(Pe[84],Re([1,0,5,4,7,20,106,3,17]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=e.$mic=void 0,e.$mic=(0,m.$gi)("IExtHostAuthentication");let E=class{constructor(l){this.b=new Map,this.c=new S.$6d,this.onDidChangeSessions=this.c.event,this.d=new N,this.f=new N,this.a=l.getProxy(M.$0L.MainThreadAuthentication)}async getSession(l,k,g,s={}){const a=F.$Am.toKey(l.identifier),r=[...g].sort().join(" ");return await this.d.getOrCreate(`${a} ${k} ${r}`,async()=>{await this.a.$ensureProvider(k);const i=l.displayName||l.name;return this.a.$getSession(k,g,a,i,s)})}async getSessions(l,k,g){const s=F.$Am.toKey(l.identifier),a=[...g].sort().join(" ");return await this.f.getOrCreate(`${s} ${a}`,async()=>{await this.a.$ensureProvider(k);const r=l.displayName||l.name;return this.a.$getSessions(k,g,s,r)})}async removeSession(l,k){const g=this.b.get(l);return g?g.provider.removeSession(k):this.a.$removeSession(l,k)}registerAuthenticationProvider(l,k,g,s){if(this.b.get(l))throw new Error(`An authentication provider with id '${l}' is already registered.`);this.b.set(l,{label:k,provider:g,options:s??{supportsMultipleAccounts:!1}});const a=g.onDidChangeSessions(r=>this.a.$sendDidChangeSessions(l,r));return this.a.$registerAuthenticationProvider(l,k,s?.supportsMultipleAccounts??!1),new P.$_L(()=>{a.dispose(),this.b.delete(l),this.a.$unregisterAuthenticationProvider(l)})}$createSession(l,k,g){const s=this.b.get(l);if(s)return Promise.resolve(s.provider.createSession(k,g));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$removeSession(l,k){const g=this.b.get(l);if(g)return Promise.resolve(g.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$getSessions(l,k){const g=this.b.get(l);if(g)return Promise.resolve(g.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$onDidChangeAuthenticationSessions(l,k){return l.startsWith(R.$cL)||this.c.fire({provider:{id:l,label:k}}),Promise.resolve()}};e.$nic=E,e.$nic=E=Qe([qe(0,f.$pO)],E);class N{constructor(){this.a=new Map}getOrCreate(l,k){const g=this.a.get(l);if(g)return g;const s=k().finally(()=>this.a.delete(l));return this.a.set(l,s),s}}}),define(Pe[110],Re([1,0,2,4,7,3,17,13,18,15,19,22]),function(me,e,S,M,P,F,R,m,f,E,N,D){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$ojc=e.$njc=void 0;let k=class{static{l=this}static{this.c=0}static{this.d=250}constructor(s,a){this.h=a,this.f=new Map,this.g=s.getProxy(M.$0L.MainThreadDecorations)}registerFileDecorationProvider(s,a){const r=l.c++;this.f.set(r,{provider:s,extensionDescription:a}),this.g.$registerDecorationProvider(r,a.identifier.value);const i=s.onDidChangeFileDecorations&&s.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(r,null);return}const c=(0,f.$3b)(n);if(c.length<=l.d){this.g.$onDidChange(r,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",a.identifier.value,c.length);const d=c.map(u=>({uri:u,rank:(0,E.$Ze)(u.path,"/")})),t=(0,f.$zb)(d,(u,o)=>u.rank-o.rank||(0,E.$df)(u.uri.path,o.uri.path)),p=[];e:for(const u of t){let o;for(const v of u){const b=(0,N.$mc)(v.uri.path);if(o!==b&&(o=b,p.push(v.uri)>=l.d))break e}}this.g.$onDidChange(r,p)});return new P.$_L(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(r),this.f.delete(r)})}async $provideDecorations(s,a,r){if(!this.f.has(s))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:c}=this.f.get(s);return await Promise.all(a.map(async d=>{try{const{uri:t,id:p}=d,u=await Promise.resolve(n.provideFileDecoration(S.URI.revive(t),r));if(!u)return;try{P.$xN.validate(u),u.badge&&typeof u.badge!="string"&&(0,D.$1F)(c,"codiconDecoration"),i[p]=[u.propagate,u.tooltip,u.badge,u.color]}catch(o){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${o}`)}}catch(t){this.h.error(t)}})),i}};e.$njc=k,e.$njc=k=l=Qe([qe(0,R.$pO),qe(1,m.$Aj)],k),e.$ojc=(0,F.$gi)("IExtHostDecorations")}),define(Pe[243],Re([1,0,14,2,7,4,12,25,15]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qjc=void 0;class E{static{this.a=0}constructor(D,l,k){this.d=l,this.e=k,this.b=new Map,this.c=D.getProxy(F.$0L.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,l){if(Object.keys(R.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const k=E.a++;this.b.set(k,l),this.c.$registerTextContentProvider(k,D);let g;if(typeof l.onDidChange=="function"){let s;g=l.onDidChange(async a=>{if(a.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(a))return;s&&await s;const r=this.$provideTextDocumentContent(k,a).then(async i=>{if(!i&&typeof i!="string")return;const n=this.d.getDocument(a);if(!n)return;const c=(0,f.$0e)(i);if(!n.equalLines(c))return this.c.$onVirtualDocumentChange(a,i)}).catch(S.$1).finally(()=>{s===r&&(s=void 0)});s=r})}return new P.$_L(()=>{this.b.delete(k)&&this.c.$unregisterTextContentProvider(k),g&&(g.dispose(),g=void 0)})}$provideTextDocumentContent(D,l){const k=this.b.get(D);return k?Promise.resolve(k.provideTextDocumentContent(M.URI.revive(l),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$qjc=E}),define(Pe[111],Re([1,0,55,12,15,299,150,7,18]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tO=e.$sO=e.$rO=void 0;const E=new Map;function N(g,s){s?E.set(g,s):E.delete(g)}e.$rO=N;function D(g){return E.get(g)}class l extends F.$Bv{constructor(s,a,r,i,n,c,d){super(a,r,i,n),this.c=s,this.m=c,this.q=d,this.b=!1}dispose(){(0,S.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,f.$ub)(this.f,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.d},get fileName(){return s.d.fsPath},get isUntitled(){return s.d.scheme===M.Schemas.untitled},get languageId(){return s.m},get version(){return s.h},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(a){return a?s.s(a):s.getText()},get eol(){return s.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return s.f.length},lineAt(a){return s.t(a)},offsetAt(a){return s.u(a)},positionAt(a){return s.v(a)},validateRange(a){return s.w(a)},validatePosition(a){return s.x(a)},getWordRangeAtPosition(a,r){return s.y(a,r)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,S.ok)(!this.b),this.m=s}_acceptIsDirty(s){(0,S.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(s){const a=this.w(s);if(a.isEmpty)return"";if(a.isSingleLine)return this.f[a.start.line].substring(a.start.character,a.end.character);const r=this.g,i=a.start.line,n=a.end.line,c=[];c.push(this.f[i].substring(a.start.character));for(let d=i+1;d<n;d++)c.push(this.f[d]);return c.push(this.f[n].substring(0,a.end.character)),c.join(r)}t(s){let a;if(s instanceof m.$aM?a=s.line:typeof s=="number"&&(a=s),typeof a!="number"||a<0||a>=this.f.length||Math.floor(a)!==a)throw new Error("Illegal value for `line`");return new k(a,this.f[a],a===this.f.length-1)}u(s){return s=this.x(s),this.l(),this.j.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.l();const a=this.j.getIndexOf(s),r=this.f[a.index].length;return new m.$aM(a.index,Math.min(a.remainder,r))}w(s){if(!(s instanceof m.$bM))throw new Error("Invalid argument");const a=this.x(s.start),r=this.x(s.end);return a===s.start&&r===s.end?s:new m.$bM(a.line,a.character,r.line,r.character)}x(s){if(!(s instanceof m.$aM))throw new Error("Invalid argument");if(this.f.length===0)return s.with(0,0);let{line:a,character:r}=s,i=!1;if(a<0)a=0,r=0,i=!0;else if(a>=this.f.length)a=this.f.length-1,r=this.f[a].length,i=!0;else{const n=this.f[a].length;r<0?(r=0,i=!0):r>n&&(r=n,i=!0)}return i?new m.$aM(a,r):s}y(s,a){const r=this.x(s);if(!a)a=D(this.m);else if((0,P.$9e)(a))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${a.source}' because it matches the empty string.`);const i=(0,R.$Ms)(r.character+1,(0,R.$Ks)(a),this.f[r.line],0);if(i)return new m.$bM(r.line,i.startColumn-1,r.line,i.endColumn-1)}}e.$sO=l;class k{constructor(s,a,r){this.a=s,this.b=a,this.c=r}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$bM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$bM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$tO=k}),define(Pe[244],Re([1,0,4,7]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sjc=void 0;class P{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(S.$0L.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,m,f){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(R);if(!E)throw new Error("Embedding vector provider not found");const N=await E.provideEmbeddingVector(m,f);if(!N)throw new Error("Embedding vector provider returned undefined");return N}registerEmbeddingVectorProvider(R,m,f){const E=this.b;return this.b++,this.a.set(E,f),this.c.$registerAiEmbeddingVectorProvider(m,E),new M.$_L(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$sjc=P}),define(Pe[63],Re([1,0,4,42,7,23,3,17,43,6,11,24,12]),function(me,e,S,M,P,F,R,m,f,E,N,D,l){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=e.$Fic=void 0;let g=k=class{constructor(a,r){this.b=new Map,this.c=new N.$ph,this.a=a.getProxy(S.$0L.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let c;const d=i.b.get(n.scheme);return d?(await i.a.$ensureActivation(n.scheme),c=await d.impl.stat(n)):c=await i.a.$stat(n),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===M.FilePermission.Readonly?1:void 0}}catch(c){k.e(c)}},async readDirectory(n){try{const c=i.b.get(n.scheme);return c?(await i.a.$ensureActivation(n.scheme),(await c.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(c){return k.e(c)}},async createDirectory(n){try{const c=i.b.get(n.scheme);return c&&!c.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(c.impl,c.extUri,n)):await i.a.$mkdir(n)}catch(c){return k.e(c)}},async readFile(n){try{const c=i.b.get(n.scheme);return c?(await i.a.$ensureActivation(n.scheme),(await c.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(c){return k.e(c)}},async writeFile(n,c){try{const d=i.b.get(n.scheme);return d&&!d.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(d.impl,d.extUri,d.extUri.dirname(n)),await i.c.queueFor(n,()=>Promise.resolve(d.impl.writeFile(n,c,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,F.$te.wrap(c))}catch(d){return k.e(d)}},async delete(n,c){try{const d=i.b.get(n.scheme);return d&&!d.isReadonly&&!c?.useTrash?(await i.a.$ensureActivation(n.scheme),await d.impl.delete(n,{recursive:!1,...c})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(d){return k.e(d)}},async rename(n,c,d){try{return await i.a.$rename(n,c,{overwrite:!1,...d})}catch(t){return k.e(t)}},async copy(n,c,d){try{return await i.a.$copy(n,c,{overwrite:!1,...d})}catch(t){return k.e(t)}},isWritableFileSystem(n){const c=r.getCapabilities(n);if(typeof c=="number")return!(c&2048)}})}async d(a,r,i){const n=[];for(;!r.isEqual(i,r.dirname(i));)try{if(!((await a.stat(i)).type&M.FileType.Directory))throw P.$oN.FileExists(`Unable to create folder '${i.scheme===l.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(M.$Wk(c)!==M.FileSystemProviderErrorCode.FileNotFound)throw c;n.push(r.basename(i)),i=r.dirname(i)}for(let c=n.length-1;c>=0;c--){i=r.joinPath(i,n[c]);try{await a.createDirectory(i)}catch(d){if(M.$Wk(d)!==M.FileSystemProviderErrorCode.FileExists)throw d}}}static e(a){if(a instanceof P.$oN)throw a;if(a instanceof M.$Sk)switch(a.code){case M.FileSystemProviderErrorCode.FileExists:throw P.$oN.FileExists(a.message);case M.FileSystemProviderErrorCode.FileNotFound:throw P.$oN.FileNotFound(a.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw P.$oN.FileNotADirectory(a.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw P.$oN.FileIsADirectory(a.message);case M.FileSystemProviderErrorCode.NoPermissions:throw P.$oN.NoPermissions(a.message);case M.FileSystemProviderErrorCode.Unavailable:throw P.$oN.Unavailable(a.message);default:throw new P.$oN(a.message,a.name)}if(!(a instanceof Error))throw new P.$oN(String(a));if(a.name==="ENOPRO"||a.message.includes("ENOPRO"))throw P.$oN.Unavailable(a.message);switch(a.name){case M.FileSystemProviderErrorCode.FileExists:throw P.$oN.FileExists(a.message);case M.FileSystemProviderErrorCode.FileNotFound:throw P.$oN.FileNotFound(a.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw P.$oN.FileNotADirectory(a.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw P.$oN.FileIsADirectory(a.message);case M.FileSystemProviderErrorCode.NoPermissions:throw P.$oN.NoPermissions(a.message);case M.FileSystemProviderErrorCode.Unavailable:throw P.$oN.Unavailable(a.message);default:throw new P.$oN(a.message,a.name)}}addFileSystemProvider(a,r,i){return this.b.set(a,{impl:r,extUri:i?.isCaseSensitive?D.$Jg:D.$Lg,isReadonly:!!i?.isReadonly}),(0,E.$Rc)(()=>this.b.delete(a))}getFileSystemProviderExtUri(a){return this.b.get(a)?.extUri??D.$Jg}};e.$Fic=g,e.$Fic=g=k=Qe([qe(0,m.$pO),qe(1,f.$gic)],g),e.$Gic=(0,R.$gi)("IExtHostConsumerFileSystem")}),define(Pe[245],Re([1,0,4,7]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jjc=void 0;class P{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(S.$0L.MainThreadIssueReporter)}async $getIssueReporterUri(R,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const f=this.a.get(R);if(!f)throw new Error("Issue request handler not found");const E=await f.handleIssueUrlRequest();if(!E)throw new Error("Issue request handler returned no result");return E}async $getIssueReporterData(R,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(R);if(!f)throw new Error("Issue data provider not found");const E=await f.provideIssueData(m);if(!E)throw new Error("Issue data provider returned no result");return E}async $getIssueReporterTemplate(R,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const f=this.b.get(R);if(!f)throw new Error("Issue data provider not found");const E=await f.provideIssueTemplate(m);if(!E)throw new Error("Issue template provider returned no result");return E}registerIssueUriRequestHandler(R,m){const f=R.identifier.value;return this.a.set(f,m),this.c.$registerIssueUriRequestHandler(f),new M.$_L(()=>{this.c.$unregisterIssueUriRequestHandler(f),this.a.delete(f)})}registerIssueDataProvider(R,m){const f=R.identifier.value;return this.b.set(f,m),this.c.$registerIssueDataProvider(f),new M.$_L(()=>{this.c.$unregisterIssueDataProvider(f),this.b.delete(f)})}}e.$Jjc=P}),define(Pe[85],Re([1,0,3,27,13,63,2]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iic=e.$Hic=void 0,e.$Hic=(0,S.$gi)("IExtensionStoragePaths");let m=class{constructor(E,N,D){this.d=N,this.f=D,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(E){return R.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,N=await this.g(E);try{return await this.f.value.stat(N),this.d.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",N),await this.f.value.createDirectory(N),await this.f.value.writeFile(R.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),N}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(E){if(this.c)return R.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return R.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Iic=m,e.$Iic=m=Qe([qe(0,M.$FO),qe(1,P.$Aj),qe(2,F.$Gic)],m)}),define(Pe[246],Re([1,0,7,17,5]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$akc=void 0;let F=class{constructor(m){this.a=new S.$yN(S.ColorThemeKind.Dark),this.b=new P.$6d}get activeColorTheme(){return this.a}$onColorThemeChange(m){let f;switch(m){case"light":f=S.ColorThemeKind.Light;break;case"hcDark":f=S.ColorThemeKind.HighContrast;break;case"hcLight":f=S.ColorThemeKind.HighContrastLight;break;default:f=S.ColorThemeKind.Dark}this.a=new S.$yN(f),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$akc=F,e.$akc=F=Qe([qe(0,M.$pO)],F)}),define(Pe[86],Re([1,0,25,5,6,171,3,13,200,4,27,17,7]),function(me,e,S,M,P,F,R,m,f,E,N,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CAb=e.$BAb=e.TunnelDtoConverter=void 0;class k extends f.$Zv{}var g;(function(a){function r(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?f.TunnelPrivacyId.Public:f.TunnelPrivacyId.Private),protocol:n.protocol}}a.fromApiTunnel=r;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==f.TunnelPrivacyId.ConstantPrivate&&n.privacy!==f.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}a.fromServiceTunnel=i})(g||(e.TunnelDtoConverter=g={})),e.$BAb=(0,R.$gi)("IExtHostTunnelService");let s=class extends P.$Tc{constructor(r,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$6d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=r.getProxy(E.$0L.MainThreadTunnelService)}async openTunnel(r,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,r.displayName);if(n){const c=new k(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(r,i){r.portRange===void 0&&r.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:r,provider:i}),this.a.$registerPortsAttributesProvider(r,n),new l.$_L(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(r,i,n,c,d){const t=[];for(const u of r){const o=this.r.get(u);if(!o)return[];t.push(...await Promise.all(i.map(async v=>{let b;try{b=await o.provider.providePortAttributes({port:v,pid:n,commandLine:c},d)}catch{b=await o.provider.providePortAttributes(v,n,c,d)}return{providedAttributes:b,port:v}})))}const p=t.filter(u=>!!u.providedAttributes);return p.length>0?p.map(u=>({autoForwardAction:u.providedAttributes.autoForwardAction,port:u.port})):[]}async $registerCandidateFinder(r){}registerTunnelProvider(r,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,d)=>await r.provideTunnel(c,d,S.CancellationToken.None)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,P.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(r,i){if(r){r.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this.f=r.showCandidatePort,this.a.$setCandidateFilter());const n=r.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let c=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:F.localize(0,null),themeIcon:"lock"},{id:"public",label:F.localize(1,null),themeIcon:"eye"}]);const d=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(d)}}else this.b=void 0;return(0,P.$Rc)(()=>{this.b=void 0})}w(r){}async $closeTunnel(r,i){if(this.g.has(r.host)){const n=this.g.get(r.host);n.has(r.port)&&(i&&n.get(r.port).disposeListener.dispose(),await n.get(r.port).tunnel.dispose(),n.delete(r.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(r,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(r,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const c=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(r.remoteAddress.host)||this.g.set(r.remoteAddress.host,new Map);const d=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:c,disposeListener:d}),g.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(r){const i=await Promise.all(r.map(c=>this.f(c.host,c.port,c.detail??""))),n=r.filter((c,d)=>i[d]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(c=>c.port).join(", ")} to ${n.map(c=>c.port).join(", ")}`),n}};e.$CAb=s,e.$CAb=s=Qe([qe(0,D.$pO),qe(1,N.$FO),qe(2,m.$Aj)],s)}),define(Pe[8],Re([1,0,18,23,130,247,53,28,123,52,69,26,24,16,2,29,87,100,105,104,83,48,60,219,22,7]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g,s,a,r,i,n,c,d,t,p,u,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$oO=e.$nO=e.MarkdownString=e.$mO=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var v;(function(we){function Fe(Q){const{selectionStartLineNumber:De,selectionStartColumn:Te,positionLineNumber:Xe,positionColumn:Ge}=Q,ct=new o.$aM(De-1,Te-1),yt=new o.$aM(Xe-1,Ge-1);return new o.$cM(ct,yt)}we.to=Fe;function oe(Q){const{anchor:De,active:Te}=Q;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}we.from=oe})(v||(e.Selection=v={}));var b;(function(we){function Fe(Q){if(!Q)return;const{start:De,end:Te}=Q;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}we.from=Fe;function oe(Q){if(!Q)return;const{startLineNumber:De,startColumn:Te,endLineNumber:Xe,endColumn:Ge}=Q;return new o.$bM(De-1,Te-1,Xe-1,Ge-1)}we.to=oe})(b||(e.Range=b={}));var $;(function(we){function Fe(Q){return{uri:Q.uri,range:b.from(Q.range)}}we.from=Fe;function oe(Q){return new o.$lM(g.URI.revive(Q.uri),b.to(Q.range))}we.to=oe})($||(e.Location=$={}));var I;(function(we){function Fe(oe){switch(oe){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 3:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}we.to=Fe})(I||(e.TokenType=I={}));var h;(function(we){function Fe(Q){return new o.$aM(Q.lineNumber-1,Q.column-1)}we.to=Fe;function oe(Q){return{lineNumber:Q.line+1,column:Q.character+1}}we.from=oe})(h||(e.Position=h={}));var y;(function(we){function Fe(De,Te,Xe){return(0,S.$Hb)((0,S.$3b)(De).map(Ge=>oe(Ge,Te,Xe)))}we.from=Fe;function oe(De,Te,Xe){if(typeof De=="string")return{$serialized:!0,language:De,isBuiltin:Xe?.isBuiltin};if(De)return{$serialized:!0,language:De.language,scheme:Q(De.scheme,Te),pattern:Z.from(De.pattern)??void 0,exclusive:De.exclusive,notebookType:De.notebookType,isBuiltin:Xe?.isBuiltin}}function Q(De,Te){return Te&&typeof De=="string"?Te.transformOutgoingScheme(De):De}})(y||(e.DocumentSelector=y={}));var w;(function(we){function Fe(Q){switch(Q){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}we.from=Fe;function oe(Q){switch(Q){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}we.to=oe})(w||(e.DiagnosticTag=w={}));var A;(function(we){function Fe(Q){let De;return Q.code&&((0,k.$Tf)(Q.code)||(0,k.$Xf)(Q.code)?De=String(Q.code):De={value:String(Q.code.value),target:Q.code.target}),{...b.from(Q.range),message:Q.message,source:Q.source,code:De,severity:J.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(L.from),tags:Array.isArray(Q.tags)?(0,S.$Hb)(Q.tags.map(w.from)):void 0}}we.from=Fe;function oe(Q){const De=new o.$nM(b.to(Q),Q.message,J.to(Q.severity));return De.source=Q.source,De.code=(0,k.$Tf)(Q.code)?Q.code:Q.code?.value,De.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(L.to),De.tags=Q.tags&&(0,S.$Hb)(Q.tags.map(w.to)),De}we.to=oe})(A||(e.Diagnostic=A={}));var L;(function(we){function Fe(Q){return{...b.from(Q.location.range),message:Q.message,resource:Q.location.uri}}we.from=Fe;function oe(Q){return new o.$mM(new o.$lM(Q.resource,b.to(Q)),Q.message)}we.to=oe})(L||(e.DiagnosticRelatedInformation=L={}));var J;(function(we){function Fe(Q){switch(Q){case o.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}we.from=Fe;function oe(Q){switch(Q){case r.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}we.to=oe})(J||(e.DiagnosticSeverity=J={}));var W;(function(we){function Fe(Q){return typeof Q=="number"&&Q>=o.ViewColumn.One?Q-1:Q===o.ViewColumn.Beside?p.$uD:p.$tD}we.from=Fe;function oe(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=oe})(W||(e.ViewColumn=W={}));function U(we){return typeof we.range<"u"}function C(we){return we.length===0?!0:!!U(we[0])}e.$mO=C;var O;(function(we){function Fe(Ge){return Ge.map(we.from)}we.fromMany=Fe;function oe(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function Q(Ge){let ct;if(oe(Ge)){const{language:Rt,value:ri}=Ge;ct={value:"```"+Rt+`
`+ri+"\n```\n"}}else o.$AM.isMarkdownString(Ge)?ct={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?ct={value:Ge}:ct={value:""};const yt=Object.create(null);ct.uris=yt;const Gt=Rt=>{try{let ri=g.URI.parse(Rt,!0);ri=ri.with({query:De(ri.query,yt)}),yt[Rt]=ri}catch{}return""},Et=new f.marked.Renderer;return Et.link=Gt,Et.image=Rt=>typeof Rt=="string"?Gt(R.$Fk(Rt).href):"",(0,f.marked)(ct.value,{renderer:Et}),ct}we.from=Q;function De(Ge,ct){if(!Ge)return Ge;let yt;try{yt=(0,E.$Oh)(Ge)}catch{}if(!yt)return Ge;let Gt=!1;return yt=(0,D.$Nn)(yt,Et=>{if(g.URI.isUri(Et)){const Rt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[Rt]=Et,Gt=!0,Rt}else return}),Gt?JSON.stringify(yt):Ge}function Te(Ge){const ct=new o.$AM(Ge.value,Ge.supportThemeIcons);return ct.isTrusted=Ge.isTrusted,ct.supportHtml=Ge.supportHtml,ct.baseUri=Ge.baseUri?g.URI.from(Ge.baseUri):void 0,ct}we.to=Te;function Xe(Ge){if(Ge)return typeof Ge=="string"?Ge:we.from(Ge)}we.fromStrict=Xe})(O||(e.MarkdownString=O={}));function q(we){return C(we)?we.map(Fe=>({range:b.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?O.fromMany(Fe.hoverMessage):Fe.hoverMessage?O.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):we.map(Fe=>({range:b.from(Fe)}))}e.$nO=q;function ne(we){return typeof we>"u"?we:typeof we=="string"?g.URI.file(we):we}e.$oO=ne;var ce;(function(we){function Fe(oe){return typeof oe>"u"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?ne(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}we.from=Fe})(ce||(e.ThemableDecorationAttachmentRenderOptions=ce={}));var ye;(function(we){function Fe(oe){return typeof oe>"u"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?ne(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?ce.from(oe.before):void 0,after:oe.after?ce.from(oe.after):void 0}}we.from=Fe})(ye||(e.ThemableDecorationRenderOptions=ye={}));var Ie;(function(we){function Fe(oe){if(typeof oe>"u")return oe;switch(oe){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Fe})(Ie||(e.DecorationRangeBehavior=Ie={}));var ue;(function(we){function Fe(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?Ie.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?ye.from(oe.light):void 0,dark:oe.dark?ye.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?ne(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?ce.from(oe.before):void 0,after:oe.after?ce.from(oe.after):void 0}}we.from=Fe})(ue||(e.DecorationRenderOptions=ue={}));var ve;(function(we){function Fe(Q){return{text:Q.newText,eol:Q.newEol&&it.from(Q.newEol),range:b.from(Q.range)}}we.from=Fe;function oe(Q){const De=new o.$gM(b.to(Q.range),Q.text);return De.newEol=typeof Q.eol>"u"?void 0:it.to(Q.eol),De}we.to=oe})(ve||(e.TextEdit=ve={}));var re;(function(we){function Fe(Q,De){const Te={edits:[]};if(Q instanceof o.$jM){const Xe=new m.$Bc;for(const Ge of Q._allEntries())Ge._type===1&&g.URI.isUri(Ge.to)&&Ge.from===void 0&&Xe.add(Ge.to);for(const Ge of Q._allEntries())if(Ge._type===1){let ct;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?ct={type:"base64",value:(0,M.$Ne)(M.$te.wrap(Ge.options.contents))}:ct={type:"dataTransferItem",id:Ge.options.contents._itemId}),Te.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:ct},metadata:Ge.metadata})}else Ge._type===2?Te.edits.push({resource:Ge.uri,textEdit:ve.from(Ge.edit),versionId:Xe.has(Ge.uri)?void 0:De?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===6?Te.edits.push({resource:Ge.uri,textEdit:{range:b.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Xe.has(Ge.uri)?void 0:De?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===3?Te.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:De?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===5&&Te.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:De?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:1,index:Ge.index,count:Ge.count,cells:Ge.cells.map(jt.from)}})}return Te}we.from=Fe;function oe(Q){const De=new o.$jM,Te=new m.$Ac;for(const Xe of Q.edits)if(Xe.textEdit){const Ge=Xe,ct=g.URI.revive(Ge.resource),yt=b.to(Ge.textEdit.range),Gt=Ge.textEdit.text,Et=Ge.textEdit.insertAsSnippet;let Rt;Et?Rt=o.$iM.replace(yt,new o.$kM(Gt)):Rt=o.$gM.replace(yt,Gt);const ri=Te.get(ct);ri?ri.push(Rt):Te.set(ct,[Rt])}else De.renameFile(g.URI.revive(Xe.oldResource),g.URI.revive(Xe.newResource),Xe.options);for(const[Xe,Ge]of Te)De.set(Xe,Ge);return De}we.to=oe})(re||(e.WorkspaceEdit=re={}));var $e;(function(we){const Fe=Object.create(null);Fe[o.SymbolKind.File]=0,Fe[o.SymbolKind.Module]=1,Fe[o.SymbolKind.Namespace]=2,Fe[o.SymbolKind.Package]=3,Fe[o.SymbolKind.Class]=4,Fe[o.SymbolKind.Method]=5,Fe[o.SymbolKind.Property]=6,Fe[o.SymbolKind.Field]=7,Fe[o.SymbolKind.Constructor]=8,Fe[o.SymbolKind.Enum]=9,Fe[o.SymbolKind.Interface]=10,Fe[o.SymbolKind.Function]=11,Fe[o.SymbolKind.Variable]=12,Fe[o.SymbolKind.Constant]=13,Fe[o.SymbolKind.String]=14,Fe[o.SymbolKind.Number]=15,Fe[o.SymbolKind.Boolean]=16,Fe[o.SymbolKind.Array]=17,Fe[o.SymbolKind.Object]=18,Fe[o.SymbolKind.Key]=19,Fe[o.SymbolKind.Null]=20,Fe[o.SymbolKind.EnumMember]=21,Fe[o.SymbolKind.Struct]=22,Fe[o.SymbolKind.Event]=23,Fe[o.SymbolKind.Operator]=24,Fe[o.SymbolKind.TypeParameter]=25;function oe(De){return typeof Fe[De]=="number"?Fe[De]:6}we.from=oe;function Q(De){for(const Te in Fe)if(Fe[Te]===De)return Number(Te);return o.SymbolKind.Property}we.to=Q})($e||(e.SymbolKind=$e={}));var ie;(function(we){function Fe(Q){switch(Q){case o.SymbolTag.Deprecated:return 1}}we.from=Fe;function oe(Q){switch(Q){case 1:return o.SymbolTag.Deprecated}}we.to=oe})(ie||(e.SymbolTag=ie={}));var le;(function(we){function Fe(Q){return{name:Q.name,kind:$e.from(Q.kind),tags:Q.tags&&Q.tags.map(ie.from),containerName:Q.containerName,location:Ee.from(Q.location)}}we.from=Fe;function oe(Q){const De=new o.$rM(Q.name,$e.to(Q.kind),Q.containerName,Ee.to(Q.location));return De.tags=Q.tags&&Q.tags.map(ie.to),De}we.to=oe})(le||(e.WorkspaceSymbol=le={}));var V;(function(we){function Fe(Q){const De={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:b.from(Q.range),selectionRange:b.from(Q.selectionRange),kind:$e.from(Q.kind),tags:Q.tags?.map(ie.from)??[]};return Q.children&&(De.children=Q.children.map(Fe)),De}we.from=Fe;function oe(Q){const De=new o.$sM(Q.name,Q.detail,$e.to(Q.kind),b.to(Q.range),b.to(Q.selectionRange));return(0,S.$Lb)(Q.tags)&&(De.tags=Q.tags.map(ie.to)),Q.children&&(De.children=Q.children.map(oe)),De}we.to=oe})(V||(e.DocumentSymbol=V={}));var _;(function(we){function Fe(Q){const De=new o.$wM($e.to(Q.kind),Q.name,Q.detail||"",g.URI.revive(Q.uri),b.to(Q.range),b.to(Q.selectionRange));return De._sessionId=Q._sessionId,De._itemId=Q._itemId,De}we.to=Fe;function oe(Q,De,Te){if(De=De??Q._sessionId,Te=Te??Q._itemId,De===void 0||Te===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Te,name:Q.name,detail:Q.detail,kind:$e.from(Q.kind),uri:Q.uri,range:b.from(Q.range),selectionRange:b.from(Q.selectionRange),tags:Q.tags?.map(ie.from)}}we.from=oe})(_||(e.CallHierarchyItem=_={}));var ke;(function(we){function Fe(oe){return new o.$xM(_.to(oe.from),oe.fromRanges.map(Q=>b.to(Q)))}we.to=Fe})(ke||(e.CallHierarchyIncomingCall=ke={}));var Le;(function(we){function Fe(oe){return new o.$yM(_.to(oe.to),oe.fromRanges.map(Q=>b.to(Q)))}we.to=Fe})(Le||(e.CallHierarchyOutgoingCall=Le={}));var Ee;(function(we){function Fe(Q){return{range:Q.range&&b.from(Q.range),uri:Q.uri}}we.from=Fe;function oe(Q){return new o.$lM(g.URI.revive(Q.uri),b.to(Q.range))}we.to=oe})(Ee||(e.location=Ee={}));var be;(function(we){function Fe(Q){const De=Q,Te=Q;return{originSelectionRange:De.originSelectionRange?b.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:Te.uri,range:b.from(De.targetRange?De.targetRange:Te.range),targetSelectionRange:De.targetSelectionRange?b.from(De.targetSelectionRange):void 0}}we.from=Fe;function oe(Q){return{targetUri:g.URI.revive(Q.uri),targetRange:b.to(Q.range),targetSelectionRange:Q.targetSelectionRange?b.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?b.to(Q.originSelectionRange):void 0}}we.to=oe})(be||(e.DefinitionLink=be={}));var ge;(function(we){function Fe(Q){return{range:b.from(Q.range),contents:O.fromMany(Q.contents)}}we.from=Fe;function oe(Q){return new o.$oM(Q.contents.map(O.to),b.to(Q.range))}we.to=oe})(ge||(e.Hover=ge={}));var G;(function(we){function Fe(Q){return{range:b.from(Q.range),expression:Q.expression}}we.from=Fe;function oe(Q){return new o.$iN(b.to(Q.range),Q.expression)}we.to=oe})(G||(e.EvaluatableExpression=G={}));var Y;(function(we){function Fe(Q){if(Q instanceof o.$jN)return{type:"text",range:b.from(Q.range),text:Q.text};if(Q instanceof o.$kN)return{type:"variable",range:b.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof o.$lN)return{type:"expression",range:b.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Fe;function oe(Q){switch(Q.type){case"text":return{range:b.to(Q.range),text:Q.text};case"variable":return{range:b.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:b.to(Q.range),expression:Q.expression}}}we.to=oe})(Y||(e.InlineValue=Y={}));var he;(function(we){function Fe(Q){return{frameId:Q.frameId,stoppedLocation:b.from(Q.stoppedLocation)}}we.from=Fe;function oe(Q){return new o.$mN(Q.frameId,b.to(Q.stoppedLocation))}we.to=oe})(he||(e.InlineValueContext=he={}));var fe;(function(we){function Fe(Q){return{range:b.from(Q.range),kind:Q.kind}}we.from=Fe;function oe(Q){return new o.$pM(b.to(Q.range),Q.kind)}we.to=oe})(fe||(e.DocumentHighlight=fe={}));var Oe;(function(we){function Fe(Q){return{uri:Q.uri,highlights:Q.highlights.map(fe.from)}}we.from=Fe;function oe(Q){return new o.$qM(g.URI.revive(Q.uri),Q.highlights.map(fe.to))}we.to=oe})(Oe||(e.MultiDocumentHighlight=Oe={}));var de;(function(we){function Fe(oe){switch(oe){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}we.to=Fe})(de||(e.CompletionTriggerKind=de={}));var Ce;(function(we){function Fe(oe){return{triggerKind:de.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}we.to=Fe})(Ce||(e.CompletionContext=Ce={}));var Ae;(function(we){function Fe(Q){switch(Q){case o.CompletionItemTag.Deprecated:return 1}}we.from=Fe;function oe(Q){switch(Q){case 1:return o.CompletionItemTag.Deprecated}}we.to=oe})(Ae||(e.CompletionItemTag=Ae={}));var ze;(function(we){const Fe=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function oe(Te){return Fe.get(Te)??9}we.from=oe;const Q=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function De(Te){return Q.get(Te)??o.CompletionItemKind.Property}we.to=De})(ze||(e.CompletionItemKind=ze={}));var z;(function(we){function Fe(oe,Q){const De=new o.$GM(oe.label);return De.insertText=oe.insertText,De.kind=ze.to(oe.kind),De.tags=oe.tags?.map(Ae.to),De.detail=oe.detail,De.documentation=R.$zk(oe.documentation)?O.to(oe.documentation):oe.documentation,De.sortText=oe.sortText,De.filterText=oe.filterText,De.preselect=oe.preselect,De.commitCharacters=oe.commitCharacters,s.$0s.isIRange(oe.range)?De.range=b.to(oe.range):typeof oe.range=="object"&&(De.range={inserting:b.to(oe.range.insert),replacing:b.to(oe.range.replace)}),De.keepWhitespace=typeof oe.insertTextRules>"u"?!1:!!(oe.insertTextRules&1),typeof oe.insertTextRules<"u"&&oe.insertTextRules&4?De.insertText=new o.$kM(oe.insertText):(De.insertText=oe.insertText,De.textEdit=De.range instanceof o.$bM?new o.$gM(De.range,De.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(De.additionalTextEdits=oe.additionalTextEdits.map(Te=>ve.to(Te))),De.command=Q&&oe.command?Q.fromInternal(oe.command):void 0,De}we.to=Fe})(z||(e.CompletionItem=z={}));var j;(function(we){function Fe(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:O.fromStrict(Q.documentation)}}we.from=Fe;function oe(Q){return{label:Q.label,documentation:R.$zk(Q.documentation)?O.to(Q.documentation):Q.documentation}}we.to=oe})(j||(e.ParameterInformation=j={}));var K;(function(we){function Fe(Q){return{label:Q.label,documentation:O.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(j.from):[],activeParameter:Q.activeParameter}}we.from=Fe;function oe(Q){return{label:Q.label,documentation:R.$zk(Q.documentation)?O.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(j.to):[],activeParameter:Q.activeParameter}}we.to=oe})(K||(e.SignatureInformation=K={}));var H;(function(we){function Fe(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(K.from):[]}}we.from=Fe;function oe(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(K.to):[]}}we.to=oe})(H||(e.SignatureHelp=H={}));var ee;(function(we){function Fe(oe,Q){const De=new o.$FM(h.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(se.to.bind(void 0,oe)),Q.kind&&Ne.to(Q.kind));return De.textEdits=Q.textEdits&&Q.textEdits.map(ve.to),De.tooltip=R.$zk(Q.tooltip)?O.to(Q.tooltip):Q.tooltip,De.paddingLeft=Q.paddingLeft,De.paddingRight=Q.paddingRight,De}we.to=Fe})(ee||(e.InlayHint=ee={}));var se;(function(we){function Fe(oe,Q){const De=new o.$EM(Q.label);return De.tooltip=R.$zk(Q.tooltip)?O.to(Q.tooltip):Q.tooltip,a.Command.is(Q.command)&&(De.command=oe.fromInternal(Q.command)),Q.location&&(De.location=Ee.to(Q.location)),De}we.to=Fe})(se||(e.InlayHintLabelPart=se={}));var Ne;(function(we){function Fe(Q){return Q}we.from=Fe;function oe(Q){return Q}we.to=oe})(Ne||(e.InlayHintKind=Ne={}));var Ve;(function(we){function Fe(Q){return{range:b.from(Q.range),url:Q.target,tooltip:Q.tooltip}}we.from=Fe;function oe(Q){let De;if(Q.url)try{De=typeof Q.url=="string"?g.URI.parse(Q.url,!0):g.URI.revive(Q.url)}catch{}return new o.$LM(b.to(Q.range),De)}we.to=oe})(Ve||(e.DocumentLink=Ve={}));var He;(function(we){function Fe(Q){const De=new o.$OM(Q.label);return Q.textEdit&&(De.textEdit=ve.to(Q.textEdit)),Q.additionalTextEdits&&(De.additionalTextEdits=Q.additionalTextEdits.map(Te=>ve.to(Te))),De}we.to=Fe;function oe(Q){return{label:Q.label,textEdit:Q.textEdit?ve.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(De=>ve.from(De)):void 0}}we.from=oe})(He||(e.ColorPresentation=He={}));var xe;(function(we){function Fe(Q){return new o.$MM(Q[0],Q[1],Q[2],Q[3])}we.to=Fe;function oe(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}we.from=oe})(xe||(e.Color=xe={}));var tt;(function(we){function Fe(Q){return{range:b.from(Q.range)}}we.from=Fe;function oe(Q){return new o.$vM(b.to(Q.range))}we.to=oe})(tt||(e.SelectionRange=tt={}));var lt;(function(we){function Fe(oe){switch(oe){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}we.to=Fe})(lt||(e.TextDocumentSaveReason=lt={}));var rt;(function(we){function Fe(Q){switch(Q){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.Interval:return 3;case o.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Fe;function oe(Q){switch(Q){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 3:return o.TextEditorLineNumbersStyle.Interval;case 1:default:return o.TextEditorLineNumbersStyle.On}}we.to=oe})(rt||(e.TextEditorLineNumbersStyle=rt={}));var it;(function(we){function Fe(Q){if(Q===o.EndOfLine.CRLF)return 1;if(Q===o.EndOfLine.LF)return 0}we.from=Fe;function oe(Q){if(Q===1)return o.EndOfLine.CRLF;if(Q===0)return o.EndOfLine.LF}we.to=oe})(it||(e.EndOfLine=it={}));var ot;(function(we){function Fe(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Fe})(ot||(e.ProgressLocation=ot={}));var Be;(function(we){function Fe(Q){const De={start:Q.start+1,end:Q.end+1};return Q.kind&&(De.kind=et.from(Q.kind)),De}we.from=Fe;function oe(Q){const De={start:Q.start-1,end:Q.end-1};return Q.kind&&(De.kind=et.to(Q.kind)),De}we.to=oe})(Be||(e.FoldingRange=Be={}));var et;(function(we){function Fe(Q){if(Q)switch(Q){case o.FoldingRangeKind.Comment:return a.$1t.Comment;case o.FoldingRangeKind.Imports:return a.$1t.Imports;case o.FoldingRangeKind.Region:return a.$1t.Region}}we.from=Fe;function oe(Q){if(Q)switch(Q.value){case a.$1t.Comment.value:return o.FoldingRangeKind.Comment;case a.$1t.Imports.value:return o.FoldingRangeKind.Imports;case a.$1t.Region.value:return o.FoldingRangeKind.Region}}we.to=oe})(et||(e.FoldingRangeKind=et={}));var X;(function(we){function Fe(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?b.from(oe.selection):void 0,override:typeof oe.override=="boolean"?n.$WE.id:void 0}}we.from=Fe})(X||(e.TextEditorOpenOptions=X={}));var Z;(function(we){function Fe(Te){return Te instanceof o.$9M?Te.toJSON():typeof Te=="string"?Te:oe(Te)||Q(Te)?new o.$9M(Te.baseUri??Te.base,Te.pattern).toJSON():Te}we.from=Fe;function oe(Te){const Xe=Te;return Xe?g.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function Q(Te){const Xe=Te;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function De(Te){return typeof Te=="string"?Te:new o.$9M(g.URI.revive(Te.baseUri),Te.pattern)}we.to=De})(Z||(e.GlobPattern=Z={}));var pe;(function(we){function Fe(oe){if(oe){if(Array.isArray(oe))return oe.map(Fe);if(typeof oe=="string")return oe;{const Q=oe;return{language:Q.language,scheme:Q.scheme,pattern:Z.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}we.from=Fe})(pe||(e.LanguageSelector=pe={}));var We;(function(we){function Fe(Q){return!!Q&&typeof Q=="object"&&"documents"in Q&&Array.isArray(Q.documents)&&Q.documents.every(De=>Array.isArray(De)&&De.every(Te=>Te&&typeof Te=="object"&&"uri"in Te&&g.URI.isUri(Te.uri)&&"version"in Te&&typeof Te.version=="number"&&"ranges"in Te&&Array.isArray(Te.ranges)&&Te.ranges.every(Xe=>Xe instanceof o.$bM)))}we.is=Fe;function oe(Q){return{documents:Q.documents.map(De=>De.map(Te=>({uri:g.URI.from(Te.uri),version:Te.version,ranges:Te.ranges.map(Xe=>b.from(Xe))})))}}we.from=oe})(We||(e.MappedEditsContext=We={}));var Ze;(function(we){function Fe(Q){return{start:Q.start,end:Q.end}}we.from=Fe;function oe(Q){return new o.$zN(Q.start,Q.end)}we.to=oe})(Ze||(e.NotebookRange=Ze={}));var st;(function(we){function Fe(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}we.to=Fe;function oe(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}we.from=oe})(st||(e.NotebookCellExecutionSummary=st={}));var Me;(function(we){function Fe(oe){if(oe===c.NotebookCellExecutionState.Unconfirmed)return o.NotebookCellExecutionState.Pending;if(oe===c.NotebookCellExecutionState.Pending)return;if(oe===c.NotebookCellExecutionState.Executing)return o.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${oe}`)}we.to=Fe})(Me||(e.NotebookCellExecutionState=Me={}));var Dt;(function(we){function Fe(Q){switch(Q){case o.NotebookCellKind.Markup:return c.CellKind.Markup;case o.NotebookCellKind.Code:default:return c.CellKind.Code}}we.from=Fe;function oe(Q){switch(Q){case c.CellKind.Markup:return o.NotebookCellKind.Markup;case c.CellKind.Code:default:return o.NotebookCellKind.Code}}we.to=oe})(Dt||(e.NotebookCellKind=Dt={}));var Qt;(function(we){function Fe(Q){const De={metadata:Q.metadata??Object.create(null),cells:[]};for(const Te of Q.cells)o.$AN.validate(Te),De.cells.push(jt.from(Te));return De}we.from=Fe;function oe(Q){const De=new o.$BN(Q.cells.map(jt.to));return(0,k.$7f)(Q.metadata)||(De.metadata=Q.metadata),De}we.to=oe})(Qt||(e.NotebookData=Qt={}));var jt;(function(we){function Fe(Q){return{cellKind:Dt.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:st.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(Vt.from):[]}}we.from=Fe;function oe(Q){return new o.$AN(Dt.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(Vt.to):void 0,Q.metadata,Q.internalMetadata?st.to(Q.internalMetadata):void 0)}we.to=oe})(jt||(e.NotebookCellData=jt={}));var si;(function(we){function Fe(Q){return{mime:Q.mime,valueBytes:M.$te.wrap(Q.data)}}we.from=Fe;function oe(Q){return new o.$CN(Q.valueBytes.buffer,Q.mime)}we.to=oe})(si||(e.NotebookCellOutputItem=si={}));var Vt;(function(we){function Fe(Q){return{outputId:Q.id,items:Q.items.map(si.from),metadata:Q.metadata}}we.from=Fe;function oe(Q){const De=Q.items.map(si.to);return new o.$DN(De,Q.outputId,Q.metadata)}we.to=oe})(Vt||(e.NotebookCellOutput=Vt={}));var St;(function(we){function Fe(De){return Q(De)?{include:Z.from(De.include)??void 0,exclude:Z.from(De.exclude)??void 0}:Z.from(De)??void 0}we.from=Fe;function oe(De){return Q(De)?{include:Z.to(De.include),exclude:Z.to(De.exclude)}:Z.to(De)}we.to=oe;function Q(De){const Te=De;return Te?!(0,k.$3f)(Te.include)&&!(0,k.$3f)(Te.exclude):!1}})(St||(e.NotebookExclusiveDocumentPattern=St={}));var Yt;(function(we){function Fe(oe,Q,De){const Te=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Te,De),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}we.from=Fe})(Yt||(e.NotebookStatusBarItem=Yt={}));var Wt;(function(we){function Fe(oe,Q,De){const Te=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{command:Q.toInternal(Te,De),label:oe.label,description:oe.description,detail:oe.detail,documentation:oe.documentation}}we.from=Fe})(Wt||(e.NotebookKernelSourceAction=Wt={}));var oi;(function(we){function Fe(oe){return{transientOutputs:oe?.transientOutputs??!1,transientCellMetadata:oe?.transientCellMetadata??{},transientDocumentMetadata:oe?.transientDocumentMetadata??{},cellContentMetadata:oe?.cellContentMetadata??{}}}we.from=Fe})(oi||(e.NotebookDocumentContentOptions=oi={}));var xt;(function(we){function Fe(Q){return{uri:Q.uri,provides:Q.provides}}we.from=Fe;function oe(Q){return new o.$FN(g.URI.revive(Q.uri),Q.provides)}we.to=oe})(xt||(e.NotebookRendererScript=xt={}));var Ye;(function(we){function Fe(Q){return{message:O.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,contextValue:Q.contextValue,location:Q.location&&{range:b.from(Q.location.range),uri:Q.location.uri}}}we.from=Fe;function oe(Q){const De=new o.$LN(typeof Q.message=="string"?Q.message:O.to(Q.message));return De.actualOutput=Q.actual,De.expectedOutput=Q.expected,De.contextValue=Q.contextValue,De.location=Q.location?Ee.to(Q.location):void 0,De}we.to=oe})(Ye||(e.TestMessage=Ye={}));var Ot;(function(we){we.namespace=t.$4K,we.denamespace=t.$5K})(Ot||(e.TestTag=Ot={}));var _t;(function(we){function Fe(Q){const De=(0,i.$lO)(Q).controllerId;return{extId:d.$ZK.fromExtHostTestItem(Q,De).toString(),label:Q.label,uri:g.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(Te=>Ot.namespace(De,Te.id)),range:s.$0s.lift(b.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&O.fromStrict(Q.error)||null}}we.from=Fe;function oe(Q){return{parent:void 0,error:void 0,id:d.$ZK.fromString(Q.extId).localId,label:Q.label,uri:g.URI.revive(Q.uri),tags:(Q.tags||[]).map(De=>{const{tagId:Te}=Ot.denamespace(De);return new o.$MN(Te)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:b.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}we.toPlain=oe})(_t||(e.TestItem=_t={})),function(we){function Fe(Q){return{id:Q.id}}we.from=Fe;function oe(Q){return new o.$MN(Q.id)}we.to=oe}(Ot||(e.TestTag=Ot={}));var dt;(function(we){const Fe=(Q,De)=>{const Te=[];for(const[Ge,ct]of De)d.$ZK.compare(ct.item.extId,Ge)===2&&(De.delete(Ge),Te.push(ct));const Xe={..._t.toPlain(Q.item),parent:void 0,taskStates:Q.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(ct=>ct.type===0).map(Ye.to)})),children:Te.map(Ge=>Fe(Ge,De))};for(const Ge of Xe.children)Ge.parent=Xe;return Xe};function oe(Q){const De=[],Te=new Map;for(const Xe of Q.items){Te.set(Xe.item.extId,Xe);const Ge=d.$ZK.root(Xe.item.extId);Q.request.targets.some(ct=>ct.controllerId===Ge&&ct.testIds.includes(Xe.item.extId))&&De.push(Xe)}return{completedAt:Q.completedAt,results:De.map(Xe=>Fe(Xe,Te))}}we.to=oe})(dt||(e.TestResults=dt={}));var $t;(function(we){function Fe(Te){return{covered:Te.covered,total:Te.total}}function oe(Te){return"line"in Te?h.from(Te):b.from(Te)}function Q(Te){return"branches"in Te?{count:Te.executed,location:oe(Te.location),type:1,branches:Te.branches.length?Te.branches.map(Xe=>({count:Xe.executed,location:Xe.location&&oe(Xe.location),label:Xe.label})):void 0}:{type:0,name:Te.name,count:Te.executed,location:oe(Te.location)}}we.fromDetailed=Q;function De(Te){return{uri:Te.uri,statement:Fe(Te.statementCoverage),branch:Te.branchCoverage&&Fe(Te.branchCoverage),declaration:Te.declarationCoverage&&Fe(Te.declarationCoverage),details:Te.detailedCoverage?.map(Q)}}we.fromFile=De})($t||(e.TestCoverage=$t={}));var ei;(function(we){function Fe(oe){switch(oe){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}we.to=Fe})(ei||(e.CodeActionTriggerKind=ei={}));var qt;(function(we){function Fe(Q){const De=new o.$SN($e.to(Q.kind),Q.name,Q.detail||"",g.URI.revive(Q.uri),b.to(Q.range),b.to(Q.selectionRange));return De._sessionId=Q._sessionId,De._itemId=Q._itemId,De}we.to=Fe;function oe(Q,De,Te){if(De=De??Q._sessionId,Te=Te??Q._itemId,De===void 0||Te===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Te,kind:$e.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:b.from(Q.range),selectionRange:b.from(Q.selectionRange),tags:Q.tags?.map(ie.from)}}we.from=oe})(qt||(e.TypeHierarchyItem=qt={}));var Ht;(function(we){function Fe(oe){if(oe)return{value:oe.value,tooltip:oe.tooltip}}we.from=Fe})(Ht||(e.ViewBadge=Ht={}));var ht;(function(we){function Fe(Te,Xe,Ge){const ct=Xe.fileData;return ct?new o.$2M(new o.$3M(ct.name,g.URI.revive(ct.uri),ct.id,(0,F.$db)(()=>Ge(ct.id)))):Te===N.$us.uriList&&Xe.uriListData?new o.$1M(De(Xe.uriListData)):new o.$1M(Xe.asString)}we.to=Fe;async function oe(Te,Xe){const Ge=await Xe.asString();if(Te===N.$us.uriList)return{asString:Ge,fileData:void 0,uriListData:Q(Ge)};const ct=Xe.asFile();return{asString:Ge,fileData:ct?{name:ct.name,uri:ct.uri,id:ct._itemId??ct.id}:void 0}}we.from=oe;function Q(Te){return P.$Gt.split(Te).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return g.URI.parse(Xe)}catch{}return Xe})}function De(Te){return P.$Gt.create(Te.map(Xe=>typeof Xe=="string"?Xe:g.URI.revive(Xe)))}})(ht||(e.DataTransferItem=ht={}));var Mt;(function(we){function Fe(Q,De){const Te=Q.items.map(([Xe,Ge])=>[Xe,ht.to(Xe,Ge,De)]);return new o.$4M(Te)}we.toDataTransfer=Fe;async function oe(Q){const De={items:[]},Te=[];for(const[Xe,Ge]of Q)Te.push((async()=>{De.items.push([Xe,await ht.from(Xe,Ge)])})());return await Promise.all(Te),De}we.from=oe})(Mt||(e.DataTransfer=Mt={}));var ti;(function(we){function Fe(Q,De){return{kind:"reply",agentId:Q.participant??De?.agentId??"",subCommand:Q.command??De?.command,message:Q.prompt,title:Q.label}}we.from=Fe;function oe(Q){return{prompt:Q.message,label:Q.title,participant:Q.agentId,command:Q.subCommand}}we.to=oe})(ti||(e.ChatFollowup=ti={}));var ii;(function(we){function Fe(oe){return"commandId"in oe?{kind:"command",title:oe.title??"",commandId:oe.commandId??"",when:oe.when??"",args:oe.args}:{kind:"reply",message:oe.message,title:oe.title,tooltip:oe.tooltip}}we.from=Fe})(ii||(e.ChatInlineFollowup=ii={}));var Ke;(function(we){function Fe(Q){switch(Q.role){case 0:return new o.$aO(Q.content);case 1:return new o.$bO(Q.content);case 2:return new o.$cO(Q.content)}}we.to=Fe;function oe(Q){if(Q instanceof o.$aO)return{role:0,content:Q.content};if(Q instanceof o.$bO)return{role:1,content:Q.content};if(Q instanceof o.$cO)return{role:2,content:Q.content};throw new Error("Invalid LanguageModelMessage")}we.from=oe})(Ke||(e.LanguageModelMessage=Ke={}));var Nt;(function(we){function Fe(De){const Te={};for(const Xe of Object.keys(De))Te[Xe]=De[Xe].map(we.to);return Te}we.objectTo=Fe;function oe(De){return{level:zt.to(De.level),kind:De.kind,value:(0,g.$vc)(De.value)?g.URI.revive(De.value):De.value,description:De.description}}we.to=oe;function Q(De){return{level:zt.from(De.level),kind:De.kind,value:De.value,description:De.description}}we.from=Q})(Nt||(e.ChatVariable=Nt={}));var zt;(function(we){function Fe(Q){switch(Q){case"short":return o.ChatVariableLevel.Short;case"medium":return o.ChatVariableLevel.Medium;case"full":default:return o.ChatVariableLevel.Full}}we.to=Fe;function oe(Q){switch(Q){case o.ChatVariableLevel.Short:return"short";case o.ChatVariableLevel.Medium:return"medium";case o.ChatVariableLevel.Full:default:return"full"}}we.from=oe})(zt||(e.ChatVariableLevel=zt={}));var Zt;(function(we){function Fe(oe){switch(oe){case 1:return o.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return o.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return o.InteractiveEditorResponseFeedbackKind.Undone;case 3:return o.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return o.InteractiveEditorResponseFeedbackKind.Bug}}we.to=Fe})(Zt||(e.InteractiveEditorResponseFeedbackKind=Zt={}));var mt;(function(we){function Fe(Q){return{kind:"markdownContent",content:O.from(Q.value)}}we.to=Fe;function oe(Q){return new o.$5N(O.to(Q.content))}we.from=oe})(mt||(e.ChatResponseMarkdownPart=mt={}));var It;(function(we){function Fe(Q){const{value:De,baseUri:Te}=Q;function Xe(Ge,ct){return Ge.map(yt=>{const Gt=g.URI.joinPath(ct,yt.name);return{label:yt.name,uri:Gt,children:yt.children&&Xe(yt.children,Gt)}})}return{kind:"treeData",treeData:{label:(0,l.$Qg)(Te),uri:Te,children:Xe(De,Te)}}}we.to=Fe;function oe(Q){const De=(0,E.$Ph)(Q.treeData);function Te(ct){return ct.map(yt=>({name:yt.label,children:yt.children&&Te(yt.children)}))}const Xe=De.uri,Ge=De.children?Te(De.children):[];return new o.$6N(Ge,Xe)}we.from=oe})(It||(e.ChatResponseFilesPart=It={}));var Ct;(function(we){function Fe(Q){return{kind:"inlineReference",name:Q.title,inlineReference:g.URI.isUri(Q.value)?Q.value:$.from(Q.value)}}we.to=Fe;function oe(Q){const De=(0,E.$Ph)(Q);return new o.$7N(g.URI.isUri(De.inlineReference)?De.inlineReference:$.to(De.inlineReference),Q.name)}we.from=oe})(Ct||(e.ChatResponseAnchorPart=Ct={}));var Lt;(function(we){function Fe(Q){return{kind:"progressMessage",content:O.from(Q.value)}}we.to=Fe;function oe(Q){return new o.$8N(Q.content.value)}we.from=oe})(Lt||(e.ChatResponseProgressPart=Lt={}));var ai;(function(we){function Fe(Q,De,Te){return{kind:"command",command:De.toInternal(Q.value,Te)??{command:Q.value.command,title:Q.value.title}}}we.to=Fe;function oe(Q,De){return new o.$9N(De.fromInternal(Q.command)??{command:Q.command.id,title:Q.command.title})}we.from=oe})(ai||(e.ChatResponseCommandButtonPart=ai={}));var Ut;(function(we){function Fe(Q){return{kind:"reference",reference:g.URI.isUri(Q.value)?Q.value:$.from(Q.value)}}we.to=Fe;function oe(Q){const De=(0,E.$Ph)(Q);return new o.$0N(g.URI.isUri(De.reference)?De.reference:$.to(De.reference))}we.from=oe})(Ut||(e.ChatResponseReferencePart=Ut={}));var Xt;(function(we){function Fe(De){return De instanceof o.$5N?mt.to(De):De instanceof o.$7N?Ct.to(De):De instanceof o.$0N?Ut.to(De):De instanceof o.$8N?Lt.to(De):De instanceof o.$6N?It.to(De):{kind:"content",content:""}}we.to=Fe;function oe(De,Te){switch(De.kind){case"reference":return Ut.from(De);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Q(De,Te)}}we.from=oe;function Q(De,Te){switch(De.kind){case"markdownContent":return mt.from(De);case"inlineReference":return Ct.from(De);case"progressMessage":return;case"treeData":return It.from(De);case"command":return ai.from(De,Te)}}we.fromContent=Q})(Xt||(e.ChatResponsePart=Xt={}));var bt;(function(we){function Fe(De,Te){return"markdownContent"in Te?((0,u.$1F)(De,"chatParticipantAdditions"),{content:O.from(Te.markdownContent),kind:"markdownContent"}):"content"in Te?"vulnerabilities"in Te&&Te.vulnerabilities?((0,u.$1F)(De,"chatParticipantAdditions"),{content:Te.content,vulnerabilities:Te.vulnerabilities,kind:"vulnerability"}):typeof Te.content=="string"?{content:Te.content,kind:"content"}:((0,u.$1F)(De,"chatParticipantAdditions"),{content:O.from(Te.content),kind:"markdownContent"}):"documents"in Te?{documents:Te.documents.map(Xe=>({uri:Xe.uri,version:Xe.version,ranges:Xe.ranges.map(Ge=>b.from(Ge))})),kind:"usedContext"}:"reference"in Te?{reference:"uri"in Te.reference?{uri:Te.reference.uri,range:b.from(Te.reference.range)}:Te.reference,kind:"reference"}:"inlineReference"in Te?{inlineReference:"uri"in Te.inlineReference?{uri:Te.inlineReference.uri,range:b.from(Te.inlineReference.range)}:Te.inlineReference,name:Te.title,kind:"inlineReference"}:"participant"in Te?((0,u.$1F)(De,"chatParticipantAdditions"),{agentName:Te.participant,command:Te.command,kind:"agentDetection"}):"message"in Te?{content:O.from(Te.message),kind:"progressMessage"}:void 0}we.from=Fe;function oe(De){switch(De.kind){case"markdownContent":case"inlineReference":case"treeData":return we.to(De);case"content":return{content:De.content};case"usedContext":return{documents:De.documents.map(Te=>({uri:g.URI.revive(Te.uri),version:Te.version,ranges:Te.ranges.map(Xe=>b.to(Xe))}))};case"reference":return{reference:(0,g.$vc)(De.reference)?g.URI.revive(De.reference):$.to(De.reference)};case"agentDetection":return;case"progressMessage":return{message:De.content.value};case"vulnerability":return{content:De.content,vulnerabilities:De.vulnerabilities};default:return}}we.to=oe;function Q(De,Te){switch(De.kind){case"markdownContent":return{content:De.content.value};case"inlineReference":return{inlineReference:(0,g.$vc)(De.inlineReference)?g.URI.revive(De.inlineReference):$.to(De.inlineReference),title:De.name};case"command":return{command:Te.fromInternal(De.command)??{command:De.command.id,title:De.command.title}};default:return}}we.toProgressContent=Q})(bt||(e.ChatResponseProgress=bt={}));var Ft;(function(we){function Fe(oe){return{prompt:oe.message,command:oe.command,variables:oe.variables.variables.map(Bt.to)}}we.to=Fe})(Ft||(e.ChatAgentRequest=Ft={}));var Bt;(function(we){function Fe(oe){return{name:oe.name,range:[oe.range.start,oe.range.endExclusive],values:oe.values.map(Nt.to)}}we.to=Fe})(Bt||(e.ChatAgentResolvedVariable=Bt={}));var Tt;(function(we){function Fe(oe){return{label:oe.label,values:oe.values.map(Nt.from),insertText:oe.insertText,detail:oe.detail,documentation:oe.documentation}}we.from=Fe})(Tt||(e.ChatAgentCompletionItem=Tt={}));var wt;(function(we){function Fe(oe){return{errorDetails:oe.errorDetails,metadata:oe.metadata}}we.to=Fe})(wt||(e.ChatAgentResult=wt={}));var Pt;(function(we){function Fe(oe,Q,De){if(Q.action.kind==="vote")return;const Te=wt.to(oe);return Q.action.kind==="command"?{action:{kind:"command",commandButton:bt.toProgressContent(Q.action.commandButton,De)},result:Te}:Q.action.kind==="followUp"?{action:{kind:"followUp",followup:ti.to(Q.action.followup)},result:Te}:{action:Q.action,result:Te}}we.to=Fe})(Pt||(e.ChatAgentUserActionEvent=Pt={}));var kt;(function(we){function Fe(oe,Q,De){return"terminalCommand"in oe?{terminalCommand:oe.terminalCommand,shouldExecute:oe.shouldExecute}:"uri"in oe?{uri:oe.uri}:Q.toInternal(oe,De)}we.from=Fe})(kt||(e.TerminalQuickFix=kt={}));var li;(function(we){function Fe(oe){return{kind:Kt.to(oe.kind)}}we.to=Fe})(li||(e.PartialAcceptInfo=li={}));var Kt;(function(we){function Fe(oe){switch(oe){case 0:return o.PartialAcceptTriggerKind.Word;case 1:return o.PartialAcceptTriggerKind.Line;case 2:return o.PartialAcceptTriggerKind.Suggest;default:return o.PartialAcceptTriggerKind.Unknown}}we.to=Fe})(Kt||(e.PartialAcceptTriggerKind=Kt={}));var ni;(function(we){function Fe(oe,Q){return{id:Q,label:oe.label,description:oe.description,canEdit:oe.canEdit,collapsibleState:oe.collapsibleState||0,contextValue:oe.contextValue}}we.from=Fe})(ni||(e.DebugTreeItem=ni={}))}),define(Pe[248],Re([1,0,4,17,8]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=void 0;let F=class{constructor(m,f){this.a=m.getProxy(S.$0L.MainThreadBulkEdits),this.b={getTextDocumentVersion:E=>f.getDocument(E)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,f,E){const N=P.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(N,void 0,E?.isRefactoring??!1)}};e.$oic=F,e.$oic=F=Qe([qe(0,M.$pO)],F)}),define(Pe[249],Re([1,0,18,11,41,5,51,6,64,16,2,160,20,4,8,7,209,22]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g,s,a,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qic=void 0;class i{constructor(t,p,u,o,v,b){this.i=t,this.j=p,this.k=u,this.l=o,this.m=v,this.n=b,this.b=f.$2d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let p=function(o){if(t.c){const v=new Error("Response stream has been closed");throw Error.captureStackTrace(v,o),v}};const t=this;this.b.reset();const u=o=>{typeof this.d>"u"&&"content"in o&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,o)};this.g={markdown(o){p(this.markdown);const v=new s.$5N(o),b=g.ChatResponseMarkdownPart.to(v);return u(b),this},filetree(o,v){p(this.filetree);const b=new s.$6N(o,v),$=g.ChatResponseFilesPart.to(b);return u($),this},anchor(o,v){p(this.anchor);const b=new s.$7N(o,v),$=g.ChatResponseAnchorPart.to(b);return u($),this},button(o){p(this.anchor);const v=new s.$9N(o),b=g.ChatResponseCommandButtonPart.to(v,t.m,t.n);return u(b),this},progress(o){p(this.progress);const v=new s.$8N(o),b=g.ChatResponseProgressPart.to(v);return u(b),this},reference(o){p(this.reference);const v=new s.$0N(o),b=g.ChatResponseReferencePart.to(v);return u(b),this},push(o){p(this.push);const v=g.ChatResponsePart.to(o);return u(v),this},report(o){if(p(this.report),"placeholder"in o&&"resolvedContent"in o)return;const v=g.ChatResponseProgress.from(t.i,o);if(!v){t.l.error("Unknown progress type: "+JSON.stringify(o));return}return u(v),this}}}return this.g}}class n{static{this.b=0}constructor(t,p,u){this.i=p,this.j=u,this.c=new Map,this.g=new m.$3c,this.d=t.getProxy(k.$0L.MainThreadChatAgents2)}createChatAgent(t,p,u){const o=n.b++,v=new c(t,p,this.d,o,u);return this.c.set(o,v),this.d.$registerAgent(o,t.identifier,p,{},(0,r.$ZF)(t,"chatParticipantAdditions")),v.apiAgent}async $invokeAgent(t,p,u,o){const v=this.c.get(t);if(!v)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let b=this.g.get(p.sessionId);b||(b=new m.$Sc,this.g.set(p.sessionId,b));const $=new i(v.extension,p,this.d,this.i,this.j.converter,b);try{const I=await this.k(p.agentId,u),h=v.invoke(g.ChatAgentRequest.to(p),{history:I},$.apiObject,o);return await(0,M.$7g)(Promise.resolve(h).then(y=>{if(y?.metadata)try{JSON.stringify(y.metadata)}catch(w){const A=`result.metadata MUST be JSON.stringify-able. Got error: ${w.message}`;return this.i.error(`[${v.extension.identifier.value}] [@${v.id}] ${A}`,v.extension),{errorDetails:{message:A},timings:$.timings}}return{errorDetails:y?.errorDetails,timings:$.timings,metadata:y?.metadata}}),o)}catch(I){return this.i.error(I,v.extension),{errorDetails:{message:(0,D.localize)(0,null,(0,P.$4i)(I)),responseIsIncomplete:!0}}}finally{$.close()}}async k(t,p){const u=[];for(const o of p.history){const v=g.ChatAgentResult.to(o.result),b=t===o.request.agentId?v:{...v,metadata:void 0};u.push(new s.$$N(o.request.message,o.request.command,o.request.variables.variables.map(g.ChatAgentResolvedVariable.to),{extensionId:"",name:o.request.agentId}));const $=(0,S.$Hb)(o.response.map(I=>g.ChatResponsePart.fromContent(I,this.j.converter)));u.push(new s.$_N($,b,{extensionId:"",name:o.request.agentId},o.request.command))}return u}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,p,u,o,v){const b=this.c.get(p);if(!b)return Promise.resolve([]);const $=await this.k(b.id,o),I=g.ChatAgentResult.to(u);return(await b.provideFollowups(I,{history:$},v)).filter(h=>{const y=!h.participant||R.Iterable.some(this.c.values(),w=>w.id===h.participant&&l.$Am.equals(w.extension.identifier,b.extension.identifier));return y||this.i.warn(`[@${b.id}] ChatFollowup refers to an unknown participant: ${h.participant}`),y}).map(h=>g.ChatFollowup.from(h,t))}$acceptFeedback(t,p,u,o){const v=this.c.get(t);if(!v)return;const b=g.ChatAgentResult.to(p);let $;switch(u){case a.InteractiveSessionVoteDirection.Down:$=s.ChatResultFeedbackKind.Unhelpful;break;case a.InteractiveSessionVoteDirection.Up:$=s.ChatResultFeedbackKind.Helpful;break}v.acceptFeedback(Object.freeze(o?{result:b,kind:$,reportIssue:o}:{result:b,kind:$}))}$acceptAction(t,p,u){const o=this.c.get(t);if(!o||u.action.kind==="vote")return;const v=g.ChatAgentUserActionEvent.to(p,u,this.j.converter);v&&o.acceptAction(Object.freeze(v))}async $invokeCompletionProvider(t,p,u){const o=this.c.get(t);return o?(await o.invokeCompletionProvider(p,u)).map(g.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,p){const u=this.c.get(t);if(u)return await u.provideWelcomeMessage(p)}async $provideSampleQuestions(t,p){const u=this.c.get(t);if(u)return(await u.provideSampleQuestions(p)).map(o=>g.ChatFollowup.from(o,void 0))}}e.$qic=n;class c{constructor(t,p,u,o,v){this.extension=t,this.id=p,this.x=u,this.y=o,this.z=v,this.o=new F.$6d,this.p=new F.$6d}acceptFeedback(t){this.o.fire(t)}acceptAction(t){this.p.fire(t)}async invokeCompletionProvider(t,p){return this.s?await this.s.provider.provideCompletionItems(t,p)??[]:[]}async provideFollowups(t,p,u){if(!this.b)return[];const o=await this.b.provideFollowups(t,p,u);return o?o.filter(v=>!(v&&"commandId"in v)).filter(v=>!(v&&"message"in v)):[]}async provideWelcomeMessage(t){if(!this.t)return[];const p=await this.t.provideWelcomeMessage(t);return p?p.map(u=>typeof u=="string"?u:g.MarkdownString.from(u)):[]}async provideSampleQuestions(t){if(!this.t||!this.t.provideSampleQuestions)return[];const p=await this.t.provideSampleQuestions(t);return p||[]}get apiAgent(){let t=!1,p=!1;const u=()=>{t||p||(p=!0,queueMicrotask(()=>{this.x.$updateAgent(this.y,{description:this.c,fullName:this.d,icon:this.g?this.g instanceof N.URI?this.g:"light"in this.g?this.g.light:void 0:void 0,iconDark:this.g&&"dark"in this.g?this.g.dark:void 0,themeIcon:this.g instanceof s.$7M?this.g:void 0,hasFollowups:this.b!==void 0,isSecondary:this.n,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:g.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:g.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:g.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.q,isSticky:this.u,requester:this.w}),p=!1}))},o=this;return{get name(){return o.id},get description(){return o.c??""},set description(v){o.c=v,u()},get fullName(){return(0,r.$1F)(o.extension,"defaultChatParticipant"),o.d??o.extension.displayName??o.extension.name},set fullName(v){(0,r.$1F)(o.extension,"defaultChatParticipant"),o.d=v,u()},get iconPath(){return o.g},set iconPath(v){o.g=v,u()},get requestHandler(){return o.z},set requestHandler(v){(0,E.$4f)(typeof v=="function","Invalid request handler"),o.z=v},get followupProvider(){return o.b},set followupProvider(v){o.b=v,u()},get isDefault(){return(0,r.$1F)(o.extension,"defaultChatParticipant"),o.i},set isDefault(v){(0,r.$1F)(o.extension,"defaultChatParticipant"),o.i=v,u()},get helpTextPrefix(){return(0,r.$1F)(o.extension,"defaultChatParticipant"),o.j},set helpTextPrefix(v){(0,r.$1F)(o.extension,"defaultChatParticipant"),o.j=v,u()},get helpTextVariablesPrefix(){return(0,r.$1F)(o.extension,"defaultChatParticipant"),o.k},set helpTextVariablesPrefix(v){(0,r.$1F)(o.extension,"defaultChatParticipant"),o.k=v,u()},get helpTextPostfix(){return(0,r.$1F)(o.extension,"defaultChatParticipant"),o.l},set helpTextPostfix(v){(0,r.$1F)(o.extension,"defaultChatParticipant"),o.l=v,u()},get isSecondary(){return(0,r.$1F)(o.extension,"defaultChatParticipant"),o.n},set isSecondary(v){(0,r.$1F)(o.extension,"defaultChatParticipant"),o.n=v,u()},get sampleRequest(){return o.m},set sampleRequest(v){o.m=v,u()},get supportIssueReporting(){return(0,r.$1F)(o.extension,"chatParticipantAdditions"),o.q},set supportIssueReporting(v){(0,r.$1F)(o.extension,"chatParticipantAdditions"),o.q=v,u()},get onDidReceiveFeedback(){return o.o.event},set participantVariableProvider(v){if((0,r.$1F)(o.extension,"chatParticipantAdditions"),o.s=v,v){if(!v.triggerCharacters.length)throw new Error("triggerCharacters are required");o.x.$registerAgentCompletionsProvider(o.y,v.triggerCharacters)}else o.x.$unregisterAgentCompletionsProvider(o.y)},get participantVariableProvider(){return(0,r.$1F)(o.extension,"chatParticipantAdditions"),o.s},set welcomeMessageProvider(v){(0,r.$1F)(o.extension,"defaultChatParticipant"),o.t=v,u()},get welcomeMessageProvider(){return(0,r.$1F)(o.extension,"defaultChatParticipant"),o.t},onDidPerformAction:(0,r.$ZF)(this.extension,"chatParticipantAdditions")?this.p.event:void 0,get isSticky(){return o.u},set isSticky(v){o.u=v,u()},set requester(v){o.w=v,u()},get requester(){return o.w},dispose(){t=!0,o.b=void 0,o.o.dispose(),o.x.$unregisterAgent(o.y)}}}invoke(t,p,u,o){return this.z(t,p,u,o)}}}),define(Pe[250],Re([1,0,14,6,4,8,7,22]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tic=void 0;class f{static{this.a=0}constructor(D){this.b=new Map,this.c=D.getProxy(P.$0L.MainThreadChatVariables)}async $resolveVariable(D,l,k,g){const s=this.b.get(D);if(s)try{if(s.resolver.resolve2){(0,m.$1F)(s.extension,"chatParticipantAdditions");const a=new E(l,this.c),r=await s.resolver.resolve2(s.data.name,{prompt:k},a.apiObject,g);if(r)return r.map(F.ChatVariable.from)}else{const a=await s.resolver.resolve(s.data.name,{prompt:k},g);if(a)return a.map(F.ChatVariable.from)}}catch(a){(0,S.$2)(a)}}registerVariableResolver(D,l,k,g){const s=f.a++;return this.b.set(s,{extension:D,data:{name:l,description:k},resolver:g}),this.c.$registerVariable(s,{name:l,description:k}),(0,M.$Rc)(()=>{this.b.delete(s),this.c.$unregisterVariable(s)})}}e.$tic=f;class E{constructor(D,l){this.c=D,this.d=l,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let l=function(g){if(D.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,g),s}};const D=this,k=g=>{this.d.$handleProgressChunk(this.c,g)};this.b={progress(g){l(this.progress);const s=new R.$8N(g),a=F.ChatResponseProgressPart.to(s);return k(a),this},reference(g){l(this.reference);const s=new R.$0N(g),a=F.ChatResponseReferencePart.to(s);return k(a),this},push(g){l(this.push);const s=F.ChatResponsePart.to(g);return k(s),this}}}return this.b}}}),define(Pe[251],Re([1,0,11,68,5,6,2,87,20,8,7,4,22]),function(me,e,S,M,P,F,R,m,f,E,N,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xic=void 0;function k(g,s,a){const r=g.getProxy(D.$0L.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new f.$Cm,s.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===6){const $=this.b.get(b.handle);return $?$.value:b}else if(b&&b.$mid===7){const $=this.b.get(b.commentControlHandle);if(!$)return b;const I=$.getCommentThread(b.commentThreadHandle);return I?I.value:b}else if(b&&(b.$mid===9||b.$mid===8)){const $=this.b.get(b.thread.commentControlHandle);if(!$)return b;const I=$.getCommentThread(b.thread.commentThreadHandle);return I?b.$mid===8?I.value:{thread:I.value,text:b.text}:b}else if(b&&b.$mid===10){const $=this.b.get(b.thread.commentControlHandle);if(!$)return b;const I=$.getCommentThread(b.thread.commentThreadHandle);if(!I)return b;const h=b.commentUniqueId,y=I.getCommentByUniqueId(h);return y||b}else if(b&&b.$mid===11){const $=this.b.get(b.thread.commentControlHandle);if(!$)return b;const I=$.getCommentThread(b.thread.commentThreadHandle);if(!I)return b;const h=b.text,y=b.commentUniqueId,w=I.getCommentByUniqueId(y);return w?(typeof w.body=="string"?w.body=h:w.body=new N.$AM(h),w):b}return b}})}createCommentController(b,$,I){const h=i.a++,y=new c(b,h,$,I);this.b.set(y.handle,y);const w=this.c.get(b.identifier)||[];return w.push(y),this.c.set(b.identifier,w),y.value}async $createCommentThreadTemplate(b,$,I){const h=this.b.get(b);h&&h.$createCommentThreadTemplate($,I)}async $setActiveComment(b,$){const I=this.b.get(b);I&&I.$setActiveComment($??void 0)}async $updateCommentThreadTemplate(b,$,I){const h=this.b.get(b);h&&h.$updateCommentThreadTemplate($,I)}$deleteCommentThread(b,$){this.b.get(b)?.$deleteCommentThread($)}async $provideCommentingRanges(b,$,I){const h=this.b.get(b);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const y=await a.ensureDocumentData(R.URI.revive($));return(0,S.$$g)(async()=>{const w=await h.commentingRangeProvider.provideCommentingRanges(y.document,I);let A;return Array.isArray(w)?A={ranges:w,fileComments:!1}:w?A={ranges:w.ranges||[],fileComments:w.fileComments||!1}:A=w??void 0,A}).then(w=>{let A;return w&&(A={ranges:w.ranges.map(L=>E.Range.from(L)),fileComments:w.fileComments}),A})}$toggleReaction(b,$,I,h,y){const w=this.b.get(b);return!w||!w.reactionHandler?Promise.resolve(void 0):(0,S.$$g)(()=>{const A=w.getCommentThread($);if(A){const L=A.getCommentByUniqueId(h.uniqueIdInThread);if(w!==void 0&&L&&w.reactionHandler)return w.reactionHandler(L,p(y))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(b){this.n=b}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(b){(b===void 0!=(this.p===void 0)||!b||!this.p||!b.isEqual(this.p))&&(this.p=b,this.b.range=b,this.c.fire())}get range(){return this.p}set canReply(b){this.d!==b&&(this.d=b,this.b.canReply=b,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(b){this.e=b,this.b.label=b,this.c.fire()}get contextValue(){return this.f}set contextValue(b){this.f=b,this.b.contextValue=b,this.c.fire()}get comments(){return this.q}set comments(b){this.q=b,this.b.comments=b,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(b){this.g=b,this.b.collapsibleState=b,this.c.fire()}get state(){return this.h}set state(b){this.h=b,this.b.state=b,this.c.fire()}get isDisposed(){return this.j}constructor(b,$,I,h,y,w,A,L){this.m=$,this.n=I,this.o=h,this.p=y,this.q=w,this.extensionDescription=A,this.r=L,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$6d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new F.$Uc,this.l.value=new F.$Sc,this.n===void 0&&(this.n=`${b}.${this.handle}`),r.$createCommentThread($,this.handle,this.n,this.o,E.Range.from(this.p),A.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=w,this.i.push({dispose:()=>{r.$deleteCommentThread($,this.handle)}});const J=this;this.value={get uri(){return J.uri},get range(){return J.range},set range(W){J.range=W},get comments(){return J.comments},set comments(W){J.comments=W},get collapsibleState(){return J.collapsibleState},set collapsibleState(W){J.collapsibleState=W},get canReply(){return J.canReply},set canReply(W){J.canReply=W},get contextValue(){return J.contextValue},set contextValue(W){J.contextValue=W},get label(){return J.label},set label(W){J.label=W},get state(){return J.state},set state(W){J.state=W},dispose:()=>{J.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new F.$Sc);const b=I=>Object.prototype.hasOwnProperty.call(this.b,I),$={};b("range")&&($.range=E.Range.from(this.p)),b("label")&&($.label=this.label),b("contextValue")&&($.contextValue=this.contextValue??null),b("comments")&&($.comments=this.q.map(I=>d(this,I,this.k,this.extensionDescription))),b("collapsibleState")&&($.collapseState=u(this.g)),b("canReply")&&($.canReply=this.canReply),b("state")&&($.state=o(this.h)),b("isTemplate")&&($.isTemplate=this.r),this.b={},r.$updateCommentThread(this.m,this.handle,this.n,this.o,$)}getCommentByUniqueId(b){for(const $ of this.k){const I=$[0],h=$[1];if(b===h)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(b=>b.dispose())}}Qe([(0,M.$Lh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(b){this.b=b,b?.resourceHints&&(0,l.$1F)(this.h,"commentingRangeHint"),r.$updateCommentingRanges(this.handle,b?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(b){this.c=b,r.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!b})}get options(){return this.d}set options(b){this.d=b,r.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,l.$1F)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,l.$1F)(this.h,"activeComment"),this.f}constructor(b,$,I,h){this.h=b,this.i=$,this.j=I,this.k=h,this.a=new Map,r.$registerCommentController(this.handle,I,h,this.h.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(w){y.options=w},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(w){y.commentingRangeProvider=w},get reactionHandler(){return y.reactionHandler},set reactionHandler(w){y.reactionHandler=w},get activeCommentThread(){return y.activeCommentThread},createCommentThread(w,A,L){return y.createCommentThread(w,A,L).value},dispose:()=>{y.dispose()}}),this.g=[],this.g.push({dispose:()=>{r.$unregisterCommentController(this.handle)}})}createCommentThread(b,$,I){$===void 0&&(0,l.$1F)(this.h,"fileComments");const h=new n(this.id,this.handle,void 0,b,$,I,this.h,!1);return this.a.set(h.handle,h),h}$setActiveComment(b){if(!b){this.e=void 0,this.f=void 0;return}const $=this.a.get(b.commentThreadHandle);$&&(this.e=b.uniqueIdInThread?$.getCommentByUniqueId(b.uniqueIdInThread):void 0,this.f=$)}$createCommentThreadTemplate(b,$){const I=new n(this.id,this.handle,void 0,R.URI.revive(b),E.Range.to($),[],this.h,!0);return I.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate(b,$){const I=this.a.get(b);I&&(I.range=E.Range.to($))}$deleteCommentThread(b){this.a.get(b)?.dispose(),this.a.delete(b)}getCommentThread(b){return this.a.get(b)}dispose(){this.a.forEach(b=>{b.dispose()}),this.g.forEach(b=>b.dispose())}}function d(v,b,$,I){let h=$.get(b);return h||(h=++v.commentHandle,$.set(b,h)),b.state!==void 0&&(0,l.$1F)(I,"commentsDraftState"),b.reactions?.some(y=>y.reactors!==void 0)&&(0,l.$1F)(I,"commentReactor"),{mode:b.mode,contextValue:b.contextValue,uniqueIdInThread:h,body:typeof b.body=="string"?b.body:E.MarkdownString.from(b.body),userName:b.author.name,userIconPath:b.author.iconPath,label:b.label,commentReactions:b.reactions?b.reactions.map(y=>t(y)):void 0,state:b.state,timestamp:b.timestamp?.toJSON()}}function t(v){return{label:v.label,iconPath:v.iconPath?E.$oO(v.iconPath):void 0,count:v.count,hasReacted:v.authorHasReacted,reactors:v.reactors&&v.reactors.length>0&&typeof v.reactors[0]!="string"?v.reactors.map(b=>b.name):v.reactors}}function p(v){return{label:v.label||"",count:v.count||0,iconPath:v.iconPath?R.URI.revive(v.iconPath):"",authorHasReacted:v.hasReacted||!1,reactors:v.reactors?.map(b=>({name:b}))}}function u(v){if(v!==void 0)switch(v){case N.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function o(v){if(v!==void 0)switch(v){case N.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case N.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new i}e.$xic=k}),define(Pe[252],Re([1,0,25,99,6,12,24,2,8,62,74,4,7]),function(me,e,S,M,P,F,R,m,f,E,N,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=void 0;class k{constructor(p,u){this.document=p,this.b=u,this.a=1,this.c=new N.$aic("custom documents")}addEdit(p){return this.c.add([p])}async undo(p,u){await this.f(p).undo(),u||this.disposeBackup()}async redo(p,u){await this.f(p).redo(),u||this.disposeBackup()}disposeEdits(p){for(const u of p)this.c.delete(u)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const p=d(this.document.uri)+this.a++;return(0,R.$Tg)(this.b,p)}updateBackup(p){this.d?.delete(),this.d=p}disposeBackup(){this.d?.delete(),this.d=void 0}f(p){const u=this.c.get(p,0);if(!u)throw new Error("No edit found");return u}}class g{constructor(){this.a=new Map}get(p,u){return this.a.get(this.b(p,u))}add(p,u,o){const v=this.b(p,u.uri);if(this.a.has(v))throw new Error(`Document already exists for viewType:${p} resource:${u.uri}`);const b=new k(u,o);return this.a.set(v,b),b}delete(p,u){const o=this.b(p,u.uri);this.a.delete(o)}b(p,u){return`${p}@@@${u}`}}var s;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(s||(s={}));class a{constructor(){this.a=new Map}addTextProvider(p,u,o){return this.b(0,p,u,o)}addCustomProvider(p,u,o){return this.b(1,p,u,o)}get(p){return this.a.get(p)}b(p,u,o,v){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,{type:p,extension:o,provider:v}),new l.$_L(()=>this.a.delete(u))}}class r{constructor(p,u,o,v,b){this.d=u,this.f=o,this.g=v,this.h=b,this.b=new a,this.c=new g,this.a=p.getProxy(D.$0L.MainThreadCustomEditors)}registerCustomEditorProvider(p,u,o,v){const b=new P.$Sc;return n(o)?(b.add(this.b.addTextProvider(u,p,o)),this.a.$registerTextEditorProvider((0,E.$Mic)(p),u,v.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,E.$Kic)(p))):(b.add(this.b.addCustomProvider(u,p,o)),i(o)&&b.add(o.onDidChangeCustomDocument($=>{const I=this.i(u,$.document.uri);if(c($)){const h=I.addEdit($);this.a.$onDidEdit($.document.uri,u,h,$.label)}else this.a.$onContentChange($.document.uri,u)})),this.a.$registerCustomEditorProvider((0,E.$Mic)(p),u,v.webviewOptions||{},!!v.supportsMultipleEditorsPerDocument,(0,E.$Kic)(p))),l.$_L.from(b,new l.$_L(()=>{this.a.$unregisterEditorProvider(u)}))}async $createCustomDocument(p,u,o,v,b){const $=this.b.get(u);if(!$)throw new Error(`No provider found for '${u}'`);if($.type!==1)throw new Error(`Invalid provide type for '${u}'`);const I=m.URI.revive(p),h=await $.provider.openCustomDocument(I,{backupId:o,untitledDocumentData:v?.buffer},b);let y;return i($.provider)&&this.f&&(y=this.f.workspaceValue($.extension)??this.f.globalValue($.extension)),this.c.add(u,h,y),{editable:i($.provider)}}async $disposeCustomDocument(p,u){const o=this.b.get(u);if(!o)throw new Error(`No provider found for '${u}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${u}'`);const v=m.URI.revive(p),{document:b}=this.i(u,v);this.c.delete(u,b),b.dispose()}async $resolveCustomEditor(p,u,o,v,b,$){const I=this.b.get(o);if(!I)throw new Error(`No provider found for '${o}'`);const h=f.ViewColumn.to(b),y=this.g.createNewWebview(u,v.contentOptions,I.extension),w=this.h.createNewWebviewPanel(u,o,v.title,h,v.options,y,v.active),A=m.URI.revive(p);switch(I.type){case 1:{const{document:L}=this.i(o,A);return I.provider.resolveCustomEditor(L,w,$)}case 0:{const L=this.d.getDocument(A);return I.provider.resolveCustomTextEditor(L,w,$)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(p,u,o){this.i(u,p).disposeEdits(o)}async $onMoveCustomEditor(p,u,o){const v=this.b.get(o);if(!v)throw new Error(`No provider found for '${o}'`);if(!v.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const b=this.h.getWebviewPanel(p);if(!b)throw new Error("No webview found");const $=m.URI.revive(u),I=this.d.getDocument($);await v.provider.moveCustomTextEditor(I,b,S.CancellationToken.None)}async $undo(p,u,o,v){return this.i(u,p).undo(o,v)}async $redo(p,u,o,v){return this.i(u,p).redo(o,v)}async $revert(p,u,o){const v=this.i(u,p);await this.j(u).revertCustomDocument(v.document,o),v.disposeBackup()}async $onSave(p,u,o){const v=this.i(u,p);await this.j(u).saveCustomDocument(v.document,o),v.disposeBackup()}async $onSaveAs(p,u,o,v){const b=this.i(u,p);return this.j(u).saveCustomDocumentAs(b.document,m.URI.revive(o),v)}async $backup(p,u,o){const v=this.i(u,p),$=await this.j(u).backupCustomDocument(v.document,{destination:v.getNewBackupUri()},o);return v.updateBackup($),$.id}i(p,u){const o=this.c.get(p,m.URI.revive(u));if(!o)throw new Error("No custom document found");return o}j(p){const o=this.b.get(p)?.provider;if(!o||!i(o))throw new Error("Custom document is not editable");return o}}e.$Pic=r;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function c(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function d(t){const p=t.scheme===F.Schemas.file||t.scheme===F.Schemas.untitled?t.fsPath:t.toString();return(0,M.$7i)(p)+""}}),define(Pe[253],Re([1,0,161,100,2,4,7,8,5,13,28,43]),function(me,e,S,M,P,F,R,m,f,E,N,D){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$iic=e.$hic=void 0;class k{#e;#t;#i;constructor(a,r,i,n,c,d,t,p){this.d=a,this.e=r,this.f=i,this.g=n,this.h=c,this.c=!1,this.f=Math.max(n,i),this.#i=new N.$Ac(u=>d.getComparisonKey(u)),this.#e=t,this.#t=p}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(a,r){if(!a){this.clear();return}this.j();let i=[];if(P.URI.isUri(a)){if(!r){this.delete(a);return}this.#i.set(a,r.slice()),i=[a]}else if(Array.isArray(a)){i=[];let d;a=[...a].sort(k.k);for(const t of a){const[p,u]=t;if((!d||p.toString()!==d.toString())&&(d&&this.#i.get(d).length===0&&this.#i.delete(d),d=p,i.push(p),this.#i.set(p,[])),u)this.#i.get(p)?.push(...u);else{const o=this.#i.get(p);o&&(o.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let c=0;for(const d of i){let t=[];const p=this.#i.get(d);if(p)if(p.length>this.g){t=[];const u=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const v of p)if(v.severity===u[o]&&t.push({...m.Diagnostic.from(v),modelVersionId:this.h(d)})===this.g)break e;t.push({severity:M.MarkerSeverity.Info,message:(0,S.localize)(0,null,p.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=p.map(u=>({...m.Diagnostic.from(u),modelVersionId:this.h(d)}));if(n.push([d,t]),c+=t.length,c>this.f)break}this.#e.$changeMany(this.e,n)}delete(a){this.j(),this.#t.fire([a]),this.#i.delete(a),this.#e?.$changeMany(this.e,[[a,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(a,r){this.j();for(const[i,n]of this)a.call(r,i,n,this)}*[Symbol.iterator](){this.j();for(const a of this.#i.keys())yield[a,this.get(a)]}get(a){this.j();const r=this.#i.get(a);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(a){return this.j(),Array.isArray(this.#i.get(a))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(a,r){return a[0].toString()<r[0].toString()?-1:a[0].toString()>r[0].toString()?1:0}}e.$hic=k;let g=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(a){const r=new N.$Ac;for(const i of a)r.set(i,i);return{uris:Object.freeze(Array.from(r.values()))}}constructor(a,r,i,n){this.j=r,this.k=i,this.l=n,this.g=new Map,this.h=new f.$0d({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=f.Event.map(this.h.event,l._mapper),this.f=a.getProxy(F.$0L.MainThreadDiagnostics)}createDiagnosticCollection(a,r){const{g:i,f:n,h:c,j:d,k:t,l:p}=this,u=new class{$changeMany(b,$){n.$changeMany(b,$),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,b,$.length===0?"CLEARING":$)}$clear(b){n.$clear(b),d.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,b)}dispose(){n.dispose()}};let o;if(!r)r="_generated_diagnostic_collection_name_#"+l.c++,o=r;else if(!i.has(r))o=r;else{this.j.warn(`DiagnosticCollection with name '${r}' does already exist.`);do o=r+l.c++;while(i.has(o))}return new class extends k{constructor(){super(r,o,l.e,l.d,b=>p.getDocument(b)?.version,t.extUri,u,c),i.set(o,this)}dispose(){super.dispose(),i.delete(o)}}}getDiagnostics(a){if(a)return this.m(a);{const r=new Map,i=[];for(const n of this.g.values())n.forEach((c,d)=>{let t=r.get(c.toString());typeof t>"u"&&(t=i.length,r.set(c.toString(),t),i.push([c,[]])),i[t][1]=i[t][1].concat(...d)});return i}}m(a){let r=[];for(const i of this.g.values())i.has(a)&&(r=r.concat(i.get(a)));return r}$acceptMarkersChange(a){if(!this.n){const r="_generated_mirror",i=new k(r,r,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(r,i),this.n=i}for(const[r,i]of a)this.n.set(P.URI.revive(r),i.map(m.Diagnostic.to))}};e.$iic=g,e.$iic=g=l=Qe([qe(1,E.$Aj),qe(2,D.$gic)],g)}),define(Pe[254],Re([1,0,2,14,7,8,189]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rjc=void 0;class m{constructor(E,N,D,l={timeout:1500,errors:3}){this.c=E,this.d=N,this.f=D,this.g=l,this.a=new R.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(E){return(N,D,l)=>{const g={dispose:this.a.push([N,D,E])};return Array.isArray(l)&&l.push(g),g}}async $participateInSave(E,N){const D=S.URI.revive(E);let l=!1;const k=setTimeout(()=>l=!0,this.g.timeout),g=[];try{for(const s of[...this.a]){if(l)break;const a=this.d.getDocument(D),r=await this.h(s,{document:a,reason:F.TextDocumentSaveReason.to(N)});g.push(r)}}finally{clearTimeout(k)}return g}h([E,N,D],l){const k=this.b.get(E);return typeof k=="number"&&k>this.g.errors?Promise.resolve(!1):this.i(D,E,N,l).then(()=>!0,g=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(g),!(g instanceof Error)||g.message!=="concurrent_edits"){const s=this.b.get(E);this.b.set(E,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(E,N,D,l){const k=[],g=Date.now(),{document:s,reason:a}=l,{version:r}=s,i=Object.freeze({document:s,reason:a,waitUntil(n){if(Object.isFrozen(k))throw(0,M.$8)("waitUntil can not be called async");k.push(Promise.resolve(n))}});try{N.apply(D,[i])}catch(n){return Promise.reject(n)}return Object.freeze(k),new Promise((n,c)=>{const d=setTimeout(()=>c(new Error("timeout")),this.g.timeout);return Promise.all(k).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' finished after ${Date.now()-g}ms`),clearTimeout(d),n(t)}).catch(t=>{clearTimeout(d),c(t)})}).then(n=>{const c={edits:[]};for(const d of n)if(Array.isArray(d)&&d.every(t=>t instanceof P.$gM))for(const{newText:t,newEol:p,range:u}of d)c.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:u&&F.Range.from(u),text:t,eol:p&&F.EndOfLine.from(p)}});if(c.edits.length!==0)return r===s.version?this.f.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.$rjc=m}),define(Pe[255],Re([1,0,5,6,2,4,111,8,16,26,7]),function(me,e,S,M,P,F,R,m,f,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jic=void 0;class D{constructor(k,g){this.a=new S.$6d,this.b=new S.$6d,this.c=new S.$6d,this.d=new S.$6d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Sc,this.h=new Map,this.f=k.getProxy(F.$0L.MainThreadDocuments),this.g=g,this.g.onDidRemoveDocuments(s=>{for(const a of s)this.b.fire(a.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const a of s)this.a.fire(a.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const g=this.g.getDocument(k);if(g)return g}getDocument(k){const g=this.getDocumentData(k);if(!g?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return g.document}ensureDocumentData(k){const g=this.g.getDocument(k);if(g)return Promise.resolve(g);let s=this.h.get(k.toString());return s||(s=this.f.$tryOpenDocument(k).then(a=>{this.h.delete(k.toString());const r=P.URI.revive(a);return(0,f.$5f)(this.g.getDocument(r))},a=>(this.h.delete(k.toString()),Promise.reject(a))),this.h.set(k.toString(),s)),s}createDocumentData(k){return this.f.$tryCreateDocument(k).then(g=>P.URI.revive(g))}$acceptModelLanguageChanged(k,g){const s=P.URI.revive(k),a=this.g.getDocument(s);if(!a)throw new Error("unknown document");this.b.fire(a.document),a._acceptLanguageId(g),this.a.fire(a.document)}$acceptModelSaved(k){const g=P.URI.revive(k),s=this.g.getDocument(g);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(k,g){const s=P.URI.revive(k),a=this.g.getDocument(s);if(!a)throw new Error("unknown document");a._acceptIsDirty(g),this.c.fire({document:a.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,g,s){const a=P.URI.revive(k),r=this.g.getDocument(a);if(!r)throw new Error("unknown document");r._acceptIsDirty(s),r.onEvents(g);let i;g.isUndoing?i=N.TextDocumentChangeReason.Undo:g.isRedoing&&(i=N.TextDocumentChangeReason.Redo),this.c.fire((0,E.$Mn)({document:r.document,contentChanges:g.changes.map(n=>({range:m.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(k,g){(0,R.$rO)(k,g)}}e.$jic=D}),define(Pe[65],Re([1,0,256,5,16,2,3,4,17,8,7]),function(me,e,S,M,P,F,R,m,f,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ric=e.$Qic=void 0,e.$Qic=(0,R.$gi)("IExtHostEditorTabs");class D{constructor(a,r,i){this.e=i,this.d=r,this.acceptDtoUpdate(a)}get apiObject(){if(!this.a){const a=this,r={get isActive(){return a.b.id===a.e()},get label(){return a.b.label},get input(){return a.c},get isDirty(){return a.b.isDirty},get isPinned(){return a.b.isPinned},get isPreview(){return a.b.isPreview},get group(){return a.d.apiObject}};this.a=Object.freeze(r)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(a){this.b=a,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new N.$TN(F.URI.revive(this.b.input.uri));case 2:return new N.$UN(F.URI.revive(this.b.input.original),F.URI.revive(this.b.input.modified));case 3:return new N.$VN(F.URI.revive(this.b.input.base),F.URI.revive(this.b.input.input1),F.URI.revive(this.b.input.input2),F.URI.revive(this.b.input.result));case 6:return new N.$WN(F.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new N.$XN(this.b.input.viewType);case 4:return new N.$YN(F.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new N.$ZN(F.URI.revive(this.b.input.original),F.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new N.$1N;case 9:return new N.$2N(F.URI.revive(this.b.input.uri),F.URI.revive(this.b.input.inputBoxUri));case 10:return new N.$3N(this.b.input.providerId);default:return}}}class l{constructor(a,r){this.c=[],this.d="",this.b=a,this.e=r;for(const i of a.tabs)i.isActive&&(this.d=i.id),this.c.push(new D(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const a=this,r={get isActive(){return a.b.groupId===a.e()},get viewColumn(){return E.ViewColumn.to(a.b.viewColumn)},get activeTab(){return a.c.find(i=>i.tabId===a.d)?.apiObject},get tabs(){return Object.freeze(a.c.map(i=>i.apiObject))}};this.a=Object.freeze(r)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(a){this.b=a}acceptTabOperation(a){if(a.kind===0){const i=new D(a.tabDto,this,()=>this.activeTabId());return this.c.splice(a.index,0,i),a.tabDto.isActive&&(this.d=i.tabId),i}else if(a.kind===1){const i=this.c.splice(a.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${a.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(a.kind===3){if(a.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(a.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${a.oldIndex} which does not exist`);return this.c.splice(a.index,0,i),i}const r=this.c.find(i=>i.tabId===a.tabDto.id);if(!r)throw new Error("INVALID tab");return a.tabDto.isActive?this.d=a.tabDto.id:this.d===a.tabDto.id&&!a.tabDto.isActive&&(this.d=""),r.acceptDtoUpdate(a.tabDto),r}activeTabId(){return this.d}}let k=class{constructor(a){this.b=new M.$6d,this.c=new M.$6d,this.e=[],this.a=a.getProxy(m.$0L.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const a=this,r={onDidChangeTabGroups:a.c.event,onDidChangeTabs:a.b.event,get all(){return Object.freeze(a.e.map(i=>i.apiObject))},get activeTabGroup(){const i=a.d;return(0,P.$5f)(a.e.find(c=>c.groupId===i)?.apiObject)},close:async(i,n)=>{const c=Array.isArray(i)?i:[i];return c.length?g(c[0])?this.j(c,n):this.i(c,n):!0}};this.f=Object.freeze(r)}return this.f}$acceptEditorTabModel(a){const r=new Set(this.e.map(u=>u.groupId)),i=new Set(a.map(u=>u.groupId)),n=(0,S.$L)(r,i),c=this.e.filter(u=>n.removed.includes(u.groupId)).map(u=>u.apiObject),d=[],t=[];this.e=a.map(u=>{const o=new l(u,()=>this.d);return n.added.includes(o.groupId)?d.push(o.apiObject):t.push(o.apiObject),o});const p=(0,P.$5f)(a.find(u=>u.isActive===!0)?.groupId);p!==void 0&&this.d!==p&&(this.d=p),this.c.fire(Object.freeze({opened:d,closed:c,changed:t}))}$acceptTabGroupUpdate(a){const r=this.e.find(i=>i.groupId===a.groupId);if(!r)throw new Error("Update Group IPC call received before group creation.");r.acceptGroupDtoUpdate(a),a.isActive&&(this.d=a.groupId),this.c.fire(Object.freeze({changed:[r.apiObject],opened:[],closed:[]}))}$acceptTabOperation(a){const r=this.e.find(n=>n.groupId===a.groupId);if(!r)throw new Error("Update Tabs IPC call received before group creation.");const i=r.acceptTabOperation(a);switch(a.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(a){for(const r of this.e)for(const i of r.tabs)if(i.apiObject===a)return i}h(a){return this.e.find(r=>r.apiObject===a)}async i(a,r){const i=[];for(const n of a){const c=this.g(n);if(!c)throw new Error("Tab close: Invalid tab not found!");i.push(c.tabId)}return this.a.$closeTab(i,r)}async j(a,r){const i=[];for(const n of a){const c=this.h(n);if(!c)throw new Error("Group close: Invalid group not found!");i.push(c.groupId)}return this.a.$closeGroup(i,r)}};e.$Ric=k,e.$Ric=k=Qe([qe(0,f.$pO)],k);function g(s){return s.tabs!==void 0}}),define(Pe[257],Re([1,0,2,4,6,7,8,300,15,23,22,53]),function(me,e,S,M,P,F,R,m,f,E,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tjc=void 0;class l{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const a=this.a.indexOf(s);a>=0&&(this.a.splice(a,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),a=[];let r,i,n=14,c=14;for(const d of s){let t=r?(0,f.$mf)(r,d):0;for(t===0?i=1:i=c;t<d.length;t++)t+1===d.length?(n=c,c=9):c+=1,a.push([i,d.toUpperCase().charCodeAt(t),c]),a.push([i,d.toLowerCase().charCodeAt(t),c]),i=c;r=d,c=n}a.push([9,58,10]),a.push([10,47,12]),this.b=new m.$_1(a)}}provideDocumentLinks(s){this.c();const a=[],r=m.$a2.computeLinks({getLineContent(i){return s.lineAt(i-1).text},getLineCount(){return s.lineCount}},this.b);for(const i of r){const n=R.DocumentLink.to(i);n.target&&a.push(n)}return a}}class k{constructor(s,a){this.i=a,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(M.$0L.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,a,r,i={}){if(k.j(r),this.d.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const n=this.h++;this.b.add(a),this.d.add(a),this.c.set(n,r);let c=2;i.isCaseSensitive&&(c+=1024),i.isReadonly&&(c+=2048),typeof r.copy=="function"&&(c+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,N.$1F)(s,"fsChunks"),c+=4);let d;i.isReadonly&&(0,D.$zk)(i.isReadonly)&&i.isReadonly.value!==""&&(d={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,a,c,d).catch(p=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${a}`),console.error(p)});const t=r.onDidChangeFile(p=>{const u=[];for(const o of p){const{uri:v,type:b}=o;if(v.scheme!==a)continue;let $;switch(b){case F.FileChangeType.Changed:$=0;break;case F.FileChangeType.Created:$=1;break;case F.FileChangeType.Deleted:$=2;break;default:throw new Error("Unknown FileChangeType")}u.push({resource:v,type:$})}this.a.$onFileSystemChange(n,u)});return(0,P.$Rc)(()=>{t.dispose(),this.b.delete(a),this.d.delete(a),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:a,ctime:r,mtime:i,size:n,permissions:c}=s;return{type:a,ctime:r,mtime:i,size:n,permissions:c}}$stat(s,a){return Promise.resolve(this.l(s).stat(S.URI.revive(a))).then(r=>k.k(r))}$readdir(s,a){return Promise.resolve(this.l(s).readDirectory(S.URI.revive(a)))}$readFile(s,a){return Promise.resolve(this.l(s).readFile(S.URI.revive(a))).then(r=>E.$te.wrap(r))}$writeFile(s,a,r,i){return Promise.resolve(this.l(s).writeFile(S.URI.revive(a),r.buffer,i))}$delete(s,a,r){return Promise.resolve(this.l(s).delete(S.URI.revive(a),r))}$rename(s,a,r,i){return Promise.resolve(this.l(s).rename(S.URI.revive(a),S.URI.revive(r),i))}$copy(s,a,r,i){const n=this.l(s);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(S.URI.revive(a),S.URI.revive(r),i))}$mkdir(s,a){return Promise.resolve(this.l(s).createDirectory(S.URI.revive(a)))}$watch(s,a,r,i){const n=this.l(s).watch(S.URI.revive(r),i);this.f.set(a,n)}$unwatch(s,a){const r=this.f.get(a);r&&(r.dispose(),this.f.delete(a))}$open(s,a,r){const i=this.l(s);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(S.URI.revive(a),r))}$close(s,a){const r=this.l(s);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(a))}$read(s,a,r,i){const n=this.l(s);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const c=E.$te.alloc(i);return Promise.resolve(n.read(a,r,c.buffer,0,i)).then(d=>c.slice(0,d))}$write(s,a,r,i){const n=this.l(s);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(a,r,i.buffer,0,i.byteLength))}l(s){const a=this.c.get(s);if(!a){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return a}}e.$tjc=k}),define(Pe[258],Re([1,0,5,34,2,4,8,7,39]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ujc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(k,g,s,a,r,i){this.a=Math.random(),this.b=new S.$6d,this.c=new S.$6d,this.d=new S.$6d,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,M.$Zj)(r),c=typeof r=="string",d=i?.correlate,t=a(p=>{if(!(typeof p.session=="number"&&p.session!==this.a)&&!(d&&typeof p.session>"u")){if(!i?.ignoreCreateEvents)for(const u of p.created){const o=P.URI.revive(u);n(o.fsPath)&&(!c||g.getWorkspaceFolder(o))&&this.b.fire(o)}if(!i?.ignoreChangeEvents)for(const u of p.changed){const o=P.URI.revive(u);n(o.fsPath)&&(!c||g.getWorkspaceFolder(o))&&this.c.fire(o)}if(!i?.ignoreDeleteEvents)for(const u of p.deleted){const o=P.URI.revive(u);n(o.fsPath)&&(!c||g.getWorkspaceFolder(o))&&this.d.fire(o)}}});this.g=m.$_L.from(this.i(k,s,r,i,i?.correlate),this.b,this.c,this.d,t)}i(k,g,s,a,r){const i=m.$_L.from();if(typeof s=="string")return i;const n=k.getProxy(F.$0L.MainThreadFileSystemEventService);let c=!1;return(s.pattern.includes(M.$Vj)||s.pattern.includes(M.$Wj))&&(c=!0),n.$watch(g.identifier.value,this.a,s.baseUri,{recursive:c,excludes:a?.excludes??[]},!!r),m.$_L.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class N{constructor(k){this.a=k,this.session=this.a.session,this.b=new f.$V(()=>this.a.created.map(P.URI.revive)),this.c=new f.$V(()=>this.a.changed.map(P.URI.revive)),this.d=new f.$V(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class D{constructor(k,g,s){this.j=k,this.k=g,this.l=s,this.a=new S.$6d,this.b=new S.$6d,this.c=new S.$6d,this.d=new S.$6d,this.g=new S.$8d,this.h=new S.$8d,this.i=new S.$8d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(k,g,s,a){return new E(this.j,k,g,this.a.event,R.GlobPattern.from(s),a)}$onFileEvent(k){this.a.fire(new N(k))}$onDidRunFileOperation(k,g){switch(k){case 2:this.b.fire(Object.freeze({files:g.map(s=>({oldUri:P.URI.revive(s.source),newUri:P.URI.revive(s.target)}))}));break;case 1:this.d.fire(Object.freeze({files:g.map(s=>P.URI.revive(s.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:g.map(s=>P.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(k){return this.m(k,this.g)}getOnWillCreateFileEvent(k){return this.m(k,this.h)}getOnWillDeleteFileEvent(k){return this.m(k,this.i)}m(k,g){return(s,a,r)=>{const i=function(c){s.call(a,c)};return i.extension=k,g.event(i,void 0,r)}}async $onWillRunFileOperation(k,g,s,a){switch(k){case 2:return await this.n(this.g,{files:g.map(r=>({oldUri:P.URI.revive(r.source),newUri:P.URI.revive(r.target)}))},s,a);case 1:return await this.n(this.i,{files:g.map(r=>P.URI.revive(r.target))},s,a);case 0:case 3:return await this.n(this.h,{files:g.map(r=>P.URI.revive(r.target))},s,a)}}async n(k,g,s,a){const r=new Set,i=[];if(await k.fireAsync(g,a,async(c,d)=>{const t=Date.now(),p=await Promise.resolve(c);p instanceof m.$jM&&(i.push([d.extension,p]),r.add(d.extension.displayName??d.extension.identifier.value)),Date.now()-t>s&&this.k.warn("SLOW file-participant",d.extension.identifier)}),a.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,c]of i){const{edits:d}=R.WorkspaceEdit.from(c,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(d)}return{edit:n,extensionNames:Array.from(r)}}}e.$ujc=D}),define(Pe[259],Re([1,0,18,11,25,14,90,6,26,64,15,16,2,29,301,87,97,163,20,8,7,22,74,4]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g,s,a,r,i,n,c,d,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=void 0;class u{constructor(z,j){this.d=z,this.e=j}async provideDocumentSymbols(z,j){const K=this.d.getDocument(z),H=await this.e.provideDocumentSymbols(K,j);if(!(0,S.$Kb)(H))return H[0]instanceof c.$sM?H.map(n.DocumentSymbol.from):u.f(H)}static f(z){z=z.slice(0).sort((H,ee)=>{let se=H.location.range.start.compareTo(ee.location.range.start);return se===0&&(se=ee.location.range.end.compareTo(H.location.range.end)),se});const j=[],K=[];for(const H of z){const ee={name:H.name||"!!MISSING: name!!",kind:n.SymbolKind.from(H.kind),tags:H.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:n.Range.from(H.location.range),selectionRange:n.Range.from(H.location.range),children:[]};for(;;){if(K.length===0){K.push(ee),j.push(ee);break}const se=K[K.length-1];if(k.$0s.containsRange(se.range,ee.range)&&!k.$0s.equalsRange(se.range,ee.range)){se.children?.push(ee),K.push(ee);break}K.pop()}}return j}}class o{constructor(z,j,K,H,ee,se){this.f=z,this.g=j,this.h=K,this.j=H,this.k=ee,this.l=se,this.d=new t.$aic("CodeLens"),this.e=new Map}async provideCodeLenses(z,j){const K=this.f.getDocument(z),H=await this.h.provideCodeLenses(K,j);if(!H||j.isCancellationRequested)return;const ee=this.d.add(H),se=new m.$Sc;this.e.set(ee,se);const Ne={cacheId:ee,lenses:[]};for(let Ve=0;Ve<H.length;Ve++)Ne.lenses.push({cacheId:[ee,Ve],range:n.Range.from(H[Ve].range),command:this.g.toInternal(H[Ve].command,se)});return Ne}async resolveCodeLens(z,j){const K=z.cacheId&&this.d.get(...z.cacheId);if(!K)return;let H;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?H=K:H=await this.h.resolveCodeLens(K,j),H||(H=K),j.isCancellationRequested)return;const ee=z.cacheId&&this.e.get(z.cacheId[0]);if(ee){if(!H.command){const se=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,se),this.l.error(se);return}return z.command=this.g.toInternal(H.command,ee),z}}releaseCodeLenses(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}}function v(ze){return Array.isArray(ze)?ze.map(n.DefinitionLink.from):ze?[n.DefinitionLink.from(ze)]:[]}class b{constructor(z,j){this.d=z,this.e=j}async provideDefinition(z,j,K){const H=this.d.getDocument(z),ee=n.Position.to(j),se=await this.e.provideDefinition(H,ee,K);return v(se)}}class ${constructor(z,j){this.d=z,this.e=j}async provideDeclaration(z,j,K){const H=this.d.getDocument(z),ee=n.Position.to(j),se=await this.e.provideDeclaration(H,ee,K);return v(se)}}class I{constructor(z,j){this.d=z,this.e=j}async provideImplementation(z,j,K){const H=this.d.getDocument(z),ee=n.Position.to(j),se=await this.e.provideImplementation(H,ee,K);return v(se)}}class h{constructor(z,j){this.d=z,this.e=j}async provideTypeDefinition(z,j,K){const H=this.d.getDocument(z),ee=n.Position.to(j),se=await this.e.provideTypeDefinition(H,ee,K);return v(se)}}class y{constructor(z,j){this.d=z,this.e=j}async provideHover(z,j,K){const H=this.d.getDocument(z),ee=n.Position.to(j),se=await this.e.provideHover(H,ee,K);if(!(!se||(0,S.$Kb)(se.contents)))return se.range||(se.range=H.getWordRangeAtPosition(ee)),se.range||(se.range=new c.$bM(ee,ee)),n.Hover.from(se)}}class w{constructor(z,j){this.d=z,this.e=j}async provideEvaluatableExpression(z,j,K){const H=this.d.getDocument(z),ee=n.Position.to(j),se=await this.e.provideEvaluatableExpression(H,ee,K);if(se)return n.EvaluatableExpression.from(se)}}class A{constructor(z,j){this.d=z,this.e=j}async provideInlineValues(z,j,K,H){const ee=this.d.getDocument(z),se=await this.e.provideInlineValues(ee,n.Range.to(j),n.InlineValueContext.to(K),H);if(Array.isArray(se))return se.map(Ne=>n.InlineValue.from(Ne))}}class L{constructor(z,j){this.d=z,this.e=j}async provideDocumentHighlights(z,j,K){const H=this.d.getDocument(z),ee=n.Position.to(j),se=await this.e.provideDocumentHighlights(H,ee,K);if(Array.isArray(se))return se.map(n.DocumentHighlight.from)}}class J{constructor(z,j){this.d=z,this.e=j}async provideMultiDocumentHighlights(z,j,K,H){const ee=this.d.getDocument(z),se=K.map(He=>this.d.getDocument(He)),Ne=n.Position.to(j),Ve=await this.e.provideMultiDocumentHighlights(ee,Ne,se,H);if(Array.isArray(Ve))return Ve.map(n.MultiDocumentHighlight.from)}}class W{constructor(z,j){this.d=z,this.e=j}async provideLinkedEditingRanges(z,j,K){const H=this.d.getDocument(z),ee=n.Position.to(j),se=await this.e.provideLinkedEditingRanges(H,ee,K);if(se&&Array.isArray(se.ranges))return{ranges:(0,S.$Hb)(se.ranges.map(n.Range.from)),wordPattern:se.wordPattern}}}class U{constructor(z,j){this.d=z,this.e=j}async provideReferences(z,j,K,H){const ee=this.d.getDocument(z),se=n.Position.to(j),Ne=await this.e.provideReferences(ee,se,K,H);if(Array.isArray(Ne))return Ne.map(n.location.from)}}class C{static{this.d=1e3}constructor(z,j,K,H,ee,se,Ne){this.g=z,this.h=j,this.j=K,this.k=H,this.l=ee,this.m=se,this.n=Ne,this.e=new t.$aic("CodeAction"),this.f=new Map}async provideCodeActions(z,j,K,H){const ee=this.g.getDocument(z),se=g.$_s.isISelection(j)?n.Selection.to(j):n.Range.to(j),Ne=[];for(const rt of this.j.getDiagnostics(z))if(se.intersection(rt.range)&&Ne.push(rt)>C.d)break;const Ve={diagnostics:Ne,only:K.only?new c.$uM(K.only):void 0,triggerKind:n.CodeActionTriggerKind.to(K.trigger)},He=await this.k.provideCodeActions(ee,se,Ve,H);if(!(0,S.$Lb)(He)||H.isCancellationRequested)return;const xe=this.e.add(He),tt=new m.$Sc;this.f.set(xe,tt);const lt=[];for(let rt=0;rt<He.length;rt++){const it=He[rt];if(it)if(C.o(it))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),lt.push({_isSynthetic:!0,title:it.title,command:this.h.toInternal(it,tt)});else{Ve.only&&(it.kind?Ve.only.contains(it.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action is of kind '${it.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ve.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ot=it.ranges??[];lt.push({cacheId:[xe,rt],title:it.title,command:it.command&&this.h.toInternal(it.command,tt),diagnostics:it.diagnostics&&it.diagnostics.map(n.Diagnostic.from),edit:it.edit&&n.WorkspaceEdit.from(it.edit,void 0),kind:it.kind&&it.kind.value,isPreferred:it.isPreferred,isAI:(0,d.$ZF)(this.m,"codeActionAI")?it.isAI:!1,ranges:(0,d.$ZF)(this.m,"codeActionRanges")?(0,S.$Hb)(ot.map(n.Range.from)):void 0,disabled:it.disabled?.reason})}}return{cacheId:xe,actions:lt}}async resolveCodeAction(z,j){const[K,H]=z,ee=this.e.get(K,H);if(!ee||C.o(ee))return{};if(!this.k.resolveCodeAction)return{};const se=await this.k.resolveCodeAction(ee,j)??ee;let Ne;se.edit&&(Ne=n.WorkspaceEdit.from(se.edit,void 0));let Ve;if(se.command){const He=this.f.get(K);He&&(Ve=this.h.toInternal(se.command,He))}return{edit:Ne,command:Ve}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class O{static toInternalProviderId(z,j){return z+"."+j}constructor(z,j,K,H,ee){this.d=z,this.e=j,this.f=K,this.g=H,this.h=ee}async prepareDocumentPaste(z,j,K,H){if(!this.f.prepareDocumentPaste)return;const ee=this.e.getDocument(z),se=j.map(He=>n.Range.to(He)),Ne=n.DataTransfer.toDataTransfer(K,()=>{throw new F.$$});if(await this.f.prepareDocumentPaste(ee,se,Ne,H),H.isCancellationRequested)return;const Ve=Array.from(Ne).filter(([,He])=>!(He instanceof c.$1M));return n.DataTransfer.from(Ve)}async providePasteEdits(z,j,K,H,ee){if(!this.f.provideDocumentPasteEdits)return;const se=this.e.getDocument(j),Ne=K.map(xe=>n.Range.to(xe)),Ve=n.DataTransfer.toDataTransfer(H,async xe=>(await this.d.$resolvePasteFileData(this.g,z,xe)).buffer),He=await this.f.provideDocumentPasteEdits(se,Ne,Ve,ee);if(He)return{label:He.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:He.yieldTo?.map(xe=>"mimeType"in xe?xe:{providerId:O.toInternalProviderId(xe.extensionId,xe.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?n.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class q{constructor(z,j){this.d=z,this.e=j}async provideDocumentFormattingEdits(z,j,K){const H=this.d.getDocument(z),ee=await this.e.provideDocumentFormattingEdits(H,j,K);if(Array.isArray(ee))return ee.map(n.TextEdit.from)}}class ne{constructor(z,j){this.d=z,this.e=j}async provideDocumentRangeFormattingEdits(z,j,K,H){const ee=this.d.getDocument(z),se=n.Range.to(j),Ne=await this.e.provideDocumentRangeFormattingEdits(ee,se,K,H);if(Array.isArray(Ne))return Ne.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,j,K,H){(0,D.$4f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(z),se=j.map(n.Range.to),Ne=await this.e.provideDocumentRangesFormattingEdits(ee,se,K,H);if(Array.isArray(Ne))return Ne.map(n.TextEdit.from)}}class ce{constructor(z,j){this.d=z,this.e=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,j,K,H,ee){const se=this.d.getDocument(z),Ne=n.Position.to(j),Ve=await this.e.provideOnTypeFormattingEdits(se,Ne,K,H,ee);if(Array.isArray(Ve))return Ve.map(n.TextEdit.from)}}class ye{constructor(z,j){this.e=z,this.f=j,this.d=new t.$aic("WorkspaceSymbols")}async provideWorkspaceSymbols(z,j){const K=await this.e.provideWorkspaceSymbols(z,j);if(!(0,S.$Lb)(K))return{symbols:[]};const H=this.d.add(K),ee={cacheId:H,symbols:[]};for(let se=0;se<K.length;se++){const Ne=K[se];if(!Ne||!Ne.name){this.f.warn("INVALID SymbolInformation",Ne);continue}ee.symbols.push({...n.WorkspaceSymbol.from(Ne),cacheId:[H,se]})}return ee}async resolveWorkspaceSymbol(z,j){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const K=this.d.get(...z.cacheId);if(K){const H=await this.e.resolveWorkspaceSymbol(K,j);return H&&(0,f.$On)(z,n.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class Ie{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,j,K){this.d=z,this.e=j,this.f=K}async provideRenameEdits(z,j,K,H){const ee=this.d.getDocument(z),se=n.Position.to(j);try{const Ne=await this.e.provideRenameEdits(ee,se,K,H);return Ne?n.WorkspaceEdit.from(Ne):void 0}catch(Ne){const Ve=Ie.g(Ne);return Ve?{rejectReason:Ve,edits:void 0}:Promise.reject(Ne)}}async resolveRenameLocation(z,j,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(z),ee=n.Position.to(j);try{const se=await this.e.prepareRename(H,ee,K);let Ne,Ve;if(c.$bM.isRange(se)?(Ne=se,Ve=H.getText(se)):(0,D.$Vf)(se)&&(Ne=se.range,Ve=se.placeholder),!Ne||!Ve)return;if(Ne.start.line>ee.line||Ne.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Ne),text:Ve}}catch(se){const Ne=Ie.g(se);return Ne?{rejectReason:Ne,range:void 0,text:void 0}:Promise.reject(se)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ue{constructor(z,j,K){this.d=z,this.e=j,this.f=K}async provideNewSymbolNames(z,j,K){const H=this.d.getDocument(z),ee=n.Range.to(j);try{const se=await this.e.provideNewSymbolNames(H,ee,K);return se?se.map(Ne=>typeof Ne=="string"?{newSymbolName:Ne}:{newSymbolName:Ne.newSymbolName,tags:Ne.tags}):void 0}catch(se){this.f.error(ue.g(se)??JSON.stringify(se,null,"	"));return}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ve{constructor(z,j){this.resultId=z,this.tokens=j}}class re{constructor(z,j){this.f=z,this.g=j,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,j,K){const H=this.f.getDocument(z),ee=j!==0?this.d.get(j):null;let se=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ee.resultId,K):await this.g.provideDocumentSemanticTokens(H,K);return ee&&this.d.delete(j),se?(se=re.h(se),this.o(re.n(ee,se),se)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return re.j(z)?re.k(z)?z:new c.$sN(new Uint32Array(z.data),z.resultId):re.l(z)?re.m(z)?z:new c.$uN(z.edits.map(j=>new c.$tN(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const j of z.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static n(z,j){if(!re.j(j)||!z||!z.tokens)return j;const K=z.tokens,H=K.length,ee=j.data,se=ee.length;let Ne=0;const Ve=Math.min(H,se);for(;Ne<Ve&&K[Ne]===ee[Ne];)Ne++;if(Ne===H&&Ne===se)return new c.$uN([],j.resultId);let He=0;const xe=Ve-Ne;for(;He<xe&&K[H-He-1]===ee[se-He-1];)He++;return new c.$uN([{start:Ne,deleteCount:H-Ne-He,data:ee.subarray(Ne,se-He)}],j.resultId)}o(z,j){if(re.j(z)){const K=this.e++;return this.d.set(K,new ve(z.resultId,z.data)),(0,a.$dab)({id:K,type:"full",data:z.data})}if(re.l(z)){const K=this.e++;return re.j(j)?this.d.set(K,new ve(j.resultId,j.data)):this.d.set(K,new ve(z.resultId)),(0,a.$dab)({id:K,type:"delta",deltas:(z.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class $e{constructor(z,j){this.d=z,this.e=j}async provideDocumentRangeSemanticTokens(z,j,K){const H=this.d.getDocument(z),ee=await this.e.provideDocumentRangeSemanticTokens(H,n.Range.to(j),K);return ee?this.f(ee):null}f(z){return(0,a.$dab)({id:0,type:"full",data:z.data})}}class ie{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,j,K,H,ee){this.f=z,this.g=j,this.h=K,this.j=H,this.k=ee,this.d=new t.$aic("CompletionItem"),this.e=new Map}async provideCompletionItems(z,j,K,H){const ee=this.f.getDocument(z),se=n.Position.to(j),Ne=ee.getWordRangeAtPosition(se)||new c.$bM(se,se),Ve=Ne.with({end:se}),He=new E.$2d,xe=await this.h.provideCompletionItems(ee,se,H,n.CompletionContext.to(K));if(!xe||H.isCancellationRequested)return;const tt=Array.isArray(xe)?new c.$HM(xe):xe,lt=ie.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),rt=new m.$Sc;this.e.set(lt,rt);const it=[],ot={x:lt,b:it,a:{replace:n.Range.from(Ne),insert:n.Range.from(Ve)},c:tt.isIncomplete||void 0,d:He.elapsed()};for(let Be=0;Be<tt.items.length;Be++){const et=tt.items[Be],X=this.l(et,[lt,Be],Ve,Ne);it.push(X)}return ot}async resolveCompletionItem(z,j){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...z);if(!K)return;const H=this.l(K,z),ee=await this.h.resolveCompletionItem(K,j);if(!ee)return;const se=this.l(ee,z);return(H.h!==se.h||H.i!==se.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==se.n||H.o!==se.o||!(0,f.$Pn)(H.p,se.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:se.d,c:se.c,l:se.l,h:se.h,i:se.i,n:se.n,o:se.o,p:se.p}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,j,K,H){const ee=this.e.get(j[0]);if(!ee)throw Error("DisposableStore is missing...");const se=this.g.toInternal(z.command,ee),Ne={x:j,a:z.label,b:z.kind!==void 0?n.CompletionItemKind.from(z.kind):void 0,m:z.tags&&z.tags.map(n.CompletionItemTag.from),c:z.detail,d:typeof z.documentation>"u"?void 0:n.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters?.join(""),l:z.additionalTextEdits&&z.additionalTextEdits.map(n.TextEdit.from),n:se?.$ident,o:se?.id,p:se?.$ident?void 0:se?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ne.h=z.textEdit.newText):typeof z.insertText=="string"?Ne.h=z.insertText:z.insertText instanceof c.$kM&&(Ne.h=z.insertText.value,Ne.i|=4);let Ve;return z.textEdit?Ve=z.textEdit.range:z.range&&(Ve=z.range),c.$bM.isRange(Ve)?Ne.j=n.Range.from(Ve):Ve&&(!K?.isEqual(Ve.inserting)||!H?.isEqual(Ve.replacing))&&(Ne.j={insert:n.Range.from(Ve.inserting),replace:n.Range.from(Ve.replacing)}),Ne}}class le{async provideInlineCompletions(z,j,K,H){}disposeCompletions(z){}handleDidShowCompletionItem(z,j,K){}handlePartialAccept(z,j,K,H){}}class V extends le{constructor(z,j,K,H){super(),this.f=z,this.g=j,this.h=K,this.j=H,this.d=new ke,this.e=(0,d.$ZF)(this.f,"inlineCompletionsAdditions"),this.k={[s.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[s.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,d.$ZF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,j,K,H){const ee=this.g.getDocument(z),se=n.Position.to(j),Ne=await this.h.provideInlineCompletionItems(ee,se,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:n.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},H);if(!Ne||H.isCancellationRequested)return;const Ve=Array.isArray(Ne)?Ne:Ne.items,He=this.e?Array.isArray(Ne)?[]:Ne.commands||[]:[],xe=this.e&&!Array.isArray(Ne)?Ne.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Ve}),items:Ve.map((rt,it)=>{let ot;rt.command&&(tt||(tt=new m.$Sc),ot=this.j.toInternal(rt.command,tt));const Be=rt.insertText;return{insertText:typeof Be=="string"?Be:{snippet:Be.value},filterText:rt.filterText,range:rt.range?n.Range.from(rt.range):void 0,command:ot,idx:it,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:He.map(rt=>(tt||(tt=new m.$Sc),this.j.toInternal(rt,tt))),suppressSuggestions:!1,enableForwardStability:xe}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,j,K){const H=this.d.get(z)?.items[j];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,K)}handlePartialAccept(z,j,K,H){const ee=this.d.get(z)?.items[j];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ee,K),this.h.handleDidPartiallyAcceptCompletionItem(ee,n.PartialAcceptInfo.to(H)))}}class _{async provideInlineEdits(z,j,K){const H=this.f.getDocument(z),ee=await this.g.provideInlineEdit(H,{triggerKind:this.e[j.triggerKind]},K);if(!ee||K.isCancellationRequested)return;let se;const Ne=this.d.createReferenceId({dispose(){se?.dispose()},item:ee});let Ve;ee.accepted&&(se||(se=new m.$Sc),Ve=this.h.toInternal(ee.accepted,se));let He;return ee.rejected&&(se||(se=new m.$Sc),He=this.h.toInternal(ee.rejected,se)),{pid:Ne,text:ee.text,range:n.Range.from(ee.range),accepted:Ve,rejected:He}}disposeEdit(z){this.d.disposeReferenceId(z)?.dispose()}constructor(z,j,K,H){this.f=j,this.g=K,this.h=H,this.d=new ke,this.e={[s.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[s.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class ke{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const j=this.e++;return this.d.set(j,z),j}disposeReferenceId(z){const j=this.d.get(z);return this.d.delete(z),j}get(z){return this.d.get(z)}}class Le{constructor(z,j){this.e=z,this.f=j,this.d=new t.$aic("SignatureHelp")}async provideSignatureHelp(z,j,K,H){const ee=this.e.getDocument(z),se=n.Position.to(j),Ne=this.g(K),Ve=await this.f.provideSignatureHelp(ee,se,H,Ne);if(Ve){const He=this.d.add([Ve]);return{...n.SignatureHelp.from(Ve),id:He}}}g(z){let j;if(z.activeSignatureHelp){const K=n.SignatureHelp.to(z.activeSignatureHelp),H=this.d.get(z.activeSignatureHelp.id,0);H?(j=H,j.activeSignature=K.activeSignature,j.activeParameter=K.activeParameter):j=K}return{...z,activeSignatureHelp:j}}releaseSignatureHelp(z){this.d.delete(z)}}class Ee{constructor(z,j,K,H,ee){this.f=z,this.g=j,this.h=K,this.j=H,this.k=ee,this.d=new t.$aic("InlayHints"),this.e=new Map}async provideInlayHints(z,j,K){const H=this.f.getDocument(z),ee=n.Range.to(j),se=await this.h.provideInlayHints(H,ee,K);if(!Array.isArray(se)||se.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`);return}if(K.isCancellationRequested)return;const Ne=this.d.add(se);this.e.set(Ne,new m.$Sc);const Ve={hints:[],cacheId:Ne};for(let He=0;He<se.length;He++)this.l(se[He],ee)&&Ve.hints.push(this.m(se[He],[Ne,He]));return this.j.trace(`[InlayHints] ${Ve.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`),Ve}async resolveInlayHint(z,j){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...z);if(!K)return;const H=await this.h.resolveInlayHint(K,j);if(H&&this.l(H))return this.m(H,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,j){return z.label.length===0||Array.isArray(z.label)&&z.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(j&&!j.contains(z.position))}m(z,j){const K=this.e.get(j[0]);if(!K)throw Error("DisposableStore is missing...");const H={label:"",cacheId:j,tooltip:n.MarkdownString.fromStrict(z.tooltip),position:n.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(n.TextEdit.from),kind:z.kind&&n.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};if(typeof z.label=="string")H.label=z.label;else{const ee=[];H.label=ee;for(const se of z.label){if(!se.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ne={label:se.value,tooltip:n.MarkdownString.fromStrict(se.tooltip)};c.$lM.isLocation(se.location)&&(Ne.location=n.location.from(se.location)),se.command&&(Ne.command=this.g.toInternal(se.command,K)),ee.push(Ne)}}return H}}class be{constructor(z,j){this.e=z,this.f=j,this.d=new t.$aic("DocumentLink")}async provideLinks(z,j){const K=this.e.getDocument(z),H=await this.f.provideDocumentLinks(K,j);if(!(!Array.isArray(H)||H.length===0)&&!j.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(be.g).map(n.DocumentLink.from)};{const ee=this.d.add(H),se={links:[],cacheId:ee};for(let Ne=0;Ne<H.length;Ne++){if(!be.g(H[Ne]))continue;const Ve=n.DocumentLink.from(H[Ne]);Ve.cacheId=[ee,Ne],se.links.push(Ve)}return se}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,j){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...z);if(!K)return;const H=await this.f.resolveDocumentLink(K,j);if(!(!H||!be.g(H)))return n.DocumentLink.from(H)}releaseLinks(z){this.d.delete(z)}}class ge{constructor(z,j){this.d=z,this.e=j}async provideColors(z,j){const K=this.d.getDocument(z),H=await this.e.provideDocumentColors(K,j);return Array.isArray(H)?H.map(se=>({color:n.Color.from(se.color),range:n.Range.from(se.range)})):[]}async provideColorPresentations(z,j,K){const H=this.d.getDocument(z),ee=n.Range.to(j.range),se=n.Color.to(j.color),Ne=await this.e.provideColorPresentations(se,{document:H,range:ee},K);if(Array.isArray(Ne))return Ne.map(n.ColorPresentation.from)}}class G{constructor(z,j){this.d=z,this.e=j}async provideFoldingRanges(z,j,K){const H=this.d.getDocument(z),ee=await this.e.provideFoldingRanges(H,j,K);if(Array.isArray(ee))return ee.map(n.FoldingRange.from)}}class Y{constructor(z,j,K){this.d=z,this.e=j,this.f=K}async provideSelectionRanges(z,j,K){const H=this.d.getDocument(z),ee=j.map(n.Position.to),se=await this.e.provideSelectionRanges(H,ee,K);if(!(0,S.$Lb)(se))return[];if(se.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ne=[];for(let Ve=0;Ve<ee.length;Ve++){const He=[];Ne.push(He);let xe=ee[Ve],tt=se[Ve];for(;;){if(!tt.range.contains(xe))throw new Error("INVALID selection range, must contain the previous range");if(He.push(n.SelectionRange.from(tt)),!tt.parent)break;xe=tt.range,tt=tt.parent}}return Ne}}class he{constructor(z,j){this.f=z,this.g=j,this.d=new R.$uO(""),this.e=new Map}async prepareSession(z,j,K){const H=this.f.getDocument(z),ee=n.Position.to(j),se=await this.g.prepareCallHierarchy(H,ee,K);if(!se)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(se)?se.map(Ve=>this.h(Ne,Ve)):[this.h(Ne,se)]}async provideCallsTo(z,j,K){const H=this.j(z,j);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(H,K);if(ee)return ee.map(se=>({from:this.h(z,se.from),fromRanges:se.fromRanges.map(Ne=>n.Range.from(Ne))}))}async provideCallsFrom(z,j,K){const H=this.j(z,j);if(!H)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(H,K);if(ee)return ee.map(se=>({to:this.h(z,se.to),fromRanges:se.fromRanges.map(Ne=>n.Range.from(Ne))}))}releaseSession(z){this.e.delete(z)}h(z,j){const K=this.e.get(z),H=n.CallHierarchyItem.from(j,z,K.size.toString(36));return K.set(H._itemId,j),H}j(z,j){return this.e.get(z)?.get(j)}}class fe{constructor(z,j){this.f=z,this.g=j,this.d=new R.$uO(""),this.e=new Map}async prepareSession(z,j,K){const H=this.f.getDocument(z),ee=n.Position.to(j),se=await this.g.prepareTypeHierarchy(H,ee,K);if(!se)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(se)?se.map(Ve=>this.h(Ne,Ve)):[this.h(Ne,se)]}async provideSupertypes(z,j,K){const H=this.j(z,j);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(H,K);if(ee)return ee.map(se=>this.h(z,se))}async provideSubtypes(z,j,K){const H=this.j(z,j);if(!H)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(H,K);if(ee)return ee.map(se=>this.h(z,se))}releaseSession(z){this.e.delete(z)}h(z,j){const K=this.e.get(z),H=n.TypeHierarchyItem.from(j,z,K.size.toString(36));return K.set(H._itemId,j),H}j(z,j){return this.e.get(z)?.get(j)}}class Oe{static toInternalProviderId(z,j){return z+"."+j}constructor(z,j,K,H,ee){this.d=z,this.e=j,this.f=K,this.g=H,this.h=ee}async provideDocumentOnDropEdits(z,j,K,H,ee){const se=this.e.getDocument(j),Ne=n.Position.to(K),Ve=n.DataTransfer.toDataTransfer(H,async xe=>(await this.d.$resolveDocumentOnDropFileData(this.g,z,xe)).buffer),He=await this.f.provideDocumentDropEdits(se,Ne,Ve,ee);if(He)return{label:He.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:He.yieldTo?.map(xe=>"mimeType"in xe?xe:{providerId:Oe.toInternalProviderId(xe.extensionId,xe.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?n.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class de{constructor(z,j){this.d=z,this.e=j}async provideMappedEdits(z,j,K,H){const ee=l.URI.revive(z),se=this.d.getDocument(ee),Ne=K.documents.map(xe=>xe.map(tt=>({uri:l.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(lt=>n.Range.to(lt))}))),Ve={documents:Ne,selections:Ne[0]?.[0]?.ranges??[]},He=await this.e.provideMappedEdits(se,j,Ve,H);return He?n.WorkspaceEdit.from(He):null}}class Ce{constructor(z,j){this.adapter=z,this.extension=j}}class Ae{static{this.d=0}constructor(z,j,K,H,ee,se,Ne,Ve){this.g=j,this.h=K,this.j=H,this.k=ee,this.l=se,this.m=Ne,this.n=Ve,this.f=new Map,this.e=z.getProxy(p.$0L.MainThreadLanguageFeatures)}o(z,j){return n.DocumentSelector.from(z,this.g,j)}p(z){return new c.$_L(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return Ae.d++}async s(z,j,K,H,ee,se=!1){const Ne=this.f.get(z);if(!Ne||!(Ne.adapter instanceof j))return H;const Ve=Date.now();se||this.l.trace(`[${Ne.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const He=K(Ne.adapter,Ne.extension);return Promise.resolve(He).catch(xe=>{(0,F.$4)(xe)||(this.l.error(`[${Ne.extension.identifier.value}] provider FAILED`),this.l.error(xe),this.n.onExtensionError(Ne.extension.identifier,xe))}).finally(()=>{se||this.l.trace(`[${Ne.extension.identifier.value}] provider DONE after ${Date.now()-Ve}ms`)}),P.CancellationToken.isCancellationToken(ee)?(0,M.$8g)(He,ee):He}t(z,j){const K=this.q();return this.f.set(K,new Ce(z,j)),K}static u(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,j,K,H){const ee=this.t(new u(this.h,K),z),se=H&&H.label||Ae.u(z);return this.e.$registerDocumentSymbolProvider(ee,this.o(j,z),se),this.p(ee)}$provideDocumentSymbols(z,j,K){return this.s(z,u,H=>H.provideDocumentSymbols(l.URI.revive(j),K),void 0,K)}registerCodeLensProvider(z,j,K){const H=this.q(),ee=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new Ce(new o(this.h,this.j.converter,K,z,this.n,this.l),z)),this.e.$registerCodeLensSupport(H,this.o(j,z),ee);let se=this.p(H);if(ee!==void 0){const Ne=K.onDidChangeCodeLenses(Ve=>this.e.$emitCodeLensEvent(ee));se=c.$_L.from(se,Ne)}return se}$provideCodeLenses(z,j,K){return this.s(z,o,H=>H.provideCodeLenses(l.URI.revive(j),K),void 0,K)}$resolveCodeLens(z,j,K){return this.s(z,o,H=>H.resolveCodeLens(j,K),void 0,void 0)}$releaseCodeLenses(z,j){this.s(z,o,K=>Promise.resolve(K.releaseCodeLenses(j)),void 0,void 0)}registerDefinitionProvider(z,j,K){const H=this.t(new b(this.h,K),z);return this.e.$registerDefinitionSupport(H,this.o(j,z)),this.p(H)}$provideDefinition(z,j,K,H){return this.s(z,b,ee=>ee.provideDefinition(l.URI.revive(j),K,H),[],H)}registerDeclarationProvider(z,j,K){const H=this.t(new $(this.h,K),z);return this.e.$registerDeclarationSupport(H,this.o(j,z)),this.p(H)}$provideDeclaration(z,j,K,H){return this.s(z,$,ee=>ee.provideDeclaration(l.URI.revive(j),K,H),[],H)}registerImplementationProvider(z,j,K){const H=this.t(new I(this.h,K),z);return this.e.$registerImplementationSupport(H,this.o(j,z)),this.p(H)}$provideImplementation(z,j,K,H){return this.s(z,I,ee=>ee.provideImplementation(l.URI.revive(j),K,H),[],H)}registerTypeDefinitionProvider(z,j,K){const H=this.t(new h(this.h,K),z);return this.e.$registerTypeDefinitionSupport(H,this.o(j,z)),this.p(H)}$provideTypeDefinition(z,j,K,H){return this.s(z,h,ee=>ee.provideTypeDefinition(l.URI.revive(j),K,H),[],H)}registerHoverProvider(z,j,K,H){const ee=this.t(new y(this.h,K),z);return this.e.$registerHoverProvider(ee,this.o(j,z)),this.p(ee)}$provideHover(z,j,K,H){return this.s(z,y,ee=>ee.provideHover(l.URI.revive(j),K,H),void 0,H)}registerEvaluatableExpressionProvider(z,j,K,H){const ee=this.t(new w(this.h,K),z);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(j,z)),this.p(ee)}$provideEvaluatableExpression(z,j,K,H){return this.s(z,w,ee=>ee.provideEvaluatableExpression(l.URI.revive(j),K,H),void 0,H)}registerInlineValuesProvider(z,j,K,H){const ee=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,se=this.t(new A(this.h,K),z);this.e.$registerInlineValuesProvider(se,this.o(j,z),ee);let Ne=this.p(se);if(ee!==void 0){const Ve=K.onDidChangeInlineValues(He=>this.e.$emitInlineValuesEvent(ee));Ne=c.$_L.from(Ne,Ve)}return Ne}$provideInlineValues(z,j,K,H,ee){return this.s(z,A,se=>se.provideInlineValues(l.URI.revive(j),K,H,ee),void 0,ee)}registerDocumentHighlightProvider(z,j,K){const H=this.t(new L(this.h,K),z);return this.e.$registerDocumentHighlightProvider(H,this.o(j,z)),this.p(H)}registerMultiDocumentHighlightProvider(z,j,K){const H=this.t(new J(this.h,K),z);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(j,z)),this.p(H)}$provideDocumentHighlights(z,j,K,H){return this.s(z,L,ee=>ee.provideDocumentHighlights(l.URI.revive(j),K,H),void 0,H)}$provideMultiDocumentHighlights(z,j,K,H,ee){return this.s(z,J,se=>se.provideMultiDocumentHighlights(l.URI.revive(j),K,H.map(Ne=>l.URI.revive(Ne)),ee),void 0,ee)}registerLinkedEditingRangeProvider(z,j,K){const H=this.t(new W(this.h,K),z);return this.e.$registerLinkedEditingRangeProvider(H,this.o(j,z)),this.p(H)}$provideLinkedEditingRanges(z,j,K,H){return this.s(z,W,async ee=>{const se=await ee.provideLinkedEditingRanges(l.URI.revive(j),K,H);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?Ae.w(se.wordPattern):void 0}},void 0,H)}registerReferenceProvider(z,j,K){const H=this.t(new U(this.h,K),z);return this.e.$registerReferenceSupport(H,this.o(j,z)),this.p(H)}$provideReferences(z,j,K,H,ee){return this.s(z,U,se=>se.provideReferences(l.URI.revive(j),K,H,ee),void 0,ee)}registerCodeActionProvider(z,j,K,H){const ee=new m.$Sc,se=this.t(new C(this.h,this.j.converter,this.k,K,this.l,z,this.m),z);return this.e.$registerQuickFixSupport(se,this.o(j,z),{providedKinds:H?.providedCodeActionKinds?.map(Ne=>Ne.value),documentation:H?.documentation?.map(Ne=>({kind:Ne.kind.value,command:this.j.converter.toInternal(Ne.command,ee)}))},Ae.u(z),!!K.resolveCodeAction),ee.add(this.p(se)),ee}$provideCodeActions(z,j,K,H,ee){return this.s(z,C,se=>se.provideCodeActions(l.URI.revive(j),K,H,ee),void 0,ee)}$resolveCodeAction(z,j,K){return this.s(z,C,H=>H.resolveCodeAction(j,K),{},void 0)}$releaseCodeActions(z,j){this.s(z,C,K=>Promise.resolve(K.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(z,j,K){const H=this.t(new q(this.h,K),z);return this.e.$registerDocumentFormattingSupport(H,this.o(j,z),z.identifier,z.displayName||z.name),this.p(H)}$provideDocumentFormattingEdits(z,j,K,H){return this.s(z,q,ee=>ee.provideDocumentFormattingEdits(l.URI.revive(j),K,H),void 0,H)}registerDocumentRangeFormattingEditProvider(z,j,K){const H=typeof K.provideDocumentRangesFormattingEdits=="function",ee=this.t(new ne(this.h,K),z);return this.e.$registerRangeFormattingSupport(ee,this.o(j,z),z.identifier,z.displayName||z.name,H),this.p(ee)}$provideDocumentRangeFormattingEdits(z,j,K,H,ee){return this.s(z,ne,se=>se.provideDocumentRangeFormattingEdits(l.URI.revive(j),K,H,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(z,j,K,H,ee){return this.s(z,ne,se=>se.provideDocumentRangesFormattingEdits(l.URI.revive(j),K,H,ee),void 0,ee)}registerOnTypeFormattingEditProvider(z,j,K,H){const ee=this.t(new ce(this.h,K),z);return this.e.$registerOnTypeFormattingSupport(ee,this.o(j,z),H,z.identifier),this.p(ee)}$provideOnTypeFormattingEdits(z,j,K,H,ee,se){return this.s(z,ce,Ne=>Ne.provideOnTypeFormattingEdits(l.URI.revive(j),K,H,ee,se),void 0,se)}registerWorkspaceSymbolProvider(z,j){const K=this.t(new ye(j,this.l),z);return this.e.$registerNavigateTypeSupport(K,typeof j.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(z,j,K){return this.s(z,ye,H=>H.provideWorkspaceSymbols(j,K),{symbols:[]},K)}$resolveWorkspaceSymbol(z,j,K){return this.s(z,ye,H=>H.resolveWorkspaceSymbol(j,K),void 0,void 0)}$releaseWorkspaceSymbols(z,j){this.s(z,ye,K=>K.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(z,j,K){const H=this.t(new Ie(this.h,K,this.l),z);return this.e.$registerRenameSupport(H,this.o(j,z),Ie.supportsResolving(K)),this.p(H)}$provideRenameEdits(z,j,K,H,ee){return this.s(z,Ie,se=>se.provideRenameEdits(l.URI.revive(j),K,H,ee),void 0,ee)}$resolveRenameLocation(z,j,K,H){return this.s(z,Ie,ee=>ee.resolveRenameLocation(l.URI.revive(j),K,H),void 0,H)}registerNewSymbolNamesProvider(z,j,K){const H=this.t(new ue(this.h,K,this.l),z);return this.e.$registerNewSymbolNamesProvider(H,this.o(j,z)),this.p(H)}$provideNewSymbolNames(z,j,K,H){return this.s(z,ue,ee=>ee.provideNewSymbolNames(l.URI.revive(j),K,H),void 0,H)}registerDocumentSemanticTokensProvider(z,j,K,H){const ee=this.t(new re(this.h,K),z),se=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(j,z),H,se);let Ne=this.p(ee);if(se){const Ve=K.onDidChangeSemanticTokens(He=>this.e.$emitDocumentSemanticTokensEvent(se));Ne=c.$_L.from(Ne,Ve)}return Ne}$provideDocumentSemanticTokens(z,j,K,H){return this.s(z,re,ee=>ee.provideDocumentSemanticTokens(l.URI.revive(j),K,H),null,H)}$releaseDocumentSemanticTokens(z,j){this.s(z,re,K=>K.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,j,K,H){const ee=this.t(new $e(this.h,K),z);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(j,z),H),this.p(ee)}$provideDocumentRangeSemanticTokens(z,j,K,H){return this.s(z,$e,ee=>ee.provideDocumentRangeSemanticTokens(l.URI.revive(j),K,H),null,H)}registerCompletionItemProvider(z,j,K,H){const ee=this.t(new ie(this.h,this.j.converter,K,this.m,z),z);return this.e.$registerCompletionsProvider(ee,this.o(j,z),H,ie.supportsResolving(K),z.identifier),this.p(ee)}$provideCompletionItems(z,j,K,H,ee){return this.s(z,ie,se=>se.provideCompletionItems(l.URI.revive(j),K,H,ee),void 0,ee)}$resolveCompletionItem(z,j,K){return this.s(z,ie,H=>H.resolveCompletionItem(j,K),void 0,K)}$releaseCompletionItems(z,j){this.s(z,ie,K=>K.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(z,j,K,H){const ee=new V(z,this.h,K,this.j.converter),se=this.t(ee,z);return this.e.$registerInlineCompletionsSupport(se,this.o(j,z),ee.supportsHandleEvents,i.$Am.toKey(z.identifier.value),H?.yieldTo?.map(Ne=>i.$Am.toKey(Ne))||[]),this.p(se)}$provideInlineCompletions(z,j,K,H,ee){return this.s(z,le,se=>se.provideInlineCompletions(l.URI.revive(j),K,H,ee),void 0,ee)}$handleInlineCompletionDidShow(z,j,K,H){this.s(z,le,async ee=>{ee.handleDidShowCompletionItem(j,K,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,j,K,H,ee){this.s(z,le,async se=>{se.handlePartialAccept(j,K,H,ee)},void 0,void 0)}$freeInlineCompletionsList(z,j){this.s(z,le,async K=>{K.disposeCompletions(j)},void 0,void 0)}registerInlineEditProvider(z,j,K){const H=new _(z,this.h,K,this.j.converter),ee=this.t(H,z);return this.e.$registerInlineEditProvider(ee,this.o(j,z),z.identifier),this.p(ee)}$provideInlineEdit(z,j,K,H){return this.s(z,_,ee=>ee.provideInlineEdits(l.URI.revive(j),K,H),void 0,H)}$freeInlineEdit(z,j){this.s(z,_,async K=>{K.disposeEdit(j)},void 0,void 0)}registerSignatureHelpProvider(z,j,K,H){const ee=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,se=this.t(new Le(this.h,K),z);return this.e.$registerSignatureHelpProvider(se,this.o(j,z),ee),this.p(se)}$provideSignatureHelp(z,j,K,H,ee){return this.s(z,Le,se=>se.provideSignatureHelp(l.URI.revive(j),K,H,ee),void 0,ee)}$releaseSignatureHelp(z,j){this.s(z,Le,K=>K.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(z,j,K){const H=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new Ee(this.h,this.j.converter,K,this.l,z),z);this.e.$registerInlayHintsProvider(ee,this.o(j,z),typeof K.resolveInlayHint=="function",H,Ae.u(z));let se=this.p(ee);if(H!==void 0){const Ne=K.onDidChangeInlayHints(Ve=>this.e.$emitInlayHintsEvent(H));se=c.$_L.from(se,Ne)}return se}$provideInlayHints(z,j,K,H){return this.s(z,Ee,ee=>ee.provideInlayHints(l.URI.revive(j),K,H),void 0,H)}$resolveInlayHint(z,j,K){return this.s(z,Ee,H=>H.resolveInlayHint(j,K),void 0,K)}$releaseInlayHints(z,j){this.s(z,Ee,K=>K.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(z,j,K){const H=this.t(new be(this.h,K),z);return this.e.$registerDocumentLinkProvider(H,this.o(j,z),typeof K.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(z,j,K){return this.s(z,be,H=>H.provideLinks(l.URI.revive(j),K),void 0,K,j.scheme==="output")}$resolveDocumentLink(z,j,K){return this.s(z,be,H=>H.resolveLink(j,K),void 0,void 0,!0)}$releaseDocumentLinks(z,j){this.s(z,be,K=>K.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(z,j,K){const H=this.t(new ge(this.h,K),z);return this.e.$registerDocumentColorProvider(H,this.o(j,z)),this.p(H)}$provideDocumentColors(z,j,K){return this.s(z,ge,H=>H.provideColors(l.URI.revive(j),K),[],K)}$provideColorPresentations(z,j,K,H){return this.s(z,ge,ee=>ee.provideColorPresentations(l.URI.revive(j),K,H),void 0,H)}registerFoldingRangeProvider(z,j,K){const H=this.q(),ee=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new Ce(new G(this.h,K),z)),this.e.$registerFoldingRangeProvider(H,this.o(j,z),z.identifier,ee);let se=this.p(H);if(ee!==void 0){const Ne=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));se=c.$_L.from(se,Ne)}return se}$provideFoldingRanges(z,j,K,H){return this.s(z,G,ee=>ee.provideFoldingRanges(l.URI.revive(j),K,H),void 0,H)}registerSelectionRangeProvider(z,j,K){const H=this.t(new Y(this.h,K,this.l),z);return this.e.$registerSelectionRangeProvider(H,this.o(j,z)),this.p(H)}$provideSelectionRanges(z,j,K,H){return this.s(z,Y,ee=>ee.provideSelectionRanges(l.URI.revive(j),K,H),[],H)}registerCallHierarchyProvider(z,j,K){const H=this.t(new he(this.h,K),z);return this.e.$registerCallHierarchyProvider(H,this.o(j,z)),this.p(H)}$prepareCallHierarchy(z,j,K,H){return this.s(z,he,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(j),K,H)),void 0,H)}$provideCallHierarchyIncomingCalls(z,j,K,H){return this.s(z,he,ee=>ee.provideCallsTo(j,K,H),void 0,H)}$provideCallHierarchyOutgoingCalls(z,j,K,H){return this.s(z,he,ee=>ee.provideCallsFrom(j,K,H),void 0,H)}$releaseCallHierarchy(z,j){this.s(z,he,K=>Promise.resolve(K.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(z,j,K){const H=this.t(new fe(this.h,K),z);return this.e.$registerTypeHierarchyProvider(H,this.o(j,z)),this.p(H)}$prepareTypeHierarchy(z,j,K,H){return this.s(z,fe,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(j),K,H)),void 0,H)}$provideTypeHierarchySupertypes(z,j,K,H){return this.s(z,fe,ee=>ee.provideSupertypes(j,K,H),void 0,H)}$provideTypeHierarchySubtypes(z,j,K,H){return this.s(z,fe,ee=>ee.provideSubtypes(j,K,H),void 0,H)}$releaseTypeHierarchy(z,j){this.s(z,fe,K=>Promise.resolve(K.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(z,j,K,H){const ee=this.q();this.f.set(ee,new Ce(new Oe(this.e,this.h,K,ee,z),z));const se=(0,d.$ZF)(z,"dropMetadata")&&H?Oe.toInternalProviderId(z.identifier.value,H.id):void 0;return this.e.$registerDocumentOnDropEditProvider(ee,this.o(j,z),se,(0,d.$ZF)(z,"dropMetadata")?H:void 0),this.p(ee)}$provideDocumentOnDropEdits(z,j,K,H,ee,se){return this.s(z,Oe,Ne=>Promise.resolve(Ne.provideDocumentOnDropEdits(j,l.URI.revive(K),H,ee,se)),void 0,void 0)}registerMappedEditsProvider(z,j,K){const H=this.t(new de(this.h,K),z);return this.e.$registerMappedEditsProvider(H,this.o(j,z)),this.p(H)}$provideMappedEdits(z,j,K,H,ee){return this.s(z,de,se=>Promise.resolve(se.provideMappedEdits(j,K,H,ee)),null,ee)}registerDocumentPasteEditProvider(z,j,K,H){const ee=this.q();this.f.set(ee,new Ce(new O(this.e,this.h,K,ee,z),z));const se=O.toInternalProviderId(z.identifier.value,H.id);return this.e.$registerPasteEditProvider(ee,this.o(j,z),se,{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(z,j,K,H,ee){return this.s(z,O,se=>se.prepareDocumentPaste(l.URI.revive(j),K,H,ee),void 0,ee)}$providePasteEdits(z,j,K,H,ee,se){return this.s(z,O,Ne=>Ne.providePasteEdits(j,l.URI.revive(K),H,ee,se),void 0,se)}static w(z){return{pattern:z.source,flags:z.flags}}static y(z){return{decreaseIndentPattern:Ae.w(z.decreaseIndentPattern),increaseIndentPattern:Ae.w(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Ae.w(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Ae.w(z.unIndentedLinePattern):void 0}}static z(z){return{beforeText:Ae.w(z.beforeText),afterText:z.afterText?Ae.w(z.afterText):void 0,previousLineText:z.previousLineText?Ae.w(z.previousLineText):void 0,action:z.action}}static B(z){return z.map(Ae.z)}static C(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(j=>c.SyntaxTokenType.toString(j)):void 0}}static D(z){return z.map(Ae.C)}setLanguageConfiguration(z,j,K){const{wordPattern:H}=K;if(H&&(0,N.$9e)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(j,H):this.h.setWordDefinitionFor(j,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const ee=this.q(),se={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Ae.w(K.wordPattern):void 0,indentationRules:K.indentationRules?Ae.y(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Ae.B(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?Ae.D(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,j,se),this.p(ee)}$setWordDefinitions(z){for(const j of z)this.h.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.$kic=Ae}),define(Pe[88],Re([1,0,6,4,8,7,101,20,11,5,164,106,14,3,17,84,13]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g,s,a){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=e.$ric=void 0,e.$ric=(0,k.$gi)("IExtHostLanguageModels");class i{constructor(t,p){this.option=t,this.stream=new f.$Jh,this.stream=p??new f.$Jh}}class n{constructor(){this.a=new Map,this.b=new f.$Jh,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let p=this.a.get(t.index);p||(this.a.size===0?p=new i(t.index,this.b):p=new i(t.index),this.a.set(t.index,p)),p.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const p of this.f())p.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let c=class{static{r=this}static{this.a=1}constructor(t,p,u){this.j=p,this.k=u,this.c=new E.$6d,this.d=new E.$6d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new m.$Cm,this.i=new Map,this.o=new Set,this.b=t.getProxy(M.$0L.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,p,u,o){const v=r.a++;this.f.set(v,{extension:t.identifier,provider:u,languageModelId:p});let b;return o.auth&&(b={providerLabel:t.displayName||t.name,accountLabel:typeof o.auth=="object"?o.auth.label:void 0}),this.b.$registerLanguageModelProvider(v,p,{extension:t.identifier,identifier:p,model:o.name??"",auth:b}),(0,S.$Rc)(()=>{this.f.delete(v),this.b.$unregisterProvider(v)})}async $provideLanguageModelResponse(t,p,u,o,v,b){const $=this.f.get(t);if(!$)return;const I=new R.$Lv(async h=>{if(b.isCancellationRequested){this.j.warn(`[CHAT](${$.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(p,{index:h.index,part:h.part})});return $.provider.provideLanguageModelResponse2(o.map(P.LanguageModelMessage.to),v,m.$Am.toKey(u),I,b)}$updateLanguageModels(t){const p=[],u=[];if(t.added)for(const o of t.added)this.g.set(o.identifier,o),p.push(o.model);if(t.removed)for(const o of t.removed){this.g.delete(o),u.push(o);for(const[v,b]of this.i)b.languageModelId===o&&(b.res.reject(new l.$5),this.i.delete(v))}this.d.fire(Object.freeze({added:Object.freeze(p),removed:Object.freeze(u)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const p=new Array;for(const{from:u,to:o,enabled:v}of t){const b=this.h.get(u)??new m.$Bm;if(b.has(o)!==v){v?b.add(o):b.delete(o),this.h.set(u,b);const I={from:u,to:o};p.push(I),this.c.fire(I)}}}async sendChatRequest(t,p,u,o,v){const b=t.identifier,$=await this.b.$prepareChatAccess(b,p,o.justification);if(!$||!this.g.has(p))throw F.$dO.NotFound(`Language model '${p}' is unknown.`);if(this.m(b,$)&&(!await this.l(t,{identifier:$.extension,displayName:$.auth.providerLabel},o.justification,o.silent)||!this.h.get(b)?.has($.extension)))throw F.$dO.NoPermissions(`Language model '${p}' cannot be used by '${b.value}'.`);const I=Math.random()*1e6|0,h=this.b.$fetchResponse(b,p,I,u.map(P.LanguageModelMessage.from),o.modelOptions??{},v),y=new f.$fh,w=new n;this.i.set(I,{languageModelId:p,res:w});let A;if(h.catch(L=>{y.isOpen()?w.reject(L):A=L}).finally(()=>{this.i.delete(I),w.resolve(),y.open()}),await y.wait(),A)throw new F.$dO(`Language model '${p}' errored, check cause for more details`,"Unknown",A);return w.apiObject}async $handleResponseFragment(t,p){const u=this.i.get(t);u&&u.res.handleFragment(p)}async l(t,p,u,o){const v=D.$cL+p.identifier.value;if(await this.k.getSession(t,v,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:p.identifier,enabled:!0}]),!0;if(o)return!1;try{const $=u?(0,N.localize)(0,null,p.displayName,u):(0,N.localize)(1,null,p.displayName);return await this.k.getSession(t,v,[],{forceNewSession:{detail:$}}),this.$updateModelAccesslist([{from:t.identifier,to:p.identifier,enabled:!0}]),!0}catch{return!1}}m(t,p){return!!p.auth&&!m.$Am.equals(p.extension,t)}async n(t){for(const p of this.o)try{await this.l(p,{identifier:t.extension,displayName:""},void 0,!0)}catch(u){this.j.error("Fake Auth request failed"),this.j.error(u)}}createLanguageModelAccessInformation(t){this.o.add(t);const p=this,u=E.Event.signal(E.Event.filter(this.c.event,v=>m.$Am.equals(v.from,t.identifier))),o=E.Event.signal(this.d.event);return{get onDidChange(){return E.Event.any(u,o)},canSendRequest(v){const b=p.g.get(v);if(!b)return;if(!p.m(t.identifier,b))return!0;const $=p.h.get(t.identifier);if($)return $.has(b.extension)}}}};e.$sic=c,e.$sic=c=r=Qe([qe(0,g.$pO),qe(1,a.$Aj),qe(2,s.$mic)],c)}),define(Pe[260],Re([1,0,4,8,7,32,11,6,22]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ljc=void 0;class E{constructor(D,l,k,g){this.c=l,this.d=k,this.e=g,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(S.$0L.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,l){await this.a.$changeLanguage(D,l);const k=this.c.getDocumentData(D);if(!k)throw new Error(`document '${D.toString()}' NOT found`);return k.document}async tokenAtPosition(D,l){const k=D.version,g=M.Position.from(l),s=await this.a.$tokensAtPosition(D.uri,g),a={type:P.StandardTokenType.Other,range:D.getWordRangeAtPosition(l)??new P.$bM(l.line,l.character,l.line,l.character)};if(!s)return a;const r={range:M.Range.to(s.range),type:M.TokenType.to(s.type)};return!r.range.contains(l)||k!==D.version?a:r}createLanguageStatusItem(D,l,k){const g=this.f++,s=this.a,a=this.g,r=`${D.identifier.value}/${l}`;if(a.has(r))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);a.add(r);const i={selector:k,id:l,name:D.displayName??D.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const c=new m.$Sc,d=()=>{if(n?.dispose(),!a.has(r)){console.warn(`LanguageStatusItem (${l}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.$ih)(()=>{c.clear(),this.a.$setLanguageStatus(g,{id:r,name:i.name??D.displayName??D.name,source:D.displayName??D.name,selector:M.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===P.LanguageStatusSeverity.Error?F.default.Error:i.severity===P.LanguageStatusSeverity.Warning?F.default.Warning:F.default.Info,command:i.command&&this.d.toInternal(i.command,c),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){c.dispose(),n?.dispose(),s.$removeLanguageStatus(g),a.delete(r)},get id(){return i.id},get name(){return i.name},set name(p){i.name=p,d()},get selector(){return i.selector},set selector(p){i.selector=p,d()},get text(){return i.text},set text(p){i.text=p,d()},set text2(p){(0,f.$1F)(D,"languageStatusText"),i.text=p,d()},get text2(){return(0,f.$1F)(D,"languageStatusText"),i.text},get detail(){return i.detail},set detail(p){i.detail=p,d()},get severity(){return i.severity},set severity(p){i.severity=p,d()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(p){i.accessibilityInformation=p,d()},get command(){return i.command},set command(p){i.command=p,d()},get busy(){return i.busy},set busy(p){i.busy=p,d()}};return d(),t}}e.$Ljc=E}),define(Pe[261],Re([1,0,12,2,8,7,83]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xjc=e.$wjc=void 0;class m{constructor(D,l,k,g){this.start=D,this.deletedCount=l,this.deletedItems=k,this.items=g}asApiEvent(){return{range:new F.$zN(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class f{static asModelAddData(D){return{EOL:D.eol,lines:D.source,languageId:D.language,uri:D.uri,isDirty:!1,versionId:1}}constructor(D,l,k){this.notebook=D,this.h=l,this.j=k,this.handle=k.handle,this.uri=M.URI.revive(k.uri),this.cellKind=k.cellKind,this.a=k.outputs.map(P.NotebookCellOutput.to),this.e=k.internalMetadata??{},this.b=Object.freeze(k.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return D.g},set mime(g){D.g=g},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(k)}return this.f}setOutputs(D){this.a=D.map(P.NotebookCellOutput.to)}setOutputItems(D,l,k){const g=k.map(P.NotebookCellOutputItem.to),s=this.a.find(a=>a.id===D);if(s&&(l||(s.items.length=0),s.items.push(...g),s.items.length>1&&s.items.every(a=>R.$9J(a.mime)))){const a=new Map,r=[];s.items.forEach(i=>{let n;a.has(i.mime)?n=a.get(i.mime):(n=[],a.set(i.mime,n),r.push(i.mime)),n.push(i.data)}),s.items.length=0,r.forEach(i=>{const n=R.$0J(a.get(i));s.items.push({mime:i,data:n.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$wjc=f;class E{static{this.a=0}constructor(D,l,k,g,s){this.k=D,this.l=l,this.m=k,this.uri=g,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,l={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===S.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(k){return k=D.n(k),D.b[k].apiCell},getCells(k){return(k?D.p(k):D.b).map(s=>s.apiCell)},save(){return D.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,l,k){this.g=D.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:k});const g={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},s=[];for(const r of D.rawEvents)r.kind===R.NotebookCellsChangeType.ModelChange?this.r(r.changes,!1,g.contentChanges):r.kind===R.NotebookCellsChangeType.Move?this.s(r.index,r.length,r.newIdx,g.contentChanges):r.kind===R.NotebookCellsChangeType.Output?(this.t(r.index,r.outputs),s.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===R.NotebookCellsChangeType.OutputItem?(this.u(r.index,r.outputId,r.append,r.outputItems),s.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(r.index,r.language),s.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document})):r.kind===R.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document}):r.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(r.index,r.mime):r.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(r.index,r.metadata),s.push({cell:this.b[r.index].apiCell,metadata:this.b[r.index].apiCell.metadata})):r.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(r.index,r.internalMetadata),s.push({cell:this.b[r.index].apiCell,executionSummary:this.b[r.index].apiCell.executionSummary}));const a=new Map;for(let r=0;r<s.length;r++){const i=s[r],n=a.get(i.cell);if(n===void 0){const c=g.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});a.set(i.cell,c-1)}else g.cellChanges[n]={...g.cellChanges[n],...i}}return Object.freeze(g),Object.freeze(g.cellChanges),Object.freeze(g.contentChanges),g}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let l=D.start|0,k=D.end|0;return l<0&&(l=0),k>this.b.length&&(k=this.b.length),D.with({start:l,end:k})}p(D){D=this.o(D);const l=[];for(let k=D.start;k<D.end;k++)l.push(this.b[k]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,l,k){if(this.j)return;const g=[],s=[],a=[];if(D.reverse().forEach(r=>{const n=r[2].map(t=>{const p=new f(this,this.l,t);return l||s.push(f.asModelAddData(t)),p}),c=new m(r[0],r[1],[],n),d=this.b.splice(r[0],r[1],...n);for(const t of d)a.push(t.uri),c.deletedItems.push(t.apiCell);g.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:a}),k)for(const r of g)k.push(r.asApiEvent())}s(D,l,k,g){const s=this.b.splice(D,l);this.b.splice(k,0,...s);const a=[new m(D,l,s.map(r=>r.apiCell),[]),new m(k,0,[],s)];for(const r of a)g.push(r.asApiEvent())}t(D,l){this.b[D].setOutputs(l)}u(D,l,k,g){this.b[D].setOutputItems(l,k,g)}v(D,l){const k=this.b[D];k.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(k.uri,l)}w(D,l){const k=this.b[D];k.apiCell.mime=l}x(D,l){this.b[D].setMetadata(l)}y(D,l){this.b[D].setInternalMetadata(l)}getCellFromApiCell(D){return this.b.find(l=>l.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(l=>l.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$xjc=E}),define(Pe[262],Re([1,0,5,2,8,7]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Njc=void 0;class R{constructor(f,E,N,D={timeout:1500,errors:3}){this.b=f,this.c=E,this.d=N,this.f=D,this.a=new S.$8d}dispose(){}getOnWillSaveNotebookDocumentEvent(f){return(E,N,D)=>{const l=function(g){E.call(N,g)};return l.extension=f,this.a.event(l,void 0,D)}}async $participateInSave(f,E,N){const D=M.URI.revive(f),l=this.c.getNotebookDocument(D);if(!l)throw new Error("Unable to resolve notebook document");const k=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:P.TextDocumentSaveReason.to(E)},N,async(s,a)=>{const r=Date.now(),i=await await Promise.resolve(s);Date.now()-r>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!N.isCancellationRequested&&i&&(i instanceof F.$jM?k.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),N.isCancellationRequested)return!1;if(k.length===0)return!0;const g={edits:[]};for(const s of k){const{edits:a}=P.WorkspaceEdit.from(s);g.edits=g.edits.concat(a)}return this.d.$tryApplyWorkspaceEdit(g)}}e.$Njc=R}),define(Pe[112],Re([1,0,14,8,7]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yjc=void 0;class F{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,f,E,N,D,l){this.id=m,this.f=f,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=N,this.c=l}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(f){this.selections=[f]},get selections(){return m.a},set selections(f){if(!Array.isArray(f)||!f.every(P.$zN.isNotebookRange))throw(0,S.$7)("selections");m.a=f,m.g(f)},get visibleRanges(){return m.b},revealRange(f,E){m.f.$tryRevealRange(m.id,M.NotebookRange.from(f),E??P.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},F.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(M.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$yjc=F}),define(Pe[263],Re([1,0,5,13,8]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pjc=void 0;let F=class{constructor(m,f){this.c=m,this.d=f,this.a=new S.$6d,this.b=new S.$6d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(m,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,f);const E=this.d.getEditorById(m);f.visibleRanges&&E._acceptVisibleRanges(f.visibleRanges.ranges.map(P.NotebookRange.to)),f.selections&&E._acceptSelections(f.selections.selections.map(P.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const f in m)this.d.getEditorById(f)._acceptViewColumn(P.ViewColumn.to(m[f]))}};e.$Pjc=F,e.$Pjc=F=Qe([qe(0,M.$Aj)],F)}),define(Pe[264],Re([1,0,5,4,112]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sjc=void 0;class F{constructor(m,f){this.c=f,this.a=new Map,this.b=m.getProxy(M.$0L.MainThreadNotebookRenderers)}$postRendererMessage(m,f,E){const N=this.c.getEditorById(m);this.a.get(f)?.fire({editor:N.apiEditor,message:E})}createRendererMessaging(m,f){if(!m.contributes?.notebookRenderer?.some(N=>N.id===f))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${f})`);return{onDidReceiveMessage:(N,D,l)=>this.d(f).event(N,D,l),postMessage:(N,D)=>{P.$yjc.apiEditorsToExtHost.has(N)&&([N,D]=[D,N]);const l=D&&P.$yjc.apiEditorsToExtHost.get(D);return this.b.$postMessage(l?.id,f,N)}}}d(m){let f=this.a.get(m);return f||(f=new S.$6d({onDidRemoveLastListener:()=>{f?.dispose(),this.a.delete(m)}}),this.a.set(m,f),f)}}e.$Sjc=F}),define(Pe[265],Re([1,0,8,101,25,68,14]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wjc=void 0;class m{constructor(D){this.b=0,this.c=new Map,this.a=D}async withProgress(D,l,k){const g=this.b++,{title:s,location:a,cancellable:r}=l,i={label:D.displayName||D.name,id:D.identifier.value};return this.a.$startProgress(g,{location:S.ProgressLocation.from(a),title:s,source:i,cancellable:r},D.isUnderDevelopment?void 0:D.identifier.value).catch(R.$2),this.d(g,k,!!r)}d(D,l,k){let g;k&&(g=new P.$de,this.c.set(D,g));const s=r=>{this.a.$progressEnd(r),this.c.delete(r),g?.dispose()};let a;try{a=l(new E(this.a,D),k&&g?g.token:P.CancellationToken.None)}catch(r){throw s(D),r}return a.then(r=>s(D),r=>s(D)),a}$acceptProgressCanceled(D){const l=this.c.get(D);l&&(l.cancel(),this.c.delete(D))}}e.$Wjc=m;function f(N,D){return N.message=D.message,typeof D.increment=="number"&&(typeof N.increment=="number"?N.increment+=D.increment:N.increment=D.increment),N}class E extends M.$Lv{constructor(D,l){super(k=>this.throttledReport(k)),this.c=D,this.d=l}throttledReport(D){this.c.$progressReport(this.d,D)}}Qe([(0,F.$Mh)(100,(N,D)=>f(N,D),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(Pe[266],Re([1,0,2,4,11,8]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xjc=void 0;class R{static{this.a=0}constructor(f,E){this.d=E,this.c=new Map,this.b=f.getProxy(M.$0L.MainThreadQuickDiff)}$provideOriginalResource(f,E,N){const D=S.URI.revive(E),l=this.c.get(f);return l?(0,P.$$g)(()=>l.provideOriginalResource(D,N)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider(f,E,N,D){const l=R.a++;return this.c.set(l,E),this.b.$registerQuickDiffProvider(l,F.DocumentSelector.from(f,this.d),N,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$Xjc=R}),define(Pe[267],Re([1,0,25,5,6,4,2,7,14,18,32,40,22,8]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yjc=void 0;function g(s,a,r){const i=s.getProxy(F.$0L.MainThreadQuickOpen);class n{constructor($,I){this.e=new Map,this.f=0,this.a=$,this.b=I}showQuickPick($,I,h,y=S.CancellationToken.None){this.c=void 0;const w=Promise.resolve(I),A=++this.f,L=i.$show(A,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},y),J={},W=L.then(()=>J);return Promise.race([W,w]).then(U=>{if(U===J)return;const C=(0,l.$ZF)($,"quickPickItemTooltip");return w.then(O=>{const q=[];for(let ne=0;ne<O.length;ne++){const ce=O[ne];if(typeof ce=="string")q.push({label:ce,handle:ne});else if(ce.kind===m.QuickPickItemKind.Separator)q.push({type:"separator",label:ce.label});else{ce.tooltip&&!C&&console.warn(`Extension '${$.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${$.identifier.value}`);const ye=ce.iconPath?u(ce.iconPath):void 0;q.push({label:ce.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:C?k.MarkdownString.fromStrict(ce.tooltip):void 0,handle:ne})}}return h&&typeof h.onDidSelectItem=="function"&&(this.c=ne=>{h.onDidSelectItem(O[ne])}),i.$setItems(A,q),L.then(ne=>{if(typeof ne=="number")return O[ne];if(Array.isArray(ne))return ne.map(ce=>O[ce])})})}).then(void 0,U=>{if(!(0,f.$4)(U))return i.$setError(A,U),Promise.reject(U)})}$onItemSelected($){this.c?.($)}showInput($,I=S.CancellationToken.None){return this.d=$?.validateInput,i.$input($,typeof this.d=="function",I).then(void 0,h=>{if(!(0,f.$4)(h))return Promise.reject(h)})}async $validateInput($){if(!this.d)return;const I=await this.d($);if(!I||typeof I=="string")return I;let h;switch(I.severity){case m.InputBoxValidationSeverity.Info:h=N.default.Info;break;case m.InputBoxValidationSeverity.Warning:h=N.default.Warning;break;case m.InputBoxValidationSeverity.Error:h=N.default.Error;break;default:h=I.message?N.default.Error:N.default.Ignore;break}return{content:I.message,severity:h}}async showWorkspaceFolderPick($,I=S.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[$]);if(!h)return;const y=await this.a.getWorkspaceFolders2();if(y)return y.find(w=>w.uri.toString()===h.uri.toString())}createQuickPick($){const I=new o($,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox($){const I=new v($,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue($,I){this.e.get($)?._fireDidChangeValue(I)}$onDidAccept($){this.e.get($)?._fireDidAccept()}$onDidChangeActive($,I){const h=this.e.get($);h instanceof o&&h._fireDidChangeActive(I)}$onDidChangeSelection($,I){const h=this.e.get($);h instanceof o&&h._fireDidChangeSelection(I)}$onDidTriggerButton($,I){this.e.get($)?._fireDidTriggerButton(I)}$onDidTriggerItemButton($,I,h){const y=this.e.get($);y instanceof o&&y._fireDidTriggerItemButton(I,h)}$onDidHide($){this.e.get($)?._fireDidHide()}}class c{static{this.a=1}constructor($,I){this.x=$,this.y=I,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$6d,this.q=new M.$6d,this.r=new M.$6d,this.s=new M.$6d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title($){this.b=$,this.z({title:$})}get step(){return this.c}set step($){this.c=$,this.z({step:$})}get totalSteps(){return this.d}set totalSteps($){this.d=$,this.z({totalSteps:$})}get enabled(){return this.g}set enabled($){this.g=$,this.z({enabled:$})}get busy(){return this.j}set busy($){this.j=$,this.z({busy:$})}get ignoreFocusOut(){return this.k}set ignoreFocusOut($){this.k=$,this.z({ignoreFocusOut:$})}get value(){return this.l}set value($){this.l=$,this.z({value:$})}get placeholder(){return this.m}set placeholder($){this.m=$,this.z({placeholder:$})}get buttons(){return this.n}set buttons($){this.n=$.slice(),this.o.clear(),$.forEach((I,h)=>{const y=I===m.$wN.Back?-1:h;this.o.set(y,I)}),this.z({buttons:$.map((I,h)=>({...u(I.iconPath),tooltip:I.tooltip,handle:I===m.$wN.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue($){this.l=$,this.q.fire($)}_fireDidTriggerButton($){const I=this.o.get($);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z($){if(!this.v){for(const I of Object.keys($)){const h=$[I];this.u[I]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function d(b){if(b instanceof m.$7M)return{id:b.id};const $=p(b),I=t(b);return{dark:typeof $=="string"?R.URI.file($):$,light:typeof I=="string"?R.URI.file(I):I}}function t(b){return typeof b=="object"&&"light"in b?b.light:b}function p(b){return typeof b=="object"&&"dark"in b?b.dark:b}function u(b){const $=d(b);let I,h;return"id"in $?h=D.ThemeIcon.asClassName($):I=$,{iconPath:I,iconClass:h}}class o extends c{constructor($,I){super($.identifier,I),this.O=$,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$6d,this.L=[],this.M=new M.$6d,this.N=new M.$6d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items($){this.B=$.slice(),this.C.clear(),this.D.clear(),$.forEach((y,w)=>{this.C.set(w,y),this.D.set(y,w)});const I=(0,l.$ZF)(this.O,"quickPickItemTooltip"),h=[];for(let y=0;y<$.length;y++){const w=$[y];if(w.kind===m.QuickPickItemKind.Separator)h.push({type:"separator",label:w.label});else{w.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const A=w.iconPath?u(w.iconPath):void 0;h.push({handle:y,label:w.label,iconPath:A?.iconPath,iconClass:A?.iconClass,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:I?k.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((L,J)=>({...u(L.iconPath),tooltip:L.tooltip,handle:J}))})}}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany($){this.E=$,this.z({canSelectMany:$})}get matchOnDescription(){return this.F}set matchOnDescription($){this.F=$,this.z({matchOnDescription:$})}get matchOnDetail(){return this.G}set matchOnDetail($){this.G=$,this.z({matchOnDetail:$})}get sortByLabel(){return this.H}set sortByLabel($){this.H=$,this.z({sortByLabel:$})}get keepScrollPosition(){return this.I}set keepScrollPosition($){this.I=$,this.z({keepScrollPosition:$})}get activeItems(){return this.J}set activeItems($){this.J=$.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems($){this.L=$.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive($){const I=(0,E.$Hb)($.map(h=>this.C.get(h)));this.J=I,this.K.fire(I)}_fireDidChangeSelection($){const I=(0,E.$Hb)($.map(h=>this.C.get(h)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton($,I){const h=this.C.get($);if(!h||!h.buttons||!h.buttons.length)return;const y=h.buttons[I];y&&this.N.fire({button:y,item:h})}}class v extends c{constructor($,I){super($.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password($){this.B=$,this.z({password:$})}get prompt(){return this.C}set prompt($){this.C=$,this.z({prompt:$})}get valueSelection(){return this.D}set valueSelection($){this.D=$,this.z({valueSelection:$})}get validationMessage(){return this.E}set validationMessage($){this.E=$,$?typeof $=="string"?this.z({validationMessage:$,severity:N.default.Error}):this.z({validationMessage:$.message,severity:$.severity??N.default.Error}):this.z({validationMessage:void 0,severity:N.default.Ignore})}}return new n(a,r)}e.$Yjc=g}),define(Pe[268],Re([1,0,2,5,68,6,11,4,18,141,13,20,40,8,22,12,21]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g,s,a){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$1jc=e.$Zjc=void 0;function i(A){return A instanceof S.URI}function n(A,L){return A.scheme===s.Schemas.file&&L.scheme===s.Schemas.file&&a.$k?A.toString()===L.toString():A.toString().toLowerCase()===L.toString().toLowerCase()}function c(A){if(A)return typeof A.iconPath=="string"?S.URI.file(A.iconPath):S.URI.isUri(A.iconPath)||l.ThemeIcon.isThemeIcon(A.iconPath)?A.iconPath:void 0}function d(A){if(A.icon){if(S.URI.isUri(A.icon))return A.icon;if(l.ThemeIcon.isThemeIcon(A.icon))return A.icon;{const L=A.icon;return{light:L.light,dark:L.dark}}}else return}function t(A,L){if(!A.iconPath&&!L.iconPath)return 0;if(A.iconPath){if(!L.iconPath)return 1}else return-1;const J=typeof A.iconPath=="string"?A.iconPath:S.URI.isUri(A.iconPath)?A.iconPath.fsPath:A.iconPath.id,W=typeof L.iconPath=="string"?L.iconPath:S.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id;return(0,E.$8q)(J,W)}function p(A,L){let J=0;if(A.strikeThrough!==L.strikeThrough)return A.strikeThrough?1:-1;if(A.faded!==L.faded)return A.faded?1:-1;if(A.tooltip!==L.tooltip)return(A.tooltip||"").localeCompare(L.tooltip||"");if(J=t(A,L),J!==0)return J;if(A.light&&L.light)J=t(A.light,L.light);else{if(A.light)return 1;if(L.light)return-1}if(J!==0)return J;if(A.dark&&L.dark)J=t(A.dark,L.dark);else{if(A.dark)return 1;if(L.dark)return-1}return J}function u(A,L){if(A.command!==L.command)return A.command<L.command?-1:1;if(A.title!==L.title)return A.title<L.title?-1:1;if(A.tooltip!==L.tooltip){if(A.tooltip!==void 0&&L.tooltip!==void 0)return A.tooltip<L.tooltip?-1:1;if(A.tooltip!==void 0)return 1;if(L.tooltip!==void 0)return-1}if(A.arguments===L.arguments)return 0;if(A.arguments)if(L.arguments){if(A.arguments.length!==L.arguments.length)return A.arguments.length-L.arguments.length}else return 1;else return-1;for(let J=0;J<A.arguments.length;J++){const W=A.arguments[J],U=L.arguments[J];if(W!==U&&!(i(W)&&i(U)&&n(W,U)))return W<U?-1:1}return 0}function o(A,L){let J=(0,E.$8q)(A.resourceUri.fsPath,L.resourceUri.fsPath,!0);if(J!==0)return J;if(A.command&&L.command)J=u(A.command,L.command);else{if(A.command)return 1;if(L.command)return-1}if(J!==0)return J;if(A.decorations&&L.decorations)J=p(A.decorations,L.decorations);else{if(A.decorations)return 1;if(L.decorations)return-1}if(A.multiFileDiffEditorModifiedUri&&L.multiFileDiffEditorModifiedUri)J=(0,E.$8q)(A.multiFileDiffEditorModifiedUri.fsPath,L.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(A.multiFileDiffEditorModifiedUri)return 1;if(L.multiFileDiffEditorModifiedUri)return-1}if(A.multiDiffEditorOriginalUri&&L.multiDiffEditorOriginalUri)J=(0,E.$8q)(A.multiDiffEditorOriginalUri.fsPath,L.multiDiffEditorOriginalUri.fsPath,!0);else{if(A.multiDiffEditorOriginalUri)return 1;if(L.multiDiffEditorOriginalUri)return-1}return J}function v(A,L){for(let J=0;J<A.length;J++)if(A[J]!==L[J])return!1;return!0}function b(A,L){return A.command===L.command&&A.title===L.title&&A.tooltip===L.tooltip&&(A.arguments&&L.arguments?v(A.arguments,L.arguments):A.arguments===L.arguments)}function $(A,L){return(0,f.$ub)(A,L,b)}class I{#e;#t;get value(){return this.d}set value(L){L=L??"",this.#e.$setInputBoxValue(this.l,L),this.n(L)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(L){this.#e.$setInputBoxPlaceholder(this.l,L),this.f=L}get validateInput(){return(0,g.$1F)(this.k,"scmValidation"),this.g}set validateInput(L){if((0,g.$1F)(this.k,"scmValidation"),L&&typeof L!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=L,this.#e.$setValidationProviderIsEnabled(this.l,!!L)}get enabled(){return this.h}set enabled(L){L=!!L,this.h!==L&&(this.h=L,this.#e.$setInputBoxEnablement(this.l,L))}get visible(){return this.j}set visible(L){L=!!L,this.j!==L&&(this.j=L,this.#e.$setInputBoxVisibility(this.l,L))}get document(){return(0,g.$1F)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(L,J,W,U,C){this.k=L,this.l=U,this.m=C,this.d="",this.e=new M.$6d,this.f="",this.h=!0,this.j=!0,this.#t=J,this.#e=W}showValidationMessage(L,J){(0,g.$1F)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,L,J)}$onInputBoxValueChange(L){this.n(L)}n(L){this.d=L,this.e.fire(L)}}e.$Zjc=I;class h{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(L){this.v=L,this.q.$updateGroupLabel(this.t,this.handle,L)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(L){this.p=L,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(L){this.f=[...L],this.k.fire()}constructor(L,J,W,U,C,O,q){this.q=L,this.s=J,this.t=W,this.u=U,this.v=C,this.multiDiffEditorEnableViewChanges=O,this.w=q,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$6d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$6d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=h.d++}getResourceState(L){return this.g.get(L)}$executeResourceCommand(L,J){const W=this.h.get(L);return W?(0,R.$$g)(()=>this.s.executeCommand(W.command,...W.arguments||[],J)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const L=[...this.f].sort(o),W=(0,f.$Db)(this.o,L,o).map(O=>{const q=O.toInsert.map(ne=>{const ce=this.e++;this.g.set(ce,ne);const ye=ne.resourceUri;let Ie;if(ne.command)if(ne.command.command==="vscode.open"||ne.command.command==="vscode.diff"||ne.command.command==="vscode.changes"){const ge=new F.$Sc;Ie=this.s.converter.toInternal(ne.command,ge),this.j.set(ce,ge)}else this.h.set(ce,ne.command);const ue=(0,g.$ZF)(this.w,"scmMultiDiffEditor"),ve=ue?ne.multiDiffEditorOriginalUri:void 0,re=ue?ne.multiFileDiffEditorModifiedUri:void 0,$e=c(ne.decorations),ie=ne.decorations&&c(ne.decorations.light)||$e,le=ne.decorations&&c(ne.decorations.dark)||$e,V=[ie,le],_=ne.decorations&&ne.decorations.tooltip||"",ke=ne.decorations&&!!ne.decorations.strikeThrough,Le=ne.decorations&&!!ne.decorations.faded,Ee=ne.contextValue||"";return{rawResource:[ce,ye,V,_,ke,Le,Ee,Ie,ve,re],handle:ce}});return{start:O.start,deleteCount:O.deleteCount,toInsert:q}}),U=W.map(({start:O,deleteCount:q,toInsert:ne})=>[O,q,ne.map(ce=>ce.rawResource)]),C=W.reverse();for(const{start:O,deleteCount:q,toInsert:ne}of C){const ce=ne.map(Ie=>Ie.handle),ye=this.n.splice(O,q,...ce);for(const Ie of ye)this.g.delete(Ie),this.h.delete(Ie),this.j.get(Ie)?.dispose(),this.j.delete(Ie)}return this.o=L,U}dispose(){this.l=!0,this.m.fire()}}class y{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(L){this.g!==L&&(this.g=L,this.#e.$updateSourceControl(this.w,{count:L}))}get quickDiffProvider(){return this.h}set quickDiffProvider(L){this.h=L;let J;(0,g.$ZF)(this.x,"quickDiffProvider")&&(J=L?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!L,quickDiffLabel:J})}get historyProvider(){return(0,g.$1F)(this.x,"scmHistoryProvider"),this.j}set historyProvider(L){(0,g.$1F)(this.x,"scmHistoryProvider"),this.j=L,this.k.value=new F.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!L}),L&&this.k.value.add(L.onDidChangeCurrentHistoryItemGroup(()=>{this.l=L?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(L){L!==this.m&&(this.m=L,this.#e.$updateSourceControl(this.w,{commitTemplate:L}))}get acceptInputCommand(){return this.o}set acceptInputCommand(L){this.n.value=new F.$Sc,this.o=L;const J=this.y.converter.toInternal(L,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:J})}get actionButton(){return(0,g.$1F)(this.x,"scmActionButton"),this.q}set actionButton(L){(0,g.$1F)(this.x,"scmActionButton"),this.p.value=new F.$Sc,this.q=L;const J=L!==void 0?{command:this.y.converter.toInternal(L.command,this.p.value),secondaryCommands:L.secondaryCommands?.map(W=>W.map(U=>this.y.converter.toInternal(U,this.p.value))),description:L.description,enabled:L.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:J??null})}get statusBarCommands(){return this.t}set statusBarCommands(L){if(this.t&&L&&$(this.t,L))return;this.s.value=new F.$Sc,this.t=L;const J=(L||[]).map(W=>this.y.converter.toInternal(W,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:J})}get selected(){return this.u}constructor(L,J,W,U,C,O,q){this.x=L,this.y=U,this.z=C,this.A=O,this.B=q,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new F.$Uc,this.m=void 0,this.n=new F.$Uc,this.o=void 0,this.p=new F.$Uc,this.s=new F.$Uc,this.t=void 0,this.u=!1,this.v=new M.$6d,this.onDidChangeSelection=this.v.event,this.w=y.d++,this.C=new Map,this.D=new Set,this.#e=W;const ne=S.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${C}/scm${this.w}/input`,query:q?`rootUri=${encodeURIComponent(q.toString())}`:void 0});this.f=new I(L,J,this.#e,this.w,ne),this.#e.$registerSourceControl(this.w,C,O,q,ne)}createResourceGroup(L,J,W){const U=(0,g.$ZF)(this.x,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,C=new h(this.#e,this.y,this.w,L,J,U,this.x),O=M.Event.once(C.onDidDispose)(()=>this.C.delete(C));return this.C.set(C,O),this.eventuallyAddResourceGroups(),C}eventuallyAddResourceGroups(){const L=[],J=[];for(const[W,U]of this.C){U.dispose();const C=W.onDidUpdateResourceStates(()=>{this.D.add(W),this.eventuallyUpdateResourceStates()});M.Event.once(W.onDidDispose)(()=>{this.D.delete(W),C.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.w,W.handle)}),L.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const O=W._takeResourceStateSnapshot();O.length>0&&J.push([W.handle,O]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.w,L,J),this.C.clear()}eventuallyUpdateResourceStates(){const L=[];this.D.forEach(J=>{const W=J._takeResourceStateSnapshot();W.length!==0&&L.push([J.handle,W])}),L.length>0&&this.#e.$spliceResourceStates(this.w,L),this.D.clear()}getResourceGroup(L){return this.e.get(L)}setSelectionState(L){this.u=L,this.v.fire(L)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(L=>L.dispose()),this.#e.$unregisterSourceControl(this.w)}}Qe([(0,P.$Lh)(100)],y.prototype,"eventuallyAddResourceGroups",null),Qe([(0,P.$Lh)(100)],y.prototype,"eventuallyUpdateResourceStates",null);let w=class{static{r=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(L,J,W,U){this.l=J,this.m=W,this.n=U,this.g=new Map,this.h=new D.$Cm,this.j=new M.$6d,this.e=L.getProxy(m.$0L.MainThreadSCM),this.f=L.getProxy(m.$0L.MainThreadTelemetry),J.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===3){const O=this.g.get(C.sourceControlHandle);if(!O)return C;const q=O.getResourceGroup(C.groupHandle);return q?q.getResourceState(C.handle):C}else if(C&&C.$mid===4){const O=this.g.get(C.sourceControlHandle);return O?O.getResourceGroup(C.groupHandle):C}else if(C&&C.$mid===5){const O=this.g.get(C.handle);return O||C}return C}})}createSourceControl(L,J,W,U){this.n.trace("ExtHostSCM#createSourceControl",L.identifier.value,J,W,U),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:L.identifier.value});const C=r.d++,O=new y(L,this.m,this.e,this.l,J,W,U);this.g.set(C,O);const q=this.h.get(L.identifier)||[];return q.push(O),this.h.set(L.identifier,q),O}getLastInputBox(L){this.n.trace("ExtHostSCM#getLastInputBox",L.identifier.value);const J=this.h.get(L.identifier),W=J&&J[J.length-1];return W&&W.inputBox}$provideOriginalResource(L,J,W){const U=S.URI.revive(J);this.n.trace("ExtHostSCM#$provideOriginalResource",L,U.toString());const C=this.g.get(L);return!C||!C.quickDiffProvider||!C.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$$g)(()=>C.quickDiffProvider.provideOriginalResource(U,W)).then(O=>O||null)}$onInputBoxValueChange(L,J){this.n.trace("ExtHostSCM#$onInputBoxValueChange",L);const W=this.g.get(L);return W&&W.inputBox.$onInputBoxValueChange(J),Promise.resolve(void 0)}$executeResourceCommand(L,J,W,U){this.n.trace("ExtHostSCM#$executeResourceCommand",L,J,W);const C=this.g.get(L);if(!C)return Promise.resolve(void 0);const O=C.getResourceGroup(J);return O?O.$executeResourceCommand(W,U):Promise.resolve(void 0)}$validateInput(L,J,W){this.n.trace("ExtHostSCM#$validateInput",L);const U=this.g.get(L);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,R.$$g)(()=>U.inputBox.validateInput(J,W)).then(C=>{if(!C)return Promise.resolve(void 0);const O=k.MarkdownString.fromStrict(C.message);return O?Promise.resolve([O,C.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(L){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",L),L!==void 0&&this.g.get(L)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=L,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(L,J,W,U){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(J,W,U)??void 0}async $provideHistoryItems(L,J,W,U){return(await this.g.get(L)?.historyProvider?.provideHistoryItems(J,W,U))?.map(q=>({...q,icon:d(q)}))??void 0}async $provideHistoryItemSummary(L,J,W,U){const C=this.g.get(L)?.historyProvider;if(typeof C?.provideHistoryItemSummary!="function")return;const O=await C.provideHistoryItemSummary(J,W,U);return O?{...O,icon:d(O)}:void 0}async $provideHistoryItemChanges(L,J,W,U){return await this.g.get(L)?.historyProvider?.provideHistoryItemChanges(J,W,U)??void 0}};e.$1jc=w,e.$1jc=w=r=Qe([qe(3,N.$Aj)],w)}),define(Pe[269],Re([1,0,4,8,2]),function(me,e,S,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2jc=void 0;class F{static{this.a=0}constructor(m,f){this.d=f,this.c=new Map,this.b=m.getProxy(S.$0L.MainThreadShare)}async $provideShare(m,f,E){return await this.c.get(m)?.provideShare({selection:M.Range.to(f.selection),resourceUri:P.URI.revive(f.resourceUri)},E)??void 0}registerShareProvider(m,f){const E=F.a++;return this.c.set(E,f),this.b.$registerShareProvider(E,M.DocumentSelector.from(m,this.d),f.id,f.label,f.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$2jc=F}),define(Pe[270],Re([1,0,7,4,167,6,8,16]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5jc=e.$4jc=void 0;class f{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new S.$8M("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new S.$8M("statusBarItem.warningForeground")]])}#e;#t;constructor(l,k,g,s,a,r=S.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new F.$Sc,this.#e=l,this.#t=k,a&&s){this.c=(0,S.$KM)(s.identifier,a);const n=g.get(this.c);n&&(r=n.alignLeft?S.StatusBarAlignment.Left:S.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(f.a++);this.e=s,this.f=a,this.g=r,this.h=this.u(i)}u(l){if((0,m.$Xf)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!f.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new F.$Sc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let k;this.m?k=this.m:k=(0,P.localize)(0,null,this.e.displayName||this.e.name);let g=this.n;this.o&&(g=f.b.get(this.o.id));const s=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,k,this.k,s,this.r?.internal,g,this.o,this.g===S.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$4jc=f;class E{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",S.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const k={message:l};return this.b.unshift(k),this.c(),new S.$_L(()=>{const g=this.b.indexOf(k);g>=0&&(this.b.splice(g,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class N{constructor(l,k){this.e=new Map,this.a=l.getProxy(M.$0L.MainThreadStatusBar),this.b=k,this.c=new E(this)}$acceptStaticEntries(l){for(const k of l)this.e.set(k.entryId,k)}createStatusBarEntry(l,k,g,s){return new f(this.a,this.b,this.e,l,k,g,s)}setStatusBarMessage(l,k){const g=this.c.setMessage(l);let s;return typeof k=="number"?s=setTimeout(()=>g.dispose(),k):typeof k<"u"&&k.then(()=>g.dispose(),()=>g.dispose()),new S.$_L(()=>{g.dispose(),clearTimeout(s)})}}e.$5jc=N}),define(Pe[113],Re([1,0,29,105,48,75,60,8,2]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EO=e.$DO=e.$CO=e.$BO=void 0;const E=(n,c,d,t)=>{let p=c;return{enumerable:!0,configurable:!1,get(){return p},set(u){if(!d(p,u)){const o=p;p=u,n.listener?.(t(u,o))}}}},N=(n,c)=>n===c,D={range:(n,c)=>n===c?!0:!n||!c?!1:n.isEqual(c),label:N,description:N,sortText:N,busy:N,error:N,canResolveChildren:N,tags:(n,c)=>!(n.length!==c.length||n.some(d=>!c.find(t=>d.id===t.id)))},l=n=>c=>({op:4,update:n(c)}),k=(n,c)=>({range:(()=>{let d;const t=l(p=>({range:S.$0s.lift(m.Range.from(p))}));return{enumerable:!0,configurable:!1,get(){return d},set(p){n.listener?.({op:6}),D.range(d,p)||(d=p,n.listener?.(t(p)))}}})(),label:E(n,c,D.label,l(d=>({label:d}))),description:E(n,void 0,D.description,l(d=>({description:d}))),sortText:E(n,void 0,D.sortText,l(d=>({sortText:d}))),canResolveChildren:E(n,!1,D.canResolveChildren,d=>({op:2,state:d})),busy:E(n,!1,D.busy,l(d=>({busy:d}))),error:E(n,void 0,D.error,l(d=>({error:m.MarkdownString.fromStrict(d)||null}))),tags:E(n,[],D.tags,(d,t)=>({op:1,new:d.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),g=n=>{const c=P.$ZK.fromString(n.extId),d=new a(c.controllerId,c.localId,n.label,f.URI.revive(n.uri)||void 0);return d.range=m.Range.to(n.range||void 0),d.description=n.description||void 0,d.sortText=n.sortText||void 0,d.tags=n.tags.map(t=>m.TestTag.to({id:(0,R.$5K)(t).tagId})),d},s=n=>{let c;for(const d of n.tests){const t=g(d.item);(0,M.$lO)(t).parent=c,c=t}return c};e.$BO=s;class a{constructor(c,d,t,p){if(d.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(d)} symbol`);const u=(0,M.$kO)(this,c);Object.defineProperties(this,{id:{value:d,enumerable:!0,writable:!1},uri:{value:p,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof r?void 0:u.parent}},children:{value:(0,F.$jO)(u,M.$lO,a),enumerable:!0,writable:!1},...k(u,t)})}}e.$CO=a;class r extends a{constructor(c,d){super(c,c,d,void 0),this._isRoot=!0}}e.$DO=r;class i extends F.$fO{constructor(c,d,t){super({controllerId:c,getDocumentVersion:p=>p&&t.getDocument(p)?.version,getApiFor:M.$lO,getChildren:p=>p.children,root:new r(c,d),toITestItem:m.TestItem.from})}}e.$EO=i}),define(Pe[31],Re([1,0,16,7,8,26,4,18,13,52,29,93,2,6,3,17,113,23,49,41,64,58,61,33]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g,s,a,r,i,n,c,d,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PO=e.$OO=e.$NO=e.$MO=e.$LO=e.$KO=void 0;let u=class{#e;#t;#i;constructor(h,y,w){this.b=new Map,this.c=new Map,this.#e=h.getProxy(R.$0L.MainThreadCommands),this.d=y,this.#i=w,this.#t=h.getProxy(R.$0L.MainThreadTelemetry),this.converter=new o(this,A=>{const L=this.c.get(A);return L?.result===b.Void?L:void 0},y),this.f=[{processArgument(A){return(0,E.$Ph)(A)}},{processArgument(A){return(0,F.$Nn)(A,function(L){if(N.$0s.isIRange(L))return P.Range.to(L);if(D.$9s.isIPosition(L))return P.Position.to(L);if(N.$0s.isIRange(L.range)&&l.URI.isUri(L.uri))return P.location.to(L);if(L instanceof r.$te)return L.buffer.buffer;if(!Array.isArray(L))return L})}}]}registerArgumentProcessor(h){this.f.push(h)}registerApiCommand(h){const y=this.registerCommand(!1,h.id,async(...w)=>{const A=h.args.map((J,W)=>{if(!J.validate(w[W]))throw new Error(`Invalid argument '${J.name}' when running '${h.id}', received: ${typeof w[W]=="object"?JSON.stringify(w[W],null,"	"):w[W]} `);return J.convert(w[W])}),L=await this.executeCommand(h.internalId,...A);return h.result.convert(L,w,this.converter)},void 0,{description:h.description,args:h.args,returns:h.result.description});return this.c.set(h.id,h),new M.$_L(()=>{y.dispose(),this.c.delete(h.id)})}registerCommand(h,y,w,A,L,J){if(this.d.trace("ExtHostCommands#registerCommand",y),!y.trim().length)throw new Error("invalid id");if(this.b.has(y))throw new Error(`command '${y}' already exists`);return this.b.set(y,{callback:w,thisArg:A,metadata:L,extension:J}),h&&this.#e.$registerCommand(y),new M.$_L(()=>{this.b.delete(y)&&h&&this.#e.$unregisterCommand(y)})}executeCommand(h,...y){return this.d.trace("ExtHostCommands#executeCommand",h),this.g(h,y,!0)}async g(h,y,w){if(this.b.has(h))return this.#e.$fireCommandActivationEvent(h),this.h(h,y,!1);{let A=!1;const L=(0,F.$Nn)(y,function(J){if(J instanceof M.$aM)return P.Position.from(J);if(J instanceof M.$bM)return P.Range.from(J);if(J instanceof M.$lM)return P.location.from(J);if(M.$zN.isNotebookRange(J))return P.NotebookRange.from(J);if(J instanceof ArrayBuffer)return A=!0,r.$te.wrap(new Uint8Array(J));if(J instanceof Uint8Array)return A=!0,r.$te.wrap(J);if(J instanceof r.$te)return A=!0,J;if(!Array.isArray(J))return J});try{const J=await this.#e.$executeCommand(h,A?new i.$0v(L):L,w);return(0,E.$Ph)(J)}catch(J){if(J instanceof Error&&J.message==="$executeCommand:retry")return this.g(h,y,!1);throw J}}}async h(h,y,w){const A=this.b.get(h);if(!A)throw new Error("Unknown command");const{callback:L,thisArg:J,metadata:W}=A;if(W?.args)for(let C=0;C<W.args.length;C++)try{(0,S.$$f)(y[C],W.args[C].constraint)}catch{throw new Error(`Running the contributed command: '${h}' failed. Illegal argument '${W.args[C].name}' - ${W.args[C].description}`)}const U=c.$2d.create();try{return await L.apply(J,y)}catch(C){if(h===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...y);O&&(h=O.command)}if(this.d.error(C,h,A.extension?.identifier),!w)throw C;if(A.extension?.identifier){const O=this.#i.onExtensionError(A.extension.identifier,C);this.d.trace("forwarded error to extension?",O,A.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$4i)(C)),this.id=h,this.source=A.extension?.displayName??A.extension?.name}}}finally{this.j(A,h,U.elapsed())}}j(h,y,w){h.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:h.extension.identifier.value,id:new d.$1o(y),duration:w})}$executeContributedCommand(h,...y){this.d.trace("ExtHostCommands#$executeContributedCommand",h);const w=this.b.get(h);return w?(y=y.map(A=>this.f.reduce((L,J)=>J.processArgument(L,w.extension?.identifier),A)),this.h(h,y,!0)):Promise.reject(new Error(`Contributed command '${h}' does not exist.`))}getCommands(h=!1){return this.d.trace("ExtHostCommands#getCommands",h),this.#e.$getCommands().then(y=>(h&&(y=y.filter(w=>w[0]!=="_")),y))}$getContributedCommandMetadata(){const h=Object.create(null);for(const[y,w]of this.b){const{metadata:A}=w;A&&(h[y]=A)}return Promise.resolve(h)}};e.$KO=u,e.$KO=u=Qe([qe(0,s.$pO),qe(1,f.$Aj),qe(2,t.$JO)],u),e.$LO=(0,g.$gi)("IExtHostCommands");class o{constructor(h,y,w){this.d=h,this.f=y,this.g=w,this.delegatingCommandId=`__vsc${(0,p.$Cg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(h,y){if(!h)return;const w={$ident:void 0,id:h.command,title:h.title,tooltip:h.tooltip};if(!h.command)return w;const A=this.f(h.command);if(A)w.id=A.internalId,w.arguments=A.args.map((L,J)=>L.convert(h.arguments&&h.arguments[J]));else if((0,m.$Lb)(h.arguments)){const L=`${h.command} /${++this.c}`;this.b.set(L,h),y.add((0,k.$Rc)(()=>{this.b.delete(L),this.g.trace("CommandsConverter#DISPOSE",L)})),w.$ident=L,w.id=this.delegatingCommandId,w.arguments=[L],this.g.trace("CommandsConverter#CREATE",h.command,L)}return w}fromInternal(h){return typeof h.$ident=="string"?this.b.get(h.$ident):{command:h.id,title:h.title,arguments:h.arguments}}getActualCommand(...h){return this.b.get(h[0])}h(...h){const y=this.getActualCommand(...h);return this.g.trace("CommandsConverter#EXECUTE",h[0],y?y.command:"MISSING"),y?this.d.executeCommand(y.command,...y.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${h[0]}`)}}e.$MO=o;class v{static{this.Uri=new v("uri","Uri of a text document",h=>l.URI.isUri(h),h=>h)}static{this.Position=new v("position","A position in a text document",h=>M.$aM.isPosition(h),P.Position.from)}static{this.Range=new v("range","A range in a text document",h=>M.$bM.isRange(h),P.Range.from)}static{this.Selection=new v("selection","A selection in a text document",h=>M.$cM.isSelection(h),P.Selection.from)}static{this.Number=new v("number","",h=>typeof h=="number",h=>h)}static{this.String=new v("string","",h=>typeof h=="string",h=>h)}static{this.StringArray=v.Arr(v.String)}static Arr(h){return new v(`${h.name}_array`,`Array of ${h.name}, ${h.description}`,y=>Array.isArray(y)&&y.every(w=>h.validate(w)),y=>y.map(w=>h.convert(w)))}static{this.CallHierarchyItem=new v("item","A call hierarchy item",h=>h instanceof M.$wM,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new v("item","A type hierarchy item",h=>h instanceof M.$SN,P.TypeHierarchyItem.from)}static{this.TestItem=new v("testItem","A VS Code TestItem",h=>h instanceof a.$CO,P.TestItem.from)}constructor(h,y,w,A){this.name=h,this.description=y,this.validate=w,this.convert=A}optional(){return new v(this.name,`(optional) ${this.description}`,h=>h==null||this.validate(h),h=>h===void 0?void 0:h===null?null:this.convert(h))}with(h,y){return new v(h??this.name,y??this.description,this.validate,this.convert)}}e.$NO=v;class b{static{this.Void=new b("no result",h=>h)}constructor(h,y){this.description=h,this.convert=y}}e.$OO=b;class ${constructor(h,y,w,A,L){this.id=h,this.internalId=y,this.description=w,this.args=A,this.result=L}}e.$PO=$}),define(Pe[271],Re([1,0,18,12,2,87,97,35,31,8,7]),function(me,e,S,M,P,F,R,m,f,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=void 0;const D=[new f.$PO("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$NO.Uri,f.$NO.Position],new f.$OO("A promise that resolves to an array of DocumentHighlight-instances.",k(E.DocumentHighlight.to))),new f.$PO("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$NO.Uri],new f.$OO("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,a)=>{if((0,S.$Kb)(s))return;class r extends N.$rM{static to(n){const c=new r(n.name,E.SymbolKind.to(n.kind),n.containerName||"",new N.$lM(a[0],E.Range.to(n.range)));return c.detail=n.detail,c.range=c.location.range,c.selectionRange=E.Range.to(n.selectionRange),c.children=n.children?n.children.map(r.to):[],c}}return s.map(r.to)})),new f.$PO("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$NO.Uri,new f.$NO("options","Formatting options",s=>!0,s=>s)],new f.$OO("A promise that resolves to an array of TextEdits.",k(E.TextEdit.to))),new f.$PO("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$NO.Uri,f.$NO.Range,new f.$NO("options","Formatting options",s=>!0,s=>s)],new f.$OO("A promise that resolves to an array of TextEdits.",k(E.TextEdit.to))),new f.$PO("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$NO.Uri,f.$NO.Position,new f.$NO("ch","Trigger character",s=>typeof s=="string",s=>s),new f.$NO("options","Formatting options",s=>!0,s=>s)],new f.$OO("A promise that resolves to an array of TextEdits.",k(E.TextEdit.to))),new f.$PO("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$NO.Uri,f.$NO.Position],new f.$OO("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$PO("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$NO.Uri,f.$NO.Position],new f.$OO("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$PO("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$NO.Uri,f.$NO.Position],new f.$OO("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$PO("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$NO.Uri,f.$NO.Position],new f.$OO("A promise that resolves to an array of Location or LocationLink instances.",g)),new f.$PO("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$NO.Uri,f.$NO.Position],new f.$OO("A promise that resolves to an array of Location-instances.",k(E.location.to))),new f.$PO("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$NO.Uri,f.$NO.Position],new f.$OO("A promise that resolves to an array of Hover-instances.",k(E.Hover.to))),new f.$PO("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$NO.Uri,new f.$NO("position","A position in a text document",s=>Array.isArray(s)&&s.every(a=>N.$aM.isPosition(a)),s=>s.map(E.Position.from))],new f.$OO("A promise that resolves to an array of ranges.",s=>s.map(a=>{let r;for(const i of a.reverse())r=new N.$vM(E.Range.to(i),r);return r}))),new f.$PO("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$NO.String.with("query","Search string")],new f.$OO("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(E.WorkspaceSymbol.to))),new f.$PO("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$NO.Uri,f.$NO.Position],new f.$OO("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(E.CallHierarchyItem.to))),new f.$PO("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$NO.CallHierarchyItem],new f.$OO("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(E.CallHierarchyIncomingCall.to))),new f.$PO("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$NO.CallHierarchyItem],new f.$OO("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(E.CallHierarchyOutgoingCall.to))),new f.$PO("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$NO.Uri,f.$NO.Position],new f.$OO("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:E.Range.to(s.range),placeholder:s.text}})),new f.$PO("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$NO.Uri,f.$NO.Position,f.$NO.String.with("newName","The new symbol name")],new f.$OO("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return E.WorkspaceEdit.to(s)}})),new f.$PO("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$NO.Uri,f.$NO.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$OO("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(E.DocumentLink.to))),new f.$PO("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$NO.Uri],new f.$OO("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new N.$qN(s.tokenTypes,s.tokenModifiers)})),new f.$PO("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$NO.Uri],new f.$OO("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const a=(0,R.$eab)(s);if(a.type==="full")return new N.$sN(a.data,void 0)})),new f.$PO("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$NO.Uri,f.$NO.Range.optional()],new f.$OO("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new N.$qN(s.tokenTypes,s.tokenModifiers)})),new f.$PO("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$NO.Uri,f.$NO.Range],new f.$OO("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const a=(0,R.$eab)(s);if(a.type==="full")return new N.$sN(a.data,void 0)})),new f.$PO("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$NO.Uri,f.$NO.Position,f.$NO.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$NO.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$OO("A promise that resolves to a CompletionList-instance.",(s,a,r)=>{if(!s)return new N.$HM([]);const i=s.suggestions.map(n=>E.CompletionItem.to(n,r));return new N.$HM(i,s.incomplete)})),new f.$PO("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$NO.Uri,f.$NO.Position,f.$NO.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$OO("A promise that resolves to SignatureHelp.",s=>{if(s)return E.SignatureHelp.to(s)})),new f.$PO("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$NO.Uri,f.$NO.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$OO("A promise that resolves to an array of CodeLens-instances.",(s,a,r)=>k(i=>new N.$zM(E.Range.to(i.range),i.command&&r.fromInternal(i.command)))(s))),new f.$PO("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$NO.Uri,new f.$NO("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>N.$bM.isRange(s),s=>N.$cM.isSelection(s)?E.Selection.from(s):E.Range.from(s)),f.$NO.String.with("kind","Code action kind to return code actions for").optional(),f.$NO.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$OO("A promise that resolves to an array of Command-instances.",(s,a,r)=>k(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(i.command)}else{const n=new N.$tM(i.title,i.kind?new N.$uM(i.kind):void 0);return i.edit&&(n.edit=E.WorkspaceEdit.to(i.edit)),i.command&&(n.command=r.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(s))),new f.$PO("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$NO.Uri],new f.$OO("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(a=>new N.$NM(E.Range.to(a.range),E.Color.to(a.color))):[])),new f.$PO("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$NO("color","The color to show and insert",s=>s instanceof N.$MM,E.Color.from),new f.$NO("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:E.Range.from(s.range)}))],new f.$OO("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(E.ColorPresentation.to):[])),new f.$PO("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$NO.Uri,f.$NO.Range],new f.$OO("A promise that resolves to an array of Inlay objects",(s,a,r)=>s.map(E.InlayHint.to.bind(void 0,r)))),new f.$PO("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$NO.Uri],new f.$OO("A promise that resolves to an array of FoldingRange objects",(s,a)=>{if(s)return s.map(E.FoldingRange.to)})),new f.$PO("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$OO("A promise that resolves to an array of NotebookContentProvider static info objects.",k(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(a=>E.NotebookExclusiveDocumentPattern.to(a))})))),new f.$PO("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$NO.Uri,f.$NO.Range,new f.$NO("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof N.$bM,s=>E.InlineValueContext.from(s))],new f.$OO("A promise that resolves to an array of InlineValue objects",s=>s.map(E.InlineValue.to))),new f.$PO("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$NO("uriOrString","Uri-instance or string (only http/https)",s=>P.URI.isUri(s)||typeof s=="string"&&(0,M.$qg)(s,M.Schemas.http,M.Schemas.https),s=>s),new f.$NO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[E.ViewColumn.from(s),void 0]:[E.ViewColumn.from(s.viewColumn),E.TextEditorOpenOptions.from(s)])).optional(),f.$NO.String.with("label","").optional()],f.$OO.Void),new f.$PO("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$NO.Uri.with("resource","Resource to open"),f.$NO.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new f.$NO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[E.ViewColumn.from(s),void 0]:[E.ViewColumn.from(s.viewColumn),E.TextEditorOpenOptions.from(s)])).optional()],f.$OO.Void),new f.$PO("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$NO.Uri.with("left","Left-hand side resource of the diff editor"),f.$NO.Uri.with("right","Right-hand side resource of the diff editor"),f.$NO.String.with("title","Human readable title for the diff editor").optional(),new f.$NO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[E.ViewColumn.from(s.viewColumn),E.TextEditorOpenOptions.from(s)]).optional()],f.$OO.Void),new f.$PO("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[f.$NO.String.with("title","Human readable title for the changes editor"),new f.$NO("resourceList","List of resources to compare",s=>{for(const a of s){if(a.length!==3)return!1;const[r,i,n]=a;if(!P.URI.isUri(r)||!P.URI.isUri(i)&&i!==void 0&&i!==null||!P.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},s=>s)],f.$OO.Void),new f.$PO("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$NO.Uri,f.$NO.Position],new f.$OO("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(E.TypeHierarchyItem.to))),new f.$PO("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$NO.TypeHierarchyItem],new f.$OO("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(E.TypeHierarchyItem.to))),new f.$PO("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$NO.TypeHierarchyItem],new f.$OO("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(E.TypeHierarchyItem.to))),new f.$PO("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$NO.TestItem],f.$OO.Void),new f.$PO("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$NO.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$OO.Void),new f.$PO("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$NO.String.with("name","The context key name"),new f.$NO("value","The context key value",()=>!0,s=>s)],f.$OO.Void),new f.$PO("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$NO.Uri,f.$NO.StringArray,new f.$NO("MappedEditsContext","Mapped Edits Context",s=>E.MappedEditsContext.is(s),s=>E.MappedEditsContext.from(s))],new f.$OO("A promise that resolves to a workspace edit or null",s=>s?E.WorkspaceEdit.to(s):null))];class l{static register(a){D.forEach(a.registerApiCommand,a),this.a(a)}static a(a){a.registerCommand(!1,"_validateWhenClauses",m.$fj)}}e.$lic=l;function k(s){return a=>{if(Array.isArray(a))return a.map(s)}}function g(s){if(!Array.isArray(s))return;const a=[];for(const r of s)F.$Wt(r)?a.push(E.DefinitionLink.to(r)):a.push(E.location.to(r));return a}}),define(Pe[272],Re([1,0,11,6,2,4,31,8,7]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vjc=void 0;class E{static{this.a=0}constructor(k,g){this.extension=k,this.provider=g,this.handle=E.a++}}class N{constructor(k){this.session=k,this.responses=[]}}class D{static{this.a=0}constructor(k,g,s,a){this.f=s,this.g=a,this.b=new Map,this.d=new Map,this.e=k.getProxy(F.$0L.MainThreadInlineChat),g.registerApiCommand(new R.$PO("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new R.$NO("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?m.Range.from(r.initialRange):void 0,initialSelection:f.$cM.isSelection(r.initialSelection)?m.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?m.Position.from(r.position):void 0}})],R.$OO.Void))}registerProvider(k,g,s){const a=new E(k,g);return this.b.set(a.handle,a),this.e.$registerInteractiveEditorProvider(a.handle,s?.label??k.displayName??k.name,k.identifier.value,typeof g.handleInteractiveEditorResponseFeedback=="function",typeof g.provideFollowups=="function",s?.supportReportIssue??!1),(0,M.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(a.handle),this.b.delete(a.handle)})}async $prepareSession(k,g,s,a){const r=this.b.get(k);if(!r){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(P.URI.revive(g)),n=m.Selection.to(s),c=await r.provider.prepareInteractiveEditorSession({document:i,selection:n},a);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const d=D.a++;return this.d.set(d,new N(c)),{id:d,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:m.Range.from(c.wholeRange),message:c.message}}async $provideResponse(k,g,s,a){const r=this.b.get(k);if(!r)return;const i=this.d.get(g.id);if(!i)return;const n={prompt:s.prompt,selection:m.Selection.to(s.selection),wholeRange:m.Range.to(s.wholeRange),attempt:s.attempt,live:s.live,previewDocument:this.f.getDocument(P.URI.revive(s.previewDocument)),withIntentDetection:s.withIntentDetection};let c=!1;const d={report:async I=>{if(!s.live&&I.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||a.isCancellationRequested||await this.e.$handleProgressChunk(s.requestId,{message:I.message,edits:I.edits?.map(m.TextEdit.from),editsShouldBeInstant:I.editsShouldBeInstant,slashCommand:I.slashCommand?.command,markdownFragment:f.$AM.isMarkdownString(I.content)?I.content.value:I.content})}},t=Promise.resolve(r.provider.provideInteractiveEditorResponse(i.session,n,d,a));let p;try{p=await(0,S.$7g)(t,a)}finally{c=!0}if(!p)return;const u=i.responses.push(p)-1,o={wholeRange:m.Range.from(p.wholeRange),placeholder:p.placeholder};if(!D.h(p))return{...o,id:u,type:"editorEdit",message:m.MarkdownString.from(p.contents),edits:[]};const{edits:v,contents:b}=p,$=b!==void 0?m.MarkdownString.from(b):void 0;return v instanceof f.$jM?{...o,id:u,type:"bulkEdit",edits:m.WorkspaceEdit.from(v),message:$}:{...o,id:u,type:"editorEdit",edits:v.map(m.TextEdit.from),message:$}}async $provideFollowups(k,g,s,a){const r=this.b.get(k),i=this.d.get(g),n=i?.responses[s];if(r&&n&&r.provider.provideFollowups){const c=Promise.resolve(r.provider.provideFollowups(i.session,n,a));return(await(0,S.$7g)(c,a))?.map(m.ChatInlineFollowup.from)}}$handleFeedback(k,g,s,a){const r=this.b.get(k),i=this.d.get(g),n=i?.responses[s];if(r&&n){const c=m.InteractiveEditorResponseFeedbackKind.to(a);r.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,c)}}$releaseSession(k,g){}static h(k){return typeof k=="object"&&typeof k.edits=="object"}}e.$vjc=D}),define(Pe[273],Re([1,0,2,31]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ijc=void 0;class P{constructor(R,m,f,E,N){this.a=m,this.b=f,this.c=E;const D=new M.$PO("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$NO("showOptions","Show Options",l=>!0,l=>l),new M.$NO("resource","Interactive resource Uri",l=>!0,l=>l),new M.$NO("controllerId","Notebook controller Id",l=>!0,l=>l),new M.$NO("title","Interactive editor title",l=>!0,l=>l)],new M.$OO("Notebook and input URI",l=>{if(N.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const k=this.a.getEditorById(l.notebookEditorId);return N.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri),notebookEditor:k.apiEditor}}return N.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(R,m,f,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:f,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Ijc=P}),define(Pe[274],Re([1,0,18,11,25,5,6,28,2,20,13,4,31,8,7,76,213,22,49,214]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g,s,a,r,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rjc=e.$Qjc=void 0;let c=class{constructor($,I,h,y,w){this.m=I,this.n=h,this.o=y,this.q=w,this.b=new m.$Ac,this.c=new m.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new F.$6d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=$.getProxy(D.$0L.MainThreadNotebookKernels);const A=new l.$PO("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$NO("options","Select kernel options",J=>!0,J=>{if(J&&"notebookEditor"in J&&"id"in J){const W=this.n.getIdByEditor(J.notebookEditor);return{id:J.id,extension:J.extension,notebookEditorId:W}}else if(J&&"notebookEditor"in J){const W=this.n.getIdByEditor(J.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${J.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return J})],l.$OO.Void),L=new l.$PO("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[l.$NO.Uri],new l.$OO("A promise that resolves to an array of variables",(J,W)=>J.map(U=>({name:U.name,value:U.value,type:U.type,editable:!1}))));this.o.registerApiCommand(A),this.o.registerApiCommand(L)}createNotebookController($,I,h,y,w,A){for(const $e of this.j.values())if($e.controller.id===I&&E.$Am.equals($.identifier,$e.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const L=this.k++,J=this;this.q.trace(`NotebookController[${L}], CREATED by ${$.identifier.value}, ${I}`);const W=()=>console.warn(`NO execute handler from notebook controller '${q.id}' of extension: '${$.identifier}'`);let U=!1;const C=new F.$6d,O=new F.$6d,q={id:v($.identifier,I),notebookType:h,extensionId:$.identifier,extensionLocation:$.extensionLocation,label:y||$.identifier.value,preloads:A?A.map(k.NotebookRendererScript.from):[]};let ne=w??W,ce,ye;this.a.$addKernel(L,q).catch($e=>{console.log($e),U=!0});let Ie=0;const ue=()=>{if(U)return;const $e=++Ie;Promise.resolve().then(()=>{$e===Ie&&this.a.$updateKernel(L,q)})},ve=new m.$Ac,re={get id(){return I},get notebookType(){return q.notebookType},onDidChangeSelectedNotebooks:C.event,get label(){return q.label},set label($e){q.label=$e??$.displayName??$.name,ue()},get detail(){return q.detail??""},set detail($e){q.detail=$e,ue()},get description(){return q.description??""},set description($e){q.description=$e,ue()},get supportedLanguages(){return q.supportedLanguages},set supportedLanguages($e){q.supportedLanguages=$e,ue()},get supportsExecutionOrder(){return q.supportsExecutionOrder??!1},set supportsExecutionOrder($e){q.supportsExecutionOrder=$e,ue()},get rendererScripts(){return q.preloads?q.preloads.map(k.NotebookRendererScript.to):[]},get executeHandler(){return ne},set executeHandler($e){ne=$e??W},get interruptHandler(){return ce},set interruptHandler($e){ce=$e,q.supportsInterrupt=!!$e,ue()},set variableProvider($e){(0,r.$1F)($,"notebookVariableProvider"),ye=$e,q.hasVariableProvider=!!$e,$e?.onDidChangeVariables(ie=>J.a.$variablesUpdated(ie.uri)),ue()},get variableProvider(){return ye},createNotebookCellExecution($e){if(U)throw new Error("notebook controller is DISPOSED");if(!ve.has($e.notebook.uri))throw J.q.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ve.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.notebook.uri.toString()}`);return J._createNotebookCellExecution($e,v($.identifier,this.id))},createNotebookExecution($e){if((0,r.$1F)($,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!ve.has($e.uri))throw J.q.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ve.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.uri.toString()}`);return J._createNotebookExecution($e,v($.identifier,this.id))},dispose:()=>{U||(this.q.trace(`NotebookController[${L}], DISPOSED`),U=!0,this.j.delete(L),C.dispose(),O.dispose(),this.a.$removeKernel(L))},updateNotebookAffinity($e,ie){ie===g.NotebookControllerAffinity2.Hidden&&(0,r.$1F)($,"notebookControllerAffinityHidden"),J.a.$updateNotebookPriority(L,$e.uri,ie)},onDidReceiveMessage:O.event,postMessage($e,ie){return(0,r.$1F)($,"notebookMessaging"),J.a.$postMessage(L,ie&&J.n.getIdByEditor(ie),$e)},asWebviewUri($e){return(0,r.$1F)($,"notebookMessaging"),(0,s.$Lxb)($e,J.m.remote)}};return this.j.set(L,{extensionId:$.identifier,controller:re,onDidReceiveMessage:O,onDidChangeSelection:C,associatedNotebooks:ve}),re}getIdByController($){for(const[I,h]of this.j)if(h.controller===$)return v(h.extensionId,$.id);return null}createNotebookControllerDetectionTask($,I){const h=this.g++,y=this;this.q.trace(`NotebookControllerDetectionTask[${h}], CREATED by ${$.identifier.value}`),this.a.$addKernelDetectionTask(h,I);const w={dispose:()=>{this.f.delete(h),y.a.$removeKernelDetectionTask(h)}};return this.f.set(h,w),w}registerKernelSourceActionProvider($,I,h){const y=this.i++,w=typeof h.onDidChangeNotebookKernelSourceActions=="function"?y:void 0,A=this;this.h.set(y,h),this.q.trace(`NotebookKernelSourceActionProvider[${y}], CREATED by ${$.identifier.value}`),this.a.$addKernelSourceActionProvider(y,y,I);let L;return w!==void 0&&(L=h.onDidChangeNotebookKernelSourceActions(J=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.h.delete(y),A.a.$removeKernelSourceActionProvider(y,y),L?.dispose()}}}async $provideKernelSourceActions($,I){const h=this.h.get($);if(h){const y=new R.$Sc;return(await h.provideNotebookKernelSourceActions(I)??[]).map(A=>k.NotebookKernelSourceAction.from(A,this.o.converter,y))}return[]}$acceptNotebookAssociation($,I,h){const y=this.j.get($);if(y){const w=this.n.getNotebookDocument(f.URI.revive(I));h?y.associatedNotebooks.set(w.uri,!0):y.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${$}] ASSOCIATE notebook`,w.uri.toString(),h),y.onDidChangeSelection.fire({selected:h,notebook:w.apiNotebook})}}async $executeCells($,I,h){const y=this.j.get($);if(!y)return;const w=this.n.getNotebookDocument(f.URI.revive(I)),A=[];for(const L of h){const J=w.getCell(L);J&&A.push(J.apiCell)}try{this.q.trace(`NotebookController[${$}] EXECUTE cells`,w.uri.toString(),A.length),await y.controller.executeHandler.call(y.controller,A,w.apiNotebook,y.controller)}catch(L){this.q.error(`NotebookController[${$}] execute cells FAILED`,L),console.error(L)}}async $cancelCells($,I,h){const y=this.j.get($);if(!y)return;const w=this.n.getNotebookDocument(f.URI.revive(I));if(y.controller.interruptHandler)await y.controller.interruptHandler.call(y.controller,w.apiNotebook);else for(const A of h){const L=w.getCell(A);L&&this.b.get(L.uri)?.cancel()}if(y.controller.interruptHandler){const A=this.c.get(w.uri);h.length&&Array.isArray(A)&&A.length&&A.forEach(L=>L.dispose())}}async $provideVariables($,I,h,y,w,A,L){const J=this.j.get($);if(!J)return;const W=this.n.getNotebookDocument(f.URI.revive(h)),U=J.controller.variableProvider;if(!U)return;let C;if(y!==void 0){if(C=this.s[y],!C)return}else this.s={};const O=w==="named"?g.NotebookVariablesRequestKind.Named:g.NotebookVariablesRequestKind.Indexed,q=U.provideVariables(W.apiNotebook,C,O,A,L);let ne=0;for await(const ce of q){if(L.isCancellationRequested)return;const ye={id:this.r++,name:ce.variable.name,value:ce.variable.value,type:ce.variable.type,language:ce.variable.language,expression:ce.variable.expression,hasNamedChildren:ce.hasNamedChildren,indexedChildrenCount:ce.indexedChildrenCount,extensionId:J.extensionId.value};if(this.s[ye.id]=ce.variable,this.a.$receiveVariable(I,ye),ne++>=n.$9gb)return}}$acceptKernelMessageFromRenderer($,I,h){const y=this.j.get($);if(!y)return;const w=this.n.getEditorById(I);y.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:h}))}$cellExecutionChanged($,I,h){const w=this.n.getNotebookDocument(f.URI.revive($)).getCell(I);if(w){const A=h?k.NotebookCellExecutionState.to(h):g.NotebookCellExecutionState.Idle;A!==void 0&&this.l.fire({cell:w.apiCell,state:A})}}_createNotebookCellExecution($,I){if($.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const y=this.n.getNotebookDocument($.notebook.uri).getCellFromApiCell($);if(!y)throw new Error("invalid cell");if(this.b.has(y.uri))throw new Error(`duplicate execution for ${y.uri}`);const w=new t(I,y,this.a);this.b.set(y.uri,w);const A=w.onDidChangeState(()=>{w.state===d.Resolved&&(w.dispose(),A.dispose(),this.b.delete(y.uri))});return w.asApiObject()}_createNotebookExecution($,I){const h=this.n.getNotebookDocument($.uri),y=$.getCells().find(L=>{const J=h.getCellFromApiCell(L);return J&&this.b.has(J.uri)});if(y)throw new Error(`duplicate cell execution for ${y.document.uri}`);if(this.c.has(h.uri))throw new Error(`duplicate notebook execution for ${h.uri}`);const w=new u(I,h,this.a),A=w.onDidChangeState(()=>{w.state===p.Resolved&&(w.dispose(),A.dispose(),this.c.delete(h.uri))});return this.c.set(h.uri,[w,A]),w.asApiObject()}};e.$Qjc=c,e.$Qjc=c=Qe([qe(4,N.$Aj)],c);var d;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(d||(d={}));class t extends R.$Tc{static{this.a=0}get state(){return this.f}constructor($,I,h){super(),this.m=I,this.n=h,this.b=t.a++,this.c=new F.$6d,this.onDidChangeState=this.c.event,this.f=d.Init,this.g=this.B(new P.$de),this.h=new o(10,y=>this.s(y)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,$,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r($){await this.h.addItem($)}async s($){const I=Array.isArray($)?$:[$];return this.n.$updateExecution(this.b,new i.$0v(I))}t(){if(this.f===d.Init)throw new Error("Must call start before modifying cell output");if(this.f===d.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w($){let I=this.m;if($&&(I=this.m.notebook.getCellFromApiCell($)),!I)throw new Error("INVALID cell");return I.handle}y($){return $.map(I=>{const h=g.$DN.ensureUniqueMimeTypes(I.items,!0);return h===I.items?k.NotebookCellOutput.from(I):k.NotebookCellOutput.from({items:h,id:I.id,metadata:I.metadata})})}async z($,I,h){const y=this.w(I),w=this.y((0,S.$3b)($));return this.r({editType:a.CellExecutionUpdateType.Output,cellHandle:y,append:h,outputs:w})}async C($,I,h){return $=g.$DN.ensureUniqueMimeTypes((0,S.$3b)($),!0),this.r({editType:a.CellExecutionUpdateType.OutputItems,items:$.map(k.NotebookCellOutputItem.from),outputId:I.id,append:h})}asApiObject(){const $=this;return Object.freeze({get token(){return $.g.token},get cell(){return $.m.apiCell},get executionOrder(){return $.j},set executionOrder(h){$.j=h,$.s([{editType:a.CellExecutionUpdateType.ExecutionState,executionOrder:$.j}])},start(h){if($.f===d.Resolved||$.f===d.Started)throw new Error("Cannot call start again");$.f=d.Started,$.c.fire(),$.s({editType:a.CellExecutionUpdateType.ExecutionState,runStartTime:h})},end(h,y){if($.f===d.Resolved)throw new Error("Cannot call resolve twice");$.f=d.Resolved,$.c.fire(),$.h.flush(),$.n.$completeExecution($.b,new i.$0v({runEndTime:y,lastRunSuccess:h}))},clearOutput(h){return $.t(),$.z([],h,!1)},appendOutput(h,y){return $.t(),$.z(h,y,!0)},replaceOutput(h,y){return $.t(),$.z(h,y,!1)},appendOutputItems(h,y){return $.t(),$.C(h,y,!0)},replaceOutputItems(h,y){return $.t(),$.C(h,y,!1)}})}}var p;(function(b){b[b.Init=0]="Init",b[b.Started=1]="Started",b[b.Resolved=2]="Resolved"})(p||(p={}));class u extends R.$Tc{static{this.a=0}get state(){return this.f}constructor($,I,h){super(),this.h=I,this.j=h,this.b=u.a++,this.c=new F.$6d,this.onDidChangeState=this.c.event,this.f=p.Init,this.g=this.B(new P.$de),this.j.$createNotebookExecution(this.b,$,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===p.Resolved||this.f===p.Started)throw new Error("Cannot call start again");this.f=p.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===p.Resolved)throw new Error("Cannot call resolve twice");this.f=p.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class o{constructor($,I){this.f=$,this.g=I,this.a=[],this.b=Date.now()}addItem($){return this.a.push($),this.c||(this.c=new M.$Dh,this.b=Date.now(),(0,M.$hh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const $=this.c;this.c=void 0;const I=this.a;return this.a=[],this.g(I).finally(()=>$.complete())}}function v(b,$){return`${b.value}/${$}`}e.$Rjc=v}),define(Pe[66],Re([1,0,5,4,3,2,17,6,7,169,14,197,25,33,198,40,11,8,31]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g,s,a,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ic=e.$5ic=e.$4ic=e.$3ic=void 0,e.$3ic=(0,P.$gi)("IExtHostTerminalService");class n{constructor(h,y,w,A){this.l=h,this._id=y,this.m=w,this.n=A,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(J=>this.f=J);const L=this;this.value={get name(){return L.n||""},get processId(){return L.b},get creationOptions(){return L.m},get exitStatus(){return L.h},get state(){return L.j},get selection(){return L.k},sendText(J,W=!0){L.q(),L.l.$sendText(L._id,J,W)},show(J){L.q(),L.l.$show(L._id,J)},hide(){L.q(),L.l.$hide(L._id)},dispose(){L.a||(L.a=!0,L.l.$dispose(L._id))},get dimensions(){if(!(L.d===void 0||L.g===void 0))return{columns:L.d,rows:L.g}}}}async create(h,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:h.name,shellPath:h.shellPath??void 0,shellArgs:h.shellArgs??void 0,cwd:h.cwd??y?.cwd??void 0,env:h.env??void 0,icon:v(h.iconPath)??void 0,color:s.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:h.message??void 0,strictEnv:h.strictEnv??void 0,hideFromUser:h.hideFromUser??void 0,forceShellIntegration:y?.forceShellIntegration??void 0,isFeatureTerminal:y?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:y?.useShellEnvironment??void 0,location:y?.location||this.o(h.location,y?.resolvedExtHostIdentifier),isTransient:h.isTransient??void 0})}async createExtensionTerminal(h,y,w,A,L){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:A,color:s.ThemeColor.isThemeColor(L)?L.id:void 0,location:y?.location||this.o(h,w),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(h,y){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&y?{parentTerminal:y}:"viewColumn"in h?{viewColumn:r.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus}:void 0:h}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(h){this.n=h}setExitStatus(h,y){this.h=Object.freeze({code:h,reason:y})}setDimensions(h,y){return h===this.d&&y===this.g||h===0||y===0?!1:(this.d=h,this.g=y,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(h){this.k=h}_setProcessId(h){this.f?(this.f(h),this.f=void 0):this.b.then(y=>{y!==h&&(this.b=Promise.resolve(h))})}}e.$4ic=n;class c{get onProcessReady(){return this.b.event}constructor(h){this.g=h,this.id=0,this.shouldPersist=!1,this.a=new S.$6d,this.onProcessData=this.a.event,this.b=new S.$6d,this.d=new S.$6d,this.onDidChangeProperty=this.d.event,this.f=new S.$6d,this.onProcessExit=this.f.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,y){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${y}`)}async start(){}shutdown(){this.g.close()}input(h){this.g.handleInput?.(h)}resize(h,y){this.g.setDimensions?.({columns:h,rows:y})}clearBuffer(){}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(h){this.g.onDidWrite(y=>this.a.fire(y)),this.g.onDidClose?.((y=void 0)=>{this.f.fire(y===void 0?void 0:y)}),this.g.onDidOverrideDimensions?.(y=>{y&&this.d.fire({type:"overrideDimensions",value:{cols:y.columns,rows:y.rows}})}),this.g.onDidChangeName?.(y=>{this.d.fire({type:"title",value:y})}),this.g.open(h||void 0),h&&this.g.setDimensions?.(h),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let d=1,t=class extends m.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(h=>h.value)}constructor(h,y,w){super(),this.Q=y,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new S.$6d,this.onDidCloseTerminal=this.H.event,this.I=new S.$6d,this.onDidOpenTerminal=this.I.event,this.J=new S.$6d,this.onDidChangeActiveTerminal=this.J.event,this.L=new S.$6d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new S.$6d,this.onDidChangeTerminalState=this.M.event,this.N=new S.$6d,this.onDidChangeShell=this.N.event,this.O=new S.$6d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new S.$6d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=w.getProxy(M.$0L.MainThreadTerminalService),this.y=new g.$Qtb(this.a.$sendProcessData),this.a.$registerProcessSupport(h),this.Q.registerArgumentProcessor({processArgument:A=>{const L=J=>{const W=J;return this.W(W.instanceId)?.value};switch(A?.$mid){case 15:return L(A);default:{if(Array.isArray(A))for(let J=0;J<A.length&&A[J].$mid===15;J++)A[J]=L(A[J]);return A}}}}),this.B({dispose:()=>{for(const[A,L]of this.g)L.shutdown(!0)}})}getDefaultShell(h){return(h?this.u:this.s)?.path||""}getDefaultShellArgs(h){return(h?this.u:this.s)?.args||[]}createExtensionTerminal(h,y){const w=new n(this.a,(0,k.$Cg)(),h,h.name),A=new c(h.pty);return w.createExtensionTerminal(h.location,y,this.R(h,y).resolvedExtHostIdentifier,v(h.iconPath),b(h.color)).then(L=>{const J=this.S(L,A);this.h[L]=J}),this.f.push(w),w.value}R(h,y){if(y=y||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const w=h.location.parentTerminal;if(w){const A=this.f.find(L=>L.value===w);A&&(y.resolvedExtHostIdentifier=A._id)}}else h.location&&typeof h.location!="object"?y.location=h.location:y.location&&typeof y.location=="object"&&"splitActiveTerminal"in y.location&&(y.location={splitActiveTerminal:!0});return y}attachPtyToTerminal(h,y){if(!this.W(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const A=new c(y),L=this.S(h,A);this.h[h]=L}async $acceptActiveTerminalChanged(h){const y=this.b;if(h===null){this.b=void 0,y!==this.b&&this.J.fire(this.b);return}const w=this.W(h);w&&(this.b=w,y!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(h,y){const w=this.W(h);w&&this.O.fire({terminal:w.value,data:y})}async $acceptTerminalDimensions(h,y,w){const A=this.W(h);A&&A.setDimensions(y,w)&&this.L.fire({terminal:A.value,dimensions:A.value.dimensions})}async $acceptDidExecuteCommand(h,y){const w=this.W(h);w&&this.P.fire({terminal:w.value,...y})}async $acceptTerminalMaximumDimensions(h,y,w){this.g.get(h)?.resize(y,w)}async $acceptTerminalTitleChange(h,y){const w=this.W(h);w&&(w.name=y)}async $acceptTerminalClosed(h,y,w){const A=this.Y(this.f,h);if(A!==null){const L=this.f.splice(A,1)[0];L.setExitStatus(y,w),this.H.fire(L.value)}}$acceptTerminalOpened(h,y,w,A){if(y){const W=this.Y(this.f,y);if(W!==null){this.f[W]._id=h,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const L={name:A.name,shellPath:A.executable,shellArgs:A.args,cwd:typeof A.cwd=="string"?A.cwd:F.URI.revive(A.cwd),env:A.env,hideFromUser:A.hideFromUser},J=new n(this.a,h,L,w);this.f.push(J),this.I.fire(J.value),J.isOpen=!0}async $acceptTerminalProcessId(h,y){this.W(h)?._setProcessId(y)}async $startExtensionTerminal(h,y){const w=this.W(h);if(!w)return{message:(0,E.localize)(0,null,h)};w.isOpen||await new Promise(L=>{const J=this.onDidOpenTerminal(async W=>{W===w.value&&(J.dispose(),L())})});const A=this.g.get(h);A?A.startSendingEvents(y):this.j[h]={initialDimensions:y}}S(h,y){const w=new m.$Sc;w.add(y.onProcessReady(L=>this.a.$sendProcessReady(h,L.pid,L.cwd,L.windowsPty))),w.add(y.onDidChangeProperty(L=>this.a.$sendProcessProperty(h,L))),this.y.startBuffering(h,y.onProcessData),w.add(y.onProcessExit(L=>this.U(h,L))),this.g.set(h,y);const A=this.j[h];return A&&y instanceof c&&(y.startSendingEvents(A.initialDimensions),delete this.j[h]),w}$acceptProcessAckDataEvent(h,y){this.g.get(h)?.acknowledgeDataEvent(y)}$acceptProcessInput(h,y){this.g.get(h)?.input(y)}$acceptTerminalInteraction(h){const y=this.W(h);y?.setInteractedWith()&&this.M.fire(y.value)}$acceptTerminalSelection(h,y){this.W(h)?.setSelection(y)}$acceptProcessResize(h,y,w){try{this.g.get(h)?.resize(y,w)}catch(A){if(A.code!=="EPIPE"&&A.code!=="ERR_IPC_CHANNEL_CLOSED")throw A}}$acceptProcessShutdown(h,y){this.g.get(h)?.shutdown(y)}$acceptProcessRequestInitialCwd(h){this.g.get(h)?.getInitialCwd().then(y=>this.a.$sendProcessProperty(h,{type:"initialCwd",value:y}))}$acceptProcessRequestCwd(h){this.g.get(h)?.getCwd().then(y=>this.a.$sendProcessProperty(h,{type:"cwd",value:y}))}$acceptProcessRequestLatency(h){return Promise.resolve(h)}registerLinkProvider(h){return this.z.add(h),this.z.size===1&&this.a.$startLinkProvider(),new f.$_L(()=>{this.z.delete(h),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(h,y,w){if(this.C.has(y))throw new Error(`Terminal profile provider "${y}" already registered`);return this.C.set(y,w),this.a.$registerProfileProvider(y,h.identifier.value),new f.$_L(()=>{this.C.delete(y),this.a.$unregisterProfileProvider(y)})}registerTerminalQuickFixProvider(h,y,w){if(this.D.has(h))throw new Error(`Terminal quick fix provider "${h}" is already registered`);return this.D.set(h,w),this.a.$registerQuickFixProvider(h,y),new f.$_L(()=>{this.D.delete(h),this.a.$unregisterQuickFixProvider(h)})}async $provideTerminalQuickFixes(h,y){const w=new l.$de().token;if(w.isCancellationRequested)return;const A=this.D.get(h);if(!A)return;const L=await A.provideTerminalQuickFixes(y,w);if(L===null||Array.isArray(L)&&L.length===0)return;const J=new m.$Sc;if(this.w.value=J,!Array.isArray(L))return L?r.TerminalQuickFix.from(L,this.Q.converter,J):void 0;const W=[];for(const U of L){const C=r.TerminalQuickFix.from(U,this.Q.converter,J);C&&W.push(C)}return W}async $createContributedProfileTerminal(h,y){const w=new l.$de().token;let A=await this.C.get(h)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(A&&!("options"in A)&&(A={options:A}),!A||!("options"in A))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in A.options){this.createExtensionTerminal(A.options,y);return}this.createTerminalFromOptions(A.options,y)}}async $provideLinks(h,y){const w=this.W(h);if(!w)return[];this.F.delete(h),this.G.get(h)?.dispose(!0);const L=new l.$de;this.G.set(h,L);const J=[],W={terminal:w.value,line:y},U=[];for(const q of this.z)U.push(a.Promises.withAsyncBody(async ne=>{L.token.onCancellationRequested(()=>ne({provider:q,links:[]}));const ce=await q.provideTerminalLinks(W,L.token)||[];L.token.isCancellationRequested||ne({provider:q,links:ce})}));const C=await Promise.all(U);if(L.token.isCancellationRequested)return[];const O=new Map;for(const q of C)q&&q.links.length>0&&J.push(...q.links.map(ne=>{const ce={id:d++,startIndex:ne.startIndex,length:ne.length,label:ne.tooltip};return O.set(ce.id,{provider:q.provider,link:ne}),ce}));return this.F.set(h,O),J}$activateLink(h,y){const w=this.F.get(h)?.get(y);w&&w.provider.handleTerminalLink(w.link)}U(h,y){this.y.stopBuffering(h),this.g.delete(h),delete this.j[h];const w=this.h[h];w&&(w.dispose(),delete this.h[h]),this.a.$sendProcessExit(h,y)}W(h){return this.X(this.f,h)}X(h,y){const w=this.Y(h,y);return w!==null?h[w]:null}Y(h,y){const w=h.findIndex(A=>A._id===y);return w===-1?null:w}getEnvironmentVariableCollection(h){let y=this.n.get(h.identifier.value);return y||(y=new p,this.$(h.identifier.value,y)),y.getScopedEnvironmentVariableCollection(void 0)}Z(h,y){const w=(0,D.$2r)(y.map),A=(0,D.$3r)(y.descriptionMap);this.a.$setEnvironmentVariableCollection(h,y.persistent,w.length===0?void 0:w,A)}$initEnvironmentVariableCollections(h){h.forEach(y=>{const w=y[0],A=new p(y[1]);this.$(w,A)})}$acceptDefaultProfile(h,y){const w=this.s;this.s=h,this.u=y,w?.path!==h.path&&this.N.fire(h.path)}$(h,y){this.n.set(h,y),y.onDidChangeCollection(()=>{this.Z(h,y)})}};e.$5ic=t,e.$5ic=t=Qe([qe(1,i.$LO),qe(2,R.$pO)],t);class p{get persistent(){return this.b}set persistent(h){this.b=h,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(h){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new S.$6d,this.map=new Map(h)}getScopedEnvironmentVariableCollection(h){const y=this.h(h);let w=this.a.get(y);return w||(w=new u(this,h),this.a.set(y,w),w.onDidChangeCollection(()=>this.d.fire())),w}replace(h,y,w,A){this.f(h,{value:y,type:f.EnvironmentVariableMutatorType.Replace,options:w??{applyAtProcessCreation:!0},scope:A})}append(h,y,w,A){this.f(h,{value:y,type:f.EnvironmentVariableMutatorType.Append,options:w??{applyAtProcessCreation:!0},scope:A})}prepend(h,y,w,A){this.f(h,{value:y,type:f.EnvironmentVariableMutatorType.Prepend,options:w??{applyAtProcessCreation:!0},scope:A})}f(h,y){if(y.options&&y.options.applyAtProcessCreation===!1&&!y.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const w=this.g(h,y.scope),A=this.map.get(w),L=y.options?{applyAtProcessCreation:y.options.applyAtProcessCreation??!1,applyAtShellIntegration:y.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!A||A.value!==y.value||A.type!==y.type||A.options?.applyAtProcessCreation!==L.applyAtProcessCreation||A.options?.applyAtShellIntegration!==L.applyAtShellIntegration||A.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index){const J=this.g(h,y.scope),W={variable:h,...y,options:L};this.map.set(J,W),this.d.fire()}}get(h,y){const w=this.g(h,y),A=this.map.get(w);return A?$(A):void 0}g(h,y){const w=this.h(y);return w.length?`${h}:::${w}`:h}h(h){return this.j(h?.workspaceFolder)??""}j(h){return h?h.uri.toString():void 0}getVariableMap(h){const y=new Map;for(const[w,A]of this.map)this.h(A.scope)===this.h(h)&&y.set(A.variable,$(A));return y}delete(h,y){const w=this.g(h,y);this.map.delete(w),this.d.fire()}clear(h){if(h?.workspaceFolder){for(const[y,w]of this.map)w.scope?.workspaceFolder?.index===h.workspaceFolder.index&&this.map.delete(y);this.k(h)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(h,y){const w=this.h(y),A=this.descriptionMap.get(w);if(!A||A.description!==h){let L;typeof h=="string"?L=h:L=h?.value.split(`

`)[0];const J={description:L,scope:y};this.descriptionMap.set(w,J),this.d.fire()}}getDescription(h){const y=this.h(h);return this.descriptionMap.get(y)?.description}k(h){const y=this.h(h);this.descriptionMap.delete(y)}}class u{get persistent(){return this.b.persistent}set persistent(h){this.b.persistent=h}get onDidChangeCollection(){return this.a&&this.a.event}constructor(h,y){this.b=h,this.d=y,this.a=new S.$6d}getScoped(h){return this.b.getScopedEnvironmentVariableCollection(h)}replace(h,y,w){this.b.replace(h,y,w,this.d)}append(h,y,w){this.b.append(h,y,w,this.d)}prepend(h,y,w){this.b.prepend(h,y,w,this.d)}get(h){return this.b.get(h,this.d)}forEach(h,y){this.b.getVariableMap(this.d).forEach((w,A)=>h.call(y,A,w,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(h){this.b.delete(h,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(h){this.b.setDescription(h,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends t{constructor(h,y){super(!1,h,y)}createTerminal(h,y,w){throw new N.$_}createTerminalFromOptions(h,y){throw new N.$_}};e.$6ic=o,e.$6ic=o=Qe([qe(0,i.$LO),qe(1,R.$pO)],o);function v(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function b(I){return s.ThemeColor.isThemeColor(I)?I:void 0}function $(I){const h={...I};return delete h.scope,h.options=h.options??void 0,delete h.variable,h}}),define(Pe[275],Re([1,0,11,23,25,5,247,99,6,26,16,33,13,4,17,113,8,7,48,75,60,22]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g,s,a,r,i,n,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_jc=e.$$jc=e.$0jc=e.$9jc=void 0;let t=class extends f.$Tc{constructor(U,C,O,q){super(),this.w=q,this.f=this.B(new F.$6d),this.g=new Map,this.s=this.B(new F.$6d),this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy(k.$0L.MainThreadTesting),this.m=new w(this.h),this.j=new v(this.h,C),O.registerArgumentProcessor({processArgument:ne=>{switch(ne?.$mid){case 16:{const ce=ne,ye=ce.tests[ce.tests.length-1].item.extId;return this.g.get(i.$ZK.root(ye))?.collection.tree.get(ye)?.actual??(0,s.$BO)(ne)}case 18:{const{extId:ce,message:ye}=ne;return{test:this.g.get(i.$ZK.root(ce))?.collection.tree.get(ce)?.actual,message:a.TestMessage.to(ye)}}default:return ne}}}),O.registerCommand(!1,"testing.getExplorerSelection",async()=>{const ne=await O.executeCommand("_testing.getExplorerSelection"),ce=ye=>{const Ie=this.g.get(i.$ZK.root(ye));if(Ie)return i.$ZK.isRoot(ye)?Ie.controller:Ie.collection.tree.get(ye)?.actual};return{include:ne?.include.map(ce).filter(N.$2f)||[],exclude:ne?.exclude.map(ce).filter(N.$2f)||[]}})}createTestController(U,C,O,q){if(this.g.has(C))throw new Error(`Attempt to insert a duplicate controller with ID "${C}"`);const ne=new f.$Sc,ce=ne.add(new s.$EO(C,O,this.w));ce.root.label=O;const ye=new Map,Ie=new Set,ue=this.h,ve={items:ce.root.children,get label(){return O},set label($e){O=$e,ce.root.label=$e,ue.$updateController(C,{label:O})},get refreshHandler(){return q},set refreshHandler($e){q=$e,ue.$updateController(C,{canRefresh:!!$e})},get id(){return C},createRunProfile:($e,ie,le,V,_,ke)=>{let Le=(0,m.$7i)($e);for(;ye.has(Le);)Le++;return new L(this.h,ye,Ie,this.s.event,C,Le,$e,ie,le,V,_,ke)},createTestItem($e,ie,le){return new s.$CO(C,$e,ie,le)},createTestRun:($e,ie,le=!0)=>this.j.createTestRun(U,C,ce,$e,ie,le),invalidateTestResults:$e=>{if($e===void 0)this.h.$markTestRetired(void 0);else{const ie=$e instanceof Array?$e:[$e];this.h.$markTestRetired(ie.map(le=>i.$ZK.fromExtHostTestItem(le,C).toString()))}},set resolveHandler($e){ce.resolveHandler=$e},get resolveHandler(){return ce.resolveHandler},dispose:()=>{ne.dispose()}};ue.$registerTestController(C,O,!!q),ne.add((0,f.$Rc)(()=>ue.$unregisterTestController(C)));const re={controller:ve,collection:ce,profiles:ye,extension:U,activeProfiles:Ie};return this.g.set(C,re),ne.add((0,f.$Rc)(()=>this.g.delete(C))),ne.add(ce.onDidGenerateDiff($e=>ue.$publishDiff(C,$e.map(c.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(U,C=P.CancellationToken.None){const O=b(U);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.g.get(O.controllerId);if(!q)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(ne=>i.$ZK.fromExtHostTestItem(ne,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:J[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:U.exclude?.map(ne=>ne.id)},C)}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}async $provideFileCoverage(U,C,O){return await this.j.getCoverageReport(U,C)?.provideFileCoverage(O)??[]}async $resolveFileCoverage(U,C,O,q){return await this.j.getCoverageReport(U,C)?.resolveFileCoverage(O,q)??[]}$configureRunProfile(U,C){this.g.get(U)?.profiles.get(C)?.configureHandler?.()}$setDefaultRunProfiles(U){const C=new Map;for(const[O,q]of Object.entries(U)){const ne=this.g.get(O);if(!ne)continue;const ce=new Map,ye=q.filter(ue=>!ne.activeProfiles.has(ue)),Ie=[...ne.activeProfiles].filter(ue=>!q.includes(ue));for(const ue of ye)ce.set(ue,!0),ne.activeProfiles.add(ue);for(const ue of Ie)ce.set(ue,!1),ne.activeProfiles.delete(ue);ce.size&&C.set(O,ce)}this.s.fire(C)}async $refreshTests(U,C){await this.g.get(U)?.controller.refreshHandler?.(C)}$publishTestResults(U){this.results=Object.freeze(U.map(C=>(0,E.$Mn)(a.TestResults.to(C))).concat(this.results).sort((C,O)=>O.completedAt-C.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,C){const O=this.g.get(i.$ZK.fromString(U).controllerId)?.collection;O&&(await O.expand(U,C<0?1/0:C),O.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(C=>c.TestsDiffOp.deserialize({asCanonicalUri:O=>O},C)))}async $runControllerTests(U,C){return Promise.all(U.map(O=>this.y(O,!1,C)))}async $startContinuousRun(U,C){const O=new P.$de(C),q=await Promise.all(U.map(ne=>this.y(ne,!0,O.token)));return!C.isCancellationRequested&&!q.some(ne=>ne.error)&&await new Promise(ne=>C.onCancellationRequested(ne)),O.dispose(!0),q}async y(U,C,O){const q=this.g.get(U.controllerId);if(!q)return{};const{collection:ne,profiles:ce,extension:ye}=q,Ie=ce.get(U.profileId);if(!Ie)return{};const ue=U.testIds.map(ie=>ne.tree.get(ie)).filter(N.$2f),ve=U.excludeExtIds.map(ie=>q.collection.tree.get(ie)).filter(N.$2f).filter(ie=>ue.some(le=>le.fullId.compare(ie.fullId)===2));if(!ue.length)return{};const re=new r.$KN(ue.some(ie=>ie.actual instanceof s.$DO)?void 0:ue.map(ie=>ie.actual),ve.map(ie=>ie.actual),Ie,C),$e=(0,c.$2K)(U)&&this.j.prepareForMainThreadTestRun(re,$.fromInternal(U,q.collection),ye,O);try{return await Ie.runHandler(re,O),{}}catch(ie){return{error:String(ie)}}finally{$e&&($e.hasRunningTasks&&!O.isCancellationRequested&&await F.Event.toPromise($e.onEnd),$e.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}};e.$9jc=t,e.$9jc=t=Qe([qe(0,g.$pO),qe(1,l.$Aj)],t);const p=1e4;var u;(function(W){W[W.Running=0]="Running",W[W.Cancelling=1]="Cancelling",W[W.Ended=2]="Ended"})(u||(u={}));class o extends f.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(U,C,O,q,ne){super(),this.s=U,this.w=C,this.y=O,this.z=q,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new F.$6d),this.m=this.B(new F.$6d),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new P.$de(ne));const ce=this.B(new S.$sh(()=>this.C(),p));this.B(this.h.token.onCancellationRequested(()=>ce.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(U){const C=this.s.id,O=this.s.controllerId,q=(0,D.$Cg)(),ne=this.y,ce=this.m;let ye;const Ie=$e=>(ie,...le)=>{if(ve){this.z.warn(`Setting the state of test "${ie.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ie)&&(this.F(ie),$e(ie,...le))},ue=($e,ie)=>{const le=ie instanceof Array?ie.map(a.TestMessage.from):[a.TestMessage.from(ie)];if($e.uri&&$e.range){const V={range:a.Range.from($e.range),uri:$e.uri};for(const _ of le)_.location=_.location||V}this.w.$appendTestMessagesInRun(C,q,i.$ZK.fromExtHostTestItem($e,O).toString(),le)};let ve=!1;const re={isPersisted:this.s.isPersisted,token:this.h.token,name:U,get coverageProvider(){return ye?.provider},set coverageProvider($e){(0,d.$1F)(ne,"testCoverage"),ye=$e&&new I($e),ce.fire({taskId:q,runId:C,coverage:ye})},enqueued:Ie($e=>{this.w.$updateTestStateInRun(C,q,i.$ZK.fromExtHostTestItem($e,O).toString(),1)}),skipped:Ie($e=>{this.w.$updateTestStateInRun(C,q,i.$ZK.fromExtHostTestItem($e,O).toString(),5)}),started:Ie($e=>{this.w.$updateTestStateInRun(C,q,i.$ZK.fromExtHostTestItem($e,O).toString(),2)}),errored:Ie(($e,ie,le)=>{ue($e,ie),this.w.$updateTestStateInRun(C,q,i.$ZK.fromExtHostTestItem($e,O).toString(),6,le)}),failed:Ie(($e,ie,le)=>{ue($e,ie),this.w.$updateTestStateInRun(C,q,i.$ZK.fromExtHostTestItem($e,O).toString(),4,le)}),passed:Ie(($e,ie)=>{this.w.$updateTestStateInRun(C,q,i.$ZK.fromExtHostTestItem($e,this.s.controllerId).toString(),3,ie)}),appendOutput:($e,ie,le)=>{ve||(le&&(this.s.isIncluded(le)?this.F(le):le=void 0),this.w.$appendOutputToRun(C,q,M.$te.fromString($e),ie&&a.location.from(ie),le&&i.$ZK.fromExtHostTestItem(le,O).toString()))},end:()=>{ve||(ve=!0,this.w.$finishedTestRunTask(C,q),this.f.delete(q),this.f.size||this.D())}};return this.f.set(q,{run:re}),this.w.$startedTestRunTask(C,{id:q,name:U,running:!0}),re}C(){for(const{run:U}of this.f.values())U.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(U){if(!(U instanceof s.$CO))throw new n.$hO(U.id);if(this.g.has(i.$ZK.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const C=[],O=this.s.colllection.root;for(;;){const q=a.TestItem.from(U);if(C.unshift(q),this.g.has(q.extId)||(this.g.add(q.extId),U===O))break;U=U.parent||O}this.w.$addTestsToRun(this.s.controllerId,this.s.id,C)}dispose(){this.D(),super.dispose()}}class v{get trackers(){return this.c.values()}constructor(U,C){this.g=U,this.h=C,this.c=new Map,this.f=[]}getCoverageReport(U,C){return this.f.find(O=>O.runId===U)?.coverage.get(C)}prepareForMainThreadTestRun(U,C,O,q){return this.j(U,C,O,q)}cancelRunById(U){for(const C of this.c.values())if(C.id===U){C.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,C,O,q,ne,ce){const ye=this.c.get(q);if(ye)return ye.createRun(ne);const Ie=$.fromPublic(C,O,q,ce),ue=b(q);this.g.$startedExtensionTestRun({controllerId:C,continuous:!!q.continuous,profile:ue&&{group:J[ue.kind],id:ue.profileId},exclude:q.exclude?.map(re=>i.$ZK.fromExtHostTestItem(re,O.root.id).toString())??[],id:Ie.id,include:q.include?.map(re=>i.$ZK.fromExtHostTestItem(re,O.root.id).toString())??[O.root.id],persist:ce});const ve=this.j(q,Ie,U);return F.Event.once(ve.onEnd)(()=>{this.g.$finishedExtensionTestRun(Ie.id),ve.dispose()}),ve.createRun(ne)}j(U,C,O,q){const ne=new o(C,this.g,O,this.h,q);this.c.set(U,ne);let ce;const ye=ne.onDidCoverage(({runId:Ie,taskId:ue,coverage:ve})=>{ce||(ce={runId:Ie,coverage:new Map},this.f.unshift(ce),this.f.length>c.$7K&&this.f.pop()),ce.coverage.set(ue,ve),this.g.$signalCoverageAvailable(Ie,ue,!!ve)});return F.Event.once(ne.onEnd)(()=>{this.c.delete(U),ye.dispose()}),ne}}e.$0jc=v;const b=W=>{if(W.profile){if(!(W.profile instanceof L))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return W.profile}};class ${static fromPublic(U,C,O,q){return new $(U,(0,D.$Cg)(),O.include?.map(ne=>i.$ZK.fromExtHostTestItem(ne,U).toString())??[U],O.exclude?.map(ne=>i.$ZK.fromExtHostTestItem(ne,U).toString())??[],q,C)}static fromInternal(U,C){return new $(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,C)}constructor(U,C,O,q,ne,ce){this.controllerId=U,this.id=C,this.isPersisted=ne,this.colllection=ce,this.c=O.map(ye=>ye+"\0"),this.f=q.map(ye=>ye+"\0")}isIncluded(U){const C=i.$ZK.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const O of this.f)if(C===O||C.startsWith(O))return!1;for(const O of this.c)if(C===O||C.startsWith(O))return!0;return!1}}e.$$jc=$;class I{constructor(U){this.provider=U}async provideFileCoverage(U){this.c||(this.c=(async()=>this.provider.provideFileCoverage(U))());try{return(await this.c)?.map(a.TestCoverage.fromFile)??[]}catch(C){throw this.c=void 0,C}}async resolveFileCoverage(U,C){const O=await this.c;let q=O?.[U];return!this.provider||!O||!q?[]:(q.detailedCoverage||(q=O[U]=await this.provider.resolveFileCoverage?.(q,C)??q),q.detailedCoverage?.map(a.TestCoverage.fromDetailed)??[])}}class h{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,a.TestItem.toPlain(U.item)),this.c.has(U)||this.f.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.f.delete(U);const C=i.$ZK.parentId(U.item.extId);if(C&&this.h.has(C.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{c:U,f:C,g:O}=this;return{get added(){return[...U].map(q=>q.revived)},get updated(){return[...C].map(q=>q.revived)},get removed(){return[...O].map(q=>q.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class y extends c.$8K{constructor(){super(...arguments),this.s=new F.$6d,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}w(U,C){return{...U,revived:a.TestItem.toPlain(U.item),depth:C?C.depth+1:0,children:new Set}}v(){return new h(this.s)}}class w{constructor(U){this.f=U}checkout(){this.c||(this.c=this.g());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(C=>C.revived)},dispose:(0,R.$db)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}g(){const U=new y({asCanonicalUri:C=>C});return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}const A=(W,U,C,O)=>{C?Object.assign(C,O):U.$updateTestRunConfig(W.controllerId,W.profileId,O)};class L{#e;#t;#i;#n;#s;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,A(this,this.#e,this.#n,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,A(this,this.#e,this.#n,{supportsContinuousRun:U}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(U){U!==this.isDefault&&(U?this.#t.add(this.profileId):this.#t.delete(this.profileId),A(this,this.#e,this.#n,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,A(this,this.#e,this.#n,{tag:U?a.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,A(this,this.#e,this.#n,{hasConfigurationHandler:!!U}))}get onDidChangeDefault(){return F.Event.chain(this.#i,U=>U.map(C=>C.get(this.controllerId)?.get(this.profileId)).filter(N.$2f))}constructor(U,C,O,q,ne,ce,ye,Ie,ue,ve=!1,re=void 0,$e=!1){this.controllerId=ne,this.profileId=ce,this.f=ye,this.kind=Ie,this.runHandler=ue,this._tag=re,this.g=$e,this.#e=U,this.#s=C,this.#t=O,this.#i=q,C.set(ce,this);const ie=J[Ie];if(typeof ie!="number")throw new Error(`Unknown TestRunProfile.group ${Ie}`);ve&&O.add(ce),this.#n={profileId:ce,controllerId:ne,tag:re?a.TestTag.namespace(this.controllerId,re.id):null,label:ye,group:ie,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:$e},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$_jc=L;const J={[r.TestRunProfileKind.Coverage]:8,[r.TestRunProfileKind.Debug]:4,[r.TestRunProfileKind.Run]:2}}),define(Pe[114],Re([1,0,55,14,90,8,7]),function(me,e,S,M,P,F,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yO=e.$xO=e.$wO=void 0;class m{static{this.c=new P.$uO("TextEditorDecorationType")}constructor(l,k,g){const s=m.c.nextId();l.$registerTextEditorDecorationType(k.identifier,s,F.DecorationRenderOptions.from(g)),this.value=Object.freeze({key:s,dispose(){l.$removeTextEditorDecorationType(s)}})}}e.$wO=m;class f{constructor(l,k){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=k.undoStopBefore,this.f=k.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,k){this.k();let g=null;if(l instanceof R.$aM)g=new R.$bM(l,l);else if(l instanceof R.$bM)g=l;else throw new Error("Unrecognized location");this.l(g,k,!1)}insert(l,k){this.k(),this.l(new R.$bM(l,l),k,!0)}delete(l){this.k();let k=null;if(l instanceof R.$bM)k=l;else throw new Error("Unrecognized location");this.l(k,null,!0)}l(l,k,g){const s=this.c.validateRange(l);this.g.push({range:s,text:k,forceMoveMarkers:g})}setEndOfLine(l){if(this.k(),l!==R.EndOfLine.LF&&l!==R.EndOfLine.CRLF)throw(0,M.$7)("endOfLine");this.h=l}}class E{constructor(l,k,g,s){this.c=l,this.d=k,this._accept(g),this.e=s;const a=this;this.value={get tabSize(){return a.f},set tabSize(r){a.n(r)},get indentSize(){return a.g},set indentSize(r){a.p(r)},get insertSpaces(){return a.j},set insertSpaces(r){a.s(r)},get cursorStyle(){return a.k},set cursorStyle(r){a.t(r)},get lineNumbers(){return a.l},set lineNumbers(r){a.u(r)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=F.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const k=Math.floor(l);return k>0?k:null}if(typeof l=="string"){const k=parseInt(l,10);return isNaN(k)?null:k>0?k:null}return null}n(l){const k=this.m(l);if(k!==null){if(typeof k=="number"){if(this.f===k)return;this.f=k}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:k}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const k=Math.floor(l);return k>0?k:null}if(typeof l=="string"){const k=parseInt(l,10);return isNaN(k)?null:k>0?k:null}return null}p(l){const k=this.o(l);if(k!==null){if(typeof k=="number"){if(this.h===k)return;this.g=k,this.h=k}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:k}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const k=this.q(l);if(typeof k=="boolean"){if(this.j===k)return;this.j=k}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:k}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:F.TextEditorLineNumbersStyle.from(l)})))}assign(l){const k={};let g=!1;if(typeof l.tabSize<"u"){const s=this.m(l.tabSize);s==="auto"?(g=!0,k.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,g=!0,k.tabSize=s)}if(typeof l.indentSize<"u"){const s=this.o(l.indentSize);s==="tabSize"?(g=!0,k.indentSize=s):typeof s=="number"&&this.h!==s&&(this.g=s,this.h=s,g=!0,k.indentSize=s)}if(typeof l.insertSpaces<"u"){const s=this.q(l.insertSpaces);s==="auto"?(g=!0,k.insertSpaces=s):this.j!==s&&(this.j=s,g=!0,k.insertSpaces=s)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,g=!0,k.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,g=!0,k.lineNumbers=F.TextEditorLineNumbersStyle.from(l.lineNumbers)),g&&this.v("setOptions",this.c.$trySetOptions(this.d,k))}v(l,k){k.catch(g=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(g)})}}e.$xO=E;class N{constructor(l,k,g,s,a,r,i,n){this.id=l,this.j=k,this.k=g,this.g=!1,this.h=new Set,this.c=a,this.d=new E(this.j,this.id,r,g),this.e=i,this.f=n;const c=this;this.value=Object.freeze({get document(){return s.value},set document(d){throw new M.$9("document")},get selection(){return c.c&&c.c[0]},set selection(d){if(!(d instanceof R.$cM))throw(0,M.$7)("selection");c.c=[d],c.l()},get selections(){return c.c},set selections(d){if(!Array.isArray(d)||d.some(t=>!(t instanceof R.$cM)))throw(0,M.$7)("selections");c.c=d,c.l()},get visibleRanges(){return c.e},set visibleRanges(d){throw new M.$9("visibleRanges")},get options(){return c.d.value},set options(d){c.g||c.d.assign(d)},get viewColumn(){return c.f},set viewColumn(d){throw new M.$9("viewColumn")},edit(d,t={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const p=new f(s.value,t);return d(p),c.m(p)},insertSnippet(d,t,p={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!t||Array.isArray(t)&&t.length===0)u=c.c.map(o=>F.Range.from(o));else if(t instanceof R.$aM){const{lineNumber:o,column:v}=F.Position.from(t);u=[{startLineNumber:o,startColumn:v,endLineNumber:o,endColumn:v}]}else if(t instanceof R.$bM)u=[F.Range.from(t)];else{u=[];for(const o of t)if(o instanceof R.$bM)u.push(F.Range.from(o));else{const{lineNumber:v,column:b}=F.Position.from(o);u.push({startLineNumber:v,startColumn:b,endLineNumber:v,endColumn:b})}}return k.$tryInsertSnippet(l,s.value.version,d.value,u,p)},setDecorations(d,t){const p=t.length===0;p&&!c.h.has(d.key)||(p?c.h.delete(d.key):c.h.add(d.key),c.n(()=>{if(F.$mO(t))return k.$trySetDecorations(l,d.key,F.$nO(t));{const u=new Array(4*t.length);for(let o=0,v=t.length;o<v;o++){const b=t[o];u[4*o]=b.start.line+1,u[4*o+1]=b.start.character+1,u[4*o+2]=b.end.line+1,u[4*o+3]=b.end.character+1}return k.$trySetDecorationsFast(l,d.key,u)}}))},revealRange(d,t){c.n(()=>k.$tryRevealRange(l,F.Range.from(d),t||R.TextEditorRevealType.Default))},show(d){k.$tryShowEditor(l,F.ViewColumn.from(d))},hide(){k.$tryHideEditor(l)}})}dispose(){(0,S.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,S.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,S.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,S.ok)(!this.g),this.f=l}_acceptSelections(l){(0,S.ok)(!this.g),this.c=l}async l(){const l=this.c.map(F.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const k=l.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const g=k.edits.map(a=>a.range);g.sort((a,r)=>a.end.line===r.end.line?a.end.character===r.end.character?a.start.line===r.start.line?a.start.character-r.start.character:a.start.line-r.start.line:a.end.character-r.end.character:a.end.line-r.end.line);for(let a=0,r=g.length-1;a<r;a++){const i=g[a].end;if(g[a+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=k.edits.map(a=>({range:F.Range.from(a.range),text:a.text,forceMoveMarkers:a.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,k.documentVersionId,s,{setEndOfLine:typeof k.setEndOfLine=="number"?F.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this.k.warn(k),null))}}e.$yO=N}),define(Pe[67],Re([1,0,55,5,6,2,3,4,111,17,114,8,13,28,12,51,39]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AO=e.$zO=void 0;class r{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(c,d){this.h=c,this.i=d,this.a=null,this.b=new Map,this.c=new k.$Ac,this.d=new M.$6d,this.e=new M.$6d,this.f=new M.$6d,this.g=new M.$6d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const d=[],t=[],p=[];if(c.removedDocuments)for(const u of c.removedDocuments){const o=F.URI.revive(u),v=this.c.get(o);v?.unref()&&(this.c.delete(o),d.push(v.value))}if(c.addedDocuments)for(const u of c.addedDocuments){const o=F.URI.revive(u.uri);let v=this.c.get(o);if(v&&o.scheme!==g.Schemas.vscodeNotebookCell&&o.scheme!==g.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);v||(v=new r(new f.$sO(this.h.getProxy(m.$0L.MainThreadDocuments),o,u.lines,u.EOL,u.versionId,u.languageId,u.isDirty)),this.c.set(o,v),t.push(v.value)),v.ref()}if(c.removedEditors)for(const u of c.removedEditors){const o=this.b.get(u);this.b.delete(u),o&&p.push(o)}if(c.addedEditors)for(const u of c.addedEditors){const o=F.URI.revive(u.documentUri);S.ok(this.c.has(o),`document '${o}' does not exist`),S.ok(!this.b.has(u.id),`editor '${u.id}' already exists!`);const v=this.c.get(o).value,b=new N.$yO(u.id,this.h.getProxy(m.$0L.MainThreadTextEditors),this.i,new a.$V(()=>v.document),u.selections.map(D.Selection.to),u.options,u.visibleRanges.map($=>D.Range.to($)),typeof u.editorPosition=="number"?D.ViewColumn.to(u.editorPosition):void 0);this.b.set(u.id,b)}c.newActiveEditor!==void 0&&(S.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,P.$Oc)(d),(0,P.$Oc)(p),c.removedDocuments&&this.e.fire(d),c.addedDocuments&&this.d.fire(t),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(u=>u.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return s.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const d=this.b.get(this.a);return c?d:d?.value}allEditors(){return[...this.b.values()]}};e.$zO=i,e.$zO=i=Qe([qe(0,E.$pO),qe(1,l.$Aj)],i),e.$AO=(0,R.$gi)("IExtHostDocumentsAndEditors")}),define(Pe[276],Re([1,0,18,5,4,114,8,7]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vic=void 0;class f{constructor(N,D){this.i=D,this.a=new M.$6d,this.b=new M.$6d,this.c=new M.$6d,this.d=new M.$6d,this.f=new M.$6d,this.g=new M.$6d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=N.getProxy(P.$0L.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(N){const D=this.i.allEditors();return N?D:D.map(l=>l.value)}async showTextDocument(N,D,l){let k;typeof D=="number"?k={position:R.ViewColumn.from(D),preserveFocus:l}:typeof D=="object"?k={position:R.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?R.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:k={preserveFocus:!1};const g=await this.h.$tryShowTextDocument(N.uri,k),s=g&&this.i.getEditor(g);if(s)return s.value;throw g?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,D){return new F.$wO(this.h,N,D).value}$acceptEditorPropertiesChanged(N,D){const l=this.i.getEditor(N);if(!l)throw new Error("unknown text editor");if(D.options&&l._acceptOptions(D.options),D.selections){const k=D.selections.selections.map(R.Selection.to);l._acceptSelections(k)}if(D.visibleRanges){const k=S.$Hb(D.visibleRanges.map(R.Range.to));l._acceptVisibleRanges(k)}if(D.options&&this.b.fire({textEditor:l.value,options:{...D.options,lineNumbers:R.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const k=m.TextEditorSelectionChangeKind.fromValue(D.selections.source),g=D.selections.selections.map(R.Selection.to);this.a.fire({textEditor:l.value,selections:g,kind:k})}if(D.visibleRanges){const k=S.$Hb(D.visibleRanges.map(R.Range.to));this.c.fire({textEditor:l.value,visibleRanges:k})}}$acceptEditorPositionData(N){for(const D in N){const l=this.i.getEditor(D);if(!l)throw new Error("Unknown text editor");const k=R.ViewColumn.to(N[D]);l.value.viewColumn!==k&&(l._acceptViewColumn(k),this.d.fire({textEditor:l.value,viewColumn:k}))}}getDiffInformation(N){return Promise.resolve(this.h.$getDiffInformation(N))}}e.$vic=f}),define(Pe[277],Re([1,0,2,3,4,6,7,8,20,16]),function(me,e,S,M,P,F,R,m,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ckc=e.$bkc=void 0,e.$bkc=(0,M.$gi)("IExtHostTimeline");class N{constructor(k,g){this.b=new Map,this.c=new Map,this.a=k.getProxy(P.$0L.MainThreadTimeline),g.registerArgumentProcessor({processArgument:(s,a)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&f.$Am.equals(a,this.b.get(s.source)?.extension)){const r=s.uri===void 0?void 0:S.URI.revive(s.uri);return this.c.get(s.source)?.get(D(r))?.get(s.handle)}else return;return s}})}async $getTimeline(k,g,s,a){return this.b.get(k)?.provider.provideTimeline(S.URI.revive(g),s,a)}registerTimelineProvider(k,g,s,a){const r=new F.$Sc,i=this.d(g.id,a,r).bind(this);let n;g.onDidChange&&(n=g.onDidChange(d=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...d,id:g.id}),this));const c=this.c;return this.f({...g,scheme:k,onDidChange:void 0,async provideTimeline(d,t,p){t?.resetCache&&(r.clear(),c.get(g.id)?.clear());const u=await g.provideTimeline(d,t,p);if(u==null)return;const o=i(d,t);return{...u,source:g.id,items:u.items.map(o)}},dispose(){for(const d of c.values())d.get(g.id)?.clear();n?.dispose(),r.dispose()}},s)}d(k,g,s){return(a,r)=>{let i;if(r?.cacheResults){let n=this.c.get(k);n===void 0&&(n=new Map,this.c.set(k,n));const c=D(a);i=n.get(c),i===void 0&&(i=new Map,n.set(c,i))}return n=>{const{iconPath:c,...d}=n,t=`${k}|${n.id??n.timestamp}`;i?.set(t,n);let p,u,o;n.iconPath&&(c instanceof R.$7M?o={id:c.id,color:c.color}:S.URI.isUri(c)?(p=c,u=c):{light:p,dark:u}=c);let v;return R.$AM.isMarkdownString(d.tooltip)?v=m.MarkdownString.from(d.tooltip):(0,E.$Tf)(d.tooltip)?v=d.tooltip:R.$AM.isMarkdownString(d.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=m.MarkdownString.from(d.detail)):(0,E.$Tf)(d.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=d.detail),{...d,id:d.id??void 0,handle:t,source:k,command:n.command?g.toInternal(n.command,s):void 0,icon:p,iconDark:u,themeIcon:o,tooltip:v,accessibilityInformation:n.accessibilityInformation}}}}f(k,g){if(this.b.get(k.id))throw new Error(`Timeline Provider ${k.id} already exists.`);return this.a.$registerTimelineProvider({id:k.id,label:k.label,scheme:k.scheme}),this.b.set(k.id,{provider:k,extension:g}),(0,F.$Rc)(()=>{for(const a of this.c.values())a.get(k.id)?.clear();this.b.delete(k.id),this.a.$unregisterTimelineProvider(k.id),k.dispose()})}}e.$ckc=N;function D(l){return l?.toString()}}),define(Pe[278],Re([1,0,170,24,2,5,6,208,11,7,16,18,8,53,25,135,22]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkc=void 0;function r(c,d){if((0,N.$Tf)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let t;return Array.isArray(c.highlights)&&(t=c.highlights.filter(p=>p.length===2&&typeof p[0]=="number"&&typeof p[1]=="number"),t=t.length?t:void 0),{label:c.label,highlights:t}}}class i extends R.$Tc{constructor(d,t,p){super(),this.f=d,this.g=t,this.h=p,this.a=new Map,this.b=new s.$J9;function u(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:o=>u(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(v=>u(v)?this.r(v):v):o})}registerTreeDataProvider(d,t,p){const u=this.createTreeView(d,{treeDataProvider:t},p);return{dispose:()=>u.dispose()}}createTreeView(d,t,p){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=t.dragAndDropController?.dropMimeTypes??[],o=t.dragAndDropController?.dragMimeTypes??[],v=!!t.dragAndDropController?.handleDrag,b=!!t.dragAndDropController?.handleDrop,$=this.m(d,t,p),I={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:u,dragMimeTypes:o,hasHandleDrag:v,hasHandleDrop:b,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},h=this.f.$registerTreeViewDataProvider(d,I),y={get onDidCollapseElement(){return $.onDidCollapseElement},get onDidExpandElement(){return $.onDidExpandElement},get selection(){return $.selectedElements},get onDidChangeSelection(){return $.onDidChangeSelection},get activeItem(){return(0,a.$1F)(p,"treeViewActiveItem"),$.focusedElement},get onDidChangeActiveItem(){return(0,a.$1F)(p,"treeViewActiveItem"),$.onDidChangeActiveItem},get visible(){return $.visible},get onDidChangeVisibility(){return $.onDidChangeVisibility},get onDidChangeCheckboxState(){return $.onDidChangeCheckboxState},get message(){return $.message},set message(w){(0,k.$zk)(w)&&(0,a.$1F)(p,"treeViewMarkdownMessage"),$.message=w},get title(){return $.title},set title(w){$.title=w},get description(){return $.description},set description(w){$.description=w},get badge(){return $.badge},set badge(w){w!==void 0&&E.ViewBadge.isViewBadge(w)?$.badge={value:Math.floor(Math.abs(w.value)),tooltip:w.tooltip}:w===void 0&&($.badge=void 0)},reveal:(w,A)=>$.reveal(w,A),dispose:async()=>{await h,this.a.delete(d),$.dispose()}};return this.B(y),y}$getChildren(d,t){const p=this.a.get(d);return p?p.getChildren(t):Promise.reject(new m.$sF(d))}async $handleDrop(d,t,p,u,o,v,b,$){const I=this.a.get(d);if(!I)return Promise.reject(new m.$sF(d));const h=l.DataTransfer.toDataTransfer(p,async y=>(await this.f.$resolveDropFileData(d,t,y)).buffer);return b===d&&$&&await this.j(h,I,$,o,v),I.onDrop(h,u,o)}async j(d,t,p,u,o){const v=this.b.removeDragOperationTransfer(o);if(v)(await v)?.forEach((b,$)=>{b&&d.set($,b)});else if(o&&t.handleDrag){const b=t.handleDrag(p,d,u);this.b.addDragOperationTransfer(o,b),await b}return d}async $handleDrag(d,t,p,u){const o=this.a.get(d);if(!o)return Promise.reject(new m.$sF(d));const v=await this.j(new E.$4M,o,t,u,p);if(!(!v||u.isCancellationRequested))return l.DataTransfer.from(v)}async $hasResolve(d){const t=this.a.get(d);if(!t)throw new m.$sF(d);return t.hasResolve}$resolve(d,t,p){const u=this.a.get(d);if(!u)throw new m.$sF(d);return u.resolveTreeItem(t,p)}$setExpanded(d,t,p){const u=this.a.get(d);if(!u)throw new m.$sF(d);u.setExpanded(t,p)}$setSelectionAndFocus(d,t,p){const u=this.a.get(d);if(!u)throw new m.$sF(d);u.setSelectionAndFocus(t,p)}$setVisible(d,t){const p=this.a.get(d);if(!p){if(!t)return;throw new m.$sF(d)}p.setVisible(t)}$changeCheckboxState(d,t){const p=this.a.get(d);if(!p)throw new m.$sF(d);p.setCheckboxState(t)}m(d,t,p){const u=this.B(new n(d,t,this.f,this.g.converter,this.h,p));return this.a.set(d,u),u}r(d){const t=this.a.get(d.$treeViewId);return t&&"$treeItemHandle"in d?t.getExtensionElement(d.$treeItemHandle):t&&"$focusedTreeItem"in d&&d.$focusedTreeItem?t.focusedElement:null}}e.$dkc=i;class n extends R.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(d=>this.getExtensionElement(d)).filter(d=>!(0,N.$3f)(d))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(d,t,p,u,o,v){if(super(),this.I=d,this.J=p,this.L=u,this.M=o,this.N=v,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new F.$6d),this.onDidExpandElement=this.u.event,this.w=this.B(new F.$6d),this.onDidCollapseElement=this.w.event,this.y=this.B(new F.$6d),this.onDidChangeSelection=this.y.event,this.z=this.B(new F.$6d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new F.$6d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new F.$6d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new F.$6d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new g.$de,v.contributes&&v.contributes.views)for(const h in v.contributes.views)for(const y of v.contributes.views[h])y.id===d&&(this.P=y.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(h=>this.F.fire({message:!1,element:h})));let b,$;const I=F.Event.debounce(this.F.event,(h,y)=>(h||(h={message:!1,elements:[]}),y.element!==!1&&(b||(b=new Promise(w=>$=w),this.G=this.G.then(()=>b)),Array.isArray(y.element)?h.elements.push(...y.element):h.elements.push(y.element)),y.message&&(h.message=!0),h),200,!0);this.B(I(({message:h,elements:y})=>{y.length&&(this.H=this.H.then(()=>{const w=$;return b=null,this.$(y).then(()=>w())})),h&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(d){const t=d?this.getExtensionElement(d):void 0;if(d&&!t)return this.M.error(`No tree item with id '${d}' found.`),Promise.resolve([]);let p=this.X(d);return p||(p=await this.Y(t)),p?p.map(u=>u.item):void 0}getExtensionElement(d){return this.j.get(d)}reveal(d,t){t=t||{select:!0,focus:!1};const p=(0,N.$3f)(t.select)?!0:t.select,u=(0,N.$3f)(t.focus)?!1:t.focus,o=(0,N.$3f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):d?this.G.then(()=>this.S(d)).then(v=>this.W(d,v[v.length-1]).then(b=>this.J.$reveal(this.I,{item:b.item,parentChain:v.map($=>$.item)},{select:p,focus:u,expand:o})),v=>this.M.error(v)):this.J.$reveal(this.I,void 0,{select:p,focus:u,expand:o})}get message(){return this.O}set message(d){this.O=d,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(d){this.P=d,this.J.$setTitle(this.I,d,this.Q)}get description(){return this.Q}set description(d){this.Q=d,this.J.$setTitle(this.I,this.P,d)}get badge(){return this.R}set badge(d){this.R?.value===d?.value&&this.R?.tooltip===d?.tooltip||(this.R=l.ViewBadge.from(d),this.J.$setBadge(this.I,d))}setExpanded(d,t){const p=this.getExtensionElement(d);p&&(t?this.u.fire(Object.freeze({element:p})):this.w.fire(Object.freeze({element:p})))}setSelectionAndFocus(d,t){const p=!(0,D.$ub)(this.s,d);this.s=d;const u=this.t!==t;this.t=t,p&&this.y.fire(Object.freeze({selection:this.selectedElements})),u&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(d){d!==this.r&&(this.r=d,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(d){const t=(await Promise.all(d.map(async p=>{const u=this.getExtensionElement(p.treeItemHandle);return u?{extensionItem:u,treeItem:await this.f.getTreeItem(u),newState:p.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(p=>p!==void 0);t.forEach(p=>{p.treeItem.checkboxState=p.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(p=>[p.extensionItem,p.newState])})}async handleDrag(d,t,p){const u=[];for(const o of d){const v=this.getExtensionElement(o);v&&u.push(v)}if(!(!this.g?.handleDrag||u.length===0))return await this.g.handleDrag(u,t,p),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(d,t,p){const u=t?this.getExtensionElement(t):void 0;if(!(!u&&t||!this.g?.handleDrop))return(0,f.$$g)(()=>this.g?.handleDrop?this.g.handleDrop(u,d,p):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(d,t){if(!this.f.resolveTreeItem)return;const p=this.j.get(d);if(p){const u=this.m.get(p);if(u){const o=await this.f.resolveTreeItem(u.extensionItem,p,t)??u.extensionItem;return this.hb(o),u.item.tooltip=this.eb(o.tooltip),u.item.command=this.fb(u.disposableStore,o.command),u.item}}}S(d){return this.U(d).then(t=>t?this.S(t).then(p=>this.W(t,p[p.length-1]).then(u=>(p.push(u),p))):Promise.resolve([]))}U(d){const t=this.m.get(d);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,f.$$g)(()=>this.f.getParent(d))}W(d,t){const p=this.m.get(d);return p?Promise.resolve(p):(0,f.$$g)(()=>this.f.getTreeItem(d)).then(u=>this.kb(d,u,t,!0)).then(u=>this.getChildren(t?t.item.handle:void 0).then(()=>{const o=this.getExtensionElement(u);if(o){const v=this.m.get(o);if(v)return Promise.resolve(v)}throw new Error(`Cannot resolve tree item for element ${u} from extension ${this.N.identifier.value}`)}))}X(d){if(d){let t;if(typeof d=="string"){const p=this.getExtensionElement(d);t=p?this.m.get(p):void 0}else t=d;return t&&t.children||void 0}return this.h}async Y(d){this.rb(d);const t=new g.$de(this.Z.token);try{const p=d?this.m.get(d):void 0,u=await this.f.getChildren(d);if(t.token.isCancellationRequested)return;const o=(0,D.$Hb)(u||[]),v=await Promise.all((0,D.$Hb)(o).map($=>this.f.getTreeItem($)));if(t.token.isCancellationRequested)return;const b=v.map(($,I)=>$?this.db(o[I],$,p):null);return(0,D.$Hb)(b)}finally{t.dispose()}}$(d){if(d.some(p=>!p))return this.Z.dispose(!0),this.Z=new g.$de,this.tb(),this.J.$refresh(this.I);{const p=this.ab(d);if(p.length)return this.bb(p)}return Promise.resolve(void 0)}ab(d){const t=new Set,p=d.map(o=>this.m.get(o));for(const o of p)if(o&&!t.has(o.item.handle)){let v=o;for(;v&&v.parent&&p.findIndex(b=>v&&v.parent&&b&&b.item.handle===v.parent.item.handle)===-1;){const b=this.j.get(v.parent.item.handle);v=b?this.m.get(b):void 0}v&&!v.parent&&t.add(o.item.handle)}const u=[];return t.forEach(o=>{const v=this.j.get(o);if(v){const b=this.m.get(v);b&&(!b.parent||!t.has(b.parent.item.handle))&&u.push(o)}}),u}bb(d){const t={};return Promise.all(d.map(p=>this.cb(p).then(u=>{u&&(t[p]=u.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(d){const t=this.getExtensionElement(d);if(t){const p=this.m.get(t);if(p)return this.rb(t),(0,f.$$g)(()=>this.f.getTreeItem(t)).then(u=>{if(u){const o=this.ib(t,u,p.parent);return this.pb(t,o,p,p.parent),p.dispose(),o}return null})}return Promise.resolve(null)}db(d,t,p){const u=this.ib(d,t,p);if(t.id&&this.j.has(u.item.handle))throw new Error((0,S.localize)(0,null,t.id));return this.ob(d,u),this.qb(u,p),u}eb(d){return E.$AM.isMarkdownString(d)?l.MarkdownString.from(d):d}fb(d,t){return t?{...this.L.toInternal(t,d),originalId:t.command}:void 0}gb(d){if(d.checkboxState===void 0)return;let t,p,u;return typeof d.checkboxState=="number"?t=d.checkboxState:(t=d.checkboxState.state,p=d.checkboxState.tooltip,u=d.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:p,accessibilityInformation:u}}hb(d){if(!E.$YM.isTreeItem(d,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(d,t,p){this.hb(t);const u=this.B(new R.$Sc),o=this.kb(d,t,p),v=this.lb(t);return{item:{handle:o,parentHandle:p?p.item.handle:void 0,label:r(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(u,t.command),contextValue:t.contextValue,icon:v,iconDark:this.mb(t)||v,themeIcon:this.jb(t),collapsibleState:(0,N.$3f)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:p,children:void 0,disposableStore:u,dispose(){u.dispose()}}}jb(d){return d.iconPath instanceof E.$7M?d.iconPath:void 0}kb(d,{id:t,label:p,resourceUri:u},o,v){if(t)return`${n.b}/${t}`;const b=r(p,this.N),$=o?o.item.handle:n.a;let I=b?b.label:u?(0,M.$Qg)(u):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const h=this.m.has(d)?this.m.get(d).item.handle:void 0,y=this.X(o)||[];let w,A=0;do{if(w=`${$}/${A}:${I}`,v||!this.j.has(w)||h===w)break;A++}while(A<=y.length);return w}lb(d){if(d.iconPath&&!(d.iconPath instanceof E.$7M))return typeof d.iconPath=="string"||P.URI.isUri(d.iconPath)?this.nb(d.iconPath):this.nb(d.iconPath.light)}mb(d){if(d.iconPath&&!(d.iconPath instanceof E.$7M)&&d.iconPath.dark)return this.nb(d.iconPath.dark)}nb(d){return P.URI.isUri(d)?d:P.URI.file(d)}ob(d,t){this.j.set(t.item.handle,d),this.m.set(d,t)}pb(d,t,p,u){this.j.delete(t.item.handle),this.m.delete(d),t.item.handle!==p.item.handle&&this.j.delete(p.item.handle),this.ob(d,t);const o=this.X(u)||[],v=o.filter(b=>b.item.handle===p.item.handle)[0];v&&o.splice(o.indexOf(v),1,t)}qb(d,t){t?(t.children||(t.children=[]),t.children.push(d)):(this.h||(this.h=[]),this.h.push(d))}rb(d){if(d){const t=this.m.get(d);if(t){if(t.children)for(const p of t.children){const u=this.j.get(p.item.handle);u&&this.sb(u)}t.children=void 0}}else this.tb()}sb(d){const t=this.m.get(d);if(t){if(t.children)for(const p of t.children){const u=this.j.get(p.item.handle);u&&this.sb(u)}this.m.delete(d),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(d=>d.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[279],Re([1,0,5,6,2,33,8,62,4,7]),function(me,e,S,M,P,F,R,m,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oic=void 0;class N extends M.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(g,s,a,r){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new S.$6d),this.onDidDispose=this.#d.event,this.#h=this.B(new S.$6d),this.onDidChangeViewState=this.#h.event,this.#e=g,this.#t=s,this.#n=a,this.#i=r.viewType,this.#s=r.panelOptions,this.#o=r.viewColumn,this.#r=r.title,this.#u=r.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(g){this.c(),this.#r!==g&&(this.#r=g,this.#t.$setTitle(this.#e,g))}get iconPath(){return this.c(),this.#a}set iconPath(g){this.c(),this.#a!==g&&(this.#a=g,this.#t.$setIconPath(this.#e,P.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(g){this.#l||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(this.#u=g.active,this.#c=g.visible,this.#o=g.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(g,s){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof g>"u"?void 0:R.ViewColumn.from(g),preserveFocus:!!s})}c(){if(this.#l)throw new Error("Webview is disposed")}}class D extends M.$Tc{static c(){return(0,F.$Cg)()}constructor(g,s,a){super(),this.j=s,this.m=a,this.g=new Map,this.h=new Map,this.f=g.getProxy(f.$0L.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(g=>g.dispose()),this.g.clear()}createWebviewPanel(g,s,a,r,i={}){const n=typeof r=="object"?r.viewColumn:r,c={viewColumn:R.ViewColumn.from(n),preserveFocus:typeof r=="object"&&!!r.preserveFocus},d=(0,m.$Kic)(g),t=D.c();this.f.$createWebviewPanel((0,m.$Mic)(g),t,s,{title:a,panelOptions:l(i),webviewOptions:(0,m.$Nic)(g,this.m,i),serializeBuffersForPostMessage:d},c);const p=this.j.createNewWebview(t,i,g);return this.createNewWebviewPanel(t,s,a,n,i,p,!0)}$onDidChangeWebviewPanelViewStates(g){const s=Object.keys(g);s.sort((a,r)=>{const i=g[a],n=g[r];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const a of s){const r=this.getWebviewPanel(a);if(!r)continue;const i=g[a];r._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(g){this.getWebviewPanel(g)?.dispose(),this.g.delete(g),this.j.deleteWebview(g)}registerWebviewPanelSerializer(g,s,a){if(this.h.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.h.set(s,{serializer:a,extension:g}),this.f.$registerSerializer(s,{serializeBuffersForPostMessage:(0,m.$Kic)(g)}),new E.$_L(()=>{this.h.delete(s),this.f.$unregisterSerializer(s)})}async $deserializeWebviewPanel(g,s,a,r){const i=this.h.get(s);if(!i)throw new Error(`No serializer found for '${s}'`);const{serializer:n,extension:c}=i,d=this.j.createNewWebview(g,a.webviewOptions,c),t=this.createNewWebviewPanel(g,s,a.title,r,a.panelOptions,d,a.active);await n.deserializeWebviewPanel(t,a.state)}createNewWebviewPanel(g,s,a,r,i,n,c){const d=new N(g,this.f,n,{viewType:s,title:a,viewColumn:r,panelOptions:i,active:c});return this.g.set(g,d),d}getWebviewPanel(g){return this.g.get(g)}}e.$Oic=D;function l(k){return{enableFindWidget:k.enableFindWidget,retainContextWhenHidden:k.retainContextWhenHidden}}}),define(Pe[280],Re([1,0,5,6,62,8,4,7]),function(me,e,S,M,P,F,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gkc=void 0;class f extends M.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(D,l,k,g,s,a){super(),this.#s=!1,this.#u=this.B(new S.$6d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new S.$6d),this.onDidDispose=this.#l.event,this.#i=k,this.#a=g,this.#e=D,this.#t=l,this.#n=s,this.#r=a}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(D){this.a(),this.#a!==D&&(this.#a=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#o}set description(D){this.a(),this.#o!==D&&(this.#o=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(D){D===this.#r||this.#s||(this.#r=D,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(D){this.a(),!(D?.value===this.#c?.value&&D?.tooltip===this.#c?.tooltip)&&(this.#c=F.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(D,l){this.d=l,this.b=new Map,this.c=new Map,this.a=D.getProxy(R.$0L.MainThreadWebviewViews)}registerWebviewViewProvider(D,l,k,g){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:k,extension:D}),this.a.$registerWebviewViewProvider((0,P.$Mic)(D),l,{retainContextWhenHidden:g?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$Kic)(D)}),new m.$_L(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(D,l,k,g,s){const a=this.b.get(l);if(!a)throw new Error(`No view provider found for '${l}'`);const{provider:r,extension:i}=a,n=this.d.createNewWebview(D,{},i),c=new f(D,this.a,l,k,n,!0);this.c.set(D,c),await r.resolveWebviewView(c,{state:g},s)}async $onDidChangeWebviewViewVisibility(D,l){this.e(D)._setVisible(l)}async $disposeWebviewView(D){const l=this.e(D);this.c.delete(D),l.dispose(),this.d.deleteWebview(D)}e(D){const l=this.c.get(D);if(!l)throw new Error("No webview found");return l}}e.$gkc=E}),define(Pe[281],Re([1,0,5,30,35,3]),function(me,e,S,M,P,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tL=e.$sL=e.OutputChannelUpdateMode=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=void 0,e.$iL="text/x-code-output",e.$jL="output",e.$kL="Log",e.$lL="text/x-code-log-output",e.$mL="log",e.$nL="workbench.panel.output",e.$oL=new P.$xj("inOutput",!1),e.$pL=new P.$xj("activeLogOutput",!1),e.$qL=new P.$xj("outputView.scrollLock",!1),e.$rL=(0,F.$gi)("outputService");var R;(function(f){f[f.Append=1]="Append",f[f.Replace=2]="Replace",f[f.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$sL={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new S.$6d,this.onDidRegisterChannel=this.b.event,this.c=new S.$6d,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(N=>E.push(N)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}M.$Xn.add(e.$sL.OutputChannels,new m),e.$tL=new P.$xj("activeOutputChannel","")}),define(Pe[115],Re([1,0,4,3,17,20,13,281,63,27,43,139,23,16,42,5,6]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ujc=e.$Tjc=void 0;class r extends R.$Gj{get disposed(){return this.n}constructor(d,t,p,u,o){super(),this.id=d,this.name=t,this.r=p,this.s=u,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(p.getLevel()),this.B(p.onDidChangeLogLevel(v=>this.setLevel(v)))}get logLevel(){return this.getLevel()}appendLine(d){this.append(d+`
`)}append(d){this.info(d)}clear(){const d=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,d)}replace(d){const t=this.m;this.info(d),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(d,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof d=="boolean"?d:t))}hide(){this.s.$close(this.id)}g(d,t){this.m+=l.$te.fromString(t).byteLength,(0,R.log)(this.r,d,t),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends r{appendLine(d){this.append(d)}}let n=class{constructor(d,t,p,u,o,v){this.i=t,this.j=p,this.k=u,this.l=o,this.m=v,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=d.getProxy(S.$0L.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,D.$Mm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(d){this.h=d;for(const[t,p]of this.g)p.visible=t===this.h}createOutputChannel(d,t,p){if(d=d.trim(),!d)throw new Error("illegal argument `name`. must not be falsy");const u=typeof t=="object"&&t.log,o=(0,k.$Tf)(t)?t:void 0;if((0,k.$Tf)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let v;const b=this.i.environment.extensionLogLevel?.find(([I])=>F.$Am.equals(p.identifier,I))?.[1];b&&(v=(0,R.$Qj)(b));const $=u?this.o(d,v,p):this.n(d,o,p);return $.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),u?this.r(d,v??this.m.getLevel(),$):this.q(d,$)}async n(d,t,p){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const u=await this.c,o=this.k.extUri.joinPath(u,`${this.f++}-${d.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),v=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),b=await this.a.$register(d,o,t,p.identifier.value);return new r(b,d,v,this.a,p)}async o(d,t,p){const u=await this.p(p),o=d.replace(/[\\/:\*\?"<>\|]/g,""),v=this.k.extUri.joinPath(u,`${o}.log`),b=`${p.identifier.value}.${o}`,$=this.l.createLogger(v,{id:b,name:d,logLevel:t,extensionId:p.identifier.value});return new i(b,d,$,this.a,p)}p(d){let t=this.d.get(d.identifier.value);if(!t){const p=this.k.extUri.joinPath(this.i.logsLocation,d.identifier.value);this.d.set(d.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(p)}catch(u){if((0,g.$Wk)(u)!==g.FileSystemProviderErrorCode.FileExists)throw u}return p})())}return t}q(d,t){let p=!1;const u=()=>{if(p)throw new Error("Channel has been closed")};return{get name(){return d},append(o){u(),t.then(v=>v.append(o))},appendLine(o){u(),t.then(v=>v.appendLine(o))},clear(){u(),t.then(o=>o.clear())},replace(o){u(),t.then(v=>v.replace(o))},show(o,v){u(),t.then(b=>b.show(o,v))},hide(){u(),t.then(o=>o.hide())},dispose(){p=!0,t.then(o=>o.dispose())}}}r(d,t,p){const u=new a.$Sc,o=()=>{if(u.isDisposed)throw new Error("Channel has been closed")},v=u.add(new s.$6d);function b($){t=$,v.fire($)}return p.then($=>{u.add($),$.logLevel!==t&&b($.logLevel),u.add($.onDidChangeLogLevel(I=>b(I)))}),{...this.q(d,p),get logLevel(){return t},onDidChangeLogLevel:v.event,trace($,...I){o(),p.then(h=>h.trace($,...I))},debug($,...I){o(),p.then(h=>h.debug($,...I))},info($,...I){o(),p.then(h=>h.info($,...I))},warn($,...I){o(),p.then(h=>h.warn($,...I))},error($,...I){o(),p.then(h=>h.error($,...I))},dispose(){u.dispose()}}}};e.$Tjc=n,e.$Tjc=n=Qe([qe(0,P.$pO),qe(1,E.$FO),qe(2,f.$Gic),qe(3,N.$gic),qe(4,R.$Bj),qe(5,R.$Aj)],n),e.$Ujc=(0,M.$gi)("IExtHostOutputService")}),define(Pe[116],Re([1,0,3,11]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$2m=void 0,e.$2m=(0,S.$gi)("remoteAgentService"),e.$3m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let F=1/0;for(let m=0;m<this.maxSampleCount;m++){const f=await P.getRoundTripTime();if(f===void 0)return;F=Math.min(F,f/2),await(0,M.$hh)(this.sampleDelay)}this.average.push(F),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(F):R=this.initial.reduce((m,f)=>m+f,0)/this.initial.length,this.lastMeasurement={initial:R,current:F,average:this.average.reduce((m,f)=>m+f,0)/this.average.length,high:typeof R>"u"?!1:F>this.highLatencyMaxThreshold||F>this.highLatencyMinThreshold&&F>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Pe[282],Re([1,0,173,56,30,47,46,6,5,116,21,26,11]),function(me,e,S,M,P,F,R,m,f,E,N,D,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=void 0,e.$OI=Object.freeze({id:"application",order:100,title:(0,S.localize)(0,null),type:"object"}),e.$PI=Object.freeze({id:"workbench",order:7,title:(0,S.localize)(1,null),type:"object"}),e.$QI=Object.freeze({id:"security",scope:1,title:(0,S.localize)(2,null),type:"object",order:7}),e.$RI=Object.freeze({id:"problems",title:(0,S.localize)(3,null),type:"object",order:101}),e.$SI={ConfigurationMigration:"base.contributions.configuration.migration"};class k{constructor(){this.migrations=[],this.a=new f.$6d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const g=new k;P.$Xn.add(e.$SI.ConfigurationMigration,g);let s=class extends m.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,n){super(),this.a=i,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const d of c.added)await this.f(d,g.migrations)})),this.c(g.migrations),this.B(g.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(i){await this.f(void 0,i);for(const n of this.b.getWorkspace().folders)await this.f(n,i)}async f(i,n){await Promise.all([n.map(c=>this.g(c,i?.uri))])}async g(i,n){const c=this.a.inspect(i.key,{resource:n}),d=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,p]of d){const u=c[t];if(!u)continue;const o=[];if(u.value!==void 0){const v=await this.h(i,t,u.value,n,void 0);for(const b of v??[])o.push([b,[]])}for(const{identifiers:v,value:b}of u.overrides??[])if(b!==void 0){const $=await this.h(i,t,b,n,v);for(const I of $??[])o.push([I,v])}o.length&&await Promise.allSettled(o.map(async([[v,b],$])=>this.a.updateValue(v,b.value,{resource:n,overrideIdentifiers:$},p)))}}async h(i,n,c,d,t){const p=o=>{const b=this.a.inspect(o,{resource:d})[n];if(b)return t?b.overrides?.find(({identifiers:$})=>(0,D.$Pn)($,t))?.value:b.value},u=await i.migrateFn(c,p);return Array.isArray(u)?u:[[i.key,u]]}};e.$TI=s,e.$TI=s=Qe([qe(0,R.$Mi),qe(1,F.$pi)],s);let a=class extends m.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.b=i,this.a=new l.$Dh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!N.$i&&(await this.b.getEnvironment())?.os!==1)return;P.$Xn.as(M.$3n.Configuration).registerConfiguration({...e.$QI,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,S.localize)(4,null)},default:[],markdownDescription:(0,S.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,S.localize)(6,null),scope:2}}})}};e.$UI=a,e.$UI=a=Qe([qe(0,E.$2m)],a)}),define(Pe[283],Re([1,0,34,12,19,24,181,282,56,3,30]),function(me,e,S,M,P,F,R,m,f,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0eb=e.$9eb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$8eb=e.$7eb=void 0,e.$7eb=(0,E.$gi)("editorResolverService"),e.$8eb="workbench.editorAssociations";const D=N.$Xn.as(f.$3n.Configuration),l={...m.$PI,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};D.registerConfiguration(l);var k;(function(r){r.builtin="builtin",r.option="option",r.exclusive="exclusive",r.default="default"})(k||(e.RegisteredEditorPriority=k={}));var g;(function(r){r[r.ABORT=1]="ABORT",r[r.NONE=2]="NONE"})(g||(e.ResolvedStatus=g={}));function s(r){switch(r){case k.exclusive:return 5;case k.default:return 4;case k.builtin:return 3;case k.option:default:return 1}}e.$9eb=s;function a(r,i){if(new Set([M.Schemas.extension,M.Schemas.webviewPanel,M.Schemas.vscodeWorkspaceTrust,M.Schemas.vscodeSettings]).has(i.scheme))return!1;const d=typeof r=="string"&&r.indexOf(P.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,F.$Qg)(i);return S.$Yj(typeof r=="string"?r.toLowerCase():r,d.toLowerCase())}e.$0eb=a}),define(Pe[284],Re([1,0,45,12,19,21,24,2,3,202,47,220,116]),function(me,e,S,M,P,F,R,m,f,E,N,D,l){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$ML=e.$LL=void 0,e.$LL=(0,f.$gi)("pathService");let g=k=class{constructor(a,r,i,n){this.d=a,this.e=r,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||F.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??a})()}hasValidBasename(a,r,i){return typeof r=="string"||typeof r>"u"?this.a.then(n=>this.h(a,n,r)):this.h(a,r,i)}h(a,r,i){return a.scheme===M.Schemas.file||a.scheme===M.Schemas.vscodeRemote?(0,S.$eg)(i??(0,R.$Qg)(a),r===1):!0}get defaultUriScheme(){return k.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(a,r){if(a.remoteAuthority)return M.Schemas.vscodeRemote;const i=(0,E.$IL)(r.getWorkspace());if(i)return i;const n=r.getWorkspace().folders[0];if(n)return n.uri.scheme;const c=r.getWorkspace().configuration;return c?c.scheme:M.Schemas.file}userHome(a){return a?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(a=>a===1?P.$fc:P.$gc)}async fileURI(a){let r="";if(await this.a===1&&(a=a.replace(/\\/g,"/")),a[0]==="/"&&a[1]==="/"){const n=a.indexOf("/",2);n===-1?(r=a.substring(2),a="/"):(r=a.substring(2,n),a=a.substring(n)||"/")}return m.URI.from({scheme:M.Schemas.file,authority:r,path:a,query:"",fragment:""})}};e.$ML=g,e.$ML=g=k=Qe([qe(1,l.$2m),qe(2,D.$uL),qe(3,N.$pi)],g)}),define(Pe[117],Re([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$jK=e.$iK=void 0;class S{constructor(R,m){this.line=R,this.character=m}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,m){return new S(0,0)}with(R){return new S(0,0)}}e.$iK=S;class M{constructor(R,m,f,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new S(R,m),this.end=new S(f,E)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new M(0,0,0,0)}with(R){return new M(0,0,0,0)}}e.$jK=M;var P;(function(F){F[F.Information=1]="Information",F[F.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Pe[44],Re([1,0,18,34,26,45,15,3,19,14,117,11]),function(me,e,S,M,P,F,R,m,f,E,N,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.SearchErrorCode=e.$yK=e.$xK=e.SearchSortOrder=e.ViewMode=e.$wK=e.$vK=e.$uK=e.$tK=e.SearchCompletionExitCode=e.$sK=e.$rK=e.$qK=e.QueryType=e.SearchProviderType=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.$kK="workbench.view.search",e.$lK="workbench.panel.search",e.$mK="workbench.view.search",e.$nK="search-result",e.$oK="search.exclude";const l="\u27EA ",k=" characters skipped \u27EB",g=(l.length+k.length+5)*2;e.$pK=(0,m.$gi)("searchService");var s;(function(ue){ue[ue.file=0]="file",ue[ue.text=1]="text",ue[ue.aiText=2]="aiText"})(s||(e.SearchProviderType=s={}));var a;(function(ue){ue[ue.File=1]="File",ue[ue.Text=2]="Text",ue[ue.aiText=3]="aiText"})(a||(e.QueryType=a={}));function r(ue){return!!ue.preview}e.$qK=r;function i(ue){return!!ue.resource}e.$rK=i;function n(ue){return!!ue.message}e.$sK=n;var c;(function(ue){ue[ue.Normal=0]="Normal",ue[ue.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class d{constructor(ve){this.resource=ve,this.results=[]}}e.$tK=d;class t{constructor(ve,re,$e,ie){this.ranges=re,this.webviewIndex=ie;const le=Array.isArray(re)?re:[re];if($e&&$e.matchLines===1&&p(le)){ve=(0,R.$Mf)(ve,$e.matchLines);let V="",_=0,ke=0;const Le=Math.floor($e.charsPerLine/5),Ee=[];for(const be of le){const ge=Math.max(be.startColumn-Le,0),G=be.startColumn+$e.charsPerLine;if(ge>ke+Le+g){const Y=l+(ge-ke)+k;V+=Y+ve.slice(ge,G),_+=ge-(ke+Y.length)}else V+=ve.slice(ke,G);Ee.push(new o(0,be.startColumn-_,be.endColumn-_)),ke=G}this.preview={text:V,matches:Array.isArray(this.ranges)?Ee:Ee[0]}}else{const V=Array.isArray(re)?re[0].startLineNumber:re.startLineNumber;this.preview={text:ve,matches:(0,S.$2b)(re,_=>new u(_.startLineNumber-V,_.startColumn,_.endLineNumber-V,_.endColumn))}}}}e.$uK=t;function p(ue){const ve=ue[0].startLineNumber;for(const re of ue)if(re.startLineNumber!==ve||re.endLineNumber!==ve)return!1;return!0}class u{constructor(ve,re,$e,ie){this.startLineNumber=ve,this.startColumn=re,this.endLineNumber=$e,this.endColumn=ie}}e.$vK=u;class o extends u{constructor(ve,re,$e){super(ve,re,ve,$e)}}e.$wK=o;var v;(function(ue){ue.List="list",ue.Tree="tree"})(v||(e.ViewMode=v={}));var b;(function(ue){ue.Default="default",ue.FileNames="fileNames",ue.Type="type",ue.Modified="modified",ue.CountDescending="countDescending",ue.CountAscending="countAscending"})(b||(e.SearchSortOrder=b={}));function $(ue,ve=!0){const re=ue&&ue.files&&ue.files.exclude,$e=ve&&ue&&ue.search&&ue.search.exclude;if(!re&&!$e)return;if(!re||!$e)return re||$e;let ie=Object.create(null);return ie=P.$On(ie,P.$Ln(re)),ie=P.$On(ie,P.$Ln($e),!0),ie}e.$xK=$;function I(ue,ve){return ue.excludePattern&&M.$Yj(ue.excludePattern,ve)?!1:ue.includePattern||ue.usingSearchPaths?ue.includePattern&&M.$Yj(ue.includePattern,ve)?!0:ue.usingSearchPaths?!!ue.folderQueries&&ue.folderQueries.some(re=>{const $e=re.folder.fsPath;if(F.$gg(ve,$e)){const ie=f.$lc($e,ve);return!re.includePattern||!!M.$Yj(re.includePattern,ie)}else return!1}):!1:!0}e.$yK=I;var h;(function(ue){ue[ue.unknownEncoding=1]="unknownEncoding",ue[ue.regexParseError=2]="regexParseError",ue[ue.globParseError=3]="globParseError",ue[ue.invalidLiteral=4]="invalidLiteral",ue[ue.rgProcessError=5]="rgProcessError",ue[ue.other=6]="other",ue[ue.canceled=7]="canceled"})(h||(e.SearchErrorCode=h={}));class y extends Error{constructor(ve,re){super(ve),this.code=re}}e.$zK=y;function w(ue){const ve=ue.message;if((0,E.$4)(ue))return new y(ve,h.canceled);try{const re=JSON.parse(ve);return new y(re.message,re.code)}catch{return new y(ve,h.other)}}e.$AK=w;function A(ue){const ve={message:ue.message,code:ue.code};return new Error(JSON.stringify(ve))}e.$BK=A;function L(ue){return ue.type==="error"?!0:ue.type==="success"}e.$CK=L;function J(ue){return ue.type==="success"}e.$DK=J;function W(ue){return!!ue.path}e.$EK=W;function U(ue,ve,re=!0){const $e=ue.searchPath?ue.searchPath:ue.relativePath;return re?(0,R.$Jf)($e,ve):M.$Yj(ve,$e)}e.$FK=U;class C{constructor(ve){this.path=ve,this.results=[]}addMatch(ve){this.results.push(ve)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$GK=C;function O(ue,ve){const re={...ue||{},...ve||{}};return Object.keys(re).filter($e=>{const ie=re[$e];return typeof ie=="boolean"&&ie})}e.$HK=O;class q{constructor(ve,re){this.c=null,this.a={...ve.excludePattern||{},...re.excludePattern||{}},this.b=M.$Zj(this.a);let $e=ve.includePattern;re.includePattern&&($e?$e={...$e,...re.includePattern}:$e=re.includePattern),$e&&(this.c=M.$Zj($e))}matchesExcludesSync(ve,re,$e){return!!(this.b&&this.b(ve,re,$e))}includedInQuerySync(ve,re,$e){return!(this.b&&this.b(ve,re,$e)||this.c&&!this.c(ve,re,$e))}includedInQuery(ve,re,$e){const ie=this.b(ve,re,$e),le=()=>this.c?!!this.c(ve,re,$e):!0;return(0,D.$5g)(ie)?ie.then(V=>V?!1:le()):le()}hasSiblingExcludeClauses(){return ne(this.a)}}e.$IK=q;function ne(ue){for(const ve in ue)if(typeof ue[ve]!="boolean")return!0;return!1}function ce(ue){if(!ue)return;let ve;return re=>(ve||(ve=(ue()||Promise.resolve([])).then($e=>$e?Ie($e):{})),ve.then($e=>!!$e[re]))}e.$JK=ce;function ye(ue){if(!ue)return;let ve;return re=>{if(!ve){const $e=ue();ve=$e?Ie($e):{}}return!!ve[re]}}e.$KK=ye;function Ie(ue){const ve={};for(const re of ue)ve[re]=!0;return ve}}),define(Pe[36],Re([1,0,18,11,25,5,6,50,12,125,24,15,2,172,3,13,191,47,43,27,17,8,7,59,44,4,52]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g,s,a,r,i,n,c,d,t,p,u,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=e.$Aic=void 0;function b(J,W,U){return new N.$Ig(C=>y(C,U)).isEqual(J,W)}function $(J,W,U){return b(J.uri,W.uri,U)?0:(0,D.$df)(J.uri.toString(),W.uri.toString())}function I(J,W,U){return J.index!==W.index?J.index<W.index?-1:1:b(J.uri,W.uri,U)?(0,D.$df)(J.name,W.name):(0,D.$df)(J.uri.toString(),W.uri.toString())}function h(J,W,U,C){const O=J.slice(0).sort((ne,ce)=>U(ne,ce,C)),q=W.slice(0).sort((ne,ce)=>U(ne,ce,C));return(0,S.$Eb)(O,q,(ne,ce)=>U(ne,ce,C))}function y(J,W){const U=W.getCapabilities(J.scheme);return!(U&&U&1024)}class w extends r.$zi{static toExtHostWorkspace(W,U,C,O){if(!W)return{workspace:null,added:[],removed:[]};const{id:q,name:ne,folders:ce,configuration:ye,transient:Ie,isUntitled:ue}=W,ve=[],re=U;U?ce.forEach((V,_)=>{const ke=l.URI.revive(V.uri),Le=w.o(C||U,ke,O);Le?(Le.name=V.name,Le.index=V.index,ve.push(Le)):ve.push({uri:ke,name:V.name,index:_})}):ve.push(...ce.map(({uri:V,name:_,index:ke})=>({uri:l.URI.revive(V),name:_,index:ke}))),ve.sort((V,_)=>V.index<_.index?-1:1);const $e=new w(q,ne,ve,!!Ie,ye?l.URI.revive(ye):null,!!ue,V=>y(V,O)),{added:ie,removed:le}=h(re?re.workspaceFolders:[],$e.workspaceFolders,$,O);return{workspace:$e,added:ie,removed:le}}static o(W,U,C){for(let O=0;O<W.folders.length;O++){const q=W.workspaceFolders[O];if(b(q.uri,U,C))return q}}constructor(W,U,C,O,q,ne,ce){super(W,C.map(ye=>new r.$Ai(ye)),O,q,ce),this.t=U,this.u=ne,this.q=[],this.s=m.$mi.forUris(ce),C.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,U){return U&&this.s.get(W)&&(W=(0,N.$Sg)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let A=class{constructor(W,U,C,O,q){this.c=new F.$6d,this.onDidChangeWorkspace=this.c.event,this.g=new F.$6d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new F.$8d,this.C=new Map,this.h=O,this.s=C,this.t=q,this.j=new E.$hm,this.k=new M.$fh,this.o=W.getProxy(o.$0L.MainThreadWorkspace),this.q=W.getProxy(o.$0L.MainThreadMessageService);const ne=U.workspace;this.l=ne?new w(ne.id,ne.name,[],!!ne.transient,ne.configuration?l.URI.revive(ne.configuration):null,!!ne.isUntitled,ce=>y(ce,C)):void 0}$initializeWorkspace(W,U){this.v=U,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:f.Schemas.untitled,path:(0,N.$Qg)((0,N.$Sg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,U,C,...O){const q=[];if(Array.isArray(O)&&O.forEach(ue=>{l.URI.isUri(ue.uri)&&!q.some(ve=>b(ve.uri,ue.uri,this.s))&&q.push({uri:ue.uri,name:ue.name||(0,N.$Pg)(ue.uri)})}),this.n||[U,C].some(ue=>typeof ue!="number"||ue<0)||C===0&&q.length===0)return!1;const ne=this.x?this.x.workspaceFolders:[];if(U+C>ne.length)return!1;const ce=ne.slice(0);ce.splice(U,C,...q.map(ue=>({uri:ue.uri,name:ue.name||(0,N.$Pg)(ue.uri),index:void 0})));for(let ue=0;ue<ce.length;ue++){const ve=ce[ue];if(ce.some((re,$e)=>$e!==ue&&b(ve.uri,re.uri,this.s)))return!1}ce.forEach((ue,ve)=>ue.index=ve);const{added:ye,removed:Ie}=h(ne,ce,I,this.s);if(ye.length===0&&Ie.length===0)return!1;if(this.o){const ue=W.displayName||W.name;this.o.$updateWorkspaceFolders(ue,U,C,q).then(void 0,ve=>{this.n=void 0;const re={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(a.Severity.Error,(0,k.localize)(0,null,ue,ve.toString()),re,[])})}return this.y(ce),!0}getWorkspaceFolder(W,U){if(this.x)return this.x.getWorkspaceFolder(W,U)}async getWorkspaceFolder2(W,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,U)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,U){let C,O="";if(typeof W=="string"?(C=l.URI.file(W),O=W):typeof W<"u"&&(C=W,O=W.fsPath),!C)return O;const q=this.getWorkspaceFolder(C,!0);if(!q)return O;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let ne=(0,N.$Vg)(q.uri,C);return U&&q.name&&(ne=`${q.name}/${ne}`),ne}y(W){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:U,added:C,removed:O}=w.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:C,removed:O}))}findFiles(W,U,C,O,q=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let ne="",ce=!0;return U===null?ce=!1:U!==void 0&&(typeof U=="string"?ne=U:ne=U.pattern),this.z(W,void 0,{exclude:ne,maxResults:C,useDefaultExcludes:ce,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},q)}findFiles2(W,U={},C,O=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${C.value}, entryPoint: findFiles2`),this.z(void 0,W,U,O)}async z(W,U,C,O=P.CancellationToken.None){if(O&&O.isCancellationRequested)return Promise.resolve([]);const q=typeof C.exclude=="string"?C.exclude:C.exclude?C.exclude.pattern:void 0,ne={ignoreSymlinks:typeof C.followSymlinks=="boolean"?!C.followSymlinks:void 0,disregardIgnoreFiles:typeof C.useIgnoreFiles=="boolean"?!C.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof C.useGlobalIgnoreFiles=="boolean"?!C.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof C.useParentIgnoreFiles=="boolean"?!C.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof C.useDefaultExcludes=="boolean"?!C.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof C.useDefaultSearchExcludes=="boolean"?!C.useDefaultSearchExcludes:!1,maxResults:C.maxResults,excludePattern:q,shouldGlobSearch:typeof C.fuzzy=="boolean"?!C.fuzzy:!0,_reason:"startFileSearch"};let ce;if(W){const{includePattern:ye,folder:Ie}=L(d.GlobPattern.from(W));ce=Ie,ne.includePattern=ye}else{const{includePattern:ye,folder:Ie}=L(d.GlobPattern.from(U));ce=Ie,ne.filePattern=ye}return this.o.$startFileSearch(ce??null,ne,O).then(ye=>Array.isArray(ye)?ye.map(Ie=>l.URI.revive(Ie)):[])}async findTextInFiles(W,U,C,O,q=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const ne=this.j.getNext(),ce=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:ye,folder:Ie}=L(d.GlobPattern.from(U.include)),ue=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ve={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:ce,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:ye,excludePattern:ue},re=!1;if(this.u[ne]=$e=>{if(re)return;const ie=l.URI.revive($e.resource);$e.results.forEach(le=>{const V=(0,v.$Ph)(le);(0,u.$qK)(V)?C({uri:ie,preview:{text:V.preview.text,matches:(0,S.$2b)(V.preview.matches,_=>new t.$bM(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))},ranges:(0,S.$2b)(V.ranges,_=>new t.$bM(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))}):C({uri:ie,text:V.text,lineNumber:V.lineNumber})})},q.isCancellationRequested)return{};try{const $e=await this.o.$startTextSearch(W,Ie??null,ve,ne,q);return delete this.u[ne],$e||{}}catch($e){throw delete this.u[ne],$e}}$handleTextSearchResult(W,U){this.u[U]?.(W)}async save(W){const U=await this.o.$save(W,{saveAs:!1});return l.URI.revive(U)}async saveAs(W){const U=await this.o.$save(W,{saveAs:!0});return l.URI.revive(U)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,U){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,U);const C=this.t.transformOutgoingScheme(W),O=this.A++;return this.o.$registerEditSessionIdentityProvider(O,C),(0,R.$Rc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(W,U){this.h.info("Getting edit session identifier for workspaceFolder",W);const C=await this.resolveWorkspaceFolder(l.URI.revive(W));if(!C){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",C);const O=this.w.get(C.uri.scheme);if(this.h.info(`Provider for scheme ${C.uri.scheme} is defined: `,!!O),!O)return;const q=await O.provideEditSessionIdentity(C,U);if(this.h.info("Provider returned edit session identifier: ",q),!!q)return q}async $provideEditSessionIdentityMatch(W,U,C,O){this.h.info("Getting edit session identifier for workspaceFolder",W);const q=await this.resolveWorkspaceFolder(l.URI.revive(W));if(!q){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",q);const ne=this.w.get(q.uri.scheme);if(this.h.info(`Provider for scheme ${q.uri.scheme} is defined: `,!!ne),!ne)return;const ce=await ne.provideEditSessionIdentityMatch?.(U,C,O);if(this.h.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(W){return(U,C,O)=>{const q=function(ce){U.call(C,ce)};return q.extension=W,this.B.event(q,void 0,O)}}async $onWillCreateEditSessionIdentity(W,U,C){const O=await this.resolveWorkspaceFolder(l.URI.revive(W));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:O},U,async(q,ne)=>{const ce=Date.now();await Promise.resolve(q),Date.now()-ce>C&&this.h.warn("SLOW edit session create-participant",ne.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(W,U){if(this.C.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.C.set(W,U);const C=this.t.transformOutgoingScheme(W),O=this.A++;return this.o.$registerCanonicalUriProvider(O,C),(0,R.$Rc)(()=>{this.C.delete(W),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(W,U,C){const O=this.C.get(W.scheme);if(!O)return;const q=await O.provideCanonicalUri?.(l.URI.revive(W),U,C);if(q)return q}async $provideCanonicalUri(W,U,C){return this.provideCanonicalUri(l.URI.revive(W),{targetScheme:U},C)}};e.$Aic=A,e.$Aic=A=Qe([qe(0,c.$pO),qe(1,n.$FO),qe(2,i.$gic),qe(3,s.$Aj),qe(4,p.$yic)],A),e.$Bic=(0,g.$gi)("IExtHostWorkspace");function L(J){let W,U;return J&&(typeof J=="string"?W=J:(W=J.pattern,U=l.URI.revive(J.baseUri))),{includePattern:W,folder:U}}}),define(Pe[37],Re([1,0,26,5,36,4,7,193,56,16,11,3,17,13,2]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=e.$Dic=e.$Cic=void 0;function s(p,u){if(u){const o=u.split(".");let v=p;for(let b=0;v&&b<o.length;b++)v=v[o[b]];return v}}function a(p){return p instanceof g.URI}function r(p){return p&&p.uri instanceof g.URI&&p.languageId&&typeof p.languageId=="string"}function i(p){return p&&!p.uri&&p.languageId&&typeof p.languageId=="string"}function n(p){return p&&p.uri instanceof g.URI&&(!p.name||typeof p.name=="string")&&(!p.index||typeof p.index=="number")}function c(p){if(a(p))return{resource:p};if(r(p))return{resource:p.uri,overrideIdentifier:p.languageId};if(i(p))return{overrideIdentifier:p.languageId};if(n(p))return{resource:p.uri};if(p===null)return{resource:null}}let d=class{constructor(u,o,v){this.a=u.getProxy(F.$0L.MainThreadConfiguration),this.c=o,this.b=v,this.d=new N.$fh,this.e=null}getConfigProvider(){return this.d.wait().then(u=>this.e)}$initializeConfiguration(u){this.e=new t(this.a,this.c,u,this.b),this.d.open()}$acceptConfigurationChanged(u,o){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(u,o))}};e.$Cic=d,e.$Cic=d=Qe([qe(0,l.$pO),qe(1,P.$Bic),qe(2,k.$Aj)],d);class t{constructor(u,o,v,b){this.a=new M.$6d,this.b=u,this.f=b,this.c=o,this.e=m.$jo.parse(v),this.d=this.k(v.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(u,o){const v={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$jo.parse(u),this.d=this.k(u.configurationScopes),this.a.fire(this.j(o,v))}getConfiguration(u,o,v){const b=c(o)||{},$=this.g(u?s(this.e.getValue(void 0,b,this.c.workspace),u):this.e.getValue(void 0,b,this.c.workspace));u&&this.h(u,b,v?.identifier);function I(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(y){return typeof s($,y)<"u"},get:(y,w)=>{this.h(u?`${u}.${y}`:y,b,v?.identifier);let A=s($,y);if(typeof A>"u")A=w;else{let L;const J=(W,U)=>{if((0,E.$Vf)(W)){let C;const O=()=>{L=L||(0,S.$Ln)($),C=C||s(L,U)};return new Proxy(W,{get:(q,ne)=>{if(typeof ne=="string"&&ne.toLowerCase()==="tojson")return O(),()=>C;if(L)return C=C||s(L,U),C[ne];const ce=q[ne];return typeof ne=="string"?J(ce,`${U}.${ne}`):ce},set:(q,ne,ce)=>(O(),C&&(C[ne]=ce),!0),deleteProperty:(q,ne)=>(O(),C&&delete C[ne],!0),defineProperty:(q,ne,ce)=>(O(),C&&Object.defineProperty(C,ne,ce),!0)})}return Array.isArray(W)?(0,S.$Ln)(W):W};A=J(A,y)}return A},update:(y,w,A,L)=>{y=u?`${u}.${y}`:y;const J=I(A);return w!==void 0?this.b.$updateConfigurationOption(J,y,w,b,L):this.b.$removeConfigurationOption(J,y,b,L)},inspect:y=>{y=u?`${u}.${y}`:y;const w=this.e.inspect(y,b,this.c.workspace);if(w)return{key:y,defaultValue:(0,S.$Ln)(w.policy?.value??w.default?.value),globalValue:(0,S.$Ln)(w.user?.value??w.application?.value),workspaceValue:(0,S.$Ln)(w.workspace?.value),workspaceFolderValue:(0,S.$Ln)(w.workspaceFolder?.value),defaultLanguageValue:(0,S.$Ln)(w.default?.override),globalLanguageValue:(0,S.$Ln)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,S.$Ln)(w.workspace?.override),workspaceFolderLanguageValue:(0,S.$Ln)(w.workspaceFolder?.override),languageIds:(0,S.$Ln)(w.overrideIdentifiers)}}};return typeof $=="object"&&(0,S.$On)(h,$,!1),Object.freeze(h)}g(u){const o=v=>(0,E.$Vf)(v)?new Proxy(v,{get:(b,$)=>o(b[$]),set:(b,$,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String($)}' of object`)},deleteProperty:(b,$)=>{throw new Error(`TypeError: Cannot delete read only property '${String($)}' of object`)},defineProperty:(b,$)=>{throw new Error(`TypeError: Cannot define property '${String($)}' for a readonly object`)},setPrototypeOf:b=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return o(u)}h(u,o,v){const b=f.$ao.test(u)?4:this.d.get(u),$=v?`[${v.value}] `:"";if(b===4){typeof o?.resource>"u"&&this.f.warn(`${$}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(b===3){o?.resource&&this.f.warn(`${$}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(u,o){const v=new m.$lo(u,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(b,$)=>v.affectsConfiguration(b,c($))})}k(u){return u.reduce((o,v)=>(o.set(v[0],v[1]),o),new Map)}}e.$Dic=t,e.$Eic=(0,D.$gi)("IExtHostConfiguration")}),define(Pe[118],Re([1,0,2,11,5,4,7,36,67,37,25,66,17,27,3,12,21,13,78,225,14]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g,s,a,r,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8jc=e.$7jc=e.$6jc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var d;(function(J){function W(C){if(C!=null)return C}J.from=W;function U(C){if(C!=null)return C}J.to=U})(d||(d={}));var t;(function(J){function W(C){if(C!=null)return C}J.from=W;function U(C){if(C!=null)return C}J.to=U})(t||(t={}));var p;(function(J){function W(C){if(C!=null)return C}J.from=W;function U(C){if(C!=null)return C}J.to=U})(p||(p={}));var u;(function(J){function W(O){if(O){const q=O;return q&&!!q.process}else return!1}J.is=W;function U(O){if(O==null)return;const q={process:O.process,args:O.args};return O.options&&(q.options=p.from(O.options)),q}J.from=U;function C(O){if(O!=null)return new R.$UM(O.process,O.args,O.options)}J.to=C})(u||(u={}));var o;(function(J){function W(C){if(C!=null)return C}J.from=W;function U(C){if(C!=null)return C}J.to=U})(o||(o={}));var v;(function(J){function W(O){if(O){const q=O;return q&&(!!q.commandLine||!!q.command)}else return!1}J.is=W;function U(O){if(O==null)return;const q={};return O.commandLine!==void 0?q.commandLine=O.commandLine:(q.command=O.command,q.args=O.args),O.options&&(q.options=o.from(O.options)),q}J.from=U;function C(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new R.$VM(O.commandLine,O.options):new R.$VM(O.command,O.args?O.args:[],O.options)}J.to=C})(v||(v={}));var b;(function(J){function W(O){if(O){const q=O;return q&&q.customExecution==="customExecution"}else return!1}J.is=W;function U(O){return{customExecution:"customExecution"}}J.from=U;function C(O,q){return q.get(O)}J.to=C})(b||(e.CustomExecutionDTO=b={}));var $;(function(J){function W(U,C){let O;return U.scope!==void 0&&typeof U.scope!="number"?O=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===R.TaskScope.Workspace&&C&&C.workspaceFile?O=C.workspaceFile:O=n.$jH),{id:U._id,workspaceFolder:O}}J.from=W})($||(e.TaskHandleDTO=$={}));var I;(function(J){function W(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}J.from=W})(I||(I={}));var h;(function(J){function W(O,q){if(O==null)return[];const ne=[];for(const ce of O){const ye=U(ce,q);ye&&ne.push(ye)}return ne}J.fromMany=W;function U(O,q){if(O==null)return;let ne;O.execution instanceof R.$UM?ne=u.from(O.execution):O.execution instanceof R.$VM?ne=v.from(O.execution):O.execution&&O.execution instanceof R.$WM&&(ne=b.from(O.execution));const ce=d.from(O.definition);let ye;return O.scope?typeof O.scope=="number"?ye=O.scope:ye=O.scope.uri:ye=R.TaskScope.Workspace,!ce||!ye?void 0:{_id:O._id,definition:ce,name:O.name,source:{extensionId:q.identifier.value,label:O.source,scope:ye},execution:ne,isBackground:O.isBackground,group:I.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}J.from=U;async function C(O,q,ne){if(O==null)return;let ce;u.is(O.execution)?ce=u.to(O.execution):v.is(O.execution)?ce=v.to(O.execution):b.is(O.execution)&&(ce=b.to(O._id,ne));const ye=d.to(O.definition);let Ie;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?Ie=O.source.scope:Ie=await q.resolveWorkspaceFolder(S.URI.revive(O.source.scope)):Ie=R.TaskScope.Workspace),!ye||!Ie)return;const ue=new R.$XM(ye,Ie,O.name,O.source.label,ce,O.problemMatchers);return O.isBackground!==void 0&&(ue.isBackground=O.isBackground),O.group!==void 0&&(ue.group=R.$TM.from(O.group._id),ue.group&&O.group.isDefault&&(ue.group=new R.$TM(ue.group.id,ue.group.label),O.group.isDefault===!0&&(ue.group.isDefault=O.group.isDefault))),O.presentationOptions&&(ue.presentationOptions=t.to(O.presentationOptions)),O._id&&(ue._id=O._id),O.detail&&(ue.detail=O.detail),ue}J.to=C})(h||(e.TaskDTO=h={}));var y;(function(J){function W(C){return C}J.from=W;function U(C){if(C)return Object.assign(Object.create(null),C)}J.to=U})(y||(y={}));class w{#e;constructor(W,U,C){this._id=U,this.a=C,this.#e=W}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}let A=class{constructor(W,U,C,O,q,ne,ce,ye){this.q=new P.$6d,this.r=new P.$6d,this.s=new P.$6d,this.u=new P.$6d,this.a=W.getProxy(F.$0L.MainThreadTask),this.b=C,this.c=O,this.d=q,this.e=ne,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=ye,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,U,C){if(!C)return new R.$_L(()=>{});const O=this.x();return this.j.set(O,{type:U,provider:C,extension:W}),this.a.$registerTaskProvider(O,U),new R.$_L(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(W,U){this.a.$registerTaskSystem(W,U)}fetchTasks(W){return this.a.$fetchTasks(y.from(W)).then(async U=>{const C=[];for(const O of U){const q=await h.to(O,this.b,this.m);q&&C.push(q)}return C})}get taskExecutions(){const W=[];return this.k.forEach(U=>W.push(U)),W}terminateTask(W){if(!(W instanceof w))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,U,C){const O=this.m.get(W.id);O&&(this.o.set(W.id,O),this.e.attachPtyToTerminal(U,await O.callback(C))),this.p=W.id,this.q.fire({execution:await this.z(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){if(!this.l.has(W.id))return;const U=await this.z(W);this.l.delete(W.id),this.k.delete(W.id),this.B(W),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const U=await this.z(W.id);this.s.fire({execution:U,processId:W.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(W){const U=await this.z(W.id);this.u.fire({execution:U,exitCode:W.exitCode})}$provideTasks(W,U){const C=this.j.get(W);if(!C)return Promise.reject(new Error("no handler found"));const O=[],q=(0,M.$$g)(()=>C.provider.provideTasks(N.CancellationToken.None)).then(ne=>this.v(U,O,C,ne));return new Promise(ne=>{q.then(ce=>{Promise.all(O).then(()=>{ne(ce)})})})}async $resolveTask(W,U){const C=this.j.get(W);if(!C)return Promise.reject(new Error("no handler found"));if(U.definition.type!==C.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${C.type}].`);const O=await h.to(U,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const q=await C.provider.resolveTask(O,N.CancellationToken.None);if(!q)return;this.A(q,C);const ne=h.from(q,C.extension);if(!ne)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return b.is(ne.execution)&&await this.y(ne,q,!0),await this.w(ne)}x(){return this.h++}async y(W,U,C){const O=await this.a.$createTaskId(W);!C&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,U.execution)),this.m.set(O,U.execution)}async z(W,U){if(typeof W=="string"){const q=this.l.get(W);if(!q)throw new c.$bb("Unexpected: The specified task is missing an execution");return q}const C=this.l.get(W.id);if(C)return C;let O;return U?O=Promise.resolve(new w(this,W.id,U)):O=h.to(W.task,this.b,this.m).then(q=>{if(!q)throw new c.$bb("Unexpected: Task does not exist.");return new w(this,W.id,q)}),this.l.set(W.id,O),O.then(q=>(this.k.set(W.id,q),q))}A(W,U){W._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}B(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const C=this.n.values();let O=C.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=C.next()}};e.$6jc=A,e.$6jc=A=Qe([qe(0,l.$pO),qe(1,k.$FO),qe(2,m.$Bic),qe(3,f.$AO),qe(4,E.$Eic),qe(5,D.$3ic),qe(6,r.$Aj),qe(7,i.$cic)],A);let L=class extends A{constructor(W,U,C,O,q,ne,ce,ye){super(W,U,C,O,q,ne,ce,ye),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:a.$h(0)})}async executeTask(W,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const C=h.from(U,W);if(C===void 0)throw new Error("Task is not valid");if(b.is(C.execution))await this.y(C,U,!1);else throw new c.$_;const O=await this.z(await this.a.$getTaskExecution(C),U);return this.a.$executeTask(C).catch(q=>{throw new Error(q)}),O}v(W,U,C,O){const q=[];if(O)for(const ne of O){if(this.A(ne,C),!ne.definition||!W[ne.definition.type]){const ye=ne.source?ne.source:"No task source";this.f.warn(`The task [${ye}, ${ne.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=h.from(ne,C.extension);ce&&b.is(ce.execution)?(q.push(ce),U.push(this.y(ce,ne,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:q,extension:C.extension}}async w(W){if(b.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,U,C){}};e.$7jc=L,e.$7jc=L=Qe([qe(0,l.$pO),qe(1,k.$FO),qe(2,m.$Bic),qe(3,f.$AO),qe(4,E.$Eic),qe(5,D.$3ic),qe(6,r.$Aj),qe(7,i.$cic)],L),e.$8jc=(0,g.$gi)("IExtHostTask")}),define(Pe[285],Re([1,0,44,29]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SK=e.$RK=e.$QK=void 0;function P(R){return"cellResults"in R}e.$QK=P,e.$RK="rawCell#";function F(R,m){let f=-1;const E=[];let N=[];return R.forEach(l=>{l.range.startLineNumber!==f&&N.length>0&&(E.push([...N]),N=[]),N.push(l),f=l.range.endLineNumber}),N.length>0&&E.push([...N]),E.map(l=>{const k=[],g=l[0].range.startLineNumber,s=l[l.length-1].range.endLineNumber;for(let a=g;a<=s;a++)k.push(m.getLineContent(a));return new S.$uK(k.join(`
`)+`
`,l.map(a=>new M.$0s(a.range.startLineNumber-1,a.range.startColumn-1,a.range.endLineNumber-1,a.range.endColumn-1)))})}e.$SK=F}),define(Pe[286],Re([1,0,166,23,5,6,28,15,16,2,42,74,4,31,8,7,49,261,112,26,12,215,285,283]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g,s,a,r,i,n,c,d,t,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hjc=void 0;class u{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(v=>v.apiEditor)}constructor(v,b,$,I,h,y){this.q=$,this.r=I,this.s=h,this.t=y,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new P.$6d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$6d,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$6d,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$6d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$aic("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=v.getProxy(l.$0L.MainThreadNotebook),this.c=v.getProxy(l.$0L.MainThreadNotebookDocuments),this.d=v.getProxy(l.$0L.MainThreadNotebookEditors),this.i=b.converter,b.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===13){const A=w.notebookEditor?.notebookUri,L=w.cell.handle,W=this.g.get(A)?.getCell(L);if(W)return W.apiCell}if(w&&w.$mid===14){const A=w.uri,L=this.g.get(A);if(L)return L.apiNotebook}return w}}),u.B(b)}getEditorById(v){const b=this.h.get(v);if(!b)throw new Error(`unknown text editor: ${v}. known editors: ${[...this.h.keys()]} `);return b}getIdByEditor(v){for(const[b,$]of this.h)if($.apiEditor===v)return b}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(v,b){const $=this.g.get(v);if(!$&&!b)throw new Error(`NO notebook document for '${v}'`);return $}static u(v,b){if(!b)return;const $=b.filenamePattern.map(I=>g.NotebookExclusiveDocumentPattern.from(I)).filter(I=>I!==void 0);if(b.filenamePattern&&!$){console.warn(`Notebook content provider view options file name pattern is invalid ${b.filenamePattern}`);return}return{extension:v.identifier,providerDisplayName:v.displayName||v.name,displayName:b.displayName,filenamePattern:$,exclusive:b.exclusive||!1}}registerNotebookCellStatusBarItemProvider(v,b,$){const I=u.a++,h=typeof $.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set(I,$),this.b.$registerNotebookCellStatusBarItemProvider(I,h,b);let y;return h!==void 0&&(y=$.onDidChangeCellStatusBarItems(w=>this.b.$emitCellStatusBarEvent(h))),new s.$_L(()=>{this.f.delete(I),this.b.$unregisterNotebookCellStatusBarItemProvider(I,h),y?.dispose()})}async createNotebookDocument(v){const b=await this.c.$tryCreateNotebook({viewType:v.viewType,content:v.content&&g.NotebookData.from(v.content)});return E.URI.revive(b)}async openNotebookDocument(v){const b=this.g.get(v);if(b)return b.apiNotebook;const $=await this.c.$tryOpenNotebook(v),I=this.g.get(E.URI.revive($));return(0,f.$5f)(I?.apiNotebook)}async showNotebookDocument(v,b){E.URI.isUri(v)&&(v=await this.openNotebookDocument(v));let $;typeof b=="object"?$={position:g.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selections:b.selections&&b.selections.map(g.NotebookRange.from),pinned:typeof b.preview=="boolean"?!b.preview:void 0}:$={preserveFocus:!1};const I=await this.d.$tryShowNotebookDocument(v.uri,v.notebookType,$),h=I&&this.h.get(I)?.apiEditor;if(h)return h;throw I?new Error(`Could NOT open editor for "${v.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${v.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(v,b,$,I){const h=this.f.get(v),y=E.URI.revive(b),w=this.g.get(y);if(!w||!h)return;const A=w.getCellFromIndex($);if(!A)return;const L=await h.provideCellStatusBarItems(A.apiCell,I);if(!L)return;const J=new F.$Sc,W=this.p.add([J]),C=(Array.isArray(L)?L:[L]).map(O=>g.NotebookStatusBarItem.from(O,this.i,J));return{cacheId:W,items:C}}$releaseNotebookCellStatusBarItems(v){this.p.delete(v)}registerNotebookSerializer(v,b,$,I,h){if((0,m.$Te)(b))throw new Error("viewType cannot be empty or just whitespace");const y=this.w++;return this.x.set(y,{viewType:b,serializer:$,options:I}),this.b.$registerNotebookSerializer(y,{id:v.identifier,location:v.extensionLocation},b,g.NotebookDocumentContentOptions.from(I),u.u(v,h)),(0,F.$Rc)(()=>{this.b.$unregisterNotebookSerializer(y)})}async $dataToNotebook(v,b,$){const I=this.x.get(v);if(!I)throw new Error("NO serializer found");const h=await I.serializer.deserializeNotebook(b.buffer,$);return new a.$0v(g.NotebookData.from(h))}async $notebookToData(v,b,$){const I=this.x.get(v);if(!I)throw new Error("NO serializer found");const h=await I.serializer.serializeNotebook(g.NotebookData.to(b.value),$);return M.$te.wrap(h)}async $saveNotebook(v,b,$,I,h){const y=E.URI.revive(b),w=this.x.get(v);if(!w)throw new Error("NO serializer found");const A=this.g.get(y);if(!A)throw new Error("Document NOT found");if(A.versionId!==$)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(y.scheme))throw new N.$2k((0,S.localize)(0,null,this.z(y)),6);await this.y(y,I);const L={metadata:(0,n.$Tn)(A.apiNotebook.metadata,O=>!(w.options?.transientDocumentMetadata??{})[O]),cells:[]};for(const O of A.apiNotebook.getCells()){const q=new s.$AN(O.kind,O.document.getText(),O.document.languageId,O.mime,w.options?.transientOutputs?[]:[...O.outputs],O.metadata,O.executionSummary);q.metadata=(0,n.$Tn)(O.metadata,ne=>!(w.options?.transientCellMetadata??{})[ne]),L.cells.push(q)}const J=await w.serializer.serializeNotebook(L,h);await this.s.value.writeFile(y,J);const W=this.s.getFileSystemProviderExtUri(y.scheme),U=await this.s.value.stat(y);return{name:W.basename(y),isFile:(U.type&N.FileType.File)!==0,isDirectory:(U.type&N.FileType.Directory)!==0,isSymbolicLink:(U.type&N.FileType.SymbolicLink)!==0,mtime:U.mtime,ctime:U.ctime,size:U.size,readonly:!!((U.permissions??0)&N.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(y.scheme),locked:!!((U.permissions??0)&N.FilePermission.Locked),etag:N.$al({mtime:U.mtime,size:U.size}),children:void 0}}async $searchInNotebooks(v,b,$,I,h){const y=this.x.get(v)?.serializer;if(!y)return{limitHit:!1,results:[]};const w=new R.$Bc;await(async(U,C,O)=>{await Promise.all(U.map(async q=>await Promise.all(q.filenamePatterns.map(ne=>{const ce={_reason:O._reason,folderQueries:O.folderQueries,includePattern:O.includePattern,excludePattern:O.excludePattern,maxResults:O.maxResults,type:1,filePattern:ne};return this.t.doInternalFileSearchWithCustomCallback(ce,C,ye=>{ye.forEach(Ie=>{w.has(Ie)||I.some(ve=>q.isFromSettings&&!ve.isFromSettings?!1:ve.filenamePatterns.some(re=>(0,p.$0eb)(re,Ie)))||w.add(Ie)})}).catch(ye=>{if(ye.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ye})}))))})($,h,b);const L=new R.$Ac;let J=!1;const W=Array.from(w).map(async U=>{const C=[];try{if(h.isCancellationRequested)return;if(b.maxResults&&[...L.values()].reduce((ce,ye)=>ce+ye.cellResults.length,0)>b.maxResults){J=!0;return}const O=[],q=this.g.get(U);if(q)q.apiNotebook.getCells().forEach(ye=>O.push({input:ye.document.getText(),outputs:ye.outputs.flatMap(Ie=>Ie.items.map(ue=>ue.data.toString()))}));else{const ce=await this.s.value.readFile(U),ye=M.$te.fromString(ce.toString()),Ie=await y.deserializeNotebook(ye.buffer,h);if(h.isCancellationRequested)return;g.NotebookData.from(Ie).cells.forEach(ve=>O.push({input:ve.source,outputs:ve.outputs.flatMap(re=>re.items.map($e=>$e.valueBytes.toString()))}))}if(h.isCancellationRequested)return;O.forEach((ce,ye)=>{const Ie=b.contentPattern.pattern,ue=new d.$ETb(ce.input,void 0,ce.outputs),ve=ue.findInInputs(Ie),re=ue.findInOutputs(Ie),$e=re.flatMap(ie=>(0,t.$SK)(ie.matches,ie.textBuffer)).map((ie,le)=>(ie.webviewIndex=le,ie));if(ve.length>0||re.length>0){const ie={index:ye,contentResults:(0,t.$SK)(ve,ue.inputTextBuffer),webviewResults:$e};C.push(ie)}});const ne={resource:U,cellResults:C};L.set(U,ne);return}catch{return}});return await Promise.all(W),{limitHit:J,results:[...L.values()]}}async y(v,b){const $=await this.s.value.stat(v);if(typeof b?.mtime=="number"&&typeof b.etag=="string"&&b.etag!==N.$_k&&typeof $.mtime=="number"&&typeof $.size=="number"&&b.mtime<$.mtime&&b.etag!==N.$al({mtime:b.mtime,size:$.size}))throw new N.$2k((0,S.localize)(1,null),3,b)}z(v){return v.scheme===c.Schemas.file?v.fsPath:v.toString()}A(v,b,$){if(this.h.has(b))throw new Error(`editor with id ALREADY EXSIST: ${b}`);const I=new i.$yjc(b,this.d,v,$.visibleRanges.map(g.NotebookRange.to),$.selections.map(g.NotebookRange.to),typeof $.viewColumn=="number"?g.ViewColumn.to($.viewColumn):void 0);this.h.set(b,I)}$acceptDocumentAndEditorsDelta(v){if(v.value.removedDocuments)for(const $ of v.value.removedDocuments){const I=E.URI.revive($),h=this.g.get(I);h&&(h.dispose(),this.g.delete(I),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:h.apiNotebook.getCells().map(y=>y.document.uri)}),this.n.fire(h.apiNotebook));for(const y of this.h.values())y.notebookData.uri.toString()===I.toString()&&this.h.delete(y.id)}if(v.value.addedDocuments){const $=[];for(const I of v.value.addedDocuments){const h=E.URI.revive(I.uri);if(this.g.has(h))throw new Error(`adding EXISTING notebook ${h} `);const y=new r.$xjc(this.c,this.q,this.r,h,I);$.push(...I.cells.map(w=>r.$wjc.asModelAddData(w))),this.g.get(h)?.dispose(),this.g.set(h,y),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:$}),this.m.fire(y.apiNotebook)}}if(v.value.addedEditors)for(const $ of v.value.addedEditors){if(this.h.has($.id))return;const I=E.URI.revive($.documentUri),h=this.g.get(I);h&&this.A(h,$.id,$)}const b=[];if(v.value.removedEditors)for(const $ of v.value.removedEditors){const I=this.h.get($);I&&(this.h.delete($),this.k?.id===I.id&&(this.k=void 0),b.push(I))}if(v.value.visibleEditors){this.l=v.value.visibleEditors.map(I=>this.h.get(I)).filter(I=>!!I);const $=new Set;this.l.forEach(I=>$.add(I.id));for(const I of this.h.values()){const h=$.has(I.id);I._acceptVisibility(h)}this.l=[...this.h.values()].map(I=>I).filter(I=>I.visible),this.o.fire(this.visibleNotebookEditors)}v.value.newActiveEditor===null?this.k=void 0:v.value.newActiveEditor&&(this.h.get(v.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${v.value.newActiveEditor}`),this.k=this.h.get(v.value.newActiveEditor)),v.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(v){const b=k.$NO.String.with("notebookType","A notebook type"),$=new k.$PO("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[b,new k.$NO("data","Bytes to convert to data",h=>h instanceof Uint8Array,h=>M.$te.wrap(h))],new k.$OO("Notebook Data",h=>g.NotebookData.to(h.value))),I=new k.$PO("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[b,new k.$NO("NotebookData","Notebook data to convert to bytes",h=>!0,h=>new a.$0v(g.NotebookData.from(h)))],new k.$OO("Bytes",h=>h.buffer));v.registerApiCommand($),v.registerApiCommand(I)}}e.$Hjc=u}),define(Pe[287],Re([1,0,19,25,41,34,24,64,44]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zjc=void 0;class E{constructor(l,k,g){this.k=l,this.l=k,this.o=g,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&F.$Zj(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&F.$Zj(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const k=this.k.folderQueries||[];return new Promise((g,s)=>{const a=r=>{this.f++,l(r)};if(this.g)return g({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(r=>{const i=r.toString(),n=S.$nc(i);this.j&&this.j(i,n)||this.v(a,{base:r,basename:n})}),Promise.all(k.map(r=>this.p(r,a))).then(r=>{g({limitHit:this.e,stats:r[0]||void 0})},r=>{s(new Error((0,P.$4i)(r)))})})}async p(l,k){const g=new M.$de,s=this.q(l),a=this.r(),r=new f.$IK(this.k,l),i=!r.hasSiblingExcludeClauses();let n;try{this.h.add(g),n=m.$2d.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,g.token),d=n.elapsed(),t=m.$2d.create();return this.g&&!this.e||(c&&c.forEach(p=>{const u=S.$gc.relative(l.folder.path,p.path);if(i){const o=S.$nc(p.path);this.v(k,{base:l.folder,relativePath:u,basename:o});return}this.s(a,l.folder,u,k)}),this.g&&!this.e)?null:(this.u(a,r,k),{providerTime:d,postProcessTime:t.elapsed()})}finally{g.dispose(),this.h.delete(g)}}q(l){const k=(0,f.$HK)(this.k.includePattern,l.includePattern),g=(0,f.$HK)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:g,includes:k,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},k,g,s){if(g===this.a){const r=S.$nc(this.a);this.v(s,{base:k,relativePath:this.a,basename:r})}function a(r){const i=S.$nc(r),n=S.$mc(r);let c=l[n];c||(c=l[n]=[],a(n)),c.push({base:k,relativePath:r,basename:i})}a(g)}u({rootEntries:l,pathToEntries:k},g,s){const a=this,r=this.a;function i(n){const c=(0,f.$KK)(()=>n.map(d=>d.basename));for(let d=0,t=n.length;d<t;d++){const p=n[d],{relativePath:u,basename:o}=p;if(g.matchesExcludesSync(u,o,r!==o?c:void 0))continue;const v=k[u];if(v)i(v);else{if(u===r)continue;a.v(s,p)}if(a.e)break}}i(l)}v(l,k){(!this.b||k.relativePath&&this.b(k.relativePath,k.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(k))}}class N{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,k,g,s){const a=this.c(l.cacheKey),r=new E(l,k,a&&a.token);let i=0;const n=c=>{i+=c.length,g(c.map(d=>this.d(d)))};return this.e(r,N.a,n,s).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:c.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new M.$de),this.b.get(l)}d(l){return l.relativePath?{resource:R.$Tg(l.base,l.relativePath)}:{resource:l.base}}e(l,k,g,s){const a=s.onCancellationRequested(()=>{l.cancel()}),r=n=>{n&&(i.push(n),k>0&&i.length>=k&&(g(i),i=[]))};let i=[];return l.search(r).then(n=>(i.length&&g(i),a.dispose(),n),n=>(i.length&&g(i),a.dispose(),Promise.reject(n)))}}e.$zjc=N}),define(Pe[288],Re([1,0,18,256,34,96,28,12,19,24,15,16,2,95,183,46,13,47,107,284,44]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g,s,a,r,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OL=e.$NL=void 0;let d=class{constructor(y,w,A,L,J){this.a=y,this.b=w,this.c=A,this.d=L,this.e=J}text(y,w,A={}){y=this.f(y,A);const L=this.a.getValue(),J=w&&w.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(w?.map(r.$Bi),A),type:2,contentPattern:y,previewOptions:A.previewOptions,maxFileSize:A.maxFileSize,usePCRE2:L.search.usePCRE2||J||!1,beforeContext:A.beforeContext,afterContext:A.afterContext,userDisabledExcludesAndIgnoreFiles:A.disregardExcludeSettings&&A.disregardIgnoreFiles}}f(y,w){const A=this.a.getValue();y.isRegExp&&(y.pattern=y.pattern.replace(/\r?\n/g,"\\n"));const L={...y,wordSeparators:A.editor.wordSeparators};return this.j(y,w)&&(L.isCaseSensitive=!0),this.k(y)&&(L.isMultiline=!0),w.notebookSearchConfig?.includeMarkupInput&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookMarkdownInput=w.notebookSearchConfig.includeMarkupInput),w.notebookSearchConfig?.includeMarkupPreview&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookMarkdownPreview=w.notebookSearchConfig.includeMarkupPreview),w.notebookSearchConfig?.includeCodeInput&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookCellInput=w.notebookSearchConfig.includeCodeInput),w.notebookSearchConfig?.includeOutput&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookCellOutput=w.notebookSearchConfig.includeOutput),L}file(y,w={}){return{...this.h(y,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey,shouldGlobMatchFilePattern:w.shouldGlobSearch}}g(y,w){return y?(y=Array.isArray(y)?y.map(v):v(y),w?this.parseSearchPaths(y):{pattern:p(...Array.isArray(y)?y:[y])}):{}}h(y=[],w={}){const A=this.g(w.includePattern,w.expandPatterns),L=this.g(w.excludePattern,w.expandPatterns),J=y.length>1,W=(A.searchPaths&&A.searchPaths.length?A.searchPaths.map(O=>this.q(O,w,L)):y.map(O=>this.r(O,w,L,J))).filter(O=>!!O),U={_reason:w._reason,folderQueries:W,usingSearchPaths:!!(A.searchPaths&&A.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:L.pattern,includePattern:A.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const O=S.$Hb(S.$Rb(this.c.groups.map(ce=>ce.editors.map(ye=>ye.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const q=O.filter(ce=>(0,c.$yK)(U,ce.fsPath)),ne=this.i(q);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ne)),{...U,...ne}}const C=w.extraFileResources&&w.extraFileResources.filter(O=>(0,c.$yK)(U,O.fsPath));return U.extraFileResources=C&&C.length?C:void 0,U}i(y){const w=[],A=new R.$Ac,L={};let J=!1;return y.forEach(W=>{if(W.scheme===m.Schemas.walkThrough)return;if((0,E.$Xg)(W)){const C=this.b.getWorkspaceFolder(W)?.uri??W.with({path:f.$mc(W.fsPath)});let O=A.get(C);O||(J=!0,O={folder:C,includePattern:{}},w.push(O),A.set(C,O));const q=f.$lc(C.fsPath,W.fsPath);(0,D.$5f)(O.includePattern)[q.replace(/\\/g,"/")]=!0}else W.fsPath&&(J=!0,L[W.fsPath]=!0)}),{folderQueries:w,includePattern:L,usingSearchPaths:!0,excludePattern:J?void 0:{"**/*":!0}}}j(y,w){if(w.isSmartCase){if(y.isRegExp){if(N.$Kf(y.pattern,!0))return!0}else if(N.$Kf(y.pattern))return!0}return!!y.isCaseSensitive}k(y){return y.isMultiline||y.isRegExp&&(0,k.$hC)(y.pattern)||y.pattern.indexOf(`
`)>=0?!0:!!y.isMultiline}parseSearchPaths(y){const w=ne=>f.$ic(ne)||/^\.\.?([\/\\]|$)/.test(ne),L=(Array.isArray(y)?y:u(y)).map(ne=>{const ce=this.e.resolvedUserHome;return ce?(0,F.$cw)(ne,ce.scheme===m.Schemas.file?ce.fsPath:ce.path):ne}),J=M.$K(L,ne=>w(ne)?"searchPaths":"exprSegments"),W=(J.exprSegments||[]).map(ne=>N.$5e(ne,"/")).map(ne=>N.$5e(ne,"\\")).map(ne=>(ne[0]==="."&&(ne="*"+ne),o(ne))),U={},C=this.m(J.searchPaths||[]);C&&C.length&&(U.searchPaths=C);const O=S.$Rb(W),q=p(...O);return q&&(U.pattern=q),U}l(y,w){return w.disregardExcludeSettings?void 0:(0,c.$xK)(y,!w.disregardSearchExcludeSettings)}m(y){if(!y||!y.length)return[];const w=y.flatMap(L=>{let{pathPortion:J,globPortion:W}=t(L);return W&&(W=b(W)),this.n(J).flatMap(C=>this.o(C,W))}),A=new Map;return w.forEach(L=>{const J=L.searchPath.toString(),W=A.get(J);W?L.pattern&&(W.pattern=W.pattern||{},W.pattern[L.pattern]=!0):A.set(J,{searchPath:L.searchPath,pattern:L.pattern?p(L.pattern):void 0})}),Array.from(A.values())}n(y){if(f.$ic(y)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==m.Schemas.file?[{searchPath:w[0].uri.with({path:y})}]:[{searchPath:l.URI.file(f.$hc(y))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(y=v(y),y.startsWith("../")||y===".."){const L=f.$gc.resolve(w.path,y);return[{searchPath:w.with({path:L})}]}const A=b(y);return[{searchPath:w,pattern:A}]}else{if(y==="./"||y===".\\")return[];{const w=y.replace(/^\.[\/\\]/,""),L=this.b.getWorkspace().folders.map(J=>{const W=w.match(new RegExp(`^${N.$Ye(J.name)}(?:/(.*)|$)`));return W?{match:W,folder:J}:null}).filter(D.$2f);if(L.length)return L.map(J=>{const W=J.match[1];return{searchPath:J.folder.uri,pattern:W&&b(W)}});{const J=y.match(/\.[\/\\](.+)[\/\\]?/),W=J?J[1]:y,U=g.localize(0,null,W);throw new Error(U)}}}}o(y,w){const A=y.pattern&&w?`${y.pattern}/${w}`:y.pattern||w,L=[{searchPath:y.searchPath,pattern:A}];return A&&!A.endsWith("**")&&L.push({searchPath:y.searchPath,pattern:A+"/**"}),L}q(y,w,A){const L=this.r((0,r.$Bi)(y.searchPath),w,A,!1);return L?{...L,includePattern:y.pattern}:null}r(y,w,A,L){let J;const W=l.URI.isUri(y)?y:y.uri;if(A.searchPaths){const ne=A.searchPaths.filter(ce=>(0,E.$Mg)(ce.searchPath,W))[0];if(ne&&!ne.pattern)return null;ne&&(J=ne.pattern)}const U=this.a.getValue({resource:W}),O={...this.l(U,w)||{},...J||{}},q=l.URI.isUri(y)?(0,E.$Qg)(y):y.name;return{folder:W,folderName:L?q:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!U.search.followSymlinks}}};e.$NL=d,e.$NL=d=Qe([qe(0,s.$Mi),qe(1,r.$pi),qe(2,i.$oD),qe(3,a.$Aj),qe(4,n.$LL)],d);function t(h){const y=h.match(/[\*\{\}\(\)\[\]\?]/);if(y){const w=y.index,A=h.substr(0,w).match(/[/|\\][^/\\]*$/);if(A){let L=h.substr(0,A.index);return L.match(/[/\\]/)||(L+="/"),{pathPortion:L,globPortion:h.substr((A.index||0)+1)}}}return{pathPortion:h}}function p(...h){return h.length?h.reduce((y,w)=>(y[w]=!0,y),Object.create(null)):void 0}function u(h){return P.$Xj(h,",").map(y=>y.trim()).filter(y=>!!y.length)}function o(h){return[`**/${h}/**`,`**/${h}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function v(h){return h.replace(/\\/g,"/")}function b(h){return v(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function $(h){return h.replace(/([?*[\]])/g,"[$1]")}function I(h,y){h=S.$Mb(h,L=>L.toString());const w=[],A=y.getWorkspace();return h&&h.forEach(L=>{let J;if(y.getWorkbenchState()===2)J=(0,E.$Vg)(A.folders[0].uri,L),J&&J!=="."&&(J="./"+J);else{const W=y.getWorkspaceFolder(L);if(W){const U=W.name;if(A.folders.filter(O=>O.name===U).length===1){const O=(0,E.$Vg)(W.uri,L);O===""?J=`./${W.name}`:J=`./${W.name}/${O}`}else J=L.fsPath}}J&&w.push($(J))}),w}e.$OL=I}),define(Pe[289],Re([1,0,24,2,25,14,3,288,44,47,11]),function(me,e,S,M,P,F,R,m,f,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xub=e.$wub=void 0;const D=7e3;function l(a,r){const i=r.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],c=[];for(const v of i)if(/^workspaceContains:/.test(v)){const b=v.substr(18);b.indexOf("*")>=0||b.indexOf("?")>=0||a.forceUsingSearch?c.push(b):n.push(b)}if(n.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:d,resolve:t}=(0,N.$_g)(),p=v=>t({activationEvent:v}),u=Promise.all(n.map(v=>k(a,v,p))).then(()=>{}),o=g(a,r.identifier,c,p);return Promise.all([u,o]).then(()=>{t(void 0)}),d}e.$wub=l;async function k(a,r,i){for(const n of a.folders)if(await a.exists(S.$Tg(M.URI.revive(n),r))){i(`workspaceContains:${r}`);return}}async function g(a,r,i,n){if(i.length===0)return Promise.resolve(void 0);const c=new P.$de,d=a.checkExists(a.folders,i,c.token),t=setTimeout(async()=>{c.cancel(),a.logService.info(`Not activating extension '${r.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},D);let p=!1;try{p=await d}catch(u){F.$4(u)||F.$1(u)}c.dispose(),clearTimeout(t),p&&n(`workspaceContains:${i.join(",")}`)}function s(a,r,i,n){const c=a.get(R.$fi),d=a.get(f.$pK),p=c.createInstance(m.$NL).file(r.map(u=>(0,E.$Bi)(M.URI.revive(u))),{_reason:"checkExists",includePattern:i,exists:!0});return d.fileSearch(p,n).then(u=>!!u.limitHit,u=>F.$4(u)?!1:Promise.reject(u))}e.$xub=s}),define(Pe[38],Re([1,0,162,19,89,24,11,6,50,2,13,4,37,221,82,36,22,108,14,20,23,204,7,102,3,27,85,17,71,86,66,88,5,289,81,206,12,79,64,21,80]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g,s,a,r,i,n,c,d,t,p,u,o,v,b,$,I,h,y,w,A,L,J,W,U,C,O,q){"use strict";var ne;Object.defineProperty(e,"__esModule",{value:!0}),e.$fjc=e.$ejc=e.$djc=e.$cjc=e.$bjc=void 0,e.$bjc=(0,u.$gi)("IHostUtils");let ce=ne=class extends m.$Tc{constructor(V,_,ke,Le,Ee,be,ge,G,Y,he,fe,Oe,de){super(),this.X=Oe,this.Y=de,this.a=this.B(new w.$6d),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=_,this.g=ke,this.f=ge,this.j=Le,this.m=Ee,this.s=be,this.t=Y,this.u=he,this.w=fe,this.y=this.g.getProxy(D.$0L.MainThreadWorkspace),this.z=this.g.getProxy(D.$0L.MainThreadTelemetry),this.C=this.g.getProxy(D.$0L.MainThreadExtensionService),this.D=new R.$fh,this.F=new R.$fh,this.G=new R.$fh,this.H=new R.$fh,this.I=new ie(this.f.extensions.activationEvents),this.L=new r.$a0b(this.I,this.f.extensions.allExtensions);const Ce=new n.$Bm(this.f.extensions.myExtensions);this.J=new r.$a0b(this.I,re(this.L,Ce)),O.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ue(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ue(this.J)}`)),this.M=new g.$Yic(this.g,this.s),this.N=new L.$7ic(this.g),this.O=G,this.h=V.createChild(new $.$ei([g.$Zic,this.M],[L.$8ic,this.N])),this.P=this.B(new k.$Xic(this.J,this.L,{onExtensionActivationError:(Ae,ze,z)=>{this.C.$onExtensionActivationError(Ae,i.$3(ze),z)},actualActivateExtension:async(Ae,ze)=>{if(r.$a0b.isHostExtension(Ae,this.J,this.L))return await this.C.$activateExtension(Ae,ze),new k.$Wic;const z=this.J.getExtensionDescription(Ae);return this.eb(z,ze)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.ub(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.sb()}catch(V){i.$1(V)}}async Z(){this.O.onWillDeactivateAll();let V=[];try{V=this.J.getAllExtensionDescriptions().map(Ee=>Ee.identifier).filter(Ee=>this.isActivated(Ee)).map(Ee=>this.db(Ee))}catch{}await Promise.all(V)}terminate(V,_=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${V}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(Le=>{this.s.error(Le)}),this.g.dispose();const ke=this.Z();Promise.race([(0,R.$hh)(5e3),ke]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${_}`):this.s.info(`Extension host exiting with code ${_}`),this.s.flush(),this.s.dispose(),this.c.exit(_)})}isActivated(V){return this.G.isOpen()?this.P.isActivated(V):!1}async getExtension(V){const _=await this.C.$getExtension(V);return _&&{..._,identifier:new n.$Am(_.identifier.value),extensionLocation:E.URI.revive(_.extensionLocation)}}$(V,_){return this.P.activateByEvent(V,_)}ab(V,_){return this.P.activateById(V,_)}activateByIdWithErrors(V,_){return this.ab(V,_).then(()=>{const ke=this.P.getActivatedExtension(V);if(ke.activationFailed)return Promise.reject(ke.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(V=>this.J)}getExtensionExports(V){if(this.G.isOpen())return this.P.getActivatedExtension(V).exports;try{return this.P.getActivatedExtension(V).exports}catch{return null}}async bb(V){if(V.scheme===W.Schemas.file&&this.c.fsRealpath){const _=await this.c.fsRealpath(V.fsPath);return E.URI.file(_)}return V}async getExtensionPathIndex(){return this.Q||(this.Q=this.cb(this.J.getAllExtensionDescriptions()).then(V=>new $e(V))),this.Q}async cb(V){const _=f.$mi.forUris(ke=>F.$Kg.ignorePathCasing(ke));return await Promise.all(V.map(async ke=>{if(this.vb(ke)){const Le=await this.bb(ke.extensionLocation);_.set(Le,ke)}})),_}db(V){let _=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(V))return _;const ke=this.P.getActivatedExtension(V);if(!ke)return _;try{typeof ke.module.deactivate=="function"&&(_=Promise.resolve(ke.module.deactivate()).then(void 0,Le=>(this.s.error(Le),Promise.resolve(void 0))))}catch(Le){this.s.error(`An error occurred when deactivating the extension '${V.value}':`),this.s.error(Le)}try{(0,m.$Oc)(ke.subscriptions)}catch(Le){this.s.error(`An error occurred when deactivating the subscriptions for extension '${V.value}':`),this.s.error(Le)}return _}async eb(V,_){return this.f.remote.isRemote?this.C.$onWillActivateExtension(V.identifier):await this.C.$onWillActivateExtension(V.identifier),this.gb(V,_).then(ke=>{const Le=ke.activationTimes;return this.C.$onDidActivateExtension(V.identifier,Le.codeLoadingTime,Le.activateCallTime,Le.activateResolvedTime,_),this.fb(V,_,"success",Le),ke},ke=>{throw this.fb(V,_,"failure"),ke})}fb(V,_,ke,Le){const Ee=Ie(V,_);this.z.$publicLog2("extensionActivationTimes",{...Ee,...Le||{},outcome:ke})}gb(V,_){const ke=Ie(V,_);this.z.$publicLog2("activatePlugin",ke);const Le=this.vb(V);if(!Le)return Promise.resolve(new k.$Vic(k.$Sic.NONE));this.s.info(`ExtensionService#_doActivateExtension ${V.identifier.value}, startup: ${_.startup}, activationEvent: '${_.activationEvent}'${V.identifier.value!==_.extensionId.value?`, root cause: ${_.extensionId.value}`:""}`),this.s.flush();const Ee=new k.$Tic(_.startup);return Promise.all([this.wb(V,(0,F.$Tg)(V.extensionLocation,Le),Ee),this.hb(V)]).then(be=>(P.mark(`code/extHost/willActivateExtension/${V.identifier.value}`),ne.ib(this.s,V.identifier,be[0],be[1],Ee))).then(be=>(P.mark(`code/extHost/didActivateExtension/${V.identifier.value}`),be))}hb(V){const _=this.Y.createLanguageModelAccessInformation(V),ke=new d.$2ic(V,this.M),Le=new d.$1ic(V.identifier.value,!1,this.M),Ee=new J.$9ic(V,this.N),be=V.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,ge=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${V.identifier.value}`),Promise.all([ke.whenReady,Le.whenReady,this.O.whenReady]).then(()=>{const G=this;let Y,he;const fe=(0,a.$ZF)(V,"ipc")?this.f.messagePorts?.get(n.$Am.toKey(V.identifier)):void 0;return Object.freeze({globalState:ke,workspaceState:Le,secrets:Ee,subscriptions:[],get languageModelAccessInformation(){return _},get extensionUri(){return V.extensionLocation},get extensionPath(){return V.extensionLocation.fsPath},asAbsolutePath(Oe){return M.$jc(V.extensionLocation.fsPath,Oe)},get storagePath(){return G.O.workspaceValue(V)?.fsPath},get globalStoragePath(){return G.O.globalValue(V).fsPath},get logPath(){return M.$jc(G.f.logsLocation.fsPath,V.identifier.value)},get logUri(){return E.URI.joinPath(G.f.logsLocation,V.identifier.value)},get storageUri(){return G.O.workspaceValue(V)},get globalStorageUri(){return G.O.globalValue(V)},get extensionMode(){return be},get extension(){return Y===void 0&&(Y=new ve(G,V.identifier,V,ge,!1)),Y},get extensionRuntime(){return(0,a.$1F)(V,"extensionRuntime"),G.extensionRuntime},get environmentVariableCollection(){return G.u.getEnvironmentVariableCollection(V)},get messagePassingProtocol(){if(!he){if(!fe)return;const Oe=w.Event.buffer(w.Event.fromDOMEventEmitter(fe,"message",de=>de.data));fe.start(),he={onDidReceiveMessage:Oe,postMessage:fe.postMessage.bind(fe)}}return he}})})}static ib(V,_,ke,Le,Ee){return ke=ke||{activate:void 0,deactivate:void 0},this.jb(V,_,ke,Le,Ee).then(be=>new k.$Uic(!1,null,Ee.build(),ke,be,Le.subscriptions))}static jb(V,_,ke,Le,Ee){if(typeof ke.activate=="function")try{Ee.activateCallStart(),V.trace(`ExtensionService#_callActivateOptional ${_.value}`);const be=typeof global=="object"?global:self,ge=ke.activate.apply(be,[Le]);return Ee.activateCallStop(),Ee.activateResolveStart(),Promise.resolve(ge).then(G=>(Ee.activateResolveStop(),G))}catch(be){return Promise.reject(be)}else return Promise.resolve(ke)}kb(V,_){this.ab(V.identifier,{startup:!1,extensionId:V.identifier,activationEvent:_}).then(void 0,ke=>{this.s.error(ke)})}lb(V,_=0){const Le=Date.now();(0,O.$B)(()=>{for(let Ee=_;Ee<V.length;Ee+=1){const be=V[Ee];for(const ge of be.activationEvents??[])if(ge==="onStartupFinished")if(Date.now()-Le>50){this.lb(V,Ee);break}else this.kb(be,ge)}})}mb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(V=>{const _=V.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ke=this.J.getAllExtensionDescriptions();if(_)this.lb(ke);else for(const Le of ke)if(Le.activationEvents)for(const Ee of Le.activationEvents)Ee==="onStartupFinished"&&this.kb(Le,Ee)})}nb(){const V=this.$("*",!0).then(void 0,be=>{this.s.error(be)});this.B(this.j.onDidChangeWorkspace(be=>this.ob(be.added)));const _=this.j.workspace?this.j.workspace.folders:[],ke=this.ob(_),Le=this.qb(),Ee=Promise.all([Le,V,ke]).then(()=>{});return Promise.race([Ee,(0,R.$hh)(1e4)]).then(()=>{this.mb()}),Ee}ob(V){return V.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(_=>this.pb(V,_))).then(()=>{})}async pb(V,_){if(this.isActivated(_.identifier))return;const ke=!this.f.remote.isRemote&&!!this.f.remote.authority,Le={logService:this.s,folders:V.map(be=>be.uri),forceUsingSearch:ke||!this.c.fsExists,exists:be=>this.c.fsExists(be.fsPath),checkExists:(be,ge,G)=>this.y.$checkExists(be,ge,G)},Ee=await(0,A.$wub)(Le,_);if(Ee)return this.ab(_.identifier,{startup:!0,extensionId:_.identifier,activationEvent:Ee.activationEvent}).then(void 0,be=>this.s.error(be))}async qb(){if(this.f.remote.authority)return this.$(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.rb()}catch(V){throw console.error(V),V}}async rb(){const{extensionDevelopmentLocationURI:V,extensionTestsLocationURI:_}=this.f.environment;if(!V||!_)throw new Error(S.localize(0,null));const ke=await this.wb(null,_,new k.$Tic(!1));if(!ke||typeof ke.run!="function")throw new Error(S.localize(1,null,_.toString()));return new Promise((Le,Ee)=>{const be=(Y,he)=>{Y?(O.$t&&this.s.error("Test runner called back with error",Y),Ee(Y)):(O.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),Le(typeof he=="number"&&he>0?1:0))},ge=(0,F.$Hg)(_),G=ke.run(ge,be);G&&G.then&&G.then(()=>{O.$t&&this.s.info("Test runner finished successfully."),Le(0)}).catch(Y=>{O.$t&&this.s.error("Test runner finished with error",Y),Ee(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}sb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$hh)(1e3)])).then(()=>this.nb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(V,_){return this.R[V]=_,(0,m.$Rc)(()=>{delete this.R[V]})}async getRemoteExecServer(V){const{resolver:_}=await this.tb(V);return _?.resolveExecServer?.(V,{resolveAttempt:0})}async tb(V){const _=V.indexOf("+");if(_===-1)throw new t.$fM("Not an authority that can be resolved!",p.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ke=V.substr(0,_);return await this.D.wait(),await this.$(`onResolveRemoteAuthority:${ke}`,!1),{authorityPrefix:ke,resolver:this.R[ke]}}async $resolveAuthority(V,_){const ke=C.$2d.create(!1),Le=()=>`[resolveAuthority(${(0,p.$pl)(V)},${_})][${ke.elapsed()}ms] `,Ee=j=>this.s.info(`${Le()}${j}`),be=j=>this.s.warn(`${Le()}${j}`),ge=(j,K=void 0)=>this.s.error(`${Le()}${j}`,K),G=j=>{if(j instanceof t.$fM)return{type:"error",error:{code:j._code,message:j._message,detail:j._detail}};throw j},Y=async j=>{Ee(`activating resolver for ${j}...`);const{resolver:K,authorityPrefix:H}=await this.tb(j);if(!K)throw ge(`no resolver for ${H}`),new t.$fM(`No remote extension installed to resolve ${H}.`,p.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:H,remoteAuthority:j}},he=V.split(/@|%40/g).reverse();Ee(`activating remote resolvers ${he.join(" -> ")}`);let fe;try{fe=await Promise.all(he.map(Y)).catch(async j=>{if(!(j instanceof t.$fM)||j._code!==p.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw j;return be(`resolving nested authorities failed: ${j.message}`),[await Y(V)]})}catch(j){return G(j)}const Oe=new R.$rh;Oe.cancelAndSet(()=>Ee("waiting..."),1e3);let de,Ce;for(const[j,{authorityPrefix:K,resolver:H,remoteAuthority:ee}]of fe.entries())try{if(j===fe.length-1)Ee("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${K}`),de=await H.resolve(ee,{resolveAttempt:_,execServer:Ce}),P.mark(`code/extHost/didResolveAuthorityOK/${K}`),Ee("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,t.$eM.isManagedResolvedAuthority(de)?de:void 0));else{if(Ee(`invoking resolveExecServer() for ${ee}`),P.mark(`code/extHost/willResolveExecServer/${K}`),Ce=await H.resolveExecServer?.(ee,{resolveAttempt:_,execServer:Ce}),!Ce)throw new t.$fM(`Exec server was not available for ${ee}`,p.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(se){return P.mark(`code/extHost/didResolveAuthorityError/${K}`),ge("returned an error",se),Oe.dispose(),G(se)}Oe.dispose();const Ae={environmentTunnels:de.environmentTunnels,features:de.tunnelFeatures?{elevation:de.tunnelFeatures.elevation,privacyOptions:de.tunnelFeatures.privacyOptions,protocol:de.tunnelFeatures.protocol===void 0?!0:de.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};Ee(`returned ${t.$eM.isManagedResolvedAuthority(de)?"managed authority":`${de.host}:${de.port}`}`);let z;if(t.$eM.isManagedResolvedAuthority(de)){const j=_;this.X.setFactory(j,de.makeConnection),z={authority:V,connectTo:new p.$ml(j),connectionToken:de.connectionToken}}else z={authority:V,connectTo:new p.$nl(de.host,de.port),connectionToken:de.connectionToken};return{type:"ok",value:{authority:z,options:ze,tunnelInformation:Ae}}}async $getCanonicalURI(V,_){this.s.info(`$getCanonicalURI invoked for authority (${(0,p.$pl)(V)})`);const{resolver:ke}=await this.tb(V);if(!ke)return null;const Le=E.URI.revive(_);if(typeof ke.getCanonicalURI>"u")return Le;const Ee=await(0,R.$$g)(()=>ke.getCanonicalURI(Le));return Ee||Le}$startExtensionHost(V){V.toAdd.forEach(Le=>Le.extensionLocation=E.URI.revive(Le.extensionLocation));const{globalRegistry:_,myExtensions:ke}=ye(this.I,this.L,this.J,V);return this.L.set(_.getAllExtensionDescriptions()),this.J.set(ke),O.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ue(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ue(this.J)}`)),this.sb()}$activateByEvent(V,_){return _===1?this.D.wait().then(ke=>this.$(V,!1)):this.G.wait().then(ke=>this.$(V,!1))}async $activate(V,_){return await this.G.wait(),this.J.getExtensionDescription(V)?(await this.ab(V,_),!0):!1}async $deltaExtensions(V){V.toAdd.forEach(be=>be.extensionLocation=E.URI.revive(be.extensionLocation));const{globalRegistry:_,myExtensions:ke}=ye(this.I,this.L,this.J,V),Le=await this.cb(ke);return(await this.getExtensionPathIndex()).setSearchTree(Le),this.L.set(_.getAllExtensionDescriptions()),this.J.set(ke),O.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ue(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ue(this.J)}`)),Promise.resolve(void 0)}async $test_latency(V){return V}async $test_up(V){return V.byteLength}async $test_down(V){const _=c.$te.alloc(V),ke=Math.random()%256;for(let Le=0;Le<V;Le++)_.writeUInt8(ke,Le);return _}async $updateRemoteConnectionData(V){this.W=V,this.a.fire()}};e.$cjc=ce,e.$cjc=ce=ne=Qe([qe(0,u.$fi),qe(1,e.$bjc),qe(2,b.$pO),qe(3,s.$Bic),qe(4,l.$Eic),qe(5,N.$Aj),qe(6,o.$FO),qe(7,v.$Hic),qe(8,I.$BAb),qe(9,h.$3ic),qe(10,U.$$ic),qe(11,q.$_ic),qe(12,y.$ric)],ce);function ye(le,V,_,ke){le.addActivationEvents(ke.addActivationEvents);const Le=new r.$a0b(le,V.getAllExtensionDescriptions());Le.deltaExtensions(ke.toAdd,ke.toRemove);const Ee=new n.$Bm(_.getAllExtensionDescriptions().map(ge=>ge.identifier));for(const ge of ke.myToRemove)Ee.delete(ge);for(const ge of ke.myToAdd)Ee.add(ge);const be=re(Le,Ee);return{globalRegistry:Le,myExtensions:be}}function Ie(le,V){return{id:le.identifier.value,name:le.name,extensionVersion:le.version,publisherDisplayName:le.publisher,activationEvents:le.activationEvents?le.activationEvents.join(","):null,isBuiltin:le.isBuiltin,reason:V.activationEvent,reasonId:V.extensionId.value}}function ue(le){return le.getAllExtensionDescriptions().map(V=>V.identifier.value).join(",")}e.$djc=(0,u.$gi)("IExtHostExtensionService");class ve{#e;#t;#i;constructor(V,_,ke,Le,Ee){this.#e=V,this.#t=_,this.#i=ke.identifier,this.id=ke.identifier.value,this.extensionUri=ke.extensionLocation,this.extensionPath=M.$hc((0,F.$Hg)(ke.extensionLocation)),this.packageJSON=ke,this.extensionKind=Le,this.isFromDifferentExtensionHost=Ee}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$ejc=ve;function re(le,V){return le.getAllExtensionDescriptions().filter(_=>V.has(_.identifier))}class $e{constructor(V){this.a=V}setSearchTree(V){this.a=V}findSubstr(V){return this.a.findSubstr(V)}forEach(V){return this.a.forEach(V)}}e.$fjc=$e;class ie{constructor(V){this.a=new n.$Cm,this.addActivationEvents(V)}readActivationEvents(V){return this.a.get(V.identifier)??[]}addActivationEvents(V){for(const _ of Object.keys(V))this.a.set(_,V[_])}}}),define(Pe[290],Re([1,0,89,2,4,37,22,20,17,27,3,38,13,15]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$nkc=void 0;let s=class{constructor(c,d,t,p,u,o,v){this.c=c,this.d=d,this.e=t,this.f=p,this.g=u,this.h=o,this.i=v,this.a=new Map,this.b=[]}async install(){this.j(),S.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();S.mark("code/extHost/didWaitForConfig");const d=await this.g.getExtensionPathIndex();this.register(new r(this.c,d,this.d,c,this.i)),this.register(this.e.createInstance(a)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,d,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const d of c.nodeModuleName)this.a.set(d,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(d=>c.alternativeModuleName(d))}};e.$nkc=s,e.$nkc=s=Qe([qe(2,N.$fi),qe(3,F.$Eic),qe(4,D.$djc),qe(5,E.$FO),qe(6,l.$Aj)],s);let a=class{static{g=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&g.a.size){const d=(0,k.$Ye)(this.c(c.environment.appRoot.fsPath)),t="[a-z0-9_.-]",p=`@${t}+\\/${t}+|${t}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${d}/${u}\\/)(${p})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const d=this.b.exec(this.c(c));if(!d)return;const[,t,p,u]=d,o=g.a.get(p);if(o!==void 0)return console.warn(`${p} as been renamed to ${o}, please update your imports`),t+o+u}c(c){return c.replace(/\\/g,"/")}};a=g=Qe([qe(0,E.$FO)],a);class r{constructor(c,d,t,p,u){this.c=c,this.d=d,this.e=t,this.f=p,this.g=u,this.nodeModuleName="vscode",this.a=new m.$Cm}load(c,d){const t=this.d.findSubstr(d);if(t){let p=this.a.get(t.identifier);return p||(p=this.c(t,this.e,this.f),this.a.set(t.identifier,p)),p}if(!this.b){let p="";this.d.forEach((u,o)=>p+=`	${o} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${d}. These are the extension path mappings: 
${p}`),this.b=this.c(R.$UF,this.e,this.f)}return this.b}}let i=class{constructor(c,d,t){this.e=c,this.f=d,this.nodeModuleName=["open","opn"],this.d=t.getProxy(P.$0L.MainThreadTelemetry);const p=t.getProxy(P.$0L.MainThreadWindow);this.c=(u,o)=>{const v=M.URI.parse(u);return o?this.g(u,o):v.scheme==="http"||v.scheme==="https"?p.$openUri(v,u,{allowTunneling:!0}):v.scheme==="mailto"||v.scheme===this.f?p.$openUri(v,u,{}):this.g(u,o)}}load(c,d,t){const p=this.e.findSubstr(d);return p&&(this.a=p.identifier.value,this.h()),this.b=t(c),this.c}g(c,d){return this.i(),this.b(c,d)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Qe([qe(2,f.$pO)],i)}),define(Pe[119],Re([1,0,39,6,19,73,3,67,65,38,7,36,218,37]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hjc=e.$gjc=void 0,e.$gjc=(0,R.$gi)("IExtHostVariableResolverProvider");class g extends l.$rP{constructor(r,i,n,c,d,t,p){function u(){if(n){const o=n.activeEditor();if(o)return o.document.uri;const v=c.tabGroups.all.find(b=>b.isActive)?.activeTab;if(v!==void 0){if(v.input instanceof N.$UN||v.input instanceof N.$ZN)return v.input.modified;if(v.input instanceof N.$TN||v.input instanceof N.$YN||v.input instanceof N.$WN)return v.input.uri}}}super({getFolderUri:o=>{const v=t.folders.filter(b=>b.name===o);if(v&&v.length>0)return v[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(o,v)=>d.getConfiguration(void 0,o).get(v),getAppRoot:()=>F.cwd(),getExecPath:()=>F.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=u();if(o)return P.$hc(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const o=u();if(o){const v=i.getWorkspaceFolder(o);if(v)return P.$hc(v.uri.fsPath)}}},getSelectedText:()=>{if(n){const o=n.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(n){const o=n.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>r.getExtension(o)},void 0,p?Promise.resolve(p):void 0,Promise.resolve(F.env))}}let s=class extends M.$Tc{constructor(r,i,n,c,d){super(),this.b=r,this.c=i,this.g=n,this.h=c,this.j=d,this.a=new S.$V(async()=>{const t=await this.h.getConfigProvider(),u={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{u.folders=await this.c.getWorkspaceFolders2()||[]})),new g(this.b,this.c,this.g,this.j,t,u,this.m())})}getResolver(){return this.a.value}m(){}};e.$hjc=s,e.$hjc=s=Qe([qe(0,E.$djc),qe(1,D.$Bic),qe(2,m.$AO),qe(3,k.$Eic),qe(4,f.$Qic)],s)}),define(Pe[120],Re([1,0,11,5,2,20,3,4,65,38,17,7,36,210,212,37,119,6,40,31,8]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g,s,a,r,i,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mjc=e.$ljc=e.$kjc=e.$jjc=e.$ijc=void 0,e.$ijc=(0,R.$gi)("IExtHostDebugService");let d=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor($,I,h,y,w,A,L){this.N=I,this.O=h,this.P=y,this.Q=w,this.R=A,this.S=L,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new M.$6d,this.o=new M.$6d,this.q=new M.$6d,this.w=new M.$6d,this.l=$.getProxy(m.$0L.MainThreadDebugService),this.A=new M.$6d,this.C=new M.$6d,this.y=new p(this.l),this.z=new Map,this.O.getExtensionRegistry().then(J=>{J.onDidChange(W=>{this.V(J)}),this.V(J)})}async $getVisualizerTreeItem($,I){const h=this.W(I);if(!h)return;const y=await this.H.get($)?.getTreeItem?.(h);return y?this.U($,y):void 0}registerDebugVisualizationTree($,I,h){const y=F.$Am.toKey($.identifier),w=this.jb(y,I);if(this.G.has(w))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this.H.set(w,h),this.l.$registerDebugVisualizerTree(w,!!h.editItem),(0,r.$Rc)(()=>{this.l.$unregisterDebugVisualizerTree(w),this.H.delete(I)})}async $getVisualizerTreeItemChildren($,I){const h=this.J.get(I)?.item;return h?(await this.H.get($)?.getChildren?.(h))?.map(w=>this.U($,w))||[]:[]}async $editVisualizerTreeItem($,I){const h=this.J.get($);if(!h)return;const y=await this.H.get(h.provider)?.editItem?.(h.item,I);return this.U(h.provider,y||h.item)}$disposeVisualizedTree($){const I=this.J.get($);if(!I)return;const h=[I.children];for(const y of h)if(y)for(const w of y)h.push(this.J.get(w)?.children),this.J.delete(w)}U($,I){let h=this.I.get(I);return h||(h=this.F++,this.I.set(I,h),this.J.set(h,{provider:$,item:I})),c.DebugTreeItem.from(I,h)}asDebugSourceUri($,I){const h=$;if(typeof h.sourceReference=="number"&&h.sourceReference>0){let y=`debug:${encodeURIComponent(h.path||"")}`,w="?";return I&&(y+=`${w}session=${encodeURIComponent(I.id)}`,w="&"),y+=`${w}ref=${h.sourceReference}`,P.URI.parse(y)}else{if(h.path)return P.URI.file(h.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V($){const I=[];for(const h of $.getAllExtensionDescriptions())if(h.contributes){const y=h.contributes.debuggers;if(y&&y.length>0)for(const w of y)(0,g.$zG)(w)&&I.push(w.type)}this.l.$registerDebugTypes(I)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const $=[];return this.z.forEach(I=>$.push(I)),$}async $resolveDebugVisualizer($,I){const h=this.L.get($);if(!h)throw new Error(`No debug visualizer found with id '${$}'`);let{v:y,provider:w,extensionId:A}=h;if(y.visualization||(y=await w.resolveDebugVisualization?.(y,I)||y,h.v=y),!y.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${w}'`);return this.kb(A,y.visualization)}async $executeDebugVisualizerCommand($){const I=this.L.get($);if(!I)throw new Error(`No debug visualizer found with id '${$}'`);const h=I.v.visualization;h&&"command"in h&&this.S.executeCommand(h.command,...h.arguments||[])}W($){const I=this.m.get($.sessionId);return I&&{session:I.api,variable:$.variable,containerId:$.containerId,frameId:$.frameId,threadId:$.threadId}}async $provideDebugVisualizers($,I,h,y){const w=this.W(h),A=this.jb($,I),L=this.G.get(A);if(!w||!L)return[];const J=await L.provideDebugVisualization(w,y);return J?J.map(W=>{const U=++this.M;this.L.set(U,{v:W,provider:L,extensionId:$});const C=W.iconPath?this.lb(W.iconPath):void 0;return{id:U,name:W.name,iconClass:C?.iconClass,iconPath:C?.iconPath,visualization:this.kb($,W.visualization)}}):[]}$disposeDebugVisualizers($){for(const I of $)this.L.delete(I)}registerDebugVisualizationProvider($,I,h){if(!$.contributes?.debugVisualizers?.some(A=>A.id===I))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${I})`);const y=F.$Am.toKey($.identifier),w=this.jb(y,I);if(this.G.has(w))throw new Error(`A debug visualization provider with id '${I}' is already registered`);return this.G.set(w,h),this.l.$registerDebugVisualizer(y,I),(0,r.$Rc)(()=>{this.l.$unregisterDebugVisualizer(y,I),this.G.delete(I)})}addBreakpoints($){const I=$.filter(w=>{const A=w.id;return this.z.has(A)?!1:(this.z.set(A,w),!0)});this.gb(I,[],[]);const h=[],y=new Map;for(const w of I)if(w instanceof D.$_M){let A=y.get(w.location.uri.toString());A||(A={type:"sourceMulti",uri:w.location.uri,lines:[]},y.set(w.location.uri.toString(),A),h.push(A)),A.lines.push({id:w.id,enabled:w.enabled,condition:w.condition,hitCondition:w.hitCondition,logMessage:w.logMessage,line:w.location.range.start.line,character:w.location.range.start.character,mode:w.mode})}else w instanceof D.$aN&&h.push({type:"function",id:w.id,enabled:w.enabled,hitCondition:w.hitCondition,logMessage:w.logMessage,condition:w.condition,functionName:w.functionName,mode:w.mode});return this.l.$registerBreakpoints(h)}removeBreakpoints($){const I=$.filter(A=>this.z.delete(A.id));this.gb([],I,[]);const h=I.filter(A=>A instanceof D.$_M).map(A=>A.id),y=I.filter(A=>A instanceof D.$aN).map(A=>A.id),w=I.filter(A=>A instanceof D.$bN).map(A=>A.id);return this.l.$unregisterBreakpoints(h,y,w)}startDebugging($,I,h){return this.l.$startDebugging($?$.uri:void 0,I,{parentSessionID:h.parentSession?h.parentSession.id:void 0,lifecycleManagedByParent:h.lifecycleManagedByParent,repl:h.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:h.noDebug,compact:h.compact,suppressSaveBeforeStart:h.suppressSaveBeforeStart,suppressDebugStatusbar:h.suppressDebugStatusbar??h.debugUI?.simple,suppressDebugToolbar:h.suppressDebugToolbar??h.debugUI?.simple,suppressDebugView:h.suppressDebugView??h.debugUI?.simple})}stopDebugging($){return this.l.$stopDebugging($?$.id:void 0)}registerDebugConfigurationProvider($,I,h){if(!I)return new D.$_L(()=>{});const y=this.d++;return this.f.push({type:$,handle:y,provider:I}),this.l.$registerDebugConfigurationProvider($,h,!!I.provideDebugConfigurations,!!I.resolveDebugConfiguration,!!I.resolveDebugConfigurationWithSubstitutedVariables,y),new D.$_L(()=>{this.f=this.f.filter(w=>w.provider!==I),this.l.$unregisterDebugConfigurationProvider(y)})}registerDebugAdapterDescriptorFactory($,I,h){if(!h)return new D.$_L(()=>{});if(!this.cb($,I))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${I}' debugger.`);if(this.$(I))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const y=this.g++;return this.h.push({type:I,handle:y,factory:h}),this.l.$registerDebugAdapterDescriptorFactory(I,y),new D.$_L(()=>{this.h=this.h.filter(w=>w.factory!==h),this.l.$unregisterDebugAdapterDescriptorFactory(y)})}registerDebugAdapterTrackerFactory($,I){if(!I)return new D.$_L(()=>{});const h=this.j++;return this.k.push({type:$,handle:h,factory:I}),new D.$_L(()=>{this.k=this.k.filter(y=>y.factory!==I)})}async $runInTerminal($,I){return Promise.resolve(void 0)}async $substituteVariables($,I){let h;const y=await this.ib($);return y&&(h={uri:y.uri,name:y.name,index:y.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(h,I)}X($,I){if($.type==="implementation")return new o($.implementation)}Y(){}async $startDASession($,I){const h=this,y=await this.hb(I);return this.eb(this.$(y.type),y).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}' (extension might have failed to activate)`);const A=this.Z(w),L=this.X(A,y);if(!L)throw new Error(`Couldn't create a debug adapter for type '${y.type}'.`);const J=L;return this.D.set($,J),this.db(y).then(W=>(W&&this.E.set($,W),J.onMessage(async U=>{if(U.type==="request"&&U.command==="handshake"){const C=U,O={type:"response",seq:0,command:C.command,request_seq:C.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const q=await this.K.sign(C.arguments.value);O.body={signature:q},J.sendResponse(O)}else throw new Error("no signer")}catch(q){O.success=!1,O.message=q.message,J.sendResponse(O)}}else W&&W.onDidSendMessage&&W.onDidSendMessage(U),U=(0,g.$EG)(U,!0),h.l.$acceptDAMessage($,U)}),J.onError(U=>{W&&W.onError&&W.onError(U),this.l.$acceptDAError($,U.name,U.message,U.stack)}),J.onExit(U=>{W&&W.onExit&&W.onExit(U??void 0,void 0),this.l.$acceptDAExit($,U??void 0,void 0)}),W&&W.onWillStartSession&&W.onWillStartSession(),J.startSession()))})}$sendDAMessage($,I){I=(0,g.$DG)(I,!1);const h=this.E.get($);h&&h.onWillReceiveMessage&&h.onWillReceiveMessage(I),this.D.get($)?.sendMessage(I)}$stopDASession($){const I=this.E.get($);this.E.delete($),I&&I.onWillStopSession&&I.onWillStopSession();const h=this.D.get($);return this.D.delete($),h?h.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta($){const I=[],h=[],y=[];if($.added)for(const w of $.added){const A=w.id;if(A&&!this.z.has(A)){let L;if(w.type==="function")L=new D.$aN(w.functionName,w.enabled,w.condition,w.hitCondition,w.logMessage,w.mode);else if(w.type==="data")L=new D.$bN(w.label,w.dataId,w.canPersist,w.enabled,w.hitCondition,w.condition,w.logMessage,w.mode);else{const J=P.URI.revive(w.uri);L=new D.$_M(new D.$lM(J,new D.$aM(w.line,w.character)),w.enabled,w.condition,w.hitCondition,w.logMessage,w.mode)}(0,D.$0M)(L,A),this.z.set(A,L),I.push(L)}}if($.removed)for(const w of $.removed){const A=this.z.get(w);A&&(this.z.delete(w),h.push(A))}if($.changed){for(const w of $.changed)if(w.id){const A=this.z.get(w.id);if(A){if(A instanceof D.$aN&&w.type==="function"){const L=A;L.enabled=w.enabled,L.condition=w.condition,L.hitCondition=w.hitCondition,L.logMessage=w.logMessage,L.functionName=w.functionName}else if(A instanceof D.$_M&&w.type==="source"){const L=A;L.enabled=w.enabled,L.condition=w.condition,L.hitCondition=w.hitCondition,L.logMessage=w.logMessage,L.location=new D.$lM(P.URI.revive(w.uri),new D.$aM(w.line,w.character))}y.push(A)}}}this.gb(I,h,y)}async $acceptStackFrameFocus($){let I;if($){const h=await this.hb($.sessionId);$.kind==="thread"?I=new D.$hN(h.api,$.threadId):I=new D.$gN(h.api,$.threadId,$.frameId)}this.B=I,this.C.fire(this.B)}$provideDebugConfigurations($,I,h){return(0,S.$$g)(async()=>{const y=this.bb($);if(!y)throw new Error("no DebugConfigurationProvider found");if(!y.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const w=await this.ib(I);return y.provideDebugConfigurations(w,h)}).then(y=>{if(!y)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return y})}$resolveDebugConfiguration($,I,h,y){return(0,S.$$g)(async()=>{const w=this.bb($);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const A=await this.ib(I);return w.resolveDebugConfiguration(A,h,y)})}$resolveDebugConfigurationWithSubstitutedVariables($,I,h,y){return(0,S.$$g)(async()=>{const w=this.bb($);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const A=await this.ib(I);return w.resolveDebugConfigurationWithSubstitutedVariables(A,h,y)})}async $provideDebugAdapter($,I){const h=this.ab($);if(!h)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const y=await this.hb(I);return this.eb(h,y).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${y.type}'`);return this.Z(w)})}async $acceptDebugSessionStarted($){const I=await this.hb($);this.n.fire(I.api)}async $acceptDebugSessionTerminated($){const I=await this.hb($);I&&(this.o.fire(I.api),this.m.delete(I.id))}async $acceptDebugSessionActiveChanged($){this.u=$?await this.hb($):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged($,I){(await this.hb($))?._acceptNameChanged(I)}async $acceptDebugSessionCustomEvent($,I){const y={session:(await this.hb($)).api,event:I.event,body:I.body};this.w.fire(y)}Z($){if($ instanceof D.$cN)return{type:"executable",command:$.command,args:$.args,options:$.options};if($ instanceof D.$dN)return{type:"server",port:$.port,host:$.host};if($ instanceof D.$eN)return{type:"pipeServer",path:$.path};if($ instanceof D.$fN)return{type:"implementation",implementation:$.implementation};throw new Error("convertToDto unexpected type")}$($){const I=this.h.filter(h=>h.type===$);if(I.length>0)return I[0].factory}ab($){const I=this.h.filter(h=>h.handle===$);if(I.length>0)return I[0].factory}bb($){const I=this.f.filter(h=>h.handle===$);if(I.length>0)return I[0].provider}cb($,I){if($.contributes){const h=$.contributes.debuggers;if(h&&h.length>0){for(const y of h)if(y.label&&y.type&&y.type===I)return!0}}return!1}db($){const h=$.configuration.type,y=this.k.filter(w=>w.type===h||w.type==="*").map(w=>(0,S.$$g)(()=>w.factory.createDebugAdapterTracker($.api)).then(A=>A,A=>null));return Promise.race([Promise.all(y).then(w=>{const A=w.filter(L=>!!L);if(A.length>0)return new u(A)}),new Promise(w=>setTimeout(()=>w(void 0),1e3))]).catch(w=>{})}async eb($,I){const h=I.configuration.debugServer;if(typeof h=="number")return Promise.resolve(new D.$dN(h));if($){const w=await this.O.getExtensionRegistry();return(0,S.$$g)(()=>$.createDebugAdapterDescriptor(I.api,this.fb(I,w))).then(A=>{if(A)return A})}const y=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(I,y))}fb($,I){}gb($,I,h){($.length>0||I.length>0||h.length>0)&&this.A.fire(Object.freeze({added:$,removed:I,changed:h}))}async hb($){if($)if(typeof $=="string"){const I=this.m.get($);if(I)return I}else{let I=this.m.get($.id);if(!I){const h=await this.ib($.folderUri),y=$.parent?this.m.get($.parent):void 0;I=new t(this.l,$.id,$.type,$.name,h,$.configuration,y?.api),this.m.set(I.id,I),this.l.$sessionCached(I.id)}return I}throw new Error("cannot find session")}ib($){if($){const I=P.URI.revive($);return this.N.resolveWorkspaceFolder(I)}return Promise.resolve(void 0)}jb($,I){return`${$}\0${I}`}kb($,I){if(I){if("title"in I&&"command"in I)return{type:0};if("treeId"in I)return{type:1,id:`${$}\0${I.treeId}`};throw new Error("Unsupported debug visualization type")}}lb($){const I=this.mb($);let h,y;return"id"in I?y=i.ThemeIcon.asClassName(I):h=I,{iconPath:h,iconClass:y}}mb($){if($ instanceof D.$7M)return{id:$.id};const I=typeof $=="object"&&"dark"in $?$.dark:$,h=typeof $=="object"&&"light"in $?$.light:$;return{dark:typeof I=="string"?P.URI.file(I):I,light:typeof h=="string"?P.URI.file(h):h}}};e.$jjc=d,e.$jjc=d=Qe([qe(0,N.$pO),qe(1,l.$Bic),qe(2,E.$djc),qe(3,s.$Eic),qe(4,f.$Qic),qe(5,a.$gjc),qe(6,n.$LO)],d);class t{constructor($,I,h,y,w,A,L){this.f=$,this.g=I,this.h=h,this.j=y,this.k=w,this.l=A,this.m=L}get api(){const $=this;return this.d??=Object.freeze({id:$.g,type:$.h,get name(){return $.j},set name(I){$.j=I,$.f.$setDebugSessionName($.g,I)},parentSession:$.m,workspaceFolder:$.k,configuration:$.l,customRequest(I,h){return $.f.$customDebugAdapterRequest($.g,I,h)},getDebugProtocolBreakpoint(I){return $.f.$getDebugProtocolBreakpoint($.g,I.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged($){this.j=$}get configuration(){return this.l}}e.$kjc=t;class p{constructor($){this.value=Object.freeze({append(I){$.$appendDebugConsole(I)},appendLine(I){this.append(I+`
`)}})}}e.$ljc=p;class u{constructor($){this.d=$}onWillStartSession(){this.d.forEach($=>$.onWillStartSession?$.onWillStartSession():void 0)}onWillReceiveMessage($){this.d.forEach(I=>I.onWillReceiveMessage?I.onWillReceiveMessage($):void 0)}onDidSendMessage($){this.d.forEach(I=>I.onDidSendMessage?I.onDidSendMessage($):void 0)}onWillStopSession(){this.d.forEach($=>$.onWillStopSession?$.onWillStopSession():void 0)}onError($){this.d.forEach(I=>I.onError?I.onError($):void 0)}onExit($,I){this.d.forEach(h=>h.onExit?h.onExit($,I):void 0)}}class o extends k.$Pnb{constructor($){super(),this.h=$,$.onDidSendMessage(I=>{this.acceptMessage(I)})}startSession(){return Promise.resolve(void 0)}sendMessage($){this.h.handleMessage($)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let v=class extends d{constructor($,I,h,y,w,A,L){super($,I,h,y,w,A,L)}};e.$mjc=v,e.$mjc=v=Qe([qe(0,N.$pO),qe(1,l.$Bic),qe(2,E.$djc),qe(3,s.$Eic),qe(4,f.$Qic),qe(5,a.$gjc),qe(6,n.$LO)],v)}),define(Pe[291],Re([1,0,14,89,2,4,239,13,54,71,27,188,17,59,38,61]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pkc=e.$okc=void 0;class a{static async installEarlyHandler(n){Error.stackTraceLimit=100;const c=n.get(m.$Aj),t=n.get(l.$pO).getProxy(F.$0L.MainThreadErrors);S.setUnexpectedErrorHandler(p=>{c.error(p);const u=S.$3(p);t.$onUnexpectedError(u)})}static async installFullHandler(n){const c=n.get(m.$Aj),d=n.get(l.$pO),t=n.get(g.$djc),p=n.get(s.$JO),u=d.getProxy(F.$0L.MainThreadExtensionService),o=d.getProxy(F.$0L.MainThreadErrors),v=await t.getExtensionPathIndex(),b=new WeakMap;function $(y,w){if(b.has(y))return b.get(y).stack;let A="",L,J;for(const U of w)A+=`
	at ${U.toString()}`,J=U.getFileName(),!L&&J&&(L=v.findSubstr(P.URI.file(J)));const W=`${y.name||"Error"}: ${y.message||""}${A}`;return b.set(y,{extensionIdentifier:L?.identifier,stack:W}),W}const I=Symbol("prepareStackTrace wrapped");let h=$;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return h},set(y){if(y===$||!y||y[I]){h=y||$;return}h=function(w,A){return $(w,A),y.call(Error,w,A)},Object.assign(h,{[I]:!0})}}),S.setUnexpectedErrorHandler(y=>{c.error(y);const w=S.$3(y),A=b.get(y);if(!A?.extensionIdentifier){o.$onUnexpectedError(w);return}u.$onExtensionRuntimeError(A.extensionIdentifier,w);const L=p.onExtensionError(A.extensionIdentifier,y);c.trace("forwarded error to extension?",L,A)})}}e.$okc=a;class r{constructor(n,c,d,t,p){this.a=d,this.b=new R.$i0b(n,null,t),c=r.e(c,this.b);const u=new E.$ei(...(0,f.$cs)());u.set(N.$FO,{_serviceBrand:void 0,...c,messagePorts:p}),u.set(l.$pO,new l.$qO(this.b)),u.set(k.$yic,new k.$zic(t)),u.set(g.$bjc,d);const o=new D.$Tq(u,!0);o.invokeFunction(a.installEarlyHandler),this.d=o.invokeFunction(v=>v.get(m.$Aj)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=o.invokeFunction(v=>v.get(g.$djc)),this.c.initialize(),o.invokeFunction(a.installFullHandler)}async asBrowserUri(n){const c=this.b.getProxy(F.$0L.MainThreadExtensionService);return P.URI.revive(await c.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,c){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=P.URI.revive(c.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=P.URI.revive(c.transformIncomingURIs(n.environment.appRoot));const d=n.environment.extensionDevelopmentLocationURI;return d&&(n.environment.extensionDevelopmentLocationURI=d.map(t=>P.URI.revive(c.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=P.URI.revive(c.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=P.URI.revive(c.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=P.URI.revive(c.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=P.URI.revive(c.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=P.URI.revive(c.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=P.URI.revive(c.transformIncomingURIs(n.logsLocation)),n.workspace=c.transformIncomingURIs(n.workspace),n}}e.$pkc=r}),define(Pe[292],Re([1,0,18,11,25,41,12,19,24,2,44]),function(me,e,S,M,P,F,R,m,f,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Djc=e.$Cjc=e.$Bjc=e.$Ajc=void 0;class D{constructor(i,n,c){this.d=i,this.e=n,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(i,n){const c=this.g.folderQueries||[],d=new P.$de(n);return new Promise((t,p)=>{this.a=new k(i);let u=!1;const o=(v,b)=>{if(!u&&!this.b){const $=this.h(v);s(v)&&typeof this.g.maxResults=="number"&&this.c+$>this.g.maxResults&&(this.b=!0,u=!0,d.cancel(),v=this.j(v,this.g.maxResults-this.c));const I=this.h(v);this.c+=I,(I>0||!s(v))&&this.a.add(v,b)}};Promise.all(c.map((v,b)=>this.k(v,$=>o($,b),d.token))).then(v=>{d.dispose(),this.a.flush();const b=v.some($=>!!$&&!!$.limitHit);t({limitHit:this.b||b,messages:(0,S.$Rb)(v.map($=>$?.message?Array.isArray($.message)?$.message:[$.message]:[])),stats:{type:this.f}})},v=>{d.dispose();const b=(0,F.$4i)(v);p(new Error(b))})})}h(i){return s(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const c=Array.isArray(i.ranges)?i.ranges:[i.ranges],d=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:c.slice(0,n),preview:{matches:d.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,c){const d=new N.$IK(this.g,i),t=[],p={report:v=>{if(!this.l(v))return;const b=i.folder.scheme===R.Schemas.file?(0,N.$JK)(()=>this.e.readdir(f.$Sg(v.uri))):void 0,$=f.$Vg(i.folder,v.uri);if($){const I=d.includedInQuery($,m.$nc($),b);(0,M.$5g)(I)?t.push(I.then(h=>{h&&n(v)})):I&&n(v)}}},u=this.n(i);let o;return this.d.query.type===3?o=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,u,p,c):o=await this.d.provider.provideTextSearchResults(l(this.d.query.contentPattern),u,p,c),t.length&&await Promise.all(t),o}l(i){if(s(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,N.$HK)(this.g.includePattern,i.includePattern),c=(0,N.$HK)(this.g.excludePattern,i.excludePattern),d={folder:E.URI.from(i.folder),excludes:c,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.e.toCanonicalName(i.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(d.usePCRE2=this.g.usePCRE2),d}}e.$Ajc=D;function l(r){return{isCaseSensitive:r.isCaseSensitive||!1,isRegExp:r.isRegExp||!1,isWordMatch:r.isWordMatch||!1,isMultiline:r.isMultiline||!1,pattern:r.pattern}}class k{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new a(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!f.$Mg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(g(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$Bjc=k;function g(r){return s(r)?{preview:{matches:(0,S.$2b)(r.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:r.preview.text},ranges:(0,S.$2b)(r.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:r.text,lineNumber:r.lineNumber}}function s(r){return!!r.preview}e.$Cjc=s;class a{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<a.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},a.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Djc=a}),define(Pe[121],Re([1,0,6,4,3,287,17,59,13,2,292]),function(me,e,S,M,P,F,R,m,f,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gjc=e.$Fjc=e.$Ejc=void 0,e.$Ejc=(0,P.$gi)("IExtHostSearch");let D=class{constructor(s,a,r){this.n=s,this.o=a,this.q=r,this.c=this.n.getProxy(M.$0L.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new F.$zjc}s(s){return this.o.transformOutgoingScheme(s)}registerTextSearchProvider(s,a){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const r=this.d++;return this.e.set(r,a),this.c.$registerTextSearchProvider(r,this.s(s)),(0,S.$Rc)(()=>{this.g.delete(s),this.e.delete(r),this.c.$unregisterProvider(r)})}registerAITextSearchProvider(s,a){if(this.i.has(s))throw new Error(`an AI text search provider for the scheme '${s}'is already registered`);this.i.add(s);const r=this.d++;return this.h.set(r,a),this.c.$registerAITextSearchProvider(r,this.s(s)),(0,S.$Rc)(()=>{this.i.delete(s),this.h.delete(r),this.c.$unregisterProvider(r)})}registerFileSearchProvider(s,a){if(this.k.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.k.add(s);const r=this.d++;return this.j.set(r,a),this.c.$registerFileSearchProvider(r,this.s(s)),(0,S.$Rc)(()=>{this.k.delete(s),this.j.delete(r),this.c.$unregisterProvider(r)})}$provideFileSearchResults(s,a,r,i){const n=l(r),c=this.j.get(s);if(c)return this.l.fileSearch(n,c,d=>{this.c.$handleFileMatch(s,a,d.map(t=>t.resource))},i);throw new Error("3 unknown provider: "+s)}async doInternalFileSearchWithCustomCallback(s,a,r){return{messages:[]}}$clearCache(s){return this.l.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,a,r,i){const n=this.e.get(s);if(!n||!n.provideTextSearchResults)throw new Error(`2 Unknown provider ${s}`);const c=l(r);return this.t(c,n).search(t=>this.c.$handleTextMatch(s,a,t),i)}$provideAITextSearchResults(s,a,r,i){const n=this.h.get(s);if(!n||!n.provideAITextSearchResults)throw new Error(`1 Unknown provider ${s}`);const c=l(r);return this.v(c,n).search(t=>this.c.$handleTextMatch(s,a,t),i)}$enableExtensionHostSearch(){}t(s,a){return new N.$Ajc({query:s,provider:a},{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"textSearchProvider")}v(s,a){return new N.$Ajc({query:s,provider:a},{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"aiTextSearchProvider")}};e.$Fjc=D,e.$Fjc=D=Qe([qe(0,R.$pO),qe(1,m.$yic),qe(2,f.$Aj)],D);function l(g){return{...g,folderQueries:g.folderQueries&&g.folderQueries.map(k),extraFileResources:g.extraFileResources&&g.extraFileResources.map(s=>E.URI.revive(s))}}e.$Gjc=l;function k(g){return{...g,folder:E.URI.revive(g.folder)}}}),define(Pe[293],Re([1,0,25,14,5,6,12,32,2,149,145,133,94,20,42,13,57,58,201,4,242,271,78,84,248,227,249,88,250,228,216,31,251,37,252,120,110,253,230,243,254,255,67,65,244,38,257,63,258,43,27,272,273,245,231,259,260,79,80,233,286,262,205,263,274,264,115,234,265,266,267,17,268,121,81,269,235,270,82,85,118,61,66,275,276,246,277,278,86,8,7,236,59,237,62,279,280,109,36,211,77,22,117]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g,s,a,r,i,n,c,d,t,p,u,o,v,b,$,I,h,y,w,A,L,J,W,U,C,O,q,ne,ce,ye,Ie,ue,ve,re,$e,ie,le,V,_,ke,Le,Ee,be,ge,G,Y,he,fe,Oe,de,Ce,Ae,ze,z,j,K,H,ee,se,Ne,Ve,He,xe,tt,lt,rt,it,ot,Be,et,X,Z,pe,We,Ze,st,Me,Dt,Qt,jt,si,Vt,St,Yt,Wt,oi,xt,Ye,Ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jkc=void 0;function _t(dt){const $t=dt.get(le.$FO),ei=dt.get(ie.$gic),qt=dt.get(re.$Gic),Ht=dt.get(ue.$djc),ht=dt.get(Wt.$Bic),Mt=dt.get(ot.$JO),ti=dt.get(A.$Eic),ii=dt.get(Qt.$yic),Ke=dt.get(ee.$pO),Nt=dt.get(lt.$Zic),zt=dt.get(rt.$Hic),Zt=dt.get(s.$Bj),mt=dt.get(s.$Aj),It=dt.get(Ze.$BAb),Ct=dt.get(t.$cic),Lt=dt.get(Yt.$ikc),ai=dt.get(Ve.$8ic),Ut=dt.get(ye.$Qic),Xt=dt.get(G.$_ic),bt=dt.get(p.$mic),Ft=dt.get(b.$ric);Ke.set(n.$$L.ExtHostFileSystemInfo,ei),Ke.set(n.$$L.ExtHostLogLevelServiceShape,Zt),Ke.set(n.$$L.ExtHostWorkspace,ht),Ke.set(n.$$L.ExtHostConfiguration,ti),Ke.set(n.$$L.ExtHostExtensionService,Ht),Ke.set(n.$$L.ExtHostStorage,Nt),Ke.set(n.$$L.ExtHostTunnelService,It),Ke.set(n.$$L.ExtHostWindow,Lt),Ke.set(n.$$L.ExtHostSecretState,ai),Ke.set(n.$$L.ExtHostTelemetry,Mt),Ke.set(n.$$L.ExtHostEditorTabs,Ut),Ke.set(n.$$L.ExtHostManagedSockets,Xt),Ke.set(n.$$L.ExtHostAuthentication,bt),Ke.set(n.$$L.ExtHostChatProvider,Ft);const Bt=Ke.set(n.$$L.ExtHostDecorations,dt.get(W.$ojc)),Tt=Ke.set(n.$$L.ExtHostDocumentsAndEditors,dt.get(ce.$AO)),wt=Ke.set(n.$$L.ExtHostCommands,dt.get(y.$LO)),Pt=Ke.set(n.$$L.ExtHostTerminalService,dt.get(Be.$3ic)),kt=Ke.set(n.$$L.ExtHostDebugService,dt.get(J.$ijc)),li=Ke.set(n.$$L.ExtHostSearch,dt.get(Ne.$Ejc)),Kt=Ke.set(n.$$L.ExtHostTask,dt.get(it.$8jc)),ni=Ke.set(n.$$L.ExtHostOutputService,dt.get(ze.$Ujc)),we=Ke.set(n.$$L.ExtHostLocalization,dt.get(ge.$$ic)),Fe=Ke.set(n.$$L.ExtHostUrls,new jt.$fkc(Ke)),oe=Ke.set(n.$$L.ExtHostDocuments,new ne.$jic(Ke,Tt)),Q=Ke.set(n.$$L.ExtHostDocumentContentProviders,new O.$qjc(Ke,Tt,mt)),De=Ke.set(n.$$L.ExtHostDocumentSaveParticipant,new q.$rjc(mt,oe,Ke.getProxy(n.$0L.MainThreadBulkEdits))),Te=Ke.set(n.$$L.ExtHostNotebook,new he.$Hjc(Ke,wt,Tt,oe,qt,li)),Xe=Ke.set(n.$$L.ExtHostNotebookDocuments,new Oe.$Ojc(Te)),Ge=Ke.set(n.$$L.ExtHostNotebookEditors,new de.$Pjc(mt,Te)),ct=Ke.set(n.$$L.ExtHostNotebookKernels,new Ce.$Qjc(Ke,$t,Te,wt,mt)),yt=Ke.set(n.$$L.ExtHostNotebookRenderers,new Ae.$Sjc(Ke,Te)),Gt=Ke.set(n.$$L.ExtHostNotebookDocumentSaveParticipant,new fe.$Njc(mt,Te,Ke.getProxy(n.$0L.MainThreadBulkEdits))),Et=Ke.set(n.$$L.ExtHostEditors,new X.$vic(Ke,Tt)),Rt=Ke.set(n.$$L.ExtHostTreeViews,new We.$dkc(Ke.getProxy(n.$0L.MainThreadTreeViews),wt,mt)),ri=Ke.set(n.$$L.ExtHostEditorInsets,new h.$wic(Ke.getProxy(n.$0L.MainThreadEditorInsets),Et,$t.remote)),wi=Ke.set(n.$$L.ExtHostDiagnostics,new U.$iic(Ke,mt,ei,Tt)),pi=Ke.set(n.$$L.ExtHostLanguages,new be.$Ljc(Ke,oe,wt.converter,ii)),ft=Ke.set(n.$$L.ExtHostLanguageFeatures,new Ee.$kic(Ke,ii,oe,wt,wi,mt,Ct,Mt)),Ai=Ke.set(n.$$L.ExtHostFileSystem,new ve.$tjc(Ke,ft)),hi=Ke.set(n.$$L.ExtHostFileSystemEventService,new $e.$ujc(Ke,mt,Tt)),mi=Ke.set(n.$$L.ExtHostQuickOpen,(0,H.$Yjc)(Ke,ht,wt)),yi=Ke.set(n.$$L.ExtHostSCM,new se.$1jc(Ke,wt,oe,mt)),Qi=Ke.set(n.$$L.ExtHostQuickDiff,new K.$Xjc(Ke,ii)),hn=Ke.set(n.$$L.ExtHostShare,new He.$2jc(Ke,ii)),Zi=Ke.set(n.$$L.ExtHostComments,(0,w.$xic)(Ke,wt,oe)),ki=Ke.set(n.$$L.ExtHostProgress,new j.$Wjc(Ke.getProxy(n.$0L.MainThreadProgress))),Mi=Ke.set(n.$$L.ExtHostLabelService,new Le.$Kjc(Ke)),Fi=Ke.set(n.$$L.ExtHostTheming,new Z.$akc(Ke)),Xi=Ke.set(n.$$L.ExtHostTimeline,new pe.$ckc(Ke,wt)),Ei=Ke.set(n.$$L.ExtHostWebviews,new si.$Lic(Ke,$t.remote,ht,mt,Ct)),Di=Ke.set(n.$$L.ExtHostWebviewPanels,new Vt.$Oic(Ke,Ei,ht)),Yi=Ke.set(n.$$L.ExtHostCustomEditors,new L.$Pic(Ke,oe,zt,Ei,Di)),dn=Ke.set(n.$$L.ExtHostWebviewViews,new St.$gkc(Ke,Ei)),bi=Ke.set(n.$$L.ExtHostTesting,new et.$9jc(Ke,mt,wt,Tt)),Oi=Ke.set(n.$$L.ExtHostUriOpeners,new Dt.$ekc(Ke)),Ni=Ke.set(n.$$L.ExtHostProfileContentHandlers,new z.$Vjc(Ke));Ke.set(n.$$L.ExtHostInteractive,new _.$Ijc(Ke,Te,Tt,wt,mt));const fn=Ke.set(n.$$L.ExtHostInlineChat,new V.$vjc(Ke,wt,oe,mt)),gn=Ke.set(n.$$L.ExtHostChatAgents2,new v.$qic(Ke,mt,wt)),xi=Ke.set(n.$$L.ExtHostChatVariables,new $.$tic(Ke)),_i=Ke.set(n.$$L.ExtHostChat,new o.$pic(Ke)),Si=Ke.set(n.$$L.ExtHostAiRelatedInformation,new c.$bic(Ke)),en=Ke.set(n.$$L.ExtHostAiEmbeddingVector,new Ie.$sjc(Ke)),Li=Ke.set(n.$$L.ExtHostIssueReporter,new ke.$Jjc(Ke)),Ti=Ke.set(n.$$L.ExtHostStatusBar,new tt.$5jc(Ke,wt.converter)),mn=Ke.set(n.$$L.ExtHostSpeech,new xe.$3jc(Ke)),ji=Object.values(n.$$L);Ke.assertRegistered(ji);const tn=new u.$oic(Ke,Tt),fi=new I.$uic(Ke),vi=new Y.$Mjc(Ke,mt),nn=new C.$pjc(Ke);return d.$lic.register(wt),function(je,ci,zi){function nt(x){return(ae,Ue,at)=>{const vt=x(At=>{try{ae.call(Ue,At)}catch(Pi){M.$2(new Error(`[ExtensionListenerError] Extension '${je.identifier.value}' FAILED to handle event: ${Pi.toString()}`,{cause:Pi})),Mt.onExtensionError(je.identifier,Pi)}});return at?.push(vt),vt}}const pt=function(){let x=!je.isUnderDevelopment;function ae(){x||(mt.info(`Extension '${je.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),x=!0)}return function Ue(at){if(Array.isArray(at))at.forEach(Ue);else if(typeof at=="string")ae();else{const vt=at;typeof vt.scheme>"u"&&ae(),typeof vt.exclusive=="boolean"&&(0,Ye.$1F)(je,"documentFiltersExclusive")}return at}}(),rn={getSession(x,ae,Ue){return typeof Ue?.forceNewSession=="object"&&Ue.forceNewSession.learnMore&&(0,Ye.$1F)(je,"authLearnMore"),bt.getSession(je,x,ae,Ue)},getSessions(x,ae){return(0,Ye.$1F)(je,"authGetSessions"),bt.getSessions(je,x,ae)},async hasSession(x,ae){return(0,Ye.$1F)(je,"authSession"),!!await bt.getSession(je,x,ae,{silent:!0})},get onDidChangeSessions(){return nt(bt.onDidChangeSessions)},registerAuthenticationProvider(x,ae,Ue,at){return bt.registerAuthenticationProvider(x,ae,Ue,at)}},$n={registerCommand(x,ae,Ue){return wt.registerCommand(!0,x,ae,Ue,void 0,je)},registerTextEditorCommand(x,ae,Ue){return wt.registerCommand(!0,x,(...at)=>{const vt=Et.getActiveTextEditor();if(!vt){mt.warn("Cannot execute "+x+" because there is no active text editor.");return}return vt.edit(At=>{ae.apply(Ue,[vt,At,...at])}).then(At=>{At||mt.warn("Edits from command "+x+" were not applied.")},At=>{mt.warn("An error occurred while running command "+x,At)})},void 0,void 0,je)},registerDiffInformationCommand:(x,ae,Ue)=>((0,Ye.$1F)(je,"diffCommand"),wt.registerCommand(!0,x,async(...at)=>{const vt=Tt.activeEditor(!0);if(!vt){mt.warn("Cannot execute "+x+" because there is no active text editor.");return}const At=await Et.getDiffInformation(vt.id);ae.apply(Ue,[At,...at])},void 0,void 0,je)),executeCommand(x,...ae){return wt.executeCommand(x,...ae)},getCommands(x=!1){return wt.getCommands(x)}},Ui={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return fi.value},get shell(){return Pt.getDefaultShell(!1)},get onDidChangeShell(){return nt(Pt.onDidChangeShell)},get isTelemetryEnabled(){return Mt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return nt(Mt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.$1F)(je,"telemetry"),Mt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$1F)(je,"telemetry"),nt(Mt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ot.$IO)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(x,ae){return ot.$HO.validateSender(x),Mt.instantiateLogger(je,x,ae)},openExternal(x,ae){return Lt.openUri(x,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:ae?.allowContributedOpeners})},async asExternalUri(x){if(x.scheme===$t.environment.appUriScheme)return Fe.createAppUri(x);try{return await Lt.asExternalUri(x,{allowTunneling:!!$t.remote.authority})}catch(ae){if((0,R.$pg)(x,R.Schemas.http)||(0,R.$pg)(x,R.Schemas.https))return x;throw ae}},get remoteName(){return(0,a.$rm)($t.remote.authority)},get remoteAuthority(){return(0,Ye.$1F)(je,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return mt.getLevel()},get onDidChangeLogLevel(){return nt(mt.onDidChangeLogLevel)},registerIssueUriRequestHandler(x){return(0,Ye.$1F)(je,"handleIssueUri"),Li.registerIssueUriRequestHandler(je,x)},registerIssueDataProvider(x){return(0,Ye.$1F)(je,"handleIssueUri"),Li.registerIssueDataProvider(je,x)},get appQuality(){return(0,Ye.$1F)(je,"resolvers"),$t.quality},get appCommit(){return(0,Ye.$1F)(je,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(Ui);const sn={createTestController(x,ae,Ue){return bi.createTestController(je,x,ae,Ue)},createTestObserver(){return(0,Ye.$1F)(je,"testObserver"),bi.createTestObserver()},runTests(x){return(0,Ye.$1F)(je,"testObserver"),bi.runTests(x)},get onDidChangeTestResults(){return(0,Ye.$1F)(je,"testObserver"),nt(bi.onResultsChanged)},get testResults(){return(0,Ye.$1F)(je,"testObserver"),bi.results}},Ii=$t.remote.isRemote?Me.ExtensionKind.Workspace:Me.ExtensionKind.UI,pn={getExtension(x,ae){(0,Ye.$ZF)(je,"extensionsAny")||(ae=!1);const Ue=ci.mine.getExtensionDescription(x);if(Ue)return new ue.$ejc(Ht,je.identifier,Ue,Ii,!1);if(ae){const at=ci.all.getExtensionDescription(x);if(at)return new ue.$ejc(Ht,je.identifier,at,Ii,!0)}},get all(){const x=[];for(const ae of ci.mine.getAllExtensionDescriptions())x.push(new ue.$ejc(Ht,je.identifier,ae,Ii,!1));return x},get allAcrossExtensionHosts(){(0,Ye.$1F)(je,"extensionsAny");const x=new k.$Bm(ci.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),ae=[];for(const Ue of ci.all.getAllExtensionDescriptions()){const at=!x.has(Ue.identifier);ae.push(new ue.$ejc(Ht,je.identifier,Ue,Ii,at))}return ae},get onDidChange(){return(0,Ye.$ZF)(je,"extensionsAny")?nt(P.Event.any(ci.mine.onDidChange,ci.all.onDidChange)):nt(ci.mine.onDidChange)}},on={createDiagnosticCollection(x){return wi.createDiagnosticCollection(je.identifier,x)},get onDidChangeDiagnostics(){return nt(wi.onDidChangeDiagnostics)},getDiagnostics:x=>wi.getDiagnostics(x),getLanguages(){return pi.getLanguages()},setTextDocumentLanguage(x,ae){return pi.changeLanguage(x.uri,ae)},match(x,ae){const Ue=st.LanguageSelector.from(x);let at;return(0,N.$Rt)(Ue)&&(at=Te.notebookDocuments.find(vt=>vt.apiNotebook.getCells().find(At=>At.document===ae))?.apiNotebook),(0,N.$Qt)(Ue,ae.uri,ae.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(x,ae,Ue){return ft.registerCodeActionProvider(je,pt(x),ae,Ue)},registerDocumentPasteEditProvider(x,ae,Ue){return(0,Ye.$1F)(je,"documentPaste"),ft.registerDocumentPasteEditProvider(je,pt(x),ae,Ue)},registerCodeLensProvider(x,ae){return ft.registerCodeLensProvider(je,pt(x),ae)},registerDefinitionProvider(x,ae){return ft.registerDefinitionProvider(je,pt(x),ae)},registerDeclarationProvider(x,ae){return ft.registerDeclarationProvider(je,pt(x),ae)},registerImplementationProvider(x,ae){return ft.registerImplementationProvider(je,pt(x),ae)},registerTypeDefinitionProvider(x,ae){return ft.registerTypeDefinitionProvider(je,pt(x),ae)},registerHoverProvider(x,ae){return ft.registerHoverProvider(je,pt(x),ae,je.identifier)},registerEvaluatableExpressionProvider(x,ae){return ft.registerEvaluatableExpressionProvider(je,pt(x),ae,je.identifier)},registerInlineValuesProvider(x,ae){return ft.registerInlineValuesProvider(je,pt(x),ae,je.identifier)},registerDocumentHighlightProvider(x,ae){return ft.registerDocumentHighlightProvider(je,pt(x),ae)},registerMultiDocumentHighlightProvider(x,ae){return ft.registerMultiDocumentHighlightProvider(je,pt(x),ae)},registerLinkedEditingRangeProvider(x,ae){return ft.registerLinkedEditingRangeProvider(je,pt(x),ae)},registerReferenceProvider(x,ae){return ft.registerReferenceProvider(je,pt(x),ae)},registerRenameProvider(x,ae){return ft.registerRenameProvider(je,pt(x),ae)},registerNewSymbolNamesProvider(x,ae){return(0,Ye.$1F)(je,"newSymbolNamesProvider"),ft.registerNewSymbolNamesProvider(je,pt(x),ae)},registerDocumentSymbolProvider(x,ae,Ue){return ft.registerDocumentSymbolProvider(je,pt(x),ae,Ue)},registerWorkspaceSymbolProvider(x){return ft.registerWorkspaceSymbolProvider(je,x)},registerDocumentFormattingEditProvider(x,ae){return ft.registerDocumentFormattingEditProvider(je,pt(x),ae)},registerDocumentRangeFormattingEditProvider(x,ae){return ft.registerDocumentRangeFormattingEditProvider(je,pt(x),ae)},registerOnTypeFormattingEditProvider(x,ae,Ue,...at){return ft.registerOnTypeFormattingEditProvider(je,pt(x),ae,[Ue].concat(at))},registerDocumentSemanticTokensProvider(x,ae,Ue){return ft.registerDocumentSemanticTokensProvider(je,pt(x),ae,Ue)},registerDocumentRangeSemanticTokensProvider(x,ae,Ue){return ft.registerDocumentRangeSemanticTokensProvider(je,pt(x),ae,Ue)},registerSignatureHelpProvider(x,ae,Ue,...at){return typeof Ue=="object"?ft.registerSignatureHelpProvider(je,pt(x),ae,Ue):ft.registerSignatureHelpProvider(je,pt(x),ae,typeof Ue>"u"?[]:[Ue,...at])},registerCompletionItemProvider(x,ae,...Ue){return ft.registerCompletionItemProvider(je,pt(x),ae,Ue)},registerInlineCompletionItemProvider(x,ae,Ue){return ae.handleDidShowCompletionItem&&(0,Ye.$1F)(je,"inlineCompletionsAdditions"),ae.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$1F)(je,"inlineCompletionsAdditions"),Ue&&(0,Ye.$1F)(je,"inlineCompletionsAdditions"),ft.registerInlineCompletionsProvider(je,pt(x),ae,Ue)},registerInlineEditProvider(x,ae){return(0,Ye.$1F)(je,"inlineEdit"),ft.registerInlineEditProvider(je,pt(x),ae)},registerDocumentLinkProvider(x,ae){return ft.registerDocumentLinkProvider(je,pt(x),ae)},registerColorProvider(x,ae){return ft.registerColorProvider(je,pt(x),ae)},registerFoldingRangeProvider(x,ae){return ft.registerFoldingRangeProvider(je,pt(x),ae)},registerSelectionRangeProvider(x,ae){return ft.registerSelectionRangeProvider(je,x,ae)},registerCallHierarchyProvider(x,ae){return ft.registerCallHierarchyProvider(je,x,ae)},registerTypeHierarchyProvider(x,ae){return ft.registerTypeHierarchyProvider(je,x,ae)},setLanguageConfiguration:(x,ae)=>ft.setLanguageConfiguration(je,x,ae),getTokenInformationAtPosition(x,ae){return(0,Ye.$1F)(je,"tokenInformation"),pi.tokenAtPosition(x,ae)},registerInlayHintsProvider(x,ae){return ft.registerInlayHintsProvider(je,x,ae)},createLanguageStatusItem(x,ae){return pi.createLanguageStatusItem(je,x,ae)},registerDocumentDropEditProvider(x,ae,Ue){return ft.registerDocumentOnDropEditProvider(je,x,ae,(0,Ye.$ZF)(je,"dropMetadata")?Ue:void 0)}},Bi={get activeTextEditor(){return Et.getActiveTextEditor()},get visibleTextEditors(){return Et.getVisibleTextEditors()},get activeTerminal(){return Pt.activeTerminal},get terminals(){return Pt.terminals},async showTextDocument(x,ae,Ue){f.URI.isUri(x)&&x.scheme===R.Schemas.vscodeRemote&&!x.authority&&Ct.report("workspace.showTextDocument",je,"A URI of 'vscode-remote' scheme requires an authority.");const at=await(f.URI.isUri(x)?Promise.resolve(Vi.openTextDocument(x)):Promise.resolve(x));return Et.showTextDocument(at,ae,Ue)},createTextEditorDecorationType(x){return Et.createTextEditorDecorationType(je,x)},onDidChangeActiveTextEditor(x,ae,Ue){return nt(Et.onDidChangeActiveTextEditor)(x,ae,Ue)},onDidChangeVisibleTextEditors(x,ae,Ue){return nt(Et.onDidChangeVisibleTextEditors)(x,ae,Ue)},onDidChangeTextEditorSelection(x,ae,Ue){return nt(Et.onDidChangeTextEditorSelection)(x,ae,Ue)},onDidChangeTextEditorOptions(x,ae,Ue){return nt(Et.onDidChangeTextEditorOptions)(x,ae,Ue)},onDidChangeTextEditorVisibleRanges(x,ae,Ue){return nt(Et.onDidChangeTextEditorVisibleRanges)(x,ae,Ue)},onDidChangeTextEditorViewColumn(x,ae,Ue){return nt(Et.onDidChangeTextEditorViewColumn)(x,ae,Ue)},onDidCloseTerminal(x,ae,Ue){return nt(Pt.onDidCloseTerminal)(x,ae,Ue)},onDidOpenTerminal(x,ae,Ue){return nt(Pt.onDidOpenTerminal)(x,ae,Ue)},onDidChangeActiveTerminal(x,ae,Ue){return nt(Pt.onDidChangeActiveTerminal)(x,ae,Ue)},onDidChangeTerminalDimensions(x,ae,Ue){return(0,Ye.$1F)(je,"terminalDimensions"),nt(Pt.onDidChangeTerminalDimensions)(x,ae,Ue)},onDidChangeTerminalState(x,ae,Ue){return nt(Pt.onDidChangeTerminalState)(x,ae,Ue)},onDidWriteTerminalData(x,ae,Ue){return(0,Ye.$1F)(je,"terminalDataWriteEvent"),nt(Pt.onDidWriteTerminalData)(x,ae,Ue)},onDidExecuteTerminalCommand(x,ae,Ue){return(0,Ye.$1F)(je,"terminalExecuteCommandEvent"),nt(Pt.onDidExecuteTerminalCommand)(x,ae,Ue)},get state(){return Lt.getState(je)},onDidChangeWindowState(x,ae,Ue){return nt(Lt.onDidChangeWindowState)(x,ae,Ue)},showInformationMessage(x,...ae){return vi.showMessage(je,m.default.Info,x,ae[0],ae.slice(1))},showWarningMessage(x,...ae){return vi.showMessage(je,m.default.Warning,x,ae[0],ae.slice(1))},showErrorMessage(x,...ae){return vi.showMessage(je,m.default.Error,x,ae[0],ae.slice(1))},showQuickPick(x,ae,Ue){return mi.showQuickPick(je,x,ae,Ue)},showWorkspaceFolderPick(x){return mi.showWorkspaceFolderPick(x)},showInputBox(x,ae){return mi.showInput(x,ae)},showOpenDialog(x){return nn.showOpenDialog(je,x)},showSaveDialog(x){return nn.showSaveDialog(x)},createStatusBarItem(x,ae,Ue){let at,vt,At;return typeof x=="string"?(at=x,vt=ae,At=Ue):(vt=x,At=ae),Ti.createStatusBarEntry(je,at,vt,At)},setStatusBarMessage(x,ae){return Ti.setStatusBarMessage(x,ae)},withScmProgress(x){return Ct.report("window.withScmProgress",je,"Use 'withProgress' instead."),ki.withProgress(je,{location:Me.ProgressLocation.SourceControl},(ae,Ue)=>x({report(at){}}))},withProgress(x,ae){return ki.withProgress(je,x,ae)},createOutputChannel(x,ae){return ni.createOutputChannel(x,ae,je)},createWebviewPanel(x,ae,Ue,at){return Di.createWebviewPanel(je,x,ae,Ue,at)},createWebviewTextEditorInset(x,ae,Ue,at){return(0,Ye.$1F)(je,"editorInsets"),ri.createWebviewEditorInset(x,ae,Ue,at,je)},createTerminal(x,ae,Ue){return typeof x=="object"?"pty"in x?Pt.createExtensionTerminal(x):Pt.createTerminalFromOptions(x):Pt.createTerminal(x,ae,Ue)},registerTerminalLinkProvider(x){return Pt.registerLinkProvider(x)},registerTerminalProfileProvider(x,ae){return Pt.registerProfileProvider(je,x,ae)},registerTerminalQuickFixProvider(x,ae){return(0,Ye.$1F)(je,"terminalQuickFixProvider"),Pt.registerTerminalQuickFixProvider(x,je.identifier.value,ae)},registerTreeDataProvider(x,ae){return Rt.registerTreeDataProvider(x,ae,je)},createTreeView(x,ae){return Rt.createTreeView(x,ae,je)},registerWebviewPanelSerializer:(x,ae)=>Di.registerWebviewPanelSerializer(je,x,ae),registerCustomEditorProvider:(x,ae,Ue={})=>Yi.registerCustomEditorProvider(je,x,ae,Ue),registerFileDecorationProvider(x){return Bt.registerFileDecorationProvider(x,je)},registerUriHandler(x){return Fe.registerUriHandler(je,x)},createQuickPick(){return mi.createQuickPick(je)},createInputBox(){return mi.createInputBox(je)},get activeColorTheme(){return Fi.activeColorTheme},onDidChangeActiveColorTheme(x,ae,Ue){return nt(Fi.onDidChangeActiveColorTheme)(x,ae,Ue)},registerWebviewViewProvider(x,ae,Ue){return dn.registerWebviewViewProvider(je,x,ae,Ue?.webviewOptions)},get activeNotebookEditor(){return Te.activeNotebookEditor},onDidChangeActiveNotebookEditor(x,ae,Ue){return nt(Te.onDidChangeActiveNotebookEditor)(x,ae,Ue)},get visibleNotebookEditors(){return Te.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return nt(Te.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(x,ae,Ue){return nt(Ge.onDidChangeNotebookEditorSelection)(x,ae,Ue)},onDidChangeNotebookEditorVisibleRanges(x,ae,Ue){return nt(Ge.onDidChangeNotebookEditorVisibleRanges)(x,ae,Ue)},showNotebookDocument(x,ae){return Te.showNotebookDocument(x,ae)},registerExternalUriOpener(x,ae,Ue){return(0,Ye.$1F)(je,"externalUriOpener"),Oi.registerExternalUriOpener(je.identifier,x,ae,Ue)},registerProfileContentHandler(x,ae){return(0,Ye.$1F)(je,"profileContentHandlers"),Ni.registerProfileContentHandler(je,x,ae)},registerQuickDiffProvider(x,ae,Ue,at){return(0,Ye.$1F)(je,"quickDiffProvider"),Qi.registerQuickDiffProvider(pt(x),ae,Ue,at)},get tabGroups(){return Ut.tabGroups},registerShareProvider(x,ae){return(0,Ye.$1F)(je,"shareProvider"),hn.registerShareProvider(pt(x),ae)}},Vi={get rootPath(){return Ct.report("workspace.rootPath",je,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(x){throw new M.$9("rootPath")},getWorkspaceFolder(x){return ht.getWorkspaceFolder(x)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(x){throw new M.$9("name")},get workspaceFile(){return ht.workspaceFile},set workspaceFile(x){throw new M.$9("workspaceFile")},updateWorkspaceFolders:(x,ae,...Ue)=>ht.updateWorkspaceFolders(je,x,ae||0,...Ue),onDidChangeWorkspaceFolders:function(x,ae,Ue){return nt(ht.onDidChangeWorkspace)(x,ae,Ue)},asRelativePath:(x,ae)=>ht.getRelativePath(x,ae),findFiles:(x,ae,Ue,at)=>ht.findFiles(x,ae,Ue,je.identifier,at),findFiles2:(x,ae,Ue)=>((0,Ye.$1F)(je,"findFiles2"),ht.findFiles2(x,ae,je.identifier,Ue)),findTextInFiles:(x,ae,Ue,at)=>{(0,Ye.$1F)(je,"findTextInFiles");let vt,At;return typeof ae=="object"?(vt=ae,At=Ue):(vt={},At=ae,at=Ue),ht.findTextInFiles(x,vt||{},At,je.identifier,at)},save:x=>ht.save(x),saveAs:x=>ht.saveAs(x),saveAll:x=>ht.saveAll(x),applyEdit(x,ae){return tn.applyWorkspaceEdit(x,je,ae)},createFileSystemWatcher:(x,ae,Ue,at)=>{let vt;return typeof ae=="boolean"?vt={ignoreCreateEvents:!!ae,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!at,correlate:!1}:ae&&((0,Ye.$1F)(je,"createFileSystemWatcher"),vt={...ae,correlate:!0}),hi.createFileSystemWatcher(ht,je,x,vt)},get textDocuments(){return oe.getAllDocumentData().map(x=>x.document)},set textDocuments(x){throw new M.$9("textDocuments")},openTextDocument(x){let ae;const Ue=x;if(typeof x=="string")ae=Promise.resolve(f.URI.file(x));else if(f.URI.isUri(x))ae=Promise.resolve(x);else if(!Ue||typeof Ue=="object")ae=oe.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ae.then(at=>(at.scheme===R.Schemas.vscodeRemote&&!at.authority&&Ct.report("workspace.openTextDocument",je,"A URI of 'vscode-remote' scheme requires an authority."),oe.ensureDocumentData(at).then(vt=>vt.document)))},onDidOpenTextDocument:(x,ae,Ue)=>nt(oe.onDidAddDocument)(x,ae,Ue),onDidCloseTextDocument:(x,ae,Ue)=>nt(oe.onDidRemoveDocument)(x,ae,Ue),onDidChangeTextDocument:(x,ae,Ue)=>nt(oe.onDidChangeDocument)(x,ae,Ue),onDidSaveTextDocument:(x,ae,Ue)=>nt(oe.onDidSaveDocument)(x,ae,Ue),onWillSaveTextDocument:(x,ae,Ue)=>nt(De.getOnWillSaveTextDocumentEvent(je))(x,ae,Ue),get notebookDocuments(){return Te.notebookDocuments.map(x=>x.apiNotebook)},async openNotebookDocument(x,ae){let Ue;if(f.URI.isUri(x))Ue=x,await Te.openNotebookDocument(x);else if(typeof x=="string")Ue=f.URI.revive(await Te.createNotebookDocument({viewType:x,content:ae}));else throw new Error("Invalid arguments");return Te.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(x,ae,Ue){return nt(Xe.onDidSaveNotebookDocument)(x,ae,Ue)},onDidChangeNotebookDocument(x,ae,Ue){return nt(Xe.onDidChangeNotebookDocument)(x,ae,Ue)},onWillSaveNotebookDocument(x,ae,Ue){return nt(Gt.getOnWillSaveNotebookDocumentEvent(je))(x,ae,Ue)},get onDidOpenNotebookDocument(){return nt(Te.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return nt(Te.onDidCloseNotebookDocument)},registerNotebookSerializer(x,ae,Ue,at){return Te.registerNotebookSerializer(je,x,ae,Ue,(0,Ye.$ZF)(je,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(x,ae,Ue)=>nt(zi.onDidChangeConfiguration)(x,ae,Ue),getConfiguration(x,ae){return ae=arguments.length===1?void 0:ae,zi.getConfiguration(x,ae,je)},registerTextDocumentContentProvider(x,ae){return Q.registerTextDocumentContentProvider(x,ae)},registerTaskProvider:(x,ae)=>(Ct.report("window.registerTaskProvider",je,"Use the corresponding function on the 'tasks' namespace instead"),Kt.registerTaskProvider(je,x,ae)),registerFileSystemProvider(x,ae,Ue){return(0,F.$Qc)(Ai.registerFileSystemProvider(je,x,ae,Ue),qt.addFileSystemProvider(x,ae,Ue))},get fs(){return qt.value},registerFileSearchProvider:(x,ae)=>((0,Ye.$1F)(je,"fileSearchProvider"),li.registerFileSearchProvider(x,ae)),registerTextSearchProvider:(x,ae)=>((0,Ye.$1F)(je,"textSearchProvider"),li.registerTextSearchProvider(x,ae)),registerAITextSearchProvider:(x,ae)=>((0,Ye.$1F)(je,"aiTextSearchProvider"),(0,Ye.$1F)(je,"textSearchProvider"),li.registerAITextSearchProvider(x,ae)),registerRemoteAuthorityResolver:(x,ae)=>((0,Ye.$1F)(je,"resolvers"),Ht.registerRemoteAuthorityResolver(x,ae)),registerResourceLabelFormatter:x=>((0,Ye.$1F)(je,"resolvers"),Mi.$registerResourceLabelFormatter(x)),getRemoteExecServer:x=>((0,Ye.$1F)(je,"resolvers"),Ht.getRemoteExecServer(x)),onDidCreateFiles:(x,ae,Ue)=>nt(hi.onDidCreateFile)(x,ae,Ue),onDidDeleteFiles:(x,ae,Ue)=>nt(hi.onDidDeleteFile)(x,ae,Ue),onDidRenameFiles:(x,ae,Ue)=>nt(hi.onDidRenameFile)(x,ae,Ue),onWillCreateFiles:(x,ae,Ue)=>nt(hi.getOnWillCreateFileEvent(je))(x,ae,Ue),onWillDeleteFiles:(x,ae,Ue)=>nt(hi.getOnWillDeleteFileEvent(je))(x,ae,Ue),onWillRenameFiles:(x,ae,Ue)=>nt(hi.getOnWillRenameFileEvent(je))(x,ae,Ue),openTunnel:x=>((0,Ye.$1F)(je,"tunnels"),It.openTunnel(je,x).then(ae=>{if(!ae)throw new Error("cannot open tunnel");return ae})),get tunnels(){return(0,Ye.$1F)(je,"tunnels"),It.getTunnels()},onDidChangeTunnels:(x,ae,Ue)=>((0,Ye.$1F)(je,"tunnels"),nt(It.onDidChangeTunnels)(x,ae,Ue)),registerPortAttributesProvider:(x,ae)=>((0,Ye.$1F)(je,"portsAttributes"),It.registerPortsAttributesProvider(x,ae)),registerTunnelProvider:(x,ae)=>((0,Ye.$1F)(je,"tunnelFactory"),It.registerTunnelProvider(x,ae)),registerTimelineProvider:(x,ae)=>((0,Ye.$1F)(je,"timeline"),Xi.registerTimelineProvider(x,ae,je.identifier,wt.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:x=>((0,Ye.$1F)(je,"workspaceTrust"),ht.requestWorkspaceTrust(x)),onDidGrantWorkspaceTrust:(x,ae,Ue)=>nt(ht.onDidGrantWorkspaceTrust)(x,ae,Ue),registerEditSessionIdentityProvider:(x,ae)=>((0,Ye.$1F)(je,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(x,ae)),onWillCreateEditSessionIdentity:(x,ae,Ue)=>((0,Ye.$1F)(je,"editSessionIdentityProvider"),nt(ht.getOnWillCreateEditSessionIdentityEvent(je))(x,ae,Ue)),registerCanonicalUriProvider:(x,ae)=>((0,Ye.$1F)(je,"canonicalUriProvider"),ht.registerCanonicalUriProvider(x,ae)),getCanonicalUri:(x,ae,Ue)=>((0,Ye.$1F)(je,"canonicalUriProvider"),ht.provideCanonicalUri(x,ae,Ue))},an={get inputBox(){return Ct.report("scm.inputBox",je,"Use 'SourceControl.inputBox' instead"),yi.getLastInputBox(je)},createSourceControl(x,ae,Ue){return yi.createSourceControl(je,x,ae,Ue)}},cn={createCommentController(x,ae){return Zi.createCommentController(je,x,ae)}},vn={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){if((0,Ye.$ZF)(je,"debugFocus"))return kt.activeStackItem},registerDebugVisualizationProvider(x,ae){return(0,Ye.$1F)(je,"debugVisualization"),kt.registerDebugVisualizationProvider(je,x,ae)},registerDebugVisualizationTreeProvider(x,ae){return(0,Ye.$1F)(je,"debugVisualization"),kt.registerDebugVisualizationTree(je,x,ae)},onDidStartDebugSession(x,ae,Ue){return nt(kt.onDidStartDebugSession)(x,ae,Ue)},onDidTerminateDebugSession(x,ae,Ue){return nt(kt.onDidTerminateDebugSession)(x,ae,Ue)},onDidChangeActiveDebugSession(x,ae,Ue){return nt(kt.onDidChangeActiveDebugSession)(x,ae,Ue)},onDidReceiveDebugSessionCustomEvent(x,ae,Ue){return nt(kt.onDidReceiveDebugSessionCustomEvent)(x,ae,Ue)},onDidChangeBreakpoints(x,ae,Ue){return nt(kt.onDidChangeBreakpoints)(x,ae,Ue)},onDidChangeActiveStackItem(x,ae,Ue){return(0,Ye.$1F)(je,"debugFocus"),nt(kt.onDidChangeActiveStackItem)(x,ae,Ue)},registerDebugConfigurationProvider(x,ae,Ue){return kt.registerDebugConfigurationProvider(x,ae,Ue||oi.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(x,ae){return kt.registerDebugAdapterDescriptorFactory(je,x,ae)},registerDebugAdapterTrackerFactory(x,ae){return kt.registerDebugAdapterTrackerFactory(x,ae)},startDebugging(x,ae,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?kt.startDebugging(x,ae,{parentSession:Ue}):kt.startDebugging(x,ae,Ue||{})},stopDebugging(x){return kt.stopDebugging(x)},addBreakpoints(x){return kt.addBreakpoints(x)},removeBreakpoints(x){return kt.removeBreakpoints(x)},asDebugSourceUri(x,ae){return kt.asDebugSourceUri(x,ae)}},bn={registerTaskProvider:(x,ae)=>Kt.registerTaskProvider(je,x,ae),fetchTasks:x=>Kt.fetchTasks(x),executeTask:x=>Kt.executeTask(je,x),get taskExecutions(){return Kt.taskExecutions},onDidStartTask:(x,ae,Ue)=>nt(Kt.onDidStartTask)(x,ae,Ue),onDidEndTask:(x,ae,Ue)=>nt(Kt.onDidEndTask)(x,ae,Ue),onDidStartTaskProcess:(x,ae,Ue)=>nt(Kt.onDidStartTaskProcess)(x,ae,Ue),onDidEndTaskProcess:(x,ae,Ue)=>nt(Kt.onDidEndTaskProcess)(x,ae,Ue)},un={createNotebookController(x,ae,Ue,at,vt){return ct.createNotebookController(je,x,ae,Ue,at,(0,Ye.$ZF)(je,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(x,ae)=>Te.registerNotebookCellStatusBarItemProvider(je,x,ae),createRendererMessaging(x){return yt.createRendererMessaging(je,x)},createNotebookControllerDetectionTask(x){return(0,Ye.$1F)(je,"notebookKernelSource"),ct.createNotebookControllerDetectionTask(je,x)},registerKernelSourceActionProvider(x,ae){return(0,Ye.$1F)(je,"notebookKernelSource"),ct.registerKernelSourceActionProvider(je,x,ae)},onDidChangeNotebookCellExecutionState(x,ae,Ue){return(0,Ye.$1F)(je,"notebookCellExecutionState"),nt(ct.onDidChangeNotebookCellExecutionState)(x,ae,Ue)}},ln={t(...x){if(typeof x[0]=="string"){const ae=x.shift(),Ue=!x||typeof x[0]!="object"?x:x[0];return we.getMessage(je.identifier.value,{message:ae,args:Ue})}return we.getMessage(je.identifier.value,x[0])},get bundle(){return we.getBundle(je.identifier.value)},get uri(){return we.getBundleUri(je.identifier.value)}},Wi={_version:1,registerInteractiveEditorSessionProvider(x,ae){return(0,Ye.$1F)(je,"interactive"),fn.registerProvider(je,x,ae)},registerInteractiveSessionProvider(x,ae){return(0,Ye.$1F)(je,"interactive"),_i.registerChatProvider(je,x,ae)},transferChatSession(x,ae){return(0,Ye.$1F)(je,"interactive"),_i.transferChatSession(x,ae)}},qi={getRelatedInformation(x,ae){return(0,Ye.$1F)(je,"aiRelatedInformation"),Si.getRelatedInformation(je,x,ae)},registerRelatedInformationProvider(x,ae){return(0,Ye.$1F)(je,"aiRelatedInformation"),Si.registerRelatedInformationProvider(je,x,ae)},registerEmbeddingVectorProvider(x,ae){return(0,Ye.$1F)(je,"aiRelatedInformation"),en.registerEmbeddingVectorProvider(je,x,ae)}},Hi={registerChatResponseProvider(x,ae,Ue){return(0,Ye.$1F)(je,"chatProvider"),Ft.registerLanguageModel(je,x,ae,Ue)},registerChatVariableResolver(x,ae,Ue){return(0,Ye.$1F)(je,"chatVariableResolver"),xi.registerVariableResolver(je,x,ae,Ue)},registerMappedEditsProvider(x,ae){return(0,Ye.$1F)(je,"mappedEditsProvider"),ft.registerMappedEditsProvider(je,x,ae)},createChatParticipant(x,ae){return(0,Ye.$1F)(je,"chatParticipant"),gn.createChatAgent(je,x,ae)}},Ci={get languageModels(){return(0,Ye.$1F)(je,"languageModels"),Ft.getLanguageModelIds()},onDidChangeLanguageModels:(x,ae,Ue)=>((0,Ye.$1F)(je,"languageModels"),Ft.onDidChangeProviders(x,ae,Ue)),sendChatRequest(x,ae,Ue,at){return(0,Ye.$1F)(je,"languageModels"),Ft.sendChatRequest(je,x,ae,Ue,at)}},Ki={registerSpeechProvider(x,ae){return(0,Ye.$1F)(je,"speech"),mn.registerProvider(je.identifier,x,ae)}};return{version:$t.version,ai:qi,authentication:rn,commands:$n,comments:cn,chat:Hi,debug:vn,env:Ui,extensions:pn,interactive:Wi,l10n:ln,languages:on,lm:Ci,notebooks:un,scm:an,speech:Ki,tasks:bn,tests:sn,window:Bi,workspace:Vi,Breakpoint:Me.$$M,TerminalOutputAnchor:Me.TerminalOutputAnchor,ChatResultFeedbackKind:Me.ChatResultFeedbackKind,ChatVariableLevel:Me.ChatVariableLevel,ChatCompletionItem:Me.$4N,CallHierarchyIncomingCall:Me.$xM,CallHierarchyItem:Me.$wM,CallHierarchyOutgoingCall:Me.$yM,CancellationError:M.$5,CancellationTokenSource:S.$de,CandidatePortSource:n.CandidatePortSource,CodeAction:Me.$tM,CodeActionKind:Me.$uM,CodeActionTriggerKind:Me.CodeActionTriggerKind,CodeLens:Me.$zM,Color:Me.$MM,ColorInformation:Me.$NM,ColorPresentation:Me.$OM,ColorThemeKind:Me.ColorThemeKind,CommentMode:Me.CommentMode,CommentState:Me.CommentState,CommentThreadCollapsibleState:Me.CommentThreadCollapsibleState,CommentThreadState:Me.CommentThreadState,CompletionItem:Me.$GM,CompletionItemKind:Me.CompletionItemKind,CompletionItemTag:Me.CompletionItemTag,CompletionList:Me.$HM,CompletionTriggerKind:Me.CompletionTriggerKind,ConfigurationTarget:Me.ConfigurationTarget,CustomExecution:Me.$WM,DebugAdapterExecutable:Me.$cN,DebugAdapterInlineImplementation:Me.$fN,DebugAdapterNamedPipeServer:Me.$eN,DebugAdapterServer:Me.$dN,DebugConfigurationProviderTriggerKind:oi.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Me.DebugConsoleMode,DebugVisualization:Me.$vN,DecorationRangeBehavior:Me.DecorationRangeBehavior,Diagnostic:Me.$nM,DiagnosticRelatedInformation:Me.$mM,DiagnosticSeverity:Me.DiagnosticSeverity,DiagnosticTag:Me.DiagnosticTag,Disposable:Me.$_L,DocumentHighlight:Me.$pM,DocumentHighlightKind:Me.DocumentHighlightKind,MultiDocumentHighlight:Me.$qM,DocumentLink:Me.$LM,DocumentSymbol:Me.$sM,EndOfLine:Me.EndOfLine,EnvironmentVariableMutatorType:Me.EnvironmentVariableMutatorType,EvaluatableExpression:Me.$iN,InlineValueText:Me.$jN,InlineValueVariableLookup:Me.$kN,InlineValueEvaluatableExpression:Me.$lN,InlineCompletionTriggerKind:Me.InlineCompletionTriggerKind,EventEmitter:P.$6d,ExtensionKind:Me.ExtensionKind,ExtensionMode:Me.ExtensionMode,ExternalUriOpenerPriority:Me.ExternalUriOpenerPriority,FileChangeType:Me.FileChangeType,FileDecoration:Me.$xN,FileDecoration2:Me.$xN,FileSystemError:Me.$oN,FileType:g.FileType,FilePermission:g.FilePermission,FoldingRange:Me.$pN,FoldingRangeKind:Me.FoldingRangeKind,FunctionBreakpoint:Me.$aN,InlineCompletionItem:Me.$IM,InlineCompletionList:Me.$JM,Hover:Me.$oM,IndentAction:D.IndentAction,Location:Me.$lM,MarkdownString:Me.$AM,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Me.$BM,PortAutoForwardAction:Me.PortAutoForwardAction,Position:Me.$aM,ProcessExecution:Me.$UM,ProgressLocation:Me.ProgressLocation,QuickInputButtons:Me.$wN,Range:Me.$bM,RelativePattern:Me.$9M,Selection:Me.$cM,SelectionRange:Me.$vM,SemanticTokens:Me.$sN,SemanticTokensBuilder:Me.$rN,SemanticTokensEdit:Me.$tN,SemanticTokensEdits:Me.$uN,SemanticTokensLegend:Me.$qN,ShellExecution:Me.$VM,ShellQuoting:Me.ShellQuoting,SignatureHelp:Me.$DM,SignatureHelpTriggerKind:Me.SignatureHelpTriggerKind,SignatureInformation:Me.$CM,SnippetString:Me.$kM,SourceBreakpoint:Me.$_M,StandardTokenType:Me.StandardTokenType,StatusBarAlignment:Me.StatusBarAlignment,SymbolInformation:Me.$rM,SymbolKind:Me.SymbolKind,SymbolTag:Me.SymbolTag,Task:Me.$XM,TaskGroup:Me.$TM,TaskPanelKind:Me.TaskPanelKind,TaskRevealKind:Me.TaskRevealKind,TaskScope:Me.TaskScope,TerminalLink:Me.$PM,TerminalQuickFixTerminalCommand:Me.$RM,TerminalQuickFixOpener:Me.$QM,TerminalLocation:Me.TerminalLocation,TerminalProfile:Me.$SM,TerminalExitReason:Me.TerminalExitReason,TextDocumentSaveReason:Me.TextDocumentSaveReason,TextEdit:Me.$gM,SnippetTextEdit:Me.$iM,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:Me.TextEditorLineNumbersStyle,TextEditorRevealType:Me.TextEditorRevealType,TextEditorSelectionChangeKind:Me.TextEditorSelectionChangeKind,SyntaxTokenType:Me.SyntaxTokenType,TextDocumentChangeReason:Me.TextDocumentChangeReason,ThemeColor:Me.$8M,ThemeIcon:Me.$7M,TreeItem:Me.$YM,TreeItemCheckboxState:Me.TreeItemCheckboxState,TreeItemCollapsibleState:Me.TreeItemCollapsibleState,TypeHierarchyItem:Me.$SN,UIKind:xt.UIKind,Uri:f.URI,ViewColumn:Me.ViewColumn,WorkspaceEdit:Me.$jM,DocumentDropEdit:Me.$5M,DocumentPasteEdit:Me.$6M,InlayHint:Me.$FM,InlayHintLabelPart:Me.$EM,InlayHintKind:Me.InlayHintKind,RemoteAuthorityResolverError:Me.$fM,ResolvedAuthority:Me.$dM,ManagedResolvedAuthority:Me.$eM,SourceControlInputBoxValidationType:Me.SourceControlInputBoxValidationType,ExtensionRuntime:Me.ExtensionRuntime,TimelineItem:Me.$HN,NotebookRange:Me.$zN,NotebookCellKind:Me.NotebookCellKind,NotebookCellExecutionState:Me.NotebookCellExecutionState,NotebookCellData:Me.$AN,NotebookData:Me.$BN,NotebookRendererScript:Me.$FN,NotebookCellStatusBarAlignment:Me.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Me.NotebookEditorRevealType,NotebookCellOutput:Me.$DN,NotebookCellOutputItem:Me.$CN,NotebookCellStatusBarItem:Me.$EN,NotebookControllerAffinity:Me.NotebookControllerAffinity,NotebookControllerAffinity2:Me.NotebookControllerAffinity2,NotebookEdit:Me.$hM,NotebookKernelSourceAction:Me.$GN,NotebookVariablesRequestKind:Me.NotebookVariablesRequestKind,PortAttributes:Me.$JN,LinkedEditingRanges:Me.$IN,TestResultState:Me.TestResultState,TestRunRequest:Me.$KN,TestMessage:Me.$LN,TestTag:Me.$MN,TestRunProfileKind:Me.TestRunProfileKind,TextSearchCompleteMessageType:Ot.TextSearchCompleteMessageType,DataTransfer:Me.$4M,DataTransferItem:Me.$ZM,CoveredCount:Me.$NN,FileCoverage:Me.$ON,StatementCoverage:Me.$PN,BranchCoverage:Me.$QN,DeclarationCoverage:Me.$RN,FunctionCoverage:Me.$RN,WorkspaceTrustState:Me.WorkspaceTrustState,LanguageStatusSeverity:Me.LanguageStatusSeverity,QuickPickItemKind:Me.QuickPickItemKind,InputBoxValidationSeverity:Me.InputBoxValidationSeverity,TabInputText:Me.$TN,TabInputTextDiff:Me.$UN,TabInputTextMerge:Me.$VN,TabInputCustom:Me.$WN,TabInputNotebook:Me.$YN,TabInputNotebookDiff:Me.$ZN,TabInputWebview:Me.$XN,TabInputTerminal:Me.$1N,TabInputInteractiveWindow:Me.$2N,TabInputChat:Me.$3N,TelemetryTrustedValue:r.$1o,LogLevel:s.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Me.InteractiveSessionVoteDirection,ChatCopyKind:Me.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Me.InteractiveEditorResponseFeedbackKind,StackFrame:Me.$gN,Thread:Me.$hN,RelatedInformationType:Me.RelatedInformationType,SpeechToTextStatus:Me.SpeechToTextStatus,PartialAcceptTriggerKind:Me.PartialAcceptTriggerKind,KeywordRecognitionStatus:Me.KeywordRecognitionStatus,ChatResponseMarkdownPart:Me.$5N,ChatResponseFileTreePart:Me.$6N,ChatResponseAnchorPart:Me.$7N,ChatResponseProgressPart:Me.$8N,ChatResponseReferencePart:Me.$0N,ChatResponseCommandButtonPart:Me.$9N,ChatRequestTurn:Me.$$N,ChatResponseTurn:Me.$_N,LanguageModelChatSystemMessage:Me.$aO,LanguageModelChatUserMessage:Me.$bO,LanguageModelChatAssistantMessage:Me.$cO,LanguageModelSystemMessage:Me.$aO,LanguageModelUserMessage:Me.$bO,LanguageModelAssistantMessage:Me.$cO,LanguageModelError:Me.$dO,NewSymbolName:Me.$nN,NewSymbolNameTag:Me.NewSymbolNameTag,InlineEdit:Me.$eO,InlineEditTriggerKind:Me.InlineEditTriggerKind}}}e.$jkc=_t}),define(Pe[294],Re([1,0,54,115,36,110,37,31,67,66,118,120,121,82,86,78,109,63,43,81,61,65,232,13,119,79,80,84,88]),function(me,e,S,M,P,F,R,m,f,E,N,D,l,k,g,s,a,r,i,n,c,d,t,p,u,o,v,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.$bs)(o.$$ic,o.$0ic,1),(0,S.$bs)(p.$Bj,t.$kkc,1),(0,S.$bs)(s.$cic,s.$dic,1),(0,S.$bs)(m.$LO,m.$KO,0),(0,S.$bs)(b.$mic,b.$nic,0),(0,S.$bs)($.$ric,$.$sic,0),(0,S.$bs)(R.$Eic,R.$Cic,0),(0,S.$bs)(r.$Gic,r.$Fic,0),(0,S.$bs)(D.$ijc,D.$mjc,0),(0,S.$bs)(F.$ojc,F.$njc,0),(0,S.$bs)(f.$AO,f.$zO,0),(0,S.$bs)(v.$_ic,v.$ajc,0),(0,S.$bs)(i.$gic,i.$fic,0),(0,S.$bs)(M.$Ujc,M.$Tjc,1),(0,S.$bs)(l.$Ejc,l.$Fjc,0),(0,S.$bs)(k.$Zic,k.$Yic,0),(0,S.$bs)(N.$8jc,N.$7jc,0),(0,S.$bs)(E.$3ic,E.$6ic,0),(0,S.$bs)(g.$BAb,g.$CAb,0),(0,S.$bs)(a.$ikc,a.$hkc,0),(0,S.$bs)(P.$Bic,P.$Aic,0),(0,S.$bs)(n.$8ic,n.$7ic,0),(0,S.$bs)(c.$JO,c.$GO,0),(0,S.$bs)(d.$Qic,d.$Ric,0),(0,S.$bs)(u.$gjc,u.$hjc,0)}),define(Pe[295],Re([1,0,293,38,2,290,7,11,238]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=void 0;class E extends F.$nkc{j(){}getModule(k,g){for(const s of this.b){const a=s(k);if(a){k=a;break}}if(this.a.has(k))return this.a.get(k).load(k,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends M.$cjc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async ub(){this.h.createInstance(f.$tmc);const k=this.h.invokeFunction(S.$jkc);this.r=this.h.createInstance(E,k,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Ab()}vb(k){return k.browser}async wb(k,g,s){g=g.with({path:D(g.path,".js")});const a=k?.identifier.value;a&&performance.mark(`code/extHost/willFetchExtensionCode/${a}`);const r=P.URI.revive(await this.C.$asBrowserUri(g)),i=await fetch(r.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a}`),i.status!==200)throw new Error(i.statusText);const n=await i.text(),c=`${g.toString(!0)}#vscode-extension`,d=`${n}
//# sourceURL=${c}`;let t;try{t=new Function("module","exports","require",d)}catch(v){throw console.error(a?`Loading code for extension ${a} failed: ${v.message}`:`Loading code failed: ${v.message}`),console.error(`${g.toString(!0)}${typeof v.line=="number"?` line ${v.line}`:""}${typeof v.column=="number"?` column ${v.column}`:""}`),console.error(v),v}k&&await this.w.initializeLocalizedMessages(k);const p={},u={exports:p},o=v=>{const b=this.r.getModule(v,g);if(b===void 0)throw new Error(`Cannot load module '${v}'`);return b};try{return s.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a}`),t(u,p,o),u.exports!==p?u.exports:p}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a}`),s.codeLoadingStop()}}async $setRemoteEnvironment(k){}async Ab(k=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const g=Date.now()+k;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,m.$hh)(10)}}e.$umc=N;function D(l,k){return l.endsWith(k)?l:l+k}}),define(Pe[296],Re([1,0,70,54,13,38,203,85,295]),function(me,e,S,M,P,F,R,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,M.$bs)(P.$Aj,new S.$di(R.$mkc,[!0],!0)),(0,M.$bs)(F.$djc,f.$umc,0),(0,M.$bs)(m.$Hic,m.$Iic,0)}),define(Pe[302],Re([1,0,23,5,77,291,240,19,89,12,2,294,296]),function(me,e,S,M,P,F,R,m,f,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function k(t){return/^(file|vscode-remote):/i.test(t)}const g=fetch.bind(self);function s(t){self.fetch=async function(p,u){return p instanceof Request||k(String(p))&&(p=(await t(N.URI.parse(String(p)))).toString(!0)),g(p,u)},self.XMLHttpRequest=class extends XMLHttpRequest{open(p,u,o,v,b){(async()=>(k(u.toString())&&(u=(await t(N.URI.parse(u.toString()))).toString(!0)),super.open(p,u,o??!0,v,b)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(p,u){if(/^file:/i.test(p.toString()))p=E.$Ag.uriToBrowserUri(N.URI.parse(p.toString())).toString(!0);else if(/^vscode-remote:/i.test(p.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const v=`(${function(h){function y(L){return typeof L=="string"||L instanceof URL?String(L).replace(/^file:\/\//i,"vscode-file://vscode-app"):L}const w=fetch.bind(self);self.fetch=function(L,J){return L instanceof Request?w(L,J):w(y(L),J)},self.XMLHttpRequest=class extends XMLHttpRequest{open(L,J,W,U,C){return super.open(L,y(J),W??!0,U,C)}};const A=importScripts.bind(self);self.importScripts=(...L)=>{A(...L.map(y))},A(h)}.toString()}('${p}'))`;u=u||{},u.name=`${name} -> ${u.name||m.$nc(p.toString())}`;const b=new Blob([v],{type:"application/javascript"}),$=URL.createObjectURL(b);return new t($,u)}}else self.Worker=class extends R.$vmc{constructor(t,p){super(l,t,{name:m.$nc(t.toString()),...p})}};const a=new class{constructor(){this.pid=void 0}exit(t){D()}};class r{constructor(){const p=new MessageChannel,u=new M.$6d;let o=!1;l(p.port2,[p.port2]),p.port1.onmessage=v=>{const{data:b}=v;if(!(b instanceof ArrayBuffer)){console.warn("UNKNOWN data received",b);return}const $=S.$te.wrap(new Uint8Array(b,0,b.byteLength));if((0,P.$Jm)($,2)){o=!0,n("received terminate message from renderer");return}u.fire($)},this.protocol={onMessage:u.event,send:v=>{if(!o){const b=v.buffer.buffer.slice(v.buffer.byteOffset,v.buffer.byteOffset+v.buffer.byteLength);p.port1.postMessage(b,[b])}}}}}function i(t){return new Promise(p=>{const u=t.onMessage(o=>{u.dispose();const v=JSON.parse(o.toString());t.send((0,P.$Im)(0)),p({protocol:t,initData:v})});t.send((0,P.$Im)(1))})}let n=t=>D();function c(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function d(){f.mark("code/extHost/willConnectToRenderer");const t=new r;return{onmessage(p){c(p)&&i(t.protocol).then(u=>{f.mark("code/extHost/didWaitForInitData");const o=new F.$pkc(u.protocol,u.initData,a,null,p.data);s(v=>o.asBrowserUri(v)),n=v=>o.terminate(v)})}}}e.create=d})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/cc1f5e3acfad98ed519befc1ebfd199777d135f4/core/vs/workbench/api/worker/extensionHostWorker.js.map
